#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1812
#define LARGE_STATE_COUNT 922
#define SYMBOL_COUNT 274
#define ALIAS_COUNT 1
#define TOKEN_COUNT 154
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 16
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 55

enum ts_symbol_identifiers {
  sym__identifier = 1,
  anon_sym_COMMA = 2,
  anon_sym_pub = 3,
  anon_sym_test = 4,
  anon_sym_comptime = 5,
  anon_sym_COLON = 6,
  anon_sym_EQ = 7,
  anon_sym_export = 8,
  anon_sym_extern = 9,
  anon_sym_threadlocal = 10,
  anon_sym_SEMI = 11,
  anon_sym_STAR_EQ = 12,
  anon_sym_STAR_PERCENT_EQ = 13,
  anon_sym_STAR_PIPE_EQ = 14,
  anon_sym_SLASH_EQ = 15,
  anon_sym_PERCENT_EQ = 16,
  anon_sym_PLUS_EQ = 17,
  anon_sym_PLUS_PERCENT_EQ = 18,
  anon_sym_PLUS_PIPE_EQ = 19,
  anon_sym_DASH_EQ = 20,
  anon_sym_DASH_PERCENT_EQ = 21,
  anon_sym_DASH_PIPE_EQ = 22,
  anon_sym_LT_LT_EQ = 23,
  anon_sym_LT_LT_PIPE_EQ = 24,
  anon_sym_GT_GT_EQ = 25,
  anon_sym_AMP_EQ = 26,
  anon_sym_CARET_EQ = 27,
  anon_sym_PIPE_EQ = 28,
  anon_sym_const = 29,
  anon_sym_var = 30,
  anon_sym_inline = 31,
  anon_sym_noinline = 32,
  anon_sym_fn = 33,
  anon_sym_LPAREN = 34,
  anon_sym_RPAREN = 35,
  anon_sym_noalias = 36,
  anon_sym_DOT_DOT_DOT = 37,
  anon_sym_usingnamespace = 38,
  anon_sym_LBRACE = 39,
  anon_sym_RBRACE = 40,
  anon_sym_packed = 41,
  anon_sym_struct = 42,
  anon_sym_opaque = 43,
  anon_sym_enum = 44,
  anon_sym_union = 45,
  anon_sym_error = 46,
  anon_sym_nosuspend = 47,
  anon_sym_suspend = 48,
  anon_sym_defer = 49,
  anon_sym_errdefer = 50,
  anon_sym_if = 51,
  anon_sym_else = 52,
  anon_sym_for = 53,
  anon_sym_DOT_DOT = 54,
  anon_sym_while = 55,
  anon_sym_PIPE = 56,
  anon_sym_STAR = 57,
  anon_sym_align = 58,
  anon_sym_addrspace = 59,
  anon_sym_linksection = 60,
  anon_sym_callconv = 61,
  anon_sym_asm = 62,
  anon_sym_volatile = 63,
  anon_sym_LBRACK = 64,
  anon_sym_RBRACK = 65,
  anon_sym_DASH_GT = 66,
  anon_sym_BANG = 67,
  anon_sym_TILDE = 68,
  anon_sym_DASH = 69,
  anon_sym_DASH_PERCENT = 70,
  anon_sym_AMP = 71,
  anon_sym_or = 72,
  anon_sym_and = 73,
  anon_sym_EQ_EQ = 74,
  anon_sym_BANG_EQ = 75,
  anon_sym_GT = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_LT_EQ = 78,
  anon_sym_LT = 79,
  anon_sym_CARET = 80,
  anon_sym_orelse = 81,
  anon_sym_LT_LT = 82,
  anon_sym_GT_GT = 83,
  anon_sym_LT_LT_PIPE = 84,
  anon_sym_PLUS = 85,
  anon_sym_PLUS_PLUS = 86,
  anon_sym_PLUS_PERCENT = 87,
  anon_sym_PLUS_PIPE = 88,
  anon_sym_DASH_PIPE = 89,
  anon_sym_SLASH = 90,
  anon_sym_PERCENT = 91,
  anon_sym_STAR_STAR = 92,
  anon_sym_STAR_PERCENT = 93,
  anon_sym_STAR_PIPE = 94,
  anon_sym_PIPE_PIPE = 95,
  anon_sym_async = 96,
  anon_sym_await = 97,
  anon_sym_continue = 98,
  anon_sym_resume = 99,
  anon_sym_return = 100,
  anon_sym_break = 101,
  anon_sym_try = 102,
  anon_sym_catch = 103,
  anon_sym_switch = 104,
  anon_sym_EQ_GT = 105,
  anon_sym_anyframe = 106,
  anon_sym_unreachable = 107,
  anon_sym_undefined = 108,
  anon_sym_null = 109,
  anon_sym_QMARK = 110,
  anon_sym_allowzero = 111,
  anon_sym_c = 112,
  anon_sym_DOT = 113,
  anon_sym_DOT_STAR = 114,
  anon_sym_DOT_QMARK = 115,
  anon_sym_DQUOTE = 116,
  aux_sym_string_token1 = 117,
  aux_sym_multiline_string_token1 = 118,
  sym_escape_sequence = 119,
  anon_sym_SQUOTE = 120,
  aux_sym_character_token1 = 121,
  sym_integer = 122,
  sym_float = 123,
  anon_sym_true = 124,
  anon_sym_false = 125,
  anon_sym_bool = 126,
  anon_sym_f16 = 127,
  anon_sym_f32 = 128,
  anon_sym_f64 = 129,
  anon_sym_f128 = 130,
  anon_sym_void = 131,
  anon_sym_type = 132,
  anon_sym_anyerror = 133,
  anon_sym_anyopaque = 134,
  anon_sym_anytype = 135,
  anon_sym_noreturn = 136,
  anon_sym_isize = 137,
  anon_sym_usize = 138,
  anon_sym_comptime_int = 139,
  anon_sym_comptime_float = 140,
  anon_sym_c_short = 141,
  anon_sym_c_ushort = 142,
  anon_sym_c_int = 143,
  anon_sym_c_uint = 144,
  anon_sym_c_long = 145,
  anon_sym_c_ulong = 146,
  anon_sym_c_longlong = 147,
  anon_sym_c_ulonglong = 148,
  anon_sym_c_longdouble = 149,
  aux_sym_builtin_type_token1 = 150,
  sym_builtin_identifier = 151,
  anon_sym_AT = 152,
  sym_comment = 153,
  sym_source_file = 154,
  sym__container_members = 155,
  sym_test_declaration = 156,
  sym_comptime_declaration = 157,
  sym_container_field = 158,
  sym_variable_declaration = 159,
  sym__variable_declaration_expression_statement = 160,
  sym__variable_declaration_header = 161,
  sym_function_declaration = 162,
  sym__function_prototype = 163,
  sym_parameters = 164,
  sym_parameter = 165,
  sym_using_namespace_declaration = 166,
  sym_block = 167,
  sym_struct_declaration = 168,
  sym_opaque_declaration = 169,
  sym_enum_declaration = 170,
  sym_union_declaration = 171,
  sym_error_set_declaration = 172,
  sym_statement = 173,
  sym_comptime_statement = 174,
  sym_nosuspend_statement = 175,
  sym_suspend_statement = 176,
  sym_defer_statement = 177,
  sym_errdefer_statement = 178,
  sym__block_expr_statement = 179,
  sym_block_expression = 180,
  sym_labeled_statement = 181,
  sym_expression_statement = 182,
  sym_if_statement = 183,
  sym__if_prefix = 184,
  sym_else_clause = 185,
  sym_for_statement = 186,
  sym__for_prefix = 187,
  sym_while_statement = 188,
  sym__while_prefix = 189,
  sym__conditional_body = 190,
  sym_payload = 191,
  sym_byte_alignment = 192,
  sym_address_space = 193,
  sym_link_section = 194,
  sym_calling_convention = 195,
  sym_expression = 196,
  sym_asm_expression = 197,
  sym_asm_output = 198,
  sym_asm_output_item = 199,
  sym_asm_input = 200,
  sym_asm_input_item = 201,
  sym_asm_clobbers = 202,
  sym_if_expression = 203,
  sym_for_expression = 204,
  sym_while_expression = 205,
  sym_assignment_expression = 206,
  sym_unary_expression = 207,
  sym_binary_expression = 208,
  sym_comptime_expression = 209,
  sym_async_expression = 210,
  sym_await_expression = 211,
  sym_nosuspend_expression = 212,
  sym_continue_expression = 213,
  sym_resume_expression = 214,
  sym_return_expression = 215,
  sym_break_expression = 216,
  sym_try_expression = 217,
  sym_catch_expression = 218,
  sym_switch_expression = 219,
  sym_switch_case = 220,
  sym__switch_case_exp = 221,
  sym_type_expression = 222,
  sym_primary_type_expression = 223,
  sym_nullable_type = 224,
  sym_anyframe_type = 225,
  sym_slice_type = 226,
  sym_pointer_type = 227,
  sym_array_type = 228,
  sym_error_union_type = 229,
  sym_field_expression = 230,
  sym_index_expression = 231,
  sym_dereference_expression = 232,
  sym_null_coercion_expression = 233,
  sym_range_expression = 234,
  sym_call_expression = 235,
  sym_anonymous_struct_initializer = 236,
  sym_struct_initializer = 237,
  sym_initializer_list = 238,
  sym_field_initializer = 239,
  sym_labeled_type_expression = 240,
  sym_comptime_type_expression = 241,
  sym_if_type_expression = 242,
  sym_parenthesized_expression = 243,
  sym_block_label = 244,
  sym_break_label = 245,
  sym_arguments = 246,
  sym_builtin_function = 247,
  sym_string = 248,
  sym_multiline_string = 249,
  sym_character = 250,
  sym_boolean = 251,
  sym_builtin_type = 252,
  sym_error_type = 253,
  sym_identifier = 254,
  sym__reserved_identifier = 255,
  aux_sym__container_members_repeat1 = 256,
  aux_sym__variable_declaration_expression_statement_repeat1 = 257,
  aux_sym_parameters_repeat1 = 258,
  aux_sym_block_repeat1 = 259,
  aux_sym_error_set_declaration_repeat1 = 260,
  aux_sym__for_prefix_repeat1 = 261,
  aux_sym_payload_repeat1 = 262,
  aux_sym_asm_output_repeat1 = 263,
  aux_sym_asm_input_repeat1 = 264,
  aux_sym_asm_clobbers_repeat1 = 265,
  aux_sym_switch_expression_repeat1 = 266,
  aux_sym__switch_case_exp_repeat1 = 267,
  aux_sym_slice_type_repeat1 = 268,
  aux_sym_pointer_type_repeat1 = 269,
  aux_sym_call_expression_repeat1 = 270,
  aux_sym_initializer_list_repeat1 = 271,
  aux_sym_string_repeat1 = 272,
  aux_sym_multiline_string_repeat1 = 273,
  alias_sym_function_signature = 274,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier] = "_identifier",
  [anon_sym_COMMA] = ",",
  [anon_sym_pub] = "pub",
  [anon_sym_test] = "test",
  [anon_sym_comptime] = "comptime",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_export] = "export",
  [anon_sym_extern] = "extern",
  [anon_sym_threadlocal] = "threadlocal",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_PERCENT_EQ] = "*%=",
  [anon_sym_STAR_PIPE_EQ] = "*|=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_PLUS_PERCENT_EQ] = "+%=",
  [anon_sym_PLUS_PIPE_EQ] = "+|=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DASH_PERCENT_EQ] = "-%=",
  [anon_sym_DASH_PIPE_EQ] = "-|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_LT_LT_PIPE_EQ] = "<<|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_const] = "const",
  [anon_sym_var] = "var",
  [anon_sym_inline] = "inline",
  [anon_sym_noinline] = "noinline",
  [anon_sym_fn] = "fn",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_noalias] = "noalias",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_usingnamespace] = "usingnamespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_packed] = "packed",
  [anon_sym_struct] = "struct",
  [anon_sym_opaque] = "opaque",
  [anon_sym_enum] = "enum",
  [anon_sym_union] = "union",
  [anon_sym_error] = "error",
  [anon_sym_nosuspend] = "nosuspend",
  [anon_sym_suspend] = "suspend",
  [anon_sym_defer] = "defer",
  [anon_sym_errdefer] = "errdefer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_while] = "while",
  [anon_sym_PIPE] = "|",
  [anon_sym_STAR] = "*",
  [anon_sym_align] = "align",
  [anon_sym_addrspace] = "addrspace",
  [anon_sym_linksection] = "linksection",
  [anon_sym_callconv] = "callconv",
  [anon_sym_asm] = "asm",
  [anon_sym_volatile] = "volatile",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_PERCENT] = "-%",
  [anon_sym_AMP] = "&",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_CARET] = "^",
  [anon_sym_orelse] = "orelse",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_LT_PIPE] = "<<|",
  [anon_sym_PLUS] = "+",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_PLUS_PERCENT] = "+%",
  [anon_sym_PLUS_PIPE] = "+|",
  [anon_sym_DASH_PIPE] = "-|",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_STAR_PERCENT] = "*%",
  [anon_sym_STAR_PIPE] = "*|",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_continue] = "continue",
  [anon_sym_resume] = "resume",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_switch] = "switch",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_anyframe] = "anyframe",
  [anon_sym_unreachable] = "unreachable",
  [anon_sym_undefined] = "undefined",
  [anon_sym_null] = "null",
  [anon_sym_QMARK] = "\?",
  [anon_sym_allowzero] = "allowzero",
  [anon_sym_c] = "c",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DOT_QMARK] = ".\?",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_content",
  [aux_sym_multiline_string_token1] = "multiline_string_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_character_token1] = "character_content",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_bool] = "bool",
  [anon_sym_f16] = "f16",
  [anon_sym_f32] = "f32",
  [anon_sym_f64] = "f64",
  [anon_sym_f128] = "f128",
  [anon_sym_void] = "void",
  [anon_sym_type] = "type",
  [anon_sym_anyerror] = "anyerror",
  [anon_sym_anyopaque] = "anyopaque",
  [anon_sym_anytype] = "anytype",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_isize] = "isize",
  [anon_sym_usize] = "usize",
  [anon_sym_comptime_int] = "comptime_int",
  [anon_sym_comptime_float] = "comptime_float",
  [anon_sym_c_short] = "c_short",
  [anon_sym_c_ushort] = "c_ushort",
  [anon_sym_c_int] = "c_int",
  [anon_sym_c_uint] = "c_uint",
  [anon_sym_c_long] = "c_long",
  [anon_sym_c_ulong] = "c_ulong",
  [anon_sym_c_longlong] = "c_longlong",
  [anon_sym_c_ulonglong] = "c_ulonglong",
  [anon_sym_c_longdouble] = "c_longdouble",
  [aux_sym_builtin_type_token1] = "builtin_type_token1",
  [sym_builtin_identifier] = "builtin_identifier",
  [anon_sym_AT] = "@",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__container_members] = "_container_members",
  [sym_test_declaration] = "test_declaration",
  [sym_comptime_declaration] = "comptime_declaration",
  [sym_container_field] = "container_field",
  [sym_variable_declaration] = "variable_declaration",
  [sym__variable_declaration_expression_statement] = "variable_declaration",
  [sym__variable_declaration_header] = "_variable_declaration_header",
  [sym_function_declaration] = "function_declaration",
  [sym__function_prototype] = "_function_prototype",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym_using_namespace_declaration] = "using_namespace_declaration",
  [sym_block] = "block",
  [sym_struct_declaration] = "struct_declaration",
  [sym_opaque_declaration] = "opaque_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym_union_declaration] = "union_declaration",
  [sym_error_set_declaration] = "error_set_declaration",
  [sym_statement] = "statement",
  [sym_comptime_statement] = "comptime_statement",
  [sym_nosuspend_statement] = "nosuspend_statement",
  [sym_suspend_statement] = "suspend_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_errdefer_statement] = "errdefer_statement",
  [sym__block_expr_statement] = "_block_expr_statement",
  [sym_block_expression] = "block_expression",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym__if_prefix] = "_if_prefix",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym__for_prefix] = "_for_prefix",
  [sym_while_statement] = "while_statement",
  [sym__while_prefix] = "_while_prefix",
  [sym__conditional_body] = "_conditional_body",
  [sym_payload] = "payload",
  [sym_byte_alignment] = "byte_alignment",
  [sym_address_space] = "address_space",
  [sym_link_section] = "link_section",
  [sym_calling_convention] = "calling_convention",
  [sym_expression] = "expression",
  [sym_asm_expression] = "asm_expression",
  [sym_asm_output] = "asm_output",
  [sym_asm_output_item] = "asm_output_item",
  [sym_asm_input] = "asm_input",
  [sym_asm_input_item] = "asm_input_item",
  [sym_asm_clobbers] = "asm_clobbers",
  [sym_if_expression] = "if_expression",
  [sym_for_expression] = "for_expression",
  [sym_while_expression] = "while_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_comptime_expression] = "comptime_expression",
  [sym_async_expression] = "async_expression",
  [sym_await_expression] = "await_expression",
  [sym_nosuspend_expression] = "nosuspend_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_resume_expression] = "resume_expression",
  [sym_return_expression] = "return_expression",
  [sym_break_expression] = "break_expression",
  [sym_try_expression] = "try_expression",
  [sym_catch_expression] = "catch_expression",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_case] = "switch_case",
  [sym__switch_case_exp] = "_switch_case_exp",
  [sym_type_expression] = "type_expression",
  [sym_primary_type_expression] = "primary_type_expression",
  [sym_nullable_type] = "nullable_type",
  [sym_anyframe_type] = "anyframe_type",
  [sym_slice_type] = "slice_type",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_error_union_type] = "error_union_type",
  [sym_field_expression] = "field_expression",
  [sym_index_expression] = "index_expression",
  [sym_dereference_expression] = "dereference_expression",
  [sym_null_coercion_expression] = "null_coercion_expression",
  [sym_range_expression] = "range_expression",
  [sym_call_expression] = "call_expression",
  [sym_anonymous_struct_initializer] = "anonymous_struct_initializer",
  [sym_struct_initializer] = "struct_initializer",
  [sym_initializer_list] = "initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_labeled_type_expression] = "labeled_type_expression",
  [sym_comptime_type_expression] = "comptime_type_expression",
  [sym_if_type_expression] = "if_type_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_block_label] = "block_label",
  [sym_break_label] = "break_label",
  [sym_arguments] = "arguments",
  [sym_builtin_function] = "builtin_function",
  [sym_string] = "string",
  [sym_multiline_string] = "multiline_string",
  [sym_character] = "character",
  [sym_boolean] = "boolean",
  [sym_builtin_type] = "builtin_type",
  [sym_error_type] = "error_type",
  [sym_identifier] = "identifier",
  [sym__reserved_identifier] = "_reserved_identifier",
  [aux_sym__container_members_repeat1] = "_container_members_repeat1",
  [aux_sym__variable_declaration_expression_statement_repeat1] = "_variable_declaration_expression_statement_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_error_set_declaration_repeat1] = "error_set_declaration_repeat1",
  [aux_sym__for_prefix_repeat1] = "_for_prefix_repeat1",
  [aux_sym_payload_repeat1] = "payload_repeat1",
  [aux_sym_asm_output_repeat1] = "asm_output_repeat1",
  [aux_sym_asm_input_repeat1] = "asm_input_repeat1",
  [aux_sym_asm_clobbers_repeat1] = "asm_clobbers_repeat1",
  [aux_sym_switch_expression_repeat1] = "switch_expression_repeat1",
  [aux_sym__switch_case_exp_repeat1] = "_switch_case_exp_repeat1",
  [aux_sym_slice_type_repeat1] = "slice_type_repeat1",
  [aux_sym_pointer_type_repeat1] = "pointer_type_repeat1",
  [aux_sym_call_expression_repeat1] = "call_expression_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_multiline_string_repeat1] = "multiline_string_repeat1",
  [alias_sym_function_signature] = "function_signature",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier] = sym__identifier,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_test] = anon_sym_test,
  [anon_sym_comptime] = anon_sym_comptime,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_threadlocal] = anon_sym_threadlocal,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_PERCENT_EQ] = anon_sym_STAR_PERCENT_EQ,
  [anon_sym_STAR_PIPE_EQ] = anon_sym_STAR_PIPE_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_PLUS_PERCENT_EQ] = anon_sym_PLUS_PERCENT_EQ,
  [anon_sym_PLUS_PIPE_EQ] = anon_sym_PLUS_PIPE_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DASH_PERCENT_EQ] = anon_sym_DASH_PERCENT_EQ,
  [anon_sym_DASH_PIPE_EQ] = anon_sym_DASH_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_LT_LT_PIPE_EQ] = anon_sym_LT_LT_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_noinline] = anon_sym_noinline,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_noalias] = anon_sym_noalias,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_usingnamespace] = anon_sym_usingnamespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_packed] = anon_sym_packed,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_opaque] = anon_sym_opaque,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_nosuspend] = anon_sym_nosuspend,
  [anon_sym_suspend] = anon_sym_suspend,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_errdefer] = anon_sym_errdefer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_align] = anon_sym_align,
  [anon_sym_addrspace] = anon_sym_addrspace,
  [anon_sym_linksection] = anon_sym_linksection,
  [anon_sym_callconv] = anon_sym_callconv,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DASH_PERCENT] = anon_sym_DASH_PERCENT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_orelse] = anon_sym_orelse,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_LT_PIPE] = anon_sym_LT_LT_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_PLUS_PERCENT] = anon_sym_PLUS_PERCENT,
  [anon_sym_PLUS_PIPE] = anon_sym_PLUS_PIPE,
  [anon_sym_DASH_PIPE] = anon_sym_DASH_PIPE,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_STAR_PERCENT] = anon_sym_STAR_PERCENT,
  [anon_sym_STAR_PIPE] = anon_sym_STAR_PIPE,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_resume] = anon_sym_resume,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_anyframe] = anon_sym_anyframe,
  [anon_sym_unreachable] = anon_sym_unreachable,
  [anon_sym_undefined] = anon_sym_undefined,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_allowzero] = anon_sym_allowzero,
  [anon_sym_c] = anon_sym_c,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DOT_QMARK] = anon_sym_DOT_QMARK,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [aux_sym_multiline_string_token1] = aux_sym_multiline_string_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_character_token1] = aux_sym_character_token1,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_f16] = anon_sym_f16,
  [anon_sym_f32] = anon_sym_f32,
  [anon_sym_f64] = anon_sym_f64,
  [anon_sym_f128] = anon_sym_f128,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_anyerror] = anon_sym_anyerror,
  [anon_sym_anyopaque] = anon_sym_anyopaque,
  [anon_sym_anytype] = anon_sym_anytype,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_isize] = anon_sym_isize,
  [anon_sym_usize] = anon_sym_usize,
  [anon_sym_comptime_int] = anon_sym_comptime_int,
  [anon_sym_comptime_float] = anon_sym_comptime_float,
  [anon_sym_c_short] = anon_sym_c_short,
  [anon_sym_c_ushort] = anon_sym_c_ushort,
  [anon_sym_c_int] = anon_sym_c_int,
  [anon_sym_c_uint] = anon_sym_c_uint,
  [anon_sym_c_long] = anon_sym_c_long,
  [anon_sym_c_ulong] = anon_sym_c_ulong,
  [anon_sym_c_longlong] = anon_sym_c_longlong,
  [anon_sym_c_ulonglong] = anon_sym_c_ulonglong,
  [anon_sym_c_longdouble] = anon_sym_c_longdouble,
  [aux_sym_builtin_type_token1] = aux_sym_builtin_type_token1,
  [sym_builtin_identifier] = sym_builtin_identifier,
  [anon_sym_AT] = anon_sym_AT,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__container_members] = sym__container_members,
  [sym_test_declaration] = sym_test_declaration,
  [sym_comptime_declaration] = sym_comptime_declaration,
  [sym_container_field] = sym_container_field,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__variable_declaration_expression_statement] = sym_variable_declaration,
  [sym__variable_declaration_header] = sym__variable_declaration_header,
  [sym_function_declaration] = sym_function_declaration,
  [sym__function_prototype] = sym__function_prototype,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym_using_namespace_declaration] = sym_using_namespace_declaration,
  [sym_block] = sym_block,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_opaque_declaration] = sym_opaque_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_union_declaration] = sym_union_declaration,
  [sym_error_set_declaration] = sym_error_set_declaration,
  [sym_statement] = sym_statement,
  [sym_comptime_statement] = sym_comptime_statement,
  [sym_nosuspend_statement] = sym_nosuspend_statement,
  [sym_suspend_statement] = sym_suspend_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_errdefer_statement] = sym_errdefer_statement,
  [sym__block_expr_statement] = sym__block_expr_statement,
  [sym_block_expression] = sym_block_expression,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym__if_prefix] = sym__if_prefix,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym__for_prefix] = sym__for_prefix,
  [sym_while_statement] = sym_while_statement,
  [sym__while_prefix] = sym__while_prefix,
  [sym__conditional_body] = sym__conditional_body,
  [sym_payload] = sym_payload,
  [sym_byte_alignment] = sym_byte_alignment,
  [sym_address_space] = sym_address_space,
  [sym_link_section] = sym_link_section,
  [sym_calling_convention] = sym_calling_convention,
  [sym_expression] = sym_expression,
  [sym_asm_expression] = sym_asm_expression,
  [sym_asm_output] = sym_asm_output,
  [sym_asm_output_item] = sym_asm_output_item,
  [sym_asm_input] = sym_asm_input,
  [sym_asm_input_item] = sym_asm_input_item,
  [sym_asm_clobbers] = sym_asm_clobbers,
  [sym_if_expression] = sym_if_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_while_expression] = sym_while_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_comptime_expression] = sym_comptime_expression,
  [sym_async_expression] = sym_async_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_nosuspend_expression] = sym_nosuspend_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_resume_expression] = sym_resume_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_break_expression] = sym_break_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_catch_expression] = sym_catch_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_case] = sym_switch_case,
  [sym__switch_case_exp] = sym__switch_case_exp,
  [sym_type_expression] = sym_type_expression,
  [sym_primary_type_expression] = sym_primary_type_expression,
  [sym_nullable_type] = sym_nullable_type,
  [sym_anyframe_type] = sym_anyframe_type,
  [sym_slice_type] = sym_slice_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_error_union_type] = sym_error_union_type,
  [sym_field_expression] = sym_field_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_dereference_expression] = sym_dereference_expression,
  [sym_null_coercion_expression] = sym_null_coercion_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_anonymous_struct_initializer] = sym_anonymous_struct_initializer,
  [sym_struct_initializer] = sym_struct_initializer,
  [sym_initializer_list] = sym_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_labeled_type_expression] = sym_labeled_type_expression,
  [sym_comptime_type_expression] = sym_comptime_type_expression,
  [sym_if_type_expression] = sym_if_type_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_block_label] = sym_block_label,
  [sym_break_label] = sym_break_label,
  [sym_arguments] = sym_arguments,
  [sym_builtin_function] = sym_builtin_function,
  [sym_string] = sym_string,
  [sym_multiline_string] = sym_multiline_string,
  [sym_character] = sym_character,
  [sym_boolean] = sym_boolean,
  [sym_builtin_type] = sym_builtin_type,
  [sym_error_type] = sym_error_type,
  [sym_identifier] = sym_identifier,
  [sym__reserved_identifier] = sym__reserved_identifier,
  [aux_sym__container_members_repeat1] = aux_sym__container_members_repeat1,
  [aux_sym__variable_declaration_expression_statement_repeat1] = aux_sym__variable_declaration_expression_statement_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_error_set_declaration_repeat1] = aux_sym_error_set_declaration_repeat1,
  [aux_sym__for_prefix_repeat1] = aux_sym__for_prefix_repeat1,
  [aux_sym_payload_repeat1] = aux_sym_payload_repeat1,
  [aux_sym_asm_output_repeat1] = aux_sym_asm_output_repeat1,
  [aux_sym_asm_input_repeat1] = aux_sym_asm_input_repeat1,
  [aux_sym_asm_clobbers_repeat1] = aux_sym_asm_clobbers_repeat1,
  [aux_sym_switch_expression_repeat1] = aux_sym_switch_expression_repeat1,
  [aux_sym__switch_case_exp_repeat1] = aux_sym__switch_case_exp_repeat1,
  [aux_sym_slice_type_repeat1] = aux_sym_slice_type_repeat1,
  [aux_sym_pointer_type_repeat1] = aux_sym_pointer_type_repeat1,
  [aux_sym_call_expression_repeat1] = aux_sym_call_expression_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_multiline_string_repeat1] = aux_sym_multiline_string_repeat1,
  [alias_sym_function_signature] = alias_sym_function_signature,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_test] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comptime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_threadlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usingnamespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_packed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opaque] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosuspend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_suspend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_errdefer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linksection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callconv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orelse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_resume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyframe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unreachable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undefined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_allowzero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_multiline_string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyerror] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyopaque] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anytype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comptime_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comptime_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_ushort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_ulong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_longlong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_ulonglong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c_longdouble] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_builtin_type_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_builtin_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__container_members] = {
    .visible = false,
    .named = true,
  },
  [sym_test_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_comptime_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_container_field] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declaration_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declaration_header] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_prototype] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_using_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_opaque_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_union_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_set_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_comptime_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nosuspend_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_suspend_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_errdefer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__block_expr_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_block_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__if_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__while_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym__conditional_body] = {
    .visible = false,
    .named = true,
  },
  [sym_payload] = {
    .visible = true,
    .named = true,
  },
  [sym_byte_alignment] = {
    .visible = true,
    .named = true,
  },
  [sym_address_space] = {
    .visible = true,
    .named = true,
  },
  [sym_link_section] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_output] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_output_item] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_input] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_input_item] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_clobbers] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comptime_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_async_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nosuspend_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_resume_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym__switch_case_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_type_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_type_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym_anyframe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_error_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dereference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_null_coercion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_struct_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comptime_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_block_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_label] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_function] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_multiline_string] = {
    .visible = true,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_error_type] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__container_members_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declaration_expression_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_error_set_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_payload_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asm_output_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asm_input_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asm_clobbers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__switch_case_exp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiline_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_function_signature] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_body = 3,
  field_condition = 4,
  field_error = 5,
  field_function = 6,
  field_index = 7,
  field_left = 8,
  field_member = 9,
  field_name = 10,
  field_object = 11,
  field_ok = 12,
  field_operator = 13,
  field_right = 14,
  field_sentinel = 15,
  field_type = 16,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_error] = "error",
  [field_function] = "function",
  [field_index] = "index",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_object] = "object",
  [field_ok] = "ok",
  [field_operator] = "operator",
  [field_right] = "right",
  [field_sentinel] = "sentinel",
  [field_type] = "type",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 0, .length = 2},
  [9] = {.index = 9, .length = 3},
  [10] = {.index = 12, .length = 1},
  [11] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 17, .length = 3},
  [16] = {.index = 20, .length = 1},
  [17] = {.index = 21, .length = 1},
  [18] = {.index = 22, .length = 1},
  [19] = {.index = 23, .length = 2},
  [20] = {.index = 25, .length = 1},
  [21] = {.index = 26, .length = 3},
  [22] = {.index = 29, .length = 1},
  [23] = {.index = 30, .length = 2},
  [24] = {.index = 32, .length = 2},
  [25] = {.index = 34, .length = 2},
  [26] = {.index = 36, .length = 2},
  [27] = {.index = 36, .length = 2},
  [28] = {.index = 38, .length = 1},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 3},
  [31] = {.index = 44, .length = 2},
  [32] = {.index = 44, .length = 2},
  [33] = {.index = 46, .length = 1},
  [34] = {.index = 47, .length = 1},
  [35] = {.index = 48, .length = 2},
  [36] = {.index = 50, .length = 2},
  [37] = {.index = 52, .length = 1},
  [38] = {.index = 53, .length = 2},
  [39] = {.index = 55, .length = 1},
  [40] = {.index = 56, .length = 1},
  [41] = {.index = 57, .length = 2},
  [42] = {.index = 59, .length = 3},
  [43] = {.index = 62, .length = 1},
  [44] = {.index = 63, .length = 2},
  [45] = {.index = 65, .length = 1},
  [46] = {.index = 66, .length = 1},
  [47] = {.index = 67, .length = 1},
  [48] = {.index = 68, .length = 1},
  [49] = {.index = 69, .length = 2},
  [50] = {.index = 71, .length = 1},
  [51] = {.index = 72, .length = 3},
  [52] = {.index = 75, .length = 1},
  [53] = {.index = 76, .length = 2},
  [54] = {.index = 78, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [2] =
    {field_type, 0},
  [3] =
    {field_type, 1},
  [4] =
    {field_type, 0, .inherited = true},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_ok, 1},
  [8] =
    {field_member, 1},
  [9] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [12] =
    {field_condition, 0, .inherited = true},
  [13] =
    {field_left, 0},
  [14] =
    {field_type, 1, .inherited = true},
  [15] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [17] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [20] =
    {field_condition, 1, .inherited = true},
  [21] =
    {field_type, 2},
  [22] =
    {field_body, 0},
  [23] =
    {field_body, 1, .inherited = true},
    {field_condition, 0, .inherited = true},
  [25] =
    {field_body, 1, .inherited = true},
  [26] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [29] =
    {field_function, 0},
  [30] =
    {field_left, 0},
    {field_right, 2},
  [32] =
    {field_member, 2},
    {field_object, 0},
  [34] =
    {field_error, 0},
    {field_ok, 2},
  [36] =
    {field_name, 0},
    {field_type, 2},
  [38] =
    {field_type, 2, .inherited = true},
  [39] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [41] =
    {field_body, 3},
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [44] =
    {field_name, 1},
    {field_type, 3},
  [46] =
    {field_type, 3},
  [47] =
    {field_body, 2, .inherited = true},
  [48] =
    {field_body, 2, .inherited = true},
    {field_condition, 1, .inherited = true},
  [50] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [52] =
    {field_condition, 2},
  [53] =
    {field_index, 2},
    {field_object, 0},
  [55] =
    {field_condition, 2, .inherited = true},
  [56] =
    {field_type, 3, .inherited = true},
  [57] =
    {field_name, 3, .inherited = true},
    {field_type, 3, .inherited = true},
  [59] =
    {field_body, 4},
    {field_name, 3, .inherited = true},
    {field_type, 3, .inherited = true},
  [62] =
    {field_type, 4},
  [63] =
    {field_name, 1},
    {field_type, 4},
  [65] =
    {field_alternative, 1},
  [66] =
    {field_sentinel, 2},
  [67] =
    {field_type, 4, .inherited = true},
  [68] =
    {field_type, 5},
  [69] =
    {field_name, 1},
    {field_type, 5},
  [71] =
    {field_alternative, 2},
  [72] =
    {field_index, 2},
    {field_object, 0},
    {field_sentinel, 4},
  [75] =
    {field_type, 6},
  [76] =
    {field_name, 1},
    {field_type, 6},
  [78] =
    {field_name, 1},
    {field_type, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_function_signature,
  },
  [12] = {
    [0] = sym_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [31] = {
    [1] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__function_prototype, 2,
    sym__function_prototype,
    alias_sym_function_signature,
  sym_builtin_type, 2,
    sym_builtin_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 2,
  [7] = 5,
  [8] = 4,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 4,
  [14] = 3,
  [15] = 3,
  [16] = 4,
  [17] = 5,
  [18] = 4,
  [19] = 5,
  [20] = 4,
  [21] = 5,
  [22] = 5,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 25,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 34,
  [37] = 37,
  [38] = 38,
  [39] = 25,
  [40] = 40,
  [41] = 41,
  [42] = 34,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 43,
  [59] = 59,
  [60] = 44,
  [61] = 45,
  [62] = 56,
  [63] = 57,
  [64] = 46,
  [65] = 47,
  [66] = 48,
  [67] = 49,
  [68] = 50,
  [69] = 51,
  [70] = 52,
  [71] = 53,
  [72] = 54,
  [73] = 55,
  [74] = 59,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 85,
  [87] = 84,
  [88] = 85,
  [89] = 84,
  [90] = 85,
  [91] = 84,
  [92] = 83,
  [93] = 83,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 96,
  [100] = 100,
  [101] = 94,
  [102] = 95,
  [103] = 98,
  [104] = 97,
  [105] = 100,
  [106] = 98,
  [107] = 96,
  [108] = 98,
  [109] = 94,
  [110] = 95,
  [111] = 96,
  [112] = 100,
  [113] = 97,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 118,
  [121] = 121,
  [122] = 115,
  [123] = 123,
  [124] = 119,
  [125] = 117,
  [126] = 114,
  [127] = 121,
  [128] = 115,
  [129] = 123,
  [130] = 117,
  [131] = 123,
  [132] = 116,
  [133] = 118,
  [134] = 119,
  [135] = 114,
  [136] = 121,
  [137] = 116,
  [138] = 138,
  [139] = 138,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 138,
  [144] = 144,
  [145] = 145,
  [146] = 141,
  [147] = 142,
  [148] = 142,
  [149] = 142,
  [150] = 141,
  [151] = 145,
  [152] = 145,
  [153] = 153,
  [154] = 154,
  [155] = 141,
  [156] = 156,
  [157] = 138,
  [158] = 145,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 163,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 168,
  [174] = 170,
  [175] = 164,
  [176] = 176,
  [177] = 164,
  [178] = 171,
  [179] = 176,
  [180] = 165,
  [181] = 170,
  [182] = 182,
  [183] = 172,
  [184] = 163,
  [185] = 172,
  [186] = 164,
  [187] = 171,
  [188] = 171,
  [189] = 163,
  [190] = 172,
  [191] = 176,
  [192] = 176,
  [193] = 167,
  [194] = 170,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 227,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 201,
  [234] = 202,
  [235] = 203,
  [236] = 204,
  [237] = 207,
  [238] = 208,
  [239] = 212,
  [240] = 215,
  [241] = 216,
  [242] = 222,
  [243] = 223,
  [244] = 224,
  [245] = 225,
  [246] = 227,
  [247] = 230,
  [248] = 231,
  [249] = 230,
  [250] = 201,
  [251] = 202,
  [252] = 203,
  [253] = 253,
  [254] = 207,
  [255] = 208,
  [256] = 256,
  [257] = 257,
  [258] = 212,
  [259] = 215,
  [260] = 216,
  [261] = 222,
  [262] = 223,
  [263] = 224,
  [264] = 225,
  [265] = 265,
  [266] = 266,
  [267] = 209,
  [268] = 232,
  [269] = 230,
  [270] = 231,
  [271] = 201,
  [272] = 202,
  [273] = 203,
  [274] = 204,
  [275] = 207,
  [276] = 208,
  [277] = 212,
  [278] = 215,
  [279] = 279,
  [280] = 216,
  [281] = 222,
  [282] = 223,
  [283] = 224,
  [284] = 225,
  [285] = 285,
  [286] = 230,
  [287] = 201,
  [288] = 203,
  [289] = 204,
  [290] = 212,
  [291] = 222,
  [292] = 230,
  [293] = 201,
  [294] = 203,
  [295] = 295,
  [296] = 204,
  [297] = 297,
  [298] = 212,
  [299] = 222,
  [300] = 209,
  [301] = 231,
  [302] = 202,
  [303] = 202,
  [304] = 304,
  [305] = 305,
  [306] = 204,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 308,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 309,
  [319] = 310,
  [320] = 320,
  [321] = 314,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 320,
  [329] = 329,
  [330] = 324,
  [331] = 327,
  [332] = 311,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 337,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 355,
  [394] = 369,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 352,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 404,
  [418] = 418,
  [419] = 419,
  [420] = 348,
  [421] = 357,
  [422] = 387,
  [423] = 418,
  [424] = 419,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 336,
  [431] = 431,
  [432] = 346,
  [433] = 405,
  [434] = 354,
  [435] = 358,
  [436] = 359,
  [437] = 437,
  [438] = 376,
  [439] = 439,
  [440] = 396,
  [441] = 397,
  [442] = 398,
  [443] = 352,
  [444] = 400,
  [445] = 401,
  [446] = 407,
  [447] = 402,
  [448] = 403,
  [449] = 408,
  [450] = 450,
  [451] = 409,
  [452] = 404,
  [453] = 405,
  [454] = 410,
  [455] = 407,
  [456] = 408,
  [457] = 409,
  [458] = 410,
  [459] = 411,
  [460] = 412,
  [461] = 413,
  [462] = 416,
  [463] = 411,
  [464] = 412,
  [465] = 413,
  [466] = 348,
  [467] = 467,
  [468] = 425,
  [469] = 357,
  [470] = 470,
  [471] = 387,
  [472] = 418,
  [473] = 419,
  [474] = 425,
  [475] = 415,
  [476] = 476,
  [477] = 416,
  [478] = 478,
  [479] = 479,
  [480] = 428,
  [481] = 429,
  [482] = 336,
  [483] = 346,
  [484] = 484,
  [485] = 354,
  [486] = 358,
  [487] = 359,
  [488] = 488,
  [489] = 376,
  [490] = 367,
  [491] = 491,
  [492] = 349,
  [493] = 350,
  [494] = 351,
  [495] = 355,
  [496] = 496,
  [497] = 369,
  [498] = 396,
  [499] = 397,
  [500] = 398,
  [501] = 352,
  [502] = 400,
  [503] = 401,
  [504] = 402,
  [505] = 403,
  [506] = 506,
  [507] = 405,
  [508] = 407,
  [509] = 408,
  [510] = 409,
  [511] = 410,
  [512] = 411,
  [513] = 412,
  [514] = 413,
  [515] = 416,
  [516] = 516,
  [517] = 396,
  [518] = 518,
  [519] = 519,
  [520] = 357,
  [521] = 387,
  [522] = 418,
  [523] = 419,
  [524] = 425,
  [525] = 400,
  [526] = 397,
  [527] = 527,
  [528] = 401,
  [529] = 529,
  [530] = 530,
  [531] = 428,
  [532] = 429,
  [533] = 336,
  [534] = 534,
  [535] = 346,
  [536] = 536,
  [537] = 537,
  [538] = 358,
  [539] = 359,
  [540] = 376,
  [541] = 491,
  [542] = 355,
  [543] = 369,
  [544] = 397,
  [545] = 398,
  [546] = 400,
  [547] = 401,
  [548] = 402,
  [549] = 403,
  [550] = 405,
  [551] = 407,
  [552] = 408,
  [553] = 409,
  [554] = 410,
  [555] = 411,
  [556] = 412,
  [557] = 413,
  [558] = 416,
  [559] = 402,
  [560] = 357,
  [561] = 387,
  [562] = 418,
  [563] = 419,
  [564] = 425,
  [565] = 403,
  [566] = 428,
  [567] = 336,
  [568] = 346,
  [569] = 358,
  [570] = 359,
  [571] = 376,
  [572] = 397,
  [573] = 398,
  [574] = 400,
  [575] = 401,
  [576] = 402,
  [577] = 403,
  [578] = 405,
  [579] = 407,
  [580] = 408,
  [581] = 409,
  [582] = 410,
  [583] = 411,
  [584] = 412,
  [585] = 413,
  [586] = 416,
  [587] = 357,
  [588] = 588,
  [589] = 387,
  [590] = 418,
  [591] = 419,
  [592] = 425,
  [593] = 593,
  [594] = 428,
  [595] = 346,
  [596] = 358,
  [597] = 428,
  [598] = 359,
  [599] = 376,
  [600] = 398,
  [601] = 367,
  [602] = 491,
  [603] = 349,
  [604] = 350,
  [605] = 351,
  [606] = 355,
  [607] = 429,
  [608] = 369,
  [609] = 396,
  [610] = 352,
  [611] = 429,
  [612] = 367,
  [613] = 491,
  [614] = 349,
  [615] = 350,
  [616] = 351,
  [617] = 355,
  [618] = 369,
  [619] = 396,
  [620] = 352,
  [621] = 429,
  [622] = 367,
  [623] = 491,
  [624] = 349,
  [625] = 350,
  [626] = 351,
  [627] = 367,
  [628] = 491,
  [629] = 349,
  [630] = 350,
  [631] = 351,
  [632] = 491,
  [633] = 491,
  [634] = 366,
  [635] = 382,
  [636] = 383,
  [637] = 450,
  [638] = 336,
  [639] = 588,
  [640] = 593,
  [641] = 347,
  [642] = 338,
  [643] = 643,
  [644] = 644,
  [645] = 383,
  [646] = 593,
  [647] = 347,
  [648] = 406,
  [649] = 365,
  [650] = 368,
  [651] = 370,
  [652] = 506,
  [653] = 516,
  [654] = 518,
  [655] = 537,
  [656] = 415,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 316,
  [666] = 169,
  [667] = 333,
  [668] = 182,
  [669] = 322,
  [670] = 670,
  [671] = 81,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 82,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 776,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 851,
  [923] = 923,
  [924] = 908,
  [925] = 775,
  [926] = 853,
  [927] = 918,
  [928] = 928,
  [929] = 860,
  [930] = 774,
  [931] = 861,
  [932] = 868,
  [933] = 896,
  [934] = 869,
  [935] = 879,
  [936] = 891,
  [937] = 880,
  [938] = 893,
  [939] = 889,
  [940] = 890,
  [941] = 941,
  [942] = 910,
  [943] = 777,
  [944] = 911,
  [945] = 870,
  [946] = 946,
  [947] = 854,
  [948] = 948,
  [949] = 867,
  [950] = 857,
  [951] = 894,
  [952] = 866,
  [953] = 852,
  [954] = 884,
  [955] = 876,
  [956] = 849,
  [957] = 957,
  [958] = 921,
  [959] = 892,
  [960] = 856,
  [961] = 914,
  [962] = 906,
  [963] = 902,
  [964] = 916,
  [965] = 900,
  [966] = 901,
  [967] = 895,
  [968] = 904,
  [969] = 897,
  [970] = 859,
  [971] = 907,
  [972] = 972,
  [973] = 973,
  [974] = 905,
  [975] = 903,
  [976] = 802,
  [977] = 841,
  [978] = 825,
  [979] = 979,
  [980] = 828,
  [981] = 776,
  [982] = 982,
  [983] = 776,
  [984] = 984,
  [985] = 985,
  [986] = 838,
  [987] = 844,
  [988] = 844,
  [989] = 910,
  [990] = 835,
  [991] = 836,
  [992] = 824,
  [993] = 826,
  [994] = 831,
  [995] = 832,
  [996] = 846,
  [997] = 798,
  [998] = 862,
  [999] = 878,
  [1000] = 917,
  [1001] = 829,
  [1002] = 797,
  [1003] = 779,
  [1004] = 839,
  [1005] = 920,
  [1006] = 785,
  [1007] = 919,
  [1008] = 792,
  [1009] = 823,
  [1010] = 788,
  [1011] = 790,
  [1012] = 791,
  [1013] = 793,
  [1014] = 794,
  [1015] = 803,
  [1016] = 888,
  [1017] = 855,
  [1018] = 865,
  [1019] = 818,
  [1020] = 822,
  [1021] = 801,
  [1022] = 804,
  [1023] = 805,
  [1024] = 810,
  [1025] = 813,
  [1026] = 819,
  [1027] = 847,
  [1028] = 799,
  [1029] = 784,
  [1030] = 800,
  [1031] = 909,
  [1032] = 882,
  [1033] = 806,
  [1034] = 808,
  [1035] = 809,
  [1036] = 837,
  [1037] = 840,
  [1038] = 845,
  [1039] = 848,
  [1040] = 913,
  [1041] = 850,
  [1042] = 864,
  [1043] = 160,
  [1044] = 842,
  [1045] = 781,
  [1046] = 795,
  [1047] = 796,
  [1048] = 830,
  [1049] = 834,
  [1050] = 782,
  [1051] = 783,
  [1052] = 789,
  [1053] = 899,
  [1054] = 161,
  [1055] = 812,
  [1056] = 814,
  [1057] = 817,
  [1058] = 820,
  [1059] = 153,
  [1060] = 140,
  [1061] = 843,
  [1062] = 786,
  [1063] = 889,
  [1064] = 81,
  [1065] = 877,
  [1066] = 82,
  [1067] = 862,
  [1068] = 878,
  [1069] = 917,
  [1070] = 920,
  [1071] = 885,
  [1072] = 919,
  [1073] = 875,
  [1074] = 881,
  [1075] = 888,
  [1076] = 855,
  [1077] = 865,
  [1078] = 887,
  [1079] = 873,
  [1080] = 909,
  [1081] = 882,
  [1082] = 898,
  [1083] = 912,
  [1084] = 913,
  [1085] = 850,
  [1086] = 864,
  [1087] = 871,
  [1088] = 886,
  [1089] = 899,
  [1090] = 863,
  [1091] = 851,
  [1092] = 877,
  [1093] = 875,
  [1094] = 881,
  [1095] = 876,
  [1096] = 887,
  [1097] = 873,
  [1098] = 884,
  [1099] = 898,
  [1100] = 912,
  [1101] = 871,
  [1102] = 886,
  [1103] = 863,
  [1104] = 889,
  [1105] = 851,
  [1106] = 876,
  [1107] = 884,
  [1108] = 872,
  [1109] = 915,
  [1110] = 874,
  [1111] = 883,
  [1112] = 858,
  [1113] = 879,
  [1114] = 880,
  [1115] = 921,
  [1116] = 891,
  [1117] = 893,
  [1118] = 894,
  [1119] = 895,
  [1120] = 896,
  [1121] = 910,
  [1122] = 911,
  [1123] = 914,
  [1124] = 916,
  [1125] = 890,
  [1126] = 918,
  [1127] = 852,
  [1128] = 853,
  [1129] = 857,
  [1130] = 859,
  [1131] = 867,
  [1132] = 849,
  [1133] = 854,
  [1134] = 856,
  [1135] = 860,
  [1136] = 861,
  [1137] = 866,
  [1138] = 868,
  [1139] = 869,
  [1140] = 870,
  [1141] = 879,
  [1142] = 880,
  [1143] = 921,
  [1144] = 891,
  [1145] = 893,
  [1146] = 894,
  [1147] = 895,
  [1148] = 896,
  [1149] = 911,
  [1150] = 914,
  [1151] = 916,
  [1152] = 890,
  [1153] = 918,
  [1154] = 852,
  [1155] = 853,
  [1156] = 857,
  [1157] = 859,
  [1158] = 867,
  [1159] = 849,
  [1160] = 854,
  [1161] = 856,
  [1162] = 860,
  [1163] = 861,
  [1164] = 866,
  [1165] = 868,
  [1166] = 869,
  [1167] = 870,
  [1168] = 897,
  [1169] = 900,
  [1170] = 901,
  [1171] = 902,
  [1172] = 903,
  [1173] = 904,
  [1174] = 905,
  [1175] = 907,
  [1176] = 908,
  [1177] = 780,
  [1178] = 892,
  [1179] = 906,
  [1180] = 828,
  [1181] = 802,
  [1182] = 821,
  [1183] = 833,
  [1184] = 872,
  [1185] = 807,
  [1186] = 838,
  [1187] = 841,
  [1188] = 915,
  [1189] = 874,
  [1190] = 883,
  [1191] = 787,
  [1192] = 858,
  [1193] = 811,
  [1194] = 815,
  [1195] = 816,
  [1196] = 827,
  [1197] = 892,
  [1198] = 897,
  [1199] = 900,
  [1200] = 901,
  [1201] = 902,
  [1202] = 903,
  [1203] = 904,
  [1204] = 905,
  [1205] = 906,
  [1206] = 907,
  [1207] = 908,
  [1208] = 885,
  [1209] = 889,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 876,
  [1213] = 1213,
  [1214] = 884,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 880,
  [1218] = 908,
  [1219] = 900,
  [1220] = 901,
  [1221] = 902,
  [1222] = 903,
  [1223] = 904,
  [1224] = 905,
  [1225] = 906,
  [1226] = 907,
  [1227] = 908,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 891,
  [1238] = 851,
  [1239] = 879,
  [1240] = 880,
  [1241] = 921,
  [1242] = 921,
  [1243] = 893,
  [1244] = 891,
  [1245] = 893,
  [1246] = 854,
  [1247] = 894,
  [1248] = 895,
  [1249] = 896,
  [1250] = 910,
  [1251] = 911,
  [1252] = 914,
  [1253] = 856,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 916,
  [1257] = 1257,
  [1258] = 894,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 860,
  [1262] = 861,
  [1263] = 890,
  [1264] = 918,
  [1265] = 852,
  [1266] = 857,
  [1267] = 859,
  [1268] = 867,
  [1269] = 849,
  [1270] = 892,
  [1271] = 895,
  [1272] = 854,
  [1273] = 856,
  [1274] = 860,
  [1275] = 861,
  [1276] = 896,
  [1277] = 910,
  [1278] = 911,
  [1279] = 914,
  [1280] = 866,
  [1281] = 897,
  [1282] = 868,
  [1283] = 869,
  [1284] = 890,
  [1285] = 918,
  [1286] = 892,
  [1287] = 852,
  [1288] = 870,
  [1289] = 897,
  [1290] = 900,
  [1291] = 901,
  [1292] = 879,
  [1293] = 902,
  [1294] = 903,
  [1295] = 904,
  [1296] = 905,
  [1297] = 866,
  [1298] = 868,
  [1299] = 869,
  [1300] = 853,
  [1301] = 857,
  [1302] = 859,
  [1303] = 916,
  [1304] = 870,
  [1305] = 867,
  [1306] = 849,
  [1307] = 851,
  [1308] = 906,
  [1309] = 907,
  [1310] = 853,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 898,
  [1316] = 1316,
  [1317] = 912,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1336,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1334,
  [1346] = 877,
  [1347] = 1347,
  [1348] = 1318,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 863,
  [1352] = 873,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 871,
  [1357] = 1326,
  [1358] = 1358,
  [1359] = 886,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 875,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 881,
  [1367] = 887,
  [1368] = 1368,
  [1369] = 1362,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1374,
  [1383] = 1378,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1378,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1399,
  [1409] = 1388,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1400,
  [1414] = 1414,
  [1415] = 1387,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 874,
  [1422] = 906,
  [1423] = 1390,
  [1424] = 1399,
  [1425] = 1400,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 906,
  [1430] = 1390,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1417,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1403,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1438,
  [1441] = 1412,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1389,
  [1445] = 1391,
  [1446] = 1398,
  [1447] = 1447,
  [1448] = 1416,
  [1449] = 1443,
  [1450] = 892,
  [1451] = 1451,
  [1452] = 892,
  [1453] = 1451,
  [1454] = 1451,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1461,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1464,
  [1467] = 1461,
  [1468] = 1461,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1474,
  [1476] = 1473,
  [1477] = 1477,
  [1478] = 1472,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1481,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1487,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1490,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1498,
  [1500] = 1498,
  [1501] = 1498,
  [1502] = 1502,
  [1503] = 1498,
  [1504] = 1498,
  [1505] = 1498,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1538,
  [1543] = 1538,
  [1544] = 1538,
  [1545] = 1541,
  [1546] = 1541,
  [1547] = 1547,
  [1548] = 1547,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1541,
  [1552] = 1552,
  [1553] = 1541,
  [1554] = 1541,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1538,
  [1560] = 1538,
  [1561] = 1536,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1555,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1586,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1585,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1578,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1572,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1614,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1569,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1616,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1583,
  [1632] = 1587,
  [1633] = 1589,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1596,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1591,
  [1641] = 1641,
  [1642] = 1621,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1659,
  [1661] = 1661,
  [1662] = 1659,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1661,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1679,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1685,
  [1688] = 1688,
  [1689] = 1659,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1656,
  [1696] = 1669,
  [1697] = 1672,
  [1698] = 1680,
  [1699] = 1676,
  [1700] = 1670,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1694,
  [1705] = 1658,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1706,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1708,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1717,
  [1730] = 1723,
  [1731] = 1731,
  [1732] = 1716,
  [1733] = 1733,
  [1734] = 1722,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1724,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1739,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1727,
  [1754] = 1725,
  [1755] = 1755,
  [1756] = 1731,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1718,
  [1762] = 1746,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1742,
  [1769] = 1769,
  [1770] = 1720,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1717,
  [1775] = 1760,
  [1776] = 1776,
  [1777] = 1741,
  [1778] = 1778,
  [1779] = 1767,
  [1780] = 1721,
  [1781] = 1740,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1736,
  [1786] = 1735,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1752,
  [1791] = 1782,
  [1792] = 1745,
  [1793] = 1793,
  [1794] = 1778,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1744,
  [1799] = 1759,
  [1800] = 1763,
  [1801] = 1801,
  [1802] = 1733,
  [1803] = 1803,
  [1804] = 1755,
  [1805] = 1783,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1787,
  [1810] = 1784,
  [1811] = 1743,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(30);
      ADVANCE_MAP(
        '!', 68,
        '"', 105,
        '%', 93,
        '&', 76,
        '\'', 113,
        '(', 53,
        ')', 54,
        '*', 63,
        '+', 87,
        ',', 31,
        '-', 70,
        '.', 100,
        '/', 92,
        '0', 118,
        ':', 32,
        ';', 35,
        '<', 82,
        '=', 33,
        '>', 79,
        '?', 99,
        '@', 127,
        '[', 64,
        '\\', 7,
        ']', 65,
        '^', 83,
        '{', 56,
        '|', 61,
        '}', 57,
        '~', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(4);
      if (lookahead == '"') ADVANCE(105);
      if (lookahead == '/') ADVANCE(107);
      if (lookahead == '\\') ADVANCE(9);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(106);
      if (lookahead != 0) ADVANCE(108);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(2);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '\\') ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(116);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(114);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 68,
        '"', 105,
        '%', 93,
        '&', 76,
        '\'', 113,
        '(', 53,
        '*', 63,
        '+', 87,
        ',', 31,
        '-', 71,
        '.', 100,
        '/', 92,
        '0', 118,
        ':', 32,
        '<', 82,
        '=', 33,
        '>', 79,
        '?', 99,
        '@', 127,
        '[', 64,
        '\\', 8,
        '^', 83,
        '{', 56,
        '|', 61,
        '~', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(105);
      if (lookahead == '/') ADVANCE(6);
      if (lookahead == '\\') ADVANCE(9);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(55);
      END_STATE();
    case 6:
      if (lookahead == '/') ADVANCE(129);
      END_STATE();
    case 7:
      if (lookahead == '\\') ADVANCE(110);
      if (lookahead == 'u') ADVANCE(10);
      if (lookahead == 'x') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != 'U') ADVANCE(110);
      END_STATE();
    case 8:
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 9:
      if (lookahead == 'u') ADVANCE(10);
      if (lookahead == 'x') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != 'U') ADVANCE(110);
      END_STATE();
    case 10:
      if (lookahead == '{') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(110);
      END_STATE();
    case 12:
      if (lookahead == '}') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 13:
      if (lookahead == '}') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == '}') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (lookahead == '}') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      END_STATE();
    case 18:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(121);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(122);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(110);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(125);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 28:
      if (eof) ADVANCE(30);
      ADVANCE_MAP(
        '!', 68,
        '"', 105,
        '%', 93,
        '&', 76,
        '\'', 113,
        '(', 53,
        ')', 54,
        '*', 63,
        '+', 87,
        ',', 31,
        '-', 70,
        '.', 101,
        '/', 92,
        '0', 118,
        ':', 32,
        ';', 35,
        '<', 82,
        '=', 33,
        '>', 79,
        '?', 99,
        '@', 127,
        '[', 64,
        '\\', 8,
        ']', 65,
        '^', 83,
        '{', 56,
        '|', 61,
        '}', 57,
        '~', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 29:
      if (eof) ADVANCE(30);
      ADVANCE_MAP(
        '!', 67,
        '"', 105,
        '&', 75,
        '\'', 113,
        '(', 53,
        ')', 54,
        '*', 62,
        ',', 31,
        '-', 72,
        '.', 102,
        '/', 6,
        '0', 118,
        ':', 32,
        ';', 35,
        '=', 34,
        '?', 99,
        '@', 127,
        '[', 64,
        '\\', 8,
        ']', 65,
        '{', 56,
        '|', 60,
        '}', 57,
        '~', 69,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_STAR_PERCENT_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_STAR_PIPE_EQ);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PLUS_PERCENT_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_PLUS_PIPE_EQ);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE_EQ);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(55);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(52);
      if (lookahead == '|') ADVANCE(97);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '*') ADVANCE(94);
      if (lookahead == '=') ADVANCE(36);
      if (lookahead == '|') ADVANCE(96);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(78);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(74);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(66);
      if (lookahead == '|') ADVANCE(91);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(74);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '|') ADVANCE(91);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT);
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(50);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(85);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(51);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '|') ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE);
      if (lookahead == '=') ADVANCE(48);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '%') ADVANCE(89);
      if (lookahead == '+') ADVANCE(88);
      if (lookahead == '=') ADVANCE(41);
      if (lookahead == '|') ADVANCE(90);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PLUS_PERCENT);
      if (lookahead == '=') ADVANCE(42);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PLUS_PIPE);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '=') ADVANCE(39);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(40);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_PERCENT);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR_PIPE);
      if (lookahead == '=') ADVANCE(38);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(103);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '?') ADVANCE(104);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(103);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '?') ADVANCE(104);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(5);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DOT_QMARK);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(107);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(106);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_multiline_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(110);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(111);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_character_token1);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_character_token1);
      if (lookahead == '/') ADVANCE(129);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_character_token1);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '\\') ADVANCE(117);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(116);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\'') ADVANCE(114);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_character_token1);
      if (lookahead == 'u') ADVANCE(10);
      if (lookahead == 'x') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != 'U') ADVANCE(110);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == 'b') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'x') ADVANCE(24);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '_') ADVANCE(24);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(18);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(21);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_builtin_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AT);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(129);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'l', 8,
        'n', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'v', 16,
        'w', 17,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(19);
      if (lookahead == 'n') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_c);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(28);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'r') ADVANCE(31);
      if (lookahead == 'x') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == '1') ADVANCE(33);
      if (lookahead == '3') ADVANCE(34);
      if (lookahead == '6') ADVANCE(35);
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 's') ADVANCE(41);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 10:
      if (lookahead == 'p') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 't') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      if (lookahead == 'w') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(54);
      if (lookahead == 'h') ADVANCE(55);
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(58);
      if (lookahead == 's') ADVANCE(59);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(42);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(62);
      END_STATE();
    case 18:
      if (lookahead == 'd') ADVANCE(63);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(64);
      if (lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 20:
      if (lookahead == 'd') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 21:
      if (lookahead == 'm') ADVANCE(68);
      if (lookahead == 'y') ADVANCE(69);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(73);
      if (lookahead == 'l') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      if (lookahead == 'u') ADVANCE(76);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 27:
      if (lookahead == 'm') ADVANCE(79);
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == '2') ADVANCE(87);
      if (lookahead == '6') ADVANCE(88);
      END_STATE();
    case 34:
      if (lookahead == '2') ADVANCE(89);
      END_STATE();
    case 35:
      if (lookahead == '4') ADVANCE(90);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(91);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym_builtin_type_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 'r') ADVANCE(98);
      if (lookahead == 's') ADVANCE(99);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(100);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 48:
      if (lookahead == 'c') ADVANCE(103);
      END_STATE();
    case 49:
      if (lookahead == 'b') ADVANCE(104);
      END_STATE();
    case 50:
      if (lookahead == 's') ADVANCE(105);
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 52:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(109);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(112);
      if (lookahead == 'y') ADVANCE(113);
      END_STATE();
    case 57:
      if (lookahead == 'p') ADVANCE(114);
      END_STATE();
    case 58:
      if (lookahead == 'd') ADVANCE(115);
      if (lookahead == 'i') ADVANCE(116);
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 60:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'l') ADVANCE(121);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(124);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'f') ADVANCE(127);
      if (lookahead == 'o') ADVANCE(128);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(133);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(134);
      END_STATE();
    case 74:
      if (lookahead == 'o') ADVANCE(135);
      END_STATE();
    case 75:
      if (lookahead == 'h') ADVANCE(136);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(137);
      if (lookahead == 'l') ADVANCE(138);
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 79:
      if (lookahead == 'p') ADVANCE(142);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(143);
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(147);
      END_STATE();
    case 84:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 85:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 87:
      if (lookahead == '8') ADVANCE(152);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_f16);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(153);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(154);
      END_STATE();
    case 94:
      if (lookahead == 'z') ADVANCE(155);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(156);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(158);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 99:
      if (lookahead == 'u') ADVANCE(160);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 101:
      if (lookahead == 'q') ADVANCE(162);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 103:
      if (lookahead == 'k') ADVANCE(164);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 105:
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(166);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 108:
      if (lookahead == 'p') ADVANCE(168);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(175);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(177);
      if (lookahead == 'z') ADVANCE(178);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(180);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 123:
      if (lookahead == 's') ADVANCE(182);
      END_STATE();
    case 124:
      if (lookahead == 'n') ADVANCE(183);
      END_STATE();
    case 125:
      if (lookahead == 'w') ADVANCE(184);
      END_STATE();
    case 126:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 127:
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 128:
      if (lookahead == 'p') ADVANCE(187);
      END_STATE();
    case 129:
      if (lookahead == 'y') ADVANCE(188);
      END_STATE();
    case 130:
      if (lookahead == 'c') ADVANCE(189);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 133:
      if (lookahead == 'k') ADVANCE(191);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 135:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 136:
      if (lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 137:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 138:
      if (lookahead == 'o') ADVANCE(196);
      END_STATE();
    case 139:
      if (lookahead == 'h') ADVANCE(197);
      END_STATE();
    case 140:
      if (lookahead == 'c') ADVANCE(198);
      END_STATE();
    case 141:
      if (lookahead == 'h') ADVANCE(199);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 149:
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(207);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_f128);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(209);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 156:
      if (lookahead == 's') ADVANCE(211);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'u') ADVANCE(216);
      END_STATE();
    case 163:
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 165:
      if (lookahead == 'm') ADVANCE(219);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 167:
      if (lookahead == 'c') ADVANCE(221);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 169:
      if (lookahead == 'c') ADVANCE(223);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_test);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 174:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(226);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 177:
      if (lookahead == 'g') ADVANCE(228);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 182:
      if (lookahead == 'p') ADVANCE(232);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_align);
      END_STATE();
    case 184:
      if (lookahead == 'z') ADVANCE(233);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 188:
      if (lookahead == 'p') ADVANCE(237);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_c_int);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(238);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 195:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 196:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 197:
      if (lookahead == 'o') ADVANCE(242);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 202:
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 204:
      if (lookahead == 'f') ADVANCE(246);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 207:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(249);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 212:
      if (lookahead == 'a') ADVANCE(251);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 214:
      if (lookahead == 'u') ADVANCE(253);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(254);
      END_STATE();
    case 216:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 217:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 218:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 219:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(260);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 223:
      if (lookahead == 'h') ADVANCE(262);
      END_STATE();
    case 224:
      if (lookahead == 'd') ADVANCE(263);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(264);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 227:
      if (lookahead == 'c') ADVANCE(265);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 232:
      if (lookahead == 'a') ADVANCE(268);
      END_STATE();
    case 233:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 234:
      if (lookahead == 'o') ADVANCE(270);
      END_STATE();
    case 235:
      if (lookahead == 'm') ADVANCE(271);
      END_STATE();
    case 236:
      if (lookahead == 'q') ADVANCE(272);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_c_long);
      if (lookahead == 'd') ADVANCE(274);
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 239:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_c_uint);
      END_STATE();
    case 241:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 243:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 244:
      if (lookahead == 'm') ADVANCE(280);
      END_STATE();
    case 245:
      if (lookahead == 'u') ADVANCE(281);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 250:
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 251:
      if (lookahead == 's') ADVANCE(284);
      END_STATE();
    case 252:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 253:
      if (lookahead == 'r') ADVANCE(286);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_opaque);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_orelse);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_packed);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_resume);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 261:
      if (lookahead == 'd') ADVANCE(288);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 263:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 264:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 265:
      if (lookahead == 'h') ADVANCE(291);
      END_STATE();
    case 266:
      if (lookahead == 'a') ADVANCE(292);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(293);
      END_STATE();
    case 268:
      if (lookahead == 'c') ADVANCE(294);
      END_STATE();
    case 269:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 270:
      if (lookahead == 'r') ADVANCE(296);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 272:
      if (lookahead == 'u') ADVANCE(298);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_anytype);
      END_STATE();
    case 274:
      if (lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 275:
      if (lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_c_short);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_c_ulong);
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(302);
      END_STATE();
    case 279:
      if (lookahead == 'v') ADVANCE(303);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(304);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(306);
      END_STATE();
    case 283:
      if (lookahead == 't') ADVANCE(307);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_noalias);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 286:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 287:
      if (lookahead == 'n') ADVANCE(310);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_suspend);
      END_STATE();
    case 289:
      if (lookahead == 'o') ADVANCE(311);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 291:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 292:
      if (lookahead == 'm') ADVANCE(314);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 295:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_anyerror);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_anyframe);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 299:
      if (lookahead == 'u') ADVANCE(319);
      END_STATE();
    case 300:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 301:
      if (lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_c_ushort);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_callconv);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_comptime);
      if (lookahead == '_') ADVANCE(322);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_errdefer);
      END_STATE();
    case 307:
      if (lookahead == 'i') ADVANCE(323);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_noinline);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 310:
      if (lookahead == 'd') ADVANCE(324);
      END_STATE();
    case 311:
      if (lookahead == 'c') ADVANCE(325);
      END_STATE();
    case 312:
      if (lookahead == 'd') ADVANCE(326);
      END_STATE();
    case 313:
      if (lookahead == 'b') ADVANCE(327);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_addrspace);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_allowzero);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_anyopaque);
      END_STATE();
    case 319:
      if (lookahead == 'b') ADVANCE(329);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(330);
      END_STATE();
    case 321:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 322:
      if (lookahead == 'f') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(333);
      END_STATE();
    case 323:
      if (lookahead == 'o') ADVANCE(334);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_nosuspend);
      END_STATE();
    case 325:
      if (lookahead == 'a') ADVANCE(335);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_undefined);
      END_STATE();
    case 327:
      if (lookahead == 'l') ADVANCE(336);
      END_STATE();
    case 328:
      if (lookahead == 's') ADVANCE(337);
      END_STATE();
    case 329:
      if (lookahead == 'l') ADVANCE(338);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_c_longlong);
      END_STATE();
    case 331:
      if (lookahead == 'g') ADVANCE(339);
      END_STATE();
    case 332:
      if (lookahead == 'l') ADVANCE(340);
      END_STATE();
    case 333:
      if (lookahead == 'n') ADVANCE(341);
      END_STATE();
    case 334:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 335:
      if (lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 336:
      if (lookahead == 'e') ADVANCE(344);
      END_STATE();
    case 337:
      if (lookahead == 'p') ADVANCE(345);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(346);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_c_ulonglong);
      END_STATE();
    case 340:
      if (lookahead == 'o') ADVANCE(347);
      END_STATE();
    case 341:
      if (lookahead == 't') ADVANCE(348);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_linksection);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_threadlocal);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_unreachable);
      END_STATE();
    case 345:
      if (lookahead == 'a') ADVANCE(349);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_c_longdouble);
      END_STATE();
    case 347:
      if (lookahead == 'a') ADVANCE(350);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_comptime_int);
      END_STATE();
    case 349:
      if (lookahead == 'c') ADVANCE(351);
      END_STATE();
    case 350:
      if (lookahead == 't') ADVANCE(352);
      END_STATE();
    case 351:
      if (lookahead == 'e') ADVANCE(353);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_comptime_float);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_usingnamespace);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 29},
  [2] = {.lex_state = 28},
  [3] = {.lex_state = 28},
  [4] = {.lex_state = 28},
  [5] = {.lex_state = 28},
  [6] = {.lex_state = 28},
  [7] = {.lex_state = 28},
  [8] = {.lex_state = 28},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 28},
  [12] = {.lex_state = 28},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 28},
  [16] = {.lex_state = 28},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 28},
  [20] = {.lex_state = 28},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 28},
  [23] = {.lex_state = 28},
  [24] = {.lex_state = 28},
  [25] = {.lex_state = 29},
  [26] = {.lex_state = 29},
  [27] = {.lex_state = 29},
  [28] = {.lex_state = 29},
  [29] = {.lex_state = 29},
  [30] = {.lex_state = 29},
  [31] = {.lex_state = 29},
  [32] = {.lex_state = 29},
  [33] = {.lex_state = 29},
  [34] = {.lex_state = 29},
  [35] = {.lex_state = 29},
  [36] = {.lex_state = 29},
  [37] = {.lex_state = 29},
  [38] = {.lex_state = 29},
  [39] = {.lex_state = 29},
  [40] = {.lex_state = 29},
  [41] = {.lex_state = 29},
  [42] = {.lex_state = 29},
  [43] = {.lex_state = 29},
  [44] = {.lex_state = 29},
  [45] = {.lex_state = 29},
  [46] = {.lex_state = 29},
  [47] = {.lex_state = 29},
  [48] = {.lex_state = 29},
  [49] = {.lex_state = 29},
  [50] = {.lex_state = 29},
  [51] = {.lex_state = 29},
  [52] = {.lex_state = 29},
  [53] = {.lex_state = 29},
  [54] = {.lex_state = 29},
  [55] = {.lex_state = 29},
  [56] = {.lex_state = 29},
  [57] = {.lex_state = 29},
  [58] = {.lex_state = 29},
  [59] = {.lex_state = 29},
  [60] = {.lex_state = 29},
  [61] = {.lex_state = 29},
  [62] = {.lex_state = 29},
  [63] = {.lex_state = 29},
  [64] = {.lex_state = 29},
  [65] = {.lex_state = 29},
  [66] = {.lex_state = 29},
  [67] = {.lex_state = 29},
  [68] = {.lex_state = 29},
  [69] = {.lex_state = 29},
  [70] = {.lex_state = 29},
  [71] = {.lex_state = 29},
  [72] = {.lex_state = 29},
  [73] = {.lex_state = 29},
  [74] = {.lex_state = 29},
  [75] = {.lex_state = 29},
  [76] = {.lex_state = 29},
  [77] = {.lex_state = 29},
  [78] = {.lex_state = 29},
  [79] = {.lex_state = 29},
  [80] = {.lex_state = 29},
  [81] = {.lex_state = 28},
  [82] = {.lex_state = 28},
  [83] = {.lex_state = 29},
  [84] = {.lex_state = 29},
  [85] = {.lex_state = 29},
  [86] = {.lex_state = 29},
  [87] = {.lex_state = 29},
  [88] = {.lex_state = 29},
  [89] = {.lex_state = 29},
  [90] = {.lex_state = 29},
  [91] = {.lex_state = 29},
  [92] = {.lex_state = 29},
  [93] = {.lex_state = 29},
  [94] = {.lex_state = 29},
  [95] = {.lex_state = 29},
  [96] = {.lex_state = 29},
  [97] = {.lex_state = 29},
  [98] = {.lex_state = 29},
  [99] = {.lex_state = 29},
  [100] = {.lex_state = 29},
  [101] = {.lex_state = 29},
  [102] = {.lex_state = 29},
  [103] = {.lex_state = 29},
  [104] = {.lex_state = 29},
  [105] = {.lex_state = 29},
  [106] = {.lex_state = 29},
  [107] = {.lex_state = 29},
  [108] = {.lex_state = 29},
  [109] = {.lex_state = 29},
  [110] = {.lex_state = 29},
  [111] = {.lex_state = 29},
  [112] = {.lex_state = 29},
  [113] = {.lex_state = 29},
  [114] = {.lex_state = 29},
  [115] = {.lex_state = 29},
  [116] = {.lex_state = 29},
  [117] = {.lex_state = 29},
  [118] = {.lex_state = 29},
  [119] = {.lex_state = 29},
  [120] = {.lex_state = 29},
  [121] = {.lex_state = 29},
  [122] = {.lex_state = 29},
  [123] = {.lex_state = 29},
  [124] = {.lex_state = 29},
  [125] = {.lex_state = 29},
  [126] = {.lex_state = 29},
  [127] = {.lex_state = 29},
  [128] = {.lex_state = 29},
  [129] = {.lex_state = 29},
  [130] = {.lex_state = 29},
  [131] = {.lex_state = 29},
  [132] = {.lex_state = 29},
  [133] = {.lex_state = 29},
  [134] = {.lex_state = 29},
  [135] = {.lex_state = 29},
  [136] = {.lex_state = 29},
  [137] = {.lex_state = 29},
  [138] = {.lex_state = 29},
  [139] = {.lex_state = 29},
  [140] = {.lex_state = 28},
  [141] = {.lex_state = 29},
  [142] = {.lex_state = 29},
  [143] = {.lex_state = 29},
  [144] = {.lex_state = 29},
  [145] = {.lex_state = 29},
  [146] = {.lex_state = 29},
  [147] = {.lex_state = 29},
  [148] = {.lex_state = 29},
  [149] = {.lex_state = 29},
  [150] = {.lex_state = 29},
  [151] = {.lex_state = 29},
  [152] = {.lex_state = 29},
  [153] = {.lex_state = 28},
  [154] = {.lex_state = 29},
  [155] = {.lex_state = 29},
  [156] = {.lex_state = 29},
  [157] = {.lex_state = 29},
  [158] = {.lex_state = 29},
  [159] = {.lex_state = 29},
  [160] = {.lex_state = 28},
  [161] = {.lex_state = 28},
  [162] = {.lex_state = 29},
  [163] = {.lex_state = 29},
  [164] = {.lex_state = 29},
  [165] = {.lex_state = 29},
  [166] = {.lex_state = 29},
  [167] = {.lex_state = 29},
  [168] = {.lex_state = 29},
  [169] = {.lex_state = 28},
  [170] = {.lex_state = 29},
  [171] = {.lex_state = 29},
  [172] = {.lex_state = 29},
  [173] = {.lex_state = 29},
  [174] = {.lex_state = 29},
  [175] = {.lex_state = 29},
  [176] = {.lex_state = 29},
  [177] = {.lex_state = 29},
  [178] = {.lex_state = 29},
  [179] = {.lex_state = 29},
  [180] = {.lex_state = 29},
  [181] = {.lex_state = 29},
  [182] = {.lex_state = 28},
  [183] = {.lex_state = 29},
  [184] = {.lex_state = 29},
  [185] = {.lex_state = 29},
  [186] = {.lex_state = 29},
  [187] = {.lex_state = 29},
  [188] = {.lex_state = 29},
  [189] = {.lex_state = 29},
  [190] = {.lex_state = 29},
  [191] = {.lex_state = 29},
  [192] = {.lex_state = 29},
  [193] = {.lex_state = 29},
  [194] = {.lex_state = 29},
  [195] = {.lex_state = 29},
  [196] = {.lex_state = 29},
  [197] = {.lex_state = 29},
  [198] = {.lex_state = 29},
  [199] = {.lex_state = 29},
  [200] = {.lex_state = 29},
  [201] = {.lex_state = 29},
  [202] = {.lex_state = 29},
  [203] = {.lex_state = 29},
  [204] = {.lex_state = 29},
  [205] = {.lex_state = 29},
  [206] = {.lex_state = 29},
  [207] = {.lex_state = 29},
  [208] = {.lex_state = 29},
  [209] = {.lex_state = 29},
  [210] = {.lex_state = 29},
  [211] = {.lex_state = 29},
  [212] = {.lex_state = 29},
  [213] = {.lex_state = 29},
  [214] = {.lex_state = 29},
  [215] = {.lex_state = 29},
  [216] = {.lex_state = 29},
  [217] = {.lex_state = 29},
  [218] = {.lex_state = 29},
  [219] = {.lex_state = 29},
  [220] = {.lex_state = 29},
  [221] = {.lex_state = 29},
  [222] = {.lex_state = 29},
  [223] = {.lex_state = 29},
  [224] = {.lex_state = 29},
  [225] = {.lex_state = 29},
  [226] = {.lex_state = 29},
  [227] = {.lex_state = 29},
  [228] = {.lex_state = 29},
  [229] = {.lex_state = 29},
  [230] = {.lex_state = 29},
  [231] = {.lex_state = 29},
  [232] = {.lex_state = 29},
  [233] = {.lex_state = 29},
  [234] = {.lex_state = 29},
  [235] = {.lex_state = 29},
  [236] = {.lex_state = 29},
  [237] = {.lex_state = 29},
  [238] = {.lex_state = 29},
  [239] = {.lex_state = 29},
  [240] = {.lex_state = 29},
  [241] = {.lex_state = 29},
  [242] = {.lex_state = 29},
  [243] = {.lex_state = 29},
  [244] = {.lex_state = 29},
  [245] = {.lex_state = 29},
  [246] = {.lex_state = 29},
  [247] = {.lex_state = 29},
  [248] = {.lex_state = 29},
  [249] = {.lex_state = 29},
  [250] = {.lex_state = 29},
  [251] = {.lex_state = 29},
  [252] = {.lex_state = 29},
  [253] = {.lex_state = 29},
  [254] = {.lex_state = 29},
  [255] = {.lex_state = 29},
  [256] = {.lex_state = 29},
  [257] = {.lex_state = 29},
  [258] = {.lex_state = 29},
  [259] = {.lex_state = 29},
  [260] = {.lex_state = 29},
  [261] = {.lex_state = 29},
  [262] = {.lex_state = 29},
  [263] = {.lex_state = 29},
  [264] = {.lex_state = 29},
  [265] = {.lex_state = 29},
  [266] = {.lex_state = 29},
  [267] = {.lex_state = 29},
  [268] = {.lex_state = 29},
  [269] = {.lex_state = 29},
  [270] = {.lex_state = 29},
  [271] = {.lex_state = 29},
  [272] = {.lex_state = 29},
  [273] = {.lex_state = 29},
  [274] = {.lex_state = 29},
  [275] = {.lex_state = 29},
  [276] = {.lex_state = 29},
  [277] = {.lex_state = 29},
  [278] = {.lex_state = 29},
  [279] = {.lex_state = 29},
  [280] = {.lex_state = 29},
  [281] = {.lex_state = 29},
  [282] = {.lex_state = 29},
  [283] = {.lex_state = 29},
  [284] = {.lex_state = 29},
  [285] = {.lex_state = 29},
  [286] = {.lex_state = 29},
  [287] = {.lex_state = 29},
  [288] = {.lex_state = 29},
  [289] = {.lex_state = 29},
  [290] = {.lex_state = 29},
  [291] = {.lex_state = 29},
  [292] = {.lex_state = 29},
  [293] = {.lex_state = 29},
  [294] = {.lex_state = 29},
  [295] = {.lex_state = 29},
  [296] = {.lex_state = 29},
  [297] = {.lex_state = 29},
  [298] = {.lex_state = 29},
  [299] = {.lex_state = 29},
  [300] = {.lex_state = 29},
  [301] = {.lex_state = 29},
  [302] = {.lex_state = 29},
  [303] = {.lex_state = 29},
  [304] = {.lex_state = 29},
  [305] = {.lex_state = 29},
  [306] = {.lex_state = 29},
  [307] = {.lex_state = 29},
  [308] = {.lex_state = 29},
  [309] = {.lex_state = 29},
  [310] = {.lex_state = 29},
  [311] = {.lex_state = 29},
  [312] = {.lex_state = 29},
  [313] = {.lex_state = 29},
  [314] = {.lex_state = 29},
  [315] = {.lex_state = 29},
  [316] = {.lex_state = 28},
  [317] = {.lex_state = 29},
  [318] = {.lex_state = 29},
  [319] = {.lex_state = 29},
  [320] = {.lex_state = 29},
  [321] = {.lex_state = 29},
  [322] = {.lex_state = 28},
  [323] = {.lex_state = 29},
  [324] = {.lex_state = 29},
  [325] = {.lex_state = 29},
  [326] = {.lex_state = 29},
  [327] = {.lex_state = 29},
  [328] = {.lex_state = 29},
  [329] = {.lex_state = 29},
  [330] = {.lex_state = 29},
  [331] = {.lex_state = 29},
  [332] = {.lex_state = 29},
  [333] = {.lex_state = 28},
  [334] = {.lex_state = 29},
  [335] = {.lex_state = 29},
  [336] = {.lex_state = 29},
  [337] = {.lex_state = 29},
  [338] = {.lex_state = 29},
  [339] = {.lex_state = 29},
  [340] = {.lex_state = 29},
  [341] = {.lex_state = 29},
  [342] = {.lex_state = 29},
  [343] = {.lex_state = 29},
  [344] = {.lex_state = 29},
  [345] = {.lex_state = 29},
  [346] = {.lex_state = 29},
  [347] = {.lex_state = 29},
  [348] = {.lex_state = 29},
  [349] = {.lex_state = 29},
  [350] = {.lex_state = 29},
  [351] = {.lex_state = 29},
  [352] = {.lex_state = 29},
  [353] = {.lex_state = 29},
  [354] = {.lex_state = 29},
  [355] = {.lex_state = 29},
  [356] = {.lex_state = 29},
  [357] = {.lex_state = 29},
  [358] = {.lex_state = 29},
  [359] = {.lex_state = 29},
  [360] = {.lex_state = 29},
  [361] = {.lex_state = 29},
  [362] = {.lex_state = 29},
  [363] = {.lex_state = 29},
  [364] = {.lex_state = 29},
  [365] = {.lex_state = 29},
  [366] = {.lex_state = 29},
  [367] = {.lex_state = 29},
  [368] = {.lex_state = 29},
  [369] = {.lex_state = 29},
  [370] = {.lex_state = 29},
  [371] = {.lex_state = 29},
  [372] = {.lex_state = 29},
  [373] = {.lex_state = 29},
  [374] = {.lex_state = 29},
  [375] = {.lex_state = 29},
  [376] = {.lex_state = 29},
  [377] = {.lex_state = 29},
  [378] = {.lex_state = 29},
  [379] = {.lex_state = 29},
  [380] = {.lex_state = 29},
  [381] = {.lex_state = 29},
  [382] = {.lex_state = 29},
  [383] = {.lex_state = 29},
  [384] = {.lex_state = 29},
  [385] = {.lex_state = 29},
  [386] = {.lex_state = 29},
  [387] = {.lex_state = 29},
  [388] = {.lex_state = 29},
  [389] = {.lex_state = 29},
  [390] = {.lex_state = 29},
  [391] = {.lex_state = 29},
  [392] = {.lex_state = 29},
  [393] = {.lex_state = 29},
  [394] = {.lex_state = 29},
  [395] = {.lex_state = 29},
  [396] = {.lex_state = 29},
  [397] = {.lex_state = 29},
  [398] = {.lex_state = 29},
  [399] = {.lex_state = 29},
  [400] = {.lex_state = 29},
  [401] = {.lex_state = 29},
  [402] = {.lex_state = 29},
  [403] = {.lex_state = 29},
  [404] = {.lex_state = 29},
  [405] = {.lex_state = 29},
  [406] = {.lex_state = 29},
  [407] = {.lex_state = 29},
  [408] = {.lex_state = 29},
  [409] = {.lex_state = 29},
  [410] = {.lex_state = 29},
  [411] = {.lex_state = 29},
  [412] = {.lex_state = 29},
  [413] = {.lex_state = 29},
  [414] = {.lex_state = 29},
  [415] = {.lex_state = 29},
  [416] = {.lex_state = 29},
  [417] = {.lex_state = 29},
  [418] = {.lex_state = 29},
  [419] = {.lex_state = 29},
  [420] = {.lex_state = 29},
  [421] = {.lex_state = 29},
  [422] = {.lex_state = 29},
  [423] = {.lex_state = 29},
  [424] = {.lex_state = 29},
  [425] = {.lex_state = 29},
  [426] = {.lex_state = 29},
  [427] = {.lex_state = 29},
  [428] = {.lex_state = 29},
  [429] = {.lex_state = 29},
  [430] = {.lex_state = 29},
  [431] = {.lex_state = 29},
  [432] = {.lex_state = 29},
  [433] = {.lex_state = 29},
  [434] = {.lex_state = 29},
  [435] = {.lex_state = 29},
  [436] = {.lex_state = 29},
  [437] = {.lex_state = 29},
  [438] = {.lex_state = 29},
  [439] = {.lex_state = 29},
  [440] = {.lex_state = 29},
  [441] = {.lex_state = 29},
  [442] = {.lex_state = 29},
  [443] = {.lex_state = 29},
  [444] = {.lex_state = 29},
  [445] = {.lex_state = 29},
  [446] = {.lex_state = 29},
  [447] = {.lex_state = 29},
  [448] = {.lex_state = 29},
  [449] = {.lex_state = 29},
  [450] = {.lex_state = 29},
  [451] = {.lex_state = 29},
  [452] = {.lex_state = 29},
  [453] = {.lex_state = 29},
  [454] = {.lex_state = 29},
  [455] = {.lex_state = 29},
  [456] = {.lex_state = 29},
  [457] = {.lex_state = 29},
  [458] = {.lex_state = 29},
  [459] = {.lex_state = 29},
  [460] = {.lex_state = 29},
  [461] = {.lex_state = 29},
  [462] = {.lex_state = 29},
  [463] = {.lex_state = 29},
  [464] = {.lex_state = 29},
  [465] = {.lex_state = 29},
  [466] = {.lex_state = 29},
  [467] = {.lex_state = 29},
  [468] = {.lex_state = 29},
  [469] = {.lex_state = 29},
  [470] = {.lex_state = 29},
  [471] = {.lex_state = 29},
  [472] = {.lex_state = 29},
  [473] = {.lex_state = 29},
  [474] = {.lex_state = 29},
  [475] = {.lex_state = 29},
  [476] = {.lex_state = 29},
  [477] = {.lex_state = 29},
  [478] = {.lex_state = 29},
  [479] = {.lex_state = 29},
  [480] = {.lex_state = 29},
  [481] = {.lex_state = 29},
  [482] = {.lex_state = 29},
  [483] = {.lex_state = 29},
  [484] = {.lex_state = 29},
  [485] = {.lex_state = 29},
  [486] = {.lex_state = 29},
  [487] = {.lex_state = 29},
  [488] = {.lex_state = 29},
  [489] = {.lex_state = 29},
  [490] = {.lex_state = 29},
  [491] = {.lex_state = 29},
  [492] = {.lex_state = 29},
  [493] = {.lex_state = 29},
  [494] = {.lex_state = 29},
  [495] = {.lex_state = 29},
  [496] = {.lex_state = 29},
  [497] = {.lex_state = 29},
  [498] = {.lex_state = 29},
  [499] = {.lex_state = 29},
  [500] = {.lex_state = 29},
  [501] = {.lex_state = 29},
  [502] = {.lex_state = 29},
  [503] = {.lex_state = 29},
  [504] = {.lex_state = 29},
  [505] = {.lex_state = 29},
  [506] = {.lex_state = 29},
  [507] = {.lex_state = 29},
  [508] = {.lex_state = 29},
  [509] = {.lex_state = 29},
  [510] = {.lex_state = 29},
  [511] = {.lex_state = 29},
  [512] = {.lex_state = 29},
  [513] = {.lex_state = 29},
  [514] = {.lex_state = 29},
  [515] = {.lex_state = 29},
  [516] = {.lex_state = 29},
  [517] = {.lex_state = 29},
  [518] = {.lex_state = 29},
  [519] = {.lex_state = 29},
  [520] = {.lex_state = 29},
  [521] = {.lex_state = 29},
  [522] = {.lex_state = 29},
  [523] = {.lex_state = 29},
  [524] = {.lex_state = 29},
  [525] = {.lex_state = 29},
  [526] = {.lex_state = 29},
  [527] = {.lex_state = 29},
  [528] = {.lex_state = 29},
  [529] = {.lex_state = 29},
  [530] = {.lex_state = 29},
  [531] = {.lex_state = 29},
  [532] = {.lex_state = 29},
  [533] = {.lex_state = 29},
  [534] = {.lex_state = 29},
  [535] = {.lex_state = 29},
  [536] = {.lex_state = 29},
  [537] = {.lex_state = 29},
  [538] = {.lex_state = 29},
  [539] = {.lex_state = 29},
  [540] = {.lex_state = 29},
  [541] = {.lex_state = 29},
  [542] = {.lex_state = 29},
  [543] = {.lex_state = 29},
  [544] = {.lex_state = 29},
  [545] = {.lex_state = 29},
  [546] = {.lex_state = 29},
  [547] = {.lex_state = 29},
  [548] = {.lex_state = 29},
  [549] = {.lex_state = 29},
  [550] = {.lex_state = 29},
  [551] = {.lex_state = 29},
  [552] = {.lex_state = 29},
  [553] = {.lex_state = 29},
  [554] = {.lex_state = 29},
  [555] = {.lex_state = 29},
  [556] = {.lex_state = 29},
  [557] = {.lex_state = 29},
  [558] = {.lex_state = 29},
  [559] = {.lex_state = 29},
  [560] = {.lex_state = 29},
  [561] = {.lex_state = 29},
  [562] = {.lex_state = 29},
  [563] = {.lex_state = 29},
  [564] = {.lex_state = 29},
  [565] = {.lex_state = 29},
  [566] = {.lex_state = 29},
  [567] = {.lex_state = 29},
  [568] = {.lex_state = 29},
  [569] = {.lex_state = 29},
  [570] = {.lex_state = 29},
  [571] = {.lex_state = 29},
  [572] = {.lex_state = 29},
  [573] = {.lex_state = 29},
  [574] = {.lex_state = 29},
  [575] = {.lex_state = 29},
  [576] = {.lex_state = 29},
  [577] = {.lex_state = 29},
  [578] = {.lex_state = 29},
  [579] = {.lex_state = 29},
  [580] = {.lex_state = 29},
  [581] = {.lex_state = 29},
  [582] = {.lex_state = 29},
  [583] = {.lex_state = 29},
  [584] = {.lex_state = 29},
  [585] = {.lex_state = 29},
  [586] = {.lex_state = 29},
  [587] = {.lex_state = 29},
  [588] = {.lex_state = 29},
  [589] = {.lex_state = 29},
  [590] = {.lex_state = 29},
  [591] = {.lex_state = 29},
  [592] = {.lex_state = 29},
  [593] = {.lex_state = 29},
  [594] = {.lex_state = 29},
  [595] = {.lex_state = 29},
  [596] = {.lex_state = 29},
  [597] = {.lex_state = 29},
  [598] = {.lex_state = 29},
  [599] = {.lex_state = 29},
  [600] = {.lex_state = 29},
  [601] = {.lex_state = 29},
  [602] = {.lex_state = 29},
  [603] = {.lex_state = 29},
  [604] = {.lex_state = 29},
  [605] = {.lex_state = 29},
  [606] = {.lex_state = 29},
  [607] = {.lex_state = 29},
  [608] = {.lex_state = 29},
  [609] = {.lex_state = 29},
  [610] = {.lex_state = 29},
  [611] = {.lex_state = 29},
  [612] = {.lex_state = 29},
  [613] = {.lex_state = 29},
  [614] = {.lex_state = 29},
  [615] = {.lex_state = 29},
  [616] = {.lex_state = 29},
  [617] = {.lex_state = 29},
  [618] = {.lex_state = 29},
  [619] = {.lex_state = 29},
  [620] = {.lex_state = 29},
  [621] = {.lex_state = 29},
  [622] = {.lex_state = 29},
  [623] = {.lex_state = 29},
  [624] = {.lex_state = 29},
  [625] = {.lex_state = 29},
  [626] = {.lex_state = 29},
  [627] = {.lex_state = 29},
  [628] = {.lex_state = 29},
  [629] = {.lex_state = 29},
  [630] = {.lex_state = 29},
  [631] = {.lex_state = 29},
  [632] = {.lex_state = 29},
  [633] = {.lex_state = 29},
  [634] = {.lex_state = 29},
  [635] = {.lex_state = 29},
  [636] = {.lex_state = 29},
  [637] = {.lex_state = 29},
  [638] = {.lex_state = 29},
  [639] = {.lex_state = 29},
  [640] = {.lex_state = 29},
  [641] = {.lex_state = 29},
  [642] = {.lex_state = 29},
  [643] = {.lex_state = 29},
  [644] = {.lex_state = 29},
  [645] = {.lex_state = 29},
  [646] = {.lex_state = 29},
  [647] = {.lex_state = 29},
  [648] = {.lex_state = 29},
  [649] = {.lex_state = 29},
  [650] = {.lex_state = 29},
  [651] = {.lex_state = 29},
  [652] = {.lex_state = 29},
  [653] = {.lex_state = 29},
  [654] = {.lex_state = 29},
  [655] = {.lex_state = 29},
  [656] = {.lex_state = 29},
  [657] = {.lex_state = 28},
  [658] = {.lex_state = 28},
  [659] = {.lex_state = 28},
  [660] = {.lex_state = 28},
  [661] = {.lex_state = 28},
  [662] = {.lex_state = 28},
  [663] = {.lex_state = 28},
  [664] = {.lex_state = 28},
  [665] = {.lex_state = 3},
  [666] = {.lex_state = 3},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 3},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 29},
  [671] = {.lex_state = 29},
  [672] = {.lex_state = 29},
  [673] = {.lex_state = 29},
  [674] = {.lex_state = 29},
  [675] = {.lex_state = 29},
  [676] = {.lex_state = 29},
  [677] = {.lex_state = 29},
  [678] = {.lex_state = 29},
  [679] = {.lex_state = 29},
  [680] = {.lex_state = 29},
  [681] = {.lex_state = 29},
  [682] = {.lex_state = 29},
  [683] = {.lex_state = 29},
  [684] = {.lex_state = 29},
  [685] = {.lex_state = 29},
  [686] = {.lex_state = 29},
  [687] = {.lex_state = 29},
  [688] = {.lex_state = 29},
  [689] = {.lex_state = 29},
  [690] = {.lex_state = 29},
  [691] = {.lex_state = 29},
  [692] = {.lex_state = 29},
  [693] = {.lex_state = 29},
  [694] = {.lex_state = 29},
  [695] = {.lex_state = 29},
  [696] = {.lex_state = 29},
  [697] = {.lex_state = 29},
  [698] = {.lex_state = 29},
  [699] = {.lex_state = 29},
  [700] = {.lex_state = 29},
  [701] = {.lex_state = 29},
  [702] = {.lex_state = 29},
  [703] = {.lex_state = 29},
  [704] = {.lex_state = 29},
  [705] = {.lex_state = 29},
  [706] = {.lex_state = 29},
  [707] = {.lex_state = 29},
  [708] = {.lex_state = 29},
  [709] = {.lex_state = 29},
  [710] = {.lex_state = 29},
  [711] = {.lex_state = 29},
  [712] = {.lex_state = 29},
  [713] = {.lex_state = 29},
  [714] = {.lex_state = 29},
  [715] = {.lex_state = 29},
  [716] = {.lex_state = 29},
  [717] = {.lex_state = 29},
  [718] = {.lex_state = 29},
  [719] = {.lex_state = 29},
  [720] = {.lex_state = 29},
  [721] = {.lex_state = 29},
  [722] = {.lex_state = 29},
  [723] = {.lex_state = 29},
  [724] = {.lex_state = 29},
  [725] = {.lex_state = 29},
  [726] = {.lex_state = 29},
  [727] = {.lex_state = 29},
  [728] = {.lex_state = 29},
  [729] = {.lex_state = 29},
  [730] = {.lex_state = 29},
  [731] = {.lex_state = 29},
  [732] = {.lex_state = 29},
  [733] = {.lex_state = 29},
  [734] = {.lex_state = 29},
  [735] = {.lex_state = 29},
  [736] = {.lex_state = 29},
  [737] = {.lex_state = 29},
  [738] = {.lex_state = 29},
  [739] = {.lex_state = 29},
  [740] = {.lex_state = 29},
  [741] = {.lex_state = 29},
  [742] = {.lex_state = 29},
  [743] = {.lex_state = 29},
  [744] = {.lex_state = 29},
  [745] = {.lex_state = 29},
  [746] = {.lex_state = 29},
  [747] = {.lex_state = 29},
  [748] = {.lex_state = 29},
  [749] = {.lex_state = 29},
  [750] = {.lex_state = 29},
  [751] = {.lex_state = 29},
  [752] = {.lex_state = 29},
  [753] = {.lex_state = 29},
  [754] = {.lex_state = 29},
  [755] = {.lex_state = 29},
  [756] = {.lex_state = 29},
  [757] = {.lex_state = 29},
  [758] = {.lex_state = 29},
  [759] = {.lex_state = 29},
  [760] = {.lex_state = 29},
  [761] = {.lex_state = 29},
  [762] = {.lex_state = 29},
  [763] = {.lex_state = 29},
  [764] = {.lex_state = 29},
  [765] = {.lex_state = 29},
  [766] = {.lex_state = 29},
  [767] = {.lex_state = 29},
  [768] = {.lex_state = 29},
  [769] = {.lex_state = 29},
  [770] = {.lex_state = 29},
  [771] = {.lex_state = 29},
  [772] = {.lex_state = 29},
  [773] = {.lex_state = 29},
  [774] = {.lex_state = 28},
  [775] = {.lex_state = 28},
  [776] = {.lex_state = 28},
  [777] = {.lex_state = 28},
  [778] = {.lex_state = 28},
  [779] = {.lex_state = 28},
  [780] = {.lex_state = 28},
  [781] = {.lex_state = 28},
  [782] = {.lex_state = 28},
  [783] = {.lex_state = 28},
  [784] = {.lex_state = 28},
  [785] = {.lex_state = 28},
  [786] = {.lex_state = 28},
  [787] = {.lex_state = 28},
  [788] = {.lex_state = 28},
  [789] = {.lex_state = 28},
  [790] = {.lex_state = 28},
  [791] = {.lex_state = 28},
  [792] = {.lex_state = 28},
  [793] = {.lex_state = 28},
  [794] = {.lex_state = 28},
  [795] = {.lex_state = 28},
  [796] = {.lex_state = 28},
  [797] = {.lex_state = 28},
  [798] = {.lex_state = 28},
  [799] = {.lex_state = 28},
  [800] = {.lex_state = 28},
  [801] = {.lex_state = 28},
  [802] = {.lex_state = 28},
  [803] = {.lex_state = 28},
  [804] = {.lex_state = 28},
  [805] = {.lex_state = 28},
  [806] = {.lex_state = 28},
  [807] = {.lex_state = 28},
  [808] = {.lex_state = 28},
  [809] = {.lex_state = 28},
  [810] = {.lex_state = 28},
  [811] = {.lex_state = 28},
  [812] = {.lex_state = 28},
  [813] = {.lex_state = 28},
  [814] = {.lex_state = 28},
  [815] = {.lex_state = 28},
  [816] = {.lex_state = 28},
  [817] = {.lex_state = 28},
  [818] = {.lex_state = 28},
  [819] = {.lex_state = 28},
  [820] = {.lex_state = 28},
  [821] = {.lex_state = 28},
  [822] = {.lex_state = 28},
  [823] = {.lex_state = 28},
  [824] = {.lex_state = 28},
  [825] = {.lex_state = 28},
  [826] = {.lex_state = 28},
  [827] = {.lex_state = 28},
  [828] = {.lex_state = 28},
  [829] = {.lex_state = 28},
  [830] = {.lex_state = 28},
  [831] = {.lex_state = 28},
  [832] = {.lex_state = 28},
  [833] = {.lex_state = 28},
  [834] = {.lex_state = 28},
  [835] = {.lex_state = 28},
  [836] = {.lex_state = 28},
  [837] = {.lex_state = 28},
  [838] = {.lex_state = 28},
  [839] = {.lex_state = 28},
  [840] = {.lex_state = 28},
  [841] = {.lex_state = 28},
  [842] = {.lex_state = 28},
  [843] = {.lex_state = 28},
  [844] = {.lex_state = 28},
  [845] = {.lex_state = 28},
  [846] = {.lex_state = 28},
  [847] = {.lex_state = 28},
  [848] = {.lex_state = 28},
  [849] = {.lex_state = 28},
  [850] = {.lex_state = 28},
  [851] = {.lex_state = 28},
  [852] = {.lex_state = 28},
  [853] = {.lex_state = 28},
  [854] = {.lex_state = 28},
  [855] = {.lex_state = 28},
  [856] = {.lex_state = 28},
  [857] = {.lex_state = 28},
  [858] = {.lex_state = 28},
  [859] = {.lex_state = 28},
  [860] = {.lex_state = 28},
  [861] = {.lex_state = 28},
  [862] = {.lex_state = 28},
  [863] = {.lex_state = 28},
  [864] = {.lex_state = 28},
  [865] = {.lex_state = 28},
  [866] = {.lex_state = 28},
  [867] = {.lex_state = 28},
  [868] = {.lex_state = 28},
  [869] = {.lex_state = 28},
  [870] = {.lex_state = 28},
  [871] = {.lex_state = 28},
  [872] = {.lex_state = 28},
  [873] = {.lex_state = 28},
  [874] = {.lex_state = 28},
  [875] = {.lex_state = 28},
  [876] = {.lex_state = 28},
  [877] = {.lex_state = 28},
  [878] = {.lex_state = 28},
  [879] = {.lex_state = 28},
  [880] = {.lex_state = 28},
  [881] = {.lex_state = 28},
  [882] = {.lex_state = 28},
  [883] = {.lex_state = 28},
  [884] = {.lex_state = 28},
  [885] = {.lex_state = 28},
  [886] = {.lex_state = 28},
  [887] = {.lex_state = 28},
  [888] = {.lex_state = 28},
  [889] = {.lex_state = 28},
  [890] = {.lex_state = 28},
  [891] = {.lex_state = 28},
  [892] = {.lex_state = 28},
  [893] = {.lex_state = 28},
  [894] = {.lex_state = 28},
  [895] = {.lex_state = 28},
  [896] = {.lex_state = 28},
  [897] = {.lex_state = 28},
  [898] = {.lex_state = 28},
  [899] = {.lex_state = 28},
  [900] = {.lex_state = 28},
  [901] = {.lex_state = 28},
  [902] = {.lex_state = 28},
  [903] = {.lex_state = 28},
  [904] = {.lex_state = 28},
  [905] = {.lex_state = 28},
  [906] = {.lex_state = 28},
  [907] = {.lex_state = 28},
  [908] = {.lex_state = 28},
  [909] = {.lex_state = 28},
  [910] = {.lex_state = 28},
  [911] = {.lex_state = 28},
  [912] = {.lex_state = 28},
  [913] = {.lex_state = 28},
  [914] = {.lex_state = 28},
  [915] = {.lex_state = 28},
  [916] = {.lex_state = 28},
  [917] = {.lex_state = 28},
  [918] = {.lex_state = 28},
  [919] = {.lex_state = 28},
  [920] = {.lex_state = 28},
  [921] = {.lex_state = 28},
  [922] = {.lex_state = 28},
  [923] = {.lex_state = 28},
  [924] = {.lex_state = 28},
  [925] = {.lex_state = 3},
  [926] = {.lex_state = 28},
  [927] = {.lex_state = 28},
  [928] = {.lex_state = 28},
  [929] = {.lex_state = 28},
  [930] = {.lex_state = 3},
  [931] = {.lex_state = 28},
  [932] = {.lex_state = 28},
  [933] = {.lex_state = 28},
  [934] = {.lex_state = 28},
  [935] = {.lex_state = 28},
  [936] = {.lex_state = 28},
  [937] = {.lex_state = 28},
  [938] = {.lex_state = 28},
  [939] = {.lex_state = 28},
  [940] = {.lex_state = 28},
  [941] = {.lex_state = 28},
  [942] = {.lex_state = 28},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 28},
  [945] = {.lex_state = 28},
  [946] = {.lex_state = 28},
  [947] = {.lex_state = 28},
  [948] = {.lex_state = 28},
  [949] = {.lex_state = 28},
  [950] = {.lex_state = 28},
  [951] = {.lex_state = 28},
  [952] = {.lex_state = 28},
  [953] = {.lex_state = 28},
  [954] = {.lex_state = 28},
  [955] = {.lex_state = 28},
  [956] = {.lex_state = 28},
  [957] = {.lex_state = 28},
  [958] = {.lex_state = 28},
  [959] = {.lex_state = 28},
  [960] = {.lex_state = 28},
  [961] = {.lex_state = 28},
  [962] = {.lex_state = 28},
  [963] = {.lex_state = 28},
  [964] = {.lex_state = 28},
  [965] = {.lex_state = 28},
  [966] = {.lex_state = 28},
  [967] = {.lex_state = 28},
  [968] = {.lex_state = 28},
  [969] = {.lex_state = 28},
  [970] = {.lex_state = 28},
  [971] = {.lex_state = 28},
  [972] = {.lex_state = 28},
  [973] = {.lex_state = 28},
  [974] = {.lex_state = 28},
  [975] = {.lex_state = 28},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 28},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 28},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 28},
  [985] = {.lex_state = 28},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 28},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 28},
  [999] = {.lex_state = 28},
  [1000] = {.lex_state = 28},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 28},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 28},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 28},
  [1017] = {.lex_state = 28},
  [1018] = {.lex_state = 28},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 28},
  [1032] = {.lex_state = 28},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 28},
  [1041] = {.lex_state = 28},
  [1042] = {.lex_state = 28},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 28},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 28},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 28},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 28},
  [1074] = {.lex_state = 28},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 28},
  [1079] = {.lex_state = 28},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 28},
  [1083] = {.lex_state = 28},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 28},
  [1088] = {.lex_state = 28},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 28},
  [1091] = {.lex_state = 28},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 28},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 28},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 28},
  [1109] = {.lex_state = 28},
  [1110] = {.lex_state = 28},
  [1111] = {.lex_state = 28},
  [1112] = {.lex_state = 28},
  [1113] = {.lex_state = 28},
  [1114] = {.lex_state = 28},
  [1115] = {.lex_state = 28},
  [1116] = {.lex_state = 28},
  [1117] = {.lex_state = 28},
  [1118] = {.lex_state = 28},
  [1119] = {.lex_state = 28},
  [1120] = {.lex_state = 28},
  [1121] = {.lex_state = 28},
  [1122] = {.lex_state = 28},
  [1123] = {.lex_state = 28},
  [1124] = {.lex_state = 28},
  [1125] = {.lex_state = 28},
  [1126] = {.lex_state = 28},
  [1127] = {.lex_state = 28},
  [1128] = {.lex_state = 28},
  [1129] = {.lex_state = 28},
  [1130] = {.lex_state = 28},
  [1131] = {.lex_state = 28},
  [1132] = {.lex_state = 28},
  [1133] = {.lex_state = 28},
  [1134] = {.lex_state = 28},
  [1135] = {.lex_state = 28},
  [1136] = {.lex_state = 28},
  [1137] = {.lex_state = 28},
  [1138] = {.lex_state = 28},
  [1139] = {.lex_state = 28},
  [1140] = {.lex_state = 28},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 28},
  [1169] = {.lex_state = 28},
  [1170] = {.lex_state = 28},
  [1171] = {.lex_state = 28},
  [1172] = {.lex_state = 28},
  [1173] = {.lex_state = 28},
  [1174] = {.lex_state = 28},
  [1175] = {.lex_state = 28},
  [1176] = {.lex_state = 28},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 28},
  [1179] = {.lex_state = 28},
  [1180] = {.lex_state = 28},
  [1181] = {.lex_state = 28},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 28},
  [1187] = {.lex_state = 28},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 28},
  [1209] = {.lex_state = 28},
  [1210] = {.lex_state = 28},
  [1211] = {.lex_state = 28},
  [1212] = {.lex_state = 28},
  [1213] = {.lex_state = 28},
  [1214] = {.lex_state = 28},
  [1215] = {.lex_state = 28},
  [1216] = {.lex_state = 28},
  [1217] = {.lex_state = 28},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 28},
  [1220] = {.lex_state = 28},
  [1221] = {.lex_state = 28},
  [1222] = {.lex_state = 28},
  [1223] = {.lex_state = 28},
  [1224] = {.lex_state = 28},
  [1225] = {.lex_state = 28},
  [1226] = {.lex_state = 28},
  [1227] = {.lex_state = 28},
  [1228] = {.lex_state = 28},
  [1229] = {.lex_state = 28},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 28},
  [1232] = {.lex_state = 28},
  [1233] = {.lex_state = 28},
  [1234] = {.lex_state = 28},
  [1235] = {.lex_state = 28},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 28},
  [1238] = {.lex_state = 28},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 28},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 28},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 28},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 28},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 28},
  [1258] = {.lex_state = 28},
  [1259] = {.lex_state = 28},
  [1260] = {.lex_state = 28},
  [1261] = {.lex_state = 28},
  [1262] = {.lex_state = 28},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 28},
  [1271] = {.lex_state = 28},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 28},
  [1277] = {.lex_state = 28},
  [1278] = {.lex_state = 28},
  [1279] = {.lex_state = 28},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 28},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 28},
  [1285] = {.lex_state = 28},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 28},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 28},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 28},
  [1298] = {.lex_state = 28},
  [1299] = {.lex_state = 28},
  [1300] = {.lex_state = 28},
  [1301] = {.lex_state = 28},
  [1302] = {.lex_state = 28},
  [1303] = {.lex_state = 28},
  [1304] = {.lex_state = 28},
  [1305] = {.lex_state = 28},
  [1306] = {.lex_state = 28},
  [1307] = {.lex_state = 28},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 28},
  [1312] = {.lex_state = 28},
  [1313] = {.lex_state = 28},
  [1314] = {.lex_state = 28},
  [1315] = {.lex_state = 28},
  [1316] = {.lex_state = 28},
  [1317] = {.lex_state = 28},
  [1318] = {.lex_state = 28},
  [1319] = {.lex_state = 28},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 28},
  [1323] = {.lex_state = 28},
  [1324] = {.lex_state = 28},
  [1325] = {.lex_state = 28},
  [1326] = {.lex_state = 28},
  [1327] = {.lex_state = 28},
  [1328] = {.lex_state = 28},
  [1329] = {.lex_state = 28},
  [1330] = {.lex_state = 28},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 28},
  [1333] = {.lex_state = 28},
  [1334] = {.lex_state = 28},
  [1335] = {.lex_state = 28},
  [1336] = {.lex_state = 28},
  [1337] = {.lex_state = 28},
  [1338] = {.lex_state = 28},
  [1339] = {.lex_state = 28},
  [1340] = {.lex_state = 28},
  [1341] = {.lex_state = 28},
  [1342] = {.lex_state = 28},
  [1343] = {.lex_state = 28},
  [1344] = {.lex_state = 28},
  [1345] = {.lex_state = 28},
  [1346] = {.lex_state = 28},
  [1347] = {.lex_state = 28},
  [1348] = {.lex_state = 28},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 28},
  [1351] = {.lex_state = 28},
  [1352] = {.lex_state = 28},
  [1353] = {.lex_state = 28},
  [1354] = {.lex_state = 28},
  [1355] = {.lex_state = 28},
  [1356] = {.lex_state = 28},
  [1357] = {.lex_state = 28},
  [1358] = {.lex_state = 28},
  [1359] = {.lex_state = 28},
  [1360] = {.lex_state = 28},
  [1361] = {.lex_state = 28},
  [1362] = {.lex_state = 28},
  [1363] = {.lex_state = 28},
  [1364] = {.lex_state = 28},
  [1365] = {.lex_state = 28},
  [1366] = {.lex_state = 28},
  [1367] = {.lex_state = 28},
  [1368] = {.lex_state = 28},
  [1369] = {.lex_state = 28},
  [1370] = {.lex_state = 28},
  [1371] = {.lex_state = 28},
  [1372] = {.lex_state = 28},
  [1373] = {.lex_state = 28},
  [1374] = {.lex_state = 28},
  [1375] = {.lex_state = 28},
  [1376] = {.lex_state = 28},
  [1377] = {.lex_state = 28},
  [1378] = {.lex_state = 28},
  [1379] = {.lex_state = 28},
  [1380] = {.lex_state = 28},
  [1381] = {.lex_state = 28},
  [1382] = {.lex_state = 28},
  [1383] = {.lex_state = 28},
  [1384] = {.lex_state = 28},
  [1385] = {.lex_state = 28},
  [1386] = {.lex_state = 28},
  [1387] = {.lex_state = 28},
  [1388] = {.lex_state = 28},
  [1389] = {.lex_state = 28},
  [1390] = {.lex_state = 28},
  [1391] = {.lex_state = 28},
  [1392] = {.lex_state = 28},
  [1393] = {.lex_state = 28},
  [1394] = {.lex_state = 28},
  [1395] = {.lex_state = 28},
  [1396] = {.lex_state = 28},
  [1397] = {.lex_state = 28},
  [1398] = {.lex_state = 28},
  [1399] = {.lex_state = 28},
  [1400] = {.lex_state = 28},
  [1401] = {.lex_state = 28},
  [1402] = {.lex_state = 28},
  [1403] = {.lex_state = 28},
  [1404] = {.lex_state = 28},
  [1405] = {.lex_state = 28},
  [1406] = {.lex_state = 28},
  [1407] = {.lex_state = 28},
  [1408] = {.lex_state = 28},
  [1409] = {.lex_state = 28},
  [1410] = {.lex_state = 28},
  [1411] = {.lex_state = 28},
  [1412] = {.lex_state = 28},
  [1413] = {.lex_state = 28},
  [1414] = {.lex_state = 28},
  [1415] = {.lex_state = 28},
  [1416] = {.lex_state = 28},
  [1417] = {.lex_state = 28},
  [1418] = {.lex_state = 28},
  [1419] = {.lex_state = 28},
  [1420] = {.lex_state = 28},
  [1421] = {.lex_state = 28},
  [1422] = {.lex_state = 28},
  [1423] = {.lex_state = 28},
  [1424] = {.lex_state = 28},
  [1425] = {.lex_state = 28},
  [1426] = {.lex_state = 28},
  [1427] = {.lex_state = 28},
  [1428] = {.lex_state = 28},
  [1429] = {.lex_state = 28},
  [1430] = {.lex_state = 28},
  [1431] = {.lex_state = 28},
  [1432] = {.lex_state = 28},
  [1433] = {.lex_state = 28},
  [1434] = {.lex_state = 28},
  [1435] = {.lex_state = 28},
  [1436] = {.lex_state = 28},
  [1437] = {.lex_state = 28},
  [1438] = {.lex_state = 28},
  [1439] = {.lex_state = 28},
  [1440] = {.lex_state = 28},
  [1441] = {.lex_state = 28},
  [1442] = {.lex_state = 28},
  [1443] = {.lex_state = 28},
  [1444] = {.lex_state = 28},
  [1445] = {.lex_state = 28},
  [1446] = {.lex_state = 28},
  [1447] = {.lex_state = 28},
  [1448] = {.lex_state = 28},
  [1449] = {.lex_state = 28},
  [1450] = {.lex_state = 28},
  [1451] = {.lex_state = 28},
  [1452] = {.lex_state = 28},
  [1453] = {.lex_state = 28},
  [1454] = {.lex_state = 28},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 0},
  [1459] = {.lex_state = 29},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 29},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 29},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 29},
  [1472] = {.lex_state = 0},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 29},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 0},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 0},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 0},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 0},
  [1498] = {.lex_state = 0},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 29},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 29},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 0},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 29},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 29},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 29},
  [1531] = {.lex_state = 29},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 1},
  [1537] = {.lex_state = 0},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 0},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 0},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 1},
  [1548] = {.lex_state = 1},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 0},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 0},
  [1559] = {.lex_state = 0},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 1},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 1},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 0},
  [1580] = {.lex_state = 0},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 0},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 0},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 0},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 0},
  [1604] = {.lex_state = 0},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 0},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 0},
  [1612] = {.lex_state = 0},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 0},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 0},
  [1626] = {.lex_state = 0},
  [1627] = {.lex_state = 0},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 0},
  [1631] = {.lex_state = 0},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 0},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 0},
  [1636] = {.lex_state = 0},
  [1637] = {.lex_state = 0},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 0},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 0},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 0},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 0},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 2},
  [1662] = {.lex_state = 0},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 0},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 0},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 0},
  [1670] = {.lex_state = 0},
  [1671] = {.lex_state = 0},
  [1672] = {.lex_state = 0},
  [1673] = {.lex_state = 0},
  [1674] = {.lex_state = 2},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 0},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 0},
  [1685] = {.lex_state = 0},
  [1686] = {.lex_state = 0},
  [1687] = {.lex_state = 0},
  [1688] = {.lex_state = 0},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 0},
  [1691] = {.lex_state = 0},
  [1692] = {.lex_state = 0},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 0},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 0},
  [1697] = {.lex_state = 0},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 0},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 0},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 0},
  [1706] = {.lex_state = 0},
  [1707] = {.lex_state = 0},
  [1708] = {.lex_state = 0},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 0},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 0},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 0},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 0},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 0},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 0},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 0},
  [1736] = {.lex_state = 0},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 0},
  [1753] = {.lex_state = 0},
  [1754] = {.lex_state = 0},
  [1755] = {.lex_state = 0},
  [1756] = {.lex_state = 0},
  [1757] = {.lex_state = 0},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 0},
  [1761] = {.lex_state = 0},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 0},
  [1765] = {.lex_state = 0},
  [1766] = {.lex_state = 0},
  [1767] = {.lex_state = 0},
  [1768] = {.lex_state = 0},
  [1769] = {.lex_state = 0},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 0},
  [1774] = {.lex_state = 0},
  [1775] = {.lex_state = 0},
  [1776] = {.lex_state = 0},
  [1777] = {.lex_state = 0},
  [1778] = {.lex_state = 0},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 0},
  [1781] = {.lex_state = 0},
  [1782] = {.lex_state = 0},
  [1783] = {.lex_state = 0},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 0},
  [1791] = {.lex_state = 0},
  [1792] = {.lex_state = 0},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 0},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 0},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 0},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 0},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_test] = ACTIONS(1),
    [anon_sym_comptime] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_threadlocal] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_noinline] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_noalias] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_usingnamespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_packed] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_opaque] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_nosuspend] = ACTIONS(1),
    [anon_sym_suspend] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_errdefer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_align] = ACTIONS(1),
    [anon_sym_addrspace] = ACTIONS(1),
    [anon_sym_linksection] = ACTIONS(1),
    [anon_sym_callconv] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DASH_PERCENT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_orelse] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1),
    [anon_sym_PLUS_PIPE] = ACTIONS(1),
    [anon_sym_DASH_PIPE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_STAR_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_resume] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_anyframe] = ACTIONS(1),
    [anon_sym_unreachable] = ACTIONS(1),
    [anon_sym_undefined] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_allowzero] = ACTIONS(1),
    [anon_sym_c] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DOT_QMARK] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_multiline_string_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_f16] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_f128] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_anyerror] = ACTIONS(1),
    [anon_sym_anyopaque] = ACTIONS(1),
    [anon_sym_anytype] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_comptime_int] = ACTIONS(1),
    [anon_sym_comptime_float] = ACTIONS(1),
    [anon_sym_c_short] = ACTIONS(1),
    [anon_sym_c_ushort] = ACTIONS(1),
    [anon_sym_c_int] = ACTIONS(1),
    [anon_sym_c_uint] = ACTIONS(1),
    [anon_sym_c_long] = ACTIONS(1),
    [anon_sym_c_ulong] = ACTIONS(1),
    [anon_sym_c_longlong] = ACTIONS(1),
    [anon_sym_c_ulonglong] = ACTIONS(1),
    [anon_sym_c_longdouble] = ACTIONS(1),
    [aux_sym_builtin_type_token1] = ACTIONS(1),
    [sym_builtin_identifier] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1795),
    [sym__container_members] = STATE(1776),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(904),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_break_label] = STATE(4),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_align] = ACTIONS(115),
    [anon_sym_addrspace] = ACTIONS(115),
    [anon_sym_linksection] = ACTIONS(115),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(127),
    [anon_sym_AMP] = ACTIONS(127),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(920),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(143),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(145),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_STAR_EQ] = ACTIONS(143),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(143),
    [anon_sym_SLASH_EQ] = ACTIONS(143),
    [anon_sym_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(143),
    [anon_sym_DASH_EQ] = ACTIONS(143),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(143),
    [anon_sym_GT_GT_EQ] = ACTIONS(143),
    [anon_sym_AMP_EQ] = ACTIONS(143),
    [anon_sym_CARET_EQ] = ACTIONS(143),
    [anon_sym_PIPE_EQ] = ACTIONS(143),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_align] = ACTIONS(145),
    [anon_sym_addrspace] = ACTIONS(145),
    [anon_sym_linksection] = ACTIONS(145),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(127),
    [anon_sym_AMP] = ACTIONS(127),
    [anon_sym_or] = ACTIONS(145),
    [anon_sym_and] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_orelse] = ACTIONS(145),
    [anon_sym_LT_LT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_LT_LT_PIPE] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT] = ACTIONS(145),
    [anon_sym_PLUS_PIPE] = ACTIONS(145),
    [anon_sym_DASH_PIPE] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_STAR] = ACTIONS(143),
    [anon_sym_STAR_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_PIPE] = ACTIONS(145),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(143),
    [anon_sym_DOT_QMARK] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(921),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_align] = ACTIONS(149),
    [anon_sym_addrspace] = ACTIONS(149),
    [anon_sym_linksection] = ACTIONS(149),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(127),
    [anon_sym_AMP] = ACTIONS(127),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(903),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_align] = ACTIONS(153),
    [anon_sym_addrspace] = ACTIONS(153),
    [anon_sym_linksection] = ACTIONS(153),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(127),
    [anon_sym_AMP] = ACTIONS(127),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(151),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(968),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_break_label] = STATE(8),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(975),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(151),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(958),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(159),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1295),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_break_label] = STATE(18),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1203),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_break_label] = STATE(13),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1223),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_break_label] = STATE(16),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1173),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_break_label] = STATE(20),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(109),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(109),
    [anon_sym_DASH_EQ] = ACTIONS(109),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(109),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(109),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(109),
    [anon_sym_AMP_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(109),
    [anon_sym_PIPE_EQ] = ACTIONS(109),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_or] = ACTIONS(115),
    [anon_sym_and] = ACTIONS(115),
    [anon_sym_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_orelse] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_LT_LT_PIPE] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_PLUS_PERCENT] = ACTIONS(115),
    [anon_sym_PLUS_PIPE] = ACTIONS(115),
    [anon_sym_DASH_PIPE] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_STAR_PERCENT] = ACTIONS(115),
    [anon_sym_STAR_PIPE] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_catch] = ACTIONS(115),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(109),
    [anon_sym_DOT_QMARK] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1143),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1070),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(145),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(143),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(143),
    [anon_sym_SLASH_EQ] = ACTIONS(143),
    [anon_sym_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(143),
    [anon_sym_DASH_EQ] = ACTIONS(143),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(143),
    [anon_sym_GT_GT_EQ] = ACTIONS(143),
    [anon_sym_AMP_EQ] = ACTIONS(143),
    [anon_sym_CARET_EQ] = ACTIONS(143),
    [anon_sym_PIPE_EQ] = ACTIONS(143),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(145),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(145),
    [anon_sym_and] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_orelse] = ACTIONS(145),
    [anon_sym_LT_LT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_LT_LT_PIPE] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT] = ACTIONS(145),
    [anon_sym_PLUS_PIPE] = ACTIONS(145),
    [anon_sym_DASH_PIPE] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_STAR] = ACTIONS(143),
    [anon_sym_STAR_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_PIPE] = ACTIONS(145),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(143),
    [anon_sym_DOT_QMARK] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1005),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(143),
    [anon_sym_EQ] = ACTIONS(145),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(143),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(143),
    [anon_sym_SLASH_EQ] = ACTIONS(143),
    [anon_sym_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(143),
    [anon_sym_DASH_EQ] = ACTIONS(143),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(143),
    [anon_sym_GT_GT_EQ] = ACTIONS(143),
    [anon_sym_AMP_EQ] = ACTIONS(143),
    [anon_sym_CARET_EQ] = ACTIONS(143),
    [anon_sym_PIPE_EQ] = ACTIONS(143),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_or] = ACTIONS(145),
    [anon_sym_and] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_orelse] = ACTIONS(145),
    [anon_sym_LT_LT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_LT_LT_PIPE] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT] = ACTIONS(145),
    [anon_sym_PLUS_PIPE] = ACTIONS(145),
    [anon_sym_DASH_PIPE] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_STAR] = ACTIONS(143),
    [anon_sym_STAR_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_PIPE] = ACTIONS(145),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_catch] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(143),
    [anon_sym_DOT_QMARK] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1241),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1294),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(151),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1242),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1222),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(283),
    [anon_sym_AMP] = ACTIONS(283),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1115),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(149),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(147),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(147),
    [anon_sym_SLASH_EQ] = ACTIONS(147),
    [anon_sym_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(147),
    [anon_sym_DASH_EQ] = ACTIONS(147),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(147),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_EQ] = ACTIONS(147),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(147),
    [anon_sym_GT_GT_EQ] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(147),
    [anon_sym_CARET_EQ] = ACTIONS(147),
    [anon_sym_PIPE_EQ] = ACTIONS(147),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_or] = ACTIONS(149),
    [anon_sym_and] = ACTIONS(149),
    [anon_sym_EQ_EQ] = ACTIONS(147),
    [anon_sym_BANG_EQ] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_GT_EQ] = ACTIONS(147),
    [anon_sym_LT_EQ] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_orelse] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(149),
    [anon_sym_LT_LT_PIPE] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_PLUS_PLUS] = ACTIONS(147),
    [anon_sym_PLUS_PERCENT] = ACTIONS(149),
    [anon_sym_PLUS_PIPE] = ACTIONS(149),
    [anon_sym_DASH_PIPE] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(147),
    [anon_sym_STAR_PERCENT] = ACTIONS(149),
    [anon_sym_STAR_PIPE] = ACTIONS(149),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_catch] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(147),
    [anon_sym_DOT_QMARK] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1202),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(189),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(151),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(225),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1172),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(153),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(151),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(151),
    [anon_sym_SLASH_EQ] = ACTIONS(151),
    [anon_sym_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(151),
    [anon_sym_DASH_EQ] = ACTIONS(151),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(151),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_EQ] = ACTIONS(151),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(151),
    [anon_sym_GT_GT_EQ] = ACTIONS(151),
    [anon_sym_AMP_EQ] = ACTIONS(151),
    [anon_sym_CARET_EQ] = ACTIONS(151),
    [anon_sym_PIPE_EQ] = ACTIONS(151),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(315),
    [anon_sym_AMP] = ACTIONS(315),
    [anon_sym_or] = ACTIONS(153),
    [anon_sym_and] = ACTIONS(153),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_orelse] = ACTIONS(153),
    [anon_sym_LT_LT] = ACTIONS(153),
    [anon_sym_GT_GT] = ACTIONS(153),
    [anon_sym_LT_LT_PIPE] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(151),
    [anon_sym_PLUS_PERCENT] = ACTIONS(153),
    [anon_sym_PLUS_PIPE] = ACTIONS(153),
    [anon_sym_DASH_PIPE] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_STAR] = ACTIONS(151),
    [anon_sym_STAR_PERCENT] = ACTIONS(153),
    [anon_sym_STAR_PIPE] = ACTIONS(153),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_catch] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DOT_STAR] = ACTIONS(151),
    [anon_sym_DOT_QMARK] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(1233),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(145),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(143),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(143),
    [anon_sym_SLASH_EQ] = ACTIONS(143),
    [anon_sym_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(143),
    [anon_sym_DASH_EQ] = ACTIONS(143),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(143),
    [anon_sym_GT_GT_EQ] = ACTIONS(143),
    [anon_sym_AMP_EQ] = ACTIONS(143),
    [anon_sym_CARET_EQ] = ACTIONS(143),
    [anon_sym_PIPE_EQ] = ACTIONS(143),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(143),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_DASH_PERCENT] = ACTIONS(145),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_or] = ACTIONS(145),
    [anon_sym_and] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_orelse] = ACTIONS(145),
    [anon_sym_LT_LT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_LT_LT_PIPE] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT] = ACTIONS(145),
    [anon_sym_PLUS_PIPE] = ACTIONS(145),
    [anon_sym_DASH_PIPE] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_STAR] = ACTIONS(143),
    [anon_sym_STAR_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_PIPE] = ACTIONS(145),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_DOT_STAR] = ACTIONS(143),
    [anon_sym_DOT_QMARK] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(1210),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(145),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_STAR_EQ] = ACTIONS(143),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(143),
    [anon_sym_SLASH_EQ] = ACTIONS(143),
    [anon_sym_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(143),
    [anon_sym_DASH_EQ] = ACTIONS(143),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(143),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_EQ] = ACTIONS(143),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(143),
    [anon_sym_GT_GT_EQ] = ACTIONS(143),
    [anon_sym_AMP_EQ] = ACTIONS(143),
    [anon_sym_CARET_EQ] = ACTIONS(143),
    [anon_sym_PIPE_EQ] = ACTIONS(143),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACE] = ACTIONS(143),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_DOT_DOT] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_DASH_PERCENT] = ACTIONS(145),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_or] = ACTIONS(145),
    [anon_sym_and] = ACTIONS(145),
    [anon_sym_EQ_EQ] = ACTIONS(143),
    [anon_sym_BANG_EQ] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_EQ] = ACTIONS(143),
    [anon_sym_LT_EQ] = ACTIONS(143),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_orelse] = ACTIONS(145),
    [anon_sym_LT_LT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_LT_LT_PIPE] = ACTIONS(145),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(143),
    [anon_sym_PLUS_PERCENT] = ACTIONS(145),
    [anon_sym_PLUS_PIPE] = ACTIONS(145),
    [anon_sym_DASH_PIPE] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_STAR] = ACTIONS(143),
    [anon_sym_STAR_PERCENT] = ACTIONS(145),
    [anon_sym_STAR_PIPE] = ACTIONS(145),
    [anon_sym_PIPE_PIPE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_catch] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(145),
    [anon_sym_DOT_STAR] = ACTIONS(143),
    [anon_sym_DOT_QMARK] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(36),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(36),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(79),
    [sym_expression] = STATE(1342),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_test_declaration] = STATE(33),
    [sym_comptime_declaration] = STATE(33),
    [sym_container_field] = STATE(1610),
    [sym_variable_declaration] = STATE(33),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(33),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(33),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(33),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(345),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(345),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(77),
    [sym_expression] = STATE(1319),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(75),
    [sym_expression] = STATE(1370),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(80),
    [sym_expression] = STATE(1372),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(79),
    [sym_expression] = STATE(1341),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(34),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(34),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_test_declaration] = STATE(33),
    [sym_comptime_declaration] = STATE(33),
    [sym_container_field] = STATE(1766),
    [sym_variable_declaration] = STATE(33),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(33),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(33),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(33),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [ts_builtin_sym_end] = ACTIONS(349),
    [sym__identifier] = ACTIONS(351),
    [anon_sym_pub] = ACTIONS(354),
    [anon_sym_test] = ACTIONS(357),
    [anon_sym_comptime] = ACTIONS(360),
    [anon_sym_export] = ACTIONS(363),
    [anon_sym_extern] = ACTIONS(366),
    [anon_sym_threadlocal] = ACTIONS(369),
    [anon_sym_const] = ACTIONS(372),
    [anon_sym_var] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(375),
    [anon_sym_noinline] = ACTIONS(378),
    [anon_sym_fn] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_usingnamespace] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_RBRACE] = ACTIONS(349),
    [anon_sym_packed] = ACTIONS(393),
    [anon_sym_struct] = ACTIONS(396),
    [anon_sym_opaque] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_union] = ACTIONS(405),
    [anon_sym_error] = ACTIONS(408),
    [anon_sym_nosuspend] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_asm] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_BANG] = ACTIONS(432),
    [anon_sym_TILDE] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_DASH_PERCENT] = ACTIONS(435),
    [anon_sym_AMP] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(441),
    [anon_sym_await] = ACTIONS(444),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_resume] = ACTIONS(450),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_break] = ACTIONS(456),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(462),
    [anon_sym_anyframe] = ACTIONS(465),
    [anon_sym_unreachable] = ACTIONS(468),
    [anon_sym_undefined] = ACTIONS(471),
    [anon_sym_null] = ACTIONS(471),
    [anon_sym_QMARK] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [aux_sym_multiline_string_token1] = ACTIONS(483),
    [anon_sym_SQUOTE] = ACTIONS(486),
    [sym_integer] = ACTIONS(468),
    [sym_float] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(492),
    [anon_sym_false] = ACTIONS(492),
    [anon_sym_bool] = ACTIONS(495),
    [anon_sym_f16] = ACTIONS(495),
    [anon_sym_f32] = ACTIONS(495),
    [anon_sym_f64] = ACTIONS(495),
    [anon_sym_f128] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(495),
    [anon_sym_anyerror] = ACTIONS(495),
    [anon_sym_anyopaque] = ACTIONS(495),
    [anon_sym_anytype] = ACTIONS(495),
    [anon_sym_noreturn] = ACTIONS(495),
    [anon_sym_isize] = ACTIONS(495),
    [anon_sym_usize] = ACTIONS(495),
    [anon_sym_comptime_int] = ACTIONS(495),
    [anon_sym_comptime_float] = ACTIONS(495),
    [anon_sym_c_short] = ACTIONS(495),
    [anon_sym_c_ushort] = ACTIONS(495),
    [anon_sym_c_int] = ACTIONS(495),
    [anon_sym_c_uint] = ACTIONS(495),
    [anon_sym_c_long] = ACTIONS(495),
    [anon_sym_c_ulong] = ACTIONS(495),
    [anon_sym_c_longlong] = ACTIONS(495),
    [anon_sym_c_ulonglong] = ACTIONS(495),
    [anon_sym_c_longdouble] = ACTIONS(495),
    [aux_sym_builtin_type_token1] = ACTIONS(495),
    [sym_builtin_identifier] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(35),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(35),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(35),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(35),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(506),
    [anon_sym_comptime] = ACTIONS(509),
    [anon_sym_extern] = ACTIONS(512),
    [anon_sym_const] = ACTIONS(515),
    [anon_sym_var] = ACTIONS(515),
    [anon_sym_inline] = ACTIONS(518),
    [anon_sym_fn] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_packed] = ACTIONS(512),
    [anon_sym_struct] = ACTIONS(532),
    [anon_sym_opaque] = ACTIONS(535),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(541),
    [anon_sym_error] = ACTIONS(544),
    [anon_sym_nosuspend] = ACTIONS(547),
    [anon_sym_suspend] = ACTIONS(550),
    [anon_sym_defer] = ACTIONS(553),
    [anon_sym_errdefer] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_asm] = ACTIONS(571),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(580),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_DASH_PERCENT] = ACTIONS(580),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_await] = ACTIONS(589),
    [anon_sym_continue] = ACTIONS(592),
    [anon_sym_resume] = ACTIONS(595),
    [anon_sym_return] = ACTIONS(598),
    [anon_sym_break] = ACTIONS(601),
    [anon_sym_try] = ACTIONS(604),
    [anon_sym_switch] = ACTIONS(607),
    [anon_sym_anyframe] = ACTIONS(610),
    [anon_sym_unreachable] = ACTIONS(613),
    [anon_sym_undefined] = ACTIONS(616),
    [anon_sym_null] = ACTIONS(616),
    [anon_sym_QMARK] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(622),
    [anon_sym_DQUOTE] = ACTIONS(625),
    [aux_sym_multiline_string_token1] = ACTIONS(628),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [sym_integer] = ACTIONS(613),
    [sym_float] = ACTIONS(634),
    [anon_sym_true] = ACTIONS(637),
    [anon_sym_false] = ACTIONS(637),
    [anon_sym_bool] = ACTIONS(640),
    [anon_sym_f16] = ACTIONS(640),
    [anon_sym_f32] = ACTIONS(640),
    [anon_sym_f64] = ACTIONS(640),
    [anon_sym_f128] = ACTIONS(640),
    [anon_sym_void] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_anyerror] = ACTIONS(640),
    [anon_sym_anyopaque] = ACTIONS(640),
    [anon_sym_anytype] = ACTIONS(640),
    [anon_sym_noreturn] = ACTIONS(640),
    [anon_sym_isize] = ACTIONS(640),
    [anon_sym_usize] = ACTIONS(640),
    [anon_sym_comptime_int] = ACTIONS(640),
    [anon_sym_comptime_float] = ACTIONS(640),
    [anon_sym_c_short] = ACTIONS(640),
    [anon_sym_c_ushort] = ACTIONS(640),
    [anon_sym_c_int] = ACTIONS(640),
    [anon_sym_c_uint] = ACTIONS(640),
    [anon_sym_c_long] = ACTIONS(640),
    [anon_sym_c_ulong] = ACTIONS(640),
    [anon_sym_c_longlong] = ACTIONS(640),
    [anon_sym_c_ulonglong] = ACTIONS(640),
    [anon_sym_c_longdouble] = ACTIONS(640),
    [aux_sym_builtin_type_token1] = ACTIONS(640),
    [sym_builtin_identifier] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(35),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(35),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(79),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(76),
    [sym_expression] = STATE(1354),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(42),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(42),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(79),
    [sym_expression] = STATE(1316),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(741),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_payload] = STATE(78),
    [sym_expression] = STATE(1322),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(35),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_block_repeat1] = STATE(35),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__container_members] = STATE(1742),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__container_members] = STATE(1747),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__container_members] = STATE(1777),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__container_members] = STATE(1716),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__container_members] = STATE(1802),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__container_members] = STATE(1799),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__container_members] = STATE(1743),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__container_members] = STATE(1730),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__container_members] = STATE(1737),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__container_members] = STATE(1754),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__container_members] = STATE(1762),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__container_members] = STATE(1790),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__container_members] = STATE(1804),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__container_members] = STATE(1727),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__container_members] = STATE(1745),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__container_members] = STATE(1768),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__container_members] = STATE(1779),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__container_members] = STATE(1739),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__container_members] = STATE(1741),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__container_members] = STATE(1753),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__container_members] = STATE(1792),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__container_members] = STATE(1732),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__container_members] = STATE(1733),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__container_members] = STATE(1759),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__container_members] = STATE(1811),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__container_members] = STATE(1723),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__container_members] = STATE(1724),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__container_members] = STATE(1725),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__container_members] = STATE(1746),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__container_members] = STATE(1752),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__container_members] = STATE(1755),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__container_members] = STATE(1767),
    [sym_test_declaration] = STATE(27),
    [sym_comptime_declaration] = STATE(27),
    [sym_container_field] = STATE(1595),
    [sym_variable_declaration] = STATE(27),
    [sym__variable_declaration_header] = STATE(1650),
    [sym_function_declaration] = STATE(27),
    [sym__function_prototype] = STATE(957),
    [sym_using_namespace_declaration] = STATE(27),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(946),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1514),
    [sym_if_type_expression] = STATE(1514),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(985),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(984),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym__container_members_repeat1] = STATE(27),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_pub] = ACTIONS(9),
    [anon_sym_test] = ACTIONS(11),
    [anon_sym_comptime] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_extern] = ACTIONS(17),
    [anon_sym_threadlocal] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(23),
    [anon_sym_noinline] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_usingnamespace] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1339),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1364),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1344),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1365),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1337),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__variable_declaration_expression_statement] = STATE(728),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(660),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_statement] = STATE(752),
    [sym_comptime_statement] = STATE(733),
    [sym_nosuspend_statement] = STATE(733),
    [sym_suspend_statement] = STATE(733),
    [sym_defer_statement] = STATE(733),
    [sym_errdefer_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym__if_prefix] = STATE(220),
    [sym_for_statement] = STATE(738),
    [sym__for_prefix] = STATE(221),
    [sym_while_statement] = STATE(738),
    [sym__while_prefix] = STATE(198),
    [sym_expression] = STATE(1360),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(662),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1477),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(329),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(331),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(335),
    [anon_sym_suspend] = ACTIONS(337),
    [anon_sym_defer] = ACTIONS(339),
    [anon_sym_errdefer] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym__identifier] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_pub] = ACTIONS(657),
    [anon_sym_test] = ACTIONS(657),
    [anon_sym_comptime] = ACTIONS(657),
    [anon_sym_COLON] = ACTIONS(655),
    [anon_sym_EQ] = ACTIONS(657),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_extern] = ACTIONS(657),
    [anon_sym_threadlocal] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_STAR_EQ] = ACTIONS(655),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(655),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(655),
    [anon_sym_SLASH_EQ] = ACTIONS(655),
    [anon_sym_PERCENT_EQ] = ACTIONS(655),
    [anon_sym_PLUS_EQ] = ACTIONS(655),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(655),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(655),
    [anon_sym_DASH_EQ] = ACTIONS(655),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(655),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_EQ] = ACTIONS(655),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(655),
    [anon_sym_GT_GT_EQ] = ACTIONS(655),
    [anon_sym_AMP_EQ] = ACTIONS(655),
    [anon_sym_CARET_EQ] = ACTIONS(655),
    [anon_sym_PIPE_EQ] = ACTIONS(655),
    [anon_sym_const] = ACTIONS(657),
    [anon_sym_var] = ACTIONS(657),
    [anon_sym_inline] = ACTIONS(657),
    [anon_sym_noinline] = ACTIONS(657),
    [anon_sym_fn] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_usingnamespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_packed] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(657),
    [anon_sym_opaque] = ACTIONS(657),
    [anon_sym_enum] = ACTIONS(657),
    [anon_sym_union] = ACTIONS(657),
    [anon_sym_error] = ACTIONS(657),
    [anon_sym_nosuspend] = ACTIONS(657),
    [anon_sym_suspend] = ACTIONS(657),
    [anon_sym_defer] = ACTIONS(657),
    [anon_sym_errdefer] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(657),
    [anon_sym_else] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(657),
    [anon_sym_DOT_DOT] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(657),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_addrspace] = ACTIONS(657),
    [anon_sym_linksection] = ACTIONS(657),
    [anon_sym_asm] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(657),
    [anon_sym_DASH_PERCENT] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_EQ_EQ] = ACTIONS(655),
    [anon_sym_BANG_EQ] = ACTIONS(655),
    [anon_sym_GT] = ACTIONS(657),
    [anon_sym_GT_EQ] = ACTIONS(655),
    [anon_sym_LT_EQ] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_orelse] = ACTIONS(657),
    [anon_sym_LT_LT] = ACTIONS(657),
    [anon_sym_GT_GT] = ACTIONS(657),
    [anon_sym_LT_LT_PIPE] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(657),
    [anon_sym_PLUS_PLUS] = ACTIONS(655),
    [anon_sym_PLUS_PERCENT] = ACTIONS(657),
    [anon_sym_PLUS_PIPE] = ACTIONS(657),
    [anon_sym_DASH_PIPE] = ACTIONS(657),
    [anon_sym_SLASH] = ACTIONS(657),
    [anon_sym_PERCENT] = ACTIONS(657),
    [anon_sym_STAR_STAR] = ACTIONS(655),
    [anon_sym_STAR_PERCENT] = ACTIONS(657),
    [anon_sym_STAR_PIPE] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(655),
    [anon_sym_async] = ACTIONS(657),
    [anon_sym_await] = ACTIONS(657),
    [anon_sym_continue] = ACTIONS(657),
    [anon_sym_resume] = ACTIONS(657),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_break] = ACTIONS(657),
    [anon_sym_try] = ACTIONS(657),
    [anon_sym_catch] = ACTIONS(657),
    [anon_sym_switch] = ACTIONS(657),
    [anon_sym_EQ_GT] = ACTIONS(655),
    [anon_sym_anyframe] = ACTIONS(657),
    [anon_sym_unreachable] = ACTIONS(657),
    [anon_sym_undefined] = ACTIONS(657),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_DOT_STAR] = ACTIONS(655),
    [anon_sym_DOT_QMARK] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [aux_sym_multiline_string_token1] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [anon_sym_bool] = ACTIONS(657),
    [anon_sym_f16] = ACTIONS(657),
    [anon_sym_f32] = ACTIONS(657),
    [anon_sym_f64] = ACTIONS(657),
    [anon_sym_f128] = ACTIONS(657),
    [anon_sym_void] = ACTIONS(657),
    [anon_sym_type] = ACTIONS(657),
    [anon_sym_anyerror] = ACTIONS(657),
    [anon_sym_anyopaque] = ACTIONS(657),
    [anon_sym_anytype] = ACTIONS(657),
    [anon_sym_noreturn] = ACTIONS(657),
    [anon_sym_isize] = ACTIONS(657),
    [anon_sym_usize] = ACTIONS(657),
    [anon_sym_comptime_int] = ACTIONS(657),
    [anon_sym_comptime_float] = ACTIONS(657),
    [anon_sym_c_short] = ACTIONS(657),
    [anon_sym_c_ushort] = ACTIONS(657),
    [anon_sym_c_int] = ACTIONS(657),
    [anon_sym_c_uint] = ACTIONS(657),
    [anon_sym_c_long] = ACTIONS(657),
    [anon_sym_c_ulong] = ACTIONS(657),
    [anon_sym_c_longlong] = ACTIONS(657),
    [anon_sym_c_ulonglong] = ACTIONS(657),
    [anon_sym_c_longdouble] = ACTIONS(657),
    [aux_sym_builtin_type_token1] = ACTIONS(657),
    [sym_builtin_identifier] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(657),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym__identifier] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_test] = ACTIONS(661),
    [anon_sym_comptime] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_EQ] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(661),
    [anon_sym_extern] = ACTIONS(661),
    [anon_sym_threadlocal] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_STAR_EQ] = ACTIONS(659),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(659),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(659),
    [anon_sym_SLASH_EQ] = ACTIONS(659),
    [anon_sym_PERCENT_EQ] = ACTIONS(659),
    [anon_sym_PLUS_EQ] = ACTIONS(659),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(659),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(659),
    [anon_sym_DASH_EQ] = ACTIONS(659),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(659),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_EQ] = ACTIONS(659),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(659),
    [anon_sym_GT_GT_EQ] = ACTIONS(659),
    [anon_sym_AMP_EQ] = ACTIONS(659),
    [anon_sym_CARET_EQ] = ACTIONS(659),
    [anon_sym_PIPE_EQ] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_var] = ACTIONS(661),
    [anon_sym_inline] = ACTIONS(661),
    [anon_sym_noinline] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_usingnamespace] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_packed] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_opaque] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_error] = ACTIONS(661),
    [anon_sym_nosuspend] = ACTIONS(661),
    [anon_sym_suspend] = ACTIONS(661),
    [anon_sym_defer] = ACTIONS(661),
    [anon_sym_errdefer] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_else] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_DOT_DOT] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_addrspace] = ACTIONS(661),
    [anon_sym_linksection] = ACTIONS(661),
    [anon_sym_asm] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_DASH_PERCENT] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_CARET] = ACTIONS(661),
    [anon_sym_orelse] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(661),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_LT_LT_PIPE] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_PLUS_PERCENT] = ACTIONS(661),
    [anon_sym_PLUS_PIPE] = ACTIONS(661),
    [anon_sym_DASH_PIPE] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(661),
    [anon_sym_PERCENT] = ACTIONS(661),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_STAR_PERCENT] = ACTIONS(661),
    [anon_sym_STAR_PIPE] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_resume] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_try] = ACTIONS(661),
    [anon_sym_catch] = ACTIONS(661),
    [anon_sym_switch] = ACTIONS(661),
    [anon_sym_EQ_GT] = ACTIONS(659),
    [anon_sym_anyframe] = ACTIONS(661),
    [anon_sym_unreachable] = ACTIONS(661),
    [anon_sym_undefined] = ACTIONS(661),
    [anon_sym_null] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_DOT] = ACTIONS(661),
    [anon_sym_DOT_STAR] = ACTIONS(659),
    [anon_sym_DOT_QMARK] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [aux_sym_multiline_string_token1] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(661),
    [sym_float] = ACTIONS(659),
    [anon_sym_true] = ACTIONS(661),
    [anon_sym_false] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_f16] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_f128] = ACTIONS(661),
    [anon_sym_void] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_anyerror] = ACTIONS(661),
    [anon_sym_anyopaque] = ACTIONS(661),
    [anon_sym_anytype] = ACTIONS(661),
    [anon_sym_noreturn] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_comptime_int] = ACTIONS(661),
    [anon_sym_comptime_float] = ACTIONS(661),
    [anon_sym_c_short] = ACTIONS(661),
    [anon_sym_c_ushort] = ACTIONS(661),
    [anon_sym_c_int] = ACTIONS(661),
    [anon_sym_c_uint] = ACTIONS(661),
    [anon_sym_c_long] = ACTIONS(661),
    [anon_sym_c_ulong] = ACTIONS(661),
    [anon_sym_c_longlong] = ACTIONS(661),
    [anon_sym_c_ulonglong] = ACTIONS(661),
    [anon_sym_c_longdouble] = ACTIONS(661),
    [aux_sym_builtin_type_token1] = ACTIONS(661),
    [sym_builtin_identifier] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(117),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1109),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(117),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(663),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(665),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(665),
    [anon_sym_c] = ACTIONS(677),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(99),
    [sym_address_space] = STATE(146),
    [sym_link_section] = STATE(179),
    [sym_calling_convention] = STATE(238),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1074),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(823),
    [sym_if_type_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(98),
    [sym_address_space] = STATE(151),
    [sym_link_section] = STATE(190),
    [sym_calling_convention] = STATE(231),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1065),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(831),
    [sym_if_type_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(103),
    [sym_address_space] = STATE(158),
    [sym_link_section] = STATE(185),
    [sym_calling_convention] = STATE(248),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1092),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(994),
    [sym_if_type_expression] = STATE(994),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(111),
    [sym_address_space] = STATE(150),
    [sym_link_section] = STATE(176),
    [sym_calling_convention] = STATE(255),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1094),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1009),
    [sym_if_type_expression] = STATE(1009),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(108),
    [sym_address_space] = STATE(145),
    [sym_link_section] = STATE(172),
    [sym_calling_convention] = STATE(301),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(877),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(831),
    [sym_if_type_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(96),
    [sym_address_space] = STATE(155),
    [sym_link_section] = STATE(192),
    [sym_calling_convention] = STATE(208),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(881),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(823),
    [sym_if_type_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(106),
    [sym_address_space] = STATE(152),
    [sym_link_section] = STATE(183),
    [sym_calling_convention] = STATE(270),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1346),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(831),
    [sym_if_type_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(107),
    [sym_address_space] = STATE(141),
    [sym_link_section] = STATE(191),
    [sym_calling_convention] = STATE(276),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1366),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(823),
    [sym_if_type_expression] = STATE(823),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(117),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1109),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(117),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(699),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(665),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(665),
    [anon_sym_c] = ACTIONS(703),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(117),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1109),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(117),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(705),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(665),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(665),
    [anon_sym_c] = ACTIONS(709),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(112),
    [sym_address_space] = STATE(112),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(909),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(112),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(711),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(711),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(97),
    [sym_address_space] = STATE(97),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(999),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(97),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(713),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(713),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(147),
    [sym_link_section] = STATE(177),
    [sym_calling_convention] = STATE(216),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(873),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1017),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(139),
    [sym_link_section] = STATE(178),
    [sym_calling_convention] = STATE(237),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1073),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(149),
    [sym_link_section] = STATE(175),
    [sym_calling_convention] = STATE(241),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1079),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1040),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(100),
    [sym_address_space] = STATE(100),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1031),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(100),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(717),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(717),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(104),
    [sym_address_space] = STATE(104),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1068),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_slice_type_repeat1] = STATE(104),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(719),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(719),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(719),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(143),
    [sym_link_section] = STATE(171),
    [sym_calling_convention] = STATE(254),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1093),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1008),
    [sym_if_type_expression] = STATE(1008),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1076),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1084),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(138),
    [sym_link_section] = STATE(188),
    [sym_calling_convention] = STATE(275),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1363),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(142),
    [sym_link_section] = STATE(164),
    [sym_calling_convention] = STATE(280),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1352),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(157),
    [sym_link_section] = STATE(187),
    [sym_calling_convention] = STATE(207),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(875),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(105),
    [sym_address_space] = STATE(105),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1080),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_slice_type_repeat1] = STATE(105),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(721),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(721),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(113),
    [sym_address_space] = STATE(113),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(878),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(113),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(723),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(148),
    [sym_link_section] = STATE(186),
    [sym_calling_convention] = STATE(260),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1097),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1028),
    [sym_if_type_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(913),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(855),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(715),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(715),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(122),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1085),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(122),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(899),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(118),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1075),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(118),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(729),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(729),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(998),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1081),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(121),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1081),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(121),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1032),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1085),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1089),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(117),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1109),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(117),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(665),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(665),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(127),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1032),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(127),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(733),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(862),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(128),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1041),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(128),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(735),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(735),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1041),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1053),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(125),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(915),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(125),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(737),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1067),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(130),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1188),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_pointer_type_repeat1] = STATE(130),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(739),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(739),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_allowzero] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(120),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1016),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(120),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(741),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_allowzero] = ACTIONS(741),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(882),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(136),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(882),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(136),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(743),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(743),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(115),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(850),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(115),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(745),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(725),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(850),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(727),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_address_space] = STATE(133),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(888),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_pointer_type_repeat1] = STATE(133),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_addrspace] = ACTIONS(671),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_allowzero] = ACTIONS(747),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(194),
    [sym_calling_convention] = STATE(278),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1367),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(170),
    [sym_calling_convention] = STATE(240),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1078),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(749),
    [sym__identifier] = ACTIONS(751),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_comptime] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(749),
    [anon_sym_EQ] = ACTIONS(751),
    [anon_sym_extern] = ACTIONS(751),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(751),
    [anon_sym_var] = ACTIONS(751),
    [anon_sym_inline] = ACTIONS(751),
    [anon_sym_fn] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(749),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(749),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_packed] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_opaque] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_union] = ACTIONS(751),
    [anon_sym_error] = ACTIONS(751),
    [anon_sym_nosuspend] = ACTIONS(751),
    [anon_sym_suspend] = ACTIONS(751),
    [anon_sym_defer] = ACTIONS(751),
    [anon_sym_errdefer] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(751),
    [anon_sym_else] = ACTIONS(751),
    [anon_sym_for] = ACTIONS(751),
    [anon_sym_DOT_DOT] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_align] = ACTIONS(751),
    [anon_sym_addrspace] = ACTIONS(751),
    [anon_sym_linksection] = ACTIONS(751),
    [anon_sym_asm] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_RBRACK] = ACTIONS(749),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_DASH_PERCENT] = ACTIONS(751),
    [anon_sym_AMP] = ACTIONS(751),
    [anon_sym_or] = ACTIONS(751),
    [anon_sym_and] = ACTIONS(751),
    [anon_sym_EQ_EQ] = ACTIONS(749),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(751),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(749),
    [anon_sym_LT] = ACTIONS(751),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_orelse] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(751),
    [anon_sym_GT_GT] = ACTIONS(751),
    [anon_sym_LT_LT_PIPE] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_PLUS_PERCENT] = ACTIONS(751),
    [anon_sym_PLUS_PIPE] = ACTIONS(751),
    [anon_sym_DASH_PIPE] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(751),
    [anon_sym_PERCENT] = ACTIONS(751),
    [anon_sym_STAR_STAR] = ACTIONS(749),
    [anon_sym_STAR_PERCENT] = ACTIONS(751),
    [anon_sym_STAR_PIPE] = ACTIONS(751),
    [anon_sym_PIPE_PIPE] = ACTIONS(749),
    [anon_sym_async] = ACTIONS(751),
    [anon_sym_await] = ACTIONS(751),
    [anon_sym_continue] = ACTIONS(751),
    [anon_sym_resume] = ACTIONS(751),
    [anon_sym_return] = ACTIONS(751),
    [anon_sym_break] = ACTIONS(751),
    [anon_sym_try] = ACTIONS(751),
    [anon_sym_catch] = ACTIONS(751),
    [anon_sym_switch] = ACTIONS(751),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_anyframe] = ACTIONS(751),
    [anon_sym_unreachable] = ACTIONS(751),
    [anon_sym_undefined] = ACTIONS(751),
    [anon_sym_null] = ACTIONS(751),
    [anon_sym_QMARK] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(751),
    [anon_sym_DOT_STAR] = ACTIONS(749),
    [anon_sym_DOT_QMARK] = ACTIONS(749),
    [anon_sym_DQUOTE] = ACTIONS(749),
    [aux_sym_multiline_string_token1] = ACTIONS(749),
    [anon_sym_SQUOTE] = ACTIONS(749),
    [sym_integer] = ACTIONS(751),
    [sym_float] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(751),
    [anon_sym_false] = ACTIONS(751),
    [anon_sym_bool] = ACTIONS(751),
    [anon_sym_f16] = ACTIONS(751),
    [anon_sym_f32] = ACTIONS(751),
    [anon_sym_f64] = ACTIONS(751),
    [anon_sym_f128] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_anyerror] = ACTIONS(751),
    [anon_sym_anyopaque] = ACTIONS(751),
    [anon_sym_anytype] = ACTIONS(751),
    [anon_sym_noreturn] = ACTIONS(751),
    [anon_sym_isize] = ACTIONS(751),
    [anon_sym_usize] = ACTIONS(751),
    [anon_sym_comptime_int] = ACTIONS(751),
    [anon_sym_comptime_float] = ACTIONS(751),
    [anon_sym_c_short] = ACTIONS(751),
    [anon_sym_c_ushort] = ACTIONS(751),
    [anon_sym_c_int] = ACTIONS(751),
    [anon_sym_c_uint] = ACTIONS(751),
    [anon_sym_c_long] = ACTIONS(751),
    [anon_sym_c_ulong] = ACTIONS(751),
    [anon_sym_c_longlong] = ACTIONS(751),
    [anon_sym_c_ulonglong] = ACTIONS(751),
    [anon_sym_c_longdouble] = ACTIONS(751),
    [aux_sym_builtin_type_token1] = ACTIONS(751),
    [sym_builtin_identifier] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(751),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(164),
    [sym_calling_convention] = STATE(280),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1352),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(166),
    [sym_calling_convention] = STATE(283),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1317),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(181),
    [sym_calling_convention] = STATE(259),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1096),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1027),
    [sym_if_type_expression] = STATE(1027),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym__function_prototype] = STATE(807),
    [sym_parameter] = STATE(1665),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1329),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1647),
    [sym_if_type_expression] = STATE(1647),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1211),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1213),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(755),
    [anon_sym_noalias] = ACTIONS(757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(187),
    [sym_calling_convention] = STATE(207),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(875),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(175),
    [sym_calling_convention] = STATE(241),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1079),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(184),
    [sym_calling_convention] = STATE(224),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(912),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(163),
    [sym_calling_convention] = STATE(263),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1100),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1037),
    [sym_if_type_expression] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(189),
    [sym_calling_convention] = STATE(244),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1083),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(186),
    [sym_calling_convention] = STATE(260),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1097),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1028),
    [sym_if_type_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(178),
    [sym_calling_convention] = STATE(237),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1073),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(188),
    [sym_calling_convention] = STATE(275),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1363),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(761),
    [sym__identifier] = ACTIONS(763),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_comptime] = ACTIONS(763),
    [anon_sym_COLON] = ACTIONS(761),
    [anon_sym_EQ] = ACTIONS(763),
    [anon_sym_extern] = ACTIONS(763),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_STAR_EQ] = ACTIONS(761),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(761),
    [anon_sym_SLASH_EQ] = ACTIONS(761),
    [anon_sym_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_PLUS_EQ] = ACTIONS(761),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(761),
    [anon_sym_DASH_EQ] = ACTIONS(761),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(761),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(761),
    [anon_sym_LT_LT_EQ] = ACTIONS(761),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(761),
    [anon_sym_GT_GT_EQ] = ACTIONS(761),
    [anon_sym_AMP_EQ] = ACTIONS(761),
    [anon_sym_CARET_EQ] = ACTIONS(761),
    [anon_sym_PIPE_EQ] = ACTIONS(761),
    [anon_sym_const] = ACTIONS(763),
    [anon_sym_var] = ACTIONS(763),
    [anon_sym_inline] = ACTIONS(763),
    [anon_sym_fn] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_packed] = ACTIONS(763),
    [anon_sym_struct] = ACTIONS(763),
    [anon_sym_opaque] = ACTIONS(763),
    [anon_sym_enum] = ACTIONS(763),
    [anon_sym_union] = ACTIONS(763),
    [anon_sym_error] = ACTIONS(763),
    [anon_sym_nosuspend] = ACTIONS(763),
    [anon_sym_suspend] = ACTIONS(763),
    [anon_sym_defer] = ACTIONS(763),
    [anon_sym_errdefer] = ACTIONS(763),
    [anon_sym_if] = ACTIONS(763),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_DOT_DOT] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(763),
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_STAR] = ACTIONS(763),
    [anon_sym_align] = ACTIONS(763),
    [anon_sym_addrspace] = ACTIONS(763),
    [anon_sym_linksection] = ACTIONS(763),
    [anon_sym_asm] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(761),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_TILDE] = ACTIONS(761),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_DASH_PERCENT] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
    [anon_sym_or] = ACTIONS(763),
    [anon_sym_and] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT] = ACTIONS(763),
    [anon_sym_GT_EQ] = ACTIONS(761),
    [anon_sym_LT_EQ] = ACTIONS(761),
    [anon_sym_LT] = ACTIONS(763),
    [anon_sym_CARET] = ACTIONS(763),
    [anon_sym_orelse] = ACTIONS(763),
    [anon_sym_LT_LT] = ACTIONS(763),
    [anon_sym_GT_GT] = ACTIONS(763),
    [anon_sym_LT_LT_PIPE] = ACTIONS(763),
    [anon_sym_PLUS] = ACTIONS(763),
    [anon_sym_PLUS_PLUS] = ACTIONS(761),
    [anon_sym_PLUS_PERCENT] = ACTIONS(763),
    [anon_sym_PLUS_PIPE] = ACTIONS(763),
    [anon_sym_DASH_PIPE] = ACTIONS(763),
    [anon_sym_SLASH] = ACTIONS(763),
    [anon_sym_PERCENT] = ACTIONS(763),
    [anon_sym_STAR_STAR] = ACTIONS(761),
    [anon_sym_STAR_PERCENT] = ACTIONS(763),
    [anon_sym_STAR_PIPE] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_await] = ACTIONS(763),
    [anon_sym_continue] = ACTIONS(763),
    [anon_sym_resume] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(763),
    [anon_sym_break] = ACTIONS(763),
    [anon_sym_try] = ACTIONS(763),
    [anon_sym_catch] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(763),
    [anon_sym_EQ_GT] = ACTIONS(761),
    [anon_sym_anyframe] = ACTIONS(763),
    [anon_sym_unreachable] = ACTIONS(763),
    [anon_sym_undefined] = ACTIONS(763),
    [anon_sym_null] = ACTIONS(763),
    [anon_sym_QMARK] = ACTIONS(761),
    [anon_sym_DOT] = ACTIONS(763),
    [anon_sym_DOT_STAR] = ACTIONS(761),
    [anon_sym_DOT_QMARK] = ACTIONS(761),
    [anon_sym_DQUOTE] = ACTIONS(761),
    [aux_sym_multiline_string_token1] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(761),
    [sym_integer] = ACTIONS(763),
    [sym_float] = ACTIONS(761),
    [anon_sym_true] = ACTIONS(763),
    [anon_sym_false] = ACTIONS(763),
    [anon_sym_bool] = ACTIONS(763),
    [anon_sym_f16] = ACTIONS(763),
    [anon_sym_f32] = ACTIONS(763),
    [anon_sym_f64] = ACTIONS(763),
    [anon_sym_f128] = ACTIONS(763),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_type] = ACTIONS(763),
    [anon_sym_anyerror] = ACTIONS(763),
    [anon_sym_anyopaque] = ACTIONS(763),
    [anon_sym_anytype] = ACTIONS(763),
    [anon_sym_noreturn] = ACTIONS(763),
    [anon_sym_isize] = ACTIONS(763),
    [anon_sym_usize] = ACTIONS(763),
    [anon_sym_comptime_int] = ACTIONS(763),
    [anon_sym_comptime_float] = ACTIONS(763),
    [anon_sym_c_short] = ACTIONS(763),
    [anon_sym_c_ushort] = ACTIONS(763),
    [anon_sym_c_int] = ACTIONS(763),
    [anon_sym_c_uint] = ACTIONS(763),
    [anon_sym_c_long] = ACTIONS(763),
    [anon_sym_c_ulong] = ACTIONS(763),
    [anon_sym_c_longlong] = ACTIONS(763),
    [anon_sym_c_ulonglong] = ACTIONS(763),
    [anon_sym_c_longdouble] = ACTIONS(763),
    [aux_sym_builtin_type_token1] = ACTIONS(763),
    [sym_builtin_identifier] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(763),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym__function_prototype] = STATE(807),
    [sym_parameter] = STATE(1593),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1329),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1647),
    [sym_if_type_expression] = STATE(1647),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1211),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1213),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_noalias] = ACTIONS(757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(177),
    [sym_calling_convention] = STATE(216),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(873),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym__function_prototype] = STATE(807),
    [sym_parameter] = STATE(1665),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1329),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1647),
    [sym_if_type_expression] = STATE(1647),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1211),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1213),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_noalias] = ACTIONS(757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(174),
    [sym_calling_convention] = STATE(215),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(887),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_link_section] = STATE(171),
    [sym_calling_convention] = STATE(254),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1093),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1008),
    [sym_if_type_expression] = STATE(1008),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_linksection] = ACTIONS(683),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym__variable_declaration_expression_statement] = STATE(742),
    [sym__variable_declaration_header] = STATE(1603),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1371),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym__identifier] = ACTIONS(771),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_comptime] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_STAR_EQ] = ACTIONS(769),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(769),
    [anon_sym_SLASH_EQ] = ACTIONS(769),
    [anon_sym_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_PLUS_EQ] = ACTIONS(769),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(769),
    [anon_sym_DASH_EQ] = ACTIONS(769),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(769),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(769),
    [anon_sym_LT_LT_EQ] = ACTIONS(769),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(769),
    [anon_sym_GT_GT_EQ] = ACTIONS(769),
    [anon_sym_AMP_EQ] = ACTIONS(769),
    [anon_sym_CARET_EQ] = ACTIONS(769),
    [anon_sym_PIPE_EQ] = ACTIONS(769),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_var] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_fn] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_packed] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_opaque] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_union] = ACTIONS(771),
    [anon_sym_error] = ACTIONS(771),
    [anon_sym_nosuspend] = ACTIONS(771),
    [anon_sym_suspend] = ACTIONS(771),
    [anon_sym_defer] = ACTIONS(771),
    [anon_sym_errdefer] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_align] = ACTIONS(771),
    [anon_sym_addrspace] = ACTIONS(771),
    [anon_sym_linksection] = ACTIONS(771),
    [anon_sym_asm] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_DASH_PERCENT] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(769),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_orelse] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_LT_LT_PIPE] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_PLUS_PERCENT] = ACTIONS(771),
    [anon_sym_PLUS_PIPE] = ACTIONS(771),
    [anon_sym_DASH_PIPE] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(769),
    [anon_sym_STAR_PERCENT] = ACTIONS(771),
    [anon_sym_STAR_PIPE] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_async] = ACTIONS(771),
    [anon_sym_await] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_resume] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_catch] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_EQ_GT] = ACTIONS(769),
    [anon_sym_anyframe] = ACTIONS(771),
    [anon_sym_unreachable] = ACTIONS(771),
    [anon_sym_undefined] = ACTIONS(771),
    [anon_sym_null] = ACTIONS(771),
    [anon_sym_QMARK] = ACTIONS(769),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_DOT_STAR] = ACTIONS(769),
    [anon_sym_DOT_QMARK] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [aux_sym_multiline_string_token1] = ACTIONS(769),
    [anon_sym_SQUOTE] = ACTIONS(769),
    [sym_integer] = ACTIONS(771),
    [sym_float] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [anon_sym_bool] = ACTIONS(771),
    [anon_sym_f16] = ACTIONS(771),
    [anon_sym_f32] = ACTIONS(771),
    [anon_sym_f64] = ACTIONS(771),
    [anon_sym_f128] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(771),
    [anon_sym_anyerror] = ACTIONS(771),
    [anon_sym_anyopaque] = ACTIONS(771),
    [anon_sym_anytype] = ACTIONS(771),
    [anon_sym_noreturn] = ACTIONS(771),
    [anon_sym_isize] = ACTIONS(771),
    [anon_sym_usize] = ACTIONS(771),
    [anon_sym_comptime_int] = ACTIONS(771),
    [anon_sym_comptime_float] = ACTIONS(771),
    [anon_sym_c_short] = ACTIONS(771),
    [anon_sym_c_ushort] = ACTIONS(771),
    [anon_sym_c_int] = ACTIONS(771),
    [anon_sym_c_uint] = ACTIONS(771),
    [anon_sym_c_long] = ACTIONS(771),
    [anon_sym_c_ulong] = ACTIONS(771),
    [anon_sym_c_longlong] = ACTIONS(771),
    [anon_sym_c_ulonglong] = ACTIONS(771),
    [anon_sym_c_longdouble] = ACTIONS(771),
    [aux_sym_builtin_type_token1] = ACTIONS(771),
    [sym_builtin_identifier] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(771),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(773),
    [sym__identifier] = ACTIONS(775),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_comptime] = ACTIONS(775),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_extern] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_STAR_EQ] = ACTIONS(773),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(773),
    [anon_sym_SLASH_EQ] = ACTIONS(773),
    [anon_sym_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_PLUS_EQ] = ACTIONS(773),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(773),
    [anon_sym_DASH_EQ] = ACTIONS(773),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(773),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(773),
    [anon_sym_LT_LT_EQ] = ACTIONS(773),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(773),
    [anon_sym_GT_GT_EQ] = ACTIONS(773),
    [anon_sym_AMP_EQ] = ACTIONS(773),
    [anon_sym_CARET_EQ] = ACTIONS(773),
    [anon_sym_PIPE_EQ] = ACTIONS(773),
    [anon_sym_const] = ACTIONS(775),
    [anon_sym_var] = ACTIONS(775),
    [anon_sym_inline] = ACTIONS(775),
    [anon_sym_fn] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_RPAREN] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_packed] = ACTIONS(775),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_opaque] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(775),
    [anon_sym_union] = ACTIONS(775),
    [anon_sym_error] = ACTIONS(775),
    [anon_sym_nosuspend] = ACTIONS(775),
    [anon_sym_suspend] = ACTIONS(775),
    [anon_sym_defer] = ACTIONS(775),
    [anon_sym_errdefer] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(773),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(775),
    [anon_sym_align] = ACTIONS(775),
    [anon_sym_addrspace] = ACTIONS(775),
    [anon_sym_linksection] = ACTIONS(775),
    [anon_sym_asm] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_DASH_PERCENT] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_orelse] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_LT_LT_PIPE] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_PLUS_PERCENT] = ACTIONS(775),
    [anon_sym_PLUS_PIPE] = ACTIONS(775),
    [anon_sym_DASH_PIPE] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_STAR_STAR] = ACTIONS(773),
    [anon_sym_STAR_PERCENT] = ACTIONS(775),
    [anon_sym_STAR_PIPE] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(775),
    [anon_sym_continue] = ACTIONS(775),
    [anon_sym_resume] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(775),
    [anon_sym_break] = ACTIONS(775),
    [anon_sym_try] = ACTIONS(775),
    [anon_sym_catch] = ACTIONS(775),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(773),
    [anon_sym_anyframe] = ACTIONS(775),
    [anon_sym_unreachable] = ACTIONS(775),
    [anon_sym_undefined] = ACTIONS(775),
    [anon_sym_null] = ACTIONS(775),
    [anon_sym_QMARK] = ACTIONS(773),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_DOT_STAR] = ACTIONS(773),
    [anon_sym_DOT_QMARK] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [aux_sym_multiline_string_token1] = ACTIONS(773),
    [anon_sym_SQUOTE] = ACTIONS(773),
    [sym_integer] = ACTIONS(775),
    [sym_float] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [anon_sym_bool] = ACTIONS(775),
    [anon_sym_f16] = ACTIONS(775),
    [anon_sym_f32] = ACTIONS(775),
    [anon_sym_f64] = ACTIONS(775),
    [anon_sym_f128] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(775),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_anyerror] = ACTIONS(775),
    [anon_sym_anyopaque] = ACTIONS(775),
    [anon_sym_anytype] = ACTIONS(775),
    [anon_sym_noreturn] = ACTIONS(775),
    [anon_sym_isize] = ACTIONS(775),
    [anon_sym_usize] = ACTIONS(775),
    [anon_sym_comptime_int] = ACTIONS(775),
    [anon_sym_comptime_float] = ACTIONS(775),
    [anon_sym_c_short] = ACTIONS(775),
    [anon_sym_c_ushort] = ACTIONS(775),
    [anon_sym_c_int] = ACTIONS(775),
    [anon_sym_c_uint] = ACTIONS(775),
    [anon_sym_c_long] = ACTIONS(775),
    [anon_sym_c_ulong] = ACTIONS(775),
    [anon_sym_c_longlong] = ACTIONS(775),
    [anon_sym_c_ulonglong] = ACTIONS(775),
    [anon_sym_c_longdouble] = ACTIONS(775),
    [aux_sym_builtin_type_token1] = ACTIONS(775),
    [sym_builtin_identifier] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(775),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym__function_prototype] = STATE(807),
    [sym_parameter] = STATE(1665),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1329),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1647),
    [sym_if_type_expression] = STATE(1647),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1211),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1213),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_noalias] = ACTIONS(757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(264),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1102),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1049),
    [sym_if_type_expression] = STATE(1049),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(283),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1317),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1605),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(284),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1359),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1673),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1673),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(789),
    [sym__identifier] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(789),
    [anon_sym_comptime] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_extern] = ACTIONS(791),
    [anon_sym_threadlocal] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(789),
    [anon_sym_STAR_EQ] = ACTIONS(789),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(789),
    [anon_sym_SLASH_EQ] = ACTIONS(789),
    [anon_sym_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(789),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(789),
    [anon_sym_DASH_EQ] = ACTIONS(789),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(789),
    [anon_sym_LT_LT_EQ] = ACTIONS(789),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(789),
    [anon_sym_GT_GT_EQ] = ACTIONS(789),
    [anon_sym_AMP_EQ] = ACTIONS(789),
    [anon_sym_CARET_EQ] = ACTIONS(789),
    [anon_sym_PIPE_EQ] = ACTIONS(789),
    [anon_sym_const] = ACTIONS(791),
    [anon_sym_var] = ACTIONS(791),
    [anon_sym_inline] = ACTIONS(791),
    [anon_sym_fn] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(789),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_packed] = ACTIONS(791),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_opaque] = ACTIONS(791),
    [anon_sym_enum] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(791),
    [anon_sym_error] = ACTIONS(791),
    [anon_sym_nosuspend] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(789),
    [anon_sym_while] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_align] = ACTIONS(791),
    [anon_sym_addrspace] = ACTIONS(791),
    [anon_sym_linksection] = ACTIONS(791),
    [anon_sym_asm] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_RBRACK] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_DASH_PERCENT] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(791),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(789),
    [anon_sym_BANG_EQ] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_GT_EQ] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_orelse] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LT_LT_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_PLUS_PERCENT] = ACTIONS(791),
    [anon_sym_PLUS_PIPE] = ACTIONS(791),
    [anon_sym_DASH_PIPE] = ACTIONS(791),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(789),
    [anon_sym_STAR_PERCENT] = ACTIONS(791),
    [anon_sym_STAR_PIPE] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(789),
    [anon_sym_async] = ACTIONS(791),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_continue] = ACTIONS(791),
    [anon_sym_resume] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(791),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_try] = ACTIONS(791),
    [anon_sym_catch] = ACTIONS(791),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(789),
    [anon_sym_anyframe] = ACTIONS(791),
    [anon_sym_unreachable] = ACTIONS(791),
    [anon_sym_undefined] = ACTIONS(791),
    [anon_sym_null] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(789),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_DOT_STAR] = ACTIONS(789),
    [anon_sym_DOT_QMARK] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [aux_sym_multiline_string_token1] = ACTIONS(789),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer] = ACTIONS(791),
    [sym_float] = ACTIONS(789),
    [anon_sym_true] = ACTIONS(791),
    [anon_sym_false] = ACTIONS(791),
    [anon_sym_bool] = ACTIONS(791),
    [anon_sym_f16] = ACTIONS(791),
    [anon_sym_f32] = ACTIONS(791),
    [anon_sym_f64] = ACTIONS(791),
    [anon_sym_f128] = ACTIONS(791),
    [anon_sym_void] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_anyerror] = ACTIONS(791),
    [anon_sym_anyopaque] = ACTIONS(791),
    [anon_sym_anytype] = ACTIONS(791),
    [anon_sym_noreturn] = ACTIONS(791),
    [anon_sym_isize] = ACTIONS(791),
    [anon_sym_usize] = ACTIONS(791),
    [anon_sym_comptime_int] = ACTIONS(791),
    [anon_sym_comptime_float] = ACTIONS(791),
    [anon_sym_c_short] = ACTIONS(791),
    [anon_sym_c_ushort] = ACTIONS(791),
    [anon_sym_c_int] = ACTIONS(791),
    [anon_sym_c_uint] = ACTIONS(791),
    [anon_sym_c_long] = ACTIONS(791),
    [anon_sym_c_ulong] = ACTIONS(791),
    [anon_sym_c_longlong] = ACTIONS(791),
    [anon_sym_c_ulonglong] = ACTIONS(791),
    [anon_sym_c_longdouble] = ACTIONS(791),
    [aux_sym_builtin_type_token1] = ACTIONS(791),
    [sym_builtin_identifier] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(243),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1082),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(259),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1096),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1027),
    [sym_if_type_expression] = STATE(1027),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(207),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(875),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1673),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(223),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(898),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(244),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1083),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(260),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1097),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1028),
    [sym_if_type_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(224),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(912),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(240),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1078),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(241),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1079),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1578),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(262),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1099),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1036),
    [sym_if_type_expression] = STATE(1036),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(797),
    [sym__identifier] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(797),
    [anon_sym_comptime] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(797),
    [anon_sym_EQ] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_threadlocal] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_STAR_EQ] = ACTIONS(797),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(797),
    [anon_sym_SLASH_EQ] = ACTIONS(797),
    [anon_sym_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(797),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(797),
    [anon_sym_DASH_EQ] = ACTIONS(797),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(797),
    [anon_sym_LT_LT_EQ] = ACTIONS(797),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(797),
    [anon_sym_GT_GT_EQ] = ACTIONS(797),
    [anon_sym_AMP_EQ] = ACTIONS(797),
    [anon_sym_CARET_EQ] = ACTIONS(797),
    [anon_sym_PIPE_EQ] = ACTIONS(797),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_var] = ACTIONS(799),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_fn] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_packed] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_opaque] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [anon_sym_error] = ACTIONS(799),
    [anon_sym_nosuspend] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_DOT_DOT] = ACTIONS(797),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(799),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_align] = ACTIONS(799),
    [anon_sym_addrspace] = ACTIONS(799),
    [anon_sym_linksection] = ACTIONS(799),
    [anon_sym_asm] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [anon_sym_RBRACK] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_DASH_PERCENT] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(799),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(797),
    [anon_sym_BANG_EQ] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(799),
    [anon_sym_GT_EQ] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_orelse] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(799),
    [anon_sym_LT_LT_PIPE] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_PLUS_PERCENT] = ACTIONS(799),
    [anon_sym_PLUS_PIPE] = ACTIONS(799),
    [anon_sym_DASH_PIPE] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_STAR_STAR] = ACTIONS(797),
    [anon_sym_STAR_PERCENT] = ACTIONS(799),
    [anon_sym_STAR_PIPE] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_resume] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_catch] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_anyframe] = ACTIONS(799),
    [anon_sym_unreachable] = ACTIONS(799),
    [anon_sym_undefined] = ACTIONS(799),
    [anon_sym_null] = ACTIONS(799),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_DOT_STAR] = ACTIONS(797),
    [anon_sym_DOT_QMARK] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(797),
    [aux_sym_multiline_string_token1] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [sym_integer] = ACTIONS(799),
    [sym_float] = ACTIONS(797),
    [anon_sym_true] = ACTIONS(799),
    [anon_sym_false] = ACTIONS(799),
    [anon_sym_bool] = ACTIONS(799),
    [anon_sym_f16] = ACTIONS(799),
    [anon_sym_f32] = ACTIONS(799),
    [anon_sym_f64] = ACTIONS(799),
    [anon_sym_f128] = ACTIONS(799),
    [anon_sym_void] = ACTIONS(799),
    [anon_sym_type] = ACTIONS(799),
    [anon_sym_anyerror] = ACTIONS(799),
    [anon_sym_anyopaque] = ACTIONS(799),
    [anon_sym_anytype] = ACTIONS(799),
    [anon_sym_noreturn] = ACTIONS(799),
    [anon_sym_isize] = ACTIONS(799),
    [anon_sym_usize] = ACTIONS(799),
    [anon_sym_comptime_int] = ACTIONS(799),
    [anon_sym_comptime_float] = ACTIONS(799),
    [anon_sym_c_short] = ACTIONS(799),
    [anon_sym_c_ushort] = ACTIONS(799),
    [anon_sym_c_int] = ACTIONS(799),
    [anon_sym_c_uint] = ACTIONS(799),
    [anon_sym_c_long] = ACTIONS(799),
    [anon_sym_c_ulong] = ACTIONS(799),
    [anon_sym_c_longlong] = ACTIONS(799),
    [anon_sym_c_ulonglong] = ACTIONS(799),
    [anon_sym_c_longdouble] = ACTIONS(799),
    [aux_sym_builtin_type_token1] = ACTIONS(799),
    [sym_builtin_identifier] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(275),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1363),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(225),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(886),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(254),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1093),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1008),
    [sym_if_type_expression] = STATE(1008),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(263),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1100),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1037),
    [sym_if_type_expression] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(215),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(887),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(278),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1367),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(245),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1088),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(237),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1073),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(280),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1352),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(216),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(873),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1673),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_calling_convention] = STATE(282),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1315),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_callconv] = ACTIONS(685),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(726),
    [sym_expression_statement] = STATE(726),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(253),
    [sym_expression] = STATE(1393),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym__variable_declaration_header] = STATE(1688),
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1394),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_const] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(21),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1230),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_switch_case] = STATE(1673),
    [sym__switch_case_exp] = STATE(1749),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(777),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(729),
    [sym_expression] = STATE(1235),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(735),
    [sym_expression] = STATE(1228),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(729),
    [sym_expression] = STATE(1231),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(597),
    [sym_expression] = STATE(940),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(607),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(955),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(638),
    [sym_expression] = STATE(953),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(346),
    [sym_expression] = STATE(956),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1333),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1711),
    [sym_if_type_expression] = STATE(1711),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1361),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1701),
    [sym_if_type_expression] = STATE(1701),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(887),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(873),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1378),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(805),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(739),
    [sym_expression] = STATE(1259),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(740),
    [sym_expression] = STATE(1260),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(359),
    [sym_expression] = STATE(929),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1323),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1703),
    [sym_if_type_expression] = STATE(1703),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1324),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1712),
    [sym_if_type_expression] = STATE(1712),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(898),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(912),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(744),
    [sym_expression_statement] = STATE(744),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1379),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(745),
    [sym_expression_statement] = STATE(745),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1393),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(747),
    [sym_expression_statement] = STATE(747),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1393),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(750),
    [sym_expression] = STATE(1232),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(735),
    [sym_expression] = STATE(1234),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(376),
    [sym_expression] = STATE(932),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(871),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(830),
    [sym_if_type_expression] = STATE(830),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(886),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(863),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(820),
    [sym_if_type_expression] = STATE(820),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(385),
    [sym_expression] = STATE(1375),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(858),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(811),
    [sym_if_type_expression] = STATE(811),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(392),
    [sym_expression] = STATE(1321),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1112),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(811),
    [sym_if_type_expression] = STATE(811),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(422),
    [sym_expression] = STATE(1279),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1073),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1334),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_field_initializer] = STATE(1569),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(428),
    [sym_expression] = STATE(1284),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(429),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1095),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(430),
    [sym_expression] = STATE(1287),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(432),
    [sym_expression] = STATE(1306),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1078),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1079),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(436),
    [sym_expression] = STATE(1261),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1082),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1083),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_payload] = STATE(438),
    [sym_expression] = STATE(1298),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1087),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(830),
    [sym_if_type_expression] = STATE(830),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1088),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(396),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1090),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(820),
    [sym_if_type_expression] = STATE(820),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1192),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1193),
    [sym_if_type_expression] = STATE(1193),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(471),
    [sym_expression] = STATE(1252),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1093),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1008),
    [sym_if_type_expression] = STATE(1008),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(387),
    [sym_expression] = STATE(961),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(480),
    [sym_expression] = STATE(1263),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(481),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1106),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(482),
    [sym_expression] = STATE(1265),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(664),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__block_expr_statement] = STATE(748),
    [sym_expression_statement] = STATE(748),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1393),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1502),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1096),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1027),
    [sym_if_type_expression] = STATE(1027),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1097),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1028),
    [sym_if_type_expression] = STATE(1028),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(972),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1506),
    [sym_if_type_expression] = STATE(1506),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(928),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1515),
    [sym_if_type_expression] = STATE(1515),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(487),
    [sym_expression] = STATE(1274),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1099),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1036),
    [sym_if_type_expression] = STATE(1036),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1100),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1037),
    [sym_if_type_expression] = STATE(1037),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(489),
    [sym_expression] = STATE(1282),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1101),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1048),
    [sym_if_type_expression] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1102),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1049),
    [sym_if_type_expression] = STATE(1049),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(440),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1103),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_comptime_type_expression] = STATE(1058),
    [sym_if_type_expression] = STATE(1058),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(687),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(948),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1508),
    [sym_if_type_expression] = STATE(1508),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(941),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1518),
    [sym_if_type_expression] = STATE(1518),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1383),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(819),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(821),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(823),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1345),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_field_initializer] = STATE(1622),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(521),
    [sym_expression] = STATE(914),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1363),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(531),
    [sym_expression] = STATE(890),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(532),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(876),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(533),
    [sym_expression] = STATE(852),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(535),
    [sym_expression] = STATE(849),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1367),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(847),
    [sym_if_type_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1352),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(799),
    [sym_if_type_expression] = STATE(799),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(539),
    [sym_expression] = STATE(860),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1315),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(837),
    [sym_if_type_expression] = STATE(837),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(923),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1480),
    [sym_if_type_expression] = STATE(1480),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1317),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(840),
    [sym_if_type_expression] = STATE(840),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_payload] = STATE(540),
    [sym_expression] = STATE(868),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1356),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(830),
    [sym_if_type_expression] = STATE(830),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1359),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(834),
    [sym_if_type_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(619),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1351),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(820),
    [sym_if_type_expression] = STATE(820),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(697),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1328),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1667),
    [sym_if_type_expression] = STATE(1667),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1215),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1216),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(561),
    [sym_expression] = STATE(1123),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(566),
    [sym_expression] = STATE(1125),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(567),
    [sym_expression] = STATE(1127),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(568),
    [sym_expression] = STATE(1132),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(570),
    [sym_expression] = STATE(1135),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_payload] = STATE(571),
    [sym_expression] = STATE(1138),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(589),
    [sym_expression] = STATE(1150),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(594),
    [sym_expression] = STATE(1152),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(336),
    [sym_expression] = STATE(1154),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(609),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1347),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1667),
    [sym_if_type_expression] = STATE(1667),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1215),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1216),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(803),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(595),
    [sym_expression] = STATE(1159),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(657),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(517),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(939),
    [sym_primary_type_expression] = STATE(973),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(1509),
    [sym_if_type_expression] = STATE(1509),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(982),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(979),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(817),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(598),
    [sym_expression] = STATE(1162),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_payload] = STATE(599),
    [sym_expression] = STATE(1165),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1386),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_COLON] = ACTIONS(833),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(835),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(498),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(875),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_comptime_type_expression] = STATE(792),
    [sym_if_type_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(695),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(611),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1212),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_payload] = STATE(621),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1212),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(739),
    [sym_expression] = STATE(1228),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(658),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym_block_expression] = STATE(723),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym__conditional_body] = STATE(740),
    [sym_expression] = STATE(1229),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1497),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_payload] = STATE(483),
    [sym_expression] = STATE(1269),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(839),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(851),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1362),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(855),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym__identifier] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_comptime] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_STAR_EQ] = ACTIONS(857),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(857),
    [anon_sym_SLASH_EQ] = ACTIONS(857),
    [anon_sym_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_PLUS_EQ] = ACTIONS(857),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(857),
    [anon_sym_DASH_EQ] = ACTIONS(857),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_AMP_EQ] = ACTIONS(857),
    [anon_sym_CARET_EQ] = ACTIONS(857),
    [anon_sym_PIPE_EQ] = ACTIONS(857),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_packed] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_opaque] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_error] = ACTIONS(859),
    [anon_sym_nosuspend] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_DOT_DOT] = ACTIONS(857),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_align] = ACTIONS(859),
    [anon_sym_addrspace] = ACTIONS(859),
    [anon_sym_linksection] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(859),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_DASH_PERCENT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_and] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_orelse] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_PLUS_PERCENT] = ACTIONS(859),
    [anon_sym_PLUS_PIPE] = ACTIONS(859),
    [anon_sym_DASH_PIPE] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_STAR_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_PIPE] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_resume] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_try] = ACTIONS(859),
    [anon_sym_catch] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_EQ_GT] = ACTIONS(857),
    [anon_sym_anyframe] = ACTIONS(859),
    [anon_sym_unreachable] = ACTIONS(859),
    [anon_sym_undefined] = ACTIONS(859),
    [anon_sym_null] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_DOT_STAR] = ACTIONS(857),
    [anon_sym_DOT_QMARK] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [aux_sym_multiline_string_token1] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [sym_integer] = ACTIONS(859),
    [sym_float] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_bool] = ACTIONS(859),
    [anon_sym_f16] = ACTIONS(859),
    [anon_sym_f32] = ACTIONS(859),
    [anon_sym_f64] = ACTIONS(859),
    [anon_sym_f128] = ACTIONS(859),
    [anon_sym_void] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_anyerror] = ACTIONS(859),
    [anon_sym_anyopaque] = ACTIONS(859),
    [anon_sym_anytype] = ACTIONS(859),
    [anon_sym_noreturn] = ACTIONS(859),
    [anon_sym_isize] = ACTIONS(859),
    [anon_sym_usize] = ACTIONS(859),
    [anon_sym_comptime_int] = ACTIONS(859),
    [anon_sym_comptime_float] = ACTIONS(859),
    [anon_sym_c_short] = ACTIONS(859),
    [anon_sym_c_ushort] = ACTIONS(859),
    [anon_sym_c_int] = ACTIONS(859),
    [anon_sym_c_uint] = ACTIONS(859),
    [anon_sym_c_long] = ACTIONS(859),
    [anon_sym_c_ulong] = ACTIONS(859),
    [anon_sym_c_longlong] = ACTIONS(859),
    [anon_sym_c_ulonglong] = ACTIONS(859),
    [anon_sym_c_longdouble] = ACTIONS(859),
    [aux_sym_builtin_type_token1] = ACTIONS(859),
    [sym_builtin_identifier] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(861),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1348),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1369),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(871),
    [sym__identifier] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_comptime] = ACTIONS(873),
    [anon_sym_COLON] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_extern] = ACTIONS(873),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_STAR_EQ] = ACTIONS(871),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(871),
    [anon_sym_SLASH_EQ] = ACTIONS(871),
    [anon_sym_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_PLUS_EQ] = ACTIONS(871),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(871),
    [anon_sym_DASH_EQ] = ACTIONS(871),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(871),
    [anon_sym_LT_LT_EQ] = ACTIONS(871),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(871),
    [anon_sym_GT_GT_EQ] = ACTIONS(871),
    [anon_sym_AMP_EQ] = ACTIONS(871),
    [anon_sym_CARET_EQ] = ACTIONS(871),
    [anon_sym_PIPE_EQ] = ACTIONS(871),
    [anon_sym_inline] = ACTIONS(873),
    [anon_sym_fn] = ACTIONS(873),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_packed] = ACTIONS(873),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_opaque] = ACTIONS(873),
    [anon_sym_enum] = ACTIONS(873),
    [anon_sym_union] = ACTIONS(873),
    [anon_sym_error] = ACTIONS(873),
    [anon_sym_nosuspend] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_DOT_DOT] = ACTIONS(871),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(873),
    [anon_sym_align] = ACTIONS(873),
    [anon_sym_addrspace] = ACTIONS(873),
    [anon_sym_linksection] = ACTIONS(873),
    [anon_sym_asm] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(871),
    [anon_sym_RBRACK] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_DASH_PERCENT] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(873),
    [anon_sym_orelse] = ACTIONS(873),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(873),
    [anon_sym_LT_LT_PIPE] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_PLUS_PERCENT] = ACTIONS(873),
    [anon_sym_PLUS_PIPE] = ACTIONS(873),
    [anon_sym_DASH_PIPE] = ACTIONS(873),
    [anon_sym_SLASH] = ACTIONS(873),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_STAR_PERCENT] = ACTIONS(873),
    [anon_sym_STAR_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_async] = ACTIONS(873),
    [anon_sym_await] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_resume] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_catch] = ACTIONS(873),
    [anon_sym_switch] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(871),
    [anon_sym_anyframe] = ACTIONS(873),
    [anon_sym_unreachable] = ACTIONS(873),
    [anon_sym_undefined] = ACTIONS(873),
    [anon_sym_null] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_DOT_STAR] = ACTIONS(871),
    [anon_sym_DOT_QMARK] = ACTIONS(871),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [aux_sym_multiline_string_token1] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(871),
    [sym_integer] = ACTIONS(873),
    [sym_float] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [anon_sym_bool] = ACTIONS(873),
    [anon_sym_f16] = ACTIONS(873),
    [anon_sym_f32] = ACTIONS(873),
    [anon_sym_f64] = ACTIONS(873),
    [anon_sym_f128] = ACTIONS(873),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_type] = ACTIONS(873),
    [anon_sym_anyerror] = ACTIONS(873),
    [anon_sym_anyopaque] = ACTIONS(873),
    [anon_sym_anytype] = ACTIONS(873),
    [anon_sym_noreturn] = ACTIONS(873),
    [anon_sym_isize] = ACTIONS(873),
    [anon_sym_usize] = ACTIONS(873),
    [anon_sym_comptime_int] = ACTIONS(873),
    [anon_sym_comptime_float] = ACTIONS(873),
    [anon_sym_c_short] = ACTIONS(873),
    [anon_sym_c_ushort] = ACTIONS(873),
    [anon_sym_c_int] = ACTIONS(873),
    [anon_sym_c_uint] = ACTIONS(873),
    [anon_sym_c_long] = ACTIONS(873),
    [anon_sym_c_ulong] = ACTIONS(873),
    [anon_sym_c_longlong] = ACTIONS(873),
    [anon_sym_c_ulonglong] = ACTIONS(873),
    [anon_sym_c_longdouble] = ACTIONS(873),
    [aux_sym_builtin_type_token1] = ACTIONS(873),
    [sym_builtin_identifier] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1376),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1332),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(379),
    [sym__while_prefix] = STATE(380),
    [sym_expression] = STATE(1236),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1318),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1376),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(895),
    [sym__identifier] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_comptime] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(897),
    [anon_sym_extern] = ACTIONS(897),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_STAR_EQ] = ACTIONS(895),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(895),
    [anon_sym_SLASH_EQ] = ACTIONS(895),
    [anon_sym_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_PLUS_EQ] = ACTIONS(895),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(895),
    [anon_sym_DASH_EQ] = ACTIONS(895),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(895),
    [anon_sym_LT_LT_EQ] = ACTIONS(895),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(895),
    [anon_sym_GT_GT_EQ] = ACTIONS(895),
    [anon_sym_AMP_EQ] = ACTIONS(895),
    [anon_sym_CARET_EQ] = ACTIONS(895),
    [anon_sym_PIPE_EQ] = ACTIONS(895),
    [anon_sym_inline] = ACTIONS(897),
    [anon_sym_fn] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_packed] = ACTIONS(897),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_opaque] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_union] = ACTIONS(897),
    [anon_sym_error] = ACTIONS(897),
    [anon_sym_nosuspend] = ACTIONS(897),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_align] = ACTIONS(897),
    [anon_sym_addrspace] = ACTIONS(897),
    [anon_sym_linksection] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_RBRACK] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_DASH_PERCENT] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_orelse] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_LT_LT_PIPE] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_PLUS_PERCENT] = ACTIONS(897),
    [anon_sym_PLUS_PIPE] = ACTIONS(897),
    [anon_sym_DASH_PIPE] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_STAR_PERCENT] = ACTIONS(897),
    [anon_sym_STAR_PIPE] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_resume] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_catch] = ACTIONS(897),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(895),
    [anon_sym_anyframe] = ACTIONS(897),
    [anon_sym_unreachable] = ACTIONS(897),
    [anon_sym_undefined] = ACTIONS(897),
    [anon_sym_null] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(897),
    [anon_sym_DOT_STAR] = ACTIONS(895),
    [anon_sym_DOT_QMARK] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [aux_sym_multiline_string_token1] = ACTIONS(895),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [sym_integer] = ACTIONS(897),
    [sym_float] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(897),
    [anon_sym_false] = ACTIONS(897),
    [anon_sym_bool] = ACTIONS(897),
    [anon_sym_f16] = ACTIONS(897),
    [anon_sym_f32] = ACTIONS(897),
    [anon_sym_f64] = ACTIONS(897),
    [anon_sym_f128] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_anyerror] = ACTIONS(897),
    [anon_sym_anyopaque] = ACTIONS(897),
    [anon_sym_anytype] = ACTIONS(897),
    [anon_sym_noreturn] = ACTIONS(897),
    [anon_sym_isize] = ACTIONS(897),
    [anon_sym_usize] = ACTIONS(897),
    [anon_sym_comptime_int] = ACTIONS(897),
    [anon_sym_comptime_float] = ACTIONS(897),
    [anon_sym_c_short] = ACTIONS(897),
    [anon_sym_c_ushort] = ACTIONS(897),
    [anon_sym_c_int] = ACTIONS(897),
    [anon_sym_c_uint] = ACTIONS(897),
    [anon_sym_c_long] = ACTIONS(897),
    [anon_sym_c_ulong] = ACTIONS(897),
    [anon_sym_c_longlong] = ACTIONS(897),
    [anon_sym_c_ulonglong] = ACTIONS(897),
    [anon_sym_c_longdouble] = ACTIONS(897),
    [aux_sym_builtin_type_token1] = ACTIONS(897),
    [sym_builtin_identifier] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1376),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1161),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1388),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1437),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1353),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1355),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1392),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1401),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1368),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1313),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1409),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(931),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1413),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(865),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(874),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(965),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(966),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(939),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1447),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(864),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(963),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1385),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(927),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(952),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(934),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1314),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1325),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1397),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1330),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1335),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1412),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1417),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(969),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1415),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(974),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1449),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(903),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1418),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1376),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1404),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1427),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1343),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(945),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1410),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1411),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1254),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1255),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1350),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1336),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1430),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1312),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1373),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1320),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(926),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1384),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1349),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1420),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1380),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1331),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1293),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1296),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1428),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1422),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1091),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1226),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1227),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1450),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1063),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1292),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1217),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1270),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1225),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1000),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1237),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1438),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1243),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1208),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1258),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1271),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1276),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1277),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1278),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1311),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1007),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1303),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(917),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(950),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(970),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1018),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1285),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1300),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1301),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1302),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1305),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1431),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1434),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1246),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1098),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1253),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1432),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1262),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(936),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1453),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1042),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1297),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1299),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1436),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1304),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1358),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1429),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1105),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1309),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1218),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1452),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1104),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1239),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [445] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1240),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(938),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1286),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1308),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(885),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1374),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(951),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1069),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1244),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(967),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1245),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1071),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1247),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1248),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1249),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1250),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1251),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1256),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(933),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(942),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(944),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1077),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1396),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(949),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1264),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1377),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1310),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1266),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1267),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1268),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(919),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1338),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(964),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1426),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1414),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1272),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1107),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1273),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1275),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1419),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1086),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1280),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1283),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1327),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1288),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1281),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1110),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1111),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1110),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1219),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1220),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1221),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1439),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1224),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(962),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(851),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(907),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(908),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(889),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(879),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(880),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(892),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(906),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1389),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(891),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(893),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(885),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(894),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(895),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(896),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(910),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(911),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(916),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1391),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(962),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(922),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1398),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1435),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(918),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(853),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(857),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(859),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(867),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(935),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(971),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1402),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(937),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1381),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1406),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(854),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(884),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(856),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1407),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(861),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1405),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1416),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(866),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(869),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(870),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(874),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(883),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1201),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1204),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1175),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1176),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1113),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1114),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1178),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1179),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1116),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1117),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1208),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1118),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1119),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1120),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1121),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1122),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1124),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1126),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1128),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1129),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1130),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1131),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(962),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1133),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1134),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1136),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1137),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1139),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [571] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1140),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [572] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1206),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1207),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1141),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1142),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1197),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [577] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1205),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [578] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1144),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1145),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [580] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1071),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [581] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1146),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1147),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1148),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [584] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(989),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [585] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1149),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1151),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1153),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1357),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1155),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1156),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1157),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1158),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1408),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1160),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [595] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1163),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1164),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(947),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [598] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1166),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1167),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [600] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(924),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [601] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(897),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [602] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1110),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1111),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [603] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(874),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [604] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(900),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [605] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(901),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [606] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(902),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [607] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(954),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [608] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(905),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [609] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(962),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1238),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [610] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1209),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [611] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1214),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [612] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1168),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [613] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(505),
    [sym__for_prefix] = STATE(499),
    [sym__while_prefix] = STATE(500),
    [sym_expression] = STATE(874),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(883),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1498),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(111),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(117),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_DASH] = ACTIONS(127),
    [anon_sym_DASH_PERCENT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(125),
    [anon_sym_async] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_try] = ACTIONS(139),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [614] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1110),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [615] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1169),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [616] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1170),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [617] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1171),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [618] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1174),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [619] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(962),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1307),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [620] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(959),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1209),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [621] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1454),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1214),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [622] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1289),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [623] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(549),
    [sym__for_prefix] = STATE(544),
    [sym__while_prefix] = STATE(545),
    [sym_expression] = STATE(1110),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1111),
    [sym_primary_type_expression] = STATE(778),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1503),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(305),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(307),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_DASH_PERCENT] = ACTIONS(313),
    [anon_sym_AMP] = ACTIONS(313),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_await] = ACTIONS(319),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(323),
    [anon_sym_break] = ACTIONS(325),
    [anon_sym_try] = ACTIONS(327),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1189),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1290),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [626] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1291),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(983),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [627] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1198),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [628] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(448),
    [sym__for_prefix] = STATE(441),
    [sym__while_prefix] = STATE(442),
    [sym_expression] = STATE(1189),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1190),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1504),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(163),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(169),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(187),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(197),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DASH_PERCENT] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(197),
    [anon_sym_async] = ACTIONS(201),
    [anon_sym_await] = ACTIONS(203),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(207),
    [anon_sym_return] = ACTIONS(209),
    [anon_sym_break] = ACTIONS(211),
    [anon_sym_try] = ACTIONS(213),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [629] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1189),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [630] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1199),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1200),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1184),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [632] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1421),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1190),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [633] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(1182),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(577),
    [sym__for_prefix] = STATE(572),
    [sym__while_prefix] = STATE(573),
    [sym_expression] = STATE(1189),
    [sym_asm_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_comptime_expression] = STATE(1182),
    [sym_async_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_nosuspend_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_resume_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_break_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_catch_expression] = STATE(1182),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1190),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1500),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(243),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(245),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(247),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(191),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_DASH_PERCENT] = ACTIONS(251),
    [anon_sym_AMP] = ACTIONS(251),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [anon_sym_continue] = ACTIONS(205),
    [anon_sym_resume] = ACTIONS(259),
    [anon_sym_return] = ACTIONS(261),
    [anon_sym_break] = ACTIONS(263),
    [anon_sym_try] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [634] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1433),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [635] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1340),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [636] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1390),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [637] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1382),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [638] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(960),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [639] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(403),
    [sym__for_prefix] = STATE(397),
    [sym__while_prefix] = STATE(398),
    [sym_expression] = STATE(1326),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(1108),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1505),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(1186),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(1187),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(267),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_fn] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_DASH] = ACTIONS(283),
    [anon_sym_DASH_PERCENT] = ACTIONS(281),
    [anon_sym_AMP] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_await] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_break] = ACTIONS(293),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(297),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(299),
    [anon_sym_null] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(303),
    [anon_sym_false] = ACTIONS(303),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [640] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1399),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [641] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1400),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [642] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1403),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [643] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1442),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [644] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1395),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [645] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1423),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [646] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1424),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [647] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1425),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1440),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [649] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1441),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [650] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1387),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [651] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1443),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(907),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [652] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1444),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [653] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1445),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [654] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1446),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(909),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [655] = {
    [sym__function_prototype] = STATE(807),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(780),
    [sym_opaque_declaration] = STATE(780),
    [sym_enum_declaration] = STATE(780),
    [sym_union_declaration] = STATE(780),
    [sym_error_set_declaration] = STATE(833),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1448),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(780),
    [sym_type_expression] = STATE(872),
    [sym_primary_type_expression] = STATE(776),
    [sym_nullable_type] = STATE(780),
    [sym_anyframe_type] = STATE(780),
    [sym_slice_type] = STATE(780),
    [sym_pointer_type] = STATE(780),
    [sym_array_type] = STATE(780),
    [sym_error_union_type] = STATE(780),
    [sym_field_expression] = STATE(780),
    [sym_index_expression] = STATE(780),
    [sym_dereference_expression] = STATE(780),
    [sym_null_coercion_expression] = STATE(780),
    [sym_range_expression] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_anonymous_struct_initializer] = STATE(833),
    [sym_struct_initializer] = STATE(833),
    [sym_labeled_type_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_block_label] = STATE(1501),
    [sym_builtin_function] = STATE(780),
    [sym_string] = STATE(780),
    [sym_multiline_string] = STATE(780),
    [sym_character] = STATE(780),
    [sym_boolean] = STATE(780),
    [sym_builtin_type] = STATE(838),
    [sym_error_type] = STATE(780),
    [sym_identifier] = STATE(841),
    [sym__reserved_identifier] = STATE(316),
    [aux_sym_multiline_string_repeat1] = STATE(775),
    [sym__identifier] = ACTIONS(7),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(27),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(37),
    [anon_sym_opaque] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_union] = ACTIONS(43),
    [anon_sym_error] = ACTIONS(45),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BANG] = ACTIONS(61),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_anyframe] = ACTIONS(83),
    [anon_sym_unreachable] = ACTIONS(85),
    [anon_sym_undefined] = ACTIONS(87),
    [anon_sym_null] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(93),
    [aux_sym_multiline_string_token1] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_integer] = ACTIONS(85),
    [sym_float] = ACTIONS(99),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_bool] = ACTIONS(103),
    [anon_sym_f16] = ACTIONS(103),
    [anon_sym_f32] = ACTIONS(103),
    [anon_sym_f64] = ACTIONS(103),
    [anon_sym_f128] = ACTIONS(103),
    [anon_sym_void] = ACTIONS(103),
    [anon_sym_type] = ACTIONS(103),
    [anon_sym_anyerror] = ACTIONS(103),
    [anon_sym_anyopaque] = ACTIONS(103),
    [anon_sym_anytype] = ACTIONS(103),
    [anon_sym_noreturn] = ACTIONS(103),
    [anon_sym_isize] = ACTIONS(103),
    [anon_sym_usize] = ACTIONS(103),
    [anon_sym_comptime_int] = ACTIONS(103),
    [anon_sym_comptime_float] = ACTIONS(103),
    [anon_sym_c_short] = ACTIONS(103),
    [anon_sym_c_ushort] = ACTIONS(103),
    [anon_sym_c_int] = ACTIONS(103),
    [anon_sym_c_uint] = ACTIONS(103),
    [anon_sym_c_long] = ACTIONS(103),
    [anon_sym_c_ulong] = ACTIONS(103),
    [anon_sym_c_longlong] = ACTIONS(103),
    [anon_sym_c_ulonglong] = ACTIONS(103),
    [anon_sym_c_longdouble] = ACTIONS(103),
    [aux_sym_builtin_type_token1] = ACTIONS(103),
    [sym_builtin_identifier] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [sym__function_prototype] = STATE(1185),
    [sym_block] = STATE(821),
    [sym_struct_declaration] = STATE(1177),
    [sym_opaque_declaration] = STATE(1177),
    [sym_enum_declaration] = STATE(1177),
    [sym_union_declaration] = STATE(1177),
    [sym_error_set_declaration] = STATE(1183),
    [sym__if_prefix] = STATE(565),
    [sym__for_prefix] = STATE(526),
    [sym__while_prefix] = STATE(600),
    [sym_expression] = STATE(1451),
    [sym_asm_expression] = STATE(821),
    [sym_if_expression] = STATE(821),
    [sym_for_expression] = STATE(821),
    [sym_while_expression] = STATE(821),
    [sym_assignment_expression] = STATE(821),
    [sym_unary_expression] = STATE(821),
    [sym_binary_expression] = STATE(821),
    [sym_comptime_expression] = STATE(821),
    [sym_async_expression] = STATE(821),
    [sym_await_expression] = STATE(821),
    [sym_nosuspend_expression] = STATE(821),
    [sym_continue_expression] = STATE(821),
    [sym_resume_expression] = STATE(821),
    [sym_return_expression] = STATE(821),
    [sym_break_expression] = STATE(821),
    [sym_try_expression] = STATE(821),
    [sym_catch_expression] = STATE(821),
    [sym_switch_expression] = STATE(1177),
    [sym_type_expression] = STATE(1072),
    [sym_primary_type_expression] = STATE(981),
    [sym_nullable_type] = STATE(1177),
    [sym_anyframe_type] = STATE(1177),
    [sym_slice_type] = STATE(1177),
    [sym_pointer_type] = STATE(1177),
    [sym_array_type] = STATE(1177),
    [sym_error_union_type] = STATE(1177),
    [sym_field_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_dereference_expression] = STATE(1177),
    [sym_null_coercion_expression] = STATE(1177),
    [sym_range_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_anonymous_struct_initializer] = STATE(1183),
    [sym_struct_initializer] = STATE(1183),
    [sym_labeled_type_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_block_label] = STATE(1499),
    [sym_builtin_function] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_multiline_string] = STATE(1177),
    [sym_character] = STATE(1177),
    [sym_boolean] = STATE(1177),
    [sym_builtin_type] = STATE(986),
    [sym_error_type] = STATE(1177),
    [sym_identifier] = STATE(977),
    [sym__reserved_identifier] = STATE(665),
    [aux_sym_multiline_string_repeat1] = STATE(925),
    [sym__identifier] = ACTIONS(161),
    [anon_sym_comptime] = ACTIONS(155),
    [anon_sym_extern] = ACTIONS(167),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_packed] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_opaque] = ACTIONS(179),
    [anon_sym_enum] = ACTIONS(181),
    [anon_sym_union] = ACTIONS(183),
    [anon_sym_error] = ACTIONS(185),
    [anon_sym_nosuspend] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_asm] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(691),
    [anon_sym_TILDE] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_DASH_PERCENT] = ACTIONS(63),
    [anon_sym_AMP] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(67),
    [anon_sym_await] = ACTIONS(69),
    [anon_sym_continue] = ACTIONS(71),
    [anon_sym_resume] = ACTIONS(73),
    [anon_sym_return] = ACTIONS(75),
    [anon_sym_break] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(215),
    [anon_sym_anyframe] = ACTIONS(217),
    [anon_sym_unreachable] = ACTIONS(219),
    [anon_sym_undefined] = ACTIONS(221),
    [anon_sym_null] = ACTIONS(221),
    [anon_sym_QMARK] = ACTIONS(223),
    [anon_sym_DOT] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(227),
    [aux_sym_multiline_string_token1] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_bool] = ACTIONS(237),
    [anon_sym_f16] = ACTIONS(237),
    [anon_sym_f32] = ACTIONS(237),
    [anon_sym_f64] = ACTIONS(237),
    [anon_sym_f128] = ACTIONS(237),
    [anon_sym_void] = ACTIONS(237),
    [anon_sym_type] = ACTIONS(237),
    [anon_sym_anyerror] = ACTIONS(237),
    [anon_sym_anyopaque] = ACTIONS(237),
    [anon_sym_anytype] = ACTIONS(237),
    [anon_sym_noreturn] = ACTIONS(237),
    [anon_sym_isize] = ACTIONS(237),
    [anon_sym_usize] = ACTIONS(237),
    [anon_sym_comptime_int] = ACTIONS(237),
    [anon_sym_comptime_float] = ACTIONS(237),
    [anon_sym_c_short] = ACTIONS(237),
    [anon_sym_c_ushort] = ACTIONS(237),
    [anon_sym_c_int] = ACTIONS(237),
    [anon_sym_c_uint] = ACTIONS(237),
    [anon_sym_c_long] = ACTIONS(237),
    [anon_sym_c_ulong] = ACTIONS(237),
    [anon_sym_c_longlong] = ACTIONS(237),
    [anon_sym_c_ulonglong] = ACTIONS(237),
    [anon_sym_c_longdouble] = ACTIONS(237),
    [aux_sym_builtin_type_token1] = ACTIONS(237),
    [sym_builtin_identifier] = ACTIONS(239),
    [anon_sym_AT] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(911),
    [sym__identifier] = ACTIONS(913),
    [anon_sym_pub] = ACTIONS(913),
    [anon_sym_test] = ACTIONS(913),
    [anon_sym_comptime] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_extern] = ACTIONS(913),
    [anon_sym_threadlocal] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_const] = ACTIONS(913),
    [anon_sym_var] = ACTIONS(913),
    [anon_sym_inline] = ACTIONS(913),
    [anon_sym_noinline] = ACTIONS(913),
    [anon_sym_fn] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_usingnamespace] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_packed] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(913),
    [anon_sym_opaque] = ACTIONS(913),
    [anon_sym_enum] = ACTIONS(913),
    [anon_sym_union] = ACTIONS(913),
    [anon_sym_error] = ACTIONS(913),
    [anon_sym_nosuspend] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_for] = ACTIONS(913),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_asm] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_DASH_PERCENT] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(913),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_async] = ACTIONS(913),
    [anon_sym_await] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(913),
    [anon_sym_resume] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(913),
    [anon_sym_catch] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(913),
    [anon_sym_anyframe] = ACTIONS(913),
    [anon_sym_unreachable] = ACTIONS(913),
    [anon_sym_undefined] = ACTIONS(913),
    [anon_sym_null] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [anon_sym_DQUOTE] = ACTIONS(911),
    [aux_sym_multiline_string_token1] = ACTIONS(911),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [sym_integer] = ACTIONS(913),
    [sym_float] = ACTIONS(911),
    [anon_sym_true] = ACTIONS(913),
    [anon_sym_false] = ACTIONS(913),
    [anon_sym_bool] = ACTIONS(913),
    [anon_sym_f16] = ACTIONS(913),
    [anon_sym_f32] = ACTIONS(913),
    [anon_sym_f64] = ACTIONS(913),
    [anon_sym_f128] = ACTIONS(913),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_anyerror] = ACTIONS(913),
    [anon_sym_anyopaque] = ACTIONS(913),
    [anon_sym_anytype] = ACTIONS(913),
    [anon_sym_noreturn] = ACTIONS(913),
    [anon_sym_isize] = ACTIONS(913),
    [anon_sym_usize] = ACTIONS(913),
    [anon_sym_comptime_int] = ACTIONS(913),
    [anon_sym_comptime_float] = ACTIONS(913),
    [anon_sym_c_short] = ACTIONS(913),
    [anon_sym_c_ushort] = ACTIONS(913),
    [anon_sym_c_int] = ACTIONS(913),
    [anon_sym_c_uint] = ACTIONS(913),
    [anon_sym_c_long] = ACTIONS(913),
    [anon_sym_c_ulong] = ACTIONS(913),
    [anon_sym_c_longlong] = ACTIONS(913),
    [anon_sym_c_ulonglong] = ACTIONS(913),
    [anon_sym_c_longdouble] = ACTIONS(913),
    [aux_sym_builtin_type_token1] = ACTIONS(913),
    [sym_builtin_identifier] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
  },
  [658] = {
    [sym__identifier] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_comptime] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_extern] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_const] = ACTIONS(919),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_inline] = ACTIONS(919),
    [anon_sym_fn] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(921),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_packed] = ACTIONS(919),
    [anon_sym_struct] = ACTIONS(919),
    [anon_sym_opaque] = ACTIONS(919),
    [anon_sym_enum] = ACTIONS(919),
    [anon_sym_union] = ACTIONS(919),
    [anon_sym_error] = ACTIONS(919),
    [anon_sym_nosuspend] = ACTIONS(919),
    [anon_sym_suspend] = ACTIONS(919),
    [anon_sym_defer] = ACTIONS(919),
    [anon_sym_errdefer] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_asm] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_DASH_PERCENT] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_async] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_resume] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_catch] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(919),
    [anon_sym_anyframe] = ACTIONS(919),
    [anon_sym_unreachable] = ACTIONS(919),
    [anon_sym_undefined] = ACTIONS(919),
    [anon_sym_null] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_DOT] = ACTIONS(919),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [anon_sym_DQUOTE] = ACTIONS(921),
    [aux_sym_multiline_string_token1] = ACTIONS(921),
    [anon_sym_SQUOTE] = ACTIONS(921),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(921),
    [anon_sym_true] = ACTIONS(919),
    [anon_sym_false] = ACTIONS(919),
    [anon_sym_bool] = ACTIONS(919),
    [anon_sym_f16] = ACTIONS(919),
    [anon_sym_f32] = ACTIONS(919),
    [anon_sym_f64] = ACTIONS(919),
    [anon_sym_f128] = ACTIONS(919),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_anyerror] = ACTIONS(919),
    [anon_sym_anyopaque] = ACTIONS(919),
    [anon_sym_anytype] = ACTIONS(919),
    [anon_sym_noreturn] = ACTIONS(919),
    [anon_sym_isize] = ACTIONS(919),
    [anon_sym_usize] = ACTIONS(919),
    [anon_sym_comptime_int] = ACTIONS(919),
    [anon_sym_comptime_float] = ACTIONS(919),
    [anon_sym_c_short] = ACTIONS(919),
    [anon_sym_c_ushort] = ACTIONS(919),
    [anon_sym_c_int] = ACTIONS(919),
    [anon_sym_c_uint] = ACTIONS(919),
    [anon_sym_c_long] = ACTIONS(919),
    [anon_sym_c_ulong] = ACTIONS(919),
    [anon_sym_c_longlong] = ACTIONS(919),
    [anon_sym_c_ulonglong] = ACTIONS(919),
    [anon_sym_c_longdouble] = ACTIONS(919),
    [aux_sym_builtin_type_token1] = ACTIONS(919),
    [sym_builtin_identifier] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
  },
  [659] = {
    [sym__identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_comptime] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_extern] = ACTIONS(923),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_STAR_EQ] = ACTIONS(925),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(925),
    [anon_sym_SLASH_EQ] = ACTIONS(925),
    [anon_sym_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(925),
    [anon_sym_DASH_EQ] = ACTIONS(925),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(925),
    [anon_sym_GT_GT_EQ] = ACTIONS(925),
    [anon_sym_AMP_EQ] = ACTIONS(925),
    [anon_sym_CARET_EQ] = ACTIONS(925),
    [anon_sym_PIPE_EQ] = ACTIONS(925),
    [anon_sym_const] = ACTIONS(923),
    [anon_sym_var] = ACTIONS(923),
    [anon_sym_inline] = ACTIONS(923),
    [anon_sym_fn] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(929),
    [anon_sym_packed] = ACTIONS(923),
    [anon_sym_struct] = ACTIONS(923),
    [anon_sym_opaque] = ACTIONS(923),
    [anon_sym_enum] = ACTIONS(923),
    [anon_sym_union] = ACTIONS(923),
    [anon_sym_error] = ACTIONS(923),
    [anon_sym_nosuspend] = ACTIONS(923),
    [anon_sym_suspend] = ACTIONS(923),
    [anon_sym_defer] = ACTIONS(923),
    [anon_sym_errdefer] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_asm] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(923),
    [anon_sym_DASH_PERCENT] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(923),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_resume] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_catch] = ACTIONS(927),
    [anon_sym_switch] = ACTIONS(923),
    [anon_sym_anyframe] = ACTIONS(923),
    [anon_sym_unreachable] = ACTIONS(923),
    [anon_sym_undefined] = ACTIONS(923),
    [anon_sym_null] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(923),
    [anon_sym_DOT_STAR] = ACTIONS(925),
    [anon_sym_DOT_QMARK] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [aux_sym_multiline_string_token1] = ACTIONS(929),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer] = ACTIONS(923),
    [sym_float] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(923),
    [anon_sym_false] = ACTIONS(923),
    [anon_sym_bool] = ACTIONS(923),
    [anon_sym_f16] = ACTIONS(923),
    [anon_sym_f32] = ACTIONS(923),
    [anon_sym_f64] = ACTIONS(923),
    [anon_sym_f128] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_type] = ACTIONS(923),
    [anon_sym_anyerror] = ACTIONS(923),
    [anon_sym_anyopaque] = ACTIONS(923),
    [anon_sym_anytype] = ACTIONS(923),
    [anon_sym_noreturn] = ACTIONS(923),
    [anon_sym_isize] = ACTIONS(923),
    [anon_sym_usize] = ACTIONS(923),
    [anon_sym_comptime_int] = ACTIONS(923),
    [anon_sym_comptime_float] = ACTIONS(923),
    [anon_sym_c_short] = ACTIONS(923),
    [anon_sym_c_ushort] = ACTIONS(923),
    [anon_sym_c_int] = ACTIONS(923),
    [anon_sym_c_uint] = ACTIONS(923),
    [anon_sym_c_long] = ACTIONS(923),
    [anon_sym_c_ulong] = ACTIONS(923),
    [anon_sym_c_longlong] = ACTIONS(923),
    [anon_sym_c_ulonglong] = ACTIONS(923),
    [anon_sym_c_longdouble] = ACTIONS(923),
    [aux_sym_builtin_type_token1] = ACTIONS(923),
    [sym_builtin_identifier] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
  },
  [660] = {
    [sym__identifier] = ACTIONS(931),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_comptime] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_extern] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_const] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_inline] = ACTIONS(931),
    [anon_sym_fn] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_LBRACE] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_packed] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(931),
    [anon_sym_opaque] = ACTIONS(931),
    [anon_sym_enum] = ACTIONS(931),
    [anon_sym_union] = ACTIONS(931),
    [anon_sym_error] = ACTIONS(931),
    [anon_sym_nosuspend] = ACTIONS(931),
    [anon_sym_suspend] = ACTIONS(931),
    [anon_sym_defer] = ACTIONS(931),
    [anon_sym_errdefer] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_asm] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_DASH_PERCENT] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_await] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_resume] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_catch] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(931),
    [anon_sym_anyframe] = ACTIONS(931),
    [anon_sym_unreachable] = ACTIONS(931),
    [anon_sym_undefined] = ACTIONS(931),
    [anon_sym_null] = ACTIONS(931),
    [anon_sym_QMARK] = ACTIONS(933),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [aux_sym_multiline_string_token1] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_integer] = ACTIONS(931),
    [sym_float] = ACTIONS(933),
    [anon_sym_true] = ACTIONS(931),
    [anon_sym_false] = ACTIONS(931),
    [anon_sym_bool] = ACTIONS(931),
    [anon_sym_f16] = ACTIONS(931),
    [anon_sym_f32] = ACTIONS(931),
    [anon_sym_f64] = ACTIONS(931),
    [anon_sym_f128] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(931),
    [anon_sym_anyerror] = ACTIONS(931),
    [anon_sym_anyopaque] = ACTIONS(931),
    [anon_sym_anytype] = ACTIONS(931),
    [anon_sym_noreturn] = ACTIONS(931),
    [anon_sym_isize] = ACTIONS(931),
    [anon_sym_usize] = ACTIONS(931),
    [anon_sym_comptime_int] = ACTIONS(931),
    [anon_sym_comptime_float] = ACTIONS(931),
    [anon_sym_c_short] = ACTIONS(931),
    [anon_sym_c_ushort] = ACTIONS(931),
    [anon_sym_c_int] = ACTIONS(931),
    [anon_sym_c_uint] = ACTIONS(931),
    [anon_sym_c_long] = ACTIONS(931),
    [anon_sym_c_ulong] = ACTIONS(931),
    [anon_sym_c_longlong] = ACTIONS(931),
    [anon_sym_c_ulonglong] = ACTIONS(931),
    [anon_sym_c_longdouble] = ACTIONS(931),
    [aux_sym_builtin_type_token1] = ACTIONS(931),
    [sym_builtin_identifier] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
  },
  [661] = {
    [sym__identifier] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_comptime] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_extern] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_STAR_EQ] = ACTIONS(925),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(925),
    [anon_sym_SLASH_EQ] = ACTIONS(925),
    [anon_sym_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(925),
    [anon_sym_DASH_EQ] = ACTIONS(925),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(925),
    [anon_sym_GT_GT_EQ] = ACTIONS(925),
    [anon_sym_AMP_EQ] = ACTIONS(925),
    [anon_sym_CARET_EQ] = ACTIONS(925),
    [anon_sym_PIPE_EQ] = ACTIONS(925),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_var] = ACTIONS(935),
    [anon_sym_inline] = ACTIONS(935),
    [anon_sym_fn] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_packed] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(935),
    [anon_sym_opaque] = ACTIONS(935),
    [anon_sym_enum] = ACTIONS(935),
    [anon_sym_union] = ACTIONS(935),
    [anon_sym_error] = ACTIONS(935),
    [anon_sym_nosuspend] = ACTIONS(935),
    [anon_sym_suspend] = ACTIONS(935),
    [anon_sym_defer] = ACTIONS(935),
    [anon_sym_errdefer] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_asm] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_DASH_PERCENT] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_await] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_resume] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_catch] = ACTIONS(927),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_anyframe] = ACTIONS(935),
    [anon_sym_unreachable] = ACTIONS(935),
    [anon_sym_undefined] = ACTIONS(935),
    [anon_sym_null] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_DOT_STAR] = ACTIONS(925),
    [anon_sym_DOT_QMARK] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(937),
    [aux_sym_multiline_string_token1] = ACTIONS(937),
    [anon_sym_SQUOTE] = ACTIONS(937),
    [sym_integer] = ACTIONS(935),
    [sym_float] = ACTIONS(937),
    [anon_sym_true] = ACTIONS(935),
    [anon_sym_false] = ACTIONS(935),
    [anon_sym_bool] = ACTIONS(935),
    [anon_sym_f16] = ACTIONS(935),
    [anon_sym_f32] = ACTIONS(935),
    [anon_sym_f64] = ACTIONS(935),
    [anon_sym_f128] = ACTIONS(935),
    [anon_sym_void] = ACTIONS(935),
    [anon_sym_type] = ACTIONS(935),
    [anon_sym_anyerror] = ACTIONS(935),
    [anon_sym_anyopaque] = ACTIONS(935),
    [anon_sym_anytype] = ACTIONS(935),
    [anon_sym_noreturn] = ACTIONS(935),
    [anon_sym_isize] = ACTIONS(935),
    [anon_sym_usize] = ACTIONS(935),
    [anon_sym_comptime_int] = ACTIONS(935),
    [anon_sym_comptime_float] = ACTIONS(935),
    [anon_sym_c_short] = ACTIONS(935),
    [anon_sym_c_ushort] = ACTIONS(935),
    [anon_sym_c_int] = ACTIONS(935),
    [anon_sym_c_uint] = ACTIONS(935),
    [anon_sym_c_long] = ACTIONS(935),
    [anon_sym_c_ulong] = ACTIONS(935),
    [anon_sym_c_longlong] = ACTIONS(935),
    [anon_sym_c_ulonglong] = ACTIONS(935),
    [anon_sym_c_longdouble] = ACTIONS(935),
    [aux_sym_builtin_type_token1] = ACTIONS(935),
    [sym_builtin_identifier] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [662] = {
    [sym__identifier] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_comptime] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_extern] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_const] = ACTIONS(939),
    [anon_sym_var] = ACTIONS(939),
    [anon_sym_inline] = ACTIONS(939),
    [anon_sym_fn] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_packed] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(939),
    [anon_sym_opaque] = ACTIONS(939),
    [anon_sym_enum] = ACTIONS(939),
    [anon_sym_union] = ACTIONS(939),
    [anon_sym_error] = ACTIONS(939),
    [anon_sym_nosuspend] = ACTIONS(939),
    [anon_sym_suspend] = ACTIONS(939),
    [anon_sym_defer] = ACTIONS(939),
    [anon_sym_errdefer] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(939),
    [anon_sym_asm] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_DASH_PERCENT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(943),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_await] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_resume] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_catch] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(939),
    [anon_sym_anyframe] = ACTIONS(939),
    [anon_sym_unreachable] = ACTIONS(939),
    [anon_sym_undefined] = ACTIONS(939),
    [anon_sym_null] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(939),
    [anon_sym_DOT_STAR] = ACTIONS(941),
    [anon_sym_DOT_QMARK] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [aux_sym_multiline_string_token1] = ACTIONS(945),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [sym_integer] = ACTIONS(939),
    [sym_float] = ACTIONS(945),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [anon_sym_bool] = ACTIONS(939),
    [anon_sym_f16] = ACTIONS(939),
    [anon_sym_f32] = ACTIONS(939),
    [anon_sym_f64] = ACTIONS(939),
    [anon_sym_f128] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_type] = ACTIONS(939),
    [anon_sym_anyerror] = ACTIONS(939),
    [anon_sym_anyopaque] = ACTIONS(939),
    [anon_sym_anytype] = ACTIONS(939),
    [anon_sym_noreturn] = ACTIONS(939),
    [anon_sym_isize] = ACTIONS(939),
    [anon_sym_usize] = ACTIONS(939),
    [anon_sym_comptime_int] = ACTIONS(939),
    [anon_sym_comptime_float] = ACTIONS(939),
    [anon_sym_c_short] = ACTIONS(939),
    [anon_sym_c_ushort] = ACTIONS(939),
    [anon_sym_c_int] = ACTIONS(939),
    [anon_sym_c_uint] = ACTIONS(939),
    [anon_sym_c_long] = ACTIONS(939),
    [anon_sym_c_ulong] = ACTIONS(939),
    [anon_sym_c_longlong] = ACTIONS(939),
    [anon_sym_c_ulonglong] = ACTIONS(939),
    [anon_sym_c_longdouble] = ACTIONS(939),
    [aux_sym_builtin_type_token1] = ACTIONS(939),
    [sym_builtin_identifier] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
  },
  [663] = {
    [sym__identifier] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_comptime] = ACTIONS(947),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_extern] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_STAR_EQ] = ACTIONS(925),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(925),
    [anon_sym_SLASH_EQ] = ACTIONS(925),
    [anon_sym_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(925),
    [anon_sym_DASH_EQ] = ACTIONS(925),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(925),
    [anon_sym_GT_GT_EQ] = ACTIONS(925),
    [anon_sym_AMP_EQ] = ACTIONS(925),
    [anon_sym_CARET_EQ] = ACTIONS(925),
    [anon_sym_PIPE_EQ] = ACTIONS(925),
    [anon_sym_const] = ACTIONS(947),
    [anon_sym_var] = ACTIONS(947),
    [anon_sym_inline] = ACTIONS(947),
    [anon_sym_fn] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_packed] = ACTIONS(947),
    [anon_sym_struct] = ACTIONS(947),
    [anon_sym_opaque] = ACTIONS(947),
    [anon_sym_enum] = ACTIONS(947),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_error] = ACTIONS(947),
    [anon_sym_nosuspend] = ACTIONS(947),
    [anon_sym_suspend] = ACTIONS(947),
    [anon_sym_defer] = ACTIONS(947),
    [anon_sym_errdefer] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_asm] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_DASH_PERCENT] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(947),
    [anon_sym_await] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_resume] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_catch] = ACTIONS(927),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_anyframe] = ACTIONS(947),
    [anon_sym_unreachable] = ACTIONS(947),
    [anon_sym_undefined] = ACTIONS(947),
    [anon_sym_null] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_DOT_STAR] = ACTIONS(925),
    [anon_sym_DOT_QMARK] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [aux_sym_multiline_string_token1] = ACTIONS(949),
    [anon_sym_SQUOTE] = ACTIONS(949),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(949),
    [anon_sym_true] = ACTIONS(947),
    [anon_sym_false] = ACTIONS(947),
    [anon_sym_bool] = ACTIONS(947),
    [anon_sym_f16] = ACTIONS(947),
    [anon_sym_f32] = ACTIONS(947),
    [anon_sym_f64] = ACTIONS(947),
    [anon_sym_f128] = ACTIONS(947),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_type] = ACTIONS(947),
    [anon_sym_anyerror] = ACTIONS(947),
    [anon_sym_anyopaque] = ACTIONS(947),
    [anon_sym_anytype] = ACTIONS(947),
    [anon_sym_noreturn] = ACTIONS(947),
    [anon_sym_isize] = ACTIONS(947),
    [anon_sym_usize] = ACTIONS(947),
    [anon_sym_comptime_int] = ACTIONS(947),
    [anon_sym_comptime_float] = ACTIONS(947),
    [anon_sym_c_short] = ACTIONS(947),
    [anon_sym_c_ushort] = ACTIONS(947),
    [anon_sym_c_int] = ACTIONS(947),
    [anon_sym_c_uint] = ACTIONS(947),
    [anon_sym_c_long] = ACTIONS(947),
    [anon_sym_c_ulong] = ACTIONS(947),
    [anon_sym_c_longlong] = ACTIONS(947),
    [anon_sym_c_ulonglong] = ACTIONS(947),
    [anon_sym_c_longdouble] = ACTIONS(947),
    [aux_sym_builtin_type_token1] = ACTIONS(947),
    [sym_builtin_identifier] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
  },
  [664] = {
    [sym__identifier] = ACTIONS(951),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_comptime] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_extern] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_const] = ACTIONS(951),
    [anon_sym_var] = ACTIONS(951),
    [anon_sym_inline] = ACTIONS(951),
    [anon_sym_fn] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_packed] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(951),
    [anon_sym_opaque] = ACTIONS(951),
    [anon_sym_enum] = ACTIONS(951),
    [anon_sym_union] = ACTIONS(951),
    [anon_sym_error] = ACTIONS(951),
    [anon_sym_nosuspend] = ACTIONS(951),
    [anon_sym_suspend] = ACTIONS(951),
    [anon_sym_defer] = ACTIONS(951),
    [anon_sym_errdefer] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_asm] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(951),
    [anon_sym_DASH_PERCENT] = ACTIONS(951),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_async] = ACTIONS(951),
    [anon_sym_await] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_resume] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_catch] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_anyframe] = ACTIONS(951),
    [anon_sym_unreachable] = ACTIONS(951),
    [anon_sym_undefined] = ACTIONS(951),
    [anon_sym_null] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(951),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [aux_sym_multiline_string_token1] = ACTIONS(953),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [sym_integer] = ACTIONS(951),
    [sym_float] = ACTIONS(953),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [anon_sym_bool] = ACTIONS(951),
    [anon_sym_f16] = ACTIONS(951),
    [anon_sym_f32] = ACTIONS(951),
    [anon_sym_f64] = ACTIONS(951),
    [anon_sym_f128] = ACTIONS(951),
    [anon_sym_void] = ACTIONS(951),
    [anon_sym_type] = ACTIONS(951),
    [anon_sym_anyerror] = ACTIONS(951),
    [anon_sym_anyopaque] = ACTIONS(951),
    [anon_sym_anytype] = ACTIONS(951),
    [anon_sym_noreturn] = ACTIONS(951),
    [anon_sym_isize] = ACTIONS(951),
    [anon_sym_usize] = ACTIONS(951),
    [anon_sym_comptime_int] = ACTIONS(951),
    [anon_sym_comptime_float] = ACTIONS(951),
    [anon_sym_c_short] = ACTIONS(951),
    [anon_sym_c_ushort] = ACTIONS(951),
    [anon_sym_c_int] = ACTIONS(951),
    [anon_sym_c_uint] = ACTIONS(951),
    [anon_sym_c_long] = ACTIONS(951),
    [anon_sym_c_ulong] = ACTIONS(951),
    [anon_sym_c_longlong] = ACTIONS(951),
    [anon_sym_c_ulonglong] = ACTIONS(951),
    [anon_sym_c_longdouble] = ACTIONS(951),
    [aux_sym_builtin_type_token1] = ACTIONS(951),
    [sym_builtin_identifier] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
  },
  [665] = {
    [sym__identifier] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_comptime] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_extern] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(857),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(857),
    [anon_sym_SLASH_EQ] = ACTIONS(857),
    [anon_sym_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_PLUS_EQ] = ACTIONS(857),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(857),
    [anon_sym_DASH_EQ] = ACTIONS(857),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(857),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_EQ] = ACTIONS(857),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(857),
    [anon_sym_GT_GT_EQ] = ACTIONS(857),
    [anon_sym_AMP_EQ] = ACTIONS(857),
    [anon_sym_CARET_EQ] = ACTIONS(857),
    [anon_sym_PIPE_EQ] = ACTIONS(857),
    [anon_sym_inline] = ACTIONS(859),
    [anon_sym_fn] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(857),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_packed] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_opaque] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(859),
    [anon_sym_error] = ACTIONS(859),
    [anon_sym_nosuspend] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_DOT_DOT] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_asm] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(859),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_DASH_PERCENT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_or] = ACTIONS(859),
    [anon_sym_and] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_orelse] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_PLUS_PERCENT] = ACTIONS(859),
    [anon_sym_PLUS_PIPE] = ACTIONS(859),
    [anon_sym_DASH_PIPE] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_STAR_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_PIPE] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_await] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_resume] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_try] = ACTIONS(859),
    [anon_sym_catch] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_EQ_GT] = ACTIONS(857),
    [anon_sym_anyframe] = ACTIONS(859),
    [anon_sym_unreachable] = ACTIONS(859),
    [anon_sym_undefined] = ACTIONS(859),
    [anon_sym_null] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(857),
    [anon_sym_DOT] = ACTIONS(859),
    [anon_sym_DOT_STAR] = ACTIONS(857),
    [anon_sym_DOT_QMARK] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [aux_sym_multiline_string_token1] = ACTIONS(857),
    [anon_sym_SQUOTE] = ACTIONS(857),
    [sym_integer] = ACTIONS(859),
    [sym_float] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_bool] = ACTIONS(859),
    [anon_sym_f16] = ACTIONS(859),
    [anon_sym_f32] = ACTIONS(859),
    [anon_sym_f64] = ACTIONS(859),
    [anon_sym_f128] = ACTIONS(859),
    [anon_sym_void] = ACTIONS(859),
    [anon_sym_type] = ACTIONS(859),
    [anon_sym_anyerror] = ACTIONS(859),
    [anon_sym_anyopaque] = ACTIONS(859),
    [anon_sym_anytype] = ACTIONS(859),
    [anon_sym_noreturn] = ACTIONS(859),
    [anon_sym_isize] = ACTIONS(859),
    [anon_sym_usize] = ACTIONS(859),
    [anon_sym_comptime_int] = ACTIONS(859),
    [anon_sym_comptime_float] = ACTIONS(859),
    [anon_sym_c_short] = ACTIONS(859),
    [anon_sym_c_ushort] = ACTIONS(859),
    [anon_sym_c_int] = ACTIONS(859),
    [anon_sym_c_uint] = ACTIONS(859),
    [anon_sym_c_long] = ACTIONS(859),
    [anon_sym_c_ulong] = ACTIONS(859),
    [anon_sym_c_longlong] = ACTIONS(859),
    [anon_sym_c_ulonglong] = ACTIONS(859),
    [anon_sym_c_longdouble] = ACTIONS(859),
    [aux_sym_builtin_type_token1] = ACTIONS(859),
    [sym_builtin_identifier] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
  },
  [666] = {
    [sym__identifier] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(789),
    [anon_sym_comptime] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(791),
    [anon_sym_extern] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(789),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(789),
    [anon_sym_SLASH_EQ] = ACTIONS(789),
    [anon_sym_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(789),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(789),
    [anon_sym_DASH_EQ] = ACTIONS(789),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(789),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(789),
    [anon_sym_LT_LT_EQ] = ACTIONS(789),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(789),
    [anon_sym_GT_GT_EQ] = ACTIONS(789),
    [anon_sym_AMP_EQ] = ACTIONS(789),
    [anon_sym_CARET_EQ] = ACTIONS(789),
    [anon_sym_PIPE_EQ] = ACTIONS(789),
    [anon_sym_inline] = ACTIONS(791),
    [anon_sym_fn] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(789),
    [anon_sym_packed] = ACTIONS(791),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_opaque] = ACTIONS(791),
    [anon_sym_enum] = ACTIONS(791),
    [anon_sym_union] = ACTIONS(791),
    [anon_sym_error] = ACTIONS(791),
    [anon_sym_nosuspend] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_DOT_DOT] = ACTIONS(791),
    [anon_sym_while] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_asm] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_DASH_PERCENT] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(791),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(789),
    [anon_sym_BANG_EQ] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_GT_EQ] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [anon_sym_orelse] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_LT_LT_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_PLUS_PERCENT] = ACTIONS(791),
    [anon_sym_PLUS_PIPE] = ACTIONS(791),
    [anon_sym_DASH_PIPE] = ACTIONS(791),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(789),
    [anon_sym_STAR_PERCENT] = ACTIONS(791),
    [anon_sym_STAR_PIPE] = ACTIONS(791),
    [anon_sym_PIPE_PIPE] = ACTIONS(789),
    [anon_sym_async] = ACTIONS(791),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_continue] = ACTIONS(791),
    [anon_sym_resume] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(791),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_try] = ACTIONS(791),
    [anon_sym_catch] = ACTIONS(791),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(789),
    [anon_sym_anyframe] = ACTIONS(791),
    [anon_sym_unreachable] = ACTIONS(791),
    [anon_sym_undefined] = ACTIONS(791),
    [anon_sym_null] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(789),
    [anon_sym_DOT] = ACTIONS(791),
    [anon_sym_DOT_STAR] = ACTIONS(789),
    [anon_sym_DOT_QMARK] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [aux_sym_multiline_string_token1] = ACTIONS(789),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer] = ACTIONS(791),
    [sym_float] = ACTIONS(789),
    [anon_sym_true] = ACTIONS(791),
    [anon_sym_false] = ACTIONS(791),
    [anon_sym_bool] = ACTIONS(791),
    [anon_sym_f16] = ACTIONS(791),
    [anon_sym_f32] = ACTIONS(791),
    [anon_sym_f64] = ACTIONS(791),
    [anon_sym_f128] = ACTIONS(791),
    [anon_sym_void] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_anyerror] = ACTIONS(791),
    [anon_sym_anyopaque] = ACTIONS(791),
    [anon_sym_anytype] = ACTIONS(791),
    [anon_sym_noreturn] = ACTIONS(791),
    [anon_sym_isize] = ACTIONS(791),
    [anon_sym_usize] = ACTIONS(791),
    [anon_sym_comptime_int] = ACTIONS(791),
    [anon_sym_comptime_float] = ACTIONS(791),
    [anon_sym_c_short] = ACTIONS(791),
    [anon_sym_c_ushort] = ACTIONS(791),
    [anon_sym_c_int] = ACTIONS(791),
    [anon_sym_c_uint] = ACTIONS(791),
    [anon_sym_c_long] = ACTIONS(791),
    [anon_sym_c_ulong] = ACTIONS(791),
    [anon_sym_c_longlong] = ACTIONS(791),
    [anon_sym_c_ulonglong] = ACTIONS(791),
    [anon_sym_c_longdouble] = ACTIONS(791),
    [aux_sym_builtin_type_token1] = ACTIONS(791),
    [sym_builtin_identifier] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [667] = {
    [sym__identifier] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_comptime] = ACTIONS(897),
    [anon_sym_COLON] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(897),
    [anon_sym_extern] = ACTIONS(897),
    [anon_sym_STAR_EQ] = ACTIONS(895),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(895),
    [anon_sym_SLASH_EQ] = ACTIONS(895),
    [anon_sym_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_PLUS_EQ] = ACTIONS(895),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(895),
    [anon_sym_DASH_EQ] = ACTIONS(895),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(895),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(895),
    [anon_sym_LT_LT_EQ] = ACTIONS(895),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(895),
    [anon_sym_GT_GT_EQ] = ACTIONS(895),
    [anon_sym_AMP_EQ] = ACTIONS(895),
    [anon_sym_CARET_EQ] = ACTIONS(895),
    [anon_sym_PIPE_EQ] = ACTIONS(895),
    [anon_sym_inline] = ACTIONS(897),
    [anon_sym_fn] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_packed] = ACTIONS(897),
    [anon_sym_struct] = ACTIONS(897),
    [anon_sym_opaque] = ACTIONS(897),
    [anon_sym_enum] = ACTIONS(897),
    [anon_sym_union] = ACTIONS(897),
    [anon_sym_error] = ACTIONS(897),
    [anon_sym_nosuspend] = ACTIONS(897),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_for] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_DASH_PERCENT] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_EQ] = ACTIONS(895),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_orelse] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_LT_LT_PIPE] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(895),
    [anon_sym_PLUS_PERCENT] = ACTIONS(897),
    [anon_sym_PLUS_PIPE] = ACTIONS(897),
    [anon_sym_DASH_PIPE] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_STAR_PERCENT] = ACTIONS(897),
    [anon_sym_STAR_PIPE] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_await] = ACTIONS(897),
    [anon_sym_continue] = ACTIONS(897),
    [anon_sym_resume] = ACTIONS(897),
    [anon_sym_return] = ACTIONS(897),
    [anon_sym_break] = ACTIONS(897),
    [anon_sym_try] = ACTIONS(897),
    [anon_sym_catch] = ACTIONS(897),
    [anon_sym_switch] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(895),
    [anon_sym_anyframe] = ACTIONS(897),
    [anon_sym_unreachable] = ACTIONS(897),
    [anon_sym_undefined] = ACTIONS(897),
    [anon_sym_null] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(895),
    [anon_sym_DOT] = ACTIONS(897),
    [anon_sym_DOT_STAR] = ACTIONS(895),
    [anon_sym_DOT_QMARK] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(895),
    [aux_sym_multiline_string_token1] = ACTIONS(895),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [sym_integer] = ACTIONS(897),
    [sym_float] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(897),
    [anon_sym_false] = ACTIONS(897),
    [anon_sym_bool] = ACTIONS(897),
    [anon_sym_f16] = ACTIONS(897),
    [anon_sym_f32] = ACTIONS(897),
    [anon_sym_f64] = ACTIONS(897),
    [anon_sym_f128] = ACTIONS(897),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(897),
    [anon_sym_anyerror] = ACTIONS(897),
    [anon_sym_anyopaque] = ACTIONS(897),
    [anon_sym_anytype] = ACTIONS(897),
    [anon_sym_noreturn] = ACTIONS(897),
    [anon_sym_isize] = ACTIONS(897),
    [anon_sym_usize] = ACTIONS(897),
    [anon_sym_comptime_int] = ACTIONS(897),
    [anon_sym_comptime_float] = ACTIONS(897),
    [anon_sym_c_short] = ACTIONS(897),
    [anon_sym_c_ushort] = ACTIONS(897),
    [anon_sym_c_int] = ACTIONS(897),
    [anon_sym_c_uint] = ACTIONS(897),
    [anon_sym_c_long] = ACTIONS(897),
    [anon_sym_c_ulong] = ACTIONS(897),
    [anon_sym_c_longlong] = ACTIONS(897),
    [anon_sym_c_ulonglong] = ACTIONS(897),
    [anon_sym_c_longdouble] = ACTIONS(897),
    [aux_sym_builtin_type_token1] = ACTIONS(897),
    [sym_builtin_identifier] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
  },
  [668] = {
    [sym__identifier] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(797),
    [anon_sym_comptime] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(797),
    [anon_sym_EQ] = ACTIONS(799),
    [anon_sym_extern] = ACTIONS(799),
    [anon_sym_STAR_EQ] = ACTIONS(797),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(797),
    [anon_sym_SLASH_EQ] = ACTIONS(797),
    [anon_sym_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_PLUS_EQ] = ACTIONS(797),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(797),
    [anon_sym_DASH_EQ] = ACTIONS(797),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(797),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(797),
    [anon_sym_LT_LT_EQ] = ACTIONS(797),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(797),
    [anon_sym_GT_GT_EQ] = ACTIONS(797),
    [anon_sym_AMP_EQ] = ACTIONS(797),
    [anon_sym_CARET_EQ] = ACTIONS(797),
    [anon_sym_PIPE_EQ] = ACTIONS(797),
    [anon_sym_inline] = ACTIONS(799),
    [anon_sym_fn] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_packed] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_opaque] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_union] = ACTIONS(799),
    [anon_sym_error] = ACTIONS(799),
    [anon_sym_nosuspend] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_DOT_DOT] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(799),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_asm] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_DASH_PERCENT] = ACTIONS(799),
    [anon_sym_AMP] = ACTIONS(799),
    [anon_sym_or] = ACTIONS(799),
    [anon_sym_and] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(797),
    [anon_sym_BANG_EQ] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(799),
    [anon_sym_GT_EQ] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(799),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_orelse] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(799),
    [anon_sym_LT_LT_PIPE] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_PLUS_PERCENT] = ACTIONS(799),
    [anon_sym_PLUS_PIPE] = ACTIONS(799),
    [anon_sym_DASH_PIPE] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_STAR_STAR] = ACTIONS(797),
    [anon_sym_STAR_PERCENT] = ACTIONS(799),
    [anon_sym_STAR_PIPE] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_resume] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_catch] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(797),
    [anon_sym_anyframe] = ACTIONS(799),
    [anon_sym_unreachable] = ACTIONS(799),
    [anon_sym_undefined] = ACTIONS(799),
    [anon_sym_null] = ACTIONS(799),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_DOT_STAR] = ACTIONS(797),
    [anon_sym_DOT_QMARK] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(797),
    [aux_sym_multiline_string_token1] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [sym_integer] = ACTIONS(799),
    [sym_float] = ACTIONS(797),
    [anon_sym_true] = ACTIONS(799),
    [anon_sym_false] = ACTIONS(799),
    [anon_sym_bool] = ACTIONS(799),
    [anon_sym_f16] = ACTIONS(799),
    [anon_sym_f32] = ACTIONS(799),
    [anon_sym_f64] = ACTIONS(799),
    [anon_sym_f128] = ACTIONS(799),
    [anon_sym_void] = ACTIONS(799),
    [anon_sym_type] = ACTIONS(799),
    [anon_sym_anyerror] = ACTIONS(799),
    [anon_sym_anyopaque] = ACTIONS(799),
    [anon_sym_anytype] = ACTIONS(799),
    [anon_sym_noreturn] = ACTIONS(799),
    [anon_sym_isize] = ACTIONS(799),
    [anon_sym_usize] = ACTIONS(799),
    [anon_sym_comptime_int] = ACTIONS(799),
    [anon_sym_comptime_float] = ACTIONS(799),
    [anon_sym_c_short] = ACTIONS(799),
    [anon_sym_c_ushort] = ACTIONS(799),
    [anon_sym_c_int] = ACTIONS(799),
    [anon_sym_c_uint] = ACTIONS(799),
    [anon_sym_c_long] = ACTIONS(799),
    [anon_sym_c_ulong] = ACTIONS(799),
    [anon_sym_c_longlong] = ACTIONS(799),
    [anon_sym_c_ulonglong] = ACTIONS(799),
    [anon_sym_c_longdouble] = ACTIONS(799),
    [aux_sym_builtin_type_token1] = ACTIONS(799),
    [sym_builtin_identifier] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
  },
  [669] = {
    [sym__identifier] = ACTIONS(873),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_comptime] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_extern] = ACTIONS(873),
    [anon_sym_STAR_EQ] = ACTIONS(871),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(871),
    [anon_sym_SLASH_EQ] = ACTIONS(871),
    [anon_sym_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_PLUS_EQ] = ACTIONS(871),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(871),
    [anon_sym_DASH_EQ] = ACTIONS(871),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(871),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(871),
    [anon_sym_LT_LT_EQ] = ACTIONS(871),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(871),
    [anon_sym_GT_GT_EQ] = ACTIONS(871),
    [anon_sym_AMP_EQ] = ACTIONS(871),
    [anon_sym_CARET_EQ] = ACTIONS(871),
    [anon_sym_PIPE_EQ] = ACTIONS(871),
    [anon_sym_inline] = ACTIONS(873),
    [anon_sym_fn] = ACTIONS(873),
    [anon_sym_LPAREN] = ACTIONS(871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_packed] = ACTIONS(873),
    [anon_sym_struct] = ACTIONS(873),
    [anon_sym_opaque] = ACTIONS(873),
    [anon_sym_enum] = ACTIONS(873),
    [anon_sym_union] = ACTIONS(873),
    [anon_sym_error] = ACTIONS(873),
    [anon_sym_nosuspend] = ACTIONS(873),
    [anon_sym_if] = ACTIONS(873),
    [anon_sym_else] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(873),
    [anon_sym_DOT_DOT] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(873),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(873),
    [anon_sym_asm] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_DASH_PERCENT] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_and] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(871),
    [anon_sym_BANG_EQ] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_EQ] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(873),
    [anon_sym_orelse] = ACTIONS(873),
    [anon_sym_LT_LT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(873),
    [anon_sym_LT_LT_PIPE] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_PLUS_PERCENT] = ACTIONS(873),
    [anon_sym_PLUS_PIPE] = ACTIONS(873),
    [anon_sym_DASH_PIPE] = ACTIONS(873),
    [anon_sym_SLASH] = ACTIONS(873),
    [anon_sym_PERCENT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_STAR_PERCENT] = ACTIONS(873),
    [anon_sym_STAR_PIPE] = ACTIONS(873),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_async] = ACTIONS(873),
    [anon_sym_await] = ACTIONS(873),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_resume] = ACTIONS(873),
    [anon_sym_return] = ACTIONS(873),
    [anon_sym_break] = ACTIONS(873),
    [anon_sym_try] = ACTIONS(873),
    [anon_sym_catch] = ACTIONS(873),
    [anon_sym_switch] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(871),
    [anon_sym_anyframe] = ACTIONS(873),
    [anon_sym_unreachable] = ACTIONS(873),
    [anon_sym_undefined] = ACTIONS(873),
    [anon_sym_null] = ACTIONS(873),
    [anon_sym_QMARK] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_DOT_STAR] = ACTIONS(871),
    [anon_sym_DOT_QMARK] = ACTIONS(871),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [aux_sym_multiline_string_token1] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(871),
    [sym_integer] = ACTIONS(873),
    [sym_float] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [anon_sym_bool] = ACTIONS(873),
    [anon_sym_f16] = ACTIONS(873),
    [anon_sym_f32] = ACTIONS(873),
    [anon_sym_f64] = ACTIONS(873),
    [anon_sym_f128] = ACTIONS(873),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_type] = ACTIONS(873),
    [anon_sym_anyerror] = ACTIONS(873),
    [anon_sym_anyopaque] = ACTIONS(873),
    [anon_sym_anytype] = ACTIONS(873),
    [anon_sym_noreturn] = ACTIONS(873),
    [anon_sym_isize] = ACTIONS(873),
    [anon_sym_usize] = ACTIONS(873),
    [anon_sym_comptime_int] = ACTIONS(873),
    [anon_sym_comptime_float] = ACTIONS(873),
    [anon_sym_c_short] = ACTIONS(873),
    [anon_sym_c_ushort] = ACTIONS(873),
    [anon_sym_c_int] = ACTIONS(873),
    [anon_sym_c_uint] = ACTIONS(873),
    [anon_sym_c_long] = ACTIONS(873),
    [anon_sym_c_ulong] = ACTIONS(873),
    [anon_sym_c_longlong] = ACTIONS(873),
    [anon_sym_c_ulonglong] = ACTIONS(873),
    [anon_sym_c_longdouble] = ACTIONS(873),
    [aux_sym_builtin_type_token1] = ACTIONS(873),
    [sym_builtin_identifier] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(955),
    [sym__identifier] = ACTIONS(957),
    [anon_sym_COMMA] = ACTIONS(955),
    [anon_sym_comptime] = ACTIONS(957),
    [anon_sym_EQ] = ACTIONS(955),
    [anon_sym_extern] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(955),
    [anon_sym_const] = ACTIONS(957),
    [anon_sym_inline] = ACTIONS(957),
    [anon_sym_fn] = ACTIONS(957),
    [anon_sym_LPAREN] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_packed] = ACTIONS(957),
    [anon_sym_struct] = ACTIONS(957),
    [anon_sym_opaque] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_union] = ACTIONS(957),
    [anon_sym_error] = ACTIONS(957),
    [anon_sym_nosuspend] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_align] = ACTIONS(957),
    [anon_sym_addrspace] = ACTIONS(957),
    [anon_sym_linksection] = ACTIONS(957),
    [anon_sym_callconv] = ACTIONS(957),
    [anon_sym_asm] = ACTIONS(957),
    [anon_sym_volatile] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_DASH_PERCENT] = ACTIONS(955),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_async] = ACTIONS(957),
    [anon_sym_await] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_resume] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_try] = ACTIONS(957),
    [anon_sym_switch] = ACTIONS(957),
    [anon_sym_anyframe] = ACTIONS(957),
    [anon_sym_unreachable] = ACTIONS(957),
    [anon_sym_undefined] = ACTIONS(957),
    [anon_sym_null] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_allowzero] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(955),
    [aux_sym_multiline_string_token1] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(955),
    [sym_integer] = ACTIONS(957),
    [sym_float] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(957),
    [anon_sym_false] = ACTIONS(957),
    [anon_sym_bool] = ACTIONS(957),
    [anon_sym_f16] = ACTIONS(957),
    [anon_sym_f32] = ACTIONS(957),
    [anon_sym_f64] = ACTIONS(957),
    [anon_sym_f128] = ACTIONS(957),
    [anon_sym_void] = ACTIONS(957),
    [anon_sym_type] = ACTIONS(957),
    [anon_sym_anyerror] = ACTIONS(957),
    [anon_sym_anyopaque] = ACTIONS(957),
    [anon_sym_anytype] = ACTIONS(957),
    [anon_sym_noreturn] = ACTIONS(957),
    [anon_sym_isize] = ACTIONS(957),
    [anon_sym_usize] = ACTIONS(957),
    [anon_sym_comptime_int] = ACTIONS(957),
    [anon_sym_comptime_float] = ACTIONS(957),
    [anon_sym_c_short] = ACTIONS(957),
    [anon_sym_c_ushort] = ACTIONS(957),
    [anon_sym_c_int] = ACTIONS(957),
    [anon_sym_c_uint] = ACTIONS(957),
    [anon_sym_c_long] = ACTIONS(957),
    [anon_sym_c_ulong] = ACTIONS(957),
    [anon_sym_c_longlong] = ACTIONS(957),
    [anon_sym_c_ulonglong] = ACTIONS(957),
    [anon_sym_c_longdouble] = ACTIONS(957),
    [aux_sym_builtin_type_token1] = ACTIONS(957),
    [sym_builtin_identifier] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(957),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym__identifier] = ACTIONS(657),
    [anon_sym_pub] = ACTIONS(657),
    [anon_sym_test] = ACTIONS(657),
    [anon_sym_comptime] = ACTIONS(657),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_extern] = ACTIONS(657),
    [anon_sym_threadlocal] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(657),
    [anon_sym_var] = ACTIONS(657),
    [anon_sym_inline] = ACTIONS(657),
    [anon_sym_noinline] = ACTIONS(657),
    [anon_sym_fn] = ACTIONS(657),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_usingnamespace] = ACTIONS(657),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_packed] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(657),
    [anon_sym_opaque] = ACTIONS(657),
    [anon_sym_enum] = ACTIONS(657),
    [anon_sym_union] = ACTIONS(657),
    [anon_sym_error] = ACTIONS(657),
    [anon_sym_nosuspend] = ACTIONS(657),
    [anon_sym_if] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(657),
    [anon_sym_while] = ACTIONS(657),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_asm] = ACTIONS(657),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(657),
    [anon_sym_DASH_PERCENT] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(655),
    [anon_sym_async] = ACTIONS(657),
    [anon_sym_await] = ACTIONS(657),
    [anon_sym_continue] = ACTIONS(657),
    [anon_sym_resume] = ACTIONS(657),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_break] = ACTIONS(657),
    [anon_sym_try] = ACTIONS(657),
    [anon_sym_switch] = ACTIONS(657),
    [anon_sym_anyframe] = ACTIONS(657),
    [anon_sym_unreachable] = ACTIONS(657),
    [anon_sym_undefined] = ACTIONS(657),
    [anon_sym_null] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(655),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [aux_sym_multiline_string_token1] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(655),
    [sym_integer] = ACTIONS(657),
    [sym_float] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [anon_sym_bool] = ACTIONS(657),
    [anon_sym_f16] = ACTIONS(657),
    [anon_sym_f32] = ACTIONS(657),
    [anon_sym_f64] = ACTIONS(657),
    [anon_sym_f128] = ACTIONS(657),
    [anon_sym_void] = ACTIONS(657),
    [anon_sym_type] = ACTIONS(657),
    [anon_sym_anyerror] = ACTIONS(657),
    [anon_sym_anyopaque] = ACTIONS(657),
    [anon_sym_anytype] = ACTIONS(657),
    [anon_sym_noreturn] = ACTIONS(657),
    [anon_sym_isize] = ACTIONS(657),
    [anon_sym_usize] = ACTIONS(657),
    [anon_sym_comptime_int] = ACTIONS(657),
    [anon_sym_comptime_float] = ACTIONS(657),
    [anon_sym_c_short] = ACTIONS(657),
    [anon_sym_c_ushort] = ACTIONS(657),
    [anon_sym_c_int] = ACTIONS(657),
    [anon_sym_c_uint] = ACTIONS(657),
    [anon_sym_c_long] = ACTIONS(657),
    [anon_sym_c_ulong] = ACTIONS(657),
    [anon_sym_c_longlong] = ACTIONS(657),
    [anon_sym_c_ulonglong] = ACTIONS(657),
    [anon_sym_c_longdouble] = ACTIONS(657),
    [aux_sym_builtin_type_token1] = ACTIONS(657),
    [sym_builtin_identifier] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(657),
    [sym_comment] = ACTIONS(3),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym__identifier] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_test] = ACTIONS(961),
    [anon_sym_comptime] = ACTIONS(961),
    [anon_sym_export] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_threadlocal] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_var] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_noinline] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_opaque] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(961),
    [anon_sym_nosuspend] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_resume] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_anyframe] = ACTIONS(961),
    [anon_sym_unreachable] = ACTIONS(961),
    [anon_sym_undefined] = ACTIONS(961),
    [anon_sym_null] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(959),
    [aux_sym_multiline_string_token1] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_f16] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_f128] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_anyerror] = ACTIONS(961),
    [anon_sym_anyopaque] = ACTIONS(961),
    [anon_sym_anytype] = ACTIONS(961),
    [anon_sym_noreturn] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_comptime_int] = ACTIONS(961),
    [anon_sym_comptime_float] = ACTIONS(961),
    [anon_sym_c_short] = ACTIONS(961),
    [anon_sym_c_ushort] = ACTIONS(961),
    [anon_sym_c_int] = ACTIONS(961),
    [anon_sym_c_uint] = ACTIONS(961),
    [anon_sym_c_long] = ACTIONS(961),
    [anon_sym_c_ulong] = ACTIONS(961),
    [anon_sym_c_longlong] = ACTIONS(961),
    [anon_sym_c_ulonglong] = ACTIONS(961),
    [anon_sym_c_longdouble] = ACTIONS(961),
    [aux_sym_builtin_type_token1] = ACTIONS(961),
    [sym_builtin_identifier] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym__identifier] = ACTIONS(965),
    [anon_sym_pub] = ACTIONS(965),
    [anon_sym_test] = ACTIONS(965),
    [anon_sym_comptime] = ACTIONS(965),
    [anon_sym_export] = ACTIONS(965),
    [anon_sym_extern] = ACTIONS(965),
    [anon_sym_threadlocal] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(965),
    [anon_sym_var] = ACTIONS(965),
    [anon_sym_inline] = ACTIONS(965),
    [anon_sym_noinline] = ACTIONS(965),
    [anon_sym_fn] = ACTIONS(965),
    [anon_sym_LPAREN] = ACTIONS(963),
    [anon_sym_usingnamespace] = ACTIONS(965),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_packed] = ACTIONS(965),
    [anon_sym_struct] = ACTIONS(965),
    [anon_sym_opaque] = ACTIONS(965),
    [anon_sym_enum] = ACTIONS(965),
    [anon_sym_union] = ACTIONS(965),
    [anon_sym_error] = ACTIONS(965),
    [anon_sym_nosuspend] = ACTIONS(965),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(965),
    [anon_sym_while] = ACTIONS(965),
    [anon_sym_STAR] = ACTIONS(963),
    [anon_sym_asm] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_DASH_PERCENT] = ACTIONS(963),
    [anon_sym_AMP] = ACTIONS(963),
    [anon_sym_async] = ACTIONS(965),
    [anon_sym_await] = ACTIONS(965),
    [anon_sym_continue] = ACTIONS(965),
    [anon_sym_resume] = ACTIONS(965),
    [anon_sym_return] = ACTIONS(965),
    [anon_sym_break] = ACTIONS(965),
    [anon_sym_try] = ACTIONS(965),
    [anon_sym_switch] = ACTIONS(965),
    [anon_sym_anyframe] = ACTIONS(965),
    [anon_sym_unreachable] = ACTIONS(965),
    [anon_sym_undefined] = ACTIONS(965),
    [anon_sym_null] = ACTIONS(965),
    [anon_sym_QMARK] = ACTIONS(963),
    [anon_sym_DOT] = ACTIONS(963),
    [anon_sym_DQUOTE] = ACTIONS(963),
    [aux_sym_multiline_string_token1] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(963),
    [sym_integer] = ACTIONS(965),
    [sym_float] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(965),
    [anon_sym_false] = ACTIONS(965),
    [anon_sym_bool] = ACTIONS(965),
    [anon_sym_f16] = ACTIONS(965),
    [anon_sym_f32] = ACTIONS(965),
    [anon_sym_f64] = ACTIONS(965),
    [anon_sym_f128] = ACTIONS(965),
    [anon_sym_void] = ACTIONS(965),
    [anon_sym_type] = ACTIONS(965),
    [anon_sym_anyerror] = ACTIONS(965),
    [anon_sym_anyopaque] = ACTIONS(965),
    [anon_sym_anytype] = ACTIONS(965),
    [anon_sym_noreturn] = ACTIONS(965),
    [anon_sym_isize] = ACTIONS(965),
    [anon_sym_usize] = ACTIONS(965),
    [anon_sym_comptime_int] = ACTIONS(965),
    [anon_sym_comptime_float] = ACTIONS(965),
    [anon_sym_c_short] = ACTIONS(965),
    [anon_sym_c_ushort] = ACTIONS(965),
    [anon_sym_c_int] = ACTIONS(965),
    [anon_sym_c_uint] = ACTIONS(965),
    [anon_sym_c_long] = ACTIONS(965),
    [anon_sym_c_ulong] = ACTIONS(965),
    [anon_sym_c_longlong] = ACTIONS(965),
    [anon_sym_c_ulonglong] = ACTIONS(965),
    [anon_sym_c_longdouble] = ACTIONS(965),
    [aux_sym_builtin_type_token1] = ACTIONS(965),
    [sym_builtin_identifier] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(965),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(967),
    [sym__identifier] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_test] = ACTIONS(969),
    [anon_sym_comptime] = ACTIONS(969),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_extern] = ACTIONS(969),
    [anon_sym_threadlocal] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_var] = ACTIONS(969),
    [anon_sym_inline] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_usingnamespace] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_packed] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_opaque] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_error] = ACTIONS(969),
    [anon_sym_nosuspend] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_asm] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_DASH_PERCENT] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_resume] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_try] = ACTIONS(969),
    [anon_sym_switch] = ACTIONS(969),
    [anon_sym_anyframe] = ACTIONS(969),
    [anon_sym_unreachable] = ACTIONS(969),
    [anon_sym_undefined] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [aux_sym_multiline_string_token1] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_f16] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_f128] = ACTIONS(969),
    [anon_sym_void] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_anyerror] = ACTIONS(969),
    [anon_sym_anyopaque] = ACTIONS(969),
    [anon_sym_anytype] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_comptime_int] = ACTIONS(969),
    [anon_sym_comptime_float] = ACTIONS(969),
    [anon_sym_c_short] = ACTIONS(969),
    [anon_sym_c_ushort] = ACTIONS(969),
    [anon_sym_c_int] = ACTIONS(969),
    [anon_sym_c_uint] = ACTIONS(969),
    [anon_sym_c_long] = ACTIONS(969),
    [anon_sym_c_ulong] = ACTIONS(969),
    [anon_sym_c_longlong] = ACTIONS(969),
    [anon_sym_c_ulonglong] = ACTIONS(969),
    [anon_sym_c_longdouble] = ACTIONS(969),
    [aux_sym_builtin_type_token1] = ACTIONS(969),
    [sym_builtin_identifier] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym__identifier] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_test] = ACTIONS(961),
    [anon_sym_comptime] = ACTIONS(961),
    [anon_sym_export] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_threadlocal] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_var] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_noinline] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_opaque] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(961),
    [anon_sym_nosuspend] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_resume] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_anyframe] = ACTIONS(961),
    [anon_sym_unreachable] = ACTIONS(961),
    [anon_sym_undefined] = ACTIONS(961),
    [anon_sym_null] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(959),
    [aux_sym_multiline_string_token1] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_f16] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_f128] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_anyerror] = ACTIONS(961),
    [anon_sym_anyopaque] = ACTIONS(961),
    [anon_sym_anytype] = ACTIONS(961),
    [anon_sym_noreturn] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_comptime_int] = ACTIONS(961),
    [anon_sym_comptime_float] = ACTIONS(961),
    [anon_sym_c_short] = ACTIONS(961),
    [anon_sym_c_ushort] = ACTIONS(961),
    [anon_sym_c_int] = ACTIONS(961),
    [anon_sym_c_uint] = ACTIONS(961),
    [anon_sym_c_long] = ACTIONS(961),
    [anon_sym_c_ulong] = ACTIONS(961),
    [anon_sym_c_longlong] = ACTIONS(961),
    [anon_sym_c_ulonglong] = ACTIONS(961),
    [anon_sym_c_longdouble] = ACTIONS(961),
    [aux_sym_builtin_type_token1] = ACTIONS(961),
    [sym_builtin_identifier] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(971),
    [sym__identifier] = ACTIONS(973),
    [anon_sym_pub] = ACTIONS(973),
    [anon_sym_test] = ACTIONS(973),
    [anon_sym_comptime] = ACTIONS(973),
    [anon_sym_export] = ACTIONS(973),
    [anon_sym_extern] = ACTIONS(973),
    [anon_sym_threadlocal] = ACTIONS(973),
    [anon_sym_const] = ACTIONS(973),
    [anon_sym_var] = ACTIONS(973),
    [anon_sym_inline] = ACTIONS(973),
    [anon_sym_noinline] = ACTIONS(973),
    [anon_sym_fn] = ACTIONS(973),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_usingnamespace] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_packed] = ACTIONS(973),
    [anon_sym_struct] = ACTIONS(973),
    [anon_sym_opaque] = ACTIONS(973),
    [anon_sym_enum] = ACTIONS(973),
    [anon_sym_union] = ACTIONS(973),
    [anon_sym_error] = ACTIONS(973),
    [anon_sym_nosuspend] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_asm] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_DASH_PERCENT] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [anon_sym_resume] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_break] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_anyframe] = ACTIONS(973),
    [anon_sym_unreachable] = ACTIONS(973),
    [anon_sym_undefined] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [aux_sym_multiline_string_token1] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(971),
    [sym_integer] = ACTIONS(973),
    [sym_float] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_bool] = ACTIONS(973),
    [anon_sym_f16] = ACTIONS(973),
    [anon_sym_f32] = ACTIONS(973),
    [anon_sym_f64] = ACTIONS(973),
    [anon_sym_f128] = ACTIONS(973),
    [anon_sym_void] = ACTIONS(973),
    [anon_sym_type] = ACTIONS(973),
    [anon_sym_anyerror] = ACTIONS(973),
    [anon_sym_anyopaque] = ACTIONS(973),
    [anon_sym_anytype] = ACTIONS(973),
    [anon_sym_noreturn] = ACTIONS(973),
    [anon_sym_isize] = ACTIONS(973),
    [anon_sym_usize] = ACTIONS(973),
    [anon_sym_comptime_int] = ACTIONS(973),
    [anon_sym_comptime_float] = ACTIONS(973),
    [anon_sym_c_short] = ACTIONS(973),
    [anon_sym_c_ushort] = ACTIONS(973),
    [anon_sym_c_int] = ACTIONS(973),
    [anon_sym_c_uint] = ACTIONS(973),
    [anon_sym_c_long] = ACTIONS(973),
    [anon_sym_c_ulong] = ACTIONS(973),
    [anon_sym_c_longlong] = ACTIONS(973),
    [anon_sym_c_ulonglong] = ACTIONS(973),
    [anon_sym_c_longdouble] = ACTIONS(973),
    [aux_sym_builtin_type_token1] = ACTIONS(973),
    [sym_builtin_identifier] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(975),
    [sym__identifier] = ACTIONS(977),
    [anon_sym_pub] = ACTIONS(977),
    [anon_sym_test] = ACTIONS(977),
    [anon_sym_comptime] = ACTIONS(977),
    [anon_sym_export] = ACTIONS(977),
    [anon_sym_extern] = ACTIONS(977),
    [anon_sym_threadlocal] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(977),
    [anon_sym_var] = ACTIONS(977),
    [anon_sym_inline] = ACTIONS(977),
    [anon_sym_noinline] = ACTIONS(977),
    [anon_sym_fn] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_usingnamespace] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_packed] = ACTIONS(977),
    [anon_sym_struct] = ACTIONS(977),
    [anon_sym_opaque] = ACTIONS(977),
    [anon_sym_enum] = ACTIONS(977),
    [anon_sym_union] = ACTIONS(977),
    [anon_sym_error] = ACTIONS(977),
    [anon_sym_nosuspend] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_DASH_PERCENT] = ACTIONS(975),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_await] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_resume] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_switch] = ACTIONS(977),
    [anon_sym_anyframe] = ACTIONS(977),
    [anon_sym_unreachable] = ACTIONS(977),
    [anon_sym_undefined] = ACTIONS(977),
    [anon_sym_null] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [aux_sym_multiline_string_token1] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(977),
    [anon_sym_false] = ACTIONS(977),
    [anon_sym_bool] = ACTIONS(977),
    [anon_sym_f16] = ACTIONS(977),
    [anon_sym_f32] = ACTIONS(977),
    [anon_sym_f64] = ACTIONS(977),
    [anon_sym_f128] = ACTIONS(977),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_type] = ACTIONS(977),
    [anon_sym_anyerror] = ACTIONS(977),
    [anon_sym_anyopaque] = ACTIONS(977),
    [anon_sym_anytype] = ACTIONS(977),
    [anon_sym_noreturn] = ACTIONS(977),
    [anon_sym_isize] = ACTIONS(977),
    [anon_sym_usize] = ACTIONS(977),
    [anon_sym_comptime_int] = ACTIONS(977),
    [anon_sym_comptime_float] = ACTIONS(977),
    [anon_sym_c_short] = ACTIONS(977),
    [anon_sym_c_ushort] = ACTIONS(977),
    [anon_sym_c_int] = ACTIONS(977),
    [anon_sym_c_uint] = ACTIONS(977),
    [anon_sym_c_long] = ACTIONS(977),
    [anon_sym_c_ulong] = ACTIONS(977),
    [anon_sym_c_longlong] = ACTIONS(977),
    [anon_sym_c_ulonglong] = ACTIONS(977),
    [anon_sym_c_longdouble] = ACTIONS(977),
    [aux_sym_builtin_type_token1] = ACTIONS(977),
    [sym_builtin_identifier] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym__identifier] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(981),
    [anon_sym_test] = ACTIONS(981),
    [anon_sym_comptime] = ACTIONS(981),
    [anon_sym_export] = ACTIONS(981),
    [anon_sym_extern] = ACTIONS(981),
    [anon_sym_threadlocal] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_var] = ACTIONS(981),
    [anon_sym_inline] = ACTIONS(981),
    [anon_sym_noinline] = ACTIONS(981),
    [anon_sym_fn] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(981),
    [anon_sym_struct] = ACTIONS(981),
    [anon_sym_opaque] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [anon_sym_union] = ACTIONS(981),
    [anon_sym_error] = ACTIONS(981),
    [anon_sym_nosuspend] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_asm] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_DASH_PERCENT] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_resume] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_try] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_anyframe] = ACTIONS(981),
    [anon_sym_unreachable] = ACTIONS(981),
    [anon_sym_undefined] = ACTIONS(981),
    [anon_sym_null] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(979),
    [aux_sym_multiline_string_token1] = ACTIONS(979),
    [anon_sym_SQUOTE] = ACTIONS(979),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_bool] = ACTIONS(981),
    [anon_sym_f16] = ACTIONS(981),
    [anon_sym_f32] = ACTIONS(981),
    [anon_sym_f64] = ACTIONS(981),
    [anon_sym_f128] = ACTIONS(981),
    [anon_sym_void] = ACTIONS(981),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_anyerror] = ACTIONS(981),
    [anon_sym_anyopaque] = ACTIONS(981),
    [anon_sym_anytype] = ACTIONS(981),
    [anon_sym_noreturn] = ACTIONS(981),
    [anon_sym_isize] = ACTIONS(981),
    [anon_sym_usize] = ACTIONS(981),
    [anon_sym_comptime_int] = ACTIONS(981),
    [anon_sym_comptime_float] = ACTIONS(981),
    [anon_sym_c_short] = ACTIONS(981),
    [anon_sym_c_ushort] = ACTIONS(981),
    [anon_sym_c_int] = ACTIONS(981),
    [anon_sym_c_uint] = ACTIONS(981),
    [anon_sym_c_long] = ACTIONS(981),
    [anon_sym_c_ulong] = ACTIONS(981),
    [anon_sym_c_longlong] = ACTIONS(981),
    [anon_sym_c_ulonglong] = ACTIONS(981),
    [anon_sym_c_longdouble] = ACTIONS(981),
    [aux_sym_builtin_type_token1] = ACTIONS(981),
    [sym_builtin_identifier] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym__identifier] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(985),
    [anon_sym_test] = ACTIONS(985),
    [anon_sym_comptime] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_inline] = ACTIONS(985),
    [anon_sym_noinline] = ACTIONS(985),
    [anon_sym_fn] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(985),
    [anon_sym_struct] = ACTIONS(985),
    [anon_sym_opaque] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [anon_sym_union] = ACTIONS(985),
    [anon_sym_error] = ACTIONS(985),
    [anon_sym_nosuspend] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_asm] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_resume] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_anyframe] = ACTIONS(985),
    [anon_sym_unreachable] = ACTIONS(985),
    [anon_sym_undefined] = ACTIONS(985),
    [anon_sym_null] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [aux_sym_multiline_string_token1] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_bool] = ACTIONS(985),
    [anon_sym_f16] = ACTIONS(985),
    [anon_sym_f32] = ACTIONS(985),
    [anon_sym_f64] = ACTIONS(985),
    [anon_sym_f128] = ACTIONS(985),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_anyerror] = ACTIONS(985),
    [anon_sym_anyopaque] = ACTIONS(985),
    [anon_sym_anytype] = ACTIONS(985),
    [anon_sym_noreturn] = ACTIONS(985),
    [anon_sym_isize] = ACTIONS(985),
    [anon_sym_usize] = ACTIONS(985),
    [anon_sym_comptime_int] = ACTIONS(985),
    [anon_sym_comptime_float] = ACTIONS(985),
    [anon_sym_c_short] = ACTIONS(985),
    [anon_sym_c_ushort] = ACTIONS(985),
    [anon_sym_c_int] = ACTIONS(985),
    [anon_sym_c_uint] = ACTIONS(985),
    [anon_sym_c_long] = ACTIONS(985),
    [anon_sym_c_ulong] = ACTIONS(985),
    [anon_sym_c_longlong] = ACTIONS(985),
    [anon_sym_c_ulonglong] = ACTIONS(985),
    [anon_sym_c_longdouble] = ACTIONS(985),
    [aux_sym_builtin_type_token1] = ACTIONS(985),
    [sym_builtin_identifier] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(967),
    [sym__identifier] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_test] = ACTIONS(969),
    [anon_sym_comptime] = ACTIONS(969),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_extern] = ACTIONS(969),
    [anon_sym_threadlocal] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_var] = ACTIONS(969),
    [anon_sym_inline] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_usingnamespace] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_packed] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_opaque] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_error] = ACTIONS(969),
    [anon_sym_nosuspend] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_asm] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_DASH_PERCENT] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_resume] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_try] = ACTIONS(969),
    [anon_sym_switch] = ACTIONS(969),
    [anon_sym_anyframe] = ACTIONS(969),
    [anon_sym_unreachable] = ACTIONS(969),
    [anon_sym_undefined] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [aux_sym_multiline_string_token1] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_f16] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_f128] = ACTIONS(969),
    [anon_sym_void] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_anyerror] = ACTIONS(969),
    [anon_sym_anyopaque] = ACTIONS(969),
    [anon_sym_anytype] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_comptime_int] = ACTIONS(969),
    [anon_sym_comptime_float] = ACTIONS(969),
    [anon_sym_c_short] = ACTIONS(969),
    [anon_sym_c_ushort] = ACTIONS(969),
    [anon_sym_c_int] = ACTIONS(969),
    [anon_sym_c_uint] = ACTIONS(969),
    [anon_sym_c_long] = ACTIONS(969),
    [anon_sym_c_ulong] = ACTIONS(969),
    [anon_sym_c_longlong] = ACTIONS(969),
    [anon_sym_c_ulonglong] = ACTIONS(969),
    [anon_sym_c_longdouble] = ACTIONS(969),
    [aux_sym_builtin_type_token1] = ACTIONS(969),
    [sym_builtin_identifier] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym__identifier] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_test] = ACTIONS(961),
    [anon_sym_comptime] = ACTIONS(961),
    [anon_sym_export] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_threadlocal] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_var] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_noinline] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_opaque] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(961),
    [anon_sym_nosuspend] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_resume] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_anyframe] = ACTIONS(961),
    [anon_sym_unreachable] = ACTIONS(961),
    [anon_sym_undefined] = ACTIONS(961),
    [anon_sym_null] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(959),
    [aux_sym_multiline_string_token1] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_f16] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_f128] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_anyerror] = ACTIONS(961),
    [anon_sym_anyopaque] = ACTIONS(961),
    [anon_sym_anytype] = ACTIONS(961),
    [anon_sym_noreturn] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_comptime_int] = ACTIONS(961),
    [anon_sym_comptime_float] = ACTIONS(961),
    [anon_sym_c_short] = ACTIONS(961),
    [anon_sym_c_ushort] = ACTIONS(961),
    [anon_sym_c_int] = ACTIONS(961),
    [anon_sym_c_uint] = ACTIONS(961),
    [anon_sym_c_long] = ACTIONS(961),
    [anon_sym_c_ulong] = ACTIONS(961),
    [anon_sym_c_longlong] = ACTIONS(961),
    [anon_sym_c_ulonglong] = ACTIONS(961),
    [anon_sym_c_longdouble] = ACTIONS(961),
    [aux_sym_builtin_type_token1] = ACTIONS(961),
    [sym_builtin_identifier] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym__identifier] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(989),
    [anon_sym_test] = ACTIONS(989),
    [anon_sym_comptime] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_extern] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(989),
    [anon_sym_var] = ACTIONS(989),
    [anon_sym_inline] = ACTIONS(989),
    [anon_sym_noinline] = ACTIONS(989),
    [anon_sym_fn] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(989),
    [anon_sym_struct] = ACTIONS(989),
    [anon_sym_opaque] = ACTIONS(989),
    [anon_sym_enum] = ACTIONS(989),
    [anon_sym_union] = ACTIONS(989),
    [anon_sym_error] = ACTIONS(989),
    [anon_sym_nosuspend] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_asm] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_resume] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_anyframe] = ACTIONS(989),
    [anon_sym_unreachable] = ACTIONS(989),
    [anon_sym_undefined] = ACTIONS(989),
    [anon_sym_null] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_multiline_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_bool] = ACTIONS(989),
    [anon_sym_f16] = ACTIONS(989),
    [anon_sym_f32] = ACTIONS(989),
    [anon_sym_f64] = ACTIONS(989),
    [anon_sym_f128] = ACTIONS(989),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_anyerror] = ACTIONS(989),
    [anon_sym_anyopaque] = ACTIONS(989),
    [anon_sym_anytype] = ACTIONS(989),
    [anon_sym_noreturn] = ACTIONS(989),
    [anon_sym_isize] = ACTIONS(989),
    [anon_sym_usize] = ACTIONS(989),
    [anon_sym_comptime_int] = ACTIONS(989),
    [anon_sym_comptime_float] = ACTIONS(989),
    [anon_sym_c_short] = ACTIONS(989),
    [anon_sym_c_ushort] = ACTIONS(989),
    [anon_sym_c_int] = ACTIONS(989),
    [anon_sym_c_uint] = ACTIONS(989),
    [anon_sym_c_long] = ACTIONS(989),
    [anon_sym_c_ulong] = ACTIONS(989),
    [anon_sym_c_longlong] = ACTIONS(989),
    [anon_sym_c_ulonglong] = ACTIONS(989),
    [anon_sym_c_longdouble] = ACTIONS(989),
    [aux_sym_builtin_type_token1] = ACTIONS(989),
    [sym_builtin_identifier] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym__identifier] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(985),
    [anon_sym_test] = ACTIONS(985),
    [anon_sym_comptime] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_inline] = ACTIONS(985),
    [anon_sym_noinline] = ACTIONS(985),
    [anon_sym_fn] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(985),
    [anon_sym_struct] = ACTIONS(985),
    [anon_sym_opaque] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [anon_sym_union] = ACTIONS(985),
    [anon_sym_error] = ACTIONS(985),
    [anon_sym_nosuspend] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_asm] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_resume] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_anyframe] = ACTIONS(985),
    [anon_sym_unreachable] = ACTIONS(985),
    [anon_sym_undefined] = ACTIONS(985),
    [anon_sym_null] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [aux_sym_multiline_string_token1] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_bool] = ACTIONS(985),
    [anon_sym_f16] = ACTIONS(985),
    [anon_sym_f32] = ACTIONS(985),
    [anon_sym_f64] = ACTIONS(985),
    [anon_sym_f128] = ACTIONS(985),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_anyerror] = ACTIONS(985),
    [anon_sym_anyopaque] = ACTIONS(985),
    [anon_sym_anytype] = ACTIONS(985),
    [anon_sym_noreturn] = ACTIONS(985),
    [anon_sym_isize] = ACTIONS(985),
    [anon_sym_usize] = ACTIONS(985),
    [anon_sym_comptime_int] = ACTIONS(985),
    [anon_sym_comptime_float] = ACTIONS(985),
    [anon_sym_c_short] = ACTIONS(985),
    [anon_sym_c_ushort] = ACTIONS(985),
    [anon_sym_c_int] = ACTIONS(985),
    [anon_sym_c_uint] = ACTIONS(985),
    [anon_sym_c_long] = ACTIONS(985),
    [anon_sym_c_ulong] = ACTIONS(985),
    [anon_sym_c_longlong] = ACTIONS(985),
    [anon_sym_c_ulonglong] = ACTIONS(985),
    [anon_sym_c_longdouble] = ACTIONS(985),
    [aux_sym_builtin_type_token1] = ACTIONS(985),
    [sym_builtin_identifier] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(967),
    [sym__identifier] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_test] = ACTIONS(969),
    [anon_sym_comptime] = ACTIONS(969),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_extern] = ACTIONS(969),
    [anon_sym_threadlocal] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_var] = ACTIONS(969),
    [anon_sym_inline] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_usingnamespace] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_packed] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_opaque] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_error] = ACTIONS(969),
    [anon_sym_nosuspend] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_asm] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_DASH_PERCENT] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_resume] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_try] = ACTIONS(969),
    [anon_sym_switch] = ACTIONS(969),
    [anon_sym_anyframe] = ACTIONS(969),
    [anon_sym_unreachable] = ACTIONS(969),
    [anon_sym_undefined] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [aux_sym_multiline_string_token1] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_f16] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_f128] = ACTIONS(969),
    [anon_sym_void] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_anyerror] = ACTIONS(969),
    [anon_sym_anyopaque] = ACTIONS(969),
    [anon_sym_anytype] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_comptime_int] = ACTIONS(969),
    [anon_sym_comptime_float] = ACTIONS(969),
    [anon_sym_c_short] = ACTIONS(969),
    [anon_sym_c_ushort] = ACTIONS(969),
    [anon_sym_c_int] = ACTIONS(969),
    [anon_sym_c_uint] = ACTIONS(969),
    [anon_sym_c_long] = ACTIONS(969),
    [anon_sym_c_ulong] = ACTIONS(969),
    [anon_sym_c_longlong] = ACTIONS(969),
    [anon_sym_c_ulonglong] = ACTIONS(969),
    [anon_sym_c_longdouble] = ACTIONS(969),
    [aux_sym_builtin_type_token1] = ACTIONS(969),
    [sym_builtin_identifier] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym__identifier] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_test] = ACTIONS(961),
    [anon_sym_comptime] = ACTIONS(961),
    [anon_sym_export] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_threadlocal] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_var] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_noinline] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_opaque] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(961),
    [anon_sym_nosuspend] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_resume] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_anyframe] = ACTIONS(961),
    [anon_sym_unreachable] = ACTIONS(961),
    [anon_sym_undefined] = ACTIONS(961),
    [anon_sym_null] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(959),
    [aux_sym_multiline_string_token1] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_f16] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_f128] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_anyerror] = ACTIONS(961),
    [anon_sym_anyopaque] = ACTIONS(961),
    [anon_sym_anytype] = ACTIONS(961),
    [anon_sym_noreturn] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_comptime_int] = ACTIONS(961),
    [anon_sym_comptime_float] = ACTIONS(961),
    [anon_sym_c_short] = ACTIONS(961),
    [anon_sym_c_ushort] = ACTIONS(961),
    [anon_sym_c_int] = ACTIONS(961),
    [anon_sym_c_uint] = ACTIONS(961),
    [anon_sym_c_long] = ACTIONS(961),
    [anon_sym_c_ulong] = ACTIONS(961),
    [anon_sym_c_longlong] = ACTIONS(961),
    [anon_sym_c_ulonglong] = ACTIONS(961),
    [anon_sym_c_longdouble] = ACTIONS(961),
    [aux_sym_builtin_type_token1] = ACTIONS(961),
    [sym_builtin_identifier] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(967),
    [sym__identifier] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_test] = ACTIONS(969),
    [anon_sym_comptime] = ACTIONS(969),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_extern] = ACTIONS(969),
    [anon_sym_threadlocal] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_var] = ACTIONS(969),
    [anon_sym_inline] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_usingnamespace] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_packed] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_opaque] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_error] = ACTIONS(969),
    [anon_sym_nosuspend] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_asm] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_DASH_PERCENT] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_resume] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_try] = ACTIONS(969),
    [anon_sym_switch] = ACTIONS(969),
    [anon_sym_anyframe] = ACTIONS(969),
    [anon_sym_unreachable] = ACTIONS(969),
    [anon_sym_undefined] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [aux_sym_multiline_string_token1] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_f16] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_f128] = ACTIONS(969),
    [anon_sym_void] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_anyerror] = ACTIONS(969),
    [anon_sym_anyopaque] = ACTIONS(969),
    [anon_sym_anytype] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_comptime_int] = ACTIONS(969),
    [anon_sym_comptime_float] = ACTIONS(969),
    [anon_sym_c_short] = ACTIONS(969),
    [anon_sym_c_ushort] = ACTIONS(969),
    [anon_sym_c_int] = ACTIONS(969),
    [anon_sym_c_uint] = ACTIONS(969),
    [anon_sym_c_long] = ACTIONS(969),
    [anon_sym_c_ulong] = ACTIONS(969),
    [anon_sym_c_longlong] = ACTIONS(969),
    [anon_sym_c_ulonglong] = ACTIONS(969),
    [anon_sym_c_longdouble] = ACTIONS(969),
    [aux_sym_builtin_type_token1] = ACTIONS(969),
    [sym_builtin_identifier] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(959),
    [sym__identifier] = ACTIONS(961),
    [anon_sym_pub] = ACTIONS(961),
    [anon_sym_test] = ACTIONS(961),
    [anon_sym_comptime] = ACTIONS(961),
    [anon_sym_export] = ACTIONS(961),
    [anon_sym_extern] = ACTIONS(961),
    [anon_sym_threadlocal] = ACTIONS(961),
    [anon_sym_const] = ACTIONS(961),
    [anon_sym_var] = ACTIONS(961),
    [anon_sym_inline] = ACTIONS(961),
    [anon_sym_noinline] = ACTIONS(961),
    [anon_sym_fn] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(961),
    [anon_sym_struct] = ACTIONS(961),
    [anon_sym_opaque] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_union] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(961),
    [anon_sym_nosuspend] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_asm] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_async] = ACTIONS(961),
    [anon_sym_await] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_resume] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_anyframe] = ACTIONS(961),
    [anon_sym_unreachable] = ACTIONS(961),
    [anon_sym_undefined] = ACTIONS(961),
    [anon_sym_null] = ACTIONS(961),
    [anon_sym_QMARK] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(959),
    [aux_sym_multiline_string_token1] = ACTIONS(959),
    [anon_sym_SQUOTE] = ACTIONS(959),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_bool] = ACTIONS(961),
    [anon_sym_f16] = ACTIONS(961),
    [anon_sym_f32] = ACTIONS(961),
    [anon_sym_f64] = ACTIONS(961),
    [anon_sym_f128] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(961),
    [anon_sym_type] = ACTIONS(961),
    [anon_sym_anyerror] = ACTIONS(961),
    [anon_sym_anyopaque] = ACTIONS(961),
    [anon_sym_anytype] = ACTIONS(961),
    [anon_sym_noreturn] = ACTIONS(961),
    [anon_sym_isize] = ACTIONS(961),
    [anon_sym_usize] = ACTIONS(961),
    [anon_sym_comptime_int] = ACTIONS(961),
    [anon_sym_comptime_float] = ACTIONS(961),
    [anon_sym_c_short] = ACTIONS(961),
    [anon_sym_c_ushort] = ACTIONS(961),
    [anon_sym_c_int] = ACTIONS(961),
    [anon_sym_c_uint] = ACTIONS(961),
    [anon_sym_c_long] = ACTIONS(961),
    [anon_sym_c_ulong] = ACTIONS(961),
    [anon_sym_c_longlong] = ACTIONS(961),
    [anon_sym_c_ulonglong] = ACTIONS(961),
    [anon_sym_c_longdouble] = ACTIONS(961),
    [aux_sym_builtin_type_token1] = ACTIONS(961),
    [sym_builtin_identifier] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [688] = {
    [sym__identifier] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_comptime] = ACTIONS(991),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_inline] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_packed] = ACTIONS(991),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_opaque] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [anon_sym_error] = ACTIONS(991),
    [anon_sym_nosuspend] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(993),
    [anon_sym_align] = ACTIONS(991),
    [anon_sym_addrspace] = ACTIONS(991),
    [anon_sym_linksection] = ACTIONS(991),
    [anon_sym_callconv] = ACTIONS(991),
    [anon_sym_asm] = ACTIONS(991),
    [anon_sym_volatile] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_DASH_PERCENT] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(993),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_await] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_resume] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [anon_sym_try] = ACTIONS(991),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_anyframe] = ACTIONS(991),
    [anon_sym_unreachable] = ACTIONS(991),
    [anon_sym_undefined] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(991),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_allowzero] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(993),
    [aux_sym_multiline_string_token1] = ACTIONS(993),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [sym_integer] = ACTIONS(991),
    [sym_float] = ACTIONS(993),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_bool] = ACTIONS(991),
    [anon_sym_f16] = ACTIONS(991),
    [anon_sym_f32] = ACTIONS(991),
    [anon_sym_f64] = ACTIONS(991),
    [anon_sym_f128] = ACTIONS(991),
    [anon_sym_void] = ACTIONS(991),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_anyerror] = ACTIONS(991),
    [anon_sym_anyopaque] = ACTIONS(991),
    [anon_sym_anytype] = ACTIONS(991),
    [anon_sym_noreturn] = ACTIONS(991),
    [anon_sym_isize] = ACTIONS(991),
    [anon_sym_usize] = ACTIONS(991),
    [anon_sym_comptime_int] = ACTIONS(991),
    [anon_sym_comptime_float] = ACTIONS(991),
    [anon_sym_c_short] = ACTIONS(991),
    [anon_sym_c_ushort] = ACTIONS(991),
    [anon_sym_c_int] = ACTIONS(991),
    [anon_sym_c_uint] = ACTIONS(991),
    [anon_sym_c_long] = ACTIONS(991),
    [anon_sym_c_ulong] = ACTIONS(991),
    [anon_sym_c_longlong] = ACTIONS(991),
    [anon_sym_c_ulonglong] = ACTIONS(991),
    [anon_sym_c_longdouble] = ACTIONS(991),
    [aux_sym_builtin_type_token1] = ACTIONS(991),
    [sym_builtin_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym__identifier] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(981),
    [anon_sym_test] = ACTIONS(981),
    [anon_sym_comptime] = ACTIONS(981),
    [anon_sym_export] = ACTIONS(981),
    [anon_sym_extern] = ACTIONS(981),
    [anon_sym_threadlocal] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(981),
    [anon_sym_var] = ACTIONS(981),
    [anon_sym_inline] = ACTIONS(981),
    [anon_sym_noinline] = ACTIONS(981),
    [anon_sym_fn] = ACTIONS(981),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(981),
    [anon_sym_struct] = ACTIONS(981),
    [anon_sym_opaque] = ACTIONS(981),
    [anon_sym_enum] = ACTIONS(981),
    [anon_sym_union] = ACTIONS(981),
    [anon_sym_error] = ACTIONS(981),
    [anon_sym_nosuspend] = ACTIONS(981),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_while] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_asm] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_DASH_PERCENT] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_async] = ACTIONS(981),
    [anon_sym_await] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [anon_sym_resume] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_try] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_anyframe] = ACTIONS(981),
    [anon_sym_unreachable] = ACTIONS(981),
    [anon_sym_undefined] = ACTIONS(981),
    [anon_sym_null] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(979),
    [aux_sym_multiline_string_token1] = ACTIONS(979),
    [anon_sym_SQUOTE] = ACTIONS(979),
    [sym_integer] = ACTIONS(981),
    [sym_float] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_bool] = ACTIONS(981),
    [anon_sym_f16] = ACTIONS(981),
    [anon_sym_f32] = ACTIONS(981),
    [anon_sym_f64] = ACTIONS(981),
    [anon_sym_f128] = ACTIONS(981),
    [anon_sym_void] = ACTIONS(981),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_anyerror] = ACTIONS(981),
    [anon_sym_anyopaque] = ACTIONS(981),
    [anon_sym_anytype] = ACTIONS(981),
    [anon_sym_noreturn] = ACTIONS(981),
    [anon_sym_isize] = ACTIONS(981),
    [anon_sym_usize] = ACTIONS(981),
    [anon_sym_comptime_int] = ACTIONS(981),
    [anon_sym_comptime_float] = ACTIONS(981),
    [anon_sym_c_short] = ACTIONS(981),
    [anon_sym_c_ushort] = ACTIONS(981),
    [anon_sym_c_int] = ACTIONS(981),
    [anon_sym_c_uint] = ACTIONS(981),
    [anon_sym_c_long] = ACTIONS(981),
    [anon_sym_c_ulong] = ACTIONS(981),
    [anon_sym_c_longlong] = ACTIONS(981),
    [anon_sym_c_ulonglong] = ACTIONS(981),
    [anon_sym_c_longdouble] = ACTIONS(981),
    [aux_sym_builtin_type_token1] = ACTIONS(981),
    [sym_builtin_identifier] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym__identifier] = ACTIONS(997),
    [anon_sym_pub] = ACTIONS(997),
    [anon_sym_test] = ACTIONS(997),
    [anon_sym_comptime] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(997),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_threadlocal] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_var] = ACTIONS(997),
    [anon_sym_inline] = ACTIONS(997),
    [anon_sym_noinline] = ACTIONS(997),
    [anon_sym_fn] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_usingnamespace] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_packed] = ACTIONS(997),
    [anon_sym_struct] = ACTIONS(997),
    [anon_sym_opaque] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [anon_sym_union] = ACTIONS(997),
    [anon_sym_error] = ACTIONS(997),
    [anon_sym_nosuspend] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_asm] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_DASH_PERCENT] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_resume] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_anyframe] = ACTIONS(997),
    [anon_sym_unreachable] = ACTIONS(997),
    [anon_sym_undefined] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [aux_sym_multiline_string_token1] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_bool] = ACTIONS(997),
    [anon_sym_f16] = ACTIONS(997),
    [anon_sym_f32] = ACTIONS(997),
    [anon_sym_f64] = ACTIONS(997),
    [anon_sym_f128] = ACTIONS(997),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_anyerror] = ACTIONS(997),
    [anon_sym_anyopaque] = ACTIONS(997),
    [anon_sym_anytype] = ACTIONS(997),
    [anon_sym_noreturn] = ACTIONS(997),
    [anon_sym_isize] = ACTIONS(997),
    [anon_sym_usize] = ACTIONS(997),
    [anon_sym_comptime_int] = ACTIONS(997),
    [anon_sym_comptime_float] = ACTIONS(997),
    [anon_sym_c_short] = ACTIONS(997),
    [anon_sym_c_ushort] = ACTIONS(997),
    [anon_sym_c_int] = ACTIONS(997),
    [anon_sym_c_uint] = ACTIONS(997),
    [anon_sym_c_long] = ACTIONS(997),
    [anon_sym_c_ulong] = ACTIONS(997),
    [anon_sym_c_longlong] = ACTIONS(997),
    [anon_sym_c_ulonglong] = ACTIONS(997),
    [anon_sym_c_longdouble] = ACTIONS(997),
    [aux_sym_builtin_type_token1] = ACTIONS(997),
    [sym_builtin_identifier] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym__identifier] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(989),
    [anon_sym_test] = ACTIONS(989),
    [anon_sym_comptime] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_extern] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(989),
    [anon_sym_var] = ACTIONS(989),
    [anon_sym_inline] = ACTIONS(989),
    [anon_sym_noinline] = ACTIONS(989),
    [anon_sym_fn] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(989),
    [anon_sym_struct] = ACTIONS(989),
    [anon_sym_opaque] = ACTIONS(989),
    [anon_sym_enum] = ACTIONS(989),
    [anon_sym_union] = ACTIONS(989),
    [anon_sym_error] = ACTIONS(989),
    [anon_sym_nosuspend] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_asm] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_resume] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_anyframe] = ACTIONS(989),
    [anon_sym_unreachable] = ACTIONS(989),
    [anon_sym_undefined] = ACTIONS(989),
    [anon_sym_null] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_multiline_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_bool] = ACTIONS(989),
    [anon_sym_f16] = ACTIONS(989),
    [anon_sym_f32] = ACTIONS(989),
    [anon_sym_f64] = ACTIONS(989),
    [anon_sym_f128] = ACTIONS(989),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_anyerror] = ACTIONS(989),
    [anon_sym_anyopaque] = ACTIONS(989),
    [anon_sym_anytype] = ACTIONS(989),
    [anon_sym_noreturn] = ACTIONS(989),
    [anon_sym_isize] = ACTIONS(989),
    [anon_sym_usize] = ACTIONS(989),
    [anon_sym_comptime_int] = ACTIONS(989),
    [anon_sym_comptime_float] = ACTIONS(989),
    [anon_sym_c_short] = ACTIONS(989),
    [anon_sym_c_ushort] = ACTIONS(989),
    [anon_sym_c_int] = ACTIONS(989),
    [anon_sym_c_uint] = ACTIONS(989),
    [anon_sym_c_long] = ACTIONS(989),
    [anon_sym_c_ulong] = ACTIONS(989),
    [anon_sym_c_longlong] = ACTIONS(989),
    [anon_sym_c_ulonglong] = ACTIONS(989),
    [anon_sym_c_longdouble] = ACTIONS(989),
    [aux_sym_builtin_type_token1] = ACTIONS(989),
    [sym_builtin_identifier] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym__identifier] = ACTIONS(661),
    [anon_sym_pub] = ACTIONS(661),
    [anon_sym_test] = ACTIONS(661),
    [anon_sym_comptime] = ACTIONS(661),
    [anon_sym_export] = ACTIONS(661),
    [anon_sym_extern] = ACTIONS(661),
    [anon_sym_threadlocal] = ACTIONS(661),
    [anon_sym_const] = ACTIONS(661),
    [anon_sym_var] = ACTIONS(661),
    [anon_sym_inline] = ACTIONS(661),
    [anon_sym_noinline] = ACTIONS(661),
    [anon_sym_fn] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_usingnamespace] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_packed] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_opaque] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_union] = ACTIONS(661),
    [anon_sym_error] = ACTIONS(661),
    [anon_sym_nosuspend] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(661),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_asm] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_DASH_PERCENT] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(661),
    [anon_sym_await] = ACTIONS(661),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_resume] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(661),
    [anon_sym_break] = ACTIONS(661),
    [anon_sym_try] = ACTIONS(661),
    [anon_sym_switch] = ACTIONS(661),
    [anon_sym_anyframe] = ACTIONS(661),
    [anon_sym_unreachable] = ACTIONS(661),
    [anon_sym_undefined] = ACTIONS(661),
    [anon_sym_null] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_DOT] = ACTIONS(659),
    [anon_sym_DQUOTE] = ACTIONS(659),
    [aux_sym_multiline_string_token1] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [sym_integer] = ACTIONS(661),
    [sym_float] = ACTIONS(659),
    [anon_sym_true] = ACTIONS(661),
    [anon_sym_false] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_f16] = ACTIONS(661),
    [anon_sym_f32] = ACTIONS(661),
    [anon_sym_f64] = ACTIONS(661),
    [anon_sym_f128] = ACTIONS(661),
    [anon_sym_void] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_anyerror] = ACTIONS(661),
    [anon_sym_anyopaque] = ACTIONS(661),
    [anon_sym_anytype] = ACTIONS(661),
    [anon_sym_noreturn] = ACTIONS(661),
    [anon_sym_isize] = ACTIONS(661),
    [anon_sym_usize] = ACTIONS(661),
    [anon_sym_comptime_int] = ACTIONS(661),
    [anon_sym_comptime_float] = ACTIONS(661),
    [anon_sym_c_short] = ACTIONS(661),
    [anon_sym_c_ushort] = ACTIONS(661),
    [anon_sym_c_int] = ACTIONS(661),
    [anon_sym_c_uint] = ACTIONS(661),
    [anon_sym_c_long] = ACTIONS(661),
    [anon_sym_c_ulong] = ACTIONS(661),
    [anon_sym_c_longlong] = ACTIONS(661),
    [anon_sym_c_ulonglong] = ACTIONS(661),
    [anon_sym_c_longdouble] = ACTIONS(661),
    [aux_sym_builtin_type_token1] = ACTIONS(661),
    [sym_builtin_identifier] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym__identifier] = ACTIONS(1001),
    [anon_sym_pub] = ACTIONS(1001),
    [anon_sym_test] = ACTIONS(1001),
    [anon_sym_comptime] = ACTIONS(1001),
    [anon_sym_export] = ACTIONS(1001),
    [anon_sym_extern] = ACTIONS(1001),
    [anon_sym_threadlocal] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1001),
    [anon_sym_var] = ACTIONS(1001),
    [anon_sym_inline] = ACTIONS(1001),
    [anon_sym_noinline] = ACTIONS(1001),
    [anon_sym_fn] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_usingnamespace] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_packed] = ACTIONS(1001),
    [anon_sym_struct] = ACTIONS(1001),
    [anon_sym_opaque] = ACTIONS(1001),
    [anon_sym_enum] = ACTIONS(1001),
    [anon_sym_union] = ACTIONS(1001),
    [anon_sym_error] = ACTIONS(1001),
    [anon_sym_nosuspend] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_STAR] = ACTIONS(999),
    [anon_sym_asm] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_DASH_PERCENT] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_resume] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1001),
    [anon_sym_anyframe] = ACTIONS(1001),
    [anon_sym_unreachable] = ACTIONS(1001),
    [anon_sym_undefined] = ACTIONS(1001),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [aux_sym_multiline_string_token1] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [sym_integer] = ACTIONS(1001),
    [sym_float] = ACTIONS(999),
    [anon_sym_true] = ACTIONS(1001),
    [anon_sym_false] = ACTIONS(1001),
    [anon_sym_bool] = ACTIONS(1001),
    [anon_sym_f16] = ACTIONS(1001),
    [anon_sym_f32] = ACTIONS(1001),
    [anon_sym_f64] = ACTIONS(1001),
    [anon_sym_f128] = ACTIONS(1001),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_type] = ACTIONS(1001),
    [anon_sym_anyerror] = ACTIONS(1001),
    [anon_sym_anyopaque] = ACTIONS(1001),
    [anon_sym_anytype] = ACTIONS(1001),
    [anon_sym_noreturn] = ACTIONS(1001),
    [anon_sym_isize] = ACTIONS(1001),
    [anon_sym_usize] = ACTIONS(1001),
    [anon_sym_comptime_int] = ACTIONS(1001),
    [anon_sym_comptime_float] = ACTIONS(1001),
    [anon_sym_c_short] = ACTIONS(1001),
    [anon_sym_c_ushort] = ACTIONS(1001),
    [anon_sym_c_int] = ACTIONS(1001),
    [anon_sym_c_uint] = ACTIONS(1001),
    [anon_sym_c_long] = ACTIONS(1001),
    [anon_sym_c_ulong] = ACTIONS(1001),
    [anon_sym_c_longlong] = ACTIONS(1001),
    [anon_sym_c_ulonglong] = ACTIONS(1001),
    [anon_sym_c_longdouble] = ACTIONS(1001),
    [aux_sym_builtin_type_token1] = ACTIONS(1001),
    [sym_builtin_identifier] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(1003),
    [sym__identifier] = ACTIONS(1005),
    [anon_sym_pub] = ACTIONS(1005),
    [anon_sym_test] = ACTIONS(1005),
    [anon_sym_comptime] = ACTIONS(1005),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_extern] = ACTIONS(1005),
    [anon_sym_threadlocal] = ACTIONS(1005),
    [anon_sym_const] = ACTIONS(1005),
    [anon_sym_var] = ACTIONS(1005),
    [anon_sym_inline] = ACTIONS(1005),
    [anon_sym_noinline] = ACTIONS(1005),
    [anon_sym_fn] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_usingnamespace] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_packed] = ACTIONS(1005),
    [anon_sym_struct] = ACTIONS(1005),
    [anon_sym_opaque] = ACTIONS(1005),
    [anon_sym_enum] = ACTIONS(1005),
    [anon_sym_union] = ACTIONS(1005),
    [anon_sym_error] = ACTIONS(1005),
    [anon_sym_nosuspend] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_asm] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_DASH_PERCENT] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_async] = ACTIONS(1005),
    [anon_sym_await] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [anon_sym_resume] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_try] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1005),
    [anon_sym_anyframe] = ACTIONS(1005),
    [anon_sym_unreachable] = ACTIONS(1005),
    [anon_sym_undefined] = ACTIONS(1005),
    [anon_sym_null] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [aux_sym_multiline_string_token1] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1005),
    [sym_float] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1005),
    [anon_sym_false] = ACTIONS(1005),
    [anon_sym_bool] = ACTIONS(1005),
    [anon_sym_f16] = ACTIONS(1005),
    [anon_sym_f32] = ACTIONS(1005),
    [anon_sym_f64] = ACTIONS(1005),
    [anon_sym_f128] = ACTIONS(1005),
    [anon_sym_void] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_anyerror] = ACTIONS(1005),
    [anon_sym_anyopaque] = ACTIONS(1005),
    [anon_sym_anytype] = ACTIONS(1005),
    [anon_sym_noreturn] = ACTIONS(1005),
    [anon_sym_isize] = ACTIONS(1005),
    [anon_sym_usize] = ACTIONS(1005),
    [anon_sym_comptime_int] = ACTIONS(1005),
    [anon_sym_comptime_float] = ACTIONS(1005),
    [anon_sym_c_short] = ACTIONS(1005),
    [anon_sym_c_ushort] = ACTIONS(1005),
    [anon_sym_c_int] = ACTIONS(1005),
    [anon_sym_c_uint] = ACTIONS(1005),
    [anon_sym_c_long] = ACTIONS(1005),
    [anon_sym_c_ulong] = ACTIONS(1005),
    [anon_sym_c_longlong] = ACTIONS(1005),
    [anon_sym_c_ulonglong] = ACTIONS(1005),
    [anon_sym_c_longdouble] = ACTIONS(1005),
    [aux_sym_builtin_type_token1] = ACTIONS(1005),
    [sym_builtin_identifier] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym__identifier] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(989),
    [anon_sym_test] = ACTIONS(989),
    [anon_sym_comptime] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_extern] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(989),
    [anon_sym_var] = ACTIONS(989),
    [anon_sym_inline] = ACTIONS(989),
    [anon_sym_noinline] = ACTIONS(989),
    [anon_sym_fn] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(989),
    [anon_sym_struct] = ACTIONS(989),
    [anon_sym_opaque] = ACTIONS(989),
    [anon_sym_enum] = ACTIONS(989),
    [anon_sym_union] = ACTIONS(989),
    [anon_sym_error] = ACTIONS(989),
    [anon_sym_nosuspend] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_asm] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_resume] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_anyframe] = ACTIONS(989),
    [anon_sym_unreachable] = ACTIONS(989),
    [anon_sym_undefined] = ACTIONS(989),
    [anon_sym_null] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_multiline_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_bool] = ACTIONS(989),
    [anon_sym_f16] = ACTIONS(989),
    [anon_sym_f32] = ACTIONS(989),
    [anon_sym_f64] = ACTIONS(989),
    [anon_sym_f128] = ACTIONS(989),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_anyerror] = ACTIONS(989),
    [anon_sym_anyopaque] = ACTIONS(989),
    [anon_sym_anytype] = ACTIONS(989),
    [anon_sym_noreturn] = ACTIONS(989),
    [anon_sym_isize] = ACTIONS(989),
    [anon_sym_usize] = ACTIONS(989),
    [anon_sym_comptime_int] = ACTIONS(989),
    [anon_sym_comptime_float] = ACTIONS(989),
    [anon_sym_c_short] = ACTIONS(989),
    [anon_sym_c_ushort] = ACTIONS(989),
    [anon_sym_c_int] = ACTIONS(989),
    [anon_sym_c_uint] = ACTIONS(989),
    [anon_sym_c_long] = ACTIONS(989),
    [anon_sym_c_ulong] = ACTIONS(989),
    [anon_sym_c_longlong] = ACTIONS(989),
    [anon_sym_c_ulonglong] = ACTIONS(989),
    [anon_sym_c_longdouble] = ACTIONS(989),
    [aux_sym_builtin_type_token1] = ACTIONS(989),
    [sym_builtin_identifier] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(1007),
    [sym__identifier] = ACTIONS(1009),
    [anon_sym_pub] = ACTIONS(1009),
    [anon_sym_test] = ACTIONS(1009),
    [anon_sym_comptime] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_extern] = ACTIONS(1009),
    [anon_sym_threadlocal] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_var] = ACTIONS(1009),
    [anon_sym_inline] = ACTIONS(1009),
    [anon_sym_noinline] = ACTIONS(1009),
    [anon_sym_fn] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_usingnamespace] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_packed] = ACTIONS(1009),
    [anon_sym_struct] = ACTIONS(1009),
    [anon_sym_opaque] = ACTIONS(1009),
    [anon_sym_enum] = ACTIONS(1009),
    [anon_sym_union] = ACTIONS(1009),
    [anon_sym_error] = ACTIONS(1009),
    [anon_sym_nosuspend] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_asm] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASH_PERCENT] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_resume] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_anyframe] = ACTIONS(1009),
    [anon_sym_unreachable] = ACTIONS(1009),
    [anon_sym_undefined] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [aux_sym_multiline_string_token1] = ACTIONS(1007),
    [anon_sym_SQUOTE] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1009),
    [anon_sym_false] = ACTIONS(1009),
    [anon_sym_bool] = ACTIONS(1009),
    [anon_sym_f16] = ACTIONS(1009),
    [anon_sym_f32] = ACTIONS(1009),
    [anon_sym_f64] = ACTIONS(1009),
    [anon_sym_f128] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_anyerror] = ACTIONS(1009),
    [anon_sym_anyopaque] = ACTIONS(1009),
    [anon_sym_anytype] = ACTIONS(1009),
    [anon_sym_noreturn] = ACTIONS(1009),
    [anon_sym_isize] = ACTIONS(1009),
    [anon_sym_usize] = ACTIONS(1009),
    [anon_sym_comptime_int] = ACTIONS(1009),
    [anon_sym_comptime_float] = ACTIONS(1009),
    [anon_sym_c_short] = ACTIONS(1009),
    [anon_sym_c_ushort] = ACTIONS(1009),
    [anon_sym_c_int] = ACTIONS(1009),
    [anon_sym_c_uint] = ACTIONS(1009),
    [anon_sym_c_long] = ACTIONS(1009),
    [anon_sym_c_ulong] = ACTIONS(1009),
    [anon_sym_c_longlong] = ACTIONS(1009),
    [anon_sym_c_ulonglong] = ACTIONS(1009),
    [anon_sym_c_longdouble] = ACTIONS(1009),
    [aux_sym_builtin_type_token1] = ACTIONS(1009),
    [sym_builtin_identifier] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym__identifier] = ACTIONS(1013),
    [anon_sym_pub] = ACTIONS(1013),
    [anon_sym_test] = ACTIONS(1013),
    [anon_sym_comptime] = ACTIONS(1013),
    [anon_sym_export] = ACTIONS(1013),
    [anon_sym_extern] = ACTIONS(1013),
    [anon_sym_threadlocal] = ACTIONS(1013),
    [anon_sym_const] = ACTIONS(1013),
    [anon_sym_var] = ACTIONS(1013),
    [anon_sym_inline] = ACTIONS(1013),
    [anon_sym_noinline] = ACTIONS(1013),
    [anon_sym_fn] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_usingnamespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_packed] = ACTIONS(1013),
    [anon_sym_struct] = ACTIONS(1013),
    [anon_sym_opaque] = ACTIONS(1013),
    [anon_sym_enum] = ACTIONS(1013),
    [anon_sym_union] = ACTIONS(1013),
    [anon_sym_error] = ACTIONS(1013),
    [anon_sym_nosuspend] = ACTIONS(1013),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_for] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_asm] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_DASH_PERCENT] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_await] = ACTIONS(1013),
    [anon_sym_continue] = ACTIONS(1013),
    [anon_sym_resume] = ACTIONS(1013),
    [anon_sym_return] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1013),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_switch] = ACTIONS(1013),
    [anon_sym_anyframe] = ACTIONS(1013),
    [anon_sym_unreachable] = ACTIONS(1013),
    [anon_sym_undefined] = ACTIONS(1013),
    [anon_sym_null] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1011),
    [anon_sym_DQUOTE] = ACTIONS(1011),
    [aux_sym_multiline_string_token1] = ACTIONS(1011),
    [anon_sym_SQUOTE] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1013),
    [sym_float] = ACTIONS(1011),
    [anon_sym_true] = ACTIONS(1013),
    [anon_sym_false] = ACTIONS(1013),
    [anon_sym_bool] = ACTIONS(1013),
    [anon_sym_f16] = ACTIONS(1013),
    [anon_sym_f32] = ACTIONS(1013),
    [anon_sym_f64] = ACTIONS(1013),
    [anon_sym_f128] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(1013),
    [anon_sym_type] = ACTIONS(1013),
    [anon_sym_anyerror] = ACTIONS(1013),
    [anon_sym_anyopaque] = ACTIONS(1013),
    [anon_sym_anytype] = ACTIONS(1013),
    [anon_sym_noreturn] = ACTIONS(1013),
    [anon_sym_isize] = ACTIONS(1013),
    [anon_sym_usize] = ACTIONS(1013),
    [anon_sym_comptime_int] = ACTIONS(1013),
    [anon_sym_comptime_float] = ACTIONS(1013),
    [anon_sym_c_short] = ACTIONS(1013),
    [anon_sym_c_ushort] = ACTIONS(1013),
    [anon_sym_c_int] = ACTIONS(1013),
    [anon_sym_c_uint] = ACTIONS(1013),
    [anon_sym_c_long] = ACTIONS(1013),
    [anon_sym_c_ulong] = ACTIONS(1013),
    [anon_sym_c_longlong] = ACTIONS(1013),
    [anon_sym_c_ulonglong] = ACTIONS(1013),
    [anon_sym_c_longdouble] = ACTIONS(1013),
    [aux_sym_builtin_type_token1] = ACTIONS(1013),
    [sym_builtin_identifier] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym__identifier] = ACTIONS(1017),
    [anon_sym_pub] = ACTIONS(1017),
    [anon_sym_test] = ACTIONS(1017),
    [anon_sym_comptime] = ACTIONS(1017),
    [anon_sym_export] = ACTIONS(1017),
    [anon_sym_extern] = ACTIONS(1017),
    [anon_sym_threadlocal] = ACTIONS(1017),
    [anon_sym_const] = ACTIONS(1017),
    [anon_sym_var] = ACTIONS(1017),
    [anon_sym_inline] = ACTIONS(1017),
    [anon_sym_noinline] = ACTIONS(1017),
    [anon_sym_fn] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_usingnamespace] = ACTIONS(1017),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_packed] = ACTIONS(1017),
    [anon_sym_struct] = ACTIONS(1017),
    [anon_sym_opaque] = ACTIONS(1017),
    [anon_sym_enum] = ACTIONS(1017),
    [anon_sym_union] = ACTIONS(1017),
    [anon_sym_error] = ACTIONS(1017),
    [anon_sym_nosuspend] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_STAR] = ACTIONS(1015),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_DASH_PERCENT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_await] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_resume] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_switch] = ACTIONS(1017),
    [anon_sym_anyframe] = ACTIONS(1017),
    [anon_sym_unreachable] = ACTIONS(1017),
    [anon_sym_undefined] = ACTIONS(1017),
    [anon_sym_null] = ACTIONS(1017),
    [anon_sym_QMARK] = ACTIONS(1015),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [aux_sym_multiline_string_token1] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [sym_integer] = ACTIONS(1017),
    [sym_float] = ACTIONS(1015),
    [anon_sym_true] = ACTIONS(1017),
    [anon_sym_false] = ACTIONS(1017),
    [anon_sym_bool] = ACTIONS(1017),
    [anon_sym_f16] = ACTIONS(1017),
    [anon_sym_f32] = ACTIONS(1017),
    [anon_sym_f64] = ACTIONS(1017),
    [anon_sym_f128] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_type] = ACTIONS(1017),
    [anon_sym_anyerror] = ACTIONS(1017),
    [anon_sym_anyopaque] = ACTIONS(1017),
    [anon_sym_anytype] = ACTIONS(1017),
    [anon_sym_noreturn] = ACTIONS(1017),
    [anon_sym_isize] = ACTIONS(1017),
    [anon_sym_usize] = ACTIONS(1017),
    [anon_sym_comptime_int] = ACTIONS(1017),
    [anon_sym_comptime_float] = ACTIONS(1017),
    [anon_sym_c_short] = ACTIONS(1017),
    [anon_sym_c_ushort] = ACTIONS(1017),
    [anon_sym_c_int] = ACTIONS(1017),
    [anon_sym_c_uint] = ACTIONS(1017),
    [anon_sym_c_long] = ACTIONS(1017),
    [anon_sym_c_ulong] = ACTIONS(1017),
    [anon_sym_c_longlong] = ACTIONS(1017),
    [anon_sym_c_ulonglong] = ACTIONS(1017),
    [anon_sym_c_longdouble] = ACTIONS(1017),
    [aux_sym_builtin_type_token1] = ACTIONS(1017),
    [sym_builtin_identifier] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(1007),
    [sym__identifier] = ACTIONS(1009),
    [anon_sym_pub] = ACTIONS(1009),
    [anon_sym_test] = ACTIONS(1009),
    [anon_sym_comptime] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_extern] = ACTIONS(1009),
    [anon_sym_threadlocal] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_var] = ACTIONS(1009),
    [anon_sym_inline] = ACTIONS(1009),
    [anon_sym_noinline] = ACTIONS(1009),
    [anon_sym_fn] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_usingnamespace] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_packed] = ACTIONS(1009),
    [anon_sym_struct] = ACTIONS(1009),
    [anon_sym_opaque] = ACTIONS(1009),
    [anon_sym_enum] = ACTIONS(1009),
    [anon_sym_union] = ACTIONS(1009),
    [anon_sym_error] = ACTIONS(1009),
    [anon_sym_nosuspend] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_asm] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASH_PERCENT] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_resume] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_anyframe] = ACTIONS(1009),
    [anon_sym_unreachable] = ACTIONS(1009),
    [anon_sym_undefined] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [aux_sym_multiline_string_token1] = ACTIONS(1007),
    [anon_sym_SQUOTE] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1009),
    [anon_sym_false] = ACTIONS(1009),
    [anon_sym_bool] = ACTIONS(1009),
    [anon_sym_f16] = ACTIONS(1009),
    [anon_sym_f32] = ACTIONS(1009),
    [anon_sym_f64] = ACTIONS(1009),
    [anon_sym_f128] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_anyerror] = ACTIONS(1009),
    [anon_sym_anyopaque] = ACTIONS(1009),
    [anon_sym_anytype] = ACTIONS(1009),
    [anon_sym_noreturn] = ACTIONS(1009),
    [anon_sym_isize] = ACTIONS(1009),
    [anon_sym_usize] = ACTIONS(1009),
    [anon_sym_comptime_int] = ACTIONS(1009),
    [anon_sym_comptime_float] = ACTIONS(1009),
    [anon_sym_c_short] = ACTIONS(1009),
    [anon_sym_c_ushort] = ACTIONS(1009),
    [anon_sym_c_int] = ACTIONS(1009),
    [anon_sym_c_uint] = ACTIONS(1009),
    [anon_sym_c_long] = ACTIONS(1009),
    [anon_sym_c_ulong] = ACTIONS(1009),
    [anon_sym_c_longlong] = ACTIONS(1009),
    [anon_sym_c_ulonglong] = ACTIONS(1009),
    [anon_sym_c_longdouble] = ACTIONS(1009),
    [aux_sym_builtin_type_token1] = ACTIONS(1009),
    [sym_builtin_identifier] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym__identifier] = ACTIONS(1021),
    [anon_sym_pub] = ACTIONS(1021),
    [anon_sym_test] = ACTIONS(1021),
    [anon_sym_comptime] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_threadlocal] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_noinline] = ACTIONS(1021),
    [anon_sym_fn] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_usingnamespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_packed] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_opaque] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_error] = ACTIONS(1021),
    [anon_sym_nosuspend] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_asm] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_DASH_PERCENT] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_resume] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_anyframe] = ACTIONS(1021),
    [anon_sym_unreachable] = ACTIONS(1021),
    [anon_sym_undefined] = ACTIONS(1021),
    [anon_sym_null] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_multiline_string_token1] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1021),
    [sym_float] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_bool] = ACTIONS(1021),
    [anon_sym_f16] = ACTIONS(1021),
    [anon_sym_f32] = ACTIONS(1021),
    [anon_sym_f64] = ACTIONS(1021),
    [anon_sym_f128] = ACTIONS(1021),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_anyerror] = ACTIONS(1021),
    [anon_sym_anyopaque] = ACTIONS(1021),
    [anon_sym_anytype] = ACTIONS(1021),
    [anon_sym_noreturn] = ACTIONS(1021),
    [anon_sym_isize] = ACTIONS(1021),
    [anon_sym_usize] = ACTIONS(1021),
    [anon_sym_comptime_int] = ACTIONS(1021),
    [anon_sym_comptime_float] = ACTIONS(1021),
    [anon_sym_c_short] = ACTIONS(1021),
    [anon_sym_c_ushort] = ACTIONS(1021),
    [anon_sym_c_int] = ACTIONS(1021),
    [anon_sym_c_uint] = ACTIONS(1021),
    [anon_sym_c_long] = ACTIONS(1021),
    [anon_sym_c_ulong] = ACTIONS(1021),
    [anon_sym_c_longlong] = ACTIONS(1021),
    [anon_sym_c_ulonglong] = ACTIONS(1021),
    [anon_sym_c_longdouble] = ACTIONS(1021),
    [aux_sym_builtin_type_token1] = ACTIONS(1021),
    [sym_builtin_identifier] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym__identifier] = ACTIONS(1025),
    [anon_sym_pub] = ACTIONS(1025),
    [anon_sym_test] = ACTIONS(1025),
    [anon_sym_comptime] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_extern] = ACTIONS(1025),
    [anon_sym_threadlocal] = ACTIONS(1025),
    [anon_sym_const] = ACTIONS(1025),
    [anon_sym_var] = ACTIONS(1025),
    [anon_sym_inline] = ACTIONS(1025),
    [anon_sym_noinline] = ACTIONS(1025),
    [anon_sym_fn] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_usingnamespace] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_packed] = ACTIONS(1025),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_opaque] = ACTIONS(1025),
    [anon_sym_enum] = ACTIONS(1025),
    [anon_sym_union] = ACTIONS(1025),
    [anon_sym_error] = ACTIONS(1025),
    [anon_sym_nosuspend] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_asm] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_DASH_PERCENT] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [anon_sym_resume] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_try] = ACTIONS(1025),
    [anon_sym_switch] = ACTIONS(1025),
    [anon_sym_anyframe] = ACTIONS(1025),
    [anon_sym_unreachable] = ACTIONS(1025),
    [anon_sym_undefined] = ACTIONS(1025),
    [anon_sym_null] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [aux_sym_multiline_string_token1] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1025),
    [sym_float] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1025),
    [anon_sym_false] = ACTIONS(1025),
    [anon_sym_bool] = ACTIONS(1025),
    [anon_sym_f16] = ACTIONS(1025),
    [anon_sym_f32] = ACTIONS(1025),
    [anon_sym_f64] = ACTIONS(1025),
    [anon_sym_f128] = ACTIONS(1025),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_anyerror] = ACTIONS(1025),
    [anon_sym_anyopaque] = ACTIONS(1025),
    [anon_sym_anytype] = ACTIONS(1025),
    [anon_sym_noreturn] = ACTIONS(1025),
    [anon_sym_isize] = ACTIONS(1025),
    [anon_sym_usize] = ACTIONS(1025),
    [anon_sym_comptime_int] = ACTIONS(1025),
    [anon_sym_comptime_float] = ACTIONS(1025),
    [anon_sym_c_short] = ACTIONS(1025),
    [anon_sym_c_ushort] = ACTIONS(1025),
    [anon_sym_c_int] = ACTIONS(1025),
    [anon_sym_c_uint] = ACTIONS(1025),
    [anon_sym_c_long] = ACTIONS(1025),
    [anon_sym_c_ulong] = ACTIONS(1025),
    [anon_sym_c_longlong] = ACTIONS(1025),
    [anon_sym_c_ulonglong] = ACTIONS(1025),
    [anon_sym_c_longdouble] = ACTIONS(1025),
    [aux_sym_builtin_type_token1] = ACTIONS(1025),
    [sym_builtin_identifier] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(349),
    [sym__identifier] = ACTIONS(1027),
    [anon_sym_pub] = ACTIONS(1027),
    [anon_sym_test] = ACTIONS(1027),
    [anon_sym_comptime] = ACTIONS(1027),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_extern] = ACTIONS(1027),
    [anon_sym_threadlocal] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_var] = ACTIONS(1027),
    [anon_sym_inline] = ACTIONS(1027),
    [anon_sym_noinline] = ACTIONS(1027),
    [anon_sym_fn] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_usingnamespace] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(349),
    [anon_sym_RBRACE] = ACTIONS(349),
    [anon_sym_packed] = ACTIONS(1027),
    [anon_sym_struct] = ACTIONS(1027),
    [anon_sym_opaque] = ACTIONS(1027),
    [anon_sym_enum] = ACTIONS(1027),
    [anon_sym_union] = ACTIONS(1027),
    [anon_sym_error] = ACTIONS(1027),
    [anon_sym_nosuspend] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(349),
    [anon_sym_asm] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(349),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_DASH_PERCENT] = ACTIONS(349),
    [anon_sym_AMP] = ACTIONS(349),
    [anon_sym_async] = ACTIONS(1027),
    [anon_sym_await] = ACTIONS(1027),
    [anon_sym_continue] = ACTIONS(1027),
    [anon_sym_resume] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1027),
    [anon_sym_switch] = ACTIONS(1027),
    [anon_sym_anyframe] = ACTIONS(1027),
    [anon_sym_unreachable] = ACTIONS(1027),
    [anon_sym_undefined] = ACTIONS(1027),
    [anon_sym_null] = ACTIONS(1027),
    [anon_sym_QMARK] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(349),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [aux_sym_multiline_string_token1] = ACTIONS(349),
    [anon_sym_SQUOTE] = ACTIONS(349),
    [sym_integer] = ACTIONS(1027),
    [sym_float] = ACTIONS(349),
    [anon_sym_true] = ACTIONS(1027),
    [anon_sym_false] = ACTIONS(1027),
    [anon_sym_bool] = ACTIONS(1027),
    [anon_sym_f16] = ACTIONS(1027),
    [anon_sym_f32] = ACTIONS(1027),
    [anon_sym_f64] = ACTIONS(1027),
    [anon_sym_f128] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_anyerror] = ACTIONS(1027),
    [anon_sym_anyopaque] = ACTIONS(1027),
    [anon_sym_anytype] = ACTIONS(1027),
    [anon_sym_noreturn] = ACTIONS(1027),
    [anon_sym_isize] = ACTIONS(1027),
    [anon_sym_usize] = ACTIONS(1027),
    [anon_sym_comptime_int] = ACTIONS(1027),
    [anon_sym_comptime_float] = ACTIONS(1027),
    [anon_sym_c_short] = ACTIONS(1027),
    [anon_sym_c_ushort] = ACTIONS(1027),
    [anon_sym_c_int] = ACTIONS(1027),
    [anon_sym_c_uint] = ACTIONS(1027),
    [anon_sym_c_long] = ACTIONS(1027),
    [anon_sym_c_ulong] = ACTIONS(1027),
    [anon_sym_c_longlong] = ACTIONS(1027),
    [anon_sym_c_ulonglong] = ACTIONS(1027),
    [anon_sym_c_longdouble] = ACTIONS(1027),
    [aux_sym_builtin_type_token1] = ACTIONS(1027),
    [sym_builtin_identifier] = ACTIONS(349),
    [anon_sym_AT] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym__identifier] = ACTIONS(1031),
    [anon_sym_pub] = ACTIONS(1031),
    [anon_sym_test] = ACTIONS(1031),
    [anon_sym_comptime] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_extern] = ACTIONS(1031),
    [anon_sym_threadlocal] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_inline] = ACTIONS(1031),
    [anon_sym_noinline] = ACTIONS(1031),
    [anon_sym_fn] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_usingnamespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_packed] = ACTIONS(1031),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_opaque] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1031),
    [anon_sym_error] = ACTIONS(1031),
    [anon_sym_nosuspend] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_asm] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_DASH_PERCENT] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_resume] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_anyframe] = ACTIONS(1031),
    [anon_sym_unreachable] = ACTIONS(1031),
    [anon_sym_undefined] = ACTIONS(1031),
    [anon_sym_null] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [aux_sym_multiline_string_token1] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1031),
    [sym_float] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1031),
    [anon_sym_false] = ACTIONS(1031),
    [anon_sym_bool] = ACTIONS(1031),
    [anon_sym_f16] = ACTIONS(1031),
    [anon_sym_f32] = ACTIONS(1031),
    [anon_sym_f64] = ACTIONS(1031),
    [anon_sym_f128] = ACTIONS(1031),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_anyerror] = ACTIONS(1031),
    [anon_sym_anyopaque] = ACTIONS(1031),
    [anon_sym_anytype] = ACTIONS(1031),
    [anon_sym_noreturn] = ACTIONS(1031),
    [anon_sym_isize] = ACTIONS(1031),
    [anon_sym_usize] = ACTIONS(1031),
    [anon_sym_comptime_int] = ACTIONS(1031),
    [anon_sym_comptime_float] = ACTIONS(1031),
    [anon_sym_c_short] = ACTIONS(1031),
    [anon_sym_c_ushort] = ACTIONS(1031),
    [anon_sym_c_int] = ACTIONS(1031),
    [anon_sym_c_uint] = ACTIONS(1031),
    [anon_sym_c_long] = ACTIONS(1031),
    [anon_sym_c_ulong] = ACTIONS(1031),
    [anon_sym_c_longlong] = ACTIONS(1031),
    [anon_sym_c_ulonglong] = ACTIONS(1031),
    [anon_sym_c_longdouble] = ACTIONS(1031),
    [aux_sym_builtin_type_token1] = ACTIONS(1031),
    [sym_builtin_identifier] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym__identifier] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(989),
    [anon_sym_test] = ACTIONS(989),
    [anon_sym_comptime] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_extern] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(989),
    [anon_sym_var] = ACTIONS(989),
    [anon_sym_inline] = ACTIONS(989),
    [anon_sym_noinline] = ACTIONS(989),
    [anon_sym_fn] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(989),
    [anon_sym_struct] = ACTIONS(989),
    [anon_sym_opaque] = ACTIONS(989),
    [anon_sym_enum] = ACTIONS(989),
    [anon_sym_union] = ACTIONS(989),
    [anon_sym_error] = ACTIONS(989),
    [anon_sym_nosuspend] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_asm] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_resume] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_anyframe] = ACTIONS(989),
    [anon_sym_unreachable] = ACTIONS(989),
    [anon_sym_undefined] = ACTIONS(989),
    [anon_sym_null] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_multiline_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_bool] = ACTIONS(989),
    [anon_sym_f16] = ACTIONS(989),
    [anon_sym_f32] = ACTIONS(989),
    [anon_sym_f64] = ACTIONS(989),
    [anon_sym_f128] = ACTIONS(989),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_anyerror] = ACTIONS(989),
    [anon_sym_anyopaque] = ACTIONS(989),
    [anon_sym_anytype] = ACTIONS(989),
    [anon_sym_noreturn] = ACTIONS(989),
    [anon_sym_isize] = ACTIONS(989),
    [anon_sym_usize] = ACTIONS(989),
    [anon_sym_comptime_int] = ACTIONS(989),
    [anon_sym_comptime_float] = ACTIONS(989),
    [anon_sym_c_short] = ACTIONS(989),
    [anon_sym_c_ushort] = ACTIONS(989),
    [anon_sym_c_int] = ACTIONS(989),
    [anon_sym_c_uint] = ACTIONS(989),
    [anon_sym_c_long] = ACTIONS(989),
    [anon_sym_c_ulong] = ACTIONS(989),
    [anon_sym_c_longlong] = ACTIONS(989),
    [anon_sym_c_ulonglong] = ACTIONS(989),
    [anon_sym_c_longdouble] = ACTIONS(989),
    [aux_sym_builtin_type_token1] = ACTIONS(989),
    [sym_builtin_identifier] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym__identifier] = ACTIONS(1035),
    [anon_sym_pub] = ACTIONS(1035),
    [anon_sym_test] = ACTIONS(1035),
    [anon_sym_comptime] = ACTIONS(1035),
    [anon_sym_export] = ACTIONS(1035),
    [anon_sym_extern] = ACTIONS(1035),
    [anon_sym_threadlocal] = ACTIONS(1035),
    [anon_sym_const] = ACTIONS(1035),
    [anon_sym_var] = ACTIONS(1035),
    [anon_sym_inline] = ACTIONS(1035),
    [anon_sym_noinline] = ACTIONS(1035),
    [anon_sym_fn] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_usingnamespace] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_packed] = ACTIONS(1035),
    [anon_sym_struct] = ACTIONS(1035),
    [anon_sym_opaque] = ACTIONS(1035),
    [anon_sym_enum] = ACTIONS(1035),
    [anon_sym_union] = ACTIONS(1035),
    [anon_sym_error] = ACTIONS(1035),
    [anon_sym_nosuspend] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_for] = ACTIONS(1035),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_asm] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1035),
    [anon_sym_continue] = ACTIONS(1035),
    [anon_sym_resume] = ACTIONS(1035),
    [anon_sym_return] = ACTIONS(1035),
    [anon_sym_break] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_switch] = ACTIONS(1035),
    [anon_sym_anyframe] = ACTIONS(1035),
    [anon_sym_unreachable] = ACTIONS(1035),
    [anon_sym_undefined] = ACTIONS(1035),
    [anon_sym_null] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [aux_sym_multiline_string_token1] = ACTIONS(1033),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [sym_integer] = ACTIONS(1035),
    [sym_float] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1035),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_bool] = ACTIONS(1035),
    [anon_sym_f16] = ACTIONS(1035),
    [anon_sym_f32] = ACTIONS(1035),
    [anon_sym_f64] = ACTIONS(1035),
    [anon_sym_f128] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1035),
    [anon_sym_type] = ACTIONS(1035),
    [anon_sym_anyerror] = ACTIONS(1035),
    [anon_sym_anyopaque] = ACTIONS(1035),
    [anon_sym_anytype] = ACTIONS(1035),
    [anon_sym_noreturn] = ACTIONS(1035),
    [anon_sym_isize] = ACTIONS(1035),
    [anon_sym_usize] = ACTIONS(1035),
    [anon_sym_comptime_int] = ACTIONS(1035),
    [anon_sym_comptime_float] = ACTIONS(1035),
    [anon_sym_c_short] = ACTIONS(1035),
    [anon_sym_c_ushort] = ACTIONS(1035),
    [anon_sym_c_int] = ACTIONS(1035),
    [anon_sym_c_uint] = ACTIONS(1035),
    [anon_sym_c_long] = ACTIONS(1035),
    [anon_sym_c_ulong] = ACTIONS(1035),
    [anon_sym_c_longlong] = ACTIONS(1035),
    [anon_sym_c_ulonglong] = ACTIONS(1035),
    [anon_sym_c_longdouble] = ACTIONS(1035),
    [aux_sym_builtin_type_token1] = ACTIONS(1035),
    [sym_builtin_identifier] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(1035),
    [sym_comment] = ACTIONS(3),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym__identifier] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1039),
    [anon_sym_test] = ACTIONS(1039),
    [anon_sym_comptime] = ACTIONS(1039),
    [anon_sym_export] = ACTIONS(1039),
    [anon_sym_extern] = ACTIONS(1039),
    [anon_sym_threadlocal] = ACTIONS(1039),
    [anon_sym_const] = ACTIONS(1039),
    [anon_sym_var] = ACTIONS(1039),
    [anon_sym_inline] = ACTIONS(1039),
    [anon_sym_noinline] = ACTIONS(1039),
    [anon_sym_fn] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_usingnamespace] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_packed] = ACTIONS(1039),
    [anon_sym_struct] = ACTIONS(1039),
    [anon_sym_opaque] = ACTIONS(1039),
    [anon_sym_enum] = ACTIONS(1039),
    [anon_sym_union] = ACTIONS(1039),
    [anon_sym_error] = ACTIONS(1039),
    [anon_sym_nosuspend] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_asm] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(1037),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_resume] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1039),
    [anon_sym_anyframe] = ACTIONS(1039),
    [anon_sym_unreachable] = ACTIONS(1039),
    [anon_sym_undefined] = ACTIONS(1039),
    [anon_sym_null] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1037),
    [anon_sym_DOT] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [aux_sym_multiline_string_token1] = ACTIONS(1037),
    [anon_sym_SQUOTE] = ACTIONS(1037),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(1037),
    [anon_sym_true] = ACTIONS(1039),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_bool] = ACTIONS(1039),
    [anon_sym_f16] = ACTIONS(1039),
    [anon_sym_f32] = ACTIONS(1039),
    [anon_sym_f64] = ACTIONS(1039),
    [anon_sym_f128] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1039),
    [anon_sym_anyerror] = ACTIONS(1039),
    [anon_sym_anyopaque] = ACTIONS(1039),
    [anon_sym_anytype] = ACTIONS(1039),
    [anon_sym_noreturn] = ACTIONS(1039),
    [anon_sym_isize] = ACTIONS(1039),
    [anon_sym_usize] = ACTIONS(1039),
    [anon_sym_comptime_int] = ACTIONS(1039),
    [anon_sym_comptime_float] = ACTIONS(1039),
    [anon_sym_c_short] = ACTIONS(1039),
    [anon_sym_c_ushort] = ACTIONS(1039),
    [anon_sym_c_int] = ACTIONS(1039),
    [anon_sym_c_uint] = ACTIONS(1039),
    [anon_sym_c_long] = ACTIONS(1039),
    [anon_sym_c_ulong] = ACTIONS(1039),
    [anon_sym_c_longlong] = ACTIONS(1039),
    [anon_sym_c_ulonglong] = ACTIONS(1039),
    [anon_sym_c_longdouble] = ACTIONS(1039),
    [aux_sym_builtin_type_token1] = ACTIONS(1039),
    [sym_builtin_identifier] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(1041),
    [sym__identifier] = ACTIONS(1043),
    [anon_sym_pub] = ACTIONS(1043),
    [anon_sym_test] = ACTIONS(1043),
    [anon_sym_comptime] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1043),
    [anon_sym_extern] = ACTIONS(1043),
    [anon_sym_threadlocal] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_var] = ACTIONS(1043),
    [anon_sym_inline] = ACTIONS(1043),
    [anon_sym_noinline] = ACTIONS(1043),
    [anon_sym_fn] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1043),
    [anon_sym_struct] = ACTIONS(1043),
    [anon_sym_opaque] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_union] = ACTIONS(1043),
    [anon_sym_error] = ACTIONS(1043),
    [anon_sym_nosuspend] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_asm] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_DASH_PERCENT] = ACTIONS(1041),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_await] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_resume] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_anyframe] = ACTIONS(1043),
    [anon_sym_unreachable] = ACTIONS(1043),
    [anon_sym_undefined] = ACTIONS(1043),
    [anon_sym_null] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1041),
    [aux_sym_multiline_string_token1] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(1041),
    [sym_integer] = ACTIONS(1043),
    [sym_float] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1043),
    [anon_sym_false] = ACTIONS(1043),
    [anon_sym_bool] = ACTIONS(1043),
    [anon_sym_f16] = ACTIONS(1043),
    [anon_sym_f32] = ACTIONS(1043),
    [anon_sym_f64] = ACTIONS(1043),
    [anon_sym_f128] = ACTIONS(1043),
    [anon_sym_void] = ACTIONS(1043),
    [anon_sym_type] = ACTIONS(1043),
    [anon_sym_anyerror] = ACTIONS(1043),
    [anon_sym_anyopaque] = ACTIONS(1043),
    [anon_sym_anytype] = ACTIONS(1043),
    [anon_sym_noreturn] = ACTIONS(1043),
    [anon_sym_isize] = ACTIONS(1043),
    [anon_sym_usize] = ACTIONS(1043),
    [anon_sym_comptime_int] = ACTIONS(1043),
    [anon_sym_comptime_float] = ACTIONS(1043),
    [anon_sym_c_short] = ACTIONS(1043),
    [anon_sym_c_ushort] = ACTIONS(1043),
    [anon_sym_c_int] = ACTIONS(1043),
    [anon_sym_c_uint] = ACTIONS(1043),
    [anon_sym_c_long] = ACTIONS(1043),
    [anon_sym_c_ulong] = ACTIONS(1043),
    [anon_sym_c_longlong] = ACTIONS(1043),
    [anon_sym_c_ulonglong] = ACTIONS(1043),
    [anon_sym_c_longdouble] = ACTIONS(1043),
    [aux_sym_builtin_type_token1] = ACTIONS(1043),
    [sym_builtin_identifier] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1043),
    [sym_comment] = ACTIONS(3),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(1007),
    [sym__identifier] = ACTIONS(1009),
    [anon_sym_pub] = ACTIONS(1009),
    [anon_sym_test] = ACTIONS(1009),
    [anon_sym_comptime] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1009),
    [anon_sym_extern] = ACTIONS(1009),
    [anon_sym_threadlocal] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1009),
    [anon_sym_var] = ACTIONS(1009),
    [anon_sym_inline] = ACTIONS(1009),
    [anon_sym_noinline] = ACTIONS(1009),
    [anon_sym_fn] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_usingnamespace] = ACTIONS(1009),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_packed] = ACTIONS(1009),
    [anon_sym_struct] = ACTIONS(1009),
    [anon_sym_opaque] = ACTIONS(1009),
    [anon_sym_enum] = ACTIONS(1009),
    [anon_sym_union] = ACTIONS(1009),
    [anon_sym_error] = ACTIONS(1009),
    [anon_sym_nosuspend] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_asm] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_DASH_PERCENT] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(1007),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_resume] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_switch] = ACTIONS(1009),
    [anon_sym_anyframe] = ACTIONS(1009),
    [anon_sym_unreachable] = ACTIONS(1009),
    [anon_sym_undefined] = ACTIONS(1009),
    [anon_sym_null] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1007),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [aux_sym_multiline_string_token1] = ACTIONS(1007),
    [anon_sym_SQUOTE] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1009),
    [anon_sym_false] = ACTIONS(1009),
    [anon_sym_bool] = ACTIONS(1009),
    [anon_sym_f16] = ACTIONS(1009),
    [anon_sym_f32] = ACTIONS(1009),
    [anon_sym_f64] = ACTIONS(1009),
    [anon_sym_f128] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_anyerror] = ACTIONS(1009),
    [anon_sym_anyopaque] = ACTIONS(1009),
    [anon_sym_anytype] = ACTIONS(1009),
    [anon_sym_noreturn] = ACTIONS(1009),
    [anon_sym_isize] = ACTIONS(1009),
    [anon_sym_usize] = ACTIONS(1009),
    [anon_sym_comptime_int] = ACTIONS(1009),
    [anon_sym_comptime_float] = ACTIONS(1009),
    [anon_sym_c_short] = ACTIONS(1009),
    [anon_sym_c_ushort] = ACTIONS(1009),
    [anon_sym_c_int] = ACTIONS(1009),
    [anon_sym_c_uint] = ACTIONS(1009),
    [anon_sym_c_long] = ACTIONS(1009),
    [anon_sym_c_ulong] = ACTIONS(1009),
    [anon_sym_c_longlong] = ACTIONS(1009),
    [anon_sym_c_ulonglong] = ACTIONS(1009),
    [anon_sym_c_longdouble] = ACTIONS(1009),
    [aux_sym_builtin_type_token1] = ACTIONS(1009),
    [sym_builtin_identifier] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(1045),
    [sym__identifier] = ACTIONS(1047),
    [anon_sym_pub] = ACTIONS(1047),
    [anon_sym_test] = ACTIONS(1047),
    [anon_sym_comptime] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(1047),
    [anon_sym_threadlocal] = ACTIONS(1047),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_var] = ACTIONS(1047),
    [anon_sym_inline] = ACTIONS(1047),
    [anon_sym_noinline] = ACTIONS(1047),
    [anon_sym_fn] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1045),
    [anon_sym_usingnamespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_packed] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1047),
    [anon_sym_opaque] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1047),
    [anon_sym_union] = ACTIONS(1047),
    [anon_sym_error] = ACTIONS(1047),
    [anon_sym_nosuspend] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1047),
    [anon_sym_for] = ACTIONS(1047),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_asm] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_DASH_PERCENT] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1047),
    [anon_sym_continue] = ACTIONS(1047),
    [anon_sym_resume] = ACTIONS(1047),
    [anon_sym_return] = ACTIONS(1047),
    [anon_sym_break] = ACTIONS(1047),
    [anon_sym_try] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1047),
    [anon_sym_anyframe] = ACTIONS(1047),
    [anon_sym_unreachable] = ACTIONS(1047),
    [anon_sym_undefined] = ACTIONS(1047),
    [anon_sym_null] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1045),
    [aux_sym_multiline_string_token1] = ACTIONS(1045),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1047),
    [sym_float] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1047),
    [anon_sym_false] = ACTIONS(1047),
    [anon_sym_bool] = ACTIONS(1047),
    [anon_sym_f16] = ACTIONS(1047),
    [anon_sym_f32] = ACTIONS(1047),
    [anon_sym_f64] = ACTIONS(1047),
    [anon_sym_f128] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_anyerror] = ACTIONS(1047),
    [anon_sym_anyopaque] = ACTIONS(1047),
    [anon_sym_anytype] = ACTIONS(1047),
    [anon_sym_noreturn] = ACTIONS(1047),
    [anon_sym_isize] = ACTIONS(1047),
    [anon_sym_usize] = ACTIONS(1047),
    [anon_sym_comptime_int] = ACTIONS(1047),
    [anon_sym_comptime_float] = ACTIONS(1047),
    [anon_sym_c_short] = ACTIONS(1047),
    [anon_sym_c_ushort] = ACTIONS(1047),
    [anon_sym_c_int] = ACTIONS(1047),
    [anon_sym_c_uint] = ACTIONS(1047),
    [anon_sym_c_long] = ACTIONS(1047),
    [anon_sym_c_ulong] = ACTIONS(1047),
    [anon_sym_c_longlong] = ACTIONS(1047),
    [anon_sym_c_ulonglong] = ACTIONS(1047),
    [anon_sym_c_longdouble] = ACTIONS(1047),
    [aux_sym_builtin_type_token1] = ACTIONS(1047),
    [sym_builtin_identifier] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym__identifier] = ACTIONS(1021),
    [anon_sym_pub] = ACTIONS(1021),
    [anon_sym_test] = ACTIONS(1021),
    [anon_sym_comptime] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_threadlocal] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_noinline] = ACTIONS(1021),
    [anon_sym_fn] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_usingnamespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_packed] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_opaque] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_error] = ACTIONS(1021),
    [anon_sym_nosuspend] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_asm] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_DASH_PERCENT] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_resume] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_anyframe] = ACTIONS(1021),
    [anon_sym_unreachable] = ACTIONS(1021),
    [anon_sym_undefined] = ACTIONS(1021),
    [anon_sym_null] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_multiline_string_token1] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1021),
    [sym_float] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_bool] = ACTIONS(1021),
    [anon_sym_f16] = ACTIONS(1021),
    [anon_sym_f32] = ACTIONS(1021),
    [anon_sym_f64] = ACTIONS(1021),
    [anon_sym_f128] = ACTIONS(1021),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_anyerror] = ACTIONS(1021),
    [anon_sym_anyopaque] = ACTIONS(1021),
    [anon_sym_anytype] = ACTIONS(1021),
    [anon_sym_noreturn] = ACTIONS(1021),
    [anon_sym_isize] = ACTIONS(1021),
    [anon_sym_usize] = ACTIONS(1021),
    [anon_sym_comptime_int] = ACTIONS(1021),
    [anon_sym_comptime_float] = ACTIONS(1021),
    [anon_sym_c_short] = ACTIONS(1021),
    [anon_sym_c_ushort] = ACTIONS(1021),
    [anon_sym_c_int] = ACTIONS(1021),
    [anon_sym_c_uint] = ACTIONS(1021),
    [anon_sym_c_long] = ACTIONS(1021),
    [anon_sym_c_ulong] = ACTIONS(1021),
    [anon_sym_c_longlong] = ACTIONS(1021),
    [anon_sym_c_ulonglong] = ACTIONS(1021),
    [anon_sym_c_longdouble] = ACTIONS(1021),
    [aux_sym_builtin_type_token1] = ACTIONS(1021),
    [sym_builtin_identifier] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym__identifier] = ACTIONS(1025),
    [anon_sym_pub] = ACTIONS(1025),
    [anon_sym_test] = ACTIONS(1025),
    [anon_sym_comptime] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_extern] = ACTIONS(1025),
    [anon_sym_threadlocal] = ACTIONS(1025),
    [anon_sym_const] = ACTIONS(1025),
    [anon_sym_var] = ACTIONS(1025),
    [anon_sym_inline] = ACTIONS(1025),
    [anon_sym_noinline] = ACTIONS(1025),
    [anon_sym_fn] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_usingnamespace] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_packed] = ACTIONS(1025),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_opaque] = ACTIONS(1025),
    [anon_sym_enum] = ACTIONS(1025),
    [anon_sym_union] = ACTIONS(1025),
    [anon_sym_error] = ACTIONS(1025),
    [anon_sym_nosuspend] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_asm] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_DASH_PERCENT] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [anon_sym_resume] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_try] = ACTIONS(1025),
    [anon_sym_switch] = ACTIONS(1025),
    [anon_sym_anyframe] = ACTIONS(1025),
    [anon_sym_unreachable] = ACTIONS(1025),
    [anon_sym_undefined] = ACTIONS(1025),
    [anon_sym_null] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [aux_sym_multiline_string_token1] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1025),
    [sym_float] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1025),
    [anon_sym_false] = ACTIONS(1025),
    [anon_sym_bool] = ACTIONS(1025),
    [anon_sym_f16] = ACTIONS(1025),
    [anon_sym_f32] = ACTIONS(1025),
    [anon_sym_f64] = ACTIONS(1025),
    [anon_sym_f128] = ACTIONS(1025),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_anyerror] = ACTIONS(1025),
    [anon_sym_anyopaque] = ACTIONS(1025),
    [anon_sym_anytype] = ACTIONS(1025),
    [anon_sym_noreturn] = ACTIONS(1025),
    [anon_sym_isize] = ACTIONS(1025),
    [anon_sym_usize] = ACTIONS(1025),
    [anon_sym_comptime_int] = ACTIONS(1025),
    [anon_sym_comptime_float] = ACTIONS(1025),
    [anon_sym_c_short] = ACTIONS(1025),
    [anon_sym_c_ushort] = ACTIONS(1025),
    [anon_sym_c_int] = ACTIONS(1025),
    [anon_sym_c_uint] = ACTIONS(1025),
    [anon_sym_c_long] = ACTIONS(1025),
    [anon_sym_c_ulong] = ACTIONS(1025),
    [anon_sym_c_longlong] = ACTIONS(1025),
    [anon_sym_c_ulonglong] = ACTIONS(1025),
    [anon_sym_c_longdouble] = ACTIONS(1025),
    [aux_sym_builtin_type_token1] = ACTIONS(1025),
    [sym_builtin_identifier] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(1049),
    [sym__identifier] = ACTIONS(1051),
    [anon_sym_pub] = ACTIONS(1051),
    [anon_sym_test] = ACTIONS(1051),
    [anon_sym_comptime] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_extern] = ACTIONS(1051),
    [anon_sym_threadlocal] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_inline] = ACTIONS(1051),
    [anon_sym_noinline] = ACTIONS(1051),
    [anon_sym_fn] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_usingnamespace] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_packed] = ACTIONS(1051),
    [anon_sym_struct] = ACTIONS(1051),
    [anon_sym_opaque] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [anon_sym_union] = ACTIONS(1051),
    [anon_sym_error] = ACTIONS(1051),
    [anon_sym_nosuspend] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1049),
    [anon_sym_asm] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_DASH_PERCENT] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_await] = ACTIONS(1051),
    [anon_sym_continue] = ACTIONS(1051),
    [anon_sym_resume] = ACTIONS(1051),
    [anon_sym_return] = ACTIONS(1051),
    [anon_sym_break] = ACTIONS(1051),
    [anon_sym_try] = ACTIONS(1051),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_anyframe] = ACTIONS(1051),
    [anon_sym_unreachable] = ACTIONS(1051),
    [anon_sym_undefined] = ACTIONS(1051),
    [anon_sym_null] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [aux_sym_multiline_string_token1] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [sym_integer] = ACTIONS(1051),
    [sym_float] = ACTIONS(1049),
    [anon_sym_true] = ACTIONS(1051),
    [anon_sym_false] = ACTIONS(1051),
    [anon_sym_bool] = ACTIONS(1051),
    [anon_sym_f16] = ACTIONS(1051),
    [anon_sym_f32] = ACTIONS(1051),
    [anon_sym_f64] = ACTIONS(1051),
    [anon_sym_f128] = ACTIONS(1051),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_type] = ACTIONS(1051),
    [anon_sym_anyerror] = ACTIONS(1051),
    [anon_sym_anyopaque] = ACTIONS(1051),
    [anon_sym_anytype] = ACTIONS(1051),
    [anon_sym_noreturn] = ACTIONS(1051),
    [anon_sym_isize] = ACTIONS(1051),
    [anon_sym_usize] = ACTIONS(1051),
    [anon_sym_comptime_int] = ACTIONS(1051),
    [anon_sym_comptime_float] = ACTIONS(1051),
    [anon_sym_c_short] = ACTIONS(1051),
    [anon_sym_c_ushort] = ACTIONS(1051),
    [anon_sym_c_int] = ACTIONS(1051),
    [anon_sym_c_uint] = ACTIONS(1051),
    [anon_sym_c_long] = ACTIONS(1051),
    [anon_sym_c_ulong] = ACTIONS(1051),
    [anon_sym_c_longlong] = ACTIONS(1051),
    [anon_sym_c_ulonglong] = ACTIONS(1051),
    [anon_sym_c_longdouble] = ACTIONS(1051),
    [aux_sym_builtin_type_token1] = ACTIONS(1051),
    [sym_builtin_identifier] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym__identifier] = ACTIONS(997),
    [anon_sym_pub] = ACTIONS(997),
    [anon_sym_test] = ACTIONS(997),
    [anon_sym_comptime] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(997),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_threadlocal] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_var] = ACTIONS(997),
    [anon_sym_inline] = ACTIONS(997),
    [anon_sym_noinline] = ACTIONS(997),
    [anon_sym_fn] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_usingnamespace] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_packed] = ACTIONS(997),
    [anon_sym_struct] = ACTIONS(997),
    [anon_sym_opaque] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [anon_sym_union] = ACTIONS(997),
    [anon_sym_error] = ACTIONS(997),
    [anon_sym_nosuspend] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_asm] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_DASH_PERCENT] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_resume] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_anyframe] = ACTIONS(997),
    [anon_sym_unreachable] = ACTIONS(997),
    [anon_sym_undefined] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [aux_sym_multiline_string_token1] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_bool] = ACTIONS(997),
    [anon_sym_f16] = ACTIONS(997),
    [anon_sym_f32] = ACTIONS(997),
    [anon_sym_f64] = ACTIONS(997),
    [anon_sym_f128] = ACTIONS(997),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_anyerror] = ACTIONS(997),
    [anon_sym_anyopaque] = ACTIONS(997),
    [anon_sym_anytype] = ACTIONS(997),
    [anon_sym_noreturn] = ACTIONS(997),
    [anon_sym_isize] = ACTIONS(997),
    [anon_sym_usize] = ACTIONS(997),
    [anon_sym_comptime_int] = ACTIONS(997),
    [anon_sym_comptime_float] = ACTIONS(997),
    [anon_sym_c_short] = ACTIONS(997),
    [anon_sym_c_ushort] = ACTIONS(997),
    [anon_sym_c_int] = ACTIONS(997),
    [anon_sym_c_uint] = ACTIONS(997),
    [anon_sym_c_long] = ACTIONS(997),
    [anon_sym_c_ulong] = ACTIONS(997),
    [anon_sym_c_longlong] = ACTIONS(997),
    [anon_sym_c_ulonglong] = ACTIONS(997),
    [anon_sym_c_longdouble] = ACTIONS(997),
    [aux_sym_builtin_type_token1] = ACTIONS(997),
    [sym_builtin_identifier] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym__identifier] = ACTIONS(1031),
    [anon_sym_pub] = ACTIONS(1031),
    [anon_sym_test] = ACTIONS(1031),
    [anon_sym_comptime] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_extern] = ACTIONS(1031),
    [anon_sym_threadlocal] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_inline] = ACTIONS(1031),
    [anon_sym_noinline] = ACTIONS(1031),
    [anon_sym_fn] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_usingnamespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_packed] = ACTIONS(1031),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_opaque] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1031),
    [anon_sym_error] = ACTIONS(1031),
    [anon_sym_nosuspend] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_asm] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_DASH_PERCENT] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_resume] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_anyframe] = ACTIONS(1031),
    [anon_sym_unreachable] = ACTIONS(1031),
    [anon_sym_undefined] = ACTIONS(1031),
    [anon_sym_null] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [aux_sym_multiline_string_token1] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1031),
    [sym_float] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1031),
    [anon_sym_false] = ACTIONS(1031),
    [anon_sym_bool] = ACTIONS(1031),
    [anon_sym_f16] = ACTIONS(1031),
    [anon_sym_f32] = ACTIONS(1031),
    [anon_sym_f64] = ACTIONS(1031),
    [anon_sym_f128] = ACTIONS(1031),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_anyerror] = ACTIONS(1031),
    [anon_sym_anyopaque] = ACTIONS(1031),
    [anon_sym_anytype] = ACTIONS(1031),
    [anon_sym_noreturn] = ACTIONS(1031),
    [anon_sym_isize] = ACTIONS(1031),
    [anon_sym_usize] = ACTIONS(1031),
    [anon_sym_comptime_int] = ACTIONS(1031),
    [anon_sym_comptime_float] = ACTIONS(1031),
    [anon_sym_c_short] = ACTIONS(1031),
    [anon_sym_c_ushort] = ACTIONS(1031),
    [anon_sym_c_int] = ACTIONS(1031),
    [anon_sym_c_uint] = ACTIONS(1031),
    [anon_sym_c_long] = ACTIONS(1031),
    [anon_sym_c_ulong] = ACTIONS(1031),
    [anon_sym_c_longlong] = ACTIONS(1031),
    [anon_sym_c_ulonglong] = ACTIONS(1031),
    [anon_sym_c_longdouble] = ACTIONS(1031),
    [aux_sym_builtin_type_token1] = ACTIONS(1031),
    [sym_builtin_identifier] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym__identifier] = ACTIONS(1021),
    [anon_sym_pub] = ACTIONS(1021),
    [anon_sym_test] = ACTIONS(1021),
    [anon_sym_comptime] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_extern] = ACTIONS(1021),
    [anon_sym_threadlocal] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_inline] = ACTIONS(1021),
    [anon_sym_noinline] = ACTIONS(1021),
    [anon_sym_fn] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_usingnamespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_packed] = ACTIONS(1021),
    [anon_sym_struct] = ACTIONS(1021),
    [anon_sym_opaque] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [anon_sym_union] = ACTIONS(1021),
    [anon_sym_error] = ACTIONS(1021),
    [anon_sym_nosuspend] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1019),
    [anon_sym_asm] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_DASH_PERCENT] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1019),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_resume] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_anyframe] = ACTIONS(1021),
    [anon_sym_unreachable] = ACTIONS(1021),
    [anon_sym_undefined] = ACTIONS(1021),
    [anon_sym_null] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1019),
    [anon_sym_DOT] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_multiline_string_token1] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1021),
    [sym_float] = ACTIONS(1019),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_bool] = ACTIONS(1021),
    [anon_sym_f16] = ACTIONS(1021),
    [anon_sym_f32] = ACTIONS(1021),
    [anon_sym_f64] = ACTIONS(1021),
    [anon_sym_f128] = ACTIONS(1021),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_anyerror] = ACTIONS(1021),
    [anon_sym_anyopaque] = ACTIONS(1021),
    [anon_sym_anytype] = ACTIONS(1021),
    [anon_sym_noreturn] = ACTIONS(1021),
    [anon_sym_isize] = ACTIONS(1021),
    [anon_sym_usize] = ACTIONS(1021),
    [anon_sym_comptime_int] = ACTIONS(1021),
    [anon_sym_comptime_float] = ACTIONS(1021),
    [anon_sym_c_short] = ACTIONS(1021),
    [anon_sym_c_ushort] = ACTIONS(1021),
    [anon_sym_c_int] = ACTIONS(1021),
    [anon_sym_c_uint] = ACTIONS(1021),
    [anon_sym_c_long] = ACTIONS(1021),
    [anon_sym_c_ulong] = ACTIONS(1021),
    [anon_sym_c_longlong] = ACTIONS(1021),
    [anon_sym_c_ulonglong] = ACTIONS(1021),
    [anon_sym_c_longdouble] = ACTIONS(1021),
    [aux_sym_builtin_type_token1] = ACTIONS(1021),
    [sym_builtin_identifier] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym__identifier] = ACTIONS(1025),
    [anon_sym_pub] = ACTIONS(1025),
    [anon_sym_test] = ACTIONS(1025),
    [anon_sym_comptime] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_extern] = ACTIONS(1025),
    [anon_sym_threadlocal] = ACTIONS(1025),
    [anon_sym_const] = ACTIONS(1025),
    [anon_sym_var] = ACTIONS(1025),
    [anon_sym_inline] = ACTIONS(1025),
    [anon_sym_noinline] = ACTIONS(1025),
    [anon_sym_fn] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_usingnamespace] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_packed] = ACTIONS(1025),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_opaque] = ACTIONS(1025),
    [anon_sym_enum] = ACTIONS(1025),
    [anon_sym_union] = ACTIONS(1025),
    [anon_sym_error] = ACTIONS(1025),
    [anon_sym_nosuspend] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_asm] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_DASH_PERCENT] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [anon_sym_resume] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_try] = ACTIONS(1025),
    [anon_sym_switch] = ACTIONS(1025),
    [anon_sym_anyframe] = ACTIONS(1025),
    [anon_sym_unreachable] = ACTIONS(1025),
    [anon_sym_undefined] = ACTIONS(1025),
    [anon_sym_null] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [aux_sym_multiline_string_token1] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1025),
    [sym_float] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1025),
    [anon_sym_false] = ACTIONS(1025),
    [anon_sym_bool] = ACTIONS(1025),
    [anon_sym_f16] = ACTIONS(1025),
    [anon_sym_f32] = ACTIONS(1025),
    [anon_sym_f64] = ACTIONS(1025),
    [anon_sym_f128] = ACTIONS(1025),
    [anon_sym_void] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_anyerror] = ACTIONS(1025),
    [anon_sym_anyopaque] = ACTIONS(1025),
    [anon_sym_anytype] = ACTIONS(1025),
    [anon_sym_noreturn] = ACTIONS(1025),
    [anon_sym_isize] = ACTIONS(1025),
    [anon_sym_usize] = ACTIONS(1025),
    [anon_sym_comptime_int] = ACTIONS(1025),
    [anon_sym_comptime_float] = ACTIONS(1025),
    [anon_sym_c_short] = ACTIONS(1025),
    [anon_sym_c_ushort] = ACTIONS(1025),
    [anon_sym_c_int] = ACTIONS(1025),
    [anon_sym_c_uint] = ACTIONS(1025),
    [anon_sym_c_long] = ACTIONS(1025),
    [anon_sym_c_ulong] = ACTIONS(1025),
    [anon_sym_c_longlong] = ACTIONS(1025),
    [anon_sym_c_ulonglong] = ACTIONS(1025),
    [anon_sym_c_longdouble] = ACTIONS(1025),
    [aux_sym_builtin_type_token1] = ACTIONS(1025),
    [sym_builtin_identifier] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym__identifier] = ACTIONS(1031),
    [anon_sym_pub] = ACTIONS(1031),
    [anon_sym_test] = ACTIONS(1031),
    [anon_sym_comptime] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_extern] = ACTIONS(1031),
    [anon_sym_threadlocal] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_inline] = ACTIONS(1031),
    [anon_sym_noinline] = ACTIONS(1031),
    [anon_sym_fn] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_usingnamespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_packed] = ACTIONS(1031),
    [anon_sym_struct] = ACTIONS(1031),
    [anon_sym_opaque] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [anon_sym_union] = ACTIONS(1031),
    [anon_sym_error] = ACTIONS(1031),
    [anon_sym_nosuspend] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_asm] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_DASH_PERCENT] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_resume] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_anyframe] = ACTIONS(1031),
    [anon_sym_unreachable] = ACTIONS(1031),
    [anon_sym_undefined] = ACTIONS(1031),
    [anon_sym_null] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [aux_sym_multiline_string_token1] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1031),
    [sym_float] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1031),
    [anon_sym_false] = ACTIONS(1031),
    [anon_sym_bool] = ACTIONS(1031),
    [anon_sym_f16] = ACTIONS(1031),
    [anon_sym_f32] = ACTIONS(1031),
    [anon_sym_f64] = ACTIONS(1031),
    [anon_sym_f128] = ACTIONS(1031),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_anyerror] = ACTIONS(1031),
    [anon_sym_anyopaque] = ACTIONS(1031),
    [anon_sym_anytype] = ACTIONS(1031),
    [anon_sym_noreturn] = ACTIONS(1031),
    [anon_sym_isize] = ACTIONS(1031),
    [anon_sym_usize] = ACTIONS(1031),
    [anon_sym_comptime_int] = ACTIONS(1031),
    [anon_sym_comptime_float] = ACTIONS(1031),
    [anon_sym_c_short] = ACTIONS(1031),
    [anon_sym_c_ushort] = ACTIONS(1031),
    [anon_sym_c_int] = ACTIONS(1031),
    [anon_sym_c_uint] = ACTIONS(1031),
    [anon_sym_c_long] = ACTIONS(1031),
    [anon_sym_c_ulong] = ACTIONS(1031),
    [anon_sym_c_longlong] = ACTIONS(1031),
    [anon_sym_c_ulonglong] = ACTIONS(1031),
    [anon_sym_c_longdouble] = ACTIONS(1031),
    [aux_sym_builtin_type_token1] = ACTIONS(1031),
    [sym_builtin_identifier] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(1053),
    [sym__identifier] = ACTIONS(1055),
    [anon_sym_pub] = ACTIONS(1055),
    [anon_sym_test] = ACTIONS(1055),
    [anon_sym_comptime] = ACTIONS(1055),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_extern] = ACTIONS(1055),
    [anon_sym_threadlocal] = ACTIONS(1055),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_var] = ACTIONS(1055),
    [anon_sym_inline] = ACTIONS(1055),
    [anon_sym_noinline] = ACTIONS(1055),
    [anon_sym_fn] = ACTIONS(1055),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_usingnamespace] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_packed] = ACTIONS(1055),
    [anon_sym_struct] = ACTIONS(1055),
    [anon_sym_opaque] = ACTIONS(1055),
    [anon_sym_enum] = ACTIONS(1055),
    [anon_sym_union] = ACTIONS(1055),
    [anon_sym_error] = ACTIONS(1055),
    [anon_sym_nosuspend] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1055),
    [anon_sym_for] = ACTIONS(1055),
    [anon_sym_while] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_asm] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_TILDE] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_DASH_PERCENT] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1055),
    [anon_sym_await] = ACTIONS(1055),
    [anon_sym_continue] = ACTIONS(1055),
    [anon_sym_resume] = ACTIONS(1055),
    [anon_sym_return] = ACTIONS(1055),
    [anon_sym_break] = ACTIONS(1055),
    [anon_sym_try] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1055),
    [anon_sym_anyframe] = ACTIONS(1055),
    [anon_sym_unreachable] = ACTIONS(1055),
    [anon_sym_undefined] = ACTIONS(1055),
    [anon_sym_null] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [aux_sym_multiline_string_token1] = ACTIONS(1053),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [sym_integer] = ACTIONS(1055),
    [sym_float] = ACTIONS(1053),
    [anon_sym_true] = ACTIONS(1055),
    [anon_sym_false] = ACTIONS(1055),
    [anon_sym_bool] = ACTIONS(1055),
    [anon_sym_f16] = ACTIONS(1055),
    [anon_sym_f32] = ACTIONS(1055),
    [anon_sym_f64] = ACTIONS(1055),
    [anon_sym_f128] = ACTIONS(1055),
    [anon_sym_void] = ACTIONS(1055),
    [anon_sym_type] = ACTIONS(1055),
    [anon_sym_anyerror] = ACTIONS(1055),
    [anon_sym_anyopaque] = ACTIONS(1055),
    [anon_sym_anytype] = ACTIONS(1055),
    [anon_sym_noreturn] = ACTIONS(1055),
    [anon_sym_isize] = ACTIONS(1055),
    [anon_sym_usize] = ACTIONS(1055),
    [anon_sym_comptime_int] = ACTIONS(1055),
    [anon_sym_comptime_float] = ACTIONS(1055),
    [anon_sym_c_short] = ACTIONS(1055),
    [anon_sym_c_ushort] = ACTIONS(1055),
    [anon_sym_c_int] = ACTIONS(1055),
    [anon_sym_c_uint] = ACTIONS(1055),
    [anon_sym_c_long] = ACTIONS(1055),
    [anon_sym_c_ulong] = ACTIONS(1055),
    [anon_sym_c_longlong] = ACTIONS(1055),
    [anon_sym_c_ulonglong] = ACTIONS(1055),
    [anon_sym_c_longdouble] = ACTIONS(1055),
    [aux_sym_builtin_type_token1] = ACTIONS(1055),
    [sym_builtin_identifier] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(1057),
    [sym__identifier] = ACTIONS(1059),
    [anon_sym_pub] = ACTIONS(1059),
    [anon_sym_test] = ACTIONS(1059),
    [anon_sym_comptime] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(1059),
    [anon_sym_extern] = ACTIONS(1059),
    [anon_sym_threadlocal] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_var] = ACTIONS(1059),
    [anon_sym_inline] = ACTIONS(1059),
    [anon_sym_noinline] = ACTIONS(1059),
    [anon_sym_fn] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_usingnamespace] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_packed] = ACTIONS(1059),
    [anon_sym_struct] = ACTIONS(1059),
    [anon_sym_opaque] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1059),
    [anon_sym_union] = ACTIONS(1059),
    [anon_sym_error] = ACTIONS(1059),
    [anon_sym_nosuspend] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_asm] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DASH_PERCENT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [anon_sym_resume] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_try] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_anyframe] = ACTIONS(1059),
    [anon_sym_unreachable] = ACTIONS(1059),
    [anon_sym_undefined] = ACTIONS(1059),
    [anon_sym_null] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [aux_sym_multiline_string_token1] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [sym_integer] = ACTIONS(1059),
    [sym_float] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_bool] = ACTIONS(1059),
    [anon_sym_f16] = ACTIONS(1059),
    [anon_sym_f32] = ACTIONS(1059),
    [anon_sym_f64] = ACTIONS(1059),
    [anon_sym_f128] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1059),
    [anon_sym_anyerror] = ACTIONS(1059),
    [anon_sym_anyopaque] = ACTIONS(1059),
    [anon_sym_anytype] = ACTIONS(1059),
    [anon_sym_noreturn] = ACTIONS(1059),
    [anon_sym_isize] = ACTIONS(1059),
    [anon_sym_usize] = ACTIONS(1059),
    [anon_sym_comptime_int] = ACTIONS(1059),
    [anon_sym_comptime_float] = ACTIONS(1059),
    [anon_sym_c_short] = ACTIONS(1059),
    [anon_sym_c_ushort] = ACTIONS(1059),
    [anon_sym_c_int] = ACTIONS(1059),
    [anon_sym_c_uint] = ACTIONS(1059),
    [anon_sym_c_long] = ACTIONS(1059),
    [anon_sym_c_ulong] = ACTIONS(1059),
    [anon_sym_c_longlong] = ACTIONS(1059),
    [anon_sym_c_ulonglong] = ACTIONS(1059),
    [anon_sym_c_longdouble] = ACTIONS(1059),
    [aux_sym_builtin_type_token1] = ACTIONS(1059),
    [sym_builtin_identifier] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym__identifier] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(985),
    [anon_sym_test] = ACTIONS(985),
    [anon_sym_comptime] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_inline] = ACTIONS(985),
    [anon_sym_noinline] = ACTIONS(985),
    [anon_sym_fn] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(985),
    [anon_sym_struct] = ACTIONS(985),
    [anon_sym_opaque] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [anon_sym_union] = ACTIONS(985),
    [anon_sym_error] = ACTIONS(985),
    [anon_sym_nosuspend] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_asm] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_resume] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_anyframe] = ACTIONS(985),
    [anon_sym_unreachable] = ACTIONS(985),
    [anon_sym_undefined] = ACTIONS(985),
    [anon_sym_null] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [aux_sym_multiline_string_token1] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_bool] = ACTIONS(985),
    [anon_sym_f16] = ACTIONS(985),
    [anon_sym_f32] = ACTIONS(985),
    [anon_sym_f64] = ACTIONS(985),
    [anon_sym_f128] = ACTIONS(985),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_anyerror] = ACTIONS(985),
    [anon_sym_anyopaque] = ACTIONS(985),
    [anon_sym_anytype] = ACTIONS(985),
    [anon_sym_noreturn] = ACTIONS(985),
    [anon_sym_isize] = ACTIONS(985),
    [anon_sym_usize] = ACTIONS(985),
    [anon_sym_comptime_int] = ACTIONS(985),
    [anon_sym_comptime_float] = ACTIONS(985),
    [anon_sym_c_short] = ACTIONS(985),
    [anon_sym_c_ushort] = ACTIONS(985),
    [anon_sym_c_int] = ACTIONS(985),
    [anon_sym_c_uint] = ACTIONS(985),
    [anon_sym_c_long] = ACTIONS(985),
    [anon_sym_c_ulong] = ACTIONS(985),
    [anon_sym_c_longlong] = ACTIONS(985),
    [anon_sym_c_ulonglong] = ACTIONS(985),
    [anon_sym_c_longdouble] = ACTIONS(985),
    [aux_sym_builtin_type_token1] = ACTIONS(985),
    [sym_builtin_identifier] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(967),
    [sym__identifier] = ACTIONS(969),
    [anon_sym_pub] = ACTIONS(969),
    [anon_sym_test] = ACTIONS(969),
    [anon_sym_comptime] = ACTIONS(969),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_extern] = ACTIONS(969),
    [anon_sym_threadlocal] = ACTIONS(969),
    [anon_sym_const] = ACTIONS(969),
    [anon_sym_var] = ACTIONS(969),
    [anon_sym_inline] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_fn] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_usingnamespace] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_packed] = ACTIONS(969),
    [anon_sym_struct] = ACTIONS(969),
    [anon_sym_opaque] = ACTIONS(969),
    [anon_sym_enum] = ACTIONS(969),
    [anon_sym_union] = ACTIONS(969),
    [anon_sym_error] = ACTIONS(969),
    [anon_sym_nosuspend] = ACTIONS(969),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(969),
    [anon_sym_while] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(967),
    [anon_sym_asm] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_BANG] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(969),
    [anon_sym_DASH_PERCENT] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_await] = ACTIONS(969),
    [anon_sym_continue] = ACTIONS(969),
    [anon_sym_resume] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(969),
    [anon_sym_break] = ACTIONS(969),
    [anon_sym_try] = ACTIONS(969),
    [anon_sym_switch] = ACTIONS(969),
    [anon_sym_anyframe] = ACTIONS(969),
    [anon_sym_unreachable] = ACTIONS(969),
    [anon_sym_undefined] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [aux_sym_multiline_string_token1] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(969),
    [anon_sym_false] = ACTIONS(969),
    [anon_sym_bool] = ACTIONS(969),
    [anon_sym_f16] = ACTIONS(969),
    [anon_sym_f32] = ACTIONS(969),
    [anon_sym_f64] = ACTIONS(969),
    [anon_sym_f128] = ACTIONS(969),
    [anon_sym_void] = ACTIONS(969),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_anyerror] = ACTIONS(969),
    [anon_sym_anyopaque] = ACTIONS(969),
    [anon_sym_anytype] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_isize] = ACTIONS(969),
    [anon_sym_usize] = ACTIONS(969),
    [anon_sym_comptime_int] = ACTIONS(969),
    [anon_sym_comptime_float] = ACTIONS(969),
    [anon_sym_c_short] = ACTIONS(969),
    [anon_sym_c_ushort] = ACTIONS(969),
    [anon_sym_c_int] = ACTIONS(969),
    [anon_sym_c_uint] = ACTIONS(969),
    [anon_sym_c_long] = ACTIONS(969),
    [anon_sym_c_ulong] = ACTIONS(969),
    [anon_sym_c_longlong] = ACTIONS(969),
    [anon_sym_c_ulonglong] = ACTIONS(969),
    [anon_sym_c_longdouble] = ACTIONS(969),
    [aux_sym_builtin_type_token1] = ACTIONS(969),
    [sym_builtin_identifier] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym__identifier] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(985),
    [anon_sym_test] = ACTIONS(985),
    [anon_sym_comptime] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_extern] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_inline] = ACTIONS(985),
    [anon_sym_noinline] = ACTIONS(985),
    [anon_sym_fn] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(985),
    [anon_sym_struct] = ACTIONS(985),
    [anon_sym_opaque] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [anon_sym_union] = ACTIONS(985),
    [anon_sym_error] = ACTIONS(985),
    [anon_sym_nosuspend] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_asm] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_resume] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_anyframe] = ACTIONS(985),
    [anon_sym_unreachable] = ACTIONS(985),
    [anon_sym_undefined] = ACTIONS(985),
    [anon_sym_null] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [aux_sym_multiline_string_token1] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(985),
    [anon_sym_false] = ACTIONS(985),
    [anon_sym_bool] = ACTIONS(985),
    [anon_sym_f16] = ACTIONS(985),
    [anon_sym_f32] = ACTIONS(985),
    [anon_sym_f64] = ACTIONS(985),
    [anon_sym_f128] = ACTIONS(985),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_anyerror] = ACTIONS(985),
    [anon_sym_anyopaque] = ACTIONS(985),
    [anon_sym_anytype] = ACTIONS(985),
    [anon_sym_noreturn] = ACTIONS(985),
    [anon_sym_isize] = ACTIONS(985),
    [anon_sym_usize] = ACTIONS(985),
    [anon_sym_comptime_int] = ACTIONS(985),
    [anon_sym_comptime_float] = ACTIONS(985),
    [anon_sym_c_short] = ACTIONS(985),
    [anon_sym_c_ushort] = ACTIONS(985),
    [anon_sym_c_int] = ACTIONS(985),
    [anon_sym_c_uint] = ACTIONS(985),
    [anon_sym_c_long] = ACTIONS(985),
    [anon_sym_c_ulong] = ACTIONS(985),
    [anon_sym_c_longlong] = ACTIONS(985),
    [anon_sym_c_ulonglong] = ACTIONS(985),
    [anon_sym_c_longdouble] = ACTIONS(985),
    [aux_sym_builtin_type_token1] = ACTIONS(985),
    [sym_builtin_identifier] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
  },
  [723] = {
    [sym_else_clause] = STATE(730),
    [sym__identifier] = ACTIONS(1061),
    [anon_sym_comptime] = ACTIONS(1061),
    [anon_sym_extern] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_inline] = ACTIONS(1061),
    [anon_sym_fn] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_packed] = ACTIONS(1061),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_opaque] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [anon_sym_union] = ACTIONS(1061),
    [anon_sym_error] = ACTIONS(1061),
    [anon_sym_nosuspend] = ACTIONS(1061),
    [anon_sym_suspend] = ACTIONS(1061),
    [anon_sym_defer] = ACTIONS(1061),
    [anon_sym_errdefer] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_asm] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_PERCENT] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_resume] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_anyframe] = ACTIONS(1061),
    [anon_sym_unreachable] = ACTIONS(1061),
    [anon_sym_undefined] = ACTIONS(1061),
    [anon_sym_null] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [aux_sym_multiline_string_token1] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_integer] = ACTIONS(1061),
    [sym_float] = ACTIONS(1063),
    [anon_sym_true] = ACTIONS(1061),
    [anon_sym_false] = ACTIONS(1061),
    [anon_sym_bool] = ACTIONS(1061),
    [anon_sym_f16] = ACTIONS(1061),
    [anon_sym_f32] = ACTIONS(1061),
    [anon_sym_f64] = ACTIONS(1061),
    [anon_sym_f128] = ACTIONS(1061),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_anyerror] = ACTIONS(1061),
    [anon_sym_anyopaque] = ACTIONS(1061),
    [anon_sym_anytype] = ACTIONS(1061),
    [anon_sym_noreturn] = ACTIONS(1061),
    [anon_sym_isize] = ACTIONS(1061),
    [anon_sym_usize] = ACTIONS(1061),
    [anon_sym_comptime_int] = ACTIONS(1061),
    [anon_sym_comptime_float] = ACTIONS(1061),
    [anon_sym_c_short] = ACTIONS(1061),
    [anon_sym_c_ushort] = ACTIONS(1061),
    [anon_sym_c_int] = ACTIONS(1061),
    [anon_sym_c_uint] = ACTIONS(1061),
    [anon_sym_c_long] = ACTIONS(1061),
    [anon_sym_c_ulong] = ACTIONS(1061),
    [anon_sym_c_longlong] = ACTIONS(1061),
    [anon_sym_c_ulonglong] = ACTIONS(1061),
    [anon_sym_c_longdouble] = ACTIONS(1061),
    [aux_sym_builtin_type_token1] = ACTIONS(1061),
    [sym_builtin_identifier] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [sym_byte_alignment] = STATE(724),
    [sym_address_space] = STATE(724),
    [aux_sym_slice_type_repeat1] = STATE(724),
    [sym__identifier] = ACTIONS(1067),
    [anon_sym_comptime] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(1067),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_inline] = ACTIONS(1067),
    [anon_sym_fn] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_packed] = ACTIONS(1067),
    [anon_sym_struct] = ACTIONS(1067),
    [anon_sym_opaque] = ACTIONS(1067),
    [anon_sym_enum] = ACTIONS(1067),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_error] = ACTIONS(1067),
    [anon_sym_nosuspend] = ACTIONS(1067),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_for] = ACTIONS(1067),
    [anon_sym_while] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_align] = ACTIONS(1074),
    [anon_sym_addrspace] = ACTIONS(1077),
    [anon_sym_asm] = ACTIONS(1067),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DASH_PERCENT] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1067),
    [anon_sym_await] = ACTIONS(1067),
    [anon_sym_continue] = ACTIONS(1067),
    [anon_sym_resume] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_break] = ACTIONS(1067),
    [anon_sym_try] = ACTIONS(1067),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_anyframe] = ACTIONS(1067),
    [anon_sym_unreachable] = ACTIONS(1067),
    [anon_sym_undefined] = ACTIONS(1067),
    [anon_sym_null] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_allowzero] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [aux_sym_multiline_string_token1] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_integer] = ACTIONS(1067),
    [sym_float] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_bool] = ACTIONS(1067),
    [anon_sym_f16] = ACTIONS(1067),
    [anon_sym_f32] = ACTIONS(1067),
    [anon_sym_f64] = ACTIONS(1067),
    [anon_sym_f128] = ACTIONS(1067),
    [anon_sym_void] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_anyerror] = ACTIONS(1067),
    [anon_sym_anyopaque] = ACTIONS(1067),
    [anon_sym_anytype] = ACTIONS(1067),
    [anon_sym_noreturn] = ACTIONS(1067),
    [anon_sym_isize] = ACTIONS(1067),
    [anon_sym_usize] = ACTIONS(1067),
    [anon_sym_comptime_int] = ACTIONS(1067),
    [anon_sym_comptime_float] = ACTIONS(1067),
    [anon_sym_c_short] = ACTIONS(1067),
    [anon_sym_c_ushort] = ACTIONS(1067),
    [anon_sym_c_int] = ACTIONS(1067),
    [anon_sym_c_uint] = ACTIONS(1067),
    [anon_sym_c_long] = ACTIONS(1067),
    [anon_sym_c_ulong] = ACTIONS(1067),
    [anon_sym_c_longlong] = ACTIONS(1067),
    [anon_sym_c_ulonglong] = ACTIONS(1067),
    [anon_sym_c_longdouble] = ACTIONS(1067),
    [aux_sym_builtin_type_token1] = ACTIONS(1067),
    [sym_builtin_identifier] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
  },
  [725] = {
    [sym_address_space] = STATE(725),
    [aux_sym_pointer_type_repeat1] = STATE(725),
    [sym__identifier] = ACTIONS(1080),
    [anon_sym_comptime] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1082),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_fn] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_packed] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_opaque] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_error] = ACTIONS(1080),
    [anon_sym_nosuspend] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1085),
    [anon_sym_align] = ACTIONS(1087),
    [anon_sym_addrspace] = ACTIONS(1090),
    [anon_sym_asm] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_DASH_PERCENT] = ACTIONS(1085),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_async] = ACTIONS(1080),
    [anon_sym_await] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_resume] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_try] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_anyframe] = ACTIONS(1080),
    [anon_sym_unreachable] = ACTIONS(1080),
    [anon_sym_undefined] = ACTIONS(1080),
    [anon_sym_null] = ACTIONS(1080),
    [anon_sym_QMARK] = ACTIONS(1085),
    [anon_sym_allowzero] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [aux_sym_multiline_string_token1] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(1085),
    [sym_integer] = ACTIONS(1080),
    [sym_float] = ACTIONS(1085),
    [anon_sym_true] = ACTIONS(1080),
    [anon_sym_false] = ACTIONS(1080),
    [anon_sym_bool] = ACTIONS(1080),
    [anon_sym_f16] = ACTIONS(1080),
    [anon_sym_f32] = ACTIONS(1080),
    [anon_sym_f64] = ACTIONS(1080),
    [anon_sym_f128] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1080),
    [anon_sym_anyerror] = ACTIONS(1080),
    [anon_sym_anyopaque] = ACTIONS(1080),
    [anon_sym_anytype] = ACTIONS(1080),
    [anon_sym_noreturn] = ACTIONS(1080),
    [anon_sym_isize] = ACTIONS(1080),
    [anon_sym_usize] = ACTIONS(1080),
    [anon_sym_comptime_int] = ACTIONS(1080),
    [anon_sym_comptime_float] = ACTIONS(1080),
    [anon_sym_c_short] = ACTIONS(1080),
    [anon_sym_c_ushort] = ACTIONS(1080),
    [anon_sym_c_int] = ACTIONS(1080),
    [anon_sym_c_uint] = ACTIONS(1080),
    [anon_sym_c_long] = ACTIONS(1080),
    [anon_sym_c_ulong] = ACTIONS(1080),
    [anon_sym_c_longlong] = ACTIONS(1080),
    [anon_sym_c_ulonglong] = ACTIONS(1080),
    [anon_sym_c_longdouble] = ACTIONS(1080),
    [aux_sym_builtin_type_token1] = ACTIONS(1080),
    [sym_builtin_identifier] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [726] = {
    [sym__identifier] = ACTIONS(1093),
    [anon_sym_comptime] = ACTIONS(1093),
    [anon_sym_extern] = ACTIONS(1093),
    [anon_sym_const] = ACTIONS(1093),
    [anon_sym_var] = ACTIONS(1093),
    [anon_sym_inline] = ACTIONS(1093),
    [anon_sym_fn] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_packed] = ACTIONS(1093),
    [anon_sym_struct] = ACTIONS(1093),
    [anon_sym_opaque] = ACTIONS(1093),
    [anon_sym_enum] = ACTIONS(1093),
    [anon_sym_union] = ACTIONS(1093),
    [anon_sym_error] = ACTIONS(1093),
    [anon_sym_nosuspend] = ACTIONS(1093),
    [anon_sym_suspend] = ACTIONS(1093),
    [anon_sym_defer] = ACTIONS(1093),
    [anon_sym_errdefer] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_for] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_asm] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_DASH_PERCENT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [anon_sym_resume] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_try] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_anyframe] = ACTIONS(1093),
    [anon_sym_unreachable] = ACTIONS(1093),
    [anon_sym_undefined] = ACTIONS(1093),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [aux_sym_multiline_string_token1] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_integer] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1093),
    [anon_sym_false] = ACTIONS(1093),
    [anon_sym_bool] = ACTIONS(1093),
    [anon_sym_f16] = ACTIONS(1093),
    [anon_sym_f32] = ACTIONS(1093),
    [anon_sym_f64] = ACTIONS(1093),
    [anon_sym_f128] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1093),
    [anon_sym_anyerror] = ACTIONS(1093),
    [anon_sym_anyopaque] = ACTIONS(1093),
    [anon_sym_anytype] = ACTIONS(1093),
    [anon_sym_noreturn] = ACTIONS(1093),
    [anon_sym_isize] = ACTIONS(1093),
    [anon_sym_usize] = ACTIONS(1093),
    [anon_sym_comptime_int] = ACTIONS(1093),
    [anon_sym_comptime_float] = ACTIONS(1093),
    [anon_sym_c_short] = ACTIONS(1093),
    [anon_sym_c_ushort] = ACTIONS(1093),
    [anon_sym_c_int] = ACTIONS(1093),
    [anon_sym_c_uint] = ACTIONS(1093),
    [anon_sym_c_long] = ACTIONS(1093),
    [anon_sym_c_ulong] = ACTIONS(1093),
    [anon_sym_c_longlong] = ACTIONS(1093),
    [anon_sym_c_ulonglong] = ACTIONS(1093),
    [anon_sym_c_longdouble] = ACTIONS(1093),
    [aux_sym_builtin_type_token1] = ACTIONS(1093),
    [sym_builtin_identifier] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
  },
  [727] = {
    [sym__identifier] = ACTIONS(1097),
    [anon_sym_comptime] = ACTIONS(1097),
    [anon_sym_extern] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_inline] = ACTIONS(1097),
    [anon_sym_fn] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_packed] = ACTIONS(1097),
    [anon_sym_struct] = ACTIONS(1097),
    [anon_sym_opaque] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [anon_sym_union] = ACTIONS(1097),
    [anon_sym_error] = ACTIONS(1097),
    [anon_sym_nosuspend] = ACTIONS(1097),
    [anon_sym_suspend] = ACTIONS(1097),
    [anon_sym_defer] = ACTIONS(1097),
    [anon_sym_errdefer] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_asm] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_DASH_PERCENT] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_resume] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_anyframe] = ACTIONS(1097),
    [anon_sym_unreachable] = ACTIONS(1097),
    [anon_sym_undefined] = ACTIONS(1097),
    [anon_sym_null] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [aux_sym_multiline_string_token1] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [sym_integer] = ACTIONS(1097),
    [sym_float] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(1097),
    [anon_sym_false] = ACTIONS(1097),
    [anon_sym_bool] = ACTIONS(1097),
    [anon_sym_f16] = ACTIONS(1097),
    [anon_sym_f32] = ACTIONS(1097),
    [anon_sym_f64] = ACTIONS(1097),
    [anon_sym_f128] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_anyerror] = ACTIONS(1097),
    [anon_sym_anyopaque] = ACTIONS(1097),
    [anon_sym_anytype] = ACTIONS(1097),
    [anon_sym_noreturn] = ACTIONS(1097),
    [anon_sym_isize] = ACTIONS(1097),
    [anon_sym_usize] = ACTIONS(1097),
    [anon_sym_comptime_int] = ACTIONS(1097),
    [anon_sym_comptime_float] = ACTIONS(1097),
    [anon_sym_c_short] = ACTIONS(1097),
    [anon_sym_c_ushort] = ACTIONS(1097),
    [anon_sym_c_int] = ACTIONS(1097),
    [anon_sym_c_uint] = ACTIONS(1097),
    [anon_sym_c_long] = ACTIONS(1097),
    [anon_sym_c_ulong] = ACTIONS(1097),
    [anon_sym_c_longlong] = ACTIONS(1097),
    [anon_sym_c_ulonglong] = ACTIONS(1097),
    [anon_sym_c_longdouble] = ACTIONS(1097),
    [aux_sym_builtin_type_token1] = ACTIONS(1097),
    [sym_builtin_identifier] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [sym__identifier] = ACTIONS(1101),
    [anon_sym_comptime] = ACTIONS(1101),
    [anon_sym_extern] = ACTIONS(1101),
    [anon_sym_const] = ACTIONS(1101),
    [anon_sym_var] = ACTIONS(1101),
    [anon_sym_inline] = ACTIONS(1101),
    [anon_sym_fn] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_packed] = ACTIONS(1101),
    [anon_sym_struct] = ACTIONS(1101),
    [anon_sym_opaque] = ACTIONS(1101),
    [anon_sym_enum] = ACTIONS(1101),
    [anon_sym_union] = ACTIONS(1101),
    [anon_sym_error] = ACTIONS(1101),
    [anon_sym_nosuspend] = ACTIONS(1101),
    [anon_sym_suspend] = ACTIONS(1101),
    [anon_sym_defer] = ACTIONS(1101),
    [anon_sym_errdefer] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_asm] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_DASH_PERCENT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [anon_sym_resume] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_try] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_anyframe] = ACTIONS(1101),
    [anon_sym_unreachable] = ACTIONS(1101),
    [anon_sym_undefined] = ACTIONS(1101),
    [anon_sym_null] = ACTIONS(1101),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [aux_sym_multiline_string_token1] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_integer] = ACTIONS(1101),
    [sym_float] = ACTIONS(1103),
    [anon_sym_true] = ACTIONS(1101),
    [anon_sym_false] = ACTIONS(1101),
    [anon_sym_bool] = ACTIONS(1101),
    [anon_sym_f16] = ACTIONS(1101),
    [anon_sym_f32] = ACTIONS(1101),
    [anon_sym_f64] = ACTIONS(1101),
    [anon_sym_f128] = ACTIONS(1101),
    [anon_sym_void] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(1101),
    [anon_sym_anyerror] = ACTIONS(1101),
    [anon_sym_anyopaque] = ACTIONS(1101),
    [anon_sym_anytype] = ACTIONS(1101),
    [anon_sym_noreturn] = ACTIONS(1101),
    [anon_sym_isize] = ACTIONS(1101),
    [anon_sym_usize] = ACTIONS(1101),
    [anon_sym_comptime_int] = ACTIONS(1101),
    [anon_sym_comptime_float] = ACTIONS(1101),
    [anon_sym_c_short] = ACTIONS(1101),
    [anon_sym_c_ushort] = ACTIONS(1101),
    [anon_sym_c_int] = ACTIONS(1101),
    [anon_sym_c_uint] = ACTIONS(1101),
    [anon_sym_c_long] = ACTIONS(1101),
    [anon_sym_c_ulong] = ACTIONS(1101),
    [anon_sym_c_longlong] = ACTIONS(1101),
    [anon_sym_c_ulonglong] = ACTIONS(1101),
    [anon_sym_c_longdouble] = ACTIONS(1101),
    [aux_sym_builtin_type_token1] = ACTIONS(1101),
    [sym_builtin_identifier] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [sym__identifier] = ACTIONS(1105),
    [anon_sym_comptime] = ACTIONS(1105),
    [anon_sym_extern] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_inline] = ACTIONS(1105),
    [anon_sym_fn] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_packed] = ACTIONS(1105),
    [anon_sym_struct] = ACTIONS(1105),
    [anon_sym_opaque] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [anon_sym_union] = ACTIONS(1105),
    [anon_sym_error] = ACTIONS(1105),
    [anon_sym_nosuspend] = ACTIONS(1105),
    [anon_sym_suspend] = ACTIONS(1105),
    [anon_sym_defer] = ACTIONS(1105),
    [anon_sym_errdefer] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_asm] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_DASH_PERCENT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_resume] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_anyframe] = ACTIONS(1105),
    [anon_sym_unreachable] = ACTIONS(1105),
    [anon_sym_undefined] = ACTIONS(1105),
    [anon_sym_null] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [aux_sym_multiline_string_token1] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [sym_integer] = ACTIONS(1105),
    [sym_float] = ACTIONS(1107),
    [anon_sym_true] = ACTIONS(1105),
    [anon_sym_false] = ACTIONS(1105),
    [anon_sym_bool] = ACTIONS(1105),
    [anon_sym_f16] = ACTIONS(1105),
    [anon_sym_f32] = ACTIONS(1105),
    [anon_sym_f64] = ACTIONS(1105),
    [anon_sym_f128] = ACTIONS(1105),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_anyerror] = ACTIONS(1105),
    [anon_sym_anyopaque] = ACTIONS(1105),
    [anon_sym_anytype] = ACTIONS(1105),
    [anon_sym_noreturn] = ACTIONS(1105),
    [anon_sym_isize] = ACTIONS(1105),
    [anon_sym_usize] = ACTIONS(1105),
    [anon_sym_comptime_int] = ACTIONS(1105),
    [anon_sym_comptime_float] = ACTIONS(1105),
    [anon_sym_c_short] = ACTIONS(1105),
    [anon_sym_c_ushort] = ACTIONS(1105),
    [anon_sym_c_int] = ACTIONS(1105),
    [anon_sym_c_uint] = ACTIONS(1105),
    [anon_sym_c_long] = ACTIONS(1105),
    [anon_sym_c_ulong] = ACTIONS(1105),
    [anon_sym_c_longlong] = ACTIONS(1105),
    [anon_sym_c_ulonglong] = ACTIONS(1105),
    [anon_sym_c_longdouble] = ACTIONS(1105),
    [aux_sym_builtin_type_token1] = ACTIONS(1105),
    [sym_builtin_identifier] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
  },
  [730] = {
    [sym__identifier] = ACTIONS(1109),
    [anon_sym_comptime] = ACTIONS(1109),
    [anon_sym_extern] = ACTIONS(1109),
    [anon_sym_const] = ACTIONS(1109),
    [anon_sym_var] = ACTIONS(1109),
    [anon_sym_inline] = ACTIONS(1109),
    [anon_sym_fn] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_RBRACE] = ACTIONS(1111),
    [anon_sym_packed] = ACTIONS(1109),
    [anon_sym_struct] = ACTIONS(1109),
    [anon_sym_opaque] = ACTIONS(1109),
    [anon_sym_enum] = ACTIONS(1109),
    [anon_sym_union] = ACTIONS(1109),
    [anon_sym_error] = ACTIONS(1109),
    [anon_sym_nosuspend] = ACTIONS(1109),
    [anon_sym_suspend] = ACTIONS(1109),
    [anon_sym_defer] = ACTIONS(1109),
    [anon_sym_errdefer] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_asm] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_DASH_PERCENT] = ACTIONS(1111),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_await] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_resume] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_switch] = ACTIONS(1109),
    [anon_sym_anyframe] = ACTIONS(1109),
    [anon_sym_unreachable] = ACTIONS(1109),
    [anon_sym_undefined] = ACTIONS(1109),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1111),
    [aux_sym_multiline_string_token1] = ACTIONS(1111),
    [anon_sym_SQUOTE] = ACTIONS(1111),
    [sym_integer] = ACTIONS(1109),
    [sym_float] = ACTIONS(1111),
    [anon_sym_true] = ACTIONS(1109),
    [anon_sym_false] = ACTIONS(1109),
    [anon_sym_bool] = ACTIONS(1109),
    [anon_sym_f16] = ACTIONS(1109),
    [anon_sym_f32] = ACTIONS(1109),
    [anon_sym_f64] = ACTIONS(1109),
    [anon_sym_f128] = ACTIONS(1109),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_anyerror] = ACTIONS(1109),
    [anon_sym_anyopaque] = ACTIONS(1109),
    [anon_sym_anytype] = ACTIONS(1109),
    [anon_sym_noreturn] = ACTIONS(1109),
    [anon_sym_isize] = ACTIONS(1109),
    [anon_sym_usize] = ACTIONS(1109),
    [anon_sym_comptime_int] = ACTIONS(1109),
    [anon_sym_comptime_float] = ACTIONS(1109),
    [anon_sym_c_short] = ACTIONS(1109),
    [anon_sym_c_ushort] = ACTIONS(1109),
    [anon_sym_c_int] = ACTIONS(1109),
    [anon_sym_c_uint] = ACTIONS(1109),
    [anon_sym_c_long] = ACTIONS(1109),
    [anon_sym_c_ulong] = ACTIONS(1109),
    [anon_sym_c_longlong] = ACTIONS(1109),
    [anon_sym_c_ulonglong] = ACTIONS(1109),
    [anon_sym_c_longdouble] = ACTIONS(1109),
    [aux_sym_builtin_type_token1] = ACTIONS(1109),
    [sym_builtin_identifier] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [sym__identifier] = ACTIONS(1113),
    [anon_sym_comptime] = ACTIONS(1113),
    [anon_sym_extern] = ACTIONS(1113),
    [anon_sym_const] = ACTIONS(1113),
    [anon_sym_var] = ACTIONS(1113),
    [anon_sym_inline] = ACTIONS(1113),
    [anon_sym_fn] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_packed] = ACTIONS(1113),
    [anon_sym_struct] = ACTIONS(1113),
    [anon_sym_opaque] = ACTIONS(1113),
    [anon_sym_enum] = ACTIONS(1113),
    [anon_sym_union] = ACTIONS(1113),
    [anon_sym_error] = ACTIONS(1113),
    [anon_sym_nosuspend] = ACTIONS(1113),
    [anon_sym_suspend] = ACTIONS(1113),
    [anon_sym_defer] = ACTIONS(1113),
    [anon_sym_errdefer] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_asm] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1113),
    [anon_sym_DASH_PERCENT] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [anon_sym_resume] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_try] = ACTIONS(1113),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_anyframe] = ACTIONS(1113),
    [anon_sym_unreachable] = ACTIONS(1113),
    [anon_sym_undefined] = ACTIONS(1113),
    [anon_sym_null] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [aux_sym_multiline_string_token1] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_integer] = ACTIONS(1113),
    [sym_float] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(1113),
    [anon_sym_false] = ACTIONS(1113),
    [anon_sym_bool] = ACTIONS(1113),
    [anon_sym_f16] = ACTIONS(1113),
    [anon_sym_f32] = ACTIONS(1113),
    [anon_sym_f64] = ACTIONS(1113),
    [anon_sym_f128] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1113),
    [anon_sym_anyerror] = ACTIONS(1113),
    [anon_sym_anyopaque] = ACTIONS(1113),
    [anon_sym_anytype] = ACTIONS(1113),
    [anon_sym_noreturn] = ACTIONS(1113),
    [anon_sym_isize] = ACTIONS(1113),
    [anon_sym_usize] = ACTIONS(1113),
    [anon_sym_comptime_int] = ACTIONS(1113),
    [anon_sym_comptime_float] = ACTIONS(1113),
    [anon_sym_c_short] = ACTIONS(1113),
    [anon_sym_c_ushort] = ACTIONS(1113),
    [anon_sym_c_int] = ACTIONS(1113),
    [anon_sym_c_uint] = ACTIONS(1113),
    [anon_sym_c_long] = ACTIONS(1113),
    [anon_sym_c_ulong] = ACTIONS(1113),
    [anon_sym_c_longlong] = ACTIONS(1113),
    [anon_sym_c_ulonglong] = ACTIONS(1113),
    [anon_sym_c_longdouble] = ACTIONS(1113),
    [aux_sym_builtin_type_token1] = ACTIONS(1113),
    [sym_builtin_identifier] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
  },
  [732] = {
    [sym__identifier] = ACTIONS(1117),
    [anon_sym_comptime] = ACTIONS(1117),
    [anon_sym_extern] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_inline] = ACTIONS(1117),
    [anon_sym_fn] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_packed] = ACTIONS(1117),
    [anon_sym_struct] = ACTIONS(1117),
    [anon_sym_opaque] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [anon_sym_union] = ACTIONS(1117),
    [anon_sym_error] = ACTIONS(1117),
    [anon_sym_nosuspend] = ACTIONS(1117),
    [anon_sym_suspend] = ACTIONS(1117),
    [anon_sym_defer] = ACTIONS(1117),
    [anon_sym_errdefer] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_asm] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_PERCENT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_resume] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_anyframe] = ACTIONS(1117),
    [anon_sym_unreachable] = ACTIONS(1117),
    [anon_sym_undefined] = ACTIONS(1117),
    [anon_sym_null] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1119),
    [aux_sym_multiline_string_token1] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1119),
    [sym_integer] = ACTIONS(1117),
    [sym_float] = ACTIONS(1119),
    [anon_sym_true] = ACTIONS(1117),
    [anon_sym_false] = ACTIONS(1117),
    [anon_sym_bool] = ACTIONS(1117),
    [anon_sym_f16] = ACTIONS(1117),
    [anon_sym_f32] = ACTIONS(1117),
    [anon_sym_f64] = ACTIONS(1117),
    [anon_sym_f128] = ACTIONS(1117),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_anyerror] = ACTIONS(1117),
    [anon_sym_anyopaque] = ACTIONS(1117),
    [anon_sym_anytype] = ACTIONS(1117),
    [anon_sym_noreturn] = ACTIONS(1117),
    [anon_sym_isize] = ACTIONS(1117),
    [anon_sym_usize] = ACTIONS(1117),
    [anon_sym_comptime_int] = ACTIONS(1117),
    [anon_sym_comptime_float] = ACTIONS(1117),
    [anon_sym_c_short] = ACTIONS(1117),
    [anon_sym_c_ushort] = ACTIONS(1117),
    [anon_sym_c_int] = ACTIONS(1117),
    [anon_sym_c_uint] = ACTIONS(1117),
    [anon_sym_c_long] = ACTIONS(1117),
    [anon_sym_c_ulong] = ACTIONS(1117),
    [anon_sym_c_longlong] = ACTIONS(1117),
    [anon_sym_c_ulonglong] = ACTIONS(1117),
    [anon_sym_c_longdouble] = ACTIONS(1117),
    [aux_sym_builtin_type_token1] = ACTIONS(1117),
    [sym_builtin_identifier] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
  },
  [733] = {
    [sym__identifier] = ACTIONS(939),
    [anon_sym_comptime] = ACTIONS(939),
    [anon_sym_extern] = ACTIONS(939),
    [anon_sym_const] = ACTIONS(939),
    [anon_sym_var] = ACTIONS(939),
    [anon_sym_inline] = ACTIONS(939),
    [anon_sym_fn] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_packed] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(939),
    [anon_sym_opaque] = ACTIONS(939),
    [anon_sym_enum] = ACTIONS(939),
    [anon_sym_union] = ACTIONS(939),
    [anon_sym_error] = ACTIONS(939),
    [anon_sym_nosuspend] = ACTIONS(939),
    [anon_sym_suspend] = ACTIONS(939),
    [anon_sym_defer] = ACTIONS(939),
    [anon_sym_errdefer] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_STAR] = ACTIONS(945),
    [anon_sym_asm] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_DASH_PERCENT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(945),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_await] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_resume] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_switch] = ACTIONS(939),
    [anon_sym_anyframe] = ACTIONS(939),
    [anon_sym_unreachable] = ACTIONS(939),
    [anon_sym_undefined] = ACTIONS(939),
    [anon_sym_null] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [aux_sym_multiline_string_token1] = ACTIONS(945),
    [anon_sym_SQUOTE] = ACTIONS(945),
    [sym_integer] = ACTIONS(939),
    [sym_float] = ACTIONS(945),
    [anon_sym_true] = ACTIONS(939),
    [anon_sym_false] = ACTIONS(939),
    [anon_sym_bool] = ACTIONS(939),
    [anon_sym_f16] = ACTIONS(939),
    [anon_sym_f32] = ACTIONS(939),
    [anon_sym_f64] = ACTIONS(939),
    [anon_sym_f128] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_type] = ACTIONS(939),
    [anon_sym_anyerror] = ACTIONS(939),
    [anon_sym_anyopaque] = ACTIONS(939),
    [anon_sym_anytype] = ACTIONS(939),
    [anon_sym_noreturn] = ACTIONS(939),
    [anon_sym_isize] = ACTIONS(939),
    [anon_sym_usize] = ACTIONS(939),
    [anon_sym_comptime_int] = ACTIONS(939),
    [anon_sym_comptime_float] = ACTIONS(939),
    [anon_sym_c_short] = ACTIONS(939),
    [anon_sym_c_ushort] = ACTIONS(939),
    [anon_sym_c_int] = ACTIONS(939),
    [anon_sym_c_uint] = ACTIONS(939),
    [anon_sym_c_long] = ACTIONS(939),
    [anon_sym_c_ulong] = ACTIONS(939),
    [anon_sym_c_longlong] = ACTIONS(939),
    [anon_sym_c_ulonglong] = ACTIONS(939),
    [anon_sym_c_longdouble] = ACTIONS(939),
    [aux_sym_builtin_type_token1] = ACTIONS(939),
    [sym_builtin_identifier] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [sym__identifier] = ACTIONS(1121),
    [anon_sym_comptime] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(1121),
    [anon_sym_var] = ACTIONS(1121),
    [anon_sym_inline] = ACTIONS(1121),
    [anon_sym_fn] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_packed] = ACTIONS(1121),
    [anon_sym_struct] = ACTIONS(1121),
    [anon_sym_opaque] = ACTIONS(1121),
    [anon_sym_enum] = ACTIONS(1121),
    [anon_sym_union] = ACTIONS(1121),
    [anon_sym_error] = ACTIONS(1121),
    [anon_sym_nosuspend] = ACTIONS(1121),
    [anon_sym_suspend] = ACTIONS(1121),
    [anon_sym_defer] = ACTIONS(1121),
    [anon_sym_errdefer] = ACTIONS(1121),
    [anon_sym_if] = ACTIONS(1121),
    [anon_sym_for] = ACTIONS(1121),
    [anon_sym_while] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_DASH_PERCENT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_async] = ACTIONS(1121),
    [anon_sym_await] = ACTIONS(1121),
    [anon_sym_continue] = ACTIONS(1121),
    [anon_sym_resume] = ACTIONS(1121),
    [anon_sym_return] = ACTIONS(1121),
    [anon_sym_break] = ACTIONS(1121),
    [anon_sym_try] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1121),
    [anon_sym_anyframe] = ACTIONS(1121),
    [anon_sym_unreachable] = ACTIONS(1121),
    [anon_sym_undefined] = ACTIONS(1121),
    [anon_sym_null] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [aux_sym_multiline_string_token1] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [sym_integer] = ACTIONS(1121),
    [sym_float] = ACTIONS(1123),
    [anon_sym_true] = ACTIONS(1121),
    [anon_sym_false] = ACTIONS(1121),
    [anon_sym_bool] = ACTIONS(1121),
    [anon_sym_f16] = ACTIONS(1121),
    [anon_sym_f32] = ACTIONS(1121),
    [anon_sym_f64] = ACTIONS(1121),
    [anon_sym_f128] = ACTIONS(1121),
    [anon_sym_void] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_anyerror] = ACTIONS(1121),
    [anon_sym_anyopaque] = ACTIONS(1121),
    [anon_sym_anytype] = ACTIONS(1121),
    [anon_sym_noreturn] = ACTIONS(1121),
    [anon_sym_isize] = ACTIONS(1121),
    [anon_sym_usize] = ACTIONS(1121),
    [anon_sym_comptime_int] = ACTIONS(1121),
    [anon_sym_comptime_float] = ACTIONS(1121),
    [anon_sym_c_short] = ACTIONS(1121),
    [anon_sym_c_ushort] = ACTIONS(1121),
    [anon_sym_c_int] = ACTIONS(1121),
    [anon_sym_c_uint] = ACTIONS(1121),
    [anon_sym_c_long] = ACTIONS(1121),
    [anon_sym_c_ulong] = ACTIONS(1121),
    [anon_sym_c_longlong] = ACTIONS(1121),
    [anon_sym_c_ulonglong] = ACTIONS(1121),
    [anon_sym_c_longdouble] = ACTIONS(1121),
    [aux_sym_builtin_type_token1] = ACTIONS(1121),
    [sym_builtin_identifier] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
  },
  [735] = {
    [sym__identifier] = ACTIONS(1125),
    [anon_sym_comptime] = ACTIONS(1125),
    [anon_sym_extern] = ACTIONS(1125),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(1125),
    [anon_sym_inline] = ACTIONS(1125),
    [anon_sym_fn] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_packed] = ACTIONS(1125),
    [anon_sym_struct] = ACTIONS(1125),
    [anon_sym_opaque] = ACTIONS(1125),
    [anon_sym_enum] = ACTIONS(1125),
    [anon_sym_union] = ACTIONS(1125),
    [anon_sym_error] = ACTIONS(1125),
    [anon_sym_nosuspend] = ACTIONS(1125),
    [anon_sym_suspend] = ACTIONS(1125),
    [anon_sym_defer] = ACTIONS(1125),
    [anon_sym_errdefer] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_for] = ACTIONS(1125),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_asm] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_DASH_PERCENT] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_resume] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_anyframe] = ACTIONS(1125),
    [anon_sym_unreachable] = ACTIONS(1125),
    [anon_sym_undefined] = ACTIONS(1125),
    [anon_sym_null] = ACTIONS(1125),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [aux_sym_multiline_string_token1] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1127),
    [sym_integer] = ACTIONS(1125),
    [sym_float] = ACTIONS(1127),
    [anon_sym_true] = ACTIONS(1125),
    [anon_sym_false] = ACTIONS(1125),
    [anon_sym_bool] = ACTIONS(1125),
    [anon_sym_f16] = ACTIONS(1125),
    [anon_sym_f32] = ACTIONS(1125),
    [anon_sym_f64] = ACTIONS(1125),
    [anon_sym_f128] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1125),
    [anon_sym_anyerror] = ACTIONS(1125),
    [anon_sym_anyopaque] = ACTIONS(1125),
    [anon_sym_anytype] = ACTIONS(1125),
    [anon_sym_noreturn] = ACTIONS(1125),
    [anon_sym_isize] = ACTIONS(1125),
    [anon_sym_usize] = ACTIONS(1125),
    [anon_sym_comptime_int] = ACTIONS(1125),
    [anon_sym_comptime_float] = ACTIONS(1125),
    [anon_sym_c_short] = ACTIONS(1125),
    [anon_sym_c_ushort] = ACTIONS(1125),
    [anon_sym_c_int] = ACTIONS(1125),
    [anon_sym_c_uint] = ACTIONS(1125),
    [anon_sym_c_long] = ACTIONS(1125),
    [anon_sym_c_ulong] = ACTIONS(1125),
    [anon_sym_c_longlong] = ACTIONS(1125),
    [anon_sym_c_ulonglong] = ACTIONS(1125),
    [anon_sym_c_longdouble] = ACTIONS(1125),
    [aux_sym_builtin_type_token1] = ACTIONS(1125),
    [sym_builtin_identifier] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
  },
  [736] = {
    [sym__identifier] = ACTIONS(1129),
    [anon_sym_comptime] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_var] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym_fn] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_packed] = ACTIONS(1129),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_opaque] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [anon_sym_error] = ACTIONS(1129),
    [anon_sym_nosuspend] = ACTIONS(1129),
    [anon_sym_suspend] = ACTIONS(1129),
    [anon_sym_defer] = ACTIONS(1129),
    [anon_sym_errdefer] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_asm] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_DASH_PERCENT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [anon_sym_resume] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_try] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_anyframe] = ACTIONS(1129),
    [anon_sym_unreachable] = ACTIONS(1129),
    [anon_sym_undefined] = ACTIONS(1129),
    [anon_sym_null] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [aux_sym_multiline_string_token1] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [sym_integer] = ACTIONS(1129),
    [sym_float] = ACTIONS(1131),
    [anon_sym_true] = ACTIONS(1129),
    [anon_sym_false] = ACTIONS(1129),
    [anon_sym_bool] = ACTIONS(1129),
    [anon_sym_f16] = ACTIONS(1129),
    [anon_sym_f32] = ACTIONS(1129),
    [anon_sym_f64] = ACTIONS(1129),
    [anon_sym_f128] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_type] = ACTIONS(1129),
    [anon_sym_anyerror] = ACTIONS(1129),
    [anon_sym_anyopaque] = ACTIONS(1129),
    [anon_sym_anytype] = ACTIONS(1129),
    [anon_sym_noreturn] = ACTIONS(1129),
    [anon_sym_isize] = ACTIONS(1129),
    [anon_sym_usize] = ACTIONS(1129),
    [anon_sym_comptime_int] = ACTIONS(1129),
    [anon_sym_comptime_float] = ACTIONS(1129),
    [anon_sym_c_short] = ACTIONS(1129),
    [anon_sym_c_ushort] = ACTIONS(1129),
    [anon_sym_c_int] = ACTIONS(1129),
    [anon_sym_c_uint] = ACTIONS(1129),
    [anon_sym_c_long] = ACTIONS(1129),
    [anon_sym_c_ulong] = ACTIONS(1129),
    [anon_sym_c_longlong] = ACTIONS(1129),
    [anon_sym_c_ulonglong] = ACTIONS(1129),
    [anon_sym_c_longdouble] = ACTIONS(1129),
    [aux_sym_builtin_type_token1] = ACTIONS(1129),
    [sym_builtin_identifier] = ACTIONS(1131),
    [anon_sym_AT] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
  },
  [737] = {
    [sym__identifier] = ACTIONS(1133),
    [anon_sym_comptime] = ACTIONS(1133),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_packed] = ACTIONS(1133),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_opaque] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_error] = ACTIONS(1133),
    [anon_sym_nosuspend] = ACTIONS(1133),
    [anon_sym_suspend] = ACTIONS(1133),
    [anon_sym_defer] = ACTIONS(1133),
    [anon_sym_errdefer] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_asm] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_DASH_PERCENT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_resume] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_try] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_anyframe] = ACTIONS(1133),
    [anon_sym_unreachable] = ACTIONS(1133),
    [anon_sym_undefined] = ACTIONS(1133),
    [anon_sym_null] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [aux_sym_multiline_string_token1] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_integer] = ACTIONS(1133),
    [sym_float] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1133),
    [anon_sym_false] = ACTIONS(1133),
    [anon_sym_bool] = ACTIONS(1133),
    [anon_sym_f16] = ACTIONS(1133),
    [anon_sym_f32] = ACTIONS(1133),
    [anon_sym_f64] = ACTIONS(1133),
    [anon_sym_f128] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1133),
    [anon_sym_anyerror] = ACTIONS(1133),
    [anon_sym_anyopaque] = ACTIONS(1133),
    [anon_sym_anytype] = ACTIONS(1133),
    [anon_sym_noreturn] = ACTIONS(1133),
    [anon_sym_isize] = ACTIONS(1133),
    [anon_sym_usize] = ACTIONS(1133),
    [anon_sym_comptime_int] = ACTIONS(1133),
    [anon_sym_comptime_float] = ACTIONS(1133),
    [anon_sym_c_short] = ACTIONS(1133),
    [anon_sym_c_ushort] = ACTIONS(1133),
    [anon_sym_c_int] = ACTIONS(1133),
    [anon_sym_c_uint] = ACTIONS(1133),
    [anon_sym_c_long] = ACTIONS(1133),
    [anon_sym_c_ulong] = ACTIONS(1133),
    [anon_sym_c_longlong] = ACTIONS(1133),
    [anon_sym_c_ulonglong] = ACTIONS(1133),
    [anon_sym_c_longdouble] = ACTIONS(1133),
    [aux_sym_builtin_type_token1] = ACTIONS(1133),
    [sym_builtin_identifier] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [sym__identifier] = ACTIONS(931),
    [anon_sym_comptime] = ACTIONS(931),
    [anon_sym_extern] = ACTIONS(931),
    [anon_sym_const] = ACTIONS(931),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_inline] = ACTIONS(931),
    [anon_sym_fn] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_LBRACE] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_packed] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(931),
    [anon_sym_opaque] = ACTIONS(931),
    [anon_sym_enum] = ACTIONS(931),
    [anon_sym_union] = ACTIONS(931),
    [anon_sym_error] = ACTIONS(931),
    [anon_sym_nosuspend] = ACTIONS(931),
    [anon_sym_suspend] = ACTIONS(931),
    [anon_sym_defer] = ACTIONS(931),
    [anon_sym_errdefer] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_asm] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_DASH_PERCENT] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(933),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_await] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_resume] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_switch] = ACTIONS(931),
    [anon_sym_anyframe] = ACTIONS(931),
    [anon_sym_unreachable] = ACTIONS(931),
    [anon_sym_undefined] = ACTIONS(931),
    [anon_sym_null] = ACTIONS(931),
    [anon_sym_QMARK] = ACTIONS(933),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(933),
    [aux_sym_multiline_string_token1] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(933),
    [sym_integer] = ACTIONS(931),
    [sym_float] = ACTIONS(933),
    [anon_sym_true] = ACTIONS(931),
    [anon_sym_false] = ACTIONS(931),
    [anon_sym_bool] = ACTIONS(931),
    [anon_sym_f16] = ACTIONS(931),
    [anon_sym_f32] = ACTIONS(931),
    [anon_sym_f64] = ACTIONS(931),
    [anon_sym_f128] = ACTIONS(931),
    [anon_sym_void] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(931),
    [anon_sym_anyerror] = ACTIONS(931),
    [anon_sym_anyopaque] = ACTIONS(931),
    [anon_sym_anytype] = ACTIONS(931),
    [anon_sym_noreturn] = ACTIONS(931),
    [anon_sym_isize] = ACTIONS(931),
    [anon_sym_usize] = ACTIONS(931),
    [anon_sym_comptime_int] = ACTIONS(931),
    [anon_sym_comptime_float] = ACTIONS(931),
    [anon_sym_c_short] = ACTIONS(931),
    [anon_sym_c_ushort] = ACTIONS(931),
    [anon_sym_c_int] = ACTIONS(931),
    [anon_sym_c_uint] = ACTIONS(931),
    [anon_sym_c_long] = ACTIONS(931),
    [anon_sym_c_ulong] = ACTIONS(931),
    [anon_sym_c_longlong] = ACTIONS(931),
    [anon_sym_c_ulonglong] = ACTIONS(931),
    [anon_sym_c_longdouble] = ACTIONS(931),
    [aux_sym_builtin_type_token1] = ACTIONS(931),
    [sym_builtin_identifier] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [sym__identifier] = ACTIONS(1137),
    [anon_sym_comptime] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym_fn] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_packed] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_opaque] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [anon_sym_error] = ACTIONS(1137),
    [anon_sym_nosuspend] = ACTIONS(1137),
    [anon_sym_suspend] = ACTIONS(1137),
    [anon_sym_defer] = ACTIONS(1137),
    [anon_sym_errdefer] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_asm] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_DASH_PERCENT] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_resume] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_anyframe] = ACTIONS(1137),
    [anon_sym_unreachable] = ACTIONS(1137),
    [anon_sym_undefined] = ACTIONS(1137),
    [anon_sym_null] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [aux_sym_multiline_string_token1] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_integer] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [anon_sym_true] = ACTIONS(1137),
    [anon_sym_false] = ACTIONS(1137),
    [anon_sym_bool] = ACTIONS(1137),
    [anon_sym_f16] = ACTIONS(1137),
    [anon_sym_f32] = ACTIONS(1137),
    [anon_sym_f64] = ACTIONS(1137),
    [anon_sym_f128] = ACTIONS(1137),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_anyerror] = ACTIONS(1137),
    [anon_sym_anyopaque] = ACTIONS(1137),
    [anon_sym_anytype] = ACTIONS(1137),
    [anon_sym_noreturn] = ACTIONS(1137),
    [anon_sym_isize] = ACTIONS(1137),
    [anon_sym_usize] = ACTIONS(1137),
    [anon_sym_comptime_int] = ACTIONS(1137),
    [anon_sym_comptime_float] = ACTIONS(1137),
    [anon_sym_c_short] = ACTIONS(1137),
    [anon_sym_c_ushort] = ACTIONS(1137),
    [anon_sym_c_int] = ACTIONS(1137),
    [anon_sym_c_uint] = ACTIONS(1137),
    [anon_sym_c_long] = ACTIONS(1137),
    [anon_sym_c_ulong] = ACTIONS(1137),
    [anon_sym_c_longlong] = ACTIONS(1137),
    [anon_sym_c_ulonglong] = ACTIONS(1137),
    [anon_sym_c_longdouble] = ACTIONS(1137),
    [aux_sym_builtin_type_token1] = ACTIONS(1137),
    [sym_builtin_identifier] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [740] = {
    [sym__identifier] = ACTIONS(1141),
    [anon_sym_comptime] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym_fn] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_packed] = ACTIONS(1141),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_opaque] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [anon_sym_error] = ACTIONS(1141),
    [anon_sym_nosuspend] = ACTIONS(1141),
    [anon_sym_suspend] = ACTIONS(1141),
    [anon_sym_defer] = ACTIONS(1141),
    [anon_sym_errdefer] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_asm] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_DASH_PERCENT] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_resume] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_anyframe] = ACTIONS(1141),
    [anon_sym_unreachable] = ACTIONS(1141),
    [anon_sym_undefined] = ACTIONS(1141),
    [anon_sym_null] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [aux_sym_multiline_string_token1] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [sym_integer] = ACTIONS(1141),
    [sym_float] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(1141),
    [anon_sym_false] = ACTIONS(1141),
    [anon_sym_bool] = ACTIONS(1141),
    [anon_sym_f16] = ACTIONS(1141),
    [anon_sym_f32] = ACTIONS(1141),
    [anon_sym_f64] = ACTIONS(1141),
    [anon_sym_f128] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(1141),
    [anon_sym_anyerror] = ACTIONS(1141),
    [anon_sym_anyopaque] = ACTIONS(1141),
    [anon_sym_anytype] = ACTIONS(1141),
    [anon_sym_noreturn] = ACTIONS(1141),
    [anon_sym_isize] = ACTIONS(1141),
    [anon_sym_usize] = ACTIONS(1141),
    [anon_sym_comptime_int] = ACTIONS(1141),
    [anon_sym_comptime_float] = ACTIONS(1141),
    [anon_sym_c_short] = ACTIONS(1141),
    [anon_sym_c_ushort] = ACTIONS(1141),
    [anon_sym_c_int] = ACTIONS(1141),
    [anon_sym_c_uint] = ACTIONS(1141),
    [anon_sym_c_long] = ACTIONS(1141),
    [anon_sym_c_ulong] = ACTIONS(1141),
    [anon_sym_c_longlong] = ACTIONS(1141),
    [anon_sym_c_ulonglong] = ACTIONS(1141),
    [anon_sym_c_longdouble] = ACTIONS(1141),
    [aux_sym_builtin_type_token1] = ACTIONS(1141),
    [sym_builtin_identifier] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [sym__identifier] = ACTIONS(1145),
    [anon_sym_comptime] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_var] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym_fn] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_packed] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_opaque] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_error] = ACTIONS(1145),
    [anon_sym_nosuspend] = ACTIONS(1145),
    [anon_sym_suspend] = ACTIONS(1145),
    [anon_sym_defer] = ACTIONS(1145),
    [anon_sym_errdefer] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_asm] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_DASH_PERCENT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_resume] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_try] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_anyframe] = ACTIONS(1145),
    [anon_sym_unreachable] = ACTIONS(1145),
    [anon_sym_undefined] = ACTIONS(1145),
    [anon_sym_null] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [aux_sym_multiline_string_token1] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [sym_integer] = ACTIONS(1145),
    [sym_float] = ACTIONS(1147),
    [anon_sym_true] = ACTIONS(1145),
    [anon_sym_false] = ACTIONS(1145),
    [anon_sym_bool] = ACTIONS(1145),
    [anon_sym_f16] = ACTIONS(1145),
    [anon_sym_f32] = ACTIONS(1145),
    [anon_sym_f64] = ACTIONS(1145),
    [anon_sym_f128] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1145),
    [anon_sym_anyerror] = ACTIONS(1145),
    [anon_sym_anyopaque] = ACTIONS(1145),
    [anon_sym_anytype] = ACTIONS(1145),
    [anon_sym_noreturn] = ACTIONS(1145),
    [anon_sym_isize] = ACTIONS(1145),
    [anon_sym_usize] = ACTIONS(1145),
    [anon_sym_comptime_int] = ACTIONS(1145),
    [anon_sym_comptime_float] = ACTIONS(1145),
    [anon_sym_c_short] = ACTIONS(1145),
    [anon_sym_c_ushort] = ACTIONS(1145),
    [anon_sym_c_int] = ACTIONS(1145),
    [anon_sym_c_uint] = ACTIONS(1145),
    [anon_sym_c_long] = ACTIONS(1145),
    [anon_sym_c_ulong] = ACTIONS(1145),
    [anon_sym_c_longlong] = ACTIONS(1145),
    [anon_sym_c_ulonglong] = ACTIONS(1145),
    [anon_sym_c_longdouble] = ACTIONS(1145),
    [aux_sym_builtin_type_token1] = ACTIONS(1145),
    [sym_builtin_identifier] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [742] = {
    [sym__identifier] = ACTIONS(1149),
    [anon_sym_comptime] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_var] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym_fn] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_packed] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_opaque] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_error] = ACTIONS(1149),
    [anon_sym_nosuspend] = ACTIONS(1149),
    [anon_sym_suspend] = ACTIONS(1149),
    [anon_sym_defer] = ACTIONS(1149),
    [anon_sym_errdefer] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_asm] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_DASH_PERCENT] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_resume] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_try] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_anyframe] = ACTIONS(1149),
    [anon_sym_unreachable] = ACTIONS(1149),
    [anon_sym_undefined] = ACTIONS(1149),
    [anon_sym_null] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [aux_sym_multiline_string_token1] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_integer] = ACTIONS(1149),
    [sym_float] = ACTIONS(1151),
    [anon_sym_true] = ACTIONS(1149),
    [anon_sym_false] = ACTIONS(1149),
    [anon_sym_bool] = ACTIONS(1149),
    [anon_sym_f16] = ACTIONS(1149),
    [anon_sym_f32] = ACTIONS(1149),
    [anon_sym_f64] = ACTIONS(1149),
    [anon_sym_f128] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1149),
    [anon_sym_anyerror] = ACTIONS(1149),
    [anon_sym_anyopaque] = ACTIONS(1149),
    [anon_sym_anytype] = ACTIONS(1149),
    [anon_sym_noreturn] = ACTIONS(1149),
    [anon_sym_isize] = ACTIONS(1149),
    [anon_sym_usize] = ACTIONS(1149),
    [anon_sym_comptime_int] = ACTIONS(1149),
    [anon_sym_comptime_float] = ACTIONS(1149),
    [anon_sym_c_short] = ACTIONS(1149),
    [anon_sym_c_ushort] = ACTIONS(1149),
    [anon_sym_c_int] = ACTIONS(1149),
    [anon_sym_c_uint] = ACTIONS(1149),
    [anon_sym_c_long] = ACTIONS(1149),
    [anon_sym_c_ulong] = ACTIONS(1149),
    [anon_sym_c_longlong] = ACTIONS(1149),
    [anon_sym_c_ulonglong] = ACTIONS(1149),
    [anon_sym_c_longdouble] = ACTIONS(1149),
    [aux_sym_builtin_type_token1] = ACTIONS(1149),
    [sym_builtin_identifier] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [743] = {
    [sym__identifier] = ACTIONS(1153),
    [anon_sym_comptime] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_var] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym_fn] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_packed] = ACTIONS(1153),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_opaque] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_error] = ACTIONS(1153),
    [anon_sym_nosuspend] = ACTIONS(1153),
    [anon_sym_suspend] = ACTIONS(1153),
    [anon_sym_defer] = ACTIONS(1153),
    [anon_sym_errdefer] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_asm] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_DASH_PERCENT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_resume] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_anyframe] = ACTIONS(1153),
    [anon_sym_unreachable] = ACTIONS(1153),
    [anon_sym_undefined] = ACTIONS(1153),
    [anon_sym_null] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [aux_sym_multiline_string_token1] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [sym_integer] = ACTIONS(1153),
    [sym_float] = ACTIONS(1155),
    [anon_sym_true] = ACTIONS(1153),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_bool] = ACTIONS(1153),
    [anon_sym_f16] = ACTIONS(1153),
    [anon_sym_f32] = ACTIONS(1153),
    [anon_sym_f64] = ACTIONS(1153),
    [anon_sym_f128] = ACTIONS(1153),
    [anon_sym_void] = ACTIONS(1153),
    [anon_sym_type] = ACTIONS(1153),
    [anon_sym_anyerror] = ACTIONS(1153),
    [anon_sym_anyopaque] = ACTIONS(1153),
    [anon_sym_anytype] = ACTIONS(1153),
    [anon_sym_noreturn] = ACTIONS(1153),
    [anon_sym_isize] = ACTIONS(1153),
    [anon_sym_usize] = ACTIONS(1153),
    [anon_sym_comptime_int] = ACTIONS(1153),
    [anon_sym_comptime_float] = ACTIONS(1153),
    [anon_sym_c_short] = ACTIONS(1153),
    [anon_sym_c_ushort] = ACTIONS(1153),
    [anon_sym_c_int] = ACTIONS(1153),
    [anon_sym_c_uint] = ACTIONS(1153),
    [anon_sym_c_long] = ACTIONS(1153),
    [anon_sym_c_ulong] = ACTIONS(1153),
    [anon_sym_c_longlong] = ACTIONS(1153),
    [anon_sym_c_ulonglong] = ACTIONS(1153),
    [anon_sym_c_longdouble] = ACTIONS(1153),
    [aux_sym_builtin_type_token1] = ACTIONS(1153),
    [sym_builtin_identifier] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [744] = {
    [sym__identifier] = ACTIONS(1157),
    [anon_sym_comptime] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_var] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym_fn] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_packed] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_opaque] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_error] = ACTIONS(1157),
    [anon_sym_nosuspend] = ACTIONS(1157),
    [anon_sym_suspend] = ACTIONS(1157),
    [anon_sym_defer] = ACTIONS(1157),
    [anon_sym_errdefer] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_asm] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_DASH_PERCENT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_await] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_resume] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_try] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_anyframe] = ACTIONS(1157),
    [anon_sym_unreachable] = ACTIONS(1157),
    [anon_sym_undefined] = ACTIONS(1157),
    [anon_sym_null] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [aux_sym_multiline_string_token1] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_integer] = ACTIONS(1157),
    [sym_float] = ACTIONS(1159),
    [anon_sym_true] = ACTIONS(1157),
    [anon_sym_false] = ACTIONS(1157),
    [anon_sym_bool] = ACTIONS(1157),
    [anon_sym_f16] = ACTIONS(1157),
    [anon_sym_f32] = ACTIONS(1157),
    [anon_sym_f64] = ACTIONS(1157),
    [anon_sym_f128] = ACTIONS(1157),
    [anon_sym_void] = ACTIONS(1157),
    [anon_sym_type] = ACTIONS(1157),
    [anon_sym_anyerror] = ACTIONS(1157),
    [anon_sym_anyopaque] = ACTIONS(1157),
    [anon_sym_anytype] = ACTIONS(1157),
    [anon_sym_noreturn] = ACTIONS(1157),
    [anon_sym_isize] = ACTIONS(1157),
    [anon_sym_usize] = ACTIONS(1157),
    [anon_sym_comptime_int] = ACTIONS(1157),
    [anon_sym_comptime_float] = ACTIONS(1157),
    [anon_sym_c_short] = ACTIONS(1157),
    [anon_sym_c_ushort] = ACTIONS(1157),
    [anon_sym_c_int] = ACTIONS(1157),
    [anon_sym_c_uint] = ACTIONS(1157),
    [anon_sym_c_long] = ACTIONS(1157),
    [anon_sym_c_ulong] = ACTIONS(1157),
    [anon_sym_c_longlong] = ACTIONS(1157),
    [anon_sym_c_ulonglong] = ACTIONS(1157),
    [anon_sym_c_longdouble] = ACTIONS(1157),
    [aux_sym_builtin_type_token1] = ACTIONS(1157),
    [sym_builtin_identifier] = ACTIONS(1159),
    [anon_sym_AT] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [745] = {
    [sym__identifier] = ACTIONS(1161),
    [anon_sym_comptime] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym_fn] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_packed] = ACTIONS(1161),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_opaque] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [anon_sym_error] = ACTIONS(1161),
    [anon_sym_nosuspend] = ACTIONS(1161),
    [anon_sym_suspend] = ACTIONS(1161),
    [anon_sym_defer] = ACTIONS(1161),
    [anon_sym_errdefer] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_asm] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_DASH_PERCENT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_await] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_resume] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_anyframe] = ACTIONS(1161),
    [anon_sym_unreachable] = ACTIONS(1161),
    [anon_sym_undefined] = ACTIONS(1161),
    [anon_sym_null] = ACTIONS(1161),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [aux_sym_multiline_string_token1] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_integer] = ACTIONS(1161),
    [sym_float] = ACTIONS(1163),
    [anon_sym_true] = ACTIONS(1161),
    [anon_sym_false] = ACTIONS(1161),
    [anon_sym_bool] = ACTIONS(1161),
    [anon_sym_f16] = ACTIONS(1161),
    [anon_sym_f32] = ACTIONS(1161),
    [anon_sym_f64] = ACTIONS(1161),
    [anon_sym_f128] = ACTIONS(1161),
    [anon_sym_void] = ACTIONS(1161),
    [anon_sym_type] = ACTIONS(1161),
    [anon_sym_anyerror] = ACTIONS(1161),
    [anon_sym_anyopaque] = ACTIONS(1161),
    [anon_sym_anytype] = ACTIONS(1161),
    [anon_sym_noreturn] = ACTIONS(1161),
    [anon_sym_isize] = ACTIONS(1161),
    [anon_sym_usize] = ACTIONS(1161),
    [anon_sym_comptime_int] = ACTIONS(1161),
    [anon_sym_comptime_float] = ACTIONS(1161),
    [anon_sym_c_short] = ACTIONS(1161),
    [anon_sym_c_ushort] = ACTIONS(1161),
    [anon_sym_c_int] = ACTIONS(1161),
    [anon_sym_c_uint] = ACTIONS(1161),
    [anon_sym_c_long] = ACTIONS(1161),
    [anon_sym_c_ulong] = ACTIONS(1161),
    [anon_sym_c_longlong] = ACTIONS(1161),
    [anon_sym_c_ulonglong] = ACTIONS(1161),
    [anon_sym_c_longdouble] = ACTIONS(1161),
    [aux_sym_builtin_type_token1] = ACTIONS(1161),
    [sym_builtin_identifier] = ACTIONS(1163),
    [anon_sym_AT] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [746] = {
    [sym__identifier] = ACTIONS(1165),
    [anon_sym_comptime] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym_fn] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_packed] = ACTIONS(1165),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_opaque] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [anon_sym_error] = ACTIONS(1165),
    [anon_sym_nosuspend] = ACTIONS(1165),
    [anon_sym_suspend] = ACTIONS(1165),
    [anon_sym_defer] = ACTIONS(1165),
    [anon_sym_errdefer] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1167),
    [anon_sym_asm] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_DASH_PERCENT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_resume] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_anyframe] = ACTIONS(1165),
    [anon_sym_unreachable] = ACTIONS(1165),
    [anon_sym_undefined] = ACTIONS(1165),
    [anon_sym_null] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [aux_sym_multiline_string_token1] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_integer] = ACTIONS(1165),
    [sym_float] = ACTIONS(1167),
    [anon_sym_true] = ACTIONS(1165),
    [anon_sym_false] = ACTIONS(1165),
    [anon_sym_bool] = ACTIONS(1165),
    [anon_sym_f16] = ACTIONS(1165),
    [anon_sym_f32] = ACTIONS(1165),
    [anon_sym_f64] = ACTIONS(1165),
    [anon_sym_f128] = ACTIONS(1165),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_anyerror] = ACTIONS(1165),
    [anon_sym_anyopaque] = ACTIONS(1165),
    [anon_sym_anytype] = ACTIONS(1165),
    [anon_sym_noreturn] = ACTIONS(1165),
    [anon_sym_isize] = ACTIONS(1165),
    [anon_sym_usize] = ACTIONS(1165),
    [anon_sym_comptime_int] = ACTIONS(1165),
    [anon_sym_comptime_float] = ACTIONS(1165),
    [anon_sym_c_short] = ACTIONS(1165),
    [anon_sym_c_ushort] = ACTIONS(1165),
    [anon_sym_c_int] = ACTIONS(1165),
    [anon_sym_c_uint] = ACTIONS(1165),
    [anon_sym_c_long] = ACTIONS(1165),
    [anon_sym_c_ulong] = ACTIONS(1165),
    [anon_sym_c_longlong] = ACTIONS(1165),
    [anon_sym_c_ulonglong] = ACTIONS(1165),
    [anon_sym_c_longdouble] = ACTIONS(1165),
    [aux_sym_builtin_type_token1] = ACTIONS(1165),
    [sym_builtin_identifier] = ACTIONS(1167),
    [anon_sym_AT] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [747] = {
    [sym__identifier] = ACTIONS(1169),
    [anon_sym_comptime] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym_fn] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_packed] = ACTIONS(1169),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_opaque] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [anon_sym_error] = ACTIONS(1169),
    [anon_sym_nosuspend] = ACTIONS(1169),
    [anon_sym_suspend] = ACTIONS(1169),
    [anon_sym_defer] = ACTIONS(1169),
    [anon_sym_errdefer] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_asm] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_DASH_PERCENT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_await] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_resume] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_anyframe] = ACTIONS(1169),
    [anon_sym_unreachable] = ACTIONS(1169),
    [anon_sym_undefined] = ACTIONS(1169),
    [anon_sym_null] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [aux_sym_multiline_string_token1] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_integer] = ACTIONS(1169),
    [sym_float] = ACTIONS(1171),
    [anon_sym_true] = ACTIONS(1169),
    [anon_sym_false] = ACTIONS(1169),
    [anon_sym_bool] = ACTIONS(1169),
    [anon_sym_f16] = ACTIONS(1169),
    [anon_sym_f32] = ACTIONS(1169),
    [anon_sym_f64] = ACTIONS(1169),
    [anon_sym_f128] = ACTIONS(1169),
    [anon_sym_void] = ACTIONS(1169),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_anyerror] = ACTIONS(1169),
    [anon_sym_anyopaque] = ACTIONS(1169),
    [anon_sym_anytype] = ACTIONS(1169),
    [anon_sym_noreturn] = ACTIONS(1169),
    [anon_sym_isize] = ACTIONS(1169),
    [anon_sym_usize] = ACTIONS(1169),
    [anon_sym_comptime_int] = ACTIONS(1169),
    [anon_sym_comptime_float] = ACTIONS(1169),
    [anon_sym_c_short] = ACTIONS(1169),
    [anon_sym_c_ushort] = ACTIONS(1169),
    [anon_sym_c_int] = ACTIONS(1169),
    [anon_sym_c_uint] = ACTIONS(1169),
    [anon_sym_c_long] = ACTIONS(1169),
    [anon_sym_c_ulong] = ACTIONS(1169),
    [anon_sym_c_longlong] = ACTIONS(1169),
    [anon_sym_c_ulonglong] = ACTIONS(1169),
    [anon_sym_c_longdouble] = ACTIONS(1169),
    [aux_sym_builtin_type_token1] = ACTIONS(1169),
    [sym_builtin_identifier] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [748] = {
    [sym__identifier] = ACTIONS(1173),
    [anon_sym_comptime] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_packed] = ACTIONS(1173),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_opaque] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [anon_sym_error] = ACTIONS(1173),
    [anon_sym_nosuspend] = ACTIONS(1173),
    [anon_sym_suspend] = ACTIONS(1173),
    [anon_sym_defer] = ACTIONS(1173),
    [anon_sym_errdefer] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_asm] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_DASH_PERCENT] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_resume] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_anyframe] = ACTIONS(1173),
    [anon_sym_unreachable] = ACTIONS(1173),
    [anon_sym_undefined] = ACTIONS(1173),
    [anon_sym_null] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [aux_sym_multiline_string_token1] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_integer] = ACTIONS(1173),
    [sym_float] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1173),
    [anon_sym_false] = ACTIONS(1173),
    [anon_sym_bool] = ACTIONS(1173),
    [anon_sym_f16] = ACTIONS(1173),
    [anon_sym_f32] = ACTIONS(1173),
    [anon_sym_f64] = ACTIONS(1173),
    [anon_sym_f128] = ACTIONS(1173),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_anyerror] = ACTIONS(1173),
    [anon_sym_anyopaque] = ACTIONS(1173),
    [anon_sym_anytype] = ACTIONS(1173),
    [anon_sym_noreturn] = ACTIONS(1173),
    [anon_sym_isize] = ACTIONS(1173),
    [anon_sym_usize] = ACTIONS(1173),
    [anon_sym_comptime_int] = ACTIONS(1173),
    [anon_sym_comptime_float] = ACTIONS(1173),
    [anon_sym_c_short] = ACTIONS(1173),
    [anon_sym_c_ushort] = ACTIONS(1173),
    [anon_sym_c_int] = ACTIONS(1173),
    [anon_sym_c_uint] = ACTIONS(1173),
    [anon_sym_c_long] = ACTIONS(1173),
    [anon_sym_c_ulong] = ACTIONS(1173),
    [anon_sym_c_longlong] = ACTIONS(1173),
    [anon_sym_c_ulonglong] = ACTIONS(1173),
    [anon_sym_c_longdouble] = ACTIONS(1173),
    [aux_sym_builtin_type_token1] = ACTIONS(1173),
    [sym_builtin_identifier] = ACTIONS(1175),
    [anon_sym_AT] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [749] = {
    [sym__identifier] = ACTIONS(1177),
    [anon_sym_comptime] = ACTIONS(1177),
    [anon_sym_COLON] = ACTIONS(1179),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_var] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym_fn] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_packed] = ACTIONS(1177),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_opaque] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [anon_sym_error] = ACTIONS(1177),
    [anon_sym_nosuspend] = ACTIONS(1177),
    [anon_sym_suspend] = ACTIONS(1177),
    [anon_sym_defer] = ACTIONS(1177),
    [anon_sym_errdefer] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_asm] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_PERCENT] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_await] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_resume] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_try] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_anyframe] = ACTIONS(1177),
    [anon_sym_unreachable] = ACTIONS(1177),
    [anon_sym_undefined] = ACTIONS(1177),
    [anon_sym_null] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [aux_sym_multiline_string_token1] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [sym_integer] = ACTIONS(1177),
    [sym_float] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_bool] = ACTIONS(1177),
    [anon_sym_f16] = ACTIONS(1177),
    [anon_sym_f32] = ACTIONS(1177),
    [anon_sym_f64] = ACTIONS(1177),
    [anon_sym_f128] = ACTIONS(1177),
    [anon_sym_void] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_anyerror] = ACTIONS(1177),
    [anon_sym_anyopaque] = ACTIONS(1177),
    [anon_sym_anytype] = ACTIONS(1177),
    [anon_sym_noreturn] = ACTIONS(1177),
    [anon_sym_isize] = ACTIONS(1177),
    [anon_sym_usize] = ACTIONS(1177),
    [anon_sym_comptime_int] = ACTIONS(1177),
    [anon_sym_comptime_float] = ACTIONS(1177),
    [anon_sym_c_short] = ACTIONS(1177),
    [anon_sym_c_ushort] = ACTIONS(1177),
    [anon_sym_c_int] = ACTIONS(1177),
    [anon_sym_c_uint] = ACTIONS(1177),
    [anon_sym_c_long] = ACTIONS(1177),
    [anon_sym_c_ulong] = ACTIONS(1177),
    [anon_sym_c_longlong] = ACTIONS(1177),
    [anon_sym_c_ulonglong] = ACTIONS(1177),
    [anon_sym_c_longdouble] = ACTIONS(1177),
    [aux_sym_builtin_type_token1] = ACTIONS(1177),
    [sym_builtin_identifier] = ACTIONS(1179),
    [anon_sym_AT] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [750] = {
    [sym__identifier] = ACTIONS(1181),
    [anon_sym_comptime] = ACTIONS(1181),
    [anon_sym_extern] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_var] = ACTIONS(1181),
    [anon_sym_inline] = ACTIONS(1181),
    [anon_sym_fn] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_packed] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1181),
    [anon_sym_opaque] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1181),
    [anon_sym_error] = ACTIONS(1181),
    [anon_sym_nosuspend] = ACTIONS(1181),
    [anon_sym_suspend] = ACTIONS(1181),
    [anon_sym_defer] = ACTIONS(1181),
    [anon_sym_errdefer] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_asm] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_DASH_PERCENT] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1181),
    [anon_sym_await] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_resume] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_try] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_anyframe] = ACTIONS(1181),
    [anon_sym_unreachable] = ACTIONS(1181),
    [anon_sym_undefined] = ACTIONS(1181),
    [anon_sym_null] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [aux_sym_multiline_string_token1] = ACTIONS(1183),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [sym_integer] = ACTIONS(1181),
    [sym_float] = ACTIONS(1183),
    [anon_sym_true] = ACTIONS(1181),
    [anon_sym_false] = ACTIONS(1181),
    [anon_sym_bool] = ACTIONS(1181),
    [anon_sym_f16] = ACTIONS(1181),
    [anon_sym_f32] = ACTIONS(1181),
    [anon_sym_f64] = ACTIONS(1181),
    [anon_sym_f128] = ACTIONS(1181),
    [anon_sym_void] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_anyerror] = ACTIONS(1181),
    [anon_sym_anyopaque] = ACTIONS(1181),
    [anon_sym_anytype] = ACTIONS(1181),
    [anon_sym_noreturn] = ACTIONS(1181),
    [anon_sym_isize] = ACTIONS(1181),
    [anon_sym_usize] = ACTIONS(1181),
    [anon_sym_comptime_int] = ACTIONS(1181),
    [anon_sym_comptime_float] = ACTIONS(1181),
    [anon_sym_c_short] = ACTIONS(1181),
    [anon_sym_c_ushort] = ACTIONS(1181),
    [anon_sym_c_int] = ACTIONS(1181),
    [anon_sym_c_uint] = ACTIONS(1181),
    [anon_sym_c_long] = ACTIONS(1181),
    [anon_sym_c_ulong] = ACTIONS(1181),
    [anon_sym_c_longlong] = ACTIONS(1181),
    [anon_sym_c_ulonglong] = ACTIONS(1181),
    [anon_sym_c_longdouble] = ACTIONS(1181),
    [aux_sym_builtin_type_token1] = ACTIONS(1181),
    [sym_builtin_identifier] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [751] = {
    [sym__identifier] = ACTIONS(1185),
    [anon_sym_comptime] = ACTIONS(1185),
    [anon_sym_extern] = ACTIONS(1185),
    [anon_sym_const] = ACTIONS(1185),
    [anon_sym_var] = ACTIONS(1185),
    [anon_sym_inline] = ACTIONS(1185),
    [anon_sym_fn] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_packed] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_opaque] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1185),
    [anon_sym_union] = ACTIONS(1185),
    [anon_sym_error] = ACTIONS(1185),
    [anon_sym_nosuspend] = ACTIONS(1185),
    [anon_sym_suspend] = ACTIONS(1185),
    [anon_sym_defer] = ACTIONS(1185),
    [anon_sym_errdefer] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_asm] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_DASH_PERCENT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1185),
    [anon_sym_continue] = ACTIONS(1185),
    [anon_sym_resume] = ACTIONS(1185),
    [anon_sym_return] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1185),
    [anon_sym_try] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1185),
    [anon_sym_anyframe] = ACTIONS(1185),
    [anon_sym_unreachable] = ACTIONS(1185),
    [anon_sym_undefined] = ACTIONS(1185),
    [anon_sym_null] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [aux_sym_multiline_string_token1] = ACTIONS(1187),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [sym_integer] = ACTIONS(1185),
    [sym_float] = ACTIONS(1187),
    [anon_sym_true] = ACTIONS(1185),
    [anon_sym_false] = ACTIONS(1185),
    [anon_sym_bool] = ACTIONS(1185),
    [anon_sym_f16] = ACTIONS(1185),
    [anon_sym_f32] = ACTIONS(1185),
    [anon_sym_f64] = ACTIONS(1185),
    [anon_sym_f128] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1185),
    [anon_sym_anyerror] = ACTIONS(1185),
    [anon_sym_anyopaque] = ACTIONS(1185),
    [anon_sym_anytype] = ACTIONS(1185),
    [anon_sym_noreturn] = ACTIONS(1185),
    [anon_sym_isize] = ACTIONS(1185),
    [anon_sym_usize] = ACTIONS(1185),
    [anon_sym_comptime_int] = ACTIONS(1185),
    [anon_sym_comptime_float] = ACTIONS(1185),
    [anon_sym_c_short] = ACTIONS(1185),
    [anon_sym_c_ushort] = ACTIONS(1185),
    [anon_sym_c_int] = ACTIONS(1185),
    [anon_sym_c_uint] = ACTIONS(1185),
    [anon_sym_c_long] = ACTIONS(1185),
    [anon_sym_c_ulong] = ACTIONS(1185),
    [anon_sym_c_longlong] = ACTIONS(1185),
    [anon_sym_c_ulonglong] = ACTIONS(1185),
    [anon_sym_c_longdouble] = ACTIONS(1185),
    [aux_sym_builtin_type_token1] = ACTIONS(1185),
    [sym_builtin_identifier] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [752] = {
    [sym__identifier] = ACTIONS(1189),
    [anon_sym_comptime] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_var] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym_fn] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_packed] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_opaque] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_error] = ACTIONS(1189),
    [anon_sym_nosuspend] = ACTIONS(1189),
    [anon_sym_suspend] = ACTIONS(1189),
    [anon_sym_defer] = ACTIONS(1189),
    [anon_sym_errdefer] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_DASH_PERCENT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_resume] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_try] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_anyframe] = ACTIONS(1189),
    [anon_sym_unreachable] = ACTIONS(1189),
    [anon_sym_undefined] = ACTIONS(1189),
    [anon_sym_null] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [aux_sym_multiline_string_token1] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [sym_integer] = ACTIONS(1189),
    [sym_float] = ACTIONS(1191),
    [anon_sym_true] = ACTIONS(1189),
    [anon_sym_false] = ACTIONS(1189),
    [anon_sym_bool] = ACTIONS(1189),
    [anon_sym_f16] = ACTIONS(1189),
    [anon_sym_f32] = ACTIONS(1189),
    [anon_sym_f64] = ACTIONS(1189),
    [anon_sym_f128] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1189),
    [anon_sym_anyerror] = ACTIONS(1189),
    [anon_sym_anyopaque] = ACTIONS(1189),
    [anon_sym_anytype] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym_isize] = ACTIONS(1189),
    [anon_sym_usize] = ACTIONS(1189),
    [anon_sym_comptime_int] = ACTIONS(1189),
    [anon_sym_comptime_float] = ACTIONS(1189),
    [anon_sym_c_short] = ACTIONS(1189),
    [anon_sym_c_ushort] = ACTIONS(1189),
    [anon_sym_c_int] = ACTIONS(1189),
    [anon_sym_c_uint] = ACTIONS(1189),
    [anon_sym_c_long] = ACTIONS(1189),
    [anon_sym_c_ulong] = ACTIONS(1189),
    [anon_sym_c_longlong] = ACTIONS(1189),
    [anon_sym_c_ulonglong] = ACTIONS(1189),
    [anon_sym_c_longdouble] = ACTIONS(1189),
    [aux_sym_builtin_type_token1] = ACTIONS(1189),
    [sym_builtin_identifier] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [753] = {
    [sym__identifier] = ACTIONS(947),
    [anon_sym_comptime] = ACTIONS(947),
    [anon_sym_extern] = ACTIONS(947),
    [anon_sym_const] = ACTIONS(947),
    [anon_sym_var] = ACTIONS(947),
    [anon_sym_inline] = ACTIONS(947),
    [anon_sym_fn] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_packed] = ACTIONS(947),
    [anon_sym_struct] = ACTIONS(947),
    [anon_sym_opaque] = ACTIONS(947),
    [anon_sym_enum] = ACTIONS(947),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_error] = ACTIONS(947),
    [anon_sym_nosuspend] = ACTIONS(947),
    [anon_sym_suspend] = ACTIONS(947),
    [anon_sym_defer] = ACTIONS(947),
    [anon_sym_errdefer] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_asm] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_DASH_PERCENT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_async] = ACTIONS(947),
    [anon_sym_await] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_resume] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_anyframe] = ACTIONS(947),
    [anon_sym_unreachable] = ACTIONS(947),
    [anon_sym_undefined] = ACTIONS(947),
    [anon_sym_null] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_DOT] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(949),
    [aux_sym_multiline_string_token1] = ACTIONS(949),
    [anon_sym_SQUOTE] = ACTIONS(949),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(949),
    [anon_sym_true] = ACTIONS(947),
    [anon_sym_false] = ACTIONS(947),
    [anon_sym_bool] = ACTIONS(947),
    [anon_sym_f16] = ACTIONS(947),
    [anon_sym_f32] = ACTIONS(947),
    [anon_sym_f64] = ACTIONS(947),
    [anon_sym_f128] = ACTIONS(947),
    [anon_sym_void] = ACTIONS(947),
    [anon_sym_type] = ACTIONS(947),
    [anon_sym_anyerror] = ACTIONS(947),
    [anon_sym_anyopaque] = ACTIONS(947),
    [anon_sym_anytype] = ACTIONS(947),
    [anon_sym_noreturn] = ACTIONS(947),
    [anon_sym_isize] = ACTIONS(947),
    [anon_sym_usize] = ACTIONS(947),
    [anon_sym_comptime_int] = ACTIONS(947),
    [anon_sym_comptime_float] = ACTIONS(947),
    [anon_sym_c_short] = ACTIONS(947),
    [anon_sym_c_ushort] = ACTIONS(947),
    [anon_sym_c_int] = ACTIONS(947),
    [anon_sym_c_uint] = ACTIONS(947),
    [anon_sym_c_long] = ACTIONS(947),
    [anon_sym_c_ulong] = ACTIONS(947),
    [anon_sym_c_longlong] = ACTIONS(947),
    [anon_sym_c_ulonglong] = ACTIONS(947),
    [anon_sym_c_longdouble] = ACTIONS(947),
    [aux_sym_builtin_type_token1] = ACTIONS(947),
    [sym_builtin_identifier] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
  },
  [754] = {
    [sym__identifier] = ACTIONS(1193),
    [anon_sym_comptime] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1193),
    [anon_sym_inline] = ACTIONS(1193),
    [anon_sym_fn] = ACTIONS(1193),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_packed] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1193),
    [anon_sym_opaque] = ACTIONS(1193),
    [anon_sym_enum] = ACTIONS(1193),
    [anon_sym_union] = ACTIONS(1193),
    [anon_sym_error] = ACTIONS(1193),
    [anon_sym_nosuspend] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_align] = ACTIONS(1193),
    [anon_sym_addrspace] = ACTIONS(1193),
    [anon_sym_asm] = ACTIONS(1193),
    [anon_sym_volatile] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_DASH_PERCENT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_await] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_resume] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_anyframe] = ACTIONS(1193),
    [anon_sym_unreachable] = ACTIONS(1193),
    [anon_sym_undefined] = ACTIONS(1193),
    [anon_sym_null] = ACTIONS(1193),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_allowzero] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [aux_sym_multiline_string_token1] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_integer] = ACTIONS(1193),
    [sym_float] = ACTIONS(1195),
    [anon_sym_true] = ACTIONS(1193),
    [anon_sym_false] = ACTIONS(1193),
    [anon_sym_bool] = ACTIONS(1193),
    [anon_sym_f16] = ACTIONS(1193),
    [anon_sym_f32] = ACTIONS(1193),
    [anon_sym_f64] = ACTIONS(1193),
    [anon_sym_f128] = ACTIONS(1193),
    [anon_sym_void] = ACTIONS(1193),
    [anon_sym_type] = ACTIONS(1193),
    [anon_sym_anyerror] = ACTIONS(1193),
    [anon_sym_anyopaque] = ACTIONS(1193),
    [anon_sym_anytype] = ACTIONS(1193),
    [anon_sym_noreturn] = ACTIONS(1193),
    [anon_sym_isize] = ACTIONS(1193),
    [anon_sym_usize] = ACTIONS(1193),
    [anon_sym_comptime_int] = ACTIONS(1193),
    [anon_sym_comptime_float] = ACTIONS(1193),
    [anon_sym_c_short] = ACTIONS(1193),
    [anon_sym_c_ushort] = ACTIONS(1193),
    [anon_sym_c_int] = ACTIONS(1193),
    [anon_sym_c_uint] = ACTIONS(1193),
    [anon_sym_c_long] = ACTIONS(1193),
    [anon_sym_c_ulong] = ACTIONS(1193),
    [anon_sym_c_longlong] = ACTIONS(1193),
    [anon_sym_c_ulonglong] = ACTIONS(1193),
    [anon_sym_c_longdouble] = ACTIONS(1193),
    [aux_sym_builtin_type_token1] = ACTIONS(1193),
    [sym_builtin_identifier] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [755] = {
    [sym__identifier] = ACTIONS(1197),
    [anon_sym_comptime] = ACTIONS(1197),
    [anon_sym_extern] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_inline] = ACTIONS(1197),
    [anon_sym_fn] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_packed] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1197),
    [anon_sym_opaque] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [anon_sym_union] = ACTIONS(1197),
    [anon_sym_error] = ACTIONS(1197),
    [anon_sym_nosuspend] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_align] = ACTIONS(1197),
    [anon_sym_addrspace] = ACTIONS(1197),
    [anon_sym_asm] = ACTIONS(1197),
    [anon_sym_volatile] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_DASH_PERCENT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_resume] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_anyframe] = ACTIONS(1197),
    [anon_sym_unreachable] = ACTIONS(1197),
    [anon_sym_undefined] = ACTIONS(1197),
    [anon_sym_null] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_allowzero] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [aux_sym_multiline_string_token1] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_integer] = ACTIONS(1197),
    [sym_float] = ACTIONS(1199),
    [anon_sym_true] = ACTIONS(1197),
    [anon_sym_false] = ACTIONS(1197),
    [anon_sym_bool] = ACTIONS(1197),
    [anon_sym_f16] = ACTIONS(1197),
    [anon_sym_f32] = ACTIONS(1197),
    [anon_sym_f64] = ACTIONS(1197),
    [anon_sym_f128] = ACTIONS(1197),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_anyerror] = ACTIONS(1197),
    [anon_sym_anyopaque] = ACTIONS(1197),
    [anon_sym_anytype] = ACTIONS(1197),
    [anon_sym_noreturn] = ACTIONS(1197),
    [anon_sym_isize] = ACTIONS(1197),
    [anon_sym_usize] = ACTIONS(1197),
    [anon_sym_comptime_int] = ACTIONS(1197),
    [anon_sym_comptime_float] = ACTIONS(1197),
    [anon_sym_c_short] = ACTIONS(1197),
    [anon_sym_c_ushort] = ACTIONS(1197),
    [anon_sym_c_int] = ACTIONS(1197),
    [anon_sym_c_uint] = ACTIONS(1197),
    [anon_sym_c_long] = ACTIONS(1197),
    [anon_sym_c_ulong] = ACTIONS(1197),
    [anon_sym_c_longlong] = ACTIONS(1197),
    [anon_sym_c_ulonglong] = ACTIONS(1197),
    [anon_sym_c_longdouble] = ACTIONS(1197),
    [aux_sym_builtin_type_token1] = ACTIONS(1197),
    [sym_builtin_identifier] = ACTIONS(1199),
    [anon_sym_AT] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [756] = {
    [sym__identifier] = ACTIONS(1201),
    [anon_sym_comptime] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym_fn] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_packed] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_opaque] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_error] = ACTIONS(1201),
    [anon_sym_nosuspend] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_align] = ACTIONS(1201),
    [anon_sym_addrspace] = ACTIONS(1201),
    [anon_sym_linksection] = ACTIONS(1201),
    [anon_sym_callconv] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_DASH_PERCENT] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_resume] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_anyframe] = ACTIONS(1201),
    [anon_sym_unreachable] = ACTIONS(1201),
    [anon_sym_undefined] = ACTIONS(1201),
    [anon_sym_null] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [aux_sym_multiline_string_token1] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [sym_integer] = ACTIONS(1201),
    [sym_float] = ACTIONS(1203),
    [anon_sym_true] = ACTIONS(1201),
    [anon_sym_false] = ACTIONS(1201),
    [anon_sym_bool] = ACTIONS(1201),
    [anon_sym_f16] = ACTIONS(1201),
    [anon_sym_f32] = ACTIONS(1201),
    [anon_sym_f64] = ACTIONS(1201),
    [anon_sym_f128] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_anyerror] = ACTIONS(1201),
    [anon_sym_anyopaque] = ACTIONS(1201),
    [anon_sym_anytype] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym_isize] = ACTIONS(1201),
    [anon_sym_usize] = ACTIONS(1201),
    [anon_sym_comptime_int] = ACTIONS(1201),
    [anon_sym_comptime_float] = ACTIONS(1201),
    [anon_sym_c_short] = ACTIONS(1201),
    [anon_sym_c_ushort] = ACTIONS(1201),
    [anon_sym_c_int] = ACTIONS(1201),
    [anon_sym_c_uint] = ACTIONS(1201),
    [anon_sym_c_long] = ACTIONS(1201),
    [anon_sym_c_ulong] = ACTIONS(1201),
    [anon_sym_c_longlong] = ACTIONS(1201),
    [anon_sym_c_ulonglong] = ACTIONS(1201),
    [anon_sym_c_longdouble] = ACTIONS(1201),
    [aux_sym_builtin_type_token1] = ACTIONS(1201),
    [sym_builtin_identifier] = ACTIONS(1203),
    [anon_sym_AT] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [757] = {
    [sym__identifier] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1207),
    [anon_sym_comptime] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym_fn] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_packed] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_opaque] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_error] = ACTIONS(1205),
    [anon_sym_nosuspend] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_callconv] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_DASH_PERCENT] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_resume] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_try] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_anyframe] = ACTIONS(1205),
    [anon_sym_unreachable] = ACTIONS(1205),
    [anon_sym_undefined] = ACTIONS(1205),
    [anon_sym_null] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [aux_sym_multiline_string_token1] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [sym_integer] = ACTIONS(1205),
    [sym_float] = ACTIONS(1207),
    [anon_sym_true] = ACTIONS(1205),
    [anon_sym_false] = ACTIONS(1205),
    [anon_sym_bool] = ACTIONS(1205),
    [anon_sym_f16] = ACTIONS(1205),
    [anon_sym_f32] = ACTIONS(1205),
    [anon_sym_f64] = ACTIONS(1205),
    [anon_sym_f128] = ACTIONS(1205),
    [anon_sym_void] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1205),
    [anon_sym_anyerror] = ACTIONS(1205),
    [anon_sym_anyopaque] = ACTIONS(1205),
    [anon_sym_anytype] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym_isize] = ACTIONS(1205),
    [anon_sym_usize] = ACTIONS(1205),
    [anon_sym_comptime_int] = ACTIONS(1205),
    [anon_sym_comptime_float] = ACTIONS(1205),
    [anon_sym_c_short] = ACTIONS(1205),
    [anon_sym_c_ushort] = ACTIONS(1205),
    [anon_sym_c_int] = ACTIONS(1205),
    [anon_sym_c_uint] = ACTIONS(1205),
    [anon_sym_c_long] = ACTIONS(1205),
    [anon_sym_c_ulong] = ACTIONS(1205),
    [anon_sym_c_longlong] = ACTIONS(1205),
    [anon_sym_c_ulonglong] = ACTIONS(1205),
    [anon_sym_c_longdouble] = ACTIONS(1205),
    [aux_sym_builtin_type_token1] = ACTIONS(1205),
    [sym_builtin_identifier] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [758] = {
    [sym__identifier] = ACTIONS(1209),
    [anon_sym_comptime] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym_fn] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_packed] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_opaque] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_error] = ACTIONS(1209),
    [anon_sym_nosuspend] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_align] = ACTIONS(1209),
    [anon_sym_addrspace] = ACTIONS(1209),
    [anon_sym_linksection] = ACTIONS(1209),
    [anon_sym_callconv] = ACTIONS(1209),
    [anon_sym_asm] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_DASH_PERCENT] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [anon_sym_resume] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_try] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_anyframe] = ACTIONS(1209),
    [anon_sym_unreachable] = ACTIONS(1209),
    [anon_sym_undefined] = ACTIONS(1209),
    [anon_sym_null] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [aux_sym_multiline_string_token1] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer] = ACTIONS(1209),
    [sym_float] = ACTIONS(1211),
    [anon_sym_true] = ACTIONS(1209),
    [anon_sym_false] = ACTIONS(1209),
    [anon_sym_bool] = ACTIONS(1209),
    [anon_sym_f16] = ACTIONS(1209),
    [anon_sym_f32] = ACTIONS(1209),
    [anon_sym_f64] = ACTIONS(1209),
    [anon_sym_f128] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1209),
    [anon_sym_anyerror] = ACTIONS(1209),
    [anon_sym_anyopaque] = ACTIONS(1209),
    [anon_sym_anytype] = ACTIONS(1209),
    [anon_sym_noreturn] = ACTIONS(1209),
    [anon_sym_isize] = ACTIONS(1209),
    [anon_sym_usize] = ACTIONS(1209),
    [anon_sym_comptime_int] = ACTIONS(1209),
    [anon_sym_comptime_float] = ACTIONS(1209),
    [anon_sym_c_short] = ACTIONS(1209),
    [anon_sym_c_ushort] = ACTIONS(1209),
    [anon_sym_c_int] = ACTIONS(1209),
    [anon_sym_c_uint] = ACTIONS(1209),
    [anon_sym_c_long] = ACTIONS(1209),
    [anon_sym_c_ulong] = ACTIONS(1209),
    [anon_sym_c_longlong] = ACTIONS(1209),
    [anon_sym_c_ulonglong] = ACTIONS(1209),
    [anon_sym_c_longdouble] = ACTIONS(1209),
    [aux_sym_builtin_type_token1] = ACTIONS(1209),
    [sym_builtin_identifier] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [759] = {
    [sym__identifier] = ACTIONS(1213),
    [anon_sym_comptime] = ACTIONS(1213),
    [anon_sym_extern] = ACTIONS(1213),
    [anon_sym_inline] = ACTIONS(1213),
    [anon_sym_fn] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_packed] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1213),
    [anon_sym_opaque] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [anon_sym_union] = ACTIONS(1213),
    [anon_sym_error] = ACTIONS(1213),
    [anon_sym_nosuspend] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_align] = ACTIONS(1213),
    [anon_sym_addrspace] = ACTIONS(1213),
    [anon_sym_linksection] = ACTIONS(1213),
    [anon_sym_callconv] = ACTIONS(1213),
    [anon_sym_asm] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_DASH_PERCENT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_resume] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_try] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_anyframe] = ACTIONS(1213),
    [anon_sym_unreachable] = ACTIONS(1213),
    [anon_sym_undefined] = ACTIONS(1213),
    [anon_sym_null] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [aux_sym_multiline_string_token1] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1213),
    [anon_sym_false] = ACTIONS(1213),
    [anon_sym_bool] = ACTIONS(1213),
    [anon_sym_f16] = ACTIONS(1213),
    [anon_sym_f32] = ACTIONS(1213),
    [anon_sym_f64] = ACTIONS(1213),
    [anon_sym_f128] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1213),
    [anon_sym_anyerror] = ACTIONS(1213),
    [anon_sym_anyopaque] = ACTIONS(1213),
    [anon_sym_anytype] = ACTIONS(1213),
    [anon_sym_noreturn] = ACTIONS(1213),
    [anon_sym_isize] = ACTIONS(1213),
    [anon_sym_usize] = ACTIONS(1213),
    [anon_sym_comptime_int] = ACTIONS(1213),
    [anon_sym_comptime_float] = ACTIONS(1213),
    [anon_sym_c_short] = ACTIONS(1213),
    [anon_sym_c_ushort] = ACTIONS(1213),
    [anon_sym_c_int] = ACTIONS(1213),
    [anon_sym_c_uint] = ACTIONS(1213),
    [anon_sym_c_long] = ACTIONS(1213),
    [anon_sym_c_ulong] = ACTIONS(1213),
    [anon_sym_c_longlong] = ACTIONS(1213),
    [anon_sym_c_ulonglong] = ACTIONS(1213),
    [anon_sym_c_longdouble] = ACTIONS(1213),
    [aux_sym_builtin_type_token1] = ACTIONS(1213),
    [sym_builtin_identifier] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
  },
  [760] = {
    [sym__identifier] = ACTIONS(1217),
    [anon_sym_comptime] = ACTIONS(1217),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym_inline] = ACTIONS(1217),
    [anon_sym_fn] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_packed] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1217),
    [anon_sym_opaque] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1217),
    [anon_sym_union] = ACTIONS(1217),
    [anon_sym_error] = ACTIONS(1217),
    [anon_sym_nosuspend] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1217),
    [anon_sym_for] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_align] = ACTIONS(1217),
    [anon_sym_addrspace] = ACTIONS(1217),
    [anon_sym_linksection] = ACTIONS(1217),
    [anon_sym_callconv] = ACTIONS(1217),
    [anon_sym_asm] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_DASH_PERCENT] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1217),
    [anon_sym_await] = ACTIONS(1217),
    [anon_sym_continue] = ACTIONS(1217),
    [anon_sym_resume] = ACTIONS(1217),
    [anon_sym_return] = ACTIONS(1217),
    [anon_sym_break] = ACTIONS(1217),
    [anon_sym_try] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1217),
    [anon_sym_anyframe] = ACTIONS(1217),
    [anon_sym_unreachable] = ACTIONS(1217),
    [anon_sym_undefined] = ACTIONS(1217),
    [anon_sym_null] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [aux_sym_multiline_string_token1] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [sym_integer] = ACTIONS(1217),
    [sym_float] = ACTIONS(1219),
    [anon_sym_true] = ACTIONS(1217),
    [anon_sym_false] = ACTIONS(1217),
    [anon_sym_bool] = ACTIONS(1217),
    [anon_sym_f16] = ACTIONS(1217),
    [anon_sym_f32] = ACTIONS(1217),
    [anon_sym_f64] = ACTIONS(1217),
    [anon_sym_f128] = ACTIONS(1217),
    [anon_sym_void] = ACTIONS(1217),
    [anon_sym_type] = ACTIONS(1217),
    [anon_sym_anyerror] = ACTIONS(1217),
    [anon_sym_anyopaque] = ACTIONS(1217),
    [anon_sym_anytype] = ACTIONS(1217),
    [anon_sym_noreturn] = ACTIONS(1217),
    [anon_sym_isize] = ACTIONS(1217),
    [anon_sym_usize] = ACTIONS(1217),
    [anon_sym_comptime_int] = ACTIONS(1217),
    [anon_sym_comptime_float] = ACTIONS(1217),
    [anon_sym_c_short] = ACTIONS(1217),
    [anon_sym_c_ushort] = ACTIONS(1217),
    [anon_sym_c_int] = ACTIONS(1217),
    [anon_sym_c_uint] = ACTIONS(1217),
    [anon_sym_c_long] = ACTIONS(1217),
    [anon_sym_c_ulong] = ACTIONS(1217),
    [anon_sym_c_longlong] = ACTIONS(1217),
    [anon_sym_c_ulonglong] = ACTIONS(1217),
    [anon_sym_c_longdouble] = ACTIONS(1217),
    [aux_sym_builtin_type_token1] = ACTIONS(1217),
    [sym_builtin_identifier] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [761] = {
    [sym_payload] = STATE(763),
    [sym__identifier] = ACTIONS(1221),
    [anon_sym_comptime] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_extern] = ACTIONS(1221),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym_fn] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_packed] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1221),
    [anon_sym_opaque] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [anon_sym_union] = ACTIONS(1221),
    [anon_sym_error] = ACTIONS(1221),
    [anon_sym_nosuspend] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_asm] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_DASH_PERCENT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_async] = ACTIONS(1221),
    [anon_sym_await] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_resume] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_try] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_anyframe] = ACTIONS(1221),
    [anon_sym_unreachable] = ACTIONS(1221),
    [anon_sym_undefined] = ACTIONS(1221),
    [anon_sym_null] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [aux_sym_multiline_string_token1] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_integer] = ACTIONS(1221),
    [sym_float] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(1221),
    [anon_sym_false] = ACTIONS(1221),
    [anon_sym_bool] = ACTIONS(1221),
    [anon_sym_f16] = ACTIONS(1221),
    [anon_sym_f32] = ACTIONS(1221),
    [anon_sym_f64] = ACTIONS(1221),
    [anon_sym_f128] = ACTIONS(1221),
    [anon_sym_void] = ACTIONS(1221),
    [anon_sym_type] = ACTIONS(1221),
    [anon_sym_anyerror] = ACTIONS(1221),
    [anon_sym_anyopaque] = ACTIONS(1221),
    [anon_sym_anytype] = ACTIONS(1221),
    [anon_sym_noreturn] = ACTIONS(1221),
    [anon_sym_isize] = ACTIONS(1221),
    [anon_sym_usize] = ACTIONS(1221),
    [anon_sym_comptime_int] = ACTIONS(1221),
    [anon_sym_comptime_float] = ACTIONS(1221),
    [anon_sym_c_short] = ACTIONS(1221),
    [anon_sym_c_ushort] = ACTIONS(1221),
    [anon_sym_c_int] = ACTIONS(1221),
    [anon_sym_c_uint] = ACTIONS(1221),
    [anon_sym_c_long] = ACTIONS(1221),
    [anon_sym_c_ulong] = ACTIONS(1221),
    [anon_sym_c_longlong] = ACTIONS(1221),
    [anon_sym_c_ulonglong] = ACTIONS(1221),
    [anon_sym_c_longdouble] = ACTIONS(1221),
    [aux_sym_builtin_type_token1] = ACTIONS(1221),
    [sym_builtin_identifier] = ACTIONS(1225),
    [anon_sym_AT] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [762] = {
    [sym_payload] = STATE(771),
    [sym__identifier] = ACTIONS(1227),
    [anon_sym_comptime] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym_fn] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_packed] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_opaque] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_error] = ACTIONS(1227),
    [anon_sym_nosuspend] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_DASH_PERCENT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_await] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_resume] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_try] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_anyframe] = ACTIONS(1227),
    [anon_sym_unreachable] = ACTIONS(1227),
    [anon_sym_undefined] = ACTIONS(1227),
    [anon_sym_null] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [aux_sym_multiline_string_token1] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_integer] = ACTIONS(1227),
    [sym_float] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(1227),
    [anon_sym_false] = ACTIONS(1227),
    [anon_sym_bool] = ACTIONS(1227),
    [anon_sym_f16] = ACTIONS(1227),
    [anon_sym_f32] = ACTIONS(1227),
    [anon_sym_f64] = ACTIONS(1227),
    [anon_sym_f128] = ACTIONS(1227),
    [anon_sym_void] = ACTIONS(1227),
    [anon_sym_type] = ACTIONS(1227),
    [anon_sym_anyerror] = ACTIONS(1227),
    [anon_sym_anyopaque] = ACTIONS(1227),
    [anon_sym_anytype] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_isize] = ACTIONS(1227),
    [anon_sym_usize] = ACTIONS(1227),
    [anon_sym_comptime_int] = ACTIONS(1227),
    [anon_sym_comptime_float] = ACTIONS(1227),
    [anon_sym_c_short] = ACTIONS(1227),
    [anon_sym_c_ushort] = ACTIONS(1227),
    [anon_sym_c_int] = ACTIONS(1227),
    [anon_sym_c_uint] = ACTIONS(1227),
    [anon_sym_c_long] = ACTIONS(1227),
    [anon_sym_c_ulong] = ACTIONS(1227),
    [anon_sym_c_longlong] = ACTIONS(1227),
    [anon_sym_c_ulonglong] = ACTIONS(1227),
    [anon_sym_c_longdouble] = ACTIONS(1227),
    [aux_sym_builtin_type_token1] = ACTIONS(1227),
    [sym_builtin_identifier] = ACTIONS(1229),
    [anon_sym_AT] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
  },
  [763] = {
    [sym__identifier] = ACTIONS(1231),
    [anon_sym_comptime] = ACTIONS(1231),
    [anon_sym_COLON] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1231),
    [anon_sym_inline] = ACTIONS(1231),
    [anon_sym_fn] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_packed] = ACTIONS(1231),
    [anon_sym_struct] = ACTIONS(1231),
    [anon_sym_opaque] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [anon_sym_union] = ACTIONS(1231),
    [anon_sym_error] = ACTIONS(1231),
    [anon_sym_nosuspend] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_asm] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_DASH_PERCENT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_await] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_resume] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_anyframe] = ACTIONS(1231),
    [anon_sym_unreachable] = ACTIONS(1231),
    [anon_sym_undefined] = ACTIONS(1231),
    [anon_sym_null] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [aux_sym_multiline_string_token1] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [sym_integer] = ACTIONS(1231),
    [sym_float] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(1231),
    [anon_sym_false] = ACTIONS(1231),
    [anon_sym_bool] = ACTIONS(1231),
    [anon_sym_f16] = ACTIONS(1231),
    [anon_sym_f32] = ACTIONS(1231),
    [anon_sym_f64] = ACTIONS(1231),
    [anon_sym_f128] = ACTIONS(1231),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_anyerror] = ACTIONS(1231),
    [anon_sym_anyopaque] = ACTIONS(1231),
    [anon_sym_anytype] = ACTIONS(1231),
    [anon_sym_noreturn] = ACTIONS(1231),
    [anon_sym_isize] = ACTIONS(1231),
    [anon_sym_usize] = ACTIONS(1231),
    [anon_sym_comptime_int] = ACTIONS(1231),
    [anon_sym_comptime_float] = ACTIONS(1231),
    [anon_sym_c_short] = ACTIONS(1231),
    [anon_sym_c_ushort] = ACTIONS(1231),
    [anon_sym_c_int] = ACTIONS(1231),
    [anon_sym_c_uint] = ACTIONS(1231),
    [anon_sym_c_long] = ACTIONS(1231),
    [anon_sym_c_ulong] = ACTIONS(1231),
    [anon_sym_c_longlong] = ACTIONS(1231),
    [anon_sym_c_ulonglong] = ACTIONS(1231),
    [anon_sym_c_longdouble] = ACTIONS(1231),
    [aux_sym_builtin_type_token1] = ACTIONS(1231),
    [sym_builtin_identifier] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [sym__identifier] = ACTIONS(1237),
    [anon_sym_comptime] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym_fn] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_packed] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_opaque] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_error] = ACTIONS(1237),
    [anon_sym_nosuspend] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_DASH_PERCENT] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_resume] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_anyframe] = ACTIONS(1237),
    [anon_sym_unreachable] = ACTIONS(1237),
    [anon_sym_undefined] = ACTIONS(1237),
    [anon_sym_null] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [aux_sym_multiline_string_token1] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [sym_integer] = ACTIONS(1237),
    [sym_float] = ACTIONS(1239),
    [anon_sym_true] = ACTIONS(1237),
    [anon_sym_false] = ACTIONS(1237),
    [anon_sym_bool] = ACTIONS(1237),
    [anon_sym_f16] = ACTIONS(1237),
    [anon_sym_f32] = ACTIONS(1237),
    [anon_sym_f64] = ACTIONS(1237),
    [anon_sym_f128] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_anyerror] = ACTIONS(1237),
    [anon_sym_anyopaque] = ACTIONS(1237),
    [anon_sym_anytype] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym_isize] = ACTIONS(1237),
    [anon_sym_usize] = ACTIONS(1237),
    [anon_sym_comptime_int] = ACTIONS(1237),
    [anon_sym_comptime_float] = ACTIONS(1237),
    [anon_sym_c_short] = ACTIONS(1237),
    [anon_sym_c_ushort] = ACTIONS(1237),
    [anon_sym_c_int] = ACTIONS(1237),
    [anon_sym_c_uint] = ACTIONS(1237),
    [anon_sym_c_long] = ACTIONS(1237),
    [anon_sym_c_ulong] = ACTIONS(1237),
    [anon_sym_c_longlong] = ACTIONS(1237),
    [anon_sym_c_ulonglong] = ACTIONS(1237),
    [anon_sym_c_longdouble] = ACTIONS(1237),
    [aux_sym_builtin_type_token1] = ACTIONS(1237),
    [sym_builtin_identifier] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [765] = {
    [sym__identifier] = ACTIONS(1241),
    [anon_sym_comptime] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym_fn] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_packed] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_opaque] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_error] = ACTIONS(1241),
    [anon_sym_nosuspend] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_DASH_PERCENT] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_resume] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_anyframe] = ACTIONS(1241),
    [anon_sym_unreachable] = ACTIONS(1241),
    [anon_sym_undefined] = ACTIONS(1241),
    [anon_sym_null] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [aux_sym_multiline_string_token1] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [sym_integer] = ACTIONS(1241),
    [sym_float] = ACTIONS(1243),
    [anon_sym_true] = ACTIONS(1241),
    [anon_sym_false] = ACTIONS(1241),
    [anon_sym_bool] = ACTIONS(1241),
    [anon_sym_f16] = ACTIONS(1241),
    [anon_sym_f32] = ACTIONS(1241),
    [anon_sym_f64] = ACTIONS(1241),
    [anon_sym_f128] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_anyerror] = ACTIONS(1241),
    [anon_sym_anyopaque] = ACTIONS(1241),
    [anon_sym_anytype] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_isize] = ACTIONS(1241),
    [anon_sym_usize] = ACTIONS(1241),
    [anon_sym_comptime_int] = ACTIONS(1241),
    [anon_sym_comptime_float] = ACTIONS(1241),
    [anon_sym_c_short] = ACTIONS(1241),
    [anon_sym_c_ushort] = ACTIONS(1241),
    [anon_sym_c_int] = ACTIONS(1241),
    [anon_sym_c_uint] = ACTIONS(1241),
    [anon_sym_c_long] = ACTIONS(1241),
    [anon_sym_c_ulong] = ACTIONS(1241),
    [anon_sym_c_longlong] = ACTIONS(1241),
    [anon_sym_c_ulonglong] = ACTIONS(1241),
    [anon_sym_c_longdouble] = ACTIONS(1241),
    [aux_sym_builtin_type_token1] = ACTIONS(1241),
    [sym_builtin_identifier] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [sym__identifier] = ACTIONS(1245),
    [anon_sym_comptime] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym_fn] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_packed] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_opaque] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_error] = ACTIONS(1245),
    [anon_sym_nosuspend] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_DASH_PERCENT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_async] = ACTIONS(1245),
    [anon_sym_await] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_resume] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_anyframe] = ACTIONS(1245),
    [anon_sym_unreachable] = ACTIONS(1245),
    [anon_sym_undefined] = ACTIONS(1245),
    [anon_sym_null] = ACTIONS(1245),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [aux_sym_multiline_string_token1] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [sym_integer] = ACTIONS(1245),
    [sym_float] = ACTIONS(1247),
    [anon_sym_true] = ACTIONS(1245),
    [anon_sym_false] = ACTIONS(1245),
    [anon_sym_bool] = ACTIONS(1245),
    [anon_sym_f16] = ACTIONS(1245),
    [anon_sym_f32] = ACTIONS(1245),
    [anon_sym_f64] = ACTIONS(1245),
    [anon_sym_f128] = ACTIONS(1245),
    [anon_sym_void] = ACTIONS(1245),
    [anon_sym_type] = ACTIONS(1245),
    [anon_sym_anyerror] = ACTIONS(1245),
    [anon_sym_anyopaque] = ACTIONS(1245),
    [anon_sym_anytype] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_isize] = ACTIONS(1245),
    [anon_sym_usize] = ACTIONS(1245),
    [anon_sym_comptime_int] = ACTIONS(1245),
    [anon_sym_comptime_float] = ACTIONS(1245),
    [anon_sym_c_short] = ACTIONS(1245),
    [anon_sym_c_ushort] = ACTIONS(1245),
    [anon_sym_c_int] = ACTIONS(1245),
    [anon_sym_c_uint] = ACTIONS(1245),
    [anon_sym_c_long] = ACTIONS(1245),
    [anon_sym_c_ulong] = ACTIONS(1245),
    [anon_sym_c_longlong] = ACTIONS(1245),
    [anon_sym_c_ulonglong] = ACTIONS(1245),
    [anon_sym_c_longdouble] = ACTIONS(1245),
    [aux_sym_builtin_type_token1] = ACTIONS(1245),
    [sym_builtin_identifier] = ACTIONS(1247),
    [anon_sym_AT] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [767] = {
    [sym__identifier] = ACTIONS(1249),
    [anon_sym_comptime] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym_fn] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_packed] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_opaque] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_error] = ACTIONS(1249),
    [anon_sym_nosuspend] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_DASH_PERCENT] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_resume] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_anyframe] = ACTIONS(1249),
    [anon_sym_unreachable] = ACTIONS(1249),
    [anon_sym_undefined] = ACTIONS(1249),
    [anon_sym_null] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [aux_sym_multiline_string_token1] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_integer] = ACTIONS(1249),
    [sym_float] = ACTIONS(1251),
    [anon_sym_true] = ACTIONS(1249),
    [anon_sym_false] = ACTIONS(1249),
    [anon_sym_bool] = ACTIONS(1249),
    [anon_sym_f16] = ACTIONS(1249),
    [anon_sym_f32] = ACTIONS(1249),
    [anon_sym_f64] = ACTIONS(1249),
    [anon_sym_f128] = ACTIONS(1249),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_anyerror] = ACTIONS(1249),
    [anon_sym_anyopaque] = ACTIONS(1249),
    [anon_sym_anytype] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym_isize] = ACTIONS(1249),
    [anon_sym_usize] = ACTIONS(1249),
    [anon_sym_comptime_int] = ACTIONS(1249),
    [anon_sym_comptime_float] = ACTIONS(1249),
    [anon_sym_c_short] = ACTIONS(1249),
    [anon_sym_c_ushort] = ACTIONS(1249),
    [anon_sym_c_int] = ACTIONS(1249),
    [anon_sym_c_uint] = ACTIONS(1249),
    [anon_sym_c_long] = ACTIONS(1249),
    [anon_sym_c_ulong] = ACTIONS(1249),
    [anon_sym_c_longlong] = ACTIONS(1249),
    [anon_sym_c_ulonglong] = ACTIONS(1249),
    [anon_sym_c_longdouble] = ACTIONS(1249),
    [aux_sym_builtin_type_token1] = ACTIONS(1249),
    [sym_builtin_identifier] = ACTIONS(1251),
    [anon_sym_AT] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
  },
  [768] = {
    [sym__identifier] = ACTIONS(1253),
    [anon_sym_comptime] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym_fn] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_packed] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_opaque] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_error] = ACTIONS(1253),
    [anon_sym_nosuspend] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_DASH_PERCENT] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_resume] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_anyframe] = ACTIONS(1253),
    [anon_sym_unreachable] = ACTIONS(1253),
    [anon_sym_undefined] = ACTIONS(1253),
    [anon_sym_null] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [aux_sym_multiline_string_token1] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [sym_integer] = ACTIONS(1253),
    [sym_float] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(1253),
    [anon_sym_false] = ACTIONS(1253),
    [anon_sym_bool] = ACTIONS(1253),
    [anon_sym_f16] = ACTIONS(1253),
    [anon_sym_f32] = ACTIONS(1253),
    [anon_sym_f64] = ACTIONS(1253),
    [anon_sym_f128] = ACTIONS(1253),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_anyerror] = ACTIONS(1253),
    [anon_sym_anyopaque] = ACTIONS(1253),
    [anon_sym_anytype] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym_isize] = ACTIONS(1253),
    [anon_sym_usize] = ACTIONS(1253),
    [anon_sym_comptime_int] = ACTIONS(1253),
    [anon_sym_comptime_float] = ACTIONS(1253),
    [anon_sym_c_short] = ACTIONS(1253),
    [anon_sym_c_ushort] = ACTIONS(1253),
    [anon_sym_c_int] = ACTIONS(1253),
    [anon_sym_c_uint] = ACTIONS(1253),
    [anon_sym_c_long] = ACTIONS(1253),
    [anon_sym_c_ulong] = ACTIONS(1253),
    [anon_sym_c_longlong] = ACTIONS(1253),
    [anon_sym_c_ulonglong] = ACTIONS(1253),
    [anon_sym_c_longdouble] = ACTIONS(1253),
    [aux_sym_builtin_type_token1] = ACTIONS(1253),
    [sym_builtin_identifier] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [769] = {
    [sym__identifier] = ACTIONS(1257),
    [anon_sym_comptime] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym_fn] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_packed] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_opaque] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_error] = ACTIONS(1257),
    [anon_sym_nosuspend] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_DASH_PERCENT] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_await] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_resume] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_try] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_anyframe] = ACTIONS(1257),
    [anon_sym_unreachable] = ACTIONS(1257),
    [anon_sym_undefined] = ACTIONS(1257),
    [anon_sym_null] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [aux_sym_multiline_string_token1] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [sym_integer] = ACTIONS(1257),
    [sym_float] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(1257),
    [anon_sym_false] = ACTIONS(1257),
    [anon_sym_bool] = ACTIONS(1257),
    [anon_sym_f16] = ACTIONS(1257),
    [anon_sym_f32] = ACTIONS(1257),
    [anon_sym_f64] = ACTIONS(1257),
    [anon_sym_f128] = ACTIONS(1257),
    [anon_sym_void] = ACTIONS(1257),
    [anon_sym_type] = ACTIONS(1257),
    [anon_sym_anyerror] = ACTIONS(1257),
    [anon_sym_anyopaque] = ACTIONS(1257),
    [anon_sym_anytype] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_isize] = ACTIONS(1257),
    [anon_sym_usize] = ACTIONS(1257),
    [anon_sym_comptime_int] = ACTIONS(1257),
    [anon_sym_comptime_float] = ACTIONS(1257),
    [anon_sym_c_short] = ACTIONS(1257),
    [anon_sym_c_ushort] = ACTIONS(1257),
    [anon_sym_c_int] = ACTIONS(1257),
    [anon_sym_c_uint] = ACTIONS(1257),
    [anon_sym_c_long] = ACTIONS(1257),
    [anon_sym_c_ulong] = ACTIONS(1257),
    [anon_sym_c_longlong] = ACTIONS(1257),
    [anon_sym_c_ulonglong] = ACTIONS(1257),
    [anon_sym_c_longdouble] = ACTIONS(1257),
    [aux_sym_builtin_type_token1] = ACTIONS(1257),
    [sym_builtin_identifier] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [770] = {
    [sym__identifier] = ACTIONS(1261),
    [anon_sym_comptime] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym_fn] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_packed] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_opaque] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_error] = ACTIONS(1261),
    [anon_sym_nosuspend] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_DASH_PERCENT] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1261),
    [anon_sym_await] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_resume] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_try] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_anyframe] = ACTIONS(1261),
    [anon_sym_unreachable] = ACTIONS(1261),
    [anon_sym_undefined] = ACTIONS(1261),
    [anon_sym_null] = ACTIONS(1261),
    [anon_sym_QMARK] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [aux_sym_multiline_string_token1] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_integer] = ACTIONS(1261),
    [sym_float] = ACTIONS(1263),
    [anon_sym_true] = ACTIONS(1261),
    [anon_sym_false] = ACTIONS(1261),
    [anon_sym_bool] = ACTIONS(1261),
    [anon_sym_f16] = ACTIONS(1261),
    [anon_sym_f32] = ACTIONS(1261),
    [anon_sym_f64] = ACTIONS(1261),
    [anon_sym_f128] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_type] = ACTIONS(1261),
    [anon_sym_anyerror] = ACTIONS(1261),
    [anon_sym_anyopaque] = ACTIONS(1261),
    [anon_sym_anytype] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym_isize] = ACTIONS(1261),
    [anon_sym_usize] = ACTIONS(1261),
    [anon_sym_comptime_int] = ACTIONS(1261),
    [anon_sym_comptime_float] = ACTIONS(1261),
    [anon_sym_c_short] = ACTIONS(1261),
    [anon_sym_c_ushort] = ACTIONS(1261),
    [anon_sym_c_int] = ACTIONS(1261),
    [anon_sym_c_uint] = ACTIONS(1261),
    [anon_sym_c_long] = ACTIONS(1261),
    [anon_sym_c_ulong] = ACTIONS(1261),
    [anon_sym_c_longlong] = ACTIONS(1261),
    [anon_sym_c_ulonglong] = ACTIONS(1261),
    [anon_sym_c_longdouble] = ACTIONS(1261),
    [aux_sym_builtin_type_token1] = ACTIONS(1261),
    [sym_builtin_identifier] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [sym__identifier] = ACTIONS(1265),
    [anon_sym_comptime] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym_fn] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_packed] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_opaque] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_error] = ACTIONS(1265),
    [anon_sym_nosuspend] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_DASH_PERCENT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_async] = ACTIONS(1265),
    [anon_sym_await] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_resume] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_anyframe] = ACTIONS(1265),
    [anon_sym_unreachable] = ACTIONS(1265),
    [anon_sym_undefined] = ACTIONS(1265),
    [anon_sym_null] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [aux_sym_multiline_string_token1] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_bool] = ACTIONS(1265),
    [anon_sym_f16] = ACTIONS(1265),
    [anon_sym_f32] = ACTIONS(1265),
    [anon_sym_f64] = ACTIONS(1265),
    [anon_sym_f128] = ACTIONS(1265),
    [anon_sym_void] = ACTIONS(1265),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_anyerror] = ACTIONS(1265),
    [anon_sym_anyopaque] = ACTIONS(1265),
    [anon_sym_anytype] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym_isize] = ACTIONS(1265),
    [anon_sym_usize] = ACTIONS(1265),
    [anon_sym_comptime_int] = ACTIONS(1265),
    [anon_sym_comptime_float] = ACTIONS(1265),
    [anon_sym_c_short] = ACTIONS(1265),
    [anon_sym_c_ushort] = ACTIONS(1265),
    [anon_sym_c_int] = ACTIONS(1265),
    [anon_sym_c_uint] = ACTIONS(1265),
    [anon_sym_c_long] = ACTIONS(1265),
    [anon_sym_c_ulong] = ACTIONS(1265),
    [anon_sym_c_longlong] = ACTIONS(1265),
    [anon_sym_c_ulonglong] = ACTIONS(1265),
    [anon_sym_c_longdouble] = ACTIONS(1265),
    [aux_sym_builtin_type_token1] = ACTIONS(1265),
    [sym_builtin_identifier] = ACTIONS(1267),
    [anon_sym_AT] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [772] = {
    [sym__identifier] = ACTIONS(1269),
    [anon_sym_comptime] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym_fn] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_packed] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_opaque] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_error] = ACTIONS(1269),
    [anon_sym_nosuspend] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_DASH_PERCENT] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_resume] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_try] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_anyframe] = ACTIONS(1269),
    [anon_sym_unreachable] = ACTIONS(1269),
    [anon_sym_undefined] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1269),
    [anon_sym_QMARK] = ACTIONS(1271),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [aux_sym_multiline_string_token1] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [sym_integer] = ACTIONS(1269),
    [sym_float] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1269),
    [anon_sym_false] = ACTIONS(1269),
    [anon_sym_bool] = ACTIONS(1269),
    [anon_sym_f16] = ACTIONS(1269),
    [anon_sym_f32] = ACTIONS(1269),
    [anon_sym_f64] = ACTIONS(1269),
    [anon_sym_f128] = ACTIONS(1269),
    [anon_sym_void] = ACTIONS(1269),
    [anon_sym_type] = ACTIONS(1269),
    [anon_sym_anyerror] = ACTIONS(1269),
    [anon_sym_anyopaque] = ACTIONS(1269),
    [anon_sym_anytype] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym_isize] = ACTIONS(1269),
    [anon_sym_usize] = ACTIONS(1269),
    [anon_sym_comptime_int] = ACTIONS(1269),
    [anon_sym_comptime_float] = ACTIONS(1269),
    [anon_sym_c_short] = ACTIONS(1269),
    [anon_sym_c_ushort] = ACTIONS(1269),
    [anon_sym_c_int] = ACTIONS(1269),
    [anon_sym_c_uint] = ACTIONS(1269),
    [anon_sym_c_long] = ACTIONS(1269),
    [anon_sym_c_ulong] = ACTIONS(1269),
    [anon_sym_c_longlong] = ACTIONS(1269),
    [anon_sym_c_ulonglong] = ACTIONS(1269),
    [anon_sym_c_longdouble] = ACTIONS(1269),
    [aux_sym_builtin_type_token1] = ACTIONS(1269),
    [sym_builtin_identifier] = ACTIONS(1271),
    [anon_sym_AT] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [sym__identifier] = ACTIONS(1273),
    [anon_sym_comptime] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym_fn] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_packed] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_opaque] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_error] = ACTIONS(1273),
    [anon_sym_nosuspend] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_DASH_PERCENT] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_async] = ACTIONS(1273),
    [anon_sym_await] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_resume] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_anyframe] = ACTIONS(1273),
    [anon_sym_unreachable] = ACTIONS(1273),
    [anon_sym_undefined] = ACTIONS(1273),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [aux_sym_multiline_string_token1] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [sym_integer] = ACTIONS(1273),
    [sym_float] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1273),
    [anon_sym_false] = ACTIONS(1273),
    [anon_sym_bool] = ACTIONS(1273),
    [anon_sym_f16] = ACTIONS(1273),
    [anon_sym_f32] = ACTIONS(1273),
    [anon_sym_f64] = ACTIONS(1273),
    [anon_sym_f128] = ACTIONS(1273),
    [anon_sym_void] = ACTIONS(1273),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_anyerror] = ACTIONS(1273),
    [anon_sym_anyopaque] = ACTIONS(1273),
    [anon_sym_anytype] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_isize] = ACTIONS(1273),
    [anon_sym_usize] = ACTIONS(1273),
    [anon_sym_comptime_int] = ACTIONS(1273),
    [anon_sym_comptime_float] = ACTIONS(1273),
    [anon_sym_c_short] = ACTIONS(1273),
    [anon_sym_c_ushort] = ACTIONS(1273),
    [anon_sym_c_int] = ACTIONS(1273),
    [anon_sym_c_uint] = ACTIONS(1273),
    [anon_sym_c_long] = ACTIONS(1273),
    [anon_sym_c_ulong] = ACTIONS(1273),
    [anon_sym_c_longlong] = ACTIONS(1273),
    [anon_sym_c_ulonglong] = ACTIONS(1273),
    [anon_sym_c_longdouble] = ACTIONS(1273),
    [aux_sym_builtin_type_token1] = ACTIONS(1273),
    [sym_builtin_identifier] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [774] = {
    [aux_sym_multiline_string_repeat1] = STATE(774),
    [ts_builtin_sym_end] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_COLON] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(1279),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_STAR_EQ] = ACTIONS(1277),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1277),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_SLASH_EQ] = ACTIONS(1277),
    [anon_sym_PERCENT_EQ] = ACTIONS(1277),
    [anon_sym_PLUS_EQ] = ACTIONS(1277),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1277),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_DASH_EQ] = ACTIONS(1277),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1277),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_LT_LT_EQ] = ACTIONS(1277),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_GT_GT_EQ] = ACTIONS(1277),
    [anon_sym_AMP_EQ] = ACTIONS(1277),
    [anon_sym_CARET_EQ] = ACTIONS(1277),
    [anon_sym_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_align] = ACTIONS(1277),
    [anon_sym_addrspace] = ACTIONS(1277),
    [anon_sym_linksection] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_RBRACK] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_DASH_PERCENT] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_or] = ACTIONS(1279),
    [anon_sym_and] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1279),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1279),
    [anon_sym_CARET] = ACTIONS(1279),
    [anon_sym_orelse] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1279),
    [anon_sym_GT_GT] = ACTIONS(1279),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1279),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1279),
    [anon_sym_PLUS_PIPE] = ACTIONS(1279),
    [anon_sym_DASH_PIPE] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(1279),
    [anon_sym_PERCENT] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_STAR_PERCENT] = ACTIONS(1279),
    [anon_sym_STAR_PIPE] = ACTIONS(1279),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_catch] = ACTIONS(1277),
    [anon_sym_EQ_GT] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_DOT_STAR] = ACTIONS(1277),
    [anon_sym_DOT_QMARK] = ACTIONS(1277),
    [aux_sym_multiline_string_token1] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [775] = {
    [aux_sym_multiline_string_repeat1] = STATE(774),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_EQ] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_STAR_EQ] = ACTIONS(1284),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1284),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1284),
    [anon_sym_SLASH_EQ] = ACTIONS(1284),
    [anon_sym_PERCENT_EQ] = ACTIONS(1284),
    [anon_sym_PLUS_EQ] = ACTIONS(1284),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1284),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1284),
    [anon_sym_DASH_EQ] = ACTIONS(1284),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1284),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1284),
    [anon_sym_LT_LT_EQ] = ACTIONS(1284),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1284),
    [anon_sym_AMP_EQ] = ACTIONS(1284),
    [anon_sym_CARET_EQ] = ACTIONS(1284),
    [anon_sym_PIPE_EQ] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1284),
    [anon_sym_DOT_DOT] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_align] = ACTIONS(1284),
    [anon_sym_addrspace] = ACTIONS(1284),
    [anon_sym_linksection] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_RBRACK] = ACTIONS(1284),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_DASH_PERCENT] = ACTIONS(1286),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_or] = ACTIONS(1286),
    [anon_sym_and] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1284),
    [anon_sym_BANG_EQ] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_CARET] = ACTIONS(1286),
    [anon_sym_orelse] = ACTIONS(1284),
    [anon_sym_LT_LT] = ACTIONS(1286),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1286),
    [anon_sym_PLUS_PIPE] = ACTIONS(1286),
    [anon_sym_DASH_PIPE] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1286),
    [anon_sym_STAR_STAR] = ACTIONS(1284),
    [anon_sym_STAR_PERCENT] = ACTIONS(1286),
    [anon_sym_STAR_PIPE] = ACTIONS(1286),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_catch] = ACTIONS(1284),
    [anon_sym_EQ_GT] = ACTIONS(1284),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_DOT_STAR] = ACTIONS(1284),
    [anon_sym_DOT_QMARK] = ACTIONS(1284),
    [aux_sym_multiline_string_token1] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [776] = {
    [sym_initializer_list] = STATE(824),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_STAR_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_SLASH_EQ] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_DASH_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1290),
    [anon_sym_AMP_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1290),
    [anon_sym_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_else] = ACTIONS(1290),
    [anon_sym_DOT_DOT] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_align] = ACTIONS(1290),
    [anon_sym_addrspace] = ACTIONS(1290),
    [anon_sym_linksection] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_DASH_PERCENT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_and] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1292),
    [anon_sym_orelse] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1292),
    [anon_sym_PLUS_PIPE] = ACTIONS(1292),
    [anon_sym_DASH_PIPE] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_PIPE] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_catch] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1292),
    [anon_sym_DOT_STAR] = ACTIONS(1290),
    [anon_sym_DOT_QMARK] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_break_label] = STATE(787),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [anon_sym_COMMA] = ACTIONS(1296),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_STAR_EQ] = ACTIONS(1296),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1296),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1296),
    [anon_sym_SLASH_EQ] = ACTIONS(1296),
    [anon_sym_PERCENT_EQ] = ACTIONS(1296),
    [anon_sym_PLUS_EQ] = ACTIONS(1296),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1296),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1296),
    [anon_sym_DASH_EQ] = ACTIONS(1296),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1296),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1296),
    [anon_sym_LT_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1296),
    [anon_sym_GT_GT_EQ] = ACTIONS(1296),
    [anon_sym_AMP_EQ] = ACTIONS(1296),
    [anon_sym_CARET_EQ] = ACTIONS(1296),
    [anon_sym_PIPE_EQ] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_RPAREN] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_else] = ACTIONS(1296),
    [anon_sym_DOT_DOT] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_align] = ACTIONS(1296),
    [anon_sym_addrspace] = ACTIONS(1296),
    [anon_sym_linksection] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_BANG] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_DASH_PERCENT] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1298),
    [anon_sym_or] = ACTIONS(1298),
    [anon_sym_and] = ACTIONS(1296),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_GT] = ACTIONS(1298),
    [anon_sym_GT_EQ] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(1298),
    [anon_sym_CARET] = ACTIONS(1298),
    [anon_sym_orelse] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1298),
    [anon_sym_GT_GT] = ACTIONS(1298),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1298),
    [anon_sym_PLUS_PIPE] = ACTIONS(1298),
    [anon_sym_DASH_PIPE] = ACTIONS(1298),
    [anon_sym_SLASH] = ACTIONS(1298),
    [anon_sym_PERCENT] = ACTIONS(1298),
    [anon_sym_STAR_STAR] = ACTIONS(1296),
    [anon_sym_STAR_PERCENT] = ACTIONS(1298),
    [anon_sym_STAR_PIPE] = ACTIONS(1298),
    [anon_sym_PIPE_PIPE] = ACTIONS(1296),
    [anon_sym_catch] = ACTIONS(1296),
    [anon_sym_EQ_GT] = ACTIONS(1296),
    [anon_sym_DOT] = ACTIONS(1298),
    [anon_sym_DOT_STAR] = ACTIONS(1296),
    [anon_sym_DOT_QMARK] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
  },
  [778] = {
    [sym_initializer_list] = STATE(824),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_STAR_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_SLASH_EQ] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_DASH_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1290),
    [anon_sym_AMP_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1290),
    [anon_sym_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_else] = ACTIONS(1290),
    [anon_sym_DOT_DOT] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_align] = ACTIONS(1290),
    [anon_sym_addrspace] = ACTIONS(1290),
    [anon_sym_linksection] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_DASH_PERCENT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_and] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1292),
    [anon_sym_orelse] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1292),
    [anon_sym_PLUS_PIPE] = ACTIONS(1292),
    [anon_sym_DASH_PIPE] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_PIPE] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_catch] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1292),
    [anon_sym_DOT_STAR] = ACTIONS(1290),
    [anon_sym_DOT_QMARK] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
  },
  [779] = {
    [ts_builtin_sym_end] = ACTIONS(1300),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_STAR_EQ] = ACTIONS(1300),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1300),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1300),
    [anon_sym_SLASH_EQ] = ACTIONS(1300),
    [anon_sym_PERCENT_EQ] = ACTIONS(1300),
    [anon_sym_PLUS_EQ] = ACTIONS(1300),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1300),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1300),
    [anon_sym_DASH_EQ] = ACTIONS(1300),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1300),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1300),
    [anon_sym_LT_LT_EQ] = ACTIONS(1300),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1300),
    [anon_sym_GT_GT_EQ] = ACTIONS(1300),
    [anon_sym_AMP_EQ] = ACTIONS(1300),
    [anon_sym_CARET_EQ] = ACTIONS(1300),
    [anon_sym_PIPE_EQ] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_else] = ACTIONS(1300),
    [anon_sym_DOT_DOT] = ACTIONS(1300),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_align] = ACTIONS(1300),
    [anon_sym_addrspace] = ACTIONS(1300),
    [anon_sym_linksection] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_DASH_PERCENT] = ACTIONS(1302),
    [anon_sym_AMP] = ACTIONS(1302),
    [anon_sym_or] = ACTIONS(1302),
    [anon_sym_and] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1300),
    [anon_sym_GT] = ACTIONS(1302),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_LT] = ACTIONS(1302),
    [anon_sym_CARET] = ACTIONS(1302),
    [anon_sym_orelse] = ACTIONS(1300),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1302),
    [anon_sym_PLUS_PIPE] = ACTIONS(1302),
    [anon_sym_DASH_PIPE] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_STAR_STAR] = ACTIONS(1300),
    [anon_sym_STAR_PERCENT] = ACTIONS(1302),
    [anon_sym_STAR_PIPE] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_catch] = ACTIONS(1300),
    [anon_sym_EQ_GT] = ACTIONS(1300),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_DOT_STAR] = ACTIONS(1300),
    [anon_sym_DOT_QMARK] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
  },
  [780] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(941),
    [anon_sym_linksection] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_DASH_PERCENT] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_catch] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(941),
    [anon_sym_DOT_QMARK] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
  },
  [781] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_STAR_EQ] = ACTIONS(1304),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1304),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1304),
    [anon_sym_SLASH_EQ] = ACTIONS(1304),
    [anon_sym_PERCENT_EQ] = ACTIONS(1304),
    [anon_sym_PLUS_EQ] = ACTIONS(1304),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1304),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1304),
    [anon_sym_DASH_EQ] = ACTIONS(1304),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1304),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1304),
    [anon_sym_LT_LT_EQ] = ACTIONS(1304),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1304),
    [anon_sym_GT_GT_EQ] = ACTIONS(1304),
    [anon_sym_AMP_EQ] = ACTIONS(1304),
    [anon_sym_CARET_EQ] = ACTIONS(1304),
    [anon_sym_PIPE_EQ] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1304),
    [anon_sym_DOT_DOT] = ACTIONS(1304),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_align] = ACTIONS(1304),
    [anon_sym_addrspace] = ACTIONS(1304),
    [anon_sym_linksection] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_DASH_PERCENT] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1306),
    [anon_sym_or] = ACTIONS(1306),
    [anon_sym_and] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_GT_EQ] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_CARET] = ACTIONS(1306),
    [anon_sym_orelse] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(1306),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1306),
    [anon_sym_PLUS_PIPE] = ACTIONS(1306),
    [anon_sym_DASH_PIPE] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_STAR_PERCENT] = ACTIONS(1306),
    [anon_sym_STAR_PIPE] = ACTIONS(1306),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_catch] = ACTIONS(1304),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_DOT] = ACTIONS(1306),
    [anon_sym_DOT_STAR] = ACTIONS(1304),
    [anon_sym_DOT_QMARK] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
  },
  [782] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_STAR_EQ] = ACTIONS(1308),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1308),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1308),
    [anon_sym_SLASH_EQ] = ACTIONS(1308),
    [anon_sym_PERCENT_EQ] = ACTIONS(1308),
    [anon_sym_PLUS_EQ] = ACTIONS(1308),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1308),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1308),
    [anon_sym_DASH_EQ] = ACTIONS(1308),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1308),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1308),
    [anon_sym_LT_LT_EQ] = ACTIONS(1308),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1308),
    [anon_sym_GT_GT_EQ] = ACTIONS(1308),
    [anon_sym_AMP_EQ] = ACTIONS(1308),
    [anon_sym_CARET_EQ] = ACTIONS(1308),
    [anon_sym_PIPE_EQ] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_else] = ACTIONS(1308),
    [anon_sym_DOT_DOT] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_align] = ACTIONS(1308),
    [anon_sym_addrspace] = ACTIONS(1308),
    [anon_sym_linksection] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_RBRACK] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_DASH_PERCENT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_or] = ACTIONS(1310),
    [anon_sym_and] = ACTIONS(1308),
    [anon_sym_EQ_EQ] = ACTIONS(1308),
    [anon_sym_BANG_EQ] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_GT_EQ] = ACTIONS(1308),
    [anon_sym_LT_EQ] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym_orelse] = ACTIONS(1308),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(1310),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1310),
    [anon_sym_PLUS_PIPE] = ACTIONS(1310),
    [anon_sym_DASH_PIPE] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_STAR_STAR] = ACTIONS(1308),
    [anon_sym_STAR_PERCENT] = ACTIONS(1310),
    [anon_sym_STAR_PIPE] = ACTIONS(1310),
    [anon_sym_PIPE_PIPE] = ACTIONS(1308),
    [anon_sym_catch] = ACTIONS(1308),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_DOT_STAR] = ACTIONS(1308),
    [anon_sym_DOT_QMARK] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [anon_sym_COMMA] = ACTIONS(1312),
    [anon_sym_COLON] = ACTIONS(1312),
    [anon_sym_EQ] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym_STAR_EQ] = ACTIONS(1312),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1312),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1312),
    [anon_sym_SLASH_EQ] = ACTIONS(1312),
    [anon_sym_PERCENT_EQ] = ACTIONS(1312),
    [anon_sym_PLUS_EQ] = ACTIONS(1312),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1312),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1312),
    [anon_sym_DASH_EQ] = ACTIONS(1312),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1312),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1312),
    [anon_sym_LT_LT_EQ] = ACTIONS(1312),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1312),
    [anon_sym_GT_GT_EQ] = ACTIONS(1312),
    [anon_sym_AMP_EQ] = ACTIONS(1312),
    [anon_sym_CARET_EQ] = ACTIONS(1312),
    [anon_sym_PIPE_EQ] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_RPAREN] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_DOT_DOT] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1314),
    [anon_sym_align] = ACTIONS(1312),
    [anon_sym_addrspace] = ACTIONS(1312),
    [anon_sym_linksection] = ACTIONS(1312),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_DASH_PERCENT] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_or] = ACTIONS(1314),
    [anon_sym_and] = ACTIONS(1312),
    [anon_sym_EQ_EQ] = ACTIONS(1312),
    [anon_sym_BANG_EQ] = ACTIONS(1312),
    [anon_sym_GT] = ACTIONS(1314),
    [anon_sym_GT_EQ] = ACTIONS(1312),
    [anon_sym_LT_EQ] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1314),
    [anon_sym_orelse] = ACTIONS(1312),
    [anon_sym_LT_LT] = ACTIONS(1314),
    [anon_sym_GT_GT] = ACTIONS(1314),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1314),
    [anon_sym_PLUS_PIPE] = ACTIONS(1314),
    [anon_sym_DASH_PIPE] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1314),
    [anon_sym_PERCENT] = ACTIONS(1314),
    [anon_sym_STAR_STAR] = ACTIONS(1312),
    [anon_sym_STAR_PERCENT] = ACTIONS(1314),
    [anon_sym_STAR_PIPE] = ACTIONS(1314),
    [anon_sym_PIPE_PIPE] = ACTIONS(1312),
    [anon_sym_catch] = ACTIONS(1312),
    [anon_sym_EQ_GT] = ACTIONS(1312),
    [anon_sym_DOT] = ACTIONS(1314),
    [anon_sym_DOT_STAR] = ACTIONS(1312),
    [anon_sym_DOT_QMARK] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
  },
  [784] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1316),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_DOT_DOT] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_align] = ACTIONS(1316),
    [anon_sym_addrspace] = ACTIONS(1316),
    [anon_sym_linksection] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_DASH_PERCENT] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_or] = ACTIONS(1318),
    [anon_sym_and] = ACTIONS(1316),
    [anon_sym_EQ_EQ] = ACTIONS(1316),
    [anon_sym_BANG_EQ] = ACTIONS(1316),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1316),
    [anon_sym_LT_EQ] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_CARET] = ACTIONS(1318),
    [anon_sym_orelse] = ACTIONS(1316),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1318),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1318),
    [anon_sym_PLUS_PIPE] = ACTIONS(1318),
    [anon_sym_DASH_PIPE] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_STAR_STAR] = ACTIONS(1316),
    [anon_sym_STAR_PERCENT] = ACTIONS(1318),
    [anon_sym_STAR_PIPE] = ACTIONS(1318),
    [anon_sym_PIPE_PIPE] = ACTIONS(1316),
    [anon_sym_catch] = ACTIONS(1316),
    [anon_sym_EQ_GT] = ACTIONS(1316),
    [anon_sym_DOT] = ACTIONS(1318),
    [anon_sym_DOT_STAR] = ACTIONS(1316),
    [anon_sym_DOT_QMARK] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
  },
  [785] = {
    [ts_builtin_sym_end] = ACTIONS(1320),
    [anon_sym_COMMA] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1320),
    [anon_sym_STAR_EQ] = ACTIONS(1320),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1320),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1320),
    [anon_sym_SLASH_EQ] = ACTIONS(1320),
    [anon_sym_PERCENT_EQ] = ACTIONS(1320),
    [anon_sym_PLUS_EQ] = ACTIONS(1320),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1320),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1320),
    [anon_sym_DASH_EQ] = ACTIONS(1320),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1320),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1320),
    [anon_sym_LT_LT_EQ] = ACTIONS(1320),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1320),
    [anon_sym_GT_GT_EQ] = ACTIONS(1320),
    [anon_sym_AMP_EQ] = ACTIONS(1320),
    [anon_sym_CARET_EQ] = ACTIONS(1320),
    [anon_sym_PIPE_EQ] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1320),
    [anon_sym_RPAREN] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_DOT_DOT] = ACTIONS(1320),
    [anon_sym_PIPE] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_align] = ACTIONS(1320),
    [anon_sym_addrspace] = ACTIONS(1320),
    [anon_sym_linksection] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_DASH_PERCENT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1322),
    [anon_sym_and] = ACTIONS(1320),
    [anon_sym_EQ_EQ] = ACTIONS(1320),
    [anon_sym_BANG_EQ] = ACTIONS(1320),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1320),
    [anon_sym_LT_EQ] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym_orelse] = ACTIONS(1320),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1322),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1320),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1322),
    [anon_sym_PLUS_PIPE] = ACTIONS(1322),
    [anon_sym_DASH_PIPE] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_STAR_STAR] = ACTIONS(1320),
    [anon_sym_STAR_PERCENT] = ACTIONS(1322),
    [anon_sym_STAR_PIPE] = ACTIONS(1322),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [anon_sym_catch] = ACTIONS(1320),
    [anon_sym_EQ_GT] = ACTIONS(1320),
    [anon_sym_DOT] = ACTIONS(1322),
    [anon_sym_DOT_STAR] = ACTIONS(1320),
    [anon_sym_DOT_QMARK] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [786] = {
    [ts_builtin_sym_end] = ACTIONS(1324),
    [anon_sym_COMMA] = ACTIONS(1324),
    [anon_sym_COLON] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_STAR_EQ] = ACTIONS(1324),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_SLASH_EQ] = ACTIONS(1324),
    [anon_sym_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1324),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_DASH_EQ] = ACTIONS(1324),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1324),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_LT_LT_EQ] = ACTIONS(1324),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_GT_GT_EQ] = ACTIONS(1324),
    [anon_sym_AMP_EQ] = ACTIONS(1324),
    [anon_sym_CARET_EQ] = ACTIONS(1324),
    [anon_sym_PIPE_EQ] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_DOT_DOT] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_align] = ACTIONS(1324),
    [anon_sym_addrspace] = ACTIONS(1324),
    [anon_sym_linksection] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_RBRACK] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_DASH_PERCENT] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_or] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG_EQ] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1326),
    [anon_sym_orelse] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1326),
    [anon_sym_PLUS_PIPE] = ACTIONS(1326),
    [anon_sym_DASH_PIPE] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_STAR_STAR] = ACTIONS(1324),
    [anon_sym_STAR_PERCENT] = ACTIONS(1326),
    [anon_sym_STAR_PIPE] = ACTIONS(1326),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_catch] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1324),
    [anon_sym_DOT] = ACTIONS(1326),
    [anon_sym_DOT_STAR] = ACTIONS(1324),
    [anon_sym_DOT_QMARK] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
  },
  [787] = {
    [ts_builtin_sym_end] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_COLON] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_STAR_EQ] = ACTIONS(1328),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1328),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_SLASH_EQ] = ACTIONS(1328),
    [anon_sym_PERCENT_EQ] = ACTIONS(1328),
    [anon_sym_PLUS_EQ] = ACTIONS(1328),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1328),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_DASH_EQ] = ACTIONS(1328),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1328),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_LT_LT_EQ] = ACTIONS(1328),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_GT_GT_EQ] = ACTIONS(1328),
    [anon_sym_AMP_EQ] = ACTIONS(1328),
    [anon_sym_CARET_EQ] = ACTIONS(1328),
    [anon_sym_PIPE_EQ] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_RPAREN] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1328),
    [anon_sym_DOT_DOT] = ACTIONS(1328),
    [anon_sym_PIPE] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1330),
    [anon_sym_align] = ACTIONS(1328),
    [anon_sym_addrspace] = ACTIONS(1328),
    [anon_sym_linksection] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_RBRACK] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_DASH_PERCENT] = ACTIONS(1330),
    [anon_sym_AMP] = ACTIONS(1330),
    [anon_sym_or] = ACTIONS(1330),
    [anon_sym_and] = ACTIONS(1328),
    [anon_sym_EQ_EQ] = ACTIONS(1328),
    [anon_sym_BANG_EQ] = ACTIONS(1328),
    [anon_sym_GT] = ACTIONS(1330),
    [anon_sym_GT_EQ] = ACTIONS(1328),
    [anon_sym_LT_EQ] = ACTIONS(1328),
    [anon_sym_LT] = ACTIONS(1330),
    [anon_sym_CARET] = ACTIONS(1330),
    [anon_sym_orelse] = ACTIONS(1328),
    [anon_sym_LT_LT] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1330),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1330),
    [anon_sym_PLUS_PIPE] = ACTIONS(1330),
    [anon_sym_DASH_PIPE] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(1330),
    [anon_sym_STAR_STAR] = ACTIONS(1328),
    [anon_sym_STAR_PERCENT] = ACTIONS(1330),
    [anon_sym_STAR_PIPE] = ACTIONS(1330),
    [anon_sym_PIPE_PIPE] = ACTIONS(1328),
    [anon_sym_catch] = ACTIONS(1328),
    [anon_sym_EQ_GT] = ACTIONS(1328),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_DOT_STAR] = ACTIONS(1328),
    [anon_sym_DOT_QMARK] = ACTIONS(1328),
    [sym_comment] = ACTIONS(3),
  },
  [788] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1332),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_DOT_DOT] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_align] = ACTIONS(1332),
    [anon_sym_addrspace] = ACTIONS(1332),
    [anon_sym_linksection] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DASH_PERCENT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1334),
    [anon_sym_or] = ACTIONS(1334),
    [anon_sym_and] = ACTIONS(1332),
    [anon_sym_EQ_EQ] = ACTIONS(1332),
    [anon_sym_BANG_EQ] = ACTIONS(1332),
    [anon_sym_GT] = ACTIONS(1334),
    [anon_sym_GT_EQ] = ACTIONS(1332),
    [anon_sym_LT_EQ] = ACTIONS(1332),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_orelse] = ACTIONS(1332),
    [anon_sym_LT_LT] = ACTIONS(1334),
    [anon_sym_GT_GT] = ACTIONS(1334),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1334),
    [anon_sym_PLUS_PIPE] = ACTIONS(1334),
    [anon_sym_DASH_PIPE] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_STAR_STAR] = ACTIONS(1332),
    [anon_sym_STAR_PERCENT] = ACTIONS(1334),
    [anon_sym_STAR_PIPE] = ACTIONS(1334),
    [anon_sym_PIPE_PIPE] = ACTIONS(1332),
    [anon_sym_catch] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(1334),
    [anon_sym_DOT_STAR] = ACTIONS(1332),
    [anon_sym_DOT_QMARK] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
  },
  [789] = {
    [ts_builtin_sym_end] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_STAR_EQ] = ACTIONS(1336),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_SLASH_EQ] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_PLUS_EQ] = ACTIONS(1336),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_DASH_EQ] = ACTIONS(1336),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1336),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1336),
    [anon_sym_AMP_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1336),
    [anon_sym_PIPE_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_DOT_DOT] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_align] = ACTIONS(1336),
    [anon_sym_addrspace] = ACTIONS(1336),
    [anon_sym_linksection] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_DASH_PERCENT] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_or] = ACTIONS(1338),
    [anon_sym_and] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1338),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1338),
    [anon_sym_orelse] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1338),
    [anon_sym_PLUS_PIPE] = ACTIONS(1338),
    [anon_sym_DASH_PIPE] = ACTIONS(1338),
    [anon_sym_SLASH] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_STAR_PERCENT] = ACTIONS(1338),
    [anon_sym_STAR_PIPE] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_catch] = ACTIONS(1336),
    [anon_sym_EQ_GT] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1338),
    [anon_sym_DOT_STAR] = ACTIONS(1336),
    [anon_sym_DOT_QMARK] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
  },
  [790] = {
    [ts_builtin_sym_end] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1340),
    [anon_sym_COLON] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1340),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1340),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1340),
    [anon_sym_SLASH_EQ] = ACTIONS(1340),
    [anon_sym_PERCENT_EQ] = ACTIONS(1340),
    [anon_sym_PLUS_EQ] = ACTIONS(1340),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1340),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1340),
    [anon_sym_DASH_EQ] = ACTIONS(1340),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1340),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1340),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1340),
    [anon_sym_GT_GT_EQ] = ACTIONS(1340),
    [anon_sym_AMP_EQ] = ACTIONS(1340),
    [anon_sym_CARET_EQ] = ACTIONS(1340),
    [anon_sym_PIPE_EQ] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_else] = ACTIONS(1340),
    [anon_sym_DOT_DOT] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_align] = ACTIONS(1340),
    [anon_sym_addrspace] = ACTIONS(1340),
    [anon_sym_linksection] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1340),
    [anon_sym_RBRACK] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_DASH_PERCENT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1342),
    [anon_sym_or] = ACTIONS(1342),
    [anon_sym_and] = ACTIONS(1340),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1342),
    [anon_sym_GT_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1342),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_orelse] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1342),
    [anon_sym_GT_GT] = ACTIONS(1342),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1342),
    [anon_sym_PLUS_PIPE] = ACTIONS(1342),
    [anon_sym_DASH_PIPE] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1342),
    [anon_sym_PERCENT] = ACTIONS(1342),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_PERCENT] = ACTIONS(1342),
    [anon_sym_STAR_PIPE] = ACTIONS(1342),
    [anon_sym_PIPE_PIPE] = ACTIONS(1340),
    [anon_sym_catch] = ACTIONS(1340),
    [anon_sym_EQ_GT] = ACTIONS(1340),
    [anon_sym_DOT] = ACTIONS(1342),
    [anon_sym_DOT_STAR] = ACTIONS(1340),
    [anon_sym_DOT_QMARK] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
  },
  [791] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_EQ] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_STAR_EQ] = ACTIONS(1344),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1344),
    [anon_sym_SLASH_EQ] = ACTIONS(1344),
    [anon_sym_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1344),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1344),
    [anon_sym_DASH_EQ] = ACTIONS(1344),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1344),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1344),
    [anon_sym_GT_GT_EQ] = ACTIONS(1344),
    [anon_sym_AMP_EQ] = ACTIONS(1344),
    [anon_sym_CARET_EQ] = ACTIONS(1344),
    [anon_sym_PIPE_EQ] = ACTIONS(1344),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1344),
    [anon_sym_DOT_DOT] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_align] = ACTIONS(1344),
    [anon_sym_addrspace] = ACTIONS(1344),
    [anon_sym_linksection] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_DASH_PERCENT] = ACTIONS(1346),
    [anon_sym_AMP] = ACTIONS(1346),
    [anon_sym_or] = ACTIONS(1346),
    [anon_sym_and] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1344),
    [anon_sym_BANG_EQ] = ACTIONS(1344),
    [anon_sym_GT] = ACTIONS(1346),
    [anon_sym_GT_EQ] = ACTIONS(1344),
    [anon_sym_LT_EQ] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_CARET] = ACTIONS(1346),
    [anon_sym_orelse] = ACTIONS(1344),
    [anon_sym_LT_LT] = ACTIONS(1346),
    [anon_sym_GT_GT] = ACTIONS(1346),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1346),
    [anon_sym_PLUS_PIPE] = ACTIONS(1346),
    [anon_sym_DASH_PIPE] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1346),
    [anon_sym_STAR_STAR] = ACTIONS(1344),
    [anon_sym_STAR_PERCENT] = ACTIONS(1346),
    [anon_sym_STAR_PIPE] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1344),
    [anon_sym_catch] = ACTIONS(1344),
    [anon_sym_EQ_GT] = ACTIONS(1344),
    [anon_sym_DOT] = ACTIONS(1346),
    [anon_sym_DOT_STAR] = ACTIONS(1344),
    [anon_sym_DOT_QMARK] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [792] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [anon_sym_COMMA] = ACTIONS(1348),
    [anon_sym_COLON] = ACTIONS(1348),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_RPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_DOT_DOT] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_align] = ACTIONS(1348),
    [anon_sym_addrspace] = ACTIONS(1348),
    [anon_sym_linksection] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_DASH_PERCENT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_or] = ACTIONS(1350),
    [anon_sym_and] = ACTIONS(1348),
    [anon_sym_EQ_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ] = ACTIONS(1348),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(1348),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_orelse] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1350),
    [anon_sym_PLUS_PIPE] = ACTIONS(1350),
    [anon_sym_DASH_PIPE] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1348),
    [anon_sym_STAR_PERCENT] = ACTIONS(1350),
    [anon_sym_STAR_PIPE] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1348),
    [anon_sym_catch] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1350),
    [anon_sym_DOT_STAR] = ACTIONS(1348),
    [anon_sym_DOT_QMARK] = ACTIONS(1348),
    [sym_comment] = ACTIONS(3),
  },
  [793] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(1352),
    [anon_sym_COLON] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym_STAR_EQ] = ACTIONS(1352),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1352),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_SLASH_EQ] = ACTIONS(1352),
    [anon_sym_PERCENT_EQ] = ACTIONS(1352),
    [anon_sym_PLUS_EQ] = ACTIONS(1352),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1352),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_DASH_EQ] = ACTIONS(1352),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1352),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_LT_LT_EQ] = ACTIONS(1352),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_GT_GT_EQ] = ACTIONS(1352),
    [anon_sym_AMP_EQ] = ACTIONS(1352),
    [anon_sym_CARET_EQ] = ACTIONS(1352),
    [anon_sym_PIPE_EQ] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [anon_sym_RPAREN] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_DOT_DOT] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_align] = ACTIONS(1352),
    [anon_sym_addrspace] = ACTIONS(1352),
    [anon_sym_linksection] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1352),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_DASH_PERCENT] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_or] = ACTIONS(1354),
    [anon_sym_and] = ACTIONS(1352),
    [anon_sym_EQ_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1354),
    [anon_sym_GT_EQ] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1352),
    [anon_sym_LT] = ACTIONS(1354),
    [anon_sym_CARET] = ACTIONS(1354),
    [anon_sym_orelse] = ACTIONS(1352),
    [anon_sym_LT_LT] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1354),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1354),
    [anon_sym_PLUS] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1354),
    [anon_sym_PLUS_PIPE] = ACTIONS(1354),
    [anon_sym_DASH_PIPE] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1352),
    [anon_sym_STAR_PERCENT] = ACTIONS(1354),
    [anon_sym_STAR_PIPE] = ACTIONS(1354),
    [anon_sym_PIPE_PIPE] = ACTIONS(1352),
    [anon_sym_catch] = ACTIONS(1352),
    [anon_sym_EQ_GT] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1354),
    [anon_sym_DOT_STAR] = ACTIONS(1352),
    [anon_sym_DOT_QMARK] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
  },
  [794] = {
    [ts_builtin_sym_end] = ACTIONS(1356),
    [anon_sym_COMMA] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(1356),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1356),
    [anon_sym_STAR_EQ] = ACTIONS(1356),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_SLASH_EQ] = ACTIONS(1356),
    [anon_sym_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_DASH_EQ] = ACTIONS(1356),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1356),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT_EQ] = ACTIONS(1356),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1356),
    [anon_sym_AMP_EQ] = ACTIONS(1356),
    [anon_sym_CARET_EQ] = ACTIONS(1356),
    [anon_sym_PIPE_EQ] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1356),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1356),
    [anon_sym_RBRACE] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_DOT_DOT] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_align] = ACTIONS(1356),
    [anon_sym_addrspace] = ACTIONS(1356),
    [anon_sym_linksection] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_RBRACK] = ACTIONS(1356),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_DASH_PERCENT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1358),
    [anon_sym_or] = ACTIONS(1358),
    [anon_sym_and] = ACTIONS(1356),
    [anon_sym_EQ_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1358),
    [anon_sym_GT_EQ] = ACTIONS(1356),
    [anon_sym_LT_EQ] = ACTIONS(1356),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_orelse] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1358),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1356),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1358),
    [anon_sym_PLUS_PIPE] = ACTIONS(1358),
    [anon_sym_DASH_PIPE] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_STAR_STAR] = ACTIONS(1356),
    [anon_sym_STAR_PERCENT] = ACTIONS(1358),
    [anon_sym_STAR_PIPE] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1356),
    [anon_sym_catch] = ACTIONS(1356),
    [anon_sym_EQ_GT] = ACTIONS(1356),
    [anon_sym_DOT] = ACTIONS(1358),
    [anon_sym_DOT_STAR] = ACTIONS(1356),
    [anon_sym_DOT_QMARK] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [795] = {
    [ts_builtin_sym_end] = ACTIONS(1360),
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_COLON] = ACTIONS(1360),
    [anon_sym_EQ] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_STAR_EQ] = ACTIONS(1360),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_SLASH_EQ] = ACTIONS(1360),
    [anon_sym_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_DASH_EQ] = ACTIONS(1360),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1360),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1360),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_GT_GT_EQ] = ACTIONS(1360),
    [anon_sym_AMP_EQ] = ACTIONS(1360),
    [anon_sym_CARET_EQ] = ACTIONS(1360),
    [anon_sym_PIPE_EQ] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1360),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_else] = ACTIONS(1360),
    [anon_sym_DOT_DOT] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_align] = ACTIONS(1360),
    [anon_sym_addrspace] = ACTIONS(1360),
    [anon_sym_linksection] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_RBRACK] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_DASH_PERCENT] = ACTIONS(1362),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_or] = ACTIONS(1362),
    [anon_sym_and] = ACTIONS(1360),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_GT_EQ] = ACTIONS(1360),
    [anon_sym_LT_EQ] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_orelse] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1362),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1362),
    [anon_sym_PLUS_PIPE] = ACTIONS(1362),
    [anon_sym_DASH_PIPE] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_STAR_STAR] = ACTIONS(1360),
    [anon_sym_STAR_PERCENT] = ACTIONS(1362),
    [anon_sym_STAR_PIPE] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1360),
    [anon_sym_catch] = ACTIONS(1360),
    [anon_sym_EQ_GT] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1362),
    [anon_sym_DOT_STAR] = ACTIONS(1360),
    [anon_sym_DOT_QMARK] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
  },
  [796] = {
    [ts_builtin_sym_end] = ACTIONS(1364),
    [anon_sym_COMMA] = ACTIONS(1364),
    [anon_sym_COLON] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym_STAR_EQ] = ACTIONS(1364),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_SLASH_EQ] = ACTIONS(1364),
    [anon_sym_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_DASH_EQ] = ACTIONS(1364),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1364),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_EQ] = ACTIONS(1364),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_GT_GT_EQ] = ACTIONS(1364),
    [anon_sym_AMP_EQ] = ACTIONS(1364),
    [anon_sym_CARET_EQ] = ACTIONS(1364),
    [anon_sym_PIPE_EQ] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_else] = ACTIONS(1364),
    [anon_sym_DOT_DOT] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_align] = ACTIONS(1364),
    [anon_sym_addrspace] = ACTIONS(1364),
    [anon_sym_linksection] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1364),
    [anon_sym_RBRACK] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_DASH_PERCENT] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_or] = ACTIONS(1366),
    [anon_sym_and] = ACTIONS(1364),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_GT_EQ] = ACTIONS(1364),
    [anon_sym_LT_EQ] = ACTIONS(1364),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_orelse] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(1366),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1366),
    [anon_sym_PLUS_PIPE] = ACTIONS(1366),
    [anon_sym_DASH_PIPE] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1366),
    [anon_sym_STAR_STAR] = ACTIONS(1364),
    [anon_sym_STAR_PERCENT] = ACTIONS(1366),
    [anon_sym_STAR_PIPE] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1364),
    [anon_sym_catch] = ACTIONS(1364),
    [anon_sym_EQ_GT] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_DOT_STAR] = ACTIONS(1364),
    [anon_sym_DOT_QMARK] = ACTIONS(1364),
    [sym_comment] = ACTIONS(3),
  },
  [797] = {
    [ts_builtin_sym_end] = ACTIONS(1368),
    [anon_sym_COMMA] = ACTIONS(1368),
    [anon_sym_COLON] = ACTIONS(1368),
    [anon_sym_EQ] = ACTIONS(1370),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym_STAR_EQ] = ACTIONS(1368),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_SLASH_EQ] = ACTIONS(1368),
    [anon_sym_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_PLUS_EQ] = ACTIONS(1368),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_DASH_EQ] = ACTIONS(1368),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1368),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT_EQ] = ACTIONS(1368),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_GT_GT_EQ] = ACTIONS(1368),
    [anon_sym_AMP_EQ] = ACTIONS(1368),
    [anon_sym_CARET_EQ] = ACTIONS(1368),
    [anon_sym_PIPE_EQ] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1368),
    [anon_sym_RPAREN] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1368),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_DOT_DOT] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_align] = ACTIONS(1368),
    [anon_sym_addrspace] = ACTIONS(1368),
    [anon_sym_linksection] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1368),
    [anon_sym_RBRACK] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_DASH_PERCENT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_or] = ACTIONS(1370),
    [anon_sym_and] = ACTIONS(1368),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_GT] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1368),
    [anon_sym_LT_EQ] = ACTIONS(1368),
    [anon_sym_LT] = ACTIONS(1370),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_orelse] = ACTIONS(1368),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1370),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1370),
    [anon_sym_PLUS_PIPE] = ACTIONS(1370),
    [anon_sym_DASH_PIPE] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1370),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_STAR] = ACTIONS(1368),
    [anon_sym_STAR_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_PIPE] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1368),
    [anon_sym_catch] = ACTIONS(1368),
    [anon_sym_EQ_GT] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_DOT_STAR] = ACTIONS(1368),
    [anon_sym_DOT_QMARK] = ACTIONS(1368),
    [sym_comment] = ACTIONS(3),
  },
  [798] = {
    [ts_builtin_sym_end] = ACTIONS(1372),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_STAR_EQ] = ACTIONS(1372),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1372),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1372),
    [anon_sym_SLASH_EQ] = ACTIONS(1372),
    [anon_sym_PERCENT_EQ] = ACTIONS(1372),
    [anon_sym_PLUS_EQ] = ACTIONS(1372),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1372),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1372),
    [anon_sym_DASH_EQ] = ACTIONS(1372),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1372),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1372),
    [anon_sym_LT_LT_EQ] = ACTIONS(1372),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1372),
    [anon_sym_GT_GT_EQ] = ACTIONS(1372),
    [anon_sym_AMP_EQ] = ACTIONS(1372),
    [anon_sym_CARET_EQ] = ACTIONS(1372),
    [anon_sym_PIPE_EQ] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_RPAREN] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_DOT_DOT] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_align] = ACTIONS(1372),
    [anon_sym_addrspace] = ACTIONS(1372),
    [anon_sym_linksection] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_RBRACK] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_DASH_PERCENT] = ACTIONS(1374),
    [anon_sym_AMP] = ACTIONS(1374),
    [anon_sym_or] = ACTIONS(1374),
    [anon_sym_and] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1372),
    [anon_sym_GT] = ACTIONS(1374),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1374),
    [anon_sym_CARET] = ACTIONS(1374),
    [anon_sym_orelse] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_GT_GT] = ACTIONS(1374),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1374),
    [anon_sym_PLUS_PIPE] = ACTIONS(1374),
    [anon_sym_DASH_PIPE] = ACTIONS(1374),
    [anon_sym_SLASH] = ACTIONS(1374),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_STAR_PERCENT] = ACTIONS(1374),
    [anon_sym_STAR_PIPE] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_catch] = ACTIONS(1372),
    [anon_sym_EQ_GT] = ACTIONS(1372),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_DOT_STAR] = ACTIONS(1372),
    [anon_sym_DOT_QMARK] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
  },
  [799] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_COLON] = ACTIONS(1376),
    [anon_sym_EQ] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_STAR_EQ] = ACTIONS(1376),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1376),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1376),
    [anon_sym_SLASH_EQ] = ACTIONS(1376),
    [anon_sym_PERCENT_EQ] = ACTIONS(1376),
    [anon_sym_PLUS_EQ] = ACTIONS(1376),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1376),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1376),
    [anon_sym_DASH_EQ] = ACTIONS(1376),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1376),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1376),
    [anon_sym_LT_LT_EQ] = ACTIONS(1376),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1376),
    [anon_sym_GT_GT_EQ] = ACTIONS(1376),
    [anon_sym_AMP_EQ] = ACTIONS(1376),
    [anon_sym_CARET_EQ] = ACTIONS(1376),
    [anon_sym_PIPE_EQ] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_else] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_align] = ACTIONS(1376),
    [anon_sym_addrspace] = ACTIONS(1376),
    [anon_sym_linksection] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_RBRACK] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1378),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_DASH_PERCENT] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1378),
    [anon_sym_or] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1376),
    [anon_sym_EQ_EQ] = ACTIONS(1376),
    [anon_sym_BANG_EQ] = ACTIONS(1376),
    [anon_sym_GT] = ACTIONS(1378),
    [anon_sym_GT_EQ] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1378),
    [anon_sym_CARET] = ACTIONS(1378),
    [anon_sym_orelse] = ACTIONS(1376),
    [anon_sym_LT_LT] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1378),
    [anon_sym_PLUS_PIPE] = ACTIONS(1378),
    [anon_sym_DASH_PIPE] = ACTIONS(1378),
    [anon_sym_SLASH] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1378),
    [anon_sym_STAR_STAR] = ACTIONS(1376),
    [anon_sym_STAR_PERCENT] = ACTIONS(1378),
    [anon_sym_STAR_PIPE] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1376),
    [anon_sym_catch] = ACTIONS(1376),
    [anon_sym_EQ_GT] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1378),
    [anon_sym_DOT_STAR] = ACTIONS(1376),
    [anon_sym_DOT_QMARK] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [anon_sym_COMMA] = ACTIONS(1380),
    [anon_sym_COLON] = ACTIONS(1380),
    [anon_sym_EQ] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_STAR_EQ] = ACTIONS(1380),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1380),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1380),
    [anon_sym_SLASH_EQ] = ACTIONS(1380),
    [anon_sym_PERCENT_EQ] = ACTIONS(1380),
    [anon_sym_PLUS_EQ] = ACTIONS(1380),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1380),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1380),
    [anon_sym_DASH_EQ] = ACTIONS(1380),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1380),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1380),
    [anon_sym_LT_LT_EQ] = ACTIONS(1380),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1380),
    [anon_sym_GT_GT_EQ] = ACTIONS(1380),
    [anon_sym_AMP_EQ] = ACTIONS(1380),
    [anon_sym_CARET_EQ] = ACTIONS(1380),
    [anon_sym_PIPE_EQ] = ACTIONS(1380),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_else] = ACTIONS(1380),
    [anon_sym_DOT_DOT] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_align] = ACTIONS(1380),
    [anon_sym_addrspace] = ACTIONS(1380),
    [anon_sym_linksection] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_DASH_PERCENT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_or] = ACTIONS(1382),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_EQ] = ACTIONS(1380),
    [anon_sym_LT_EQ] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(1382),
    [anon_sym_orelse] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1382),
    [anon_sym_PLUS_PIPE] = ACTIONS(1382),
    [anon_sym_DASH_PIPE] = ACTIONS(1382),
    [anon_sym_SLASH] = ACTIONS(1382),
    [anon_sym_PERCENT] = ACTIONS(1382),
    [anon_sym_STAR_STAR] = ACTIONS(1380),
    [anon_sym_STAR_PERCENT] = ACTIONS(1382),
    [anon_sym_STAR_PIPE] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_catch] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(1380),
    [anon_sym_DOT] = ACTIONS(1382),
    [anon_sym_DOT_STAR] = ACTIONS(1380),
    [anon_sym_DOT_QMARK] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
  },
  [801] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_EQ] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_STAR_EQ] = ACTIONS(1384),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1384),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1384),
    [anon_sym_SLASH_EQ] = ACTIONS(1384),
    [anon_sym_PERCENT_EQ] = ACTIONS(1384),
    [anon_sym_PLUS_EQ] = ACTIONS(1384),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1384),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1384),
    [anon_sym_DASH_EQ] = ACTIONS(1384),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1384),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1384),
    [anon_sym_LT_LT_EQ] = ACTIONS(1384),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1384),
    [anon_sym_GT_GT_EQ] = ACTIONS(1384),
    [anon_sym_AMP_EQ] = ACTIONS(1384),
    [anon_sym_CARET_EQ] = ACTIONS(1384),
    [anon_sym_PIPE_EQ] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1384),
    [anon_sym_DOT_DOT] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1386),
    [anon_sym_align] = ACTIONS(1384),
    [anon_sym_addrspace] = ACTIONS(1384),
    [anon_sym_linksection] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_RBRACK] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_DASH_PERCENT] = ACTIONS(1386),
    [anon_sym_AMP] = ACTIONS(1386),
    [anon_sym_or] = ACTIONS(1386),
    [anon_sym_and] = ACTIONS(1384),
    [anon_sym_EQ_EQ] = ACTIONS(1384),
    [anon_sym_BANG_EQ] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_EQ] = ACTIONS(1384),
    [anon_sym_LT_EQ] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_CARET] = ACTIONS(1386),
    [anon_sym_orelse] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1386),
    [anon_sym_PLUS_PIPE] = ACTIONS(1386),
    [anon_sym_DASH_PIPE] = ACTIONS(1386),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_PERCENT] = ACTIONS(1386),
    [anon_sym_STAR_STAR] = ACTIONS(1384),
    [anon_sym_STAR_PERCENT] = ACTIONS(1386),
    [anon_sym_STAR_PIPE] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_catch] = ACTIONS(1384),
    [anon_sym_EQ_GT] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1386),
    [anon_sym_DOT_STAR] = ACTIONS(1384),
    [anon_sym_DOT_QMARK] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
  },
  [802] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1391),
    [anon_sym_EQ] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_STAR_EQ] = ACTIONS(1388),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1388),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1388),
    [anon_sym_SLASH_EQ] = ACTIONS(1388),
    [anon_sym_PERCENT_EQ] = ACTIONS(1388),
    [anon_sym_PLUS_EQ] = ACTIONS(1388),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1388),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1388),
    [anon_sym_DASH_EQ] = ACTIONS(1388),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1388),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1388),
    [anon_sym_LT_LT_EQ] = ACTIONS(1388),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1388),
    [anon_sym_GT_GT_EQ] = ACTIONS(1388),
    [anon_sym_AMP_EQ] = ACTIONS(1388),
    [anon_sym_CARET_EQ] = ACTIONS(1388),
    [anon_sym_PIPE_EQ] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_DOT_DOT] = ACTIONS(1388),
    [anon_sym_PIPE] = ACTIONS(1393),
    [anon_sym_STAR] = ACTIONS(1393),
    [anon_sym_align] = ACTIONS(1388),
    [anon_sym_addrspace] = ACTIONS(1388),
    [anon_sym_linksection] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_DASH_PERCENT] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1393),
    [anon_sym_or] = ACTIONS(1393),
    [anon_sym_and] = ACTIONS(1388),
    [anon_sym_EQ_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ] = ACTIONS(1388),
    [anon_sym_GT] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1388),
    [anon_sym_LT_EQ] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_orelse] = ACTIONS(1388),
    [anon_sym_LT_LT] = ACTIONS(1393),
    [anon_sym_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1393),
    [anon_sym_PLUS_PIPE] = ACTIONS(1393),
    [anon_sym_DASH_PIPE] = ACTIONS(1393),
    [anon_sym_SLASH] = ACTIONS(1393),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1388),
    [anon_sym_STAR_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_PIPE] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_EQ_GT] = ACTIONS(1388),
    [anon_sym_DOT] = ACTIONS(1393),
    [anon_sym_DOT_STAR] = ACTIONS(1388),
    [anon_sym_DOT_QMARK] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
  },
  [803] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1396),
    [anon_sym_COLON] = ACTIONS(1396),
    [anon_sym_EQ] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_STAR_EQ] = ACTIONS(1396),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_SLASH_EQ] = ACTIONS(1396),
    [anon_sym_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_PLUS_EQ] = ACTIONS(1396),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_DASH_EQ] = ACTIONS(1396),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1396),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_LT_LT_EQ] = ACTIONS(1396),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_GT_GT_EQ] = ACTIONS(1396),
    [anon_sym_AMP_EQ] = ACTIONS(1396),
    [anon_sym_CARET_EQ] = ACTIONS(1396),
    [anon_sym_PIPE_EQ] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1396),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_else] = ACTIONS(1396),
    [anon_sym_DOT_DOT] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_align] = ACTIONS(1396),
    [anon_sym_addrspace] = ACTIONS(1396),
    [anon_sym_linksection] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_DASH_PERCENT] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1398),
    [anon_sym_or] = ACTIONS(1398),
    [anon_sym_and] = ACTIONS(1396),
    [anon_sym_EQ_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(1396),
    [anon_sym_GT] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1396),
    [anon_sym_LT_EQ] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_orelse] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1398),
    [anon_sym_PLUS_PIPE] = ACTIONS(1398),
    [anon_sym_DASH_PIPE] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_STAR_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR_PIPE] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1396),
    [anon_sym_catch] = ACTIONS(1396),
    [anon_sym_EQ_GT] = ACTIONS(1396),
    [anon_sym_DOT] = ACTIONS(1398),
    [anon_sym_DOT_STAR] = ACTIONS(1396),
    [anon_sym_DOT_QMARK] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
  },
  [804] = {
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_COLON] = ACTIONS(1400),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_STAR_EQ] = ACTIONS(1400),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_SLASH_EQ] = ACTIONS(1400),
    [anon_sym_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_PLUS_EQ] = ACTIONS(1400),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_DASH_EQ] = ACTIONS(1400),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1400),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_LT_LT_EQ] = ACTIONS(1400),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_GT_GT_EQ] = ACTIONS(1400),
    [anon_sym_AMP_EQ] = ACTIONS(1400),
    [anon_sym_CARET_EQ] = ACTIONS(1400),
    [anon_sym_PIPE_EQ] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_DOT_DOT] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_align] = ACTIONS(1400),
    [anon_sym_addrspace] = ACTIONS(1400),
    [anon_sym_linksection] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_RBRACK] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_DASH_PERCENT] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1402),
    [anon_sym_or] = ACTIONS(1402),
    [anon_sym_and] = ACTIONS(1400),
    [anon_sym_EQ_EQ] = ACTIONS(1400),
    [anon_sym_BANG_EQ] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_EQ] = ACTIONS(1400),
    [anon_sym_LT_EQ] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_orelse] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1402),
    [anon_sym_PLUS_PIPE] = ACTIONS(1402),
    [anon_sym_DASH_PIPE] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1402),
    [anon_sym_PERCENT] = ACTIONS(1402),
    [anon_sym_STAR_STAR] = ACTIONS(1400),
    [anon_sym_STAR_PERCENT] = ACTIONS(1402),
    [anon_sym_STAR_PIPE] = ACTIONS(1402),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_catch] = ACTIONS(1400),
    [anon_sym_EQ_GT] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1402),
    [anon_sym_DOT_STAR] = ACTIONS(1400),
    [anon_sym_DOT_QMARK] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
  },
  [805] = {
    [ts_builtin_sym_end] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(1404),
    [anon_sym_COLON] = ACTIONS(1404),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym_STAR_EQ] = ACTIONS(1404),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1404),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1404),
    [anon_sym_SLASH_EQ] = ACTIONS(1404),
    [anon_sym_PERCENT_EQ] = ACTIONS(1404),
    [anon_sym_PLUS_EQ] = ACTIONS(1404),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1404),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1404),
    [anon_sym_DASH_EQ] = ACTIONS(1404),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1404),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1404),
    [anon_sym_LT_LT_EQ] = ACTIONS(1404),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1404),
    [anon_sym_GT_GT_EQ] = ACTIONS(1404),
    [anon_sym_AMP_EQ] = ACTIONS(1404),
    [anon_sym_CARET_EQ] = ACTIONS(1404),
    [anon_sym_PIPE_EQ] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [anon_sym_RPAREN] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1404),
    [anon_sym_else] = ACTIONS(1404),
    [anon_sym_DOT_DOT] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_align] = ACTIONS(1404),
    [anon_sym_addrspace] = ACTIONS(1404),
    [anon_sym_linksection] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_RBRACK] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1406),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_DASH_PERCENT] = ACTIONS(1406),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_or] = ACTIONS(1406),
    [anon_sym_and] = ACTIONS(1404),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_GT_EQ] = ACTIONS(1404),
    [anon_sym_LT_EQ] = ACTIONS(1404),
    [anon_sym_LT] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_orelse] = ACTIONS(1404),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1406),
    [anon_sym_PLUS_PIPE] = ACTIONS(1406),
    [anon_sym_DASH_PIPE] = ACTIONS(1406),
    [anon_sym_SLASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_STAR_STAR] = ACTIONS(1404),
    [anon_sym_STAR_PERCENT] = ACTIONS(1406),
    [anon_sym_STAR_PIPE] = ACTIONS(1406),
    [anon_sym_PIPE_PIPE] = ACTIONS(1404),
    [anon_sym_catch] = ACTIONS(1404),
    [anon_sym_EQ_GT] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_DOT_STAR] = ACTIONS(1404),
    [anon_sym_DOT_QMARK] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [806] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_COLON] = ACTIONS(1408),
    [anon_sym_EQ] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_STAR_EQ] = ACTIONS(1408),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_SLASH_EQ] = ACTIONS(1408),
    [anon_sym_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_PLUS_EQ] = ACTIONS(1408),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_DASH_EQ] = ACTIONS(1408),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1408),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_EQ] = ACTIONS(1408),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_GT_GT_EQ] = ACTIONS(1408),
    [anon_sym_AMP_EQ] = ACTIONS(1408),
    [anon_sym_CARET_EQ] = ACTIONS(1408),
    [anon_sym_PIPE_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_else] = ACTIONS(1408),
    [anon_sym_DOT_DOT] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1410),
    [anon_sym_align] = ACTIONS(1408),
    [anon_sym_addrspace] = ACTIONS(1408),
    [anon_sym_linksection] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_RBRACK] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_DASH_PERCENT] = ACTIONS(1410),
    [anon_sym_AMP] = ACTIONS(1410),
    [anon_sym_or] = ACTIONS(1410),
    [anon_sym_and] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1410),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1410),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_orelse] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1410),
    [anon_sym_GT_GT] = ACTIONS(1410),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1410),
    [anon_sym_PLUS_PIPE] = ACTIONS(1410),
    [anon_sym_DASH_PIPE] = ACTIONS(1410),
    [anon_sym_SLASH] = ACTIONS(1410),
    [anon_sym_PERCENT] = ACTIONS(1410),
    [anon_sym_STAR_STAR] = ACTIONS(1408),
    [anon_sym_STAR_PERCENT] = ACTIONS(1410),
    [anon_sym_STAR_PIPE] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_catch] = ACTIONS(1408),
    [anon_sym_EQ_GT] = ACTIONS(1408),
    [anon_sym_DOT] = ACTIONS(1410),
    [anon_sym_DOT_STAR] = ACTIONS(1408),
    [anon_sym_DOT_QMARK] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [ts_builtin_sym_end] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_COLON] = ACTIONS(1412),
    [anon_sym_EQ] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym_STAR_EQ] = ACTIONS(1412),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1412),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1412),
    [anon_sym_SLASH_EQ] = ACTIONS(1412),
    [anon_sym_PERCENT_EQ] = ACTIONS(1412),
    [anon_sym_PLUS_EQ] = ACTIONS(1412),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1412),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1412),
    [anon_sym_DASH_EQ] = ACTIONS(1412),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1412),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1412),
    [anon_sym_LT_LT_EQ] = ACTIONS(1412),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1412),
    [anon_sym_GT_GT_EQ] = ACTIONS(1412),
    [anon_sym_AMP_EQ] = ACTIONS(1412),
    [anon_sym_CARET_EQ] = ACTIONS(1412),
    [anon_sym_PIPE_EQ] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [anon_sym_RPAREN] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_else] = ACTIONS(1412),
    [anon_sym_DOT_DOT] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_align] = ACTIONS(1412),
    [anon_sym_addrspace] = ACTIONS(1412),
    [anon_sym_linksection] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1412),
    [anon_sym_RBRACK] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_DASH_PERCENT] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(1414),
    [anon_sym_or] = ACTIONS(1414),
    [anon_sym_and] = ACTIONS(1412),
    [anon_sym_EQ_EQ] = ACTIONS(1412),
    [anon_sym_BANG_EQ] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(1414),
    [anon_sym_GT_EQ] = ACTIONS(1412),
    [anon_sym_LT_EQ] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_CARET] = ACTIONS(1414),
    [anon_sym_orelse] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_GT_GT] = ACTIONS(1414),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1414),
    [anon_sym_PLUS_PIPE] = ACTIONS(1414),
    [anon_sym_DASH_PIPE] = ACTIONS(1414),
    [anon_sym_SLASH] = ACTIONS(1414),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_STAR_STAR] = ACTIONS(1412),
    [anon_sym_STAR_PERCENT] = ACTIONS(1414),
    [anon_sym_STAR_PIPE] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1412),
    [anon_sym_catch] = ACTIONS(1412),
    [anon_sym_EQ_GT] = ACTIONS(1412),
    [anon_sym_DOT] = ACTIONS(1414),
    [anon_sym_DOT_STAR] = ACTIONS(1412),
    [anon_sym_DOT_QMARK] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
  },
  [808] = {
    [ts_builtin_sym_end] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(1416),
    [anon_sym_COLON] = ACTIONS(1416),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_STAR_EQ] = ACTIONS(1416),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_SLASH_EQ] = ACTIONS(1416),
    [anon_sym_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_PLUS_EQ] = ACTIONS(1416),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_DASH_EQ] = ACTIONS(1416),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1416),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_LT_LT_EQ] = ACTIONS(1416),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_GT_GT_EQ] = ACTIONS(1416),
    [anon_sym_AMP_EQ] = ACTIONS(1416),
    [anon_sym_CARET_EQ] = ACTIONS(1416),
    [anon_sym_PIPE_EQ] = ACTIONS(1416),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_RPAREN] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_else] = ACTIONS(1416),
    [anon_sym_DOT_DOT] = ACTIONS(1416),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_align] = ACTIONS(1416),
    [anon_sym_addrspace] = ACTIONS(1416),
    [anon_sym_linksection] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_RBRACK] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DASH_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
    [anon_sym_or] = ACTIONS(1418),
    [anon_sym_and] = ACTIONS(1416),
    [anon_sym_EQ_EQ] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1416),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1416),
    [anon_sym_LT_EQ] = ACTIONS(1416),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_orelse] = ACTIONS(1416),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1418),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1418),
    [anon_sym_PLUS_PIPE] = ACTIONS(1418),
    [anon_sym_DASH_PIPE] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR_STAR] = ACTIONS(1416),
    [anon_sym_STAR_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR_PIPE] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1416),
    [anon_sym_catch] = ACTIONS(1416),
    [anon_sym_EQ_GT] = ACTIONS(1416),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_DOT_STAR] = ACTIONS(1416),
    [anon_sym_DOT_QMARK] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
  },
  [809] = {
    [ts_builtin_sym_end] = ACTIONS(1420),
    [anon_sym_COMMA] = ACTIONS(1420),
    [anon_sym_COLON] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym_STAR_EQ] = ACTIONS(1420),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_SLASH_EQ] = ACTIONS(1420),
    [anon_sym_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_PLUS_EQ] = ACTIONS(1420),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_DASH_EQ] = ACTIONS(1420),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1420),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_EQ] = ACTIONS(1420),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_GT_GT_EQ] = ACTIONS(1420),
    [anon_sym_AMP_EQ] = ACTIONS(1420),
    [anon_sym_CARET_EQ] = ACTIONS(1420),
    [anon_sym_PIPE_EQ] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_RPAREN] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_else] = ACTIONS(1420),
    [anon_sym_DOT_DOT] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_align] = ACTIONS(1420),
    [anon_sym_addrspace] = ACTIONS(1420),
    [anon_sym_linksection] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_RBRACK] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_DASH_PERCENT] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_or] = ACTIONS(1422),
    [anon_sym_and] = ACTIONS(1420),
    [anon_sym_EQ_EQ] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1420),
    [anon_sym_GT] = ACTIONS(1422),
    [anon_sym_GT_EQ] = ACTIONS(1420),
    [anon_sym_LT_EQ] = ACTIONS(1420),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_orelse] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1422),
    [anon_sym_PLUS_PIPE] = ACTIONS(1422),
    [anon_sym_DASH_PIPE] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_STAR_STAR] = ACTIONS(1420),
    [anon_sym_STAR_PERCENT] = ACTIONS(1422),
    [anon_sym_STAR_PIPE] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1420),
    [anon_sym_catch] = ACTIONS(1420),
    [anon_sym_EQ_GT] = ACTIONS(1420),
    [anon_sym_DOT] = ACTIONS(1422),
    [anon_sym_DOT_STAR] = ACTIONS(1420),
    [anon_sym_DOT_QMARK] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [ts_builtin_sym_end] = ACTIONS(1424),
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_COLON] = ACTIONS(1424),
    [anon_sym_EQ] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_STAR_EQ] = ACTIONS(1424),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_SLASH_EQ] = ACTIONS(1424),
    [anon_sym_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_DASH_EQ] = ACTIONS(1424),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1424),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_EQ] = ACTIONS(1424),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_GT_GT_EQ] = ACTIONS(1424),
    [anon_sym_AMP_EQ] = ACTIONS(1424),
    [anon_sym_CARET_EQ] = ACTIONS(1424),
    [anon_sym_PIPE_EQ] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_else] = ACTIONS(1424),
    [anon_sym_DOT_DOT] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_align] = ACTIONS(1424),
    [anon_sym_addrspace] = ACTIONS(1424),
    [anon_sym_linksection] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_RBRACK] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_DASH_PERCENT] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_or] = ACTIONS(1426),
    [anon_sym_and] = ACTIONS(1424),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1426),
    [anon_sym_GT_EQ] = ACTIONS(1424),
    [anon_sym_LT_EQ] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1426),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_orelse] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1426),
    [anon_sym_GT_GT] = ACTIONS(1426),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1426),
    [anon_sym_PLUS_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_PIPE] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(1426),
    [anon_sym_PERCENT] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1424),
    [anon_sym_STAR_PERCENT] = ACTIONS(1426),
    [anon_sym_STAR_PIPE] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_catch] = ACTIONS(1424),
    [anon_sym_EQ_GT] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1426),
    [anon_sym_DOT_STAR] = ACTIONS(1424),
    [anon_sym_DOT_QMARK] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
  },
  [811] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_STAR_EQ] = ACTIONS(1428),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_SLASH_EQ] = ACTIONS(1428),
    [anon_sym_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_DASH_EQ] = ACTIONS(1428),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_LT_LT_EQ] = ACTIONS(1428),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_GT_GT_EQ] = ACTIONS(1428),
    [anon_sym_AMP_EQ] = ACTIONS(1428),
    [anon_sym_CARET_EQ] = ACTIONS(1428),
    [anon_sym_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_else] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_align] = ACTIONS(1428),
    [anon_sym_addrspace] = ACTIONS(1428),
    [anon_sym_linksection] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_DASH_PERCENT] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_or] = ACTIONS(1430),
    [anon_sym_and] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_orelse] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1430),
    [anon_sym_PLUS_PIPE] = ACTIONS(1430),
    [anon_sym_DASH_PIPE] = ACTIONS(1430),
    [anon_sym_SLASH] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1430),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_STAR_PERCENT] = ACTIONS(1430),
    [anon_sym_STAR_PIPE] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_catch] = ACTIONS(1428),
    [anon_sym_EQ_GT] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1430),
    [anon_sym_DOT_STAR] = ACTIONS(1428),
    [anon_sym_DOT_QMARK] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [anon_sym_COMMA] = ACTIONS(1432),
    [anon_sym_COLON] = ACTIONS(1432),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_STAR_EQ] = ACTIONS(1432),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1432),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1432),
    [anon_sym_SLASH_EQ] = ACTIONS(1432),
    [anon_sym_PERCENT_EQ] = ACTIONS(1432),
    [anon_sym_PLUS_EQ] = ACTIONS(1432),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1432),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1432),
    [anon_sym_DASH_EQ] = ACTIONS(1432),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1432),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1432),
    [anon_sym_LT_LT_EQ] = ACTIONS(1432),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1432),
    [anon_sym_GT_GT_EQ] = ACTIONS(1432),
    [anon_sym_AMP_EQ] = ACTIONS(1432),
    [anon_sym_CARET_EQ] = ACTIONS(1432),
    [anon_sym_PIPE_EQ] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_RPAREN] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1432),
    [anon_sym_DOT_DOT] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_align] = ACTIONS(1432),
    [anon_sym_addrspace] = ACTIONS(1432),
    [anon_sym_linksection] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_RBRACK] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DASH_PERCENT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_or] = ACTIONS(1434),
    [anon_sym_and] = ACTIONS(1432),
    [anon_sym_EQ_EQ] = ACTIONS(1432),
    [anon_sym_BANG_EQ] = ACTIONS(1432),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_GT_EQ] = ACTIONS(1432),
    [anon_sym_LT_EQ] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym_orelse] = ACTIONS(1432),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1434),
    [anon_sym_PLUS_PIPE] = ACTIONS(1434),
    [anon_sym_DASH_PIPE] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_STAR_STAR] = ACTIONS(1432),
    [anon_sym_STAR_PERCENT] = ACTIONS(1434),
    [anon_sym_STAR_PIPE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1432),
    [anon_sym_catch] = ACTIONS(1432),
    [anon_sym_EQ_GT] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_DOT_STAR] = ACTIONS(1432),
    [anon_sym_DOT_QMARK] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_COMMA] = ACTIONS(1436),
    [anon_sym_COLON] = ACTIONS(1436),
    [anon_sym_EQ] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_STAR_EQ] = ACTIONS(1436),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1436),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1436),
    [anon_sym_SLASH_EQ] = ACTIONS(1436),
    [anon_sym_PERCENT_EQ] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1436),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1436),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1436),
    [anon_sym_DASH_EQ] = ACTIONS(1436),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1436),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1436),
    [anon_sym_LT_LT_EQ] = ACTIONS(1436),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1436),
    [anon_sym_GT_GT_EQ] = ACTIONS(1436),
    [anon_sym_AMP_EQ] = ACTIONS(1436),
    [anon_sym_CARET_EQ] = ACTIONS(1436),
    [anon_sym_PIPE_EQ] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1436),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_else] = ACTIONS(1436),
    [anon_sym_DOT_DOT] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_align] = ACTIONS(1436),
    [anon_sym_addrspace] = ACTIONS(1436),
    [anon_sym_linksection] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_RBRACK] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_DASH_PERCENT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1438),
    [anon_sym_or] = ACTIONS(1438),
    [anon_sym_and] = ACTIONS(1436),
    [anon_sym_EQ_EQ] = ACTIONS(1436),
    [anon_sym_BANG_EQ] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1438),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_orelse] = ACTIONS(1436),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1438),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1438),
    [anon_sym_PLUS_PIPE] = ACTIONS(1438),
    [anon_sym_DASH_PIPE] = ACTIONS(1438),
    [anon_sym_SLASH] = ACTIONS(1438),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_STAR_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_PIPE] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1436),
    [anon_sym_catch] = ACTIONS(1436),
    [anon_sym_EQ_GT] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_DOT_STAR] = ACTIONS(1436),
    [anon_sym_DOT_QMARK] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [814] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [anon_sym_COMMA] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_STAR_EQ] = ACTIONS(1440),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1440),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1440),
    [anon_sym_SLASH_EQ] = ACTIONS(1440),
    [anon_sym_PERCENT_EQ] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1440),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1440),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1440),
    [anon_sym_DASH_EQ] = ACTIONS(1440),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1440),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1440),
    [anon_sym_LT_LT_EQ] = ACTIONS(1440),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1440),
    [anon_sym_GT_GT_EQ] = ACTIONS(1440),
    [anon_sym_AMP_EQ] = ACTIONS(1440),
    [anon_sym_CARET_EQ] = ACTIONS(1440),
    [anon_sym_PIPE_EQ] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_DOT_DOT] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_align] = ACTIONS(1440),
    [anon_sym_addrspace] = ACTIONS(1440),
    [anon_sym_linksection] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1440),
    [anon_sym_RBRACK] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_DASH_PERCENT] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_or] = ACTIONS(1442),
    [anon_sym_and] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_CARET] = ACTIONS(1442),
    [anon_sym_orelse] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1442),
    [anon_sym_GT_GT] = ACTIONS(1442),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1442),
    [anon_sym_PLUS_PIPE] = ACTIONS(1442),
    [anon_sym_DASH_PIPE] = ACTIONS(1442),
    [anon_sym_SLASH] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(1442),
    [anon_sym_STAR_STAR] = ACTIONS(1440),
    [anon_sym_STAR_PERCENT] = ACTIONS(1442),
    [anon_sym_STAR_PIPE] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1440),
    [anon_sym_EQ_GT] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_DOT_STAR] = ACTIONS(1440),
    [anon_sym_DOT_QMARK] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [815] = {
    [ts_builtin_sym_end] = ACTIONS(1444),
    [anon_sym_COMMA] = ACTIONS(1444),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_EQ] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym_STAR_EQ] = ACTIONS(1444),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1444),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1444),
    [anon_sym_SLASH_EQ] = ACTIONS(1444),
    [anon_sym_PERCENT_EQ] = ACTIONS(1444),
    [anon_sym_PLUS_EQ] = ACTIONS(1444),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1444),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1444),
    [anon_sym_DASH_EQ] = ACTIONS(1444),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1444),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1444),
    [anon_sym_LT_LT_EQ] = ACTIONS(1444),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1444),
    [anon_sym_GT_GT_EQ] = ACTIONS(1444),
    [anon_sym_AMP_EQ] = ACTIONS(1444),
    [anon_sym_CARET_EQ] = ACTIONS(1444),
    [anon_sym_PIPE_EQ] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1444),
    [anon_sym_RPAREN] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [anon_sym_else] = ACTIONS(1444),
    [anon_sym_DOT_DOT] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_align] = ACTIONS(1444),
    [anon_sym_addrspace] = ACTIONS(1444),
    [anon_sym_linksection] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_RBRACK] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_DASH_PERCENT] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1446),
    [anon_sym_or] = ACTIONS(1446),
    [anon_sym_and] = ACTIONS(1444),
    [anon_sym_EQ_EQ] = ACTIONS(1444),
    [anon_sym_BANG_EQ] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_EQ] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_CARET] = ACTIONS(1446),
    [anon_sym_orelse] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1446),
    [anon_sym_PLUS_PIPE] = ACTIONS(1446),
    [anon_sym_DASH_PIPE] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1446),
    [anon_sym_PERCENT] = ACTIONS(1446),
    [anon_sym_STAR_STAR] = ACTIONS(1444),
    [anon_sym_STAR_PERCENT] = ACTIONS(1446),
    [anon_sym_STAR_PIPE] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_catch] = ACTIONS(1444),
    [anon_sym_EQ_GT] = ACTIONS(1444),
    [anon_sym_DOT] = ACTIONS(1446),
    [anon_sym_DOT_STAR] = ACTIONS(1444),
    [anon_sym_DOT_QMARK] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [816] = {
    [ts_builtin_sym_end] = ACTIONS(1448),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_COLON] = ACTIONS(1448),
    [anon_sym_EQ] = ACTIONS(1450),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_STAR_EQ] = ACTIONS(1448),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1448),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1448),
    [anon_sym_SLASH_EQ] = ACTIONS(1448),
    [anon_sym_PERCENT_EQ] = ACTIONS(1448),
    [anon_sym_PLUS_EQ] = ACTIONS(1448),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1448),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1448),
    [anon_sym_DASH_EQ] = ACTIONS(1448),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1448),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1448),
    [anon_sym_LT_LT_EQ] = ACTIONS(1448),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1448),
    [anon_sym_GT_GT_EQ] = ACTIONS(1448),
    [anon_sym_AMP_EQ] = ACTIONS(1448),
    [anon_sym_CARET_EQ] = ACTIONS(1448),
    [anon_sym_PIPE_EQ] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_DOT_DOT] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1450),
    [anon_sym_align] = ACTIONS(1448),
    [anon_sym_addrspace] = ACTIONS(1448),
    [anon_sym_linksection] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [anon_sym_RBRACK] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_DASH_PERCENT] = ACTIONS(1450),
    [anon_sym_AMP] = ACTIONS(1450),
    [anon_sym_or] = ACTIONS(1450),
    [anon_sym_and] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1448),
    [anon_sym_BANG_EQ] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1450),
    [anon_sym_GT_EQ] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1450),
    [anon_sym_CARET] = ACTIONS(1450),
    [anon_sym_orelse] = ACTIONS(1448),
    [anon_sym_LT_LT] = ACTIONS(1450),
    [anon_sym_GT_GT] = ACTIONS(1450),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1450),
    [anon_sym_PLUS_PIPE] = ACTIONS(1450),
    [anon_sym_DASH_PIPE] = ACTIONS(1450),
    [anon_sym_SLASH] = ACTIONS(1450),
    [anon_sym_PERCENT] = ACTIONS(1450),
    [anon_sym_STAR_STAR] = ACTIONS(1448),
    [anon_sym_STAR_PERCENT] = ACTIONS(1450),
    [anon_sym_STAR_PIPE] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1448),
    [anon_sym_catch] = ACTIONS(1448),
    [anon_sym_EQ_GT] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1450),
    [anon_sym_DOT_STAR] = ACTIONS(1448),
    [anon_sym_DOT_QMARK] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [817] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1452),
    [anon_sym_COLON] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_STAR_EQ] = ACTIONS(1452),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1452),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1452),
    [anon_sym_SLASH_EQ] = ACTIONS(1452),
    [anon_sym_PERCENT_EQ] = ACTIONS(1452),
    [anon_sym_PLUS_EQ] = ACTIONS(1452),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1452),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1452),
    [anon_sym_DASH_EQ] = ACTIONS(1452),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1452),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1452),
    [anon_sym_LT_LT_EQ] = ACTIONS(1452),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1452),
    [anon_sym_GT_GT_EQ] = ACTIONS(1452),
    [anon_sym_AMP_EQ] = ACTIONS(1452),
    [anon_sym_CARET_EQ] = ACTIONS(1452),
    [anon_sym_PIPE_EQ] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_RPAREN] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_DOT_DOT] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_align] = ACTIONS(1452),
    [anon_sym_addrspace] = ACTIONS(1452),
    [anon_sym_linksection] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_RBRACK] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_DASH_PERCENT] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_or] = ACTIONS(1454),
    [anon_sym_and] = ACTIONS(1452),
    [anon_sym_EQ_EQ] = ACTIONS(1452),
    [anon_sym_BANG_EQ] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_GT_EQ] = ACTIONS(1452),
    [anon_sym_LT_EQ] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1454),
    [anon_sym_orelse] = ACTIONS(1452),
    [anon_sym_LT_LT] = ACTIONS(1454),
    [anon_sym_GT_GT] = ACTIONS(1454),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1454),
    [anon_sym_PLUS_PIPE] = ACTIONS(1454),
    [anon_sym_DASH_PIPE] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1454),
    [anon_sym_STAR_STAR] = ACTIONS(1452),
    [anon_sym_STAR_PERCENT] = ACTIONS(1454),
    [anon_sym_STAR_PIPE] = ACTIONS(1454),
    [anon_sym_PIPE_PIPE] = ACTIONS(1452),
    [anon_sym_catch] = ACTIONS(1452),
    [anon_sym_EQ_GT] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_DOT_STAR] = ACTIONS(1452),
    [anon_sym_DOT_QMARK] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [818] = {
    [ts_builtin_sym_end] = ACTIONS(1456),
    [anon_sym_COMMA] = ACTIONS(1456),
    [anon_sym_COLON] = ACTIONS(1456),
    [anon_sym_EQ] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_STAR_EQ] = ACTIONS(1456),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1456),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1456),
    [anon_sym_SLASH_EQ] = ACTIONS(1456),
    [anon_sym_PERCENT_EQ] = ACTIONS(1456),
    [anon_sym_PLUS_EQ] = ACTIONS(1456),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1456),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1456),
    [anon_sym_DASH_EQ] = ACTIONS(1456),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1456),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1456),
    [anon_sym_LT_LT_EQ] = ACTIONS(1456),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1456),
    [anon_sym_GT_GT_EQ] = ACTIONS(1456),
    [anon_sym_AMP_EQ] = ACTIONS(1456),
    [anon_sym_CARET_EQ] = ACTIONS(1456),
    [anon_sym_PIPE_EQ] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [anon_sym_RPAREN] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_else] = ACTIONS(1456),
    [anon_sym_DOT_DOT] = ACTIONS(1456),
    [anon_sym_PIPE] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_align] = ACTIONS(1456),
    [anon_sym_addrspace] = ACTIONS(1456),
    [anon_sym_linksection] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_RBRACK] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_DASH_PERCENT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1458),
    [anon_sym_or] = ACTIONS(1458),
    [anon_sym_and] = ACTIONS(1456),
    [anon_sym_EQ_EQ] = ACTIONS(1456),
    [anon_sym_BANG_EQ] = ACTIONS(1456),
    [anon_sym_GT] = ACTIONS(1458),
    [anon_sym_GT_EQ] = ACTIONS(1456),
    [anon_sym_LT_EQ] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1458),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym_orelse] = ACTIONS(1456),
    [anon_sym_LT_LT] = ACTIONS(1458),
    [anon_sym_GT_GT] = ACTIONS(1458),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1458),
    [anon_sym_PLUS_PIPE] = ACTIONS(1458),
    [anon_sym_DASH_PIPE] = ACTIONS(1458),
    [anon_sym_SLASH] = ACTIONS(1458),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR_STAR] = ACTIONS(1456),
    [anon_sym_STAR_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR_PIPE] = ACTIONS(1458),
    [anon_sym_PIPE_PIPE] = ACTIONS(1456),
    [anon_sym_catch] = ACTIONS(1456),
    [anon_sym_EQ_GT] = ACTIONS(1456),
    [anon_sym_DOT] = ACTIONS(1458),
    [anon_sym_DOT_STAR] = ACTIONS(1456),
    [anon_sym_DOT_QMARK] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [819] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_COLON] = ACTIONS(1460),
    [anon_sym_EQ] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_STAR_EQ] = ACTIONS(1460),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1460),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1460),
    [anon_sym_SLASH_EQ] = ACTIONS(1460),
    [anon_sym_PERCENT_EQ] = ACTIONS(1460),
    [anon_sym_PLUS_EQ] = ACTIONS(1460),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1460),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1460),
    [anon_sym_DASH_EQ] = ACTIONS(1460),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1460),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1460),
    [anon_sym_LT_LT_EQ] = ACTIONS(1460),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1460),
    [anon_sym_GT_GT_EQ] = ACTIONS(1460),
    [anon_sym_AMP_EQ] = ACTIONS(1460),
    [anon_sym_CARET_EQ] = ACTIONS(1460),
    [anon_sym_PIPE_EQ] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_DOT_DOT] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_align] = ACTIONS(1460),
    [anon_sym_addrspace] = ACTIONS(1460),
    [anon_sym_linksection] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_RBRACK] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_DASH_PERCENT] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_or] = ACTIONS(1462),
    [anon_sym_and] = ACTIONS(1460),
    [anon_sym_EQ_EQ] = ACTIONS(1460),
    [anon_sym_BANG_EQ] = ACTIONS(1460),
    [anon_sym_GT] = ACTIONS(1462),
    [anon_sym_GT_EQ] = ACTIONS(1460),
    [anon_sym_LT_EQ] = ACTIONS(1460),
    [anon_sym_LT] = ACTIONS(1462),
    [anon_sym_CARET] = ACTIONS(1462),
    [anon_sym_orelse] = ACTIONS(1460),
    [anon_sym_LT_LT] = ACTIONS(1462),
    [anon_sym_GT_GT] = ACTIONS(1462),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1462),
    [anon_sym_PLUS_PIPE] = ACTIONS(1462),
    [anon_sym_DASH_PIPE] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_PERCENT] = ACTIONS(1462),
    [anon_sym_STAR_STAR] = ACTIONS(1460),
    [anon_sym_STAR_PERCENT] = ACTIONS(1462),
    [anon_sym_STAR_PIPE] = ACTIONS(1462),
    [anon_sym_PIPE_PIPE] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_EQ_GT] = ACTIONS(1460),
    [anon_sym_DOT] = ACTIONS(1462),
    [anon_sym_DOT_STAR] = ACTIONS(1460),
    [anon_sym_DOT_QMARK] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
  },
  [820] = {
    [ts_builtin_sym_end] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_COLON] = ACTIONS(1464),
    [anon_sym_EQ] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_STAR_EQ] = ACTIONS(1464),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1464),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1464),
    [anon_sym_SLASH_EQ] = ACTIONS(1464),
    [anon_sym_PERCENT_EQ] = ACTIONS(1464),
    [anon_sym_PLUS_EQ] = ACTIONS(1464),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1464),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1464),
    [anon_sym_DASH_EQ] = ACTIONS(1464),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1464),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1464),
    [anon_sym_LT_LT_EQ] = ACTIONS(1464),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1464),
    [anon_sym_GT_GT_EQ] = ACTIONS(1464),
    [anon_sym_AMP_EQ] = ACTIONS(1464),
    [anon_sym_CARET_EQ] = ACTIONS(1464),
    [anon_sym_PIPE_EQ] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_DOT_DOT] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_align] = ACTIONS(1464),
    [anon_sym_addrspace] = ACTIONS(1464),
    [anon_sym_linksection] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_DASH_PERCENT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_or] = ACTIONS(1466),
    [anon_sym_and] = ACTIONS(1464),
    [anon_sym_EQ_EQ] = ACTIONS(1464),
    [anon_sym_BANG_EQ] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1466),
    [anon_sym_GT_EQ] = ACTIONS(1464),
    [anon_sym_LT_EQ] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1466),
    [anon_sym_CARET] = ACTIONS(1466),
    [anon_sym_orelse] = ACTIONS(1464),
    [anon_sym_LT_LT] = ACTIONS(1466),
    [anon_sym_GT_GT] = ACTIONS(1466),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1466),
    [anon_sym_PLUS_PIPE] = ACTIONS(1466),
    [anon_sym_DASH_PIPE] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1466),
    [anon_sym_PERCENT] = ACTIONS(1466),
    [anon_sym_STAR_STAR] = ACTIONS(1464),
    [anon_sym_STAR_PERCENT] = ACTIONS(1466),
    [anon_sym_STAR_PIPE] = ACTIONS(1466),
    [anon_sym_PIPE_PIPE] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(1466),
    [anon_sym_DOT_STAR] = ACTIONS(1464),
    [anon_sym_DOT_QMARK] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(917),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_align] = ACTIONS(917),
    [anon_sym_addrspace] = ACTIONS(917),
    [anon_sym_linksection] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_DASH_PERCENT] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(917),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_catch] = ACTIONS(917),
    [anon_sym_EQ_GT] = ACTIONS(917),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
  },
  [822] = {
    [ts_builtin_sym_end] = ACTIONS(1468),
    [anon_sym_COMMA] = ACTIONS(1468),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_STAR_EQ] = ACTIONS(1468),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1468),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1468),
    [anon_sym_SLASH_EQ] = ACTIONS(1468),
    [anon_sym_PERCENT_EQ] = ACTIONS(1468),
    [anon_sym_PLUS_EQ] = ACTIONS(1468),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1468),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1468),
    [anon_sym_DASH_EQ] = ACTIONS(1468),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1468),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1468),
    [anon_sym_LT_LT_EQ] = ACTIONS(1468),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1468),
    [anon_sym_GT_GT_EQ] = ACTIONS(1468),
    [anon_sym_AMP_EQ] = ACTIONS(1468),
    [anon_sym_CARET_EQ] = ACTIONS(1468),
    [anon_sym_PIPE_EQ] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_DOT_DOT] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_align] = ACTIONS(1468),
    [anon_sym_addrspace] = ACTIONS(1468),
    [anon_sym_linksection] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [anon_sym_RBRACK] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_DASH_PERCENT] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1470),
    [anon_sym_or] = ACTIONS(1470),
    [anon_sym_and] = ACTIONS(1468),
    [anon_sym_EQ_EQ] = ACTIONS(1468),
    [anon_sym_BANG_EQ] = ACTIONS(1468),
    [anon_sym_GT] = ACTIONS(1470),
    [anon_sym_GT_EQ] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1468),
    [anon_sym_LT] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [anon_sym_orelse] = ACTIONS(1468),
    [anon_sym_LT_LT] = ACTIONS(1470),
    [anon_sym_GT_GT] = ACTIONS(1470),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1470),
    [anon_sym_PLUS_PIPE] = ACTIONS(1470),
    [anon_sym_DASH_PIPE] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_PERCENT] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1468),
    [anon_sym_STAR_PERCENT] = ACTIONS(1470),
    [anon_sym_STAR_PIPE] = ACTIONS(1470),
    [anon_sym_PIPE_PIPE] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_EQ_GT] = ACTIONS(1468),
    [anon_sym_DOT] = ACTIONS(1470),
    [anon_sym_DOT_STAR] = ACTIONS(1468),
    [anon_sym_DOT_QMARK] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [823] = {
    [ts_builtin_sym_end] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_STAR_EQ] = ACTIONS(1472),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1472),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1472),
    [anon_sym_SLASH_EQ] = ACTIONS(1472),
    [anon_sym_PERCENT_EQ] = ACTIONS(1472),
    [anon_sym_PLUS_EQ] = ACTIONS(1472),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1472),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1472),
    [anon_sym_DASH_EQ] = ACTIONS(1472),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1472),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1472),
    [anon_sym_LT_LT_EQ] = ACTIONS(1472),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1472),
    [anon_sym_GT_GT_EQ] = ACTIONS(1472),
    [anon_sym_AMP_EQ] = ACTIONS(1472),
    [anon_sym_CARET_EQ] = ACTIONS(1472),
    [anon_sym_PIPE_EQ] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_DOT_DOT] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_align] = ACTIONS(1472),
    [anon_sym_addrspace] = ACTIONS(1472),
    [anon_sym_linksection] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_DASH_PERCENT] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_or] = ACTIONS(1474),
    [anon_sym_and] = ACTIONS(1472),
    [anon_sym_EQ_EQ] = ACTIONS(1472),
    [anon_sym_BANG_EQ] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1474),
    [anon_sym_GT_EQ] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1472),
    [anon_sym_LT] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [anon_sym_orelse] = ACTIONS(1472),
    [anon_sym_LT_LT] = ACTIONS(1474),
    [anon_sym_GT_GT] = ACTIONS(1474),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1474),
    [anon_sym_PLUS_PIPE] = ACTIONS(1474),
    [anon_sym_DASH_PIPE] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1472),
    [anon_sym_STAR_PERCENT] = ACTIONS(1474),
    [anon_sym_STAR_PIPE] = ACTIONS(1474),
    [anon_sym_PIPE_PIPE] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_EQ_GT] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_DOT_STAR] = ACTIONS(1472),
    [anon_sym_DOT_QMARK] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
  },
  [824] = {
    [ts_builtin_sym_end] = ACTIONS(1476),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_STAR_EQ] = ACTIONS(1476),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1476),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1476),
    [anon_sym_SLASH_EQ] = ACTIONS(1476),
    [anon_sym_PERCENT_EQ] = ACTIONS(1476),
    [anon_sym_PLUS_EQ] = ACTIONS(1476),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1476),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1476),
    [anon_sym_DASH_EQ] = ACTIONS(1476),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1476),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1476),
    [anon_sym_LT_LT_EQ] = ACTIONS(1476),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1476),
    [anon_sym_GT_GT_EQ] = ACTIONS(1476),
    [anon_sym_AMP_EQ] = ACTIONS(1476),
    [anon_sym_CARET_EQ] = ACTIONS(1476),
    [anon_sym_PIPE_EQ] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_DOT_DOT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_align] = ACTIONS(1476),
    [anon_sym_addrspace] = ACTIONS(1476),
    [anon_sym_linksection] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_RBRACK] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_DASH_PERCENT] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1478),
    [anon_sym_or] = ACTIONS(1478),
    [anon_sym_and] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_BANG_EQ] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1478),
    [anon_sym_GT_EQ] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [anon_sym_orelse] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(1478),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1478),
    [anon_sym_PLUS_PIPE] = ACTIONS(1478),
    [anon_sym_DASH_PIPE] = ACTIONS(1478),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_PERCENT] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1476),
    [anon_sym_STAR_PERCENT] = ACTIONS(1478),
    [anon_sym_STAR_PIPE] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_EQ_GT] = ACTIONS(1476),
    [anon_sym_DOT] = ACTIONS(1478),
    [anon_sym_DOT_STAR] = ACTIONS(1476),
    [anon_sym_DOT_QMARK] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [825] = {
    [ts_builtin_sym_end] = ACTIONS(1480),
    [anon_sym_COMMA] = ACTIONS(1480),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym_STAR_EQ] = ACTIONS(1480),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_SLASH_EQ] = ACTIONS(1480),
    [anon_sym_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_DASH_EQ] = ACTIONS(1480),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1480),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_EQ] = ACTIONS(1480),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_GT_GT_EQ] = ACTIONS(1480),
    [anon_sym_AMP_EQ] = ACTIONS(1480),
    [anon_sym_CARET_EQ] = ACTIONS(1480),
    [anon_sym_PIPE_EQ] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [anon_sym_RPAREN] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_DOT_DOT] = ACTIONS(1480),
    [anon_sym_PIPE] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_align] = ACTIONS(1480),
    [anon_sym_addrspace] = ACTIONS(1480),
    [anon_sym_linksection] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_RBRACK] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_DASH_PERCENT] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_or] = ACTIONS(1482),
    [anon_sym_and] = ACTIONS(1480),
    [anon_sym_EQ_EQ] = ACTIONS(1480),
    [anon_sym_BANG_EQ] = ACTIONS(1480),
    [anon_sym_GT] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1480),
    [anon_sym_LT] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [anon_sym_orelse] = ACTIONS(1480),
    [anon_sym_LT_LT] = ACTIONS(1482),
    [anon_sym_GT_GT] = ACTIONS(1482),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1482),
    [anon_sym_PLUS_PIPE] = ACTIONS(1482),
    [anon_sym_DASH_PIPE] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_PERCENT] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1480),
    [anon_sym_STAR_PERCENT] = ACTIONS(1482),
    [anon_sym_STAR_PIPE] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_EQ_GT] = ACTIONS(1480),
    [anon_sym_DOT] = ACTIONS(1482),
    [anon_sym_DOT_STAR] = ACTIONS(1480),
    [anon_sym_DOT_QMARK] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(925),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_STAR_EQ] = ACTIONS(925),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(925),
    [anon_sym_SLASH_EQ] = ACTIONS(925),
    [anon_sym_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(925),
    [anon_sym_DASH_EQ] = ACTIONS(925),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(925),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_EQ] = ACTIONS(925),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(925),
    [anon_sym_GT_GT_EQ] = ACTIONS(925),
    [anon_sym_AMP_EQ] = ACTIONS(925),
    [anon_sym_CARET_EQ] = ACTIONS(925),
    [anon_sym_PIPE_EQ] = ACTIONS(925),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_else] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(927),
    [anon_sym_STAR] = ACTIONS(927),
    [anon_sym_align] = ACTIONS(925),
    [anon_sym_addrspace] = ACTIONS(925),
    [anon_sym_linksection] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(925),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_PERCENT] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(925),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_catch] = ACTIONS(925),
    [anon_sym_EQ_GT] = ACTIONS(925),
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_DOT_STAR] = ACTIONS(925),
    [anon_sym_DOT_QMARK] = ACTIONS(925),
    [sym_comment] = ACTIONS(3),
  },
  [827] = {
    [ts_builtin_sym_end] = ACTIONS(1484),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_STAR_EQ] = ACTIONS(1484),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1484),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1484),
    [anon_sym_SLASH_EQ] = ACTIONS(1484),
    [anon_sym_PERCENT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1484),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1484),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1484),
    [anon_sym_LT_LT_EQ] = ACTIONS(1484),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1484),
    [anon_sym_GT_GT_EQ] = ACTIONS(1484),
    [anon_sym_AMP_EQ] = ACTIONS(1484),
    [anon_sym_CARET_EQ] = ACTIONS(1484),
    [anon_sym_PIPE_EQ] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_RPAREN] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_DOT_DOT] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_align] = ACTIONS(1484),
    [anon_sym_addrspace] = ACTIONS(1484),
    [anon_sym_linksection] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1484),
    [anon_sym_RBRACK] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_PERCENT] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_or] = ACTIONS(1486),
    [anon_sym_and] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [anon_sym_orelse] = ACTIONS(1484),
    [anon_sym_LT_LT] = ACTIONS(1486),
    [anon_sym_GT_GT] = ACTIONS(1486),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1486),
    [anon_sym_PLUS_PIPE] = ACTIONS(1486),
    [anon_sym_DASH_PIPE] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_PERCENT] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1484),
    [anon_sym_STAR_PERCENT] = ACTIONS(1486),
    [anon_sym_STAR_PIPE] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_EQ_GT] = ACTIONS(1484),
    [anon_sym_DOT] = ACTIONS(1486),
    [anon_sym_DOT_STAR] = ACTIONS(1484),
    [anon_sym_DOT_QMARK] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [828] = {
    [ts_builtin_sym_end] = ACTIONS(1488),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_COLON] = ACTIONS(1391),
    [anon_sym_EQ] = ACTIONS(1491),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_STAR_EQ] = ACTIONS(1488),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1488),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1488),
    [anon_sym_SLASH_EQ] = ACTIONS(1488),
    [anon_sym_PERCENT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1488),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1488),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1488),
    [anon_sym_LT_LT_EQ] = ACTIONS(1488),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1488),
    [anon_sym_GT_GT_EQ] = ACTIONS(1488),
    [anon_sym_AMP_EQ] = ACTIONS(1488),
    [anon_sym_CARET_EQ] = ACTIONS(1488),
    [anon_sym_PIPE_EQ] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_DOT_DOT] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1491),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_align] = ACTIONS(1488),
    [anon_sym_addrspace] = ACTIONS(1488),
    [anon_sym_linksection] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_RBRACK] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1491),
    [anon_sym_DASH_PERCENT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_or] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1488),
    [anon_sym_EQ_EQ] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_LT] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_orelse] = ACTIONS(1488),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1491),
    [anon_sym_PLUS_PIPE] = ACTIONS(1491),
    [anon_sym_DASH_PIPE] = ACTIONS(1491),
    [anon_sym_SLASH] = ACTIONS(1491),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1488),
    [anon_sym_STAR_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_PIPE] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_EQ_GT] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1491),
    [anon_sym_DOT_STAR] = ACTIONS(1488),
    [anon_sym_DOT_QMARK] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [829] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1494),
    [anon_sym_EQ] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym_STAR_EQ] = ACTIONS(1494),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1494),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1494),
    [anon_sym_SLASH_EQ] = ACTIONS(1494),
    [anon_sym_PERCENT_EQ] = ACTIONS(1494),
    [anon_sym_PLUS_EQ] = ACTIONS(1494),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1494),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1494),
    [anon_sym_DASH_EQ] = ACTIONS(1494),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1494),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1494),
    [anon_sym_LT_LT_EQ] = ACTIONS(1494),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1494),
    [anon_sym_GT_GT_EQ] = ACTIONS(1494),
    [anon_sym_AMP_EQ] = ACTIONS(1494),
    [anon_sym_CARET_EQ] = ACTIONS(1494),
    [anon_sym_PIPE_EQ] = ACTIONS(1494),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_else] = ACTIONS(1494),
    [anon_sym_DOT_DOT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_align] = ACTIONS(1494),
    [anon_sym_addrspace] = ACTIONS(1494),
    [anon_sym_linksection] = ACTIONS(1494),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_RBRACK] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_DASH_PERCENT] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_or] = ACTIONS(1496),
    [anon_sym_and] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1496),
    [anon_sym_orelse] = ACTIONS(1494),
    [anon_sym_LT_LT] = ACTIONS(1496),
    [anon_sym_GT_GT] = ACTIONS(1496),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1496),
    [anon_sym_PLUS_PIPE] = ACTIONS(1496),
    [anon_sym_DASH_PIPE] = ACTIONS(1496),
    [anon_sym_SLASH] = ACTIONS(1496),
    [anon_sym_PERCENT] = ACTIONS(1496),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_STAR_PERCENT] = ACTIONS(1496),
    [anon_sym_STAR_PIPE] = ACTIONS(1496),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_catch] = ACTIONS(1494),
    [anon_sym_EQ_GT] = ACTIONS(1494),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_DOT_STAR] = ACTIONS(1494),
    [anon_sym_DOT_QMARK] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [830] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [anon_sym_COMMA] = ACTIONS(1498),
    [anon_sym_COLON] = ACTIONS(1498),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_STAR_EQ] = ACTIONS(1498),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1498),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1498),
    [anon_sym_SLASH_EQ] = ACTIONS(1498),
    [anon_sym_PERCENT_EQ] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(1498),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1498),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1498),
    [anon_sym_DASH_EQ] = ACTIONS(1498),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1498),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1498),
    [anon_sym_LT_LT_EQ] = ACTIONS(1498),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1498),
    [anon_sym_GT_GT_EQ] = ACTIONS(1498),
    [anon_sym_AMP_EQ] = ACTIONS(1498),
    [anon_sym_CARET_EQ] = ACTIONS(1498),
    [anon_sym_PIPE_EQ] = ACTIONS(1498),
    [anon_sym_LPAREN] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [anon_sym_else] = ACTIONS(1498),
    [anon_sym_DOT_DOT] = ACTIONS(1498),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_align] = ACTIONS(1498),
    [anon_sym_addrspace] = ACTIONS(1498),
    [anon_sym_linksection] = ACTIONS(1498),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_DASH_PERCENT] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_or] = ACTIONS(1500),
    [anon_sym_and] = ACTIONS(1498),
    [anon_sym_EQ_EQ] = ACTIONS(1498),
    [anon_sym_BANG_EQ] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1498),
    [anon_sym_LT_EQ] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_CARET] = ACTIONS(1500),
    [anon_sym_orelse] = ACTIONS(1498),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1500),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1500),
    [anon_sym_PLUS_PIPE] = ACTIONS(1500),
    [anon_sym_DASH_PIPE] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1500),
    [anon_sym_PERCENT] = ACTIONS(1500),
    [anon_sym_STAR_STAR] = ACTIONS(1498),
    [anon_sym_STAR_PERCENT] = ACTIONS(1500),
    [anon_sym_STAR_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1498),
    [anon_sym_catch] = ACTIONS(1498),
    [anon_sym_EQ_GT] = ACTIONS(1498),
    [anon_sym_DOT] = ACTIONS(1500),
    [anon_sym_DOT_STAR] = ACTIONS(1498),
    [anon_sym_DOT_QMARK] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1502),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym_STAR_EQ] = ACTIONS(1502),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1502),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1502),
    [anon_sym_SLASH_EQ] = ACTIONS(1502),
    [anon_sym_PERCENT_EQ] = ACTIONS(1502),
    [anon_sym_PLUS_EQ] = ACTIONS(1502),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1502),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1502),
    [anon_sym_DASH_EQ] = ACTIONS(1502),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1502),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1502),
    [anon_sym_LT_LT_EQ] = ACTIONS(1502),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1502),
    [anon_sym_GT_GT_EQ] = ACTIONS(1502),
    [anon_sym_AMP_EQ] = ACTIONS(1502),
    [anon_sym_CARET_EQ] = ACTIONS(1502),
    [anon_sym_PIPE_EQ] = ACTIONS(1502),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [anon_sym_else] = ACTIONS(1502),
    [anon_sym_DOT_DOT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_align] = ACTIONS(1502),
    [anon_sym_addrspace] = ACTIONS(1502),
    [anon_sym_linksection] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_RBRACK] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_DASH_PERCENT] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_or] = ACTIONS(1504),
    [anon_sym_and] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_CARET] = ACTIONS(1504),
    [anon_sym_orelse] = ACTIONS(1502),
    [anon_sym_LT_LT] = ACTIONS(1504),
    [anon_sym_GT_GT] = ACTIONS(1504),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1504),
    [anon_sym_PLUS_PIPE] = ACTIONS(1504),
    [anon_sym_DASH_PIPE] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1504),
    [anon_sym_PERCENT] = ACTIONS(1504),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_STAR_PERCENT] = ACTIONS(1504),
    [anon_sym_STAR_PIPE] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_catch] = ACTIONS(1502),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_DOT] = ACTIONS(1504),
    [anon_sym_DOT_STAR] = ACTIONS(1502),
    [anon_sym_DOT_QMARK] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [832] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [anon_sym_COMMA] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1506),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1506),
    [anon_sym_STAR_EQ] = ACTIONS(1506),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1506),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1506),
    [anon_sym_SLASH_EQ] = ACTIONS(1506),
    [anon_sym_PERCENT_EQ] = ACTIONS(1506),
    [anon_sym_PLUS_EQ] = ACTIONS(1506),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1506),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1506),
    [anon_sym_DASH_EQ] = ACTIONS(1506),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1506),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1506),
    [anon_sym_LT_LT_EQ] = ACTIONS(1506),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1506),
    [anon_sym_GT_GT_EQ] = ACTIONS(1506),
    [anon_sym_AMP_EQ] = ACTIONS(1506),
    [anon_sym_CARET_EQ] = ACTIONS(1506),
    [anon_sym_PIPE_EQ] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_DOT_DOT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_align] = ACTIONS(1506),
    [anon_sym_addrspace] = ACTIONS(1506),
    [anon_sym_linksection] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_DASH_PERCENT] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_or] = ACTIONS(1508),
    [anon_sym_and] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_CARET] = ACTIONS(1508),
    [anon_sym_orelse] = ACTIONS(1506),
    [anon_sym_LT_LT] = ACTIONS(1508),
    [anon_sym_GT_GT] = ACTIONS(1508),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1508),
    [anon_sym_PLUS_PIPE] = ACTIONS(1508),
    [anon_sym_DASH_PIPE] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1508),
    [anon_sym_PERCENT] = ACTIONS(1508),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_STAR_PERCENT] = ACTIONS(1508),
    [anon_sym_STAR_PIPE] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_catch] = ACTIONS(1506),
    [anon_sym_EQ_GT] = ACTIONS(1506),
    [anon_sym_DOT] = ACTIONS(1508),
    [anon_sym_DOT_STAR] = ACTIONS(1506),
    [anon_sym_DOT_QMARK] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [833] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_STAR_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_SLASH_EQ] = ACTIONS(1290),
    [anon_sym_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_DASH_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1290),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_GT_GT_EQ] = ACTIONS(1290),
    [anon_sym_AMP_EQ] = ACTIONS(1290),
    [anon_sym_CARET_EQ] = ACTIONS(1290),
    [anon_sym_PIPE_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_else] = ACTIONS(1290),
    [anon_sym_DOT_DOT] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_align] = ACTIONS(1290),
    [anon_sym_addrspace] = ACTIONS(1290),
    [anon_sym_linksection] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_DASH_PERCENT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_or] = ACTIONS(1292),
    [anon_sym_and] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1292),
    [anon_sym_orelse] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1292),
    [anon_sym_PLUS_PIPE] = ACTIONS(1292),
    [anon_sym_DASH_PIPE] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_STAR_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_PIPE] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_catch] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1292),
    [anon_sym_DOT_STAR] = ACTIONS(1290),
    [anon_sym_DOT_QMARK] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
  },
  [834] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1512),
    [anon_sym_SEMI] = ACTIONS(1510),
    [anon_sym_STAR_EQ] = ACTIONS(1510),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1510),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1510),
    [anon_sym_SLASH_EQ] = ACTIONS(1510),
    [anon_sym_PERCENT_EQ] = ACTIONS(1510),
    [anon_sym_PLUS_EQ] = ACTIONS(1510),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1510),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1510),
    [anon_sym_DASH_EQ] = ACTIONS(1510),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1510),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1510),
    [anon_sym_LT_LT_EQ] = ACTIONS(1510),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1510),
    [anon_sym_GT_GT_EQ] = ACTIONS(1510),
    [anon_sym_AMP_EQ] = ACTIONS(1510),
    [anon_sym_CARET_EQ] = ACTIONS(1510),
    [anon_sym_PIPE_EQ] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_else] = ACTIONS(1510),
    [anon_sym_DOT_DOT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_align] = ACTIONS(1510),
    [anon_sym_addrspace] = ACTIONS(1510),
    [anon_sym_linksection] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_DASH_PERCENT] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_or] = ACTIONS(1512),
    [anon_sym_and] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_CARET] = ACTIONS(1512),
    [anon_sym_orelse] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1512),
    [anon_sym_GT_GT] = ACTIONS(1512),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1512),
    [anon_sym_PLUS_PIPE] = ACTIONS(1512),
    [anon_sym_DASH_PIPE] = ACTIONS(1512),
    [anon_sym_SLASH] = ACTIONS(1512),
    [anon_sym_PERCENT] = ACTIONS(1512),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_STAR_PERCENT] = ACTIONS(1512),
    [anon_sym_STAR_PIPE] = ACTIONS(1512),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_catch] = ACTIONS(1510),
    [anon_sym_EQ_GT] = ACTIONS(1510),
    [anon_sym_DOT] = ACTIONS(1512),
    [anon_sym_DOT_STAR] = ACTIONS(1510),
    [anon_sym_DOT_QMARK] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [835] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [anon_sym_COMMA] = ACTIONS(1514),
    [anon_sym_COLON] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1514),
    [anon_sym_STAR_EQ] = ACTIONS(1514),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1514),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1514),
    [anon_sym_SLASH_EQ] = ACTIONS(1514),
    [anon_sym_PERCENT_EQ] = ACTIONS(1514),
    [anon_sym_PLUS_EQ] = ACTIONS(1514),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1514),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1514),
    [anon_sym_DASH_EQ] = ACTIONS(1514),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1514),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1514),
    [anon_sym_LT_LT_EQ] = ACTIONS(1514),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1514),
    [anon_sym_GT_GT_EQ] = ACTIONS(1514),
    [anon_sym_AMP_EQ] = ACTIONS(1514),
    [anon_sym_CARET_EQ] = ACTIONS(1514),
    [anon_sym_PIPE_EQ] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [anon_sym_RPAREN] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_else] = ACTIONS(1514),
    [anon_sym_DOT_DOT] = ACTIONS(1514),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_align] = ACTIONS(1514),
    [anon_sym_addrspace] = ACTIONS(1514),
    [anon_sym_linksection] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_DASH_PERCENT] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_or] = ACTIONS(1516),
    [anon_sym_and] = ACTIONS(1514),
    [anon_sym_EQ_EQ] = ACTIONS(1514),
    [anon_sym_BANG_EQ] = ACTIONS(1514),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_GT_EQ] = ACTIONS(1514),
    [anon_sym_LT_EQ] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_CARET] = ACTIONS(1516),
    [anon_sym_orelse] = ACTIONS(1514),
    [anon_sym_LT_LT] = ACTIONS(1516),
    [anon_sym_GT_GT] = ACTIONS(1516),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1516),
    [anon_sym_PLUS_PIPE] = ACTIONS(1516),
    [anon_sym_DASH_PIPE] = ACTIONS(1516),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_PERCENT] = ACTIONS(1516),
    [anon_sym_STAR_STAR] = ACTIONS(1514),
    [anon_sym_STAR_PERCENT] = ACTIONS(1516),
    [anon_sym_STAR_PIPE] = ACTIONS(1516),
    [anon_sym_PIPE_PIPE] = ACTIONS(1514),
    [anon_sym_catch] = ACTIONS(1514),
    [anon_sym_EQ_GT] = ACTIONS(1514),
    [anon_sym_DOT] = ACTIONS(1516),
    [anon_sym_DOT_STAR] = ACTIONS(1514),
    [anon_sym_DOT_QMARK] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [anon_sym_COMMA] = ACTIONS(1518),
    [anon_sym_COLON] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1518),
    [anon_sym_STAR_EQ] = ACTIONS(1518),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1518),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1518),
    [anon_sym_SLASH_EQ] = ACTIONS(1518),
    [anon_sym_PERCENT_EQ] = ACTIONS(1518),
    [anon_sym_PLUS_EQ] = ACTIONS(1518),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1518),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1518),
    [anon_sym_DASH_EQ] = ACTIONS(1518),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1518),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1518),
    [anon_sym_LT_LT_EQ] = ACTIONS(1518),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1518),
    [anon_sym_GT_GT_EQ] = ACTIONS(1518),
    [anon_sym_AMP_EQ] = ACTIONS(1518),
    [anon_sym_CARET_EQ] = ACTIONS(1518),
    [anon_sym_PIPE_EQ] = ACTIONS(1518),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [anon_sym_else] = ACTIONS(1518),
    [anon_sym_DOT_DOT] = ACTIONS(1518),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_align] = ACTIONS(1518),
    [anon_sym_addrspace] = ACTIONS(1518),
    [anon_sym_linksection] = ACTIONS(1518),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_RBRACK] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_DASH_PERCENT] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_or] = ACTIONS(1520),
    [anon_sym_and] = ACTIONS(1518),
    [anon_sym_EQ_EQ] = ACTIONS(1518),
    [anon_sym_BANG_EQ] = ACTIONS(1518),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1518),
    [anon_sym_LT_EQ] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1520),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_orelse] = ACTIONS(1518),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_GT_GT] = ACTIONS(1520),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1520),
    [anon_sym_PLUS_PIPE] = ACTIONS(1520),
    [anon_sym_DASH_PIPE] = ACTIONS(1520),
    [anon_sym_SLASH] = ACTIONS(1520),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1518),
    [anon_sym_STAR_PERCENT] = ACTIONS(1520),
    [anon_sym_STAR_PIPE] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1518),
    [anon_sym_catch] = ACTIONS(1518),
    [anon_sym_EQ_GT] = ACTIONS(1518),
    [anon_sym_DOT] = ACTIONS(1520),
    [anon_sym_DOT_STAR] = ACTIONS(1518),
    [anon_sym_DOT_QMARK] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [837] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_STAR_EQ] = ACTIONS(1522),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1522),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1522),
    [anon_sym_SLASH_EQ] = ACTIONS(1522),
    [anon_sym_PERCENT_EQ] = ACTIONS(1522),
    [anon_sym_PLUS_EQ] = ACTIONS(1522),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1522),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1522),
    [anon_sym_DASH_EQ] = ACTIONS(1522),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1522),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1522),
    [anon_sym_LT_LT_EQ] = ACTIONS(1522),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1522),
    [anon_sym_GT_GT_EQ] = ACTIONS(1522),
    [anon_sym_AMP_EQ] = ACTIONS(1522),
    [anon_sym_CARET_EQ] = ACTIONS(1522),
    [anon_sym_PIPE_EQ] = ACTIONS(1522),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_else] = ACTIONS(1522),
    [anon_sym_DOT_DOT] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_align] = ACTIONS(1522),
    [anon_sym_addrspace] = ACTIONS(1522),
    [anon_sym_linksection] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_DASH_PERCENT] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_or] = ACTIONS(1524),
    [anon_sym_and] = ACTIONS(1522),
    [anon_sym_EQ_EQ] = ACTIONS(1522),
    [anon_sym_BANG_EQ] = ACTIONS(1522),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_EQ] = ACTIONS(1522),
    [anon_sym_LT_EQ] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1524),
    [anon_sym_orelse] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(1524),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1524),
    [anon_sym_PLUS_PIPE] = ACTIONS(1524),
    [anon_sym_DASH_PIPE] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1524),
    [anon_sym_STAR_STAR] = ACTIONS(1522),
    [anon_sym_STAR_PERCENT] = ACTIONS(1524),
    [anon_sym_STAR_PIPE] = ACTIONS(1524),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_catch] = ACTIONS(1522),
    [anon_sym_EQ_GT] = ACTIONS(1522),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_DOT_STAR] = ACTIONS(1522),
    [anon_sym_DOT_QMARK] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [838] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(1526),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(941),
    [anon_sym_linksection] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_DASH_PERCENT] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_catch] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(941),
    [anon_sym_DOT_QMARK] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
  },
  [839] = {
    [ts_builtin_sym_end] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [anon_sym_COLON] = ACTIONS(1528),
    [anon_sym_EQ] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym_STAR_EQ] = ACTIONS(1528),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1528),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1528),
    [anon_sym_SLASH_EQ] = ACTIONS(1528),
    [anon_sym_PERCENT_EQ] = ACTIONS(1528),
    [anon_sym_PLUS_EQ] = ACTIONS(1528),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1528),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1528),
    [anon_sym_DASH_EQ] = ACTIONS(1528),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1528),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1528),
    [anon_sym_LT_LT_EQ] = ACTIONS(1528),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1528),
    [anon_sym_GT_GT_EQ] = ACTIONS(1528),
    [anon_sym_AMP_EQ] = ACTIONS(1528),
    [anon_sym_CARET_EQ] = ACTIONS(1528),
    [anon_sym_PIPE_EQ] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_RPAREN] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_else] = ACTIONS(1528),
    [anon_sym_DOT_DOT] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_align] = ACTIONS(1528),
    [anon_sym_addrspace] = ACTIONS(1528),
    [anon_sym_linksection] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_DASH_PERCENT] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1530),
    [anon_sym_or] = ACTIONS(1530),
    [anon_sym_and] = ACTIONS(1528),
    [anon_sym_EQ_EQ] = ACTIONS(1528),
    [anon_sym_BANG_EQ] = ACTIONS(1528),
    [anon_sym_GT] = ACTIONS(1530),
    [anon_sym_GT_EQ] = ACTIONS(1528),
    [anon_sym_LT_EQ] = ACTIONS(1528),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_orelse] = ACTIONS(1528),
    [anon_sym_LT_LT] = ACTIONS(1530),
    [anon_sym_GT_GT] = ACTIONS(1530),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1530),
    [anon_sym_PLUS_PIPE] = ACTIONS(1530),
    [anon_sym_DASH_PIPE] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym_PERCENT] = ACTIONS(1530),
    [anon_sym_STAR_STAR] = ACTIONS(1528),
    [anon_sym_STAR_PERCENT] = ACTIONS(1530),
    [anon_sym_STAR_PIPE] = ACTIONS(1530),
    [anon_sym_PIPE_PIPE] = ACTIONS(1528),
    [anon_sym_catch] = ACTIONS(1528),
    [anon_sym_EQ_GT] = ACTIONS(1528),
    [anon_sym_DOT] = ACTIONS(1530),
    [anon_sym_DOT_STAR] = ACTIONS(1528),
    [anon_sym_DOT_QMARK] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
  },
  [840] = {
    [ts_builtin_sym_end] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_STAR_EQ] = ACTIONS(1532),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1532),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1532),
    [anon_sym_SLASH_EQ] = ACTIONS(1532),
    [anon_sym_PERCENT_EQ] = ACTIONS(1532),
    [anon_sym_PLUS_EQ] = ACTIONS(1532),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1532),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1532),
    [anon_sym_DASH_EQ] = ACTIONS(1532),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1532),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1532),
    [anon_sym_LT_LT_EQ] = ACTIONS(1532),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1532),
    [anon_sym_GT_GT_EQ] = ACTIONS(1532),
    [anon_sym_AMP_EQ] = ACTIONS(1532),
    [anon_sym_CARET_EQ] = ACTIONS(1532),
    [anon_sym_PIPE_EQ] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOT_DOT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_align] = ACTIONS(1532),
    [anon_sym_addrspace] = ACTIONS(1532),
    [anon_sym_linksection] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_DASH_PERCENT] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_or] = ACTIONS(1534),
    [anon_sym_and] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1532),
    [anon_sym_LT_EQ] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1534),
    [anon_sym_CARET] = ACTIONS(1534),
    [anon_sym_orelse] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1534),
    [anon_sym_PLUS_PIPE] = ACTIONS(1534),
    [anon_sym_DASH_PIPE] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1534),
    [anon_sym_STAR_STAR] = ACTIONS(1532),
    [anon_sym_STAR_PERCENT] = ACTIONS(1534),
    [anon_sym_STAR_PIPE] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_catch] = ACTIONS(1532),
    [anon_sym_EQ_GT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_DOT_STAR] = ACTIONS(1532),
    [anon_sym_DOT_QMARK] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [841] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(941),
    [anon_sym_linksection] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_DASH_PERCENT] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_catch] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(941),
    [anon_sym_DOT_QMARK] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
  },
  [842] = {
    [ts_builtin_sym_end] = ACTIONS(1538),
    [anon_sym_COMMA] = ACTIONS(1538),
    [anon_sym_COLON] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1538),
    [anon_sym_STAR_EQ] = ACTIONS(1538),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1538),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1538),
    [anon_sym_SLASH_EQ] = ACTIONS(1538),
    [anon_sym_PERCENT_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1538),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1538),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1538),
    [anon_sym_LT_LT_EQ] = ACTIONS(1538),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1538),
    [anon_sym_GT_GT_EQ] = ACTIONS(1538),
    [anon_sym_AMP_EQ] = ACTIONS(1538),
    [anon_sym_CARET_EQ] = ACTIONS(1538),
    [anon_sym_PIPE_EQ] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_else] = ACTIONS(1538),
    [anon_sym_DOT_DOT] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_align] = ACTIONS(1538),
    [anon_sym_addrspace] = ACTIONS(1538),
    [anon_sym_linksection] = ACTIONS(1538),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_PERCENT] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_or] = ACTIONS(1540),
    [anon_sym_and] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_EQ] = ACTIONS(1538),
    [anon_sym_LT_EQ] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_orelse] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1538),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1540),
    [anon_sym_PLUS_PIPE] = ACTIONS(1540),
    [anon_sym_DASH_PIPE] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_STAR_STAR] = ACTIONS(1538),
    [anon_sym_STAR_PERCENT] = ACTIONS(1540),
    [anon_sym_STAR_PIPE] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_catch] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1538),
    [anon_sym_DOT] = ACTIONS(1540),
    [anon_sym_DOT_STAR] = ACTIONS(1538),
    [anon_sym_DOT_QMARK] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
  },
  [843] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_STAR_EQ] = ACTIONS(1542),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1542),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1542),
    [anon_sym_SLASH_EQ] = ACTIONS(1542),
    [anon_sym_PERCENT_EQ] = ACTIONS(1542),
    [anon_sym_PLUS_EQ] = ACTIONS(1542),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1542),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1542),
    [anon_sym_DASH_EQ] = ACTIONS(1542),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1542),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1542),
    [anon_sym_LT_LT_EQ] = ACTIONS(1542),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1542),
    [anon_sym_GT_GT_EQ] = ACTIONS(1542),
    [anon_sym_AMP_EQ] = ACTIONS(1542),
    [anon_sym_CARET_EQ] = ACTIONS(1542),
    [anon_sym_PIPE_EQ] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOT_DOT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_align] = ACTIONS(1542),
    [anon_sym_addrspace] = ACTIONS(1542),
    [anon_sym_linksection] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_DASH_PERCENT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_or] = ACTIONS(1544),
    [anon_sym_and] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1544),
    [anon_sym_orelse] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1544),
    [anon_sym_PLUS_PIPE] = ACTIONS(1544),
    [anon_sym_DASH_PIPE] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_STAR_PERCENT] = ACTIONS(1544),
    [anon_sym_STAR_PIPE] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_catch] = ACTIONS(1542),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_DOT_STAR] = ACTIONS(1542),
    [anon_sym_DOT_QMARK] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
  },
  [844] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(941),
    [anon_sym_linksection] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_DASH_PERCENT] = ACTIONS(943),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_catch] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(941),
    [anon_sym_DOT_QMARK] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
  },
  [845] = {
    [ts_builtin_sym_end] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_COLON] = ACTIONS(1548),
    [anon_sym_EQ] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_STAR_EQ] = ACTIONS(1548),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_SLASH_EQ] = ACTIONS(1548),
    [anon_sym_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_PLUS_EQ] = ACTIONS(1548),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_DASH_EQ] = ACTIONS(1548),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1548),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_EQ] = ACTIONS(1548),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_GT_GT_EQ] = ACTIONS(1548),
    [anon_sym_AMP_EQ] = ACTIONS(1548),
    [anon_sym_CARET_EQ] = ACTIONS(1548),
    [anon_sym_PIPE_EQ] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_else] = ACTIONS(1548),
    [anon_sym_DOT_DOT] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_STAR] = ACTIONS(1550),
    [anon_sym_align] = ACTIONS(1548),
    [anon_sym_addrspace] = ACTIONS(1548),
    [anon_sym_linksection] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_BANG] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_DASH_PERCENT] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_or] = ACTIONS(1550),
    [anon_sym_and] = ACTIONS(1548),
    [anon_sym_EQ_EQ] = ACTIONS(1548),
    [anon_sym_BANG_EQ] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_GT_EQ] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1550),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_orelse] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1550),
    [anon_sym_PLUS_PIPE] = ACTIONS(1550),
    [anon_sym_DASH_PIPE] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1550),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_STAR_STAR] = ACTIONS(1548),
    [anon_sym_STAR_PERCENT] = ACTIONS(1550),
    [anon_sym_STAR_PIPE] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1548),
    [anon_sym_catch] = ACTIONS(1548),
    [anon_sym_EQ_GT] = ACTIONS(1548),
    [anon_sym_DOT] = ACTIONS(1550),
    [anon_sym_DOT_STAR] = ACTIONS(1548),
    [anon_sym_DOT_QMARK] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
  },
  [846] = {
    [ts_builtin_sym_end] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1552),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_EQ] = ACTIONS(1554),
    [anon_sym_SEMI] = ACTIONS(1552),
    [anon_sym_STAR_EQ] = ACTIONS(1552),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1552),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1552),
    [anon_sym_SLASH_EQ] = ACTIONS(1552),
    [anon_sym_PERCENT_EQ] = ACTIONS(1552),
    [anon_sym_PLUS_EQ] = ACTIONS(1552),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1552),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1552),
    [anon_sym_DASH_EQ] = ACTIONS(1552),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1552),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1552),
    [anon_sym_LT_LT_EQ] = ACTIONS(1552),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1552),
    [anon_sym_GT_GT_EQ] = ACTIONS(1552),
    [anon_sym_AMP_EQ] = ACTIONS(1552),
    [anon_sym_CARET_EQ] = ACTIONS(1552),
    [anon_sym_PIPE_EQ] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_RPAREN] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1552),
    [anon_sym_else] = ACTIONS(1552),
    [anon_sym_DOT_DOT] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1554),
    [anon_sym_STAR] = ACTIONS(1554),
    [anon_sym_align] = ACTIONS(1552),
    [anon_sym_addrspace] = ACTIONS(1552),
    [anon_sym_linksection] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_DASH_PERCENT] = ACTIONS(1554),
    [anon_sym_AMP] = ACTIONS(1554),
    [anon_sym_or] = ACTIONS(1554),
    [anon_sym_and] = ACTIONS(1552),
    [anon_sym_EQ_EQ] = ACTIONS(1552),
    [anon_sym_BANG_EQ] = ACTIONS(1552),
    [anon_sym_GT] = ACTIONS(1554),
    [anon_sym_GT_EQ] = ACTIONS(1552),
    [anon_sym_LT_EQ] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_CARET] = ACTIONS(1554),
    [anon_sym_orelse] = ACTIONS(1552),
    [anon_sym_LT_LT] = ACTIONS(1554),
    [anon_sym_GT_GT] = ACTIONS(1554),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1554),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1554),
    [anon_sym_PLUS_PIPE] = ACTIONS(1554),
    [anon_sym_DASH_PIPE] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1554),
    [anon_sym_PERCENT] = ACTIONS(1554),
    [anon_sym_STAR_STAR] = ACTIONS(1552),
    [anon_sym_STAR_PERCENT] = ACTIONS(1554),
    [anon_sym_STAR_PIPE] = ACTIONS(1554),
    [anon_sym_PIPE_PIPE] = ACTIONS(1552),
    [anon_sym_catch] = ACTIONS(1552),
    [anon_sym_EQ_GT] = ACTIONS(1552),
    [anon_sym_DOT] = ACTIONS(1554),
    [anon_sym_DOT_STAR] = ACTIONS(1552),
    [anon_sym_DOT_QMARK] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
  },
  [847] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_COLON] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1556),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_SLASH_EQ] = ACTIONS(1556),
    [anon_sym_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_DASH_EQ] = ACTIONS(1556),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1556),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_EQ] = ACTIONS(1556),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_GT_GT_EQ] = ACTIONS(1556),
    [anon_sym_AMP_EQ] = ACTIONS(1556),
    [anon_sym_CARET_EQ] = ACTIONS(1556),
    [anon_sym_PIPE_EQ] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_DOT_DOT] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_align] = ACTIONS(1556),
    [anon_sym_addrspace] = ACTIONS(1556),
    [anon_sym_linksection] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_DASH_PERCENT] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_or] = ACTIONS(1558),
    [anon_sym_and] = ACTIONS(1556),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1558),
    [anon_sym_GT_EQ] = ACTIONS(1556),
    [anon_sym_LT_EQ] = ACTIONS(1556),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_orelse] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1558),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1558),
    [anon_sym_PLUS_PIPE] = ACTIONS(1558),
    [anon_sym_DASH_PIPE] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_STAR_STAR] = ACTIONS(1556),
    [anon_sym_STAR_PERCENT] = ACTIONS(1558),
    [anon_sym_STAR_PIPE] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1556),
    [anon_sym_catch] = ACTIONS(1556),
    [anon_sym_EQ_GT] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1558),
    [anon_sym_DOT_STAR] = ACTIONS(1556),
    [anon_sym_DOT_QMARK] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
  },
  [848] = {
    [ts_builtin_sym_end] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_COLON] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1562),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_STAR_EQ] = ACTIONS(1560),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1560),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1560),
    [anon_sym_SLASH_EQ] = ACTIONS(1560),
    [anon_sym_PERCENT_EQ] = ACTIONS(1560),
    [anon_sym_PLUS_EQ] = ACTIONS(1560),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1560),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1560),
    [anon_sym_DASH_EQ] = ACTIONS(1560),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1560),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1560),
    [anon_sym_LT_LT_EQ] = ACTIONS(1560),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1560),
    [anon_sym_GT_GT_EQ] = ACTIONS(1560),
    [anon_sym_AMP_EQ] = ACTIONS(1560),
    [anon_sym_CARET_EQ] = ACTIONS(1560),
    [anon_sym_PIPE_EQ] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_DOT_DOT] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1562),
    [anon_sym_align] = ACTIONS(1560),
    [anon_sym_addrspace] = ACTIONS(1560),
    [anon_sym_linksection] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1562),
    [anon_sym_DASH] = ACTIONS(1562),
    [anon_sym_DASH_PERCENT] = ACTIONS(1562),
    [anon_sym_AMP] = ACTIONS(1562),
    [anon_sym_or] = ACTIONS(1562),
    [anon_sym_and] = ACTIONS(1560),
    [anon_sym_EQ_EQ] = ACTIONS(1560),
    [anon_sym_BANG_EQ] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(1562),
    [anon_sym_GT_EQ] = ACTIONS(1560),
    [anon_sym_LT_EQ] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1562),
    [anon_sym_CARET] = ACTIONS(1562),
    [anon_sym_orelse] = ACTIONS(1560),
    [anon_sym_LT_LT] = ACTIONS(1562),
    [anon_sym_GT_GT] = ACTIONS(1562),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(1562),
    [anon_sym_PLUS_PLUS] = ACTIONS(1560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1562),
    [anon_sym_PLUS_PIPE] = ACTIONS(1562),
    [anon_sym_DASH_PIPE] = ACTIONS(1562),
    [anon_sym_SLASH] = ACTIONS(1562),
    [anon_sym_PERCENT] = ACTIONS(1562),
    [anon_sym_STAR_STAR] = ACTIONS(1560),
    [anon_sym_STAR_PERCENT] = ACTIONS(1562),
    [anon_sym_STAR_PIPE] = ACTIONS(1562),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [anon_sym_catch] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1562),
    [anon_sym_DOT_STAR] = ACTIONS(1560),
    [anon_sym_DOT_QMARK] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
  },
  [849] = {
    [ts_builtin_sym_end] = ACTIONS(1564),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1564),
    [anon_sym_addrspace] = ACTIONS(1564),
    [anon_sym_linksection] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [850] = {
    [ts_builtin_sym_end] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_EQ] = ACTIONS(1610),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_STAR_EQ] = ACTIONS(1608),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1608),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1608),
    [anon_sym_SLASH_EQ] = ACTIONS(1608),
    [anon_sym_PERCENT_EQ] = ACTIONS(1608),
    [anon_sym_PLUS_EQ] = ACTIONS(1608),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1608),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1608),
    [anon_sym_DASH_EQ] = ACTIONS(1608),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1608),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1608),
    [anon_sym_LT_LT_EQ] = ACTIONS(1608),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1608),
    [anon_sym_GT_GT_EQ] = ACTIONS(1608),
    [anon_sym_AMP_EQ] = ACTIONS(1608),
    [anon_sym_CARET_EQ] = ACTIONS(1608),
    [anon_sym_PIPE_EQ] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_RPAREN] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_else] = ACTIONS(1608),
    [anon_sym_DOT_DOT] = ACTIONS(1608),
    [anon_sym_PIPE] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1610),
    [anon_sym_align] = ACTIONS(1608),
    [anon_sym_addrspace] = ACTIONS(1608),
    [anon_sym_linksection] = ACTIONS(1608),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1610),
    [anon_sym_DASH_PERCENT] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1610),
    [anon_sym_or] = ACTIONS(1610),
    [anon_sym_and] = ACTIONS(1608),
    [anon_sym_EQ_EQ] = ACTIONS(1608),
    [anon_sym_BANG_EQ] = ACTIONS(1608),
    [anon_sym_GT] = ACTIONS(1610),
    [anon_sym_GT_EQ] = ACTIONS(1608),
    [anon_sym_LT_EQ] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1610),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_orelse] = ACTIONS(1608),
    [anon_sym_LT_LT] = ACTIONS(1610),
    [anon_sym_GT_GT] = ACTIONS(1610),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1610),
    [anon_sym_PLUS] = ACTIONS(1610),
    [anon_sym_PLUS_PLUS] = ACTIONS(1608),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1610),
    [anon_sym_PLUS_PIPE] = ACTIONS(1610),
    [anon_sym_DASH_PIPE] = ACTIONS(1610),
    [anon_sym_SLASH] = ACTIONS(1610),
    [anon_sym_PERCENT] = ACTIONS(1610),
    [anon_sym_STAR_STAR] = ACTIONS(1608),
    [anon_sym_STAR_PERCENT] = ACTIONS(1610),
    [anon_sym_STAR_PIPE] = ACTIONS(1610),
    [anon_sym_PIPE_PIPE] = ACTIONS(1608),
    [anon_sym_catch] = ACTIONS(1608),
    [anon_sym_EQ_GT] = ACTIONS(1608),
    [anon_sym_DOT] = ACTIONS(1610),
    [anon_sym_DOT_STAR] = ACTIONS(1608),
    [anon_sym_DOT_QMARK] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
  },
  [851] = {
    [ts_builtin_sym_end] = ACTIONS(1614),
    [anon_sym_COMMA] = ACTIONS(1614),
    [anon_sym_EQ] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1614),
    [anon_sym_STAR_EQ] = ACTIONS(1619),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1619),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1619),
    [anon_sym_SLASH_EQ] = ACTIONS(1619),
    [anon_sym_PERCENT_EQ] = ACTIONS(1619),
    [anon_sym_PLUS_EQ] = ACTIONS(1619),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1619),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1619),
    [anon_sym_DASH_EQ] = ACTIONS(1619),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1619),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1619),
    [anon_sym_LT_LT_EQ] = ACTIONS(1619),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1619),
    [anon_sym_GT_GT_EQ] = ACTIONS(1619),
    [anon_sym_AMP_EQ] = ACTIONS(1619),
    [anon_sym_CARET_EQ] = ACTIONS(1619),
    [anon_sym_PIPE_EQ] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1614),
    [anon_sym_RBRACE] = ACTIONS(1614),
    [anon_sym_else] = ACTIONS(1622),
    [anon_sym_DOT_DOT] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1616),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1614),
    [anon_sym_addrspace] = ACTIONS(1614),
    [anon_sym_linksection] = ACTIONS(1614),
    [anon_sym_LBRACK] = ACTIONS(1619),
    [anon_sym_RBRACK] = ACTIONS(1614),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_DASH_PERCENT] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_or] = ACTIONS(1616),
    [anon_sym_and] = ACTIONS(1619),
    [anon_sym_EQ_EQ] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1616),
    [anon_sym_GT_EQ] = ACTIONS(1619),
    [anon_sym_LT_EQ] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_CARET] = ACTIONS(1616),
    [anon_sym_orelse] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1616),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1616),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1616),
    [anon_sym_PLUS_PIPE] = ACTIONS(1616),
    [anon_sym_DASH_PIPE] = ACTIONS(1616),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1616),
    [anon_sym_STAR_STAR] = ACTIONS(1619),
    [anon_sym_STAR_PERCENT] = ACTIONS(1616),
    [anon_sym_STAR_PIPE] = ACTIONS(1616),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_catch] = ACTIONS(1619),
    [anon_sym_EQ_GT] = ACTIONS(1614),
    [anon_sym_DOT] = ACTIONS(1616),
    [anon_sym_DOT_STAR] = ACTIONS(1619),
    [anon_sym_DOT_QMARK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [ts_builtin_sym_end] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_else] = ACTIONS(1624),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1624),
    [anon_sym_addrspace] = ACTIONS(1624),
    [anon_sym_linksection] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1624),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [853] = {
    [ts_builtin_sym_end] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_EQ] = ACTIONS(1630),
    [anon_sym_SEMI] = ACTIONS(1628),
    [anon_sym_STAR_EQ] = ACTIONS(1628),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1628),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1628),
    [anon_sym_SLASH_EQ] = ACTIONS(1628),
    [anon_sym_PERCENT_EQ] = ACTIONS(1628),
    [anon_sym_PLUS_EQ] = ACTIONS(1628),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1628),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1628),
    [anon_sym_DASH_EQ] = ACTIONS(1628),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1628),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1628),
    [anon_sym_LT_LT_EQ] = ACTIONS(1628),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1628),
    [anon_sym_GT_GT_EQ] = ACTIONS(1628),
    [anon_sym_AMP_EQ] = ACTIONS(1628),
    [anon_sym_CARET_EQ] = ACTIONS(1628),
    [anon_sym_PIPE_EQ] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_LBRACE] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_else] = ACTIONS(1628),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1628),
    [anon_sym_addrspace] = ACTIONS(1628),
    [anon_sym_linksection] = ACTIONS(1628),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1628),
    [anon_sym_BANG] = ACTIONS(1630),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1630),
    [anon_sym_and] = ACTIONS(1628),
    [anon_sym_EQ_EQ] = ACTIONS(1628),
    [anon_sym_BANG_EQ] = ACTIONS(1628),
    [anon_sym_GT] = ACTIONS(1630),
    [anon_sym_GT_EQ] = ACTIONS(1628),
    [anon_sym_LT_EQ] = ACTIONS(1628),
    [anon_sym_LT] = ACTIONS(1630),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1628),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [ts_builtin_sym_end] = ACTIONS(1632),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1632),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_else] = ACTIONS(1632),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1632),
    [anon_sym_addrspace] = ACTIONS(1632),
    [anon_sym_linksection] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1632),
    [anon_sym_BANG] = ACTIONS(1634),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1632),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [855] = {
    [ts_builtin_sym_end] = ACTIONS(1636),
    [anon_sym_COMMA] = ACTIONS(1636),
    [anon_sym_EQ] = ACTIONS(1638),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_STAR_EQ] = ACTIONS(1636),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1636),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1636),
    [anon_sym_SLASH_EQ] = ACTIONS(1636),
    [anon_sym_PERCENT_EQ] = ACTIONS(1636),
    [anon_sym_PLUS_EQ] = ACTIONS(1636),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1636),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1636),
    [anon_sym_DASH_EQ] = ACTIONS(1636),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1636),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1636),
    [anon_sym_LT_LT_EQ] = ACTIONS(1636),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1636),
    [anon_sym_GT_GT_EQ] = ACTIONS(1636),
    [anon_sym_AMP_EQ] = ACTIONS(1636),
    [anon_sym_CARET_EQ] = ACTIONS(1636),
    [anon_sym_PIPE_EQ] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1636),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1636),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_else] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_PIPE] = ACTIONS(1638),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_align] = ACTIONS(1636),
    [anon_sym_addrspace] = ACTIONS(1636),
    [anon_sym_linksection] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1638),
    [anon_sym_DASH_PERCENT] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_or] = ACTIONS(1638),
    [anon_sym_and] = ACTIONS(1636),
    [anon_sym_EQ_EQ] = ACTIONS(1636),
    [anon_sym_BANG_EQ] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1638),
    [anon_sym_GT_EQ] = ACTIONS(1636),
    [anon_sym_LT_EQ] = ACTIONS(1636),
    [anon_sym_LT] = ACTIONS(1638),
    [anon_sym_CARET] = ACTIONS(1638),
    [anon_sym_orelse] = ACTIONS(1636),
    [anon_sym_LT_LT] = ACTIONS(1638),
    [anon_sym_GT_GT] = ACTIONS(1638),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_PLUS_PLUS] = ACTIONS(1636),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1638),
    [anon_sym_PLUS_PIPE] = ACTIONS(1638),
    [anon_sym_DASH_PIPE] = ACTIONS(1638),
    [anon_sym_SLASH] = ACTIONS(1638),
    [anon_sym_PERCENT] = ACTIONS(1638),
    [anon_sym_STAR_STAR] = ACTIONS(1636),
    [anon_sym_STAR_PERCENT] = ACTIONS(1638),
    [anon_sym_STAR_PIPE] = ACTIONS(1638),
    [anon_sym_PIPE_PIPE] = ACTIONS(1636),
    [anon_sym_catch] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1638),
    [anon_sym_DOT_STAR] = ACTIONS(1636),
    [anon_sym_DOT_QMARK] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
  },
  [856] = {
    [ts_builtin_sym_end] = ACTIONS(1640),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1640),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1640),
    [anon_sym_RBRACE] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1640),
    [anon_sym_addrspace] = ACTIONS(1640),
    [anon_sym_linksection] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [857] = {
    [ts_builtin_sym_end] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1646),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1644),
    [anon_sym_addrspace] = ACTIONS(1644),
    [anon_sym_linksection] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1644),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [858] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_STAR_EQ] = ACTIONS(1428),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_SLASH_EQ] = ACTIONS(1428),
    [anon_sym_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_DASH_EQ] = ACTIONS(1428),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1428),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_LT_LT_EQ] = ACTIONS(1428),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_GT_GT_EQ] = ACTIONS(1428),
    [anon_sym_AMP_EQ] = ACTIONS(1428),
    [anon_sym_CARET_EQ] = ACTIONS(1428),
    [anon_sym_PIPE_EQ] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_else] = ACTIONS(1428),
    [anon_sym_DOT_DOT] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_align] = ACTIONS(1428),
    [anon_sym_addrspace] = ACTIONS(1428),
    [anon_sym_linksection] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_DASH_PERCENT] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
    [anon_sym_or] = ACTIONS(1430),
    [anon_sym_and] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1428),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_orelse] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1430),
    [anon_sym_PLUS_PIPE] = ACTIONS(1430),
    [anon_sym_DASH_PIPE] = ACTIONS(1430),
    [anon_sym_SLASH] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1430),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_STAR_PERCENT] = ACTIONS(1430),
    [anon_sym_STAR_PIPE] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_catch] = ACTIONS(1428),
    [anon_sym_EQ_GT] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(1430),
    [anon_sym_DOT_STAR] = ACTIONS(1428),
    [anon_sym_DOT_QMARK] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
  },
  [859] = {
    [ts_builtin_sym_end] = ACTIONS(1650),
    [anon_sym_COMMA] = ACTIONS(1650),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_RBRACE] = ACTIONS(1650),
    [anon_sym_else] = ACTIONS(1652),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1650),
    [anon_sym_addrspace] = ACTIONS(1650),
    [anon_sym_linksection] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1654),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1650),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [860] = {
    [ts_builtin_sym_end] = ACTIONS(1564),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1564),
    [anon_sym_addrspace] = ACTIONS(1564),
    [anon_sym_linksection] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [861] = {
    [ts_builtin_sym_end] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1656),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_else] = ACTIONS(1656),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1656),
    [anon_sym_addrspace] = ACTIONS(1656),
    [anon_sym_linksection] = ACTIONS(1656),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [862] = {
    [ts_builtin_sym_end] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1662),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [anon_sym_LPAREN] = ACTIONS(1660),
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_else] = ACTIONS(1660),
    [anon_sym_DOT_DOT] = ACTIONS(1660),
    [anon_sym_PIPE] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1662),
    [anon_sym_align] = ACTIONS(1660),
    [anon_sym_addrspace] = ACTIONS(1660),
    [anon_sym_linksection] = ACTIONS(1660),
    [anon_sym_LBRACK] = ACTIONS(1660),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1662),
    [anon_sym_DASH_PERCENT] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1662),
    [anon_sym_or] = ACTIONS(1662),
    [anon_sym_and] = ACTIONS(1660),
    [anon_sym_EQ_EQ] = ACTIONS(1660),
    [anon_sym_BANG_EQ] = ACTIONS(1660),
    [anon_sym_GT] = ACTIONS(1662),
    [anon_sym_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_EQ] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_orelse] = ACTIONS(1660),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1662),
    [anon_sym_PLUS] = ACTIONS(1662),
    [anon_sym_PLUS_PLUS] = ACTIONS(1660),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1662),
    [anon_sym_PLUS_PIPE] = ACTIONS(1662),
    [anon_sym_DASH_PIPE] = ACTIONS(1662),
    [anon_sym_SLASH] = ACTIONS(1662),
    [anon_sym_PERCENT] = ACTIONS(1662),
    [anon_sym_STAR_STAR] = ACTIONS(1660),
    [anon_sym_STAR_PERCENT] = ACTIONS(1662),
    [anon_sym_STAR_PIPE] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1660),
    [anon_sym_catch] = ACTIONS(1660),
    [anon_sym_EQ_GT] = ACTIONS(1660),
    [anon_sym_DOT] = ACTIONS(1662),
    [anon_sym_DOT_STAR] = ACTIONS(1660),
    [anon_sym_DOT_QMARK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
  },
  [863] = {
    [ts_builtin_sym_end] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_EQ] = ACTIONS(1664),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_STAR_EQ] = ACTIONS(1667),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1667),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1667),
    [anon_sym_SLASH_EQ] = ACTIONS(1667),
    [anon_sym_PERCENT_EQ] = ACTIONS(1667),
    [anon_sym_PLUS_EQ] = ACTIONS(1667),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1667),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1667),
    [anon_sym_DASH_EQ] = ACTIONS(1667),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1667),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1667),
    [anon_sym_LT_LT_EQ] = ACTIONS(1667),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1667),
    [anon_sym_GT_GT_EQ] = ACTIONS(1667),
    [anon_sym_AMP_EQ] = ACTIONS(1667),
    [anon_sym_CARET_EQ] = ACTIONS(1667),
    [anon_sym_PIPE_EQ] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(1667),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_DOT_DOT] = ACTIONS(1667),
    [anon_sym_PIPE] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1664),
    [anon_sym_align] = ACTIONS(1464),
    [anon_sym_addrspace] = ACTIONS(1464),
    [anon_sym_linksection] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1667),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1664),
    [anon_sym_DASH_PERCENT] = ACTIONS(1664),
    [anon_sym_AMP] = ACTIONS(1664),
    [anon_sym_or] = ACTIONS(1664),
    [anon_sym_and] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1667),
    [anon_sym_BANG_EQ] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1664),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_LT] = ACTIONS(1664),
    [anon_sym_CARET] = ACTIONS(1664),
    [anon_sym_orelse] = ACTIONS(1667),
    [anon_sym_LT_LT] = ACTIONS(1664),
    [anon_sym_GT_GT] = ACTIONS(1664),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1664),
    [anon_sym_PLUS_PLUS] = ACTIONS(1667),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1664),
    [anon_sym_PLUS_PIPE] = ACTIONS(1664),
    [anon_sym_DASH_PIPE] = ACTIONS(1664),
    [anon_sym_SLASH] = ACTIONS(1664),
    [anon_sym_PERCENT] = ACTIONS(1664),
    [anon_sym_STAR_STAR] = ACTIONS(1667),
    [anon_sym_STAR_PERCENT] = ACTIONS(1664),
    [anon_sym_STAR_PIPE] = ACTIONS(1664),
    [anon_sym_PIPE_PIPE] = ACTIONS(1667),
    [anon_sym_catch] = ACTIONS(1667),
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(1664),
    [anon_sym_DOT_STAR] = ACTIONS(1667),
    [anon_sym_DOT_QMARK] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
  },
  [864] = {
    [ts_builtin_sym_end] = ACTIONS(1670),
    [anon_sym_COMMA] = ACTIONS(1670),
    [anon_sym_EQ] = ACTIONS(1672),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_STAR_EQ] = ACTIONS(1670),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_SLASH_EQ] = ACTIONS(1670),
    [anon_sym_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_DASH_EQ] = ACTIONS(1670),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1670),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_LT_LT_EQ] = ACTIONS(1670),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_GT_GT_EQ] = ACTIONS(1670),
    [anon_sym_AMP_EQ] = ACTIONS(1670),
    [anon_sym_CARET_EQ] = ACTIONS(1670),
    [anon_sym_PIPE_EQ] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_RPAREN] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1670),
    [anon_sym_DOT_DOT] = ACTIONS(1670),
    [anon_sym_PIPE] = ACTIONS(1672),
    [anon_sym_STAR] = ACTIONS(1672),
    [anon_sym_align] = ACTIONS(1670),
    [anon_sym_addrspace] = ACTIONS(1670),
    [anon_sym_linksection] = ACTIONS(1670),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_RBRACK] = ACTIONS(1670),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1672),
    [anon_sym_DASH_PERCENT] = ACTIONS(1672),
    [anon_sym_AMP] = ACTIONS(1672),
    [anon_sym_or] = ACTIONS(1672),
    [anon_sym_and] = ACTIONS(1670),
    [anon_sym_EQ_EQ] = ACTIONS(1670),
    [anon_sym_BANG_EQ] = ACTIONS(1670),
    [anon_sym_GT] = ACTIONS(1672),
    [anon_sym_GT_EQ] = ACTIONS(1670),
    [anon_sym_LT_EQ] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1672),
    [anon_sym_CARET] = ACTIONS(1672),
    [anon_sym_orelse] = ACTIONS(1670),
    [anon_sym_LT_LT] = ACTIONS(1672),
    [anon_sym_GT_GT] = ACTIONS(1672),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1672),
    [anon_sym_PLUS] = ACTIONS(1672),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1672),
    [anon_sym_PLUS_PIPE] = ACTIONS(1672),
    [anon_sym_DASH_PIPE] = ACTIONS(1672),
    [anon_sym_SLASH] = ACTIONS(1672),
    [anon_sym_PERCENT] = ACTIONS(1672),
    [anon_sym_STAR_STAR] = ACTIONS(1670),
    [anon_sym_STAR_PERCENT] = ACTIONS(1672),
    [anon_sym_STAR_PIPE] = ACTIONS(1672),
    [anon_sym_PIPE_PIPE] = ACTIONS(1670),
    [anon_sym_catch] = ACTIONS(1670),
    [anon_sym_EQ_GT] = ACTIONS(1670),
    [anon_sym_DOT] = ACTIONS(1672),
    [anon_sym_DOT_STAR] = ACTIONS(1670),
    [anon_sym_DOT_QMARK] = ACTIONS(1670),
    [sym_comment] = ACTIONS(3),
  },
  [865] = {
    [ts_builtin_sym_end] = ACTIONS(1674),
    [anon_sym_COMMA] = ACTIONS(1674),
    [anon_sym_EQ] = ACTIONS(1676),
    [anon_sym_SEMI] = ACTIONS(1674),
    [anon_sym_STAR_EQ] = ACTIONS(1674),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1674),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1674),
    [anon_sym_SLASH_EQ] = ACTIONS(1674),
    [anon_sym_PERCENT_EQ] = ACTIONS(1674),
    [anon_sym_PLUS_EQ] = ACTIONS(1674),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1674),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1674),
    [anon_sym_DASH_EQ] = ACTIONS(1674),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1674),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1674),
    [anon_sym_LT_LT_EQ] = ACTIONS(1674),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1674),
    [anon_sym_GT_GT_EQ] = ACTIONS(1674),
    [anon_sym_AMP_EQ] = ACTIONS(1674),
    [anon_sym_CARET_EQ] = ACTIONS(1674),
    [anon_sym_PIPE_EQ] = ACTIONS(1674),
    [anon_sym_LPAREN] = ACTIONS(1674),
    [anon_sym_RPAREN] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1674),
    [anon_sym_RBRACE] = ACTIONS(1674),
    [anon_sym_else] = ACTIONS(1674),
    [anon_sym_DOT_DOT] = ACTIONS(1674),
    [anon_sym_PIPE] = ACTIONS(1676),
    [anon_sym_STAR] = ACTIONS(1676),
    [anon_sym_align] = ACTIONS(1674),
    [anon_sym_addrspace] = ACTIONS(1674),
    [anon_sym_linksection] = ACTIONS(1674),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [anon_sym_RBRACK] = ACTIONS(1674),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1676),
    [anon_sym_DASH_PERCENT] = ACTIONS(1676),
    [anon_sym_AMP] = ACTIONS(1676),
    [anon_sym_or] = ACTIONS(1676),
    [anon_sym_and] = ACTIONS(1674),
    [anon_sym_EQ_EQ] = ACTIONS(1674),
    [anon_sym_BANG_EQ] = ACTIONS(1674),
    [anon_sym_GT] = ACTIONS(1676),
    [anon_sym_GT_EQ] = ACTIONS(1674),
    [anon_sym_LT_EQ] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_CARET] = ACTIONS(1676),
    [anon_sym_orelse] = ACTIONS(1674),
    [anon_sym_LT_LT] = ACTIONS(1676),
    [anon_sym_GT_GT] = ACTIONS(1676),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1676),
    [anon_sym_PLUS] = ACTIONS(1676),
    [anon_sym_PLUS_PLUS] = ACTIONS(1674),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1676),
    [anon_sym_PLUS_PIPE] = ACTIONS(1676),
    [anon_sym_DASH_PIPE] = ACTIONS(1676),
    [anon_sym_SLASH] = ACTIONS(1676),
    [anon_sym_PERCENT] = ACTIONS(1676),
    [anon_sym_STAR_STAR] = ACTIONS(1674),
    [anon_sym_STAR_PERCENT] = ACTIONS(1676),
    [anon_sym_STAR_PIPE] = ACTIONS(1676),
    [anon_sym_PIPE_PIPE] = ACTIONS(1674),
    [anon_sym_catch] = ACTIONS(1674),
    [anon_sym_EQ_GT] = ACTIONS(1674),
    [anon_sym_DOT] = ACTIONS(1676),
    [anon_sym_DOT_STAR] = ACTIONS(1674),
    [anon_sym_DOT_QMARK] = ACTIONS(1674),
    [sym_comment] = ACTIONS(3),
  },
  [866] = {
    [ts_builtin_sym_end] = ACTIONS(1678),
    [anon_sym_COMMA] = ACTIONS(1678),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1678),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1678),
    [anon_sym_else] = ACTIONS(1678),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1678),
    [anon_sym_addrspace] = ACTIONS(1678),
    [anon_sym_linksection] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1678),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [867] = {
    [ts_builtin_sym_end] = ACTIONS(1682),
    [anon_sym_COMMA] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1682),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1682),
    [anon_sym_addrspace] = ACTIONS(1682),
    [anon_sym_linksection] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1682),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [868] = {
    [ts_builtin_sym_end] = ACTIONS(1686),
    [anon_sym_COMMA] = ACTIONS(1686),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_else] = ACTIONS(1686),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1686),
    [anon_sym_addrspace] = ACTIONS(1686),
    [anon_sym_linksection] = ACTIONS(1686),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1686),
    [anon_sym_BANG] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1686),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [869] = {
    [ts_builtin_sym_end] = ACTIONS(1656),
    [anon_sym_COMMA] = ACTIONS(1656),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1656),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1656),
    [anon_sym_RBRACE] = ACTIONS(1656),
    [anon_sym_else] = ACTIONS(1656),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1656),
    [anon_sym_addrspace] = ACTIONS(1656),
    [anon_sym_linksection] = ACTIONS(1656),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [870] = {
    [ts_builtin_sym_end] = ACTIONS(1690),
    [anon_sym_COMMA] = ACTIONS(1690),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_else] = ACTIONS(1690),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1690),
    [anon_sym_addrspace] = ACTIONS(1690),
    [anon_sym_linksection] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1690),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1690),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [871] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [anon_sym_COMMA] = ACTIONS(1498),
    [anon_sym_EQ] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1498),
    [anon_sym_STAR_EQ] = ACTIONS(1697),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_SLASH_EQ] = ACTIONS(1697),
    [anon_sym_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_PLUS_EQ] = ACTIONS(1697),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_DASH_EQ] = ACTIONS(1697),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1697),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1697),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_GT_GT_EQ] = ACTIONS(1697),
    [anon_sym_AMP_EQ] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1697),
    [anon_sym_PIPE_EQ] = ACTIONS(1697),
    [anon_sym_LPAREN] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [anon_sym_else] = ACTIONS(1498),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_align] = ACTIONS(1498),
    [anon_sym_addrspace] = ACTIONS(1498),
    [anon_sym_linksection] = ACTIONS(1498),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_DASH_PERCENT] = ACTIONS(1694),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_or] = ACTIONS(1694),
    [anon_sym_and] = ACTIONS(1697),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(1694),
    [anon_sym_GT_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1694),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_orelse] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1697),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1694),
    [anon_sym_PLUS_PIPE] = ACTIONS(1694),
    [anon_sym_DASH_PIPE] = ACTIONS(1694),
    [anon_sym_SLASH] = ACTIONS(1694),
    [anon_sym_PERCENT] = ACTIONS(1694),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_PERCENT] = ACTIONS(1694),
    [anon_sym_STAR_PIPE] = ACTIONS(1694),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_catch] = ACTIONS(1697),
    [anon_sym_EQ_GT] = ACTIONS(1498),
    [anon_sym_DOT] = ACTIONS(1694),
    [anon_sym_DOT_STAR] = ACTIONS(1697),
    [anon_sym_DOT_QMARK] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [ts_builtin_sym_end] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_STAR_EQ] = ACTIONS(917),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(917),
    [anon_sym_SLASH_EQ] = ACTIONS(917),
    [anon_sym_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(917),
    [anon_sym_DASH_EQ] = ACTIONS(917),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(917),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_EQ] = ACTIONS(917),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(917),
    [anon_sym_GT_GT_EQ] = ACTIONS(917),
    [anon_sym_AMP_EQ] = ACTIONS(917),
    [anon_sym_CARET_EQ] = ACTIONS(917),
    [anon_sym_PIPE_EQ] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(917),
    [anon_sym_DOT_DOT] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_align] = ACTIONS(917),
    [anon_sym_addrspace] = ACTIONS(917),
    [anon_sym_linksection] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_DASH_PERCENT] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_or] = ACTIONS(915),
    [anon_sym_and] = ACTIONS(917),
    [anon_sym_EQ_EQ] = ACTIONS(917),
    [anon_sym_BANG_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(915),
    [anon_sym_orelse] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_LT_LT_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_PLUS_PERCENT] = ACTIONS(915),
    [anon_sym_PLUS_PIPE] = ACTIONS(915),
    [anon_sym_DASH_PIPE] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_STAR_PERCENT] = ACTIONS(915),
    [anon_sym_STAR_PIPE] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_catch] = ACTIONS(917),
    [anon_sym_EQ_GT] = ACTIONS(917),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_DOT_STAR] = ACTIONS(917),
    [anon_sym_DOT_QMARK] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
  },
  [873] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_EQ] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_else] = ACTIONS(1376),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1700),
    [anon_sym_STAR] = ACTIONS(1700),
    [anon_sym_align] = ACTIONS(1376),
    [anon_sym_addrspace] = ACTIONS(1376),
    [anon_sym_linksection] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_DASH_PERCENT] = ACTIONS(1700),
    [anon_sym_AMP] = ACTIONS(1700),
    [anon_sym_or] = ACTIONS(1700),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_GT] = ACTIONS(1700),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1700),
    [anon_sym_CARET] = ACTIONS(1700),
    [anon_sym_orelse] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1700),
    [anon_sym_GT_GT] = ACTIONS(1700),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1700),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_PLUS_PLUS] = ACTIONS(1703),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1700),
    [anon_sym_PLUS_PIPE] = ACTIONS(1700),
    [anon_sym_DASH_PIPE] = ACTIONS(1700),
    [anon_sym_SLASH] = ACTIONS(1700),
    [anon_sym_PERCENT] = ACTIONS(1700),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_STAR_PERCENT] = ACTIONS(1700),
    [anon_sym_STAR_PIPE] = ACTIONS(1700),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_catch] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1376),
    [anon_sym_DOT] = ACTIONS(1700),
    [anon_sym_DOT_STAR] = ACTIONS(1703),
    [anon_sym_DOT_QMARK] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
  },
  [874] = {
    [ts_builtin_sym_end] = ACTIONS(1706),
    [anon_sym_COMMA] = ACTIONS(1706),
    [anon_sym_EQ] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1706),
    [anon_sym_STAR_EQ] = ACTIONS(1706),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1706),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1706),
    [anon_sym_SLASH_EQ] = ACTIONS(1706),
    [anon_sym_PERCENT_EQ] = ACTIONS(1706),
    [anon_sym_PLUS_EQ] = ACTIONS(1706),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1706),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1706),
    [anon_sym_DASH_EQ] = ACTIONS(1706),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1706),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1706),
    [anon_sym_LT_LT_EQ] = ACTIONS(1706),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1706),
    [anon_sym_GT_GT_EQ] = ACTIONS(1706),
    [anon_sym_AMP_EQ] = ACTIONS(1706),
    [anon_sym_CARET_EQ] = ACTIONS(1706),
    [anon_sym_PIPE_EQ] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(1706),
    [anon_sym_RBRACE] = ACTIONS(1706),
    [anon_sym_else] = ACTIONS(1706),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1708),
    [anon_sym_align] = ACTIONS(1706),
    [anon_sym_addrspace] = ACTIONS(1706),
    [anon_sym_linksection] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1708),
    [anon_sym_DASH_PERCENT] = ACTIONS(1708),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_or] = ACTIONS(1708),
    [anon_sym_and] = ACTIONS(1706),
    [anon_sym_EQ_EQ] = ACTIONS(1706),
    [anon_sym_BANG_EQ] = ACTIONS(1706),
    [anon_sym_GT] = ACTIONS(1708),
    [anon_sym_GT_EQ] = ACTIONS(1706),
    [anon_sym_LT_EQ] = ACTIONS(1706),
    [anon_sym_LT] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1708),
    [anon_sym_orelse] = ACTIONS(1706),
    [anon_sym_LT_LT] = ACTIONS(1708),
    [anon_sym_GT_GT] = ACTIONS(1708),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1708),
    [anon_sym_PLUS] = ACTIONS(1708),
    [anon_sym_PLUS_PLUS] = ACTIONS(1706),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1708),
    [anon_sym_PLUS_PIPE] = ACTIONS(1708),
    [anon_sym_DASH_PIPE] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1708),
    [anon_sym_PERCENT] = ACTIONS(1708),
    [anon_sym_STAR_STAR] = ACTIONS(1706),
    [anon_sym_STAR_PERCENT] = ACTIONS(1708),
    [anon_sym_STAR_PIPE] = ACTIONS(1708),
    [anon_sym_PIPE_PIPE] = ACTIONS(1706),
    [anon_sym_catch] = ACTIONS(1706),
    [anon_sym_EQ_GT] = ACTIONS(1706),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [875] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [anon_sym_COMMA] = ACTIONS(1348),
    [anon_sym_EQ] = ACTIONS(1710),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1713),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1713),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1713),
    [anon_sym_SLASH_EQ] = ACTIONS(1713),
    [anon_sym_PERCENT_EQ] = ACTIONS(1713),
    [anon_sym_PLUS_EQ] = ACTIONS(1713),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1713),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1713),
    [anon_sym_DASH_EQ] = ACTIONS(1713),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1713),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1713),
    [anon_sym_LT_LT_EQ] = ACTIONS(1713),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1713),
    [anon_sym_GT_GT_EQ] = ACTIONS(1713),
    [anon_sym_AMP_EQ] = ACTIONS(1713),
    [anon_sym_CARET_EQ] = ACTIONS(1713),
    [anon_sym_PIPE_EQ] = ACTIONS(1713),
    [anon_sym_LPAREN] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_DOT_DOT] = ACTIONS(1713),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_STAR] = ACTIONS(1710),
    [anon_sym_align] = ACTIONS(1348),
    [anon_sym_addrspace] = ACTIONS(1348),
    [anon_sym_linksection] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_DASH_PERCENT] = ACTIONS(1710),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_or] = ACTIONS(1710),
    [anon_sym_and] = ACTIONS(1713),
    [anon_sym_EQ_EQ] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1713),
    [anon_sym_GT] = ACTIONS(1710),
    [anon_sym_GT_EQ] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_orelse] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(1710),
    [anon_sym_GT_GT] = ACTIONS(1710),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1710),
    [anon_sym_PLUS_PIPE] = ACTIONS(1710),
    [anon_sym_DASH_PIPE] = ACTIONS(1710),
    [anon_sym_SLASH] = ACTIONS(1710),
    [anon_sym_PERCENT] = ACTIONS(1710),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_STAR_PERCENT] = ACTIONS(1710),
    [anon_sym_STAR_PIPE] = ACTIONS(1710),
    [anon_sym_PIPE_PIPE] = ACTIONS(1713),
    [anon_sym_catch] = ACTIONS(1713),
    [anon_sym_EQ_GT] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1710),
    [anon_sym_DOT_STAR] = ACTIONS(1713),
    [anon_sym_DOT_QMARK] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
  },
  [876] = {
    [ts_builtin_sym_end] = ACTIONS(1716),
    [anon_sym_COMMA] = ACTIONS(1716),
    [anon_sym_EQ] = ACTIONS(1718),
    [anon_sym_SEMI] = ACTIONS(1716),
    [anon_sym_STAR_EQ] = ACTIONS(1721),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1721),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1721),
    [anon_sym_SLASH_EQ] = ACTIONS(1721),
    [anon_sym_PERCENT_EQ] = ACTIONS(1721),
    [anon_sym_PLUS_EQ] = ACTIONS(1721),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1721),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1721),
    [anon_sym_DASH_EQ] = ACTIONS(1721),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1721),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1721),
    [anon_sym_LT_LT_EQ] = ACTIONS(1721),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1721),
    [anon_sym_GT_GT_EQ] = ACTIONS(1721),
    [anon_sym_AMP_EQ] = ACTIONS(1721),
    [anon_sym_CARET_EQ] = ACTIONS(1721),
    [anon_sym_PIPE_EQ] = ACTIONS(1721),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_RPAREN] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1716),
    [anon_sym_RBRACE] = ACTIONS(1716),
    [anon_sym_else] = ACTIONS(1716),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_align] = ACTIONS(1716),
    [anon_sym_addrspace] = ACTIONS(1716),
    [anon_sym_linksection] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1721),
    [anon_sym_RBRACK] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_DASH_PERCENT] = ACTIONS(1718),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_or] = ACTIONS(1718),
    [anon_sym_and] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1718),
    [anon_sym_GT_EQ] = ACTIONS(1721),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_CARET] = ACTIONS(1718),
    [anon_sym_orelse] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1718),
    [anon_sym_GT_GT] = ACTIONS(1718),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1718),
    [anon_sym_PLUS_PLUS] = ACTIONS(1721),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1718),
    [anon_sym_PLUS_PIPE] = ACTIONS(1718),
    [anon_sym_DASH_PIPE] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(1718),
    [anon_sym_PERCENT] = ACTIONS(1718),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_STAR_PERCENT] = ACTIONS(1718),
    [anon_sym_STAR_PIPE] = ACTIONS(1718),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_catch] = ACTIONS(1721),
    [anon_sym_EQ_GT] = ACTIONS(1716),
    [anon_sym_DOT] = ACTIONS(1718),
    [anon_sym_DOT_STAR] = ACTIONS(1721),
    [anon_sym_DOT_QMARK] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
  },
  [877] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_EQ] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1502),
    [anon_sym_STAR_EQ] = ACTIONS(1727),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_SLASH_EQ] = ACTIONS(1727),
    [anon_sym_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1727),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_DASH_EQ] = ACTIONS(1727),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_GT_GT_EQ] = ACTIONS(1727),
    [anon_sym_AMP_EQ] = ACTIONS(1727),
    [anon_sym_CARET_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [anon_sym_else] = ACTIONS(1502),
    [anon_sym_DOT_DOT] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_align] = ACTIONS(1502),
    [anon_sym_addrspace] = ACTIONS(1502),
    [anon_sym_linksection] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_DASH_PERCENT] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1724),
    [anon_sym_or] = ACTIONS(1724),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1724),
    [anon_sym_CARET] = ACTIONS(1724),
    [anon_sym_orelse] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1724),
    [anon_sym_GT_GT] = ACTIONS(1724),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1724),
    [anon_sym_PLUS_PIPE] = ACTIONS(1724),
    [anon_sym_DASH_PIPE] = ACTIONS(1724),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_PERCENT] = ACTIONS(1724),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_STAR_PERCENT] = ACTIONS(1724),
    [anon_sym_STAR_PIPE] = ACTIONS(1724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_catch] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_DOT] = ACTIONS(1724),
    [anon_sym_DOT_STAR] = ACTIONS(1727),
    [anon_sym_DOT_QMARK] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [878] = {
    [ts_builtin_sym_end] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1730),
    [anon_sym_EQ] = ACTIONS(1732),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_STAR_EQ] = ACTIONS(1730),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1730),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1730),
    [anon_sym_SLASH_EQ] = ACTIONS(1730),
    [anon_sym_PERCENT_EQ] = ACTIONS(1730),
    [anon_sym_PLUS_EQ] = ACTIONS(1730),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1730),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1730),
    [anon_sym_DASH_EQ] = ACTIONS(1730),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1730),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1730),
    [anon_sym_LT_LT_EQ] = ACTIONS(1730),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1730),
    [anon_sym_GT_GT_EQ] = ACTIONS(1730),
    [anon_sym_AMP_EQ] = ACTIONS(1730),
    [anon_sym_CARET_EQ] = ACTIONS(1730),
    [anon_sym_PIPE_EQ] = ACTIONS(1730),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_RPAREN] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_else] = ACTIONS(1730),
    [anon_sym_DOT_DOT] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(1732),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_align] = ACTIONS(1730),
    [anon_sym_addrspace] = ACTIONS(1730),
    [anon_sym_linksection] = ACTIONS(1730),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_RBRACK] = ACTIONS(1730),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1732),
    [anon_sym_DASH_PERCENT] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1732),
    [anon_sym_or] = ACTIONS(1732),
    [anon_sym_and] = ACTIONS(1730),
    [anon_sym_EQ_EQ] = ACTIONS(1730),
    [anon_sym_BANG_EQ] = ACTIONS(1730),
    [anon_sym_GT] = ACTIONS(1732),
    [anon_sym_GT_EQ] = ACTIONS(1730),
    [anon_sym_LT_EQ] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1732),
    [anon_sym_CARET] = ACTIONS(1732),
    [anon_sym_orelse] = ACTIONS(1730),
    [anon_sym_LT_LT] = ACTIONS(1732),
    [anon_sym_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1732),
    [anon_sym_PLUS] = ACTIONS(1732),
    [anon_sym_PLUS_PLUS] = ACTIONS(1730),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1732),
    [anon_sym_PLUS_PIPE] = ACTIONS(1732),
    [anon_sym_DASH_PIPE] = ACTIONS(1732),
    [anon_sym_SLASH] = ACTIONS(1732),
    [anon_sym_PERCENT] = ACTIONS(1732),
    [anon_sym_STAR_STAR] = ACTIONS(1730),
    [anon_sym_STAR_PERCENT] = ACTIONS(1732),
    [anon_sym_STAR_PIPE] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1730),
    [anon_sym_catch] = ACTIONS(1730),
    [anon_sym_EQ_GT] = ACTIONS(1730),
    [anon_sym_DOT] = ACTIONS(1732),
    [anon_sym_DOT_STAR] = ACTIONS(1730),
    [anon_sym_DOT_QMARK] = ACTIONS(1730),
    [sym_comment] = ACTIONS(3),
  },
  [879] = {
    [ts_builtin_sym_end] = ACTIONS(1734),
    [anon_sym_COMMA] = ACTIONS(1734),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_else] = ACTIONS(1736),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1734),
    [anon_sym_addrspace] = ACTIONS(1734),
    [anon_sym_linksection] = ACTIONS(1734),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1734),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [880] = {
    [ts_builtin_sym_end] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_else] = ACTIONS(1742),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1740),
    [anon_sym_addrspace] = ACTIONS(1740),
    [anon_sym_linksection] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1740),
    [anon_sym_BANG] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1740),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [881] = {
    [ts_builtin_sym_end] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_STAR_EQ] = ACTIONS(1749),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1749),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_SLASH_EQ] = ACTIONS(1749),
    [anon_sym_PERCENT_EQ] = ACTIONS(1749),
    [anon_sym_PLUS_EQ] = ACTIONS(1749),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1749),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_DASH_EQ] = ACTIONS(1749),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1749),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_LT_LT_EQ] = ACTIONS(1749),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_GT_GT_EQ] = ACTIONS(1749),
    [anon_sym_AMP_EQ] = ACTIONS(1749),
    [anon_sym_CARET_EQ] = ACTIONS(1749),
    [anon_sym_PIPE_EQ] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_STAR] = ACTIONS(1746),
    [anon_sym_align] = ACTIONS(1472),
    [anon_sym_addrspace] = ACTIONS(1472),
    [anon_sym_linksection] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1746),
    [anon_sym_DASH_PERCENT] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
    [anon_sym_or] = ACTIONS(1746),
    [anon_sym_and] = ACTIONS(1749),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_EQ] = ACTIONS(1749),
    [anon_sym_LT_EQ] = ACTIONS(1749),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_CARET] = ACTIONS(1746),
    [anon_sym_orelse] = ACTIONS(1749),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1746),
    [anon_sym_PLUS] = ACTIONS(1746),
    [anon_sym_PLUS_PLUS] = ACTIONS(1749),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1746),
    [anon_sym_PLUS_PIPE] = ACTIONS(1746),
    [anon_sym_DASH_PIPE] = ACTIONS(1746),
    [anon_sym_SLASH] = ACTIONS(1746),
    [anon_sym_PERCENT] = ACTIONS(1746),
    [anon_sym_STAR_STAR] = ACTIONS(1749),
    [anon_sym_STAR_PERCENT] = ACTIONS(1746),
    [anon_sym_STAR_PIPE] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1749),
    [anon_sym_catch] = ACTIONS(1749),
    [anon_sym_EQ_GT] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1746),
    [anon_sym_DOT_STAR] = ACTIONS(1749),
    [anon_sym_DOT_QMARK] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
  },
  [882] = {
    [ts_builtin_sym_end] = ACTIONS(1752),
    [anon_sym_COMMA] = ACTIONS(1752),
    [anon_sym_EQ] = ACTIONS(1754),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym_STAR_EQ] = ACTIONS(1752),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1752),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1752),
    [anon_sym_SLASH_EQ] = ACTIONS(1752),
    [anon_sym_PERCENT_EQ] = ACTIONS(1752),
    [anon_sym_PLUS_EQ] = ACTIONS(1752),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1752),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1752),
    [anon_sym_DASH_EQ] = ACTIONS(1752),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1752),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1752),
    [anon_sym_LT_LT_EQ] = ACTIONS(1752),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1752),
    [anon_sym_GT_GT_EQ] = ACTIONS(1752),
    [anon_sym_AMP_EQ] = ACTIONS(1752),
    [anon_sym_CARET_EQ] = ACTIONS(1752),
    [anon_sym_PIPE_EQ] = ACTIONS(1752),
    [anon_sym_LPAREN] = ACTIONS(1752),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1752),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_else] = ACTIONS(1752),
    [anon_sym_DOT_DOT] = ACTIONS(1752),
    [anon_sym_PIPE] = ACTIONS(1754),
    [anon_sym_STAR] = ACTIONS(1754),
    [anon_sym_align] = ACTIONS(1752),
    [anon_sym_addrspace] = ACTIONS(1752),
    [anon_sym_linksection] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(1752),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_DASH_PERCENT] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(1754),
    [anon_sym_or] = ACTIONS(1754),
    [anon_sym_and] = ACTIONS(1752),
    [anon_sym_EQ_EQ] = ACTIONS(1752),
    [anon_sym_BANG_EQ] = ACTIONS(1752),
    [anon_sym_GT] = ACTIONS(1754),
    [anon_sym_GT_EQ] = ACTIONS(1752),
    [anon_sym_LT_EQ] = ACTIONS(1752),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_CARET] = ACTIONS(1754),
    [anon_sym_orelse] = ACTIONS(1752),
    [anon_sym_LT_LT] = ACTIONS(1754),
    [anon_sym_GT_GT] = ACTIONS(1754),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_PLUS_PLUS] = ACTIONS(1752),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1754),
    [anon_sym_PLUS_PIPE] = ACTIONS(1754),
    [anon_sym_DASH_PIPE] = ACTIONS(1754),
    [anon_sym_SLASH] = ACTIONS(1754),
    [anon_sym_PERCENT] = ACTIONS(1754),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_STAR_PERCENT] = ACTIONS(1754),
    [anon_sym_STAR_PIPE] = ACTIONS(1754),
    [anon_sym_PIPE_PIPE] = ACTIONS(1752),
    [anon_sym_catch] = ACTIONS(1752),
    [anon_sym_EQ_GT] = ACTIONS(1752),
    [anon_sym_DOT] = ACTIONS(1754),
    [anon_sym_DOT_STAR] = ACTIONS(1752),
    [anon_sym_DOT_QMARK] = ACTIONS(1752),
    [sym_comment] = ACTIONS(3),
  },
  [883] = {
    [ts_builtin_sym_end] = ACTIONS(1756),
    [anon_sym_COMMA] = ACTIONS(1756),
    [anon_sym_EQ] = ACTIONS(1758),
    [anon_sym_SEMI] = ACTIONS(1756),
    [anon_sym_STAR_EQ] = ACTIONS(1756),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_SLASH_EQ] = ACTIONS(1756),
    [anon_sym_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_DASH_EQ] = ACTIONS(1756),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_LT_LT_EQ] = ACTIONS(1756),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_GT_GT_EQ] = ACTIONS(1756),
    [anon_sym_AMP_EQ] = ACTIONS(1756),
    [anon_sym_CARET_EQ] = ACTIONS(1756),
    [anon_sym_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1756),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_else] = ACTIONS(1756),
    [anon_sym_DOT_DOT] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_align] = ACTIONS(1756),
    [anon_sym_addrspace] = ACTIONS(1756),
    [anon_sym_linksection] = ACTIONS(1756),
    [anon_sym_LBRACK] = ACTIONS(1756),
    [anon_sym_RBRACK] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_DASH_PERCENT] = ACTIONS(1758),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_or] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1756),
    [anon_sym_EQ_EQ] = ACTIONS(1756),
    [anon_sym_BANG_EQ] = ACTIONS(1756),
    [anon_sym_GT] = ACTIONS(1758),
    [anon_sym_GT_EQ] = ACTIONS(1756),
    [anon_sym_LT_EQ] = ACTIONS(1756),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1758),
    [anon_sym_orelse] = ACTIONS(1756),
    [anon_sym_LT_LT] = ACTIONS(1758),
    [anon_sym_GT_GT] = ACTIONS(1758),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(1758),
    [anon_sym_PLUS_PLUS] = ACTIONS(1756),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1758),
    [anon_sym_PLUS_PIPE] = ACTIONS(1758),
    [anon_sym_DASH_PIPE] = ACTIONS(1758),
    [anon_sym_SLASH] = ACTIONS(1758),
    [anon_sym_PERCENT] = ACTIONS(1758),
    [anon_sym_STAR_STAR] = ACTIONS(1756),
    [anon_sym_STAR_PERCENT] = ACTIONS(1758),
    [anon_sym_STAR_PIPE] = ACTIONS(1758),
    [anon_sym_PIPE_PIPE] = ACTIONS(1756),
    [anon_sym_catch] = ACTIONS(1756),
    [anon_sym_EQ_GT] = ACTIONS(1756),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_DOT_STAR] = ACTIONS(1756),
    [anon_sym_DOT_QMARK] = ACTIONS(1756),
    [sym_comment] = ACTIONS(3),
  },
  [884] = {
    [ts_builtin_sym_end] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_SEMI] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1765),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1765),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1765),
    [anon_sym_SLASH_EQ] = ACTIONS(1765),
    [anon_sym_PERCENT_EQ] = ACTIONS(1765),
    [anon_sym_PLUS_EQ] = ACTIONS(1765),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1765),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1765),
    [anon_sym_DASH_EQ] = ACTIONS(1765),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1765),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1765),
    [anon_sym_LT_LT_EQ] = ACTIONS(1765),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1765),
    [anon_sym_GT_GT_EQ] = ACTIONS(1765),
    [anon_sym_AMP_EQ] = ACTIONS(1765),
    [anon_sym_CARET_EQ] = ACTIONS(1765),
    [anon_sym_PIPE_EQ] = ACTIONS(1765),
    [anon_sym_LPAREN] = ACTIONS(1765),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1760),
    [anon_sym_RBRACE] = ACTIONS(1760),
    [anon_sym_else] = ACTIONS(1760),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_align] = ACTIONS(1760),
    [anon_sym_addrspace] = ACTIONS(1760),
    [anon_sym_linksection] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1765),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_DASH_PERCENT] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_or] = ACTIONS(1762),
    [anon_sym_and] = ACTIONS(1765),
    [anon_sym_EQ_EQ] = ACTIONS(1765),
    [anon_sym_BANG_EQ] = ACTIONS(1765),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym_orelse] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1762),
    [anon_sym_PLUS_PIPE] = ACTIONS(1762),
    [anon_sym_DASH_PIPE] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_STAR_STAR] = ACTIONS(1765),
    [anon_sym_STAR_PERCENT] = ACTIONS(1762),
    [anon_sym_STAR_PIPE] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1765),
    [anon_sym_catch] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(1760),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_DOT_STAR] = ACTIONS(1765),
    [anon_sym_DOT_QMARK] = ACTIONS(1765),
    [sym_comment] = ACTIONS(3),
  },
  [885] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1770),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DASH_PERCENT] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1770),
    [anon_sym_orelse] = ACTIONS(1768),
    [anon_sym_LT_LT] = ACTIONS(1770),
    [anon_sym_GT_GT] = ACTIONS(1770),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1770),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_PLUS_PLUS] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1770),
    [anon_sym_PLUS_PIPE] = ACTIONS(1770),
    [anon_sym_DASH_PIPE] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1770),
    [anon_sym_PERCENT] = ACTIONS(1770),
    [anon_sym_STAR_STAR] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT] = ACTIONS(1770),
    [anon_sym_STAR_PIPE] = ACTIONS(1770),
    [anon_sym_PIPE_PIPE] = ACTIONS(1768),
    [anon_sym_catch] = ACTIONS(1768),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [886] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1772),
    [anon_sym_SEMI] = ACTIONS(1510),
    [anon_sym_STAR_EQ] = ACTIONS(1775),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1775),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_SLASH_EQ] = ACTIONS(1775),
    [anon_sym_PERCENT_EQ] = ACTIONS(1775),
    [anon_sym_PLUS_EQ] = ACTIONS(1775),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1775),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_DASH_EQ] = ACTIONS(1775),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1775),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_LT_LT_EQ] = ACTIONS(1775),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_GT_GT_EQ] = ACTIONS(1775),
    [anon_sym_AMP_EQ] = ACTIONS(1775),
    [anon_sym_CARET_EQ] = ACTIONS(1775),
    [anon_sym_PIPE_EQ] = ACTIONS(1775),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_else] = ACTIONS(1510),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_align] = ACTIONS(1510),
    [anon_sym_addrspace] = ACTIONS(1510),
    [anon_sym_linksection] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1775),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1772),
    [anon_sym_DASH_PERCENT] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
    [anon_sym_or] = ACTIONS(1772),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_EQ_EQ] = ACTIONS(1775),
    [anon_sym_BANG_EQ] = ACTIONS(1775),
    [anon_sym_GT] = ACTIONS(1772),
    [anon_sym_GT_EQ] = ACTIONS(1775),
    [anon_sym_LT_EQ] = ACTIONS(1775),
    [anon_sym_LT] = ACTIONS(1772),
    [anon_sym_CARET] = ACTIONS(1772),
    [anon_sym_orelse] = ACTIONS(1775),
    [anon_sym_LT_LT] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1772),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1772),
    [anon_sym_PLUS] = ACTIONS(1772),
    [anon_sym_PLUS_PLUS] = ACTIONS(1775),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1772),
    [anon_sym_PLUS_PIPE] = ACTIONS(1772),
    [anon_sym_DASH_PIPE] = ACTIONS(1772),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1772),
    [anon_sym_STAR_STAR] = ACTIONS(1775),
    [anon_sym_STAR_PERCENT] = ACTIONS(1772),
    [anon_sym_STAR_PIPE] = ACTIONS(1772),
    [anon_sym_PIPE_PIPE] = ACTIONS(1775),
    [anon_sym_catch] = ACTIONS(1775),
    [anon_sym_EQ_GT] = ACTIONS(1510),
    [anon_sym_DOT] = ACTIONS(1772),
    [anon_sym_DOT_STAR] = ACTIONS(1775),
    [anon_sym_DOT_QMARK] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_STAR_EQ] = ACTIONS(1781),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1781),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1781),
    [anon_sym_SLASH_EQ] = ACTIONS(1781),
    [anon_sym_PERCENT_EQ] = ACTIONS(1781),
    [anon_sym_PLUS_EQ] = ACTIONS(1781),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1781),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1781),
    [anon_sym_DASH_EQ] = ACTIONS(1781),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1781),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1781),
    [anon_sym_LT_LT_EQ] = ACTIONS(1781),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1781),
    [anon_sym_GT_GT_EQ] = ACTIONS(1781),
    [anon_sym_AMP_EQ] = ACTIONS(1781),
    [anon_sym_CARET_EQ] = ACTIONS(1781),
    [anon_sym_PIPE_EQ] = ACTIONS(1781),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_DOT_DOT] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1778),
    [anon_sym_STAR] = ACTIONS(1778),
    [anon_sym_align] = ACTIONS(1556),
    [anon_sym_addrspace] = ACTIONS(1556),
    [anon_sym_linksection] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1781),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1778),
    [anon_sym_DASH_PERCENT] = ACTIONS(1778),
    [anon_sym_AMP] = ACTIONS(1778),
    [anon_sym_or] = ACTIONS(1778),
    [anon_sym_and] = ACTIONS(1781),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1781),
    [anon_sym_GT] = ACTIONS(1778),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1778),
    [anon_sym_CARET] = ACTIONS(1778),
    [anon_sym_orelse] = ACTIONS(1781),
    [anon_sym_LT_LT] = ACTIONS(1778),
    [anon_sym_GT_GT] = ACTIONS(1778),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(1778),
    [anon_sym_PLUS_PLUS] = ACTIONS(1781),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1778),
    [anon_sym_PLUS_PIPE] = ACTIONS(1778),
    [anon_sym_DASH_PIPE] = ACTIONS(1778),
    [anon_sym_SLASH] = ACTIONS(1778),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1781),
    [anon_sym_STAR_PERCENT] = ACTIONS(1778),
    [anon_sym_STAR_PIPE] = ACTIONS(1778),
    [anon_sym_PIPE_PIPE] = ACTIONS(1781),
    [anon_sym_catch] = ACTIONS(1781),
    [anon_sym_EQ_GT] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_DOT_STAR] = ACTIONS(1781),
    [anon_sym_DOT_QMARK] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [888] = {
    [ts_builtin_sym_end] = ACTIONS(1784),
    [anon_sym_COMMA] = ACTIONS(1784),
    [anon_sym_EQ] = ACTIONS(1786),
    [anon_sym_SEMI] = ACTIONS(1784),
    [anon_sym_STAR_EQ] = ACTIONS(1784),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1784),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1784),
    [anon_sym_SLASH_EQ] = ACTIONS(1784),
    [anon_sym_PERCENT_EQ] = ACTIONS(1784),
    [anon_sym_PLUS_EQ] = ACTIONS(1784),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1784),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1784),
    [anon_sym_DASH_EQ] = ACTIONS(1784),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1784),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1784),
    [anon_sym_LT_LT_EQ] = ACTIONS(1784),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1784),
    [anon_sym_GT_GT_EQ] = ACTIONS(1784),
    [anon_sym_AMP_EQ] = ACTIONS(1784),
    [anon_sym_CARET_EQ] = ACTIONS(1784),
    [anon_sym_PIPE_EQ] = ACTIONS(1784),
    [anon_sym_LPAREN] = ACTIONS(1784),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [anon_sym_LBRACE] = ACTIONS(1784),
    [anon_sym_RBRACE] = ACTIONS(1784),
    [anon_sym_else] = ACTIONS(1784),
    [anon_sym_DOT_DOT] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_STAR] = ACTIONS(1786),
    [anon_sym_align] = ACTIONS(1784),
    [anon_sym_addrspace] = ACTIONS(1784),
    [anon_sym_linksection] = ACTIONS(1784),
    [anon_sym_LBRACK] = ACTIONS(1784),
    [anon_sym_RBRACK] = ACTIONS(1784),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_DASH_PERCENT] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1786),
    [anon_sym_or] = ACTIONS(1786),
    [anon_sym_and] = ACTIONS(1784),
    [anon_sym_EQ_EQ] = ACTIONS(1784),
    [anon_sym_BANG_EQ] = ACTIONS(1784),
    [anon_sym_GT] = ACTIONS(1786),
    [anon_sym_GT_EQ] = ACTIONS(1784),
    [anon_sym_LT_EQ] = ACTIONS(1784),
    [anon_sym_LT] = ACTIONS(1786),
    [anon_sym_CARET] = ACTIONS(1786),
    [anon_sym_orelse] = ACTIONS(1784),
    [anon_sym_LT_LT] = ACTIONS(1786),
    [anon_sym_GT_GT] = ACTIONS(1786),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(1786),
    [anon_sym_PLUS_PLUS] = ACTIONS(1784),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1786),
    [anon_sym_PLUS_PIPE] = ACTIONS(1786),
    [anon_sym_DASH_PIPE] = ACTIONS(1786),
    [anon_sym_SLASH] = ACTIONS(1786),
    [anon_sym_PERCENT] = ACTIONS(1786),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_STAR_PERCENT] = ACTIONS(1786),
    [anon_sym_STAR_PIPE] = ACTIONS(1786),
    [anon_sym_PIPE_PIPE] = ACTIONS(1784),
    [anon_sym_catch] = ACTIONS(1784),
    [anon_sym_EQ_GT] = ACTIONS(1784),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_DOT_STAR] = ACTIONS(1784),
    [anon_sym_DOT_QMARK] = ACTIONS(1784),
    [sym_comment] = ACTIONS(3),
  },
  [889] = {
    [ts_builtin_sym_end] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1788),
    [anon_sym_STAR_EQ] = ACTIONS(1793),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1793),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1793),
    [anon_sym_SLASH_EQ] = ACTIONS(1793),
    [anon_sym_PERCENT_EQ] = ACTIONS(1793),
    [anon_sym_PLUS_EQ] = ACTIONS(1793),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1793),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1793),
    [anon_sym_DASH_EQ] = ACTIONS(1793),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1793),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1793),
    [anon_sym_LT_LT_EQ] = ACTIONS(1793),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1793),
    [anon_sym_GT_GT_EQ] = ACTIONS(1793),
    [anon_sym_AMP_EQ] = ACTIONS(1793),
    [anon_sym_CARET_EQ] = ACTIONS(1793),
    [anon_sym_PIPE_EQ] = ACTIONS(1793),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_else] = ACTIONS(1788),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1790),
    [anon_sym_STAR] = ACTIONS(1790),
    [anon_sym_align] = ACTIONS(1788),
    [anon_sym_addrspace] = ACTIONS(1788),
    [anon_sym_linksection] = ACTIONS(1788),
    [anon_sym_LBRACK] = ACTIONS(1793),
    [anon_sym_RBRACK] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_DASH_PERCENT] = ACTIONS(1790),
    [anon_sym_AMP] = ACTIONS(1790),
    [anon_sym_or] = ACTIONS(1790),
    [anon_sym_and] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1793),
    [anon_sym_BANG_EQ] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1790),
    [anon_sym_GT_EQ] = ACTIONS(1793),
    [anon_sym_LT_EQ] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1790),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_orelse] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1790),
    [anon_sym_GT_GT] = ACTIONS(1790),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1790),
    [anon_sym_PLUS] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1793),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1790),
    [anon_sym_PLUS_PIPE] = ACTIONS(1790),
    [anon_sym_DASH_PIPE] = ACTIONS(1790),
    [anon_sym_SLASH] = ACTIONS(1790),
    [anon_sym_PERCENT] = ACTIONS(1790),
    [anon_sym_STAR_STAR] = ACTIONS(1793),
    [anon_sym_STAR_PERCENT] = ACTIONS(1790),
    [anon_sym_STAR_PIPE] = ACTIONS(1790),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [anon_sym_catch] = ACTIONS(1793),
    [anon_sym_EQ_GT] = ACTIONS(1788),
    [anon_sym_DOT] = ACTIONS(1790),
    [anon_sym_DOT_STAR] = ACTIONS(1793),
    [anon_sym_DOT_QMARK] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
  },
  [890] = {
    [ts_builtin_sym_end] = ACTIONS(1796),
    [anon_sym_COMMA] = ACTIONS(1796),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1796),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1796),
    [anon_sym_LBRACE] = ACTIONS(1796),
    [anon_sym_RBRACE] = ACTIONS(1796),
    [anon_sym_else] = ACTIONS(1796),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1796),
    [anon_sym_addrspace] = ACTIONS(1796),
    [anon_sym_linksection] = ACTIONS(1796),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1796),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1796),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [891] = {
    [ts_builtin_sym_end] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(1800),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1800),
    [anon_sym_addrspace] = ACTIONS(1800),
    [anon_sym_linksection] = ACTIONS(1800),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1800),
    [anon_sym_BANG] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1800),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [892] = {
    [ts_builtin_sym_end] = ACTIONS(1804),
    [anon_sym_COMMA] = ACTIONS(1804),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1804),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1804),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [anon_sym_else] = ACTIONS(1804),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1804),
    [anon_sym_addrspace] = ACTIONS(1804),
    [anon_sym_linksection] = ACTIONS(1804),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1804),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1804),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [893] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1770),
    [anon_sym_orelse] = ACTIONS(1768),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1768),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [894] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_DASH_PERCENT] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1770),
    [anon_sym_orelse] = ACTIONS(1768),
    [anon_sym_LT_LT] = ACTIONS(1770),
    [anon_sym_GT_GT] = ACTIONS(1770),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1770),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_PLUS_PLUS] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1770),
    [anon_sym_PLUS_PIPE] = ACTIONS(1770),
    [anon_sym_DASH_PIPE] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1768),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [897] = {
    [ts_builtin_sym_end] = ACTIONS(1808),
    [anon_sym_COMMA] = ACTIONS(1808),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1808),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(1808),
    [anon_sym_RBRACE] = ACTIONS(1808),
    [anon_sym_else] = ACTIONS(1808),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1808),
    [anon_sym_addrspace] = ACTIONS(1808),
    [anon_sym_linksection] = ACTIONS(1808),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1808),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1808),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [898] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_STAR_EQ] = ACTIONS(1815),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1815),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1815),
    [anon_sym_SLASH_EQ] = ACTIONS(1815),
    [anon_sym_PERCENT_EQ] = ACTIONS(1815),
    [anon_sym_PLUS_EQ] = ACTIONS(1815),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1815),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1815),
    [anon_sym_DASH_EQ] = ACTIONS(1815),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1815),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1815),
    [anon_sym_LT_LT_EQ] = ACTIONS(1815),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1815),
    [anon_sym_GT_GT_EQ] = ACTIONS(1815),
    [anon_sym_AMP_EQ] = ACTIONS(1815),
    [anon_sym_CARET_EQ] = ACTIONS(1815),
    [anon_sym_PIPE_EQ] = ACTIONS(1815),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_else] = ACTIONS(1522),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_PIPE] = ACTIONS(1812),
    [anon_sym_STAR] = ACTIONS(1812),
    [anon_sym_align] = ACTIONS(1522),
    [anon_sym_addrspace] = ACTIONS(1522),
    [anon_sym_linksection] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1815),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1812),
    [anon_sym_DASH_PERCENT] = ACTIONS(1812),
    [anon_sym_AMP] = ACTIONS(1812),
    [anon_sym_or] = ACTIONS(1812),
    [anon_sym_and] = ACTIONS(1815),
    [anon_sym_EQ_EQ] = ACTIONS(1815),
    [anon_sym_BANG_EQ] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1812),
    [anon_sym_GT_EQ] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(1812),
    [anon_sym_CARET] = ACTIONS(1812),
    [anon_sym_orelse] = ACTIONS(1815),
    [anon_sym_LT_LT] = ACTIONS(1812),
    [anon_sym_GT_GT] = ACTIONS(1812),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1812),
    [anon_sym_PLUS] = ACTIONS(1812),
    [anon_sym_PLUS_PLUS] = ACTIONS(1815),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1812),
    [anon_sym_PLUS_PIPE] = ACTIONS(1812),
    [anon_sym_DASH_PIPE] = ACTIONS(1812),
    [anon_sym_SLASH] = ACTIONS(1812),
    [anon_sym_PERCENT] = ACTIONS(1812),
    [anon_sym_STAR_STAR] = ACTIONS(1815),
    [anon_sym_STAR_PERCENT] = ACTIONS(1812),
    [anon_sym_STAR_PIPE] = ACTIONS(1812),
    [anon_sym_PIPE_PIPE] = ACTIONS(1815),
    [anon_sym_catch] = ACTIONS(1815),
    [anon_sym_EQ_GT] = ACTIONS(1522),
    [anon_sym_DOT] = ACTIONS(1812),
    [anon_sym_DOT_STAR] = ACTIONS(1815),
    [anon_sym_DOT_QMARK] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
  },
  [899] = {
    [ts_builtin_sym_end] = ACTIONS(1818),
    [anon_sym_COMMA] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_STAR_EQ] = ACTIONS(1818),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1818),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1818),
    [anon_sym_SLASH_EQ] = ACTIONS(1818),
    [anon_sym_PERCENT_EQ] = ACTIONS(1818),
    [anon_sym_PLUS_EQ] = ACTIONS(1818),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1818),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1818),
    [anon_sym_DASH_EQ] = ACTIONS(1818),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1818),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1818),
    [anon_sym_LT_LT_EQ] = ACTIONS(1818),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1818),
    [anon_sym_GT_GT_EQ] = ACTIONS(1818),
    [anon_sym_AMP_EQ] = ACTIONS(1818),
    [anon_sym_CARET_EQ] = ACTIONS(1818),
    [anon_sym_PIPE_EQ] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_DOT_DOT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1820),
    [anon_sym_STAR] = ACTIONS(1820),
    [anon_sym_align] = ACTIONS(1818),
    [anon_sym_addrspace] = ACTIONS(1818),
    [anon_sym_linksection] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1818),
    [anon_sym_RBRACK] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1820),
    [anon_sym_DASH_PERCENT] = ACTIONS(1820),
    [anon_sym_AMP] = ACTIONS(1820),
    [anon_sym_or] = ACTIONS(1820),
    [anon_sym_and] = ACTIONS(1818),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1820),
    [anon_sym_GT_EQ] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1820),
    [anon_sym_CARET] = ACTIONS(1820),
    [anon_sym_orelse] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1820),
    [anon_sym_GT_GT] = ACTIONS(1820),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1820),
    [anon_sym_PLUS] = ACTIONS(1820),
    [anon_sym_PLUS_PLUS] = ACTIONS(1818),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1820),
    [anon_sym_PLUS_PIPE] = ACTIONS(1820),
    [anon_sym_DASH_PIPE] = ACTIONS(1820),
    [anon_sym_SLASH] = ACTIONS(1820),
    [anon_sym_PERCENT] = ACTIONS(1820),
    [anon_sym_STAR_STAR] = ACTIONS(1818),
    [anon_sym_STAR_PERCENT] = ACTIONS(1820),
    [anon_sym_STAR_PIPE] = ACTIONS(1820),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_catch] = ACTIONS(1818),
    [anon_sym_EQ_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1820),
    [anon_sym_DOT_STAR] = ACTIONS(1818),
    [anon_sym_DOT_QMARK] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
  },
  [900] = {
    [ts_builtin_sym_end] = ACTIONS(1822),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_else] = ACTIONS(1822),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1822),
    [anon_sym_addrspace] = ACTIONS(1822),
    [anon_sym_linksection] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1822),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [901] = {
    [ts_builtin_sym_end] = ACTIONS(1826),
    [anon_sym_COMMA] = ACTIONS(1826),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_LBRACE] = ACTIONS(1826),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_else] = ACTIONS(1826),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1826),
    [anon_sym_addrspace] = ACTIONS(1826),
    [anon_sym_linksection] = ACTIONS(1826),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1826),
    [anon_sym_BANG] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1826),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [902] = {
    [ts_builtin_sym_end] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(1830),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_else] = ACTIONS(1830),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1830),
    [anon_sym_addrspace] = ACTIONS(1830),
    [anon_sym_linksection] = ACTIONS(1830),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1830),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1830),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [ts_builtin_sym_end] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_else] = ACTIONS(1834),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1834),
    [anon_sym_addrspace] = ACTIONS(1834),
    [anon_sym_linksection] = ACTIONS(1834),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1834),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [904] = {
    [ts_builtin_sym_end] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_else] = ACTIONS(147),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(147),
    [anon_sym_addrspace] = ACTIONS(147),
    [anon_sym_linksection] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(147),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [905] = {
    [ts_builtin_sym_end] = ACTIONS(1838),
    [anon_sym_COMMA] = ACTIONS(1838),
    [anon_sym_EQ] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1838),
    [anon_sym_STAR_EQ] = ACTIONS(1838),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1838),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1838),
    [anon_sym_SLASH_EQ] = ACTIONS(1838),
    [anon_sym_PERCENT_EQ] = ACTIONS(1838),
    [anon_sym_PLUS_EQ] = ACTIONS(1838),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1838),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1838),
    [anon_sym_DASH_EQ] = ACTIONS(1838),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1838),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1838),
    [anon_sym_LT_LT_EQ] = ACTIONS(1838),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1838),
    [anon_sym_GT_GT_EQ] = ACTIONS(1838),
    [anon_sym_AMP_EQ] = ACTIONS(1838),
    [anon_sym_CARET_EQ] = ACTIONS(1838),
    [anon_sym_PIPE_EQ] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_else] = ACTIONS(1838),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1838),
    [anon_sym_addrspace] = ACTIONS(1838),
    [anon_sym_linksection] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1840),
    [anon_sym_and] = ACTIONS(1838),
    [anon_sym_EQ_EQ] = ACTIONS(1838),
    [anon_sym_BANG_EQ] = ACTIONS(1838),
    [anon_sym_GT] = ACTIONS(1840),
    [anon_sym_GT_EQ] = ACTIONS(1838),
    [anon_sym_LT_EQ] = ACTIONS(1838),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1838),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [906] = {
    [ts_builtin_sym_end] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(1842),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_else] = ACTIONS(1844),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1842),
    [anon_sym_addrspace] = ACTIONS(1842),
    [anon_sym_linksection] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1842),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [907] = {
    [ts_builtin_sym_end] = ACTIONS(1848),
    [anon_sym_COMMA] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1848),
    [anon_sym_else] = ACTIONS(1850),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1848),
    [anon_sym_addrspace] = ACTIONS(1848),
    [anon_sym_linksection] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [908] = {
    [ts_builtin_sym_end] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1854),
    [anon_sym_RBRACE] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1856),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1854),
    [anon_sym_addrspace] = ACTIONS(1854),
    [anon_sym_linksection] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1854),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [909] = {
    [ts_builtin_sym_end] = ACTIONS(1860),
    [anon_sym_COMMA] = ACTIONS(1860),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1860),
    [anon_sym_STAR_EQ] = ACTIONS(1860),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1860),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1860),
    [anon_sym_SLASH_EQ] = ACTIONS(1860),
    [anon_sym_PERCENT_EQ] = ACTIONS(1860),
    [anon_sym_PLUS_EQ] = ACTIONS(1860),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1860),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1860),
    [anon_sym_DASH_EQ] = ACTIONS(1860),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1860),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1860),
    [anon_sym_LT_LT_EQ] = ACTIONS(1860),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1860),
    [anon_sym_GT_GT_EQ] = ACTIONS(1860),
    [anon_sym_AMP_EQ] = ACTIONS(1860),
    [anon_sym_CARET_EQ] = ACTIONS(1860),
    [anon_sym_PIPE_EQ] = ACTIONS(1860),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_RPAREN] = ACTIONS(1860),
    [anon_sym_LBRACE] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_else] = ACTIONS(1860),
    [anon_sym_DOT_DOT] = ACTIONS(1860),
    [anon_sym_PIPE] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1862),
    [anon_sym_align] = ACTIONS(1860),
    [anon_sym_addrspace] = ACTIONS(1860),
    [anon_sym_linksection] = ACTIONS(1860),
    [anon_sym_LBRACK] = ACTIONS(1860),
    [anon_sym_RBRACK] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_DASH_PERCENT] = ACTIONS(1862),
    [anon_sym_AMP] = ACTIONS(1862),
    [anon_sym_or] = ACTIONS(1862),
    [anon_sym_and] = ACTIONS(1860),
    [anon_sym_EQ_EQ] = ACTIONS(1860),
    [anon_sym_BANG_EQ] = ACTIONS(1860),
    [anon_sym_GT] = ACTIONS(1862),
    [anon_sym_GT_EQ] = ACTIONS(1860),
    [anon_sym_LT_EQ] = ACTIONS(1860),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_CARET] = ACTIONS(1862),
    [anon_sym_orelse] = ACTIONS(1860),
    [anon_sym_LT_LT] = ACTIONS(1862),
    [anon_sym_GT_GT] = ACTIONS(1862),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_PLUS_PLUS] = ACTIONS(1860),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1862),
    [anon_sym_PLUS_PIPE] = ACTIONS(1862),
    [anon_sym_DASH_PIPE] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1862),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_STAR_STAR] = ACTIONS(1860),
    [anon_sym_STAR_PERCENT] = ACTIONS(1862),
    [anon_sym_STAR_PIPE] = ACTIONS(1862),
    [anon_sym_PIPE_PIPE] = ACTIONS(1860),
    [anon_sym_catch] = ACTIONS(1860),
    [anon_sym_EQ_GT] = ACTIONS(1860),
    [anon_sym_DOT] = ACTIONS(1862),
    [anon_sym_DOT_STAR] = ACTIONS(1860),
    [anon_sym_DOT_QMARK] = ACTIONS(1860),
    [sym_comment] = ACTIONS(3),
  },
  [910] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [911] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_COMMA] = ACTIONS(1768),
    [anon_sym_EQ] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_STAR_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_SLASH_EQ] = ACTIONS(1768),
    [anon_sym_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_DASH_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1768),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1768),
    [anon_sym_AMP_EQ] = ACTIONS(1768),
    [anon_sym_CARET_EQ] = ACTIONS(1768),
    [anon_sym_PIPE_EQ] = ACTIONS(1768),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1768),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1770),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1768),
    [anon_sym_addrspace] = ACTIONS(1768),
    [anon_sym_linksection] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_BANG] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1770),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_EQ_EQ] = ACTIONS(1768),
    [anon_sym_BANG_EQ] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1770),
    [anon_sym_GT_EQ] = ACTIONS(1768),
    [anon_sym_LT_EQ] = ACTIONS(1768),
    [anon_sym_LT] = ACTIONS(1770),
    [anon_sym_CARET] = ACTIONS(1770),
    [anon_sym_orelse] = ACTIONS(1768),
    [anon_sym_LT_LT] = ACTIONS(1770),
    [anon_sym_GT_GT] = ACTIONS(1770),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1770),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1768),
    [anon_sym_EQ_GT] = ACTIONS(1768),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [912] = {
    [ts_builtin_sym_end] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1864),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_STAR_EQ] = ACTIONS(1867),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1867),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1867),
    [anon_sym_SLASH_EQ] = ACTIONS(1867),
    [anon_sym_PERCENT_EQ] = ACTIONS(1867),
    [anon_sym_PLUS_EQ] = ACTIONS(1867),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1867),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1867),
    [anon_sym_DASH_EQ] = ACTIONS(1867),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1867),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1867),
    [anon_sym_LT_LT_EQ] = ACTIONS(1867),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1867),
    [anon_sym_GT_GT_EQ] = ACTIONS(1867),
    [anon_sym_AMP_EQ] = ACTIONS(1867),
    [anon_sym_CARET_EQ] = ACTIONS(1867),
    [anon_sym_PIPE_EQ] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1864),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_align] = ACTIONS(1532),
    [anon_sym_addrspace] = ACTIONS(1532),
    [anon_sym_linksection] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_DASH_PERCENT] = ACTIONS(1864),
    [anon_sym_AMP] = ACTIONS(1864),
    [anon_sym_or] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1867),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_GT_EQ] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_CARET] = ACTIONS(1864),
    [anon_sym_orelse] = ACTIONS(1867),
    [anon_sym_LT_LT] = ACTIONS(1864),
    [anon_sym_GT_GT] = ACTIONS(1864),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1864),
    [anon_sym_PLUS] = ACTIONS(1864),
    [anon_sym_PLUS_PLUS] = ACTIONS(1867),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1864),
    [anon_sym_PLUS_PIPE] = ACTIONS(1864),
    [anon_sym_DASH_PIPE] = ACTIONS(1864),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1864),
    [anon_sym_STAR_STAR] = ACTIONS(1867),
    [anon_sym_STAR_PERCENT] = ACTIONS(1864),
    [anon_sym_STAR_PIPE] = ACTIONS(1864),
    [anon_sym_PIPE_PIPE] = ACTIONS(1867),
    [anon_sym_catch] = ACTIONS(1867),
    [anon_sym_EQ_GT] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1864),
    [anon_sym_DOT_STAR] = ACTIONS(1867),
    [anon_sym_DOT_QMARK] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
  },
  [913] = {
    [ts_builtin_sym_end] = ACTIONS(1870),
    [anon_sym_COMMA] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1870),
    [anon_sym_STAR_EQ] = ACTIONS(1870),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1870),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1870),
    [anon_sym_SLASH_EQ] = ACTIONS(1870),
    [anon_sym_PERCENT_EQ] = ACTIONS(1870),
    [anon_sym_PLUS_EQ] = ACTIONS(1870),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1870),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1870),
    [anon_sym_DASH_EQ] = ACTIONS(1870),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1870),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1870),
    [anon_sym_LT_LT_EQ] = ACTIONS(1870),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1870),
    [anon_sym_GT_GT_EQ] = ACTIONS(1870),
    [anon_sym_AMP_EQ] = ACTIONS(1870),
    [anon_sym_CARET_EQ] = ACTIONS(1870),
    [anon_sym_PIPE_EQ] = ACTIONS(1870),
    [anon_sym_LPAREN] = ACTIONS(1870),
    [anon_sym_RPAREN] = ACTIONS(1870),
    [anon_sym_LBRACE] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1870),
    [anon_sym_else] = ACTIONS(1870),
    [anon_sym_DOT_DOT] = ACTIONS(1870),
    [anon_sym_PIPE] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1872),
    [anon_sym_align] = ACTIONS(1870),
    [anon_sym_addrspace] = ACTIONS(1870),
    [anon_sym_linksection] = ACTIONS(1870),
    [anon_sym_LBRACK] = ACTIONS(1870),
    [anon_sym_RBRACK] = ACTIONS(1870),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_DASH_PERCENT] = ACTIONS(1872),
    [anon_sym_AMP] = ACTIONS(1872),
    [anon_sym_or] = ACTIONS(1872),
    [anon_sym_and] = ACTIONS(1870),
    [anon_sym_EQ_EQ] = ACTIONS(1870),
    [anon_sym_BANG_EQ] = ACTIONS(1870),
    [anon_sym_GT] = ACTIONS(1872),
    [anon_sym_GT_EQ] = ACTIONS(1870),
    [anon_sym_LT_EQ] = ACTIONS(1870),
    [anon_sym_LT] = ACTIONS(1872),
    [anon_sym_CARET] = ACTIONS(1872),
    [anon_sym_orelse] = ACTIONS(1870),
    [anon_sym_LT_LT] = ACTIONS(1872),
    [anon_sym_GT_GT] = ACTIONS(1872),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_PLUS_PLUS] = ACTIONS(1870),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1872),
    [anon_sym_PLUS_PIPE] = ACTIONS(1872),
    [anon_sym_DASH_PIPE] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1872),
    [anon_sym_STAR_STAR] = ACTIONS(1870),
    [anon_sym_STAR_PERCENT] = ACTIONS(1872),
    [anon_sym_STAR_PIPE] = ACTIONS(1872),
    [anon_sym_PIPE_PIPE] = ACTIONS(1870),
    [anon_sym_catch] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1870),
    [anon_sym_DOT] = ACTIONS(1872),
    [anon_sym_DOT_STAR] = ACTIONS(1870),
    [anon_sym_DOT_QMARK] = ACTIONS(1870),
    [sym_comment] = ACTIONS(3),
  },
  [914] = {
    [ts_builtin_sym_end] = ACTIONS(1874),
    [anon_sym_COMMA] = ACTIONS(1874),
    [anon_sym_EQ] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_STAR_EQ] = ACTIONS(1874),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1874),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1874),
    [anon_sym_SLASH_EQ] = ACTIONS(1874),
    [anon_sym_PERCENT_EQ] = ACTIONS(1874),
    [anon_sym_PLUS_EQ] = ACTIONS(1874),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1874),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1874),
    [anon_sym_DASH_EQ] = ACTIONS(1874),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1874),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1874),
    [anon_sym_LT_LT_EQ] = ACTIONS(1874),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1874),
    [anon_sym_GT_GT_EQ] = ACTIONS(1874),
    [anon_sym_AMP_EQ] = ACTIONS(1874),
    [anon_sym_CARET_EQ] = ACTIONS(1874),
    [anon_sym_PIPE_EQ] = ACTIONS(1874),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1874),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_else] = ACTIONS(1874),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1874),
    [anon_sym_addrspace] = ACTIONS(1874),
    [anon_sym_linksection] = ACTIONS(1874),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1876),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1876),
    [anon_sym_and] = ACTIONS(1874),
    [anon_sym_EQ_EQ] = ACTIONS(1874),
    [anon_sym_BANG_EQ] = ACTIONS(1874),
    [anon_sym_GT] = ACTIONS(1876),
    [anon_sym_GT_EQ] = ACTIONS(1874),
    [anon_sym_LT_EQ] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1874),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [ts_builtin_sym_end] = ACTIONS(1878),
    [anon_sym_COMMA] = ACTIONS(1878),
    [anon_sym_EQ] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_STAR_EQ] = ACTIONS(1878),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1878),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1878),
    [anon_sym_SLASH_EQ] = ACTIONS(1878),
    [anon_sym_PERCENT_EQ] = ACTIONS(1878),
    [anon_sym_PLUS_EQ] = ACTIONS(1878),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1878),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1878),
    [anon_sym_DASH_EQ] = ACTIONS(1878),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1878),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1878),
    [anon_sym_LT_LT_EQ] = ACTIONS(1878),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1878),
    [anon_sym_GT_GT_EQ] = ACTIONS(1878),
    [anon_sym_AMP_EQ] = ACTIONS(1878),
    [anon_sym_CARET_EQ] = ACTIONS(1878),
    [anon_sym_PIPE_EQ] = ACTIONS(1878),
    [anon_sym_LPAREN] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_LBRACE] = ACTIONS(1878),
    [anon_sym_RBRACE] = ACTIONS(1878),
    [anon_sym_else] = ACTIONS(1878),
    [anon_sym_DOT_DOT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(1880),
    [anon_sym_STAR] = ACTIONS(1880),
    [anon_sym_align] = ACTIONS(1878),
    [anon_sym_addrspace] = ACTIONS(1878),
    [anon_sym_linksection] = ACTIONS(1878),
    [anon_sym_LBRACK] = ACTIONS(1878),
    [anon_sym_RBRACK] = ACTIONS(1878),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1880),
    [anon_sym_DASH_PERCENT] = ACTIONS(1880),
    [anon_sym_AMP] = ACTIONS(1880),
    [anon_sym_or] = ACTIONS(1880),
    [anon_sym_and] = ACTIONS(1878),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1880),
    [anon_sym_GT_EQ] = ACTIONS(1878),
    [anon_sym_LT_EQ] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1880),
    [anon_sym_CARET] = ACTIONS(1880),
    [anon_sym_orelse] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1880),
    [anon_sym_GT_GT] = ACTIONS(1880),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1880),
    [anon_sym_PLUS] = ACTIONS(1880),
    [anon_sym_PLUS_PLUS] = ACTIONS(1878),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1880),
    [anon_sym_PLUS_PIPE] = ACTIONS(1880),
    [anon_sym_DASH_PIPE] = ACTIONS(1880),
    [anon_sym_SLASH] = ACTIONS(1880),
    [anon_sym_PERCENT] = ACTIONS(1880),
    [anon_sym_STAR_STAR] = ACTIONS(1878),
    [anon_sym_STAR_PERCENT] = ACTIONS(1880),
    [anon_sym_STAR_PIPE] = ACTIONS(1880),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_catch] = ACTIONS(1878),
    [anon_sym_EQ_GT] = ACTIONS(1878),
    [anon_sym_DOT] = ACTIONS(1880),
    [anon_sym_DOT_STAR] = ACTIONS(1878),
    [anon_sym_DOT_QMARK] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
  },
  [916] = {
    [ts_builtin_sym_end] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(1740),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_else] = ACTIONS(1882),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1740),
    [anon_sym_addrspace] = ACTIONS(1740),
    [anon_sym_linksection] = ACTIONS(1740),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1740),
    [anon_sym_BANG] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1740),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [917] = {
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(1884),
    [anon_sym_EQ] = ACTIONS(1886),
    [anon_sym_SEMI] = ACTIONS(1884),
    [anon_sym_STAR_EQ] = ACTIONS(1884),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1884),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1884),
    [anon_sym_SLASH_EQ] = ACTIONS(1884),
    [anon_sym_PERCENT_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1884),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1884),
    [anon_sym_DASH_EQ] = ACTIONS(1884),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1884),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1884),
    [anon_sym_LT_LT_EQ] = ACTIONS(1884),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1884),
    [anon_sym_GT_GT_EQ] = ACTIONS(1884),
    [anon_sym_AMP_EQ] = ACTIONS(1884),
    [anon_sym_CARET_EQ] = ACTIONS(1884),
    [anon_sym_PIPE_EQ] = ACTIONS(1884),
    [anon_sym_LPAREN] = ACTIONS(1884),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_LBRACE] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [anon_sym_else] = ACTIONS(1884),
    [anon_sym_DOT_DOT] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1886),
    [anon_sym_align] = ACTIONS(1884),
    [anon_sym_addrspace] = ACTIONS(1884),
    [anon_sym_linksection] = ACTIONS(1884),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [anon_sym_RBRACK] = ACTIONS(1884),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1886),
    [anon_sym_DASH_PERCENT] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [anon_sym_or] = ACTIONS(1886),
    [anon_sym_and] = ACTIONS(1884),
    [anon_sym_EQ_EQ] = ACTIONS(1884),
    [anon_sym_BANG_EQ] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_GT_EQ] = ACTIONS(1884),
    [anon_sym_LT_EQ] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_CARET] = ACTIONS(1886),
    [anon_sym_orelse] = ACTIONS(1884),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1886),
    [anon_sym_PLUS] = ACTIONS(1886),
    [anon_sym_PLUS_PLUS] = ACTIONS(1884),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1886),
    [anon_sym_PLUS_PIPE] = ACTIONS(1886),
    [anon_sym_DASH_PIPE] = ACTIONS(1886),
    [anon_sym_SLASH] = ACTIONS(1886),
    [anon_sym_PERCENT] = ACTIONS(1886),
    [anon_sym_STAR_STAR] = ACTIONS(1884),
    [anon_sym_STAR_PERCENT] = ACTIONS(1886),
    [anon_sym_STAR_PIPE] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1884),
    [anon_sym_catch] = ACTIONS(1884),
    [anon_sym_EQ_GT] = ACTIONS(1884),
    [anon_sym_DOT] = ACTIONS(1886),
    [anon_sym_DOT_STAR] = ACTIONS(1884),
    [anon_sym_DOT_QMARK] = ACTIONS(1884),
    [sym_comment] = ACTIONS(3),
  },
  [918] = {
    [ts_builtin_sym_end] = ACTIONS(1644),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1644),
    [anon_sym_addrspace] = ACTIONS(1644),
    [anon_sym_linksection] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1644),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [919] = {
    [ts_builtin_sym_end] = ACTIONS(1888),
    [anon_sym_COMMA] = ACTIONS(1888),
    [anon_sym_EQ] = ACTIONS(1890),
    [anon_sym_SEMI] = ACTIONS(1888),
    [anon_sym_STAR_EQ] = ACTIONS(1888),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1888),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1888),
    [anon_sym_SLASH_EQ] = ACTIONS(1888),
    [anon_sym_PERCENT_EQ] = ACTIONS(1888),
    [anon_sym_PLUS_EQ] = ACTIONS(1888),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1888),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1888),
    [anon_sym_DASH_EQ] = ACTIONS(1888),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1888),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1888),
    [anon_sym_LT_LT_EQ] = ACTIONS(1888),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1888),
    [anon_sym_GT_GT_EQ] = ACTIONS(1888),
    [anon_sym_AMP_EQ] = ACTIONS(1888),
    [anon_sym_CARET_EQ] = ACTIONS(1888),
    [anon_sym_PIPE_EQ] = ACTIONS(1888),
    [anon_sym_LPAREN] = ACTIONS(1888),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_LBRACE] = ACTIONS(1888),
    [anon_sym_RBRACE] = ACTIONS(1888),
    [anon_sym_else] = ACTIONS(1888),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1890),
    [anon_sym_align] = ACTIONS(1888),
    [anon_sym_addrspace] = ACTIONS(1888),
    [anon_sym_linksection] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(1888),
    [anon_sym_RBRACK] = ACTIONS(1888),
    [anon_sym_BANG] = ACTIONS(1612),
    [anon_sym_DASH] = ACTIONS(1890),
    [anon_sym_DASH_PERCENT] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
    [anon_sym_or] = ACTIONS(1890),
    [anon_sym_and] = ACTIONS(1888),
    [anon_sym_EQ_EQ] = ACTIONS(1888),
    [anon_sym_BANG_EQ] = ACTIONS(1888),
    [anon_sym_GT] = ACTIONS(1890),
    [anon_sym_GT_EQ] = ACTIONS(1888),
    [anon_sym_LT_EQ] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(1890),
    [anon_sym_CARET] = ACTIONS(1890),
    [anon_sym_orelse] = ACTIONS(1888),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1890),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_PLUS_PLUS] = ACTIONS(1888),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1890),
    [anon_sym_PLUS_PIPE] = ACTIONS(1890),
    [anon_sym_DASH_PIPE] = ACTIONS(1890),
    [anon_sym_SLASH] = ACTIONS(1890),
    [anon_sym_PERCENT] = ACTIONS(1890),
    [anon_sym_STAR_STAR] = ACTIONS(1888),
    [anon_sym_STAR_PERCENT] = ACTIONS(1890),
    [anon_sym_STAR_PIPE] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1888),
    [anon_sym_catch] = ACTIONS(1888),
    [anon_sym_EQ_GT] = ACTIONS(1888),
    [anon_sym_DOT] = ACTIONS(1890),
    [anon_sym_DOT_STAR] = ACTIONS(1888),
    [anon_sym_DOT_QMARK] = ACTIONS(1888),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [ts_builtin_sym_end] = ACTIONS(1892),
    [anon_sym_COMMA] = ACTIONS(1892),
    [anon_sym_EQ] = ACTIONS(1894),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_STAR_EQ] = ACTIONS(1892),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1892),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1892),
    [anon_sym_SLASH_EQ] = ACTIONS(1892),
    [anon_sym_PERCENT_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1892),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1892),
    [anon_sym_DASH_EQ] = ACTIONS(1892),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1892),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1892),
    [anon_sym_LT_LT_EQ] = ACTIONS(1892),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1892),
    [anon_sym_GT_GT_EQ] = ACTIONS(1892),
    [anon_sym_AMP_EQ] = ACTIONS(1892),
    [anon_sym_CARET_EQ] = ACTIONS(1892),
    [anon_sym_PIPE_EQ] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1892),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_RBRACE] = ACTIONS(1892),
    [anon_sym_else] = ACTIONS(1892),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1894),
    [anon_sym_STAR] = ACTIONS(1894),
    [anon_sym_align] = ACTIONS(1892),
    [anon_sym_addrspace] = ACTIONS(1892),
    [anon_sym_linksection] = ACTIONS(1892),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1892),
    [anon_sym_BANG] = ACTIONS(1894),
    [anon_sym_DASH] = ACTIONS(1894),
    [anon_sym_DASH_PERCENT] = ACTIONS(1894),
    [anon_sym_AMP] = ACTIONS(1894),
    [anon_sym_or] = ACTIONS(1894),
    [anon_sym_and] = ACTIONS(1892),
    [anon_sym_EQ_EQ] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1894),
    [anon_sym_GT_EQ] = ACTIONS(1892),
    [anon_sym_LT_EQ] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1894),
    [anon_sym_CARET] = ACTIONS(1894),
    [anon_sym_orelse] = ACTIONS(1892),
    [anon_sym_LT_LT] = ACTIONS(1894),
    [anon_sym_GT_GT] = ACTIONS(1894),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1894),
    [anon_sym_PLUS] = ACTIONS(1894),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1894),
    [anon_sym_PLUS_PIPE] = ACTIONS(1894),
    [anon_sym_DASH_PIPE] = ACTIONS(1894),
    [anon_sym_SLASH] = ACTIONS(1894),
    [anon_sym_PERCENT] = ACTIONS(1894),
    [anon_sym_STAR_STAR] = ACTIONS(1892),
    [anon_sym_STAR_PERCENT] = ACTIONS(1894),
    [anon_sym_STAR_PIPE] = ACTIONS(1894),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_catch] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1892),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
  [921] = {
    [ts_builtin_sym_end] = ACTIONS(1896),
    [anon_sym_COMMA] = ACTIONS(1896),
    [anon_sym_EQ] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1896),
    [anon_sym_STAR_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_SLASH_EQ] = ACTIONS(1568),
    [anon_sym_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_DASH_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1568),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_EQ] = ACTIONS(1568),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_GT_GT_EQ] = ACTIONS(1568),
    [anon_sym_AMP_EQ] = ACTIONS(1568),
    [anon_sym_CARET_EQ] = ACTIONS(1568),
    [anon_sym_PIPE_EQ] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1896),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_else] = ACTIONS(1896),
    [anon_sym_DOT_DOT] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_align] = ACTIONS(1896),
    [anon_sym_addrspace] = ACTIONS(1896),
    [anon_sym_linksection] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_DASH_PERCENT] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_or] = ACTIONS(1584),
    [anon_sym_and] = ACTIONS(1586),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_orelse] = ACTIONS(1592),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_PLUS_PLUS] = ACTIONS(1596),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1582),
    [anon_sym_PLUS_PIPE] = ACTIONS(1582),
    [anon_sym_DASH_PIPE] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_STAR] = ACTIONS(1598),
    [anon_sym_STAR_PERCENT] = ACTIONS(1576),
    [anon_sym_STAR_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1598),
    [anon_sym_catch] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1896),
    [anon_sym_DOT] = ACTIONS(1602),
    [anon_sym_DOT_STAR] = ACTIONS(1604),
    [anon_sym_DOT_QMARK] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1616), 1,
      anon_sym_EQ,
    ACTIONS(1900), 1,
      anon_sym_else,
    ACTIONS(1614), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_align,
      anon_sym_addrspace,
      anon_sym_linksection,
    ACTIONS(915), 21,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [79] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1904), 1,
      anon_sym_EQ,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1908), 1,
      anon_sym_addrspace,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1495), 1,
      sym_byte_alignment,
    STATE(1528), 1,
      sym_address_space,
    STATE(1634), 1,
      sym_link_section,
    ACTIONS(1902), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(915), 21,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [168] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1916), 1,
      anon_sym_else,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1854), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 1,
      aux_sym_multiline_string_token1,
    STATE(930), 1,
      aux_sym_multiline_string_repeat1,
    ACTIONS(1286), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1284), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [352] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1630), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1628), 30,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [450] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1644), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [558] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1946), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1557), 1,
      sym_byte_alignment,
    ACTIONS(1944), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [640] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1564), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 1,
      aux_sym_multiline_string_token1,
    STATE(930), 1,
      aux_sym_multiline_string_repeat1,
    ACTIONS(1279), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1277), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [822] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1656), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [930] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1686), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1038] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 26,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_GT,
  [1140] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1656), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1248] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1951), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1734), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1800), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1466] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1953), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1740), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1576] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(1768), 32,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [1668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1790), 1,
      anon_sym_EQ,
    ACTIONS(1788), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_align,
      anon_sym_addrspace,
      anon_sym_linksection,
    ACTIONS(915), 21,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [1744] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1796), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1852] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1957), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1563), 1,
      sym_byte_alignment,
    ACTIONS(1955), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [1934] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1770), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 30,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [2032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(165), 1,
      anon_sym_COLON,
    STATE(1191), 1,
      sym_break_label,
    ACTIONS(1298), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1296), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [2106] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1768), 32,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [2196] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1690), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1961), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1556), 1,
      sym_byte_alignment,
    ACTIONS(1959), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [2386] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1632), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1965), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1562), 1,
      sym_byte_alignment,
    ACTIONS(1963), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [2576] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1682), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2684] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1967), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1644), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2794] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1770), 16,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 33,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [2880] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1678), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2988] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1624), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1762), 1,
      anon_sym_EQ,
    ACTIONS(1760), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_align,
      anon_sym_addrspace,
      anon_sym_linksection,
    ACTIONS(915), 21,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [3172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1718), 1,
      anon_sym_EQ,
    ACTIONS(1716), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_align,
      anon_sym_addrspace,
      anon_sym_linksection,
    ACTIONS(915), 21,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [3248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1564), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 1,
      anon_sym_SEMI,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    STATE(709), 1,
      sym_block,
    ACTIONS(1414), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1412), 36,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_align,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [3432] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1896), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3540] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1804), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3648] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1640), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3756] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1876), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1874), 30,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [3854] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1973), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1842), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [3964] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1830), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4072] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1975), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1740), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4182] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1822), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4290] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1826), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4398] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [4502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(147), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4610] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1808), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4718] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1977), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1650), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1979), 1,
      anon_sym_else,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1848), 7,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1983), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1537), 1,
      sym_byte_alignment,
    ACTIONS(1981), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5020] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1987), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_initializer_list,
    STATE(1550), 1,
      sym_byte_alignment,
    ACTIONS(1985), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1292), 22,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5102] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1840), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1838), 30,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [5200] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1834), 8,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_COLON,
    ACTIONS(1393), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1388), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_COLON,
    ACTIONS(943), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1480), 37,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_align,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_COLON,
    ACTIONS(1491), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1488), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(992), 1,
      sym_initializer_list,
    ACTIONS(1292), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_align,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LBRACE,
    STATE(992), 1,
      sym_initializer_list,
    ACTIONS(1292), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_align,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [5947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_align,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 1,
      anon_sym_COLON,
    ACTIONS(943), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_DASH_GT,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_DASH_GT,
    ACTIONS(943), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6231] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1770), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 27,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [6327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1514), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1518), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1476), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(927), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(925), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1502), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1506), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1552), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1372), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1662), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1660), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [6941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1732), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1730), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1886), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1884), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1494), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1368), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1300), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1528), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7353] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1894), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1892), 32,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [7433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1320), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1890), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1888), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1348), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1472), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1332), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1342), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1340), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1344), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1352), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [7979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1356), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1396), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1786), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1784), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1638), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1636), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1676), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1674), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1456), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1468), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1384), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1400), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1404), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1424), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1436), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1460), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1556), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [8937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1376), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1316), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1380), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1862), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1860), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1754), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1752), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1408), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1416), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1420), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1522), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1532), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1548), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1560), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1872), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1870), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1610), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1608), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1672), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1670), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [9967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(771), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(769), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1538), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1304), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1362), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1360), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1364), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1498), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1510), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1308), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1312), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1336), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1820), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1818), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(775), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(773), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1432), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1442), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1440), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1452), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [10989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1464), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(763), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(761), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(749), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1542), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1324), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1788), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1790), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1793), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(657), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(655), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1502), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1724), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1727), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(661), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(659), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1662), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1660), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1732), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1730), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1886), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1884), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [11819] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1894), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1892), 32,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [11899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1770), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1768), 32,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [11979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1890), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1888), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1348), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1710), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1713), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1472), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1746), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1749), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1786), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1784), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1638), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1636), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1676), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1674), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1556), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1778), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1781), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1376), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1700), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1703), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1862), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1860), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1754), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1752), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1522), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1812), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1815), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1532), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1864), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1867), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1872), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1870), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1610), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1608), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [12971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1672), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1670), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1498), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1694), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1697), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1510), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1772), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1775), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1820), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1818), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1464), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1664), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1667), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(2037), 1,
      anon_sym_else,
    ACTIONS(1614), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(1616), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1619), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1502), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1724), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1727), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1348), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1710), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1713), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1472), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1746), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1749), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1716), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1718), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1721), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1556), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1778), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1781), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1376), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1700), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1703), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1760), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(1762), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1765), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1522), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1812), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1815), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [13977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1532), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1864), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1867), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1498), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1694), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1697), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1510), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1772), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1775), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1464), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1664), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1667), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1788), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1790), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1793), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(2039), 1,
      anon_sym_else,
    ACTIONS(1614), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(1616), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1619), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1716), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1718), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1721), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1760), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(1762), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1765), 31,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1880), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1878), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1708), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1706), 32,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [14775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1758), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1756), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BANG,
    ACTIONS(1430), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1428), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [14915] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1738), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2045), 1,
      anon_sym_else,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1734), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15025] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1744), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2071), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1740), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15135] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1898), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1896), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15243] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1802), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1800), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15351] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 8,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(1768), 29,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [15441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1770), 17,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 30,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_catch,
  [15525] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1770), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 22,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
  [15627] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1770), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 23,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
  [15727] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1770), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 27,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [15823] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 11,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1768), 29,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [15911] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1876), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1874), 27,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [16007] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1744), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2073), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1740), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16117] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1798), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1796), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1648), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1644), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16333] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1626), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1624), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16441] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1630), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1628), 27,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [16537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1648), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2075), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1644), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16647] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1654), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2077), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1650), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16757] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1684), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1682), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16865] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_BANG,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1564), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [16973] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1634), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1632), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17081] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1642), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1640), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17189] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_BANG,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1564), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17297] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1658), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1656), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17405] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1680), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1678), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17513] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1688), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1686), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17621] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1658), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1656), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17729] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1692), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1690), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17837] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2083), 1,
      anon_sym_else,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1734), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17947] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1744), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2093), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1740), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18057] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1898), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1896), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18165] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1800), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18273] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 8,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(1768), 29,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [18363] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1770), 17,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 30,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [18447] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1770), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 22,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
  [18549] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1770), 3,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 23,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_GT,
  [18649] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 11,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1768), 29,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [18737] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1876), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1874), 27,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [18833] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1744), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2095), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1740), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18943] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1796), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19051] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1644), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19159] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1624), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19267] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1630), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1628), 27,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [19363] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2097), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1644), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2099), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1650), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19583] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1682), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19691] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1564), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19799] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1632), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19907] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1640), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20015] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1564), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20123] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1656), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20231] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1678), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20339] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1686), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20447] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1656), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20555] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1692), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1690), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20663] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1810), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1808), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20771] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1824), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1822), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20879] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1828), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1826), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20987] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1832), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1830), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21095] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1836), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1834), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21203] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_BANG,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(147), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21311] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1840), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1838), 27,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1852), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2101), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1848), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21517] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1858), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2103), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1854), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [21695] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1806), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1804), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21803] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1846), 1,
      anon_sym_BANG,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2041), 1,
      anon_sym_EQ,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2055), 1,
      anon_sym_and,
    ACTIONS(2061), 1,
      anon_sym_orelse,
    ACTIONS(2065), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2069), 1,
      anon_sym_catch,
    ACTIONS(2105), 1,
      anon_sym_else,
    ACTIONS(2059), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2067), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2063), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1842), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
    ACTIONS(2057), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2049), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2051), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2043), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1488), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [21981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1388), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1290), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(915), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1412), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 37,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1880), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1878), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1708), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1706), 32,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [22609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1758), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1756), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1328), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 1,
      anon_sym_BANG,
    ACTIONS(1430), 23,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1428), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1428), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1444), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [22953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1448), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [23021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 24,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1484), 36,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_EQ_GT,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [23089] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1804), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23197] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1808), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23305] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1822), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23413] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1826), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23521] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1830), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23629] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1834), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23737] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(149), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(147), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23845] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1840), 5,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1838), 27,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [23941] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2107), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1842), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24051] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2109), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1848), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24161] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_BANG,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      anon_sym_orelse,
    ACTIONS(2019), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2023), 1,
      anon_sym_catch,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2079), 1,
      anon_sym_EQ,
    ACTIONS(2085), 1,
      anon_sym_or,
    ACTIONS(2087), 1,
      anon_sym_and,
    ACTIONS(2111), 1,
      anon_sym_else,
    ACTIONS(2021), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2007), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2017), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1854), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    ACTIONS(2089), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2009), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2013), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2081), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24271] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1770), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1768), 32,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [24351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1788), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24422] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    STATE(1638), 1,
      aux_sym__for_prefix_repeat1,
    ACTIONS(1894), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1892), 30,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [24503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1716), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1760), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      anon_sym_COLON,
    ACTIONS(943), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(941), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [24921] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2125), 1,
      anon_sym_else,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1740), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25027] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2155), 1,
      anon_sym_else,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1854), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25133] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1822), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25237] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1826), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25341] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1830), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25445] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1834), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25549] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(147), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25653] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1840), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1838), 26,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25747] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2181), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1842), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25853] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2183), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1848), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25959] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2185), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1854), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26065] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1734), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2189), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26175] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2191), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26285] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2193), 1,
      anon_sym_COMMA,
    ACTIONS(2195), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2197), 1,
      anon_sym_EQ_GT,
    STATE(1617), 1,
      aux_sym__switch_case_exp_repeat1,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26395] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2199), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26505] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1842), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2201), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26615] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1894), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1892), 30,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [26693] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1848), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2203), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26803] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1854), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2205), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26913] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_EQ_GT,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2207), 1,
      anon_sym_COMMA,
    ACTIONS(2209), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1574), 1,
      aux_sym__switch_case_exp_repeat1,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27023] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1800), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2211), 1,
      anon_sym_else,
    ACTIONS(1614), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27199] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2213), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1734), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27305] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2215), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1740), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27411] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1896), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27515] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1896), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(1768), 28,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [27707] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1800), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27811] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(1768), 28,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [27899] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1632), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1770), 16,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 29,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [28085] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 21,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
  [28185] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 22,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_GT,
  [28283] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1770), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 26,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [28377] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1768), 28,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_EQ_GT,
  [28463] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1876), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1874), 26,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [28557] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1640), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28661] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2220), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2217), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28767] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2225), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2222), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28873] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2227), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1740), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 23,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(1448), 35,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29045] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1770), 16,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 29,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_catch,
  [29127] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1644), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2229), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29237] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2187), 1,
      anon_sym_SEMI,
    ACTIONS(2231), 1,
      anon_sym_else,
    STATE(730), 1,
      sym_else_clause,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29347] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1564), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29451] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1656), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29555] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1796), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29659] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1644), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29763] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1624), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29867] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2233), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1644), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29973] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2235), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1650), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30079] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1682), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30183] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1564), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30287] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1804), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30391] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 21,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
  [30491] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1632), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30595] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1640), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30699] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1564), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30803] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1656), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30907] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(1770), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 22,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
  [31005] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1770), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1768), 26,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1768), 28,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [31185] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1876), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1874), 26,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31279] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1678), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31383] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1808), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1686), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31591] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1656), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31695] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1796), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31799] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1644), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31903] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1804), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32007] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1624), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32111] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1690), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32215] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1808), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32319] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1822), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32423] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1826), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32527] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2237), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1734), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32633] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1830), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32737] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1834), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32841] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(147), 4,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32945] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1840), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1838), 26,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [33039] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1678), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33143] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1686), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33247] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1656), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33351] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1630), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1628), 26,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33445] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2239), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1644), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33551] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2241), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1650), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33657] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2243), 1,
      anon_sym_else,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1740), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33763] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1690), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33867] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1682), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [33971] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1564), 4,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_else,
      anon_sym_RBRACK,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2245), 1,
      anon_sym_else,
    ACTIONS(1614), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [34147] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2247), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1842), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34253] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2249), 1,
      anon_sym_else,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1848), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34359] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1630), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1628), 26,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
  [34453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2251), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34556] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_EQ_GT,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2253), 1,
      anon_sym_COMMA,
    STATE(1599), 1,
      aux_sym__switch_case_exp_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34663] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2255), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2257), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1522), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [34938] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1532), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [35114] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2267), 1,
      anon_sym_COMMA,
    ACTIONS(2269), 1,
      anon_sym_RPAREN,
    STATE(1596), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35221] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35328] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2271), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35431] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2274), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35534] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2277), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [35710] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2279), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [35779] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2281), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35882] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2283), 1,
      anon_sym_COLON,
    ACTIONS(2285), 1,
      anon_sym_RPAREN,
    STATE(1761), 1,
      sym_asm_output,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35989] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2287), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2289), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [36161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2292), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [36230] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2294), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36333] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2296), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36436] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2299), 1,
      anon_sym_COMMA,
    ACTIONS(2301), 1,
      anon_sym_RPAREN,
    ACTIONS(2303), 1,
      anon_sym_DOT_DOT,
    STATE(1620), 1,
      aux_sym__for_prefix_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2305), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [36612] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2307), 1,
      anon_sym_COMMA,
    ACTIONS(2309), 1,
      anon_sym_RBRACE,
    STATE(1583), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36719] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2311), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36822] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2283), 1,
      anon_sym_COLON,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    STATE(1722), 1,
      sym_asm_output,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36929] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37036] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2315), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37139] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37246] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2283), 1,
      anon_sym_COLON,
    ACTIONS(2317), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_asm_output,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37353] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37460] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37567] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2319), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37670] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37777] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2321), 1,
      anon_sym_COMMA,
    ACTIONS(2323), 1,
      anon_sym_RBRACE,
    STATE(1631), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [37884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1502), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [37953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2325), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [38022] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2329), 1,
      anon_sym_RPAREN,
    STATE(1636), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38129] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2151), 1,
      anon_sym_EQ,
    ACTIONS(2163), 1,
      anon_sym_or,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2171), 1,
      anon_sym_orelse,
    ACTIONS(2175), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2179), 1,
      anon_sym_catch,
    ACTIONS(2333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2169), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2177), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(2157), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2173), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2167), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2159), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2161), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2153), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38234] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_EQ_GT,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2335), 1,
      anon_sym_COMMA,
    STATE(1590), 1,
      aux_sym__switch_case_exp_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1464), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [38410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1376), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [38479] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2337), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38582] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38689] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2339), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1498), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [38861] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2283), 1,
      anon_sym_COLON,
    ACTIONS(2341), 1,
      anon_sym_RPAREN,
    STATE(1718), 1,
      sym_asm_output,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [38968] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2343), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1510), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [39140] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2345), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [39316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    ACTIONS(2349), 1,
      anon_sym_RPAREN,
    STATE(1611), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1348), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [39492] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39599] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1472), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [39775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(1556), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [39844] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2351), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39947] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2353), 1,
      anon_sym_COMMA,
    ACTIONS(2355), 1,
      anon_sym_RPAREN,
    STATE(1572), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40054] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40161] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40268] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_EQ,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2265), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40375] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2357), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40477] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2359), 1,
      anon_sym_COLON,
    ACTIONS(2361), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40581] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40683] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2365), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40785] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2369), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40889] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2371), 1,
      anon_sym_COLON,
    ACTIONS(2373), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40993] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1808), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_BANG,
    ACTIONS(2375), 1,
      anon_sym_RPAREN,
    ACTIONS(915), 22,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT,
    ACTIONS(917), 32,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_LBRACK,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [41165] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2377), 1,
      anon_sym_COLON,
    ACTIONS(2379), 1,
      anon_sym_RPAREN,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41269] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2381), 1,
      anon_sym_COLON,
    ACTIONS(2383), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41373] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2385), 1,
      anon_sym_COLON,
    ACTIONS(2387), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41477] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2389), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41579] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2391), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41681] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2393), 1,
      anon_sym_COLON,
    ACTIONS(2395), 1,
      anon_sym_RBRACK,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41785] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2397), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41886] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2399), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41987] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2401), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42088] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2403), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42189] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2405), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42290] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2407), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42391] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2263), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42492] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2409), 1,
      anon_sym_COMMA,
    ACTIONS(2411), 1,
      anon_sym_EQ,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42593] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2413), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42694] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2415), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42795] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2417), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42896] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2419), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2421), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43098] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2423), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2425), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43300] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2427), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43401] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2429), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2431), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43603] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2433), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43704] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2435), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43805] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2437), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [43906] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2439), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44007] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2441), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44108] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2443), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44209] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2445), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44310] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2447), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44411] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2449), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44512] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2451), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44613] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2453), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44714] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2455), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44815] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2457), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44916] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2459), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45017] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2461), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45118] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2463), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45219] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1708), 21,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1706), 28,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_else,
      anon_sym_and,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_orelse,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_catch,
  [45294] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1973), 1,
      anon_sym_else,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45395] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2467), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45496] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2469), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45597] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2471), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45698] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2473), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45799] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2475), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45900] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2477), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1973), 1,
      anon_sym_else,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46102] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2479), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46203] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2481), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46304] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2483), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46405] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2485), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46506] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2487), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46607] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2489), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46708] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2491), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46809] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2493), 1,
      anon_sym_RBRACK,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46910] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2495), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47011] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2497), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47112] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2499), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47213] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2501), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47314] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2503), 1,
      anon_sym_SEMI,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47415] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2505), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47516] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2507), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47617] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2509), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47718] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2511), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2121), 1,
      anon_sym_EQ,
    ACTIONS(2133), 1,
      anon_sym_or,
    ACTIONS(2135), 1,
      anon_sym_and,
    ACTIONS(2141), 1,
      anon_sym_orelse,
    ACTIONS(2145), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(2149), 1,
      anon_sym_catch,
    ACTIONS(2513), 1,
      anon_sym_COLON,
    ACTIONS(2139), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2147), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(2127), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2143), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(2137), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2129), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(2131), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(2123), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47920] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2515), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48021] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2517), 1,
      anon_sym_RPAREN,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48122] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48220] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48318] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2003), 1,
      anon_sym_LPAREN,
    ACTIONS(2011), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      anon_sym_DOT,
    ACTIONS(2027), 1,
      anon_sym_DOT_STAR,
    ACTIONS(2029), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48416] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(2033), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48514] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1602), 1,
      anon_sym_DOT,
    ACTIONS(1604), 1,
      anon_sym_DOT_STAR,
    ACTIONS(1606), 1,
      anon_sym_DOT_QMARK,
    ACTIONS(1912), 1,
      anon_sym_EQ,
    ACTIONS(1924), 1,
      anon_sym_or,
    ACTIONS(1926), 1,
      anon_sym_and,
    ACTIONS(1932), 1,
      anon_sym_orelse,
    ACTIONS(1936), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1940), 1,
      anon_sym_catch,
    ACTIONS(1930), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1938), 2,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
    ACTIONS(1918), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1934), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1928), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1922), 6,
      anon_sym_DASH,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1914), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48612] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 1,
      anon_sym_test,
    ACTIONS(2521), 1,
      anon_sym_comptime,
    ACTIONS(2523), 1,
      anon_sym_export,
    ACTIONS(2525), 1,
      anon_sym_extern,
    ACTIONS(2527), 1,
      anon_sym_threadlocal,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2535), 1,
      anon_sym_usingnamespace,
    STATE(1612), 1,
      sym__function_prototype,
    STATE(1693), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
    ACTIONS(2531), 2,
      anon_sym_inline,
      anon_sym_noinline,
  [48651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(712), 1,
      sym_block,
    STATE(1668), 2,
      sym_string,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48681] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(2527), 1,
      anon_sym_threadlocal,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2539), 1,
      anon_sym_struct,
    ACTIONS(2541), 1,
      anon_sym_opaque,
    ACTIONS(2543), 1,
      anon_sym_enum,
    ACTIONS(2545), 1,
      anon_sym_union,
    STATE(1512), 1,
      sym_string,
    STATE(1582), 1,
      sym__function_prototype,
    STATE(1702), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [48719] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(693), 1,
      sym_block,
    STATE(1654), 2,
      sym_string,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48749] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2547), 1,
      anon_sym_PIPE,
    ACTIONS(2549), 1,
      anon_sym_STAR,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1678), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1908), 1,
      anon_sym_addrspace,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    ACTIONS(2553), 1,
      anon_sym_COLON,
    STATE(1496), 1,
      sym_byte_alignment,
    STATE(1519), 1,
      sym_address_space,
    STATE(1645), 1,
      sym_link_section,
    ACTIONS(2551), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [48805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(85), 1,
      sym_parameters,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1660), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(86), 1,
      sym_parameters,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1659), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2549), 1,
      anon_sym_STAR,
    ACTIONS(2557), 1,
      anon_sym_PIPE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1678), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(815), 1,
      sym_initializer_list,
    STATE(816), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2549), 1,
      anon_sym_STAR,
    ACTIONS(2559), 1,
      anon_sym_PIPE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1678), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LBRACE,
    ACTIONS(2561), 1,
      anon_sym_AT,
    STATE(665), 1,
      sym__reserved_identifier,
    STATE(1194), 1,
      sym_initializer_list,
    STATE(1195), 1,
      sym_identifier,
    ACTIONS(161), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_parameters,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1662), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [48987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(88), 1,
      sym_parameters,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1689), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 1,
      anon_sym_LBRACE,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(815), 1,
      sym_initializer_list,
    STATE(1257), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2563), 1,
      anon_sym_DASH_GT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1751), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2549), 1,
      anon_sym_STAR,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1678), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2565), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1655), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2567), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1597), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2569), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1655), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2571), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1655), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2573), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1585), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2575), 1,
      anon_sym_inline,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(199), 1,
      sym__for_prefix,
    STATE(200), 1,
      sym__while_prefix,
    STATE(663), 1,
      sym_block,
    STATE(753), 2,
      sym_for_statement,
      sym_while_statement,
  [49229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2581), 1,
      anon_sym_RBRACE,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1655), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_STAR,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1629), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(1908), 1,
      anon_sym_addrspace,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1495), 1,
      sym_byte_alignment,
    STATE(1528), 1,
      sym_address_space,
    STATE(1634), 1,
      sym_link_section,
    ACTIONS(1902), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [49302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(798), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1460), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1796), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_AT,
    STATE(665), 1,
      sym__reserved_identifier,
    STATE(997), 1,
      sym_identifier,
    ACTIONS(161), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1714), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1801), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_AT,
    STATE(665), 1,
      sym__reserved_identifier,
    STATE(669), 1,
      sym_identifier,
    ACTIONS(161), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(322), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1655), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(785), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1773), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_AT,
    STATE(665), 1,
      sym__reserved_identifier,
    STATE(1006), 1,
      sym_identifier,
    ACTIONS(161), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_AT,
    STATE(316), 1,
      sym__reserved_identifier,
    STATE(1624), 1,
      sym_identifier,
    ACTIONS(7), 5,
      anon_sym_undefined,
      anon_sym_null,
      anon_sym_true,
      anon_sym_false,
      sym__identifier,
  [49562] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2585), 1,
      anon_sym_threadlocal,
    STATE(1511), 1,
      sym_string,
    STATE(1627), 1,
      sym__function_prototype,
    STATE(1671), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [49588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_addrspace,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1535), 1,
      sym_address_space,
    STATE(1630), 1,
      sym_link_section,
    ACTIONS(2587), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [49609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_addrspace,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1534), 1,
      sym_address_space,
    STATE(1635), 1,
      sym_link_section,
    ACTIONS(2589), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [49630] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2591), 1,
      anon_sym_inline,
    STATE(477), 1,
      sym__while_prefix,
    STATE(525), 1,
      sym__for_prefix,
    STATE(659), 1,
      sym_block,
  [49655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2593), 1,
      anon_sym_inline,
    STATE(502), 1,
      sym__for_prefix,
    STATE(515), 1,
      sym__while_prefix,
    STATE(826), 1,
      sym_block,
  [49680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2591), 1,
      anon_sym_inline,
    STATE(477), 1,
      sym__while_prefix,
    STATE(525), 1,
      sym__for_prefix,
    STATE(993), 1,
      sym_block,
  [49705] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2595), 1,
      anon_sym_inline,
    STATE(574), 1,
      sym__for_prefix,
    STATE(586), 1,
      sym__while_prefix,
    STATE(993), 1,
      sym_block,
  [49730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2591), 1,
      anon_sym_inline,
    STATE(477), 1,
      sym__while_prefix,
    STATE(525), 1,
      sym__for_prefix,
    STATE(826), 1,
      sym_block,
  [49755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2591), 1,
      anon_sym_inline,
    STATE(477), 1,
      sym__while_prefix,
    STATE(525), 1,
      sym__for_prefix,
    STATE(661), 1,
      sym_block,
  [49780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2597), 1,
      anon_sym_inline,
    STATE(546), 1,
      sym__for_prefix,
    STATE(558), 1,
      sym__while_prefix,
    STATE(826), 1,
      sym_block,
  [49805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2599), 1,
      anon_sym_inline,
    STATE(444), 1,
      sym__for_prefix,
    STATE(462), 1,
      sym__while_prefix,
    STATE(993), 1,
      sym_block,
  [49830] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    ACTIONS(2601), 1,
      anon_sym_inline,
    STATE(400), 1,
      sym__for_prefix,
    STATE(416), 1,
      sym__while_prefix,
    STATE(826), 1,
      sym_block,
  [49855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2603), 1,
      anon_sym_EQ,
    STATE(1537), 1,
      sym_byte_alignment,
    ACTIONS(1981), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1691), 2,
      sym_string,
      sym_multiline_string,
  [49893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2607), 1,
      anon_sym_EQ,
    STATE(1562), 1,
      sym_byte_alignment,
    ACTIONS(1963), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2609), 1,
      anon_sym_EQ,
    STATE(1550), 1,
      sym_byte_alignment,
    ACTIONS(1985), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    ACTIONS(2611), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1601), 2,
      sym_string,
      sym_multiline_string,
  [49949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2613), 1,
      anon_sym_threadlocal,
    STATE(1580), 1,
      sym__function_prototype,
    STATE(1653), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [49969] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2585), 1,
      anon_sym_threadlocal,
    STATE(1625), 1,
      sym__function_prototype,
    STATE(1664), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [49989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      anon_sym_threadlocal,
    ACTIONS(2533), 1,
      anon_sym_fn,
    STATE(1571), 1,
      sym__function_prototype,
    STATE(1682), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [50009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2615), 1,
      anon_sym_EQ,
    STATE(1556), 1,
      sym_byte_alignment,
    ACTIONS(1959), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2617), 1,
      anon_sym_EQ,
    STATE(1557), 1,
      sym_byte_alignment,
    ACTIONS(1944), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    ACTIONS(2619), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1691), 2,
      sym_string,
      sym_multiline_string,
  [50065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_fn,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(525), 1,
      sym__for_prefix,
    STATE(528), 1,
      sym__while_prefix,
    STATE(1577), 1,
      sym__function_prototype,
  [50087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_align,
    ACTIONS(2621), 1,
      anon_sym_EQ,
    STATE(1563), 1,
      sym_byte_alignment,
    ACTIONS(1955), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1635), 1,
      sym_link_section,
    ACTIONS(2589), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [50120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    ACTIONS(2625), 1,
      anon_sym_RPAREN,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    STATE(1639), 1,
      sym_asm_input_item,
    STATE(1808), 1,
      sym_asm_clobbers,
  [50139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_COMMA,
    ACTIONS(2631), 1,
      anon_sym_COLON,
    ACTIONS(2633), 1,
      anon_sym_RPAREN,
    STATE(1524), 1,
      aux_sym_asm_output_repeat1,
    STATE(1788), 1,
      sym_asm_input,
  [50158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    ACTIONS(2635), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
    STATE(1526), 1,
      aux_sym_asm_input_repeat1,
    STATE(1728), 1,
      sym_asm_clobbers,
  [50177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_COLON,
    ACTIONS(2639), 1,
      anon_sym_RPAREN,
    ACTIONS(2641), 1,
      anon_sym_LBRACK,
    STATE(1607), 1,
      sym_asm_output_item,
    STATE(1757), 1,
      sym_asm_input,
  [50196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_COLON,
    ACTIONS(2639), 1,
      anon_sym_RPAREN,
    ACTIONS(2643), 1,
      anon_sym_COMMA,
    STATE(1565), 1,
      aux_sym_asm_output_repeat1,
    STATE(1757), 1,
      sym_asm_input,
  [50215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
    STATE(1639), 1,
      sym_asm_input_item,
    STATE(1793), 1,
      sym_asm_clobbers,
  [50234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
    ACTIONS(2647), 1,
      anon_sym_COMMA,
    STATE(1549), 1,
      aux_sym_asm_input_repeat1,
    STATE(1793), 1,
      sym_asm_clobbers,
  [50253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1691), 2,
      sym_string,
      sym_multiline_string,
  [50270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1630), 1,
      sym_link_section,
    ACTIONS(2587), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [50285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_COLON,
    ACTIONS(2641), 1,
      anon_sym_LBRACK,
    ACTIONS(2649), 1,
      anon_sym_RPAREN,
    STATE(1521), 1,
      sym_asm_output_item,
    STATE(1750), 1,
      sym_asm_input,
  [50304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1803), 2,
      sym_string,
      sym_multiline_string,
  [50321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    ACTIONS(95), 1,
      aux_sym_multiline_string_token1,
    STATE(775), 1,
      aux_sym_multiline_string_repeat1,
    STATE(1806), 2,
      sym_string,
      sym_multiline_string,
  [50338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2651), 1,
      anon_sym_RPAREN,
    STATE(1522), 1,
      sym_asm_input_item,
    STATE(1726), 1,
      sym_asm_clobbers,
  [50357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_COLON,
    ACTIONS(2641), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_RPAREN,
    STATE(1607), 1,
      sym_asm_output_item,
    STATE(1807), 1,
      sym_asm_input,
  [50376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1584), 1,
      sym_link_section,
    ACTIONS(2655), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [50391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_linksection,
    STATE(1644), 1,
      sym_link_section,
    ACTIONS(2657), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [50406] = 5,
    ACTIONS(2659), 1,
      anon_sym_DQUOTE,
    ACTIONS(2661), 1,
      aux_sym_string_token1,
    ACTIONS(2663), 1,
      sym_escape_sequence,
    ACTIONS(2665), 1,
      sym_comment,
    STATE(1548), 1,
      aux_sym_string_repeat1,
  [50422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_EQ,
    ACTIONS(2667), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(562), 1,
      sym__for_prefix,
    STATE(563), 1,
      sym__while_prefix,
  [50450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2671), 4,
      anon_sym_inline,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_while,
  [50460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(210), 1,
      sym__for_prefix,
    STATE(211), 1,
      sym__while_prefix,
  [50476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(444), 1,
      sym__for_prefix,
    STATE(445), 1,
      sym__while_prefix,
  [50492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(423), 1,
      sym__for_prefix,
    STATE(424), 1,
      sym__while_prefix,
  [50508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(472), 1,
      sym__for_prefix,
    STATE(473), 1,
      sym__while_prefix,
  [50524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(418), 1,
      sym__for_prefix,
    STATE(419), 1,
      sym__while_prefix,
  [50540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(502), 1,
      sym__for_prefix,
    STATE(503), 1,
      sym__while_prefix,
  [50556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(525), 1,
      sym__for_prefix,
    STATE(528), 1,
      sym__while_prefix,
  [50572] = 5,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_DQUOTE,
    ACTIONS(2675), 1,
      aux_sym_string_token1,
    ACTIONS(2677), 1,
      sym_escape_sequence,
    STATE(1564), 1,
      aux_sym_string_repeat1,
  [50588] = 5,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2675), 1,
      aux_sym_string_token1,
    ACTIONS(2677), 1,
      sym_escape_sequence,
    ACTIONS(2679), 1,
      anon_sym_DQUOTE,
    STATE(1564), 1,
      aux_sym_string_repeat1,
  [50604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_COMMA,
    STATE(1549), 1,
      aux_sym_asm_input_repeat1,
    ACTIONS(2684), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [50618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_EQ,
    ACTIONS(2686), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(400), 1,
      sym__for_prefix,
    STATE(401), 1,
      sym__while_prefix,
  [50646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2690), 4,
      anon_sym_inline,
      anon_sym_LBRACE,
      anon_sym_for,
      anon_sym_while,
  [50656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(546), 1,
      sym__for_prefix,
    STATE(547), 1,
      sym__while_prefix,
  [50672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(574), 1,
      sym__for_prefix,
    STATE(575), 1,
      sym__while_prefix,
  [50688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_struct,
    ACTIONS(2694), 1,
      anon_sym_opaque,
    ACTIONS(2696), 1,
      anon_sym_enum,
    ACTIONS(2698), 1,
      anon_sym_union,
  [50704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2702), 1,
      anon_sym_EQ,
    ACTIONS(2700), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2706), 1,
      anon_sym_EQ,
    ACTIONS(2704), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(304), 1,
      sym__for_prefix,
    STATE(305), 1,
      sym__while_prefix,
  [50744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(522), 1,
      sym__for_prefix,
    STATE(523), 1,
      sym__while_prefix,
  [50760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_for,
    ACTIONS(2579), 1,
      anon_sym_while,
    STATE(590), 1,
      sym__for_prefix,
    STATE(591), 1,
      sym__while_prefix,
  [50776] = 5,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2708), 1,
      anon_sym_DQUOTE,
    ACTIONS(2710), 1,
      aux_sym_string_token1,
    ACTIONS(2712), 1,
      sym_escape_sequence,
    STATE(1547), 1,
      aux_sym_string_repeat1,
  [50792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2716), 1,
      anon_sym_EQ,
    ACTIONS(2714), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_EQ,
    ACTIONS(2718), 3,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [50816] = 5,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2722), 1,
      anon_sym_DQUOTE,
    ACTIONS(2724), 1,
      aux_sym_string_token1,
    ACTIONS(2727), 1,
      sym_escape_sequence,
    STATE(1564), 1,
      aux_sym_string_repeat1,
  [50832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_COMMA,
    STATE(1565), 1,
      aux_sym_asm_output_repeat1,
    ACTIONS(2733), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [50846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(2319), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [50860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_struct,
    ACTIONS(2541), 1,
      anon_sym_opaque,
    ACTIONS(2543), 1,
      anon_sym_enum,
    ACTIONS(2545), 1,
      anon_sym_union,
  [50876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1666), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [50887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2309), 1,
      anon_sym_RBRACE,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    STATE(1589), 1,
      aux_sym_initializer_list_repeat1,
  [50900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_EQ,
    STATE(1615), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
  [50913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2742), 1,
      anon_sym_SEMI,
    STATE(675), 1,
      sym_block,
  [50926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(893), 1,
      anon_sym_RPAREN,
    ACTIONS(2744), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [50939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1692), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [50950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_EQ_GT,
    ACTIONS(2335), 1,
      anon_sym_COMMA,
    STATE(1575), 1,
      aux_sym__switch_case_exp_repeat1,
  [50963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_EQ_GT,
    ACTIONS(2746), 1,
      anon_sym_COMMA,
    STATE(1575), 1,
      aux_sym__switch_case_exp_repeat1,
  [50976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 1,
      anon_sym_COMMA,
    ACTIONS(2752), 1,
      anon_sym_RBRACE,
    STATE(1576), 1,
      aux_sym_switch_expression_repeat1,
  [50989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2754), 1,
      anon_sym_SEMI,
    STATE(685), 1,
      sym_block,
  [51002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_COMMA,
    ACTIONS(2758), 1,
      anon_sym_RBRACE,
    STATE(1619), 1,
      aux_sym_switch_expression_repeat1,
  [51015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2760), 1,
      anon_sym_SEMI,
    STATE(687), 1,
      sym_block,
  [51028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2762), 1,
      anon_sym_SEMI,
    STATE(677), 1,
      sym_block,
  [51041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_COMMA,
    ACTIONS(2767), 1,
      anon_sym_RPAREN,
    STATE(1581), 1,
      aux_sym_asm_clobbers_repeat1,
  [51054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_SEMI,
    STATE(681), 1,
      sym_block,
  [51067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_RBRACE,
    ACTIONS(2771), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [51080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2773), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2775), 1,
      anon_sym_COMMA,
    ACTIONS(2777), 1,
      anon_sym_RBRACE,
    STATE(1628), 1,
      aux_sym_error_set_declaration_repeat1,
  [51102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(849), 1,
      anon_sym_RBRACE,
    ACTIONS(2779), 1,
      anon_sym_DOT,
    STATE(1707), 1,
      sym_field_initializer,
  [51115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_RBRACE,
    ACTIONS(2779), 1,
      anon_sym_DOT,
    STATE(1707), 1,
      sym_field_initializer,
  [51128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_COMMA,
    ACTIONS(2784), 1,
      anon_sym_RBRACE,
    STATE(1588), 1,
      aux_sym_initializer_list_repeat1,
  [51141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_RBRACE,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    STATE(1588), 1,
      aux_sym_initializer_list_repeat1,
  [51154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_EQ_GT,
    ACTIONS(2253), 1,
      anon_sym_COMMA,
    STATE(1575), 1,
      aux_sym__switch_case_exp_repeat1,
  [51167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 1,
      anon_sym_RPAREN,
    ACTIONS(2788), 1,
      anon_sym_LPAREN,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
  [51180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_COMMA,
    ACTIONS(2795), 1,
      anon_sym_RPAREN,
    STATE(1592), 1,
      aux_sym_parameters_repeat1,
  [51193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_COMMA,
    ACTIONS(2799), 1,
      anon_sym_RPAREN,
    STATE(1598), 1,
      aux_sym_parameters_repeat1,
  [51206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(841), 1,
      anon_sym_RBRACE,
    ACTIONS(2779), 1,
      anon_sym_DOT,
    STATE(1707), 1,
      sym_field_initializer,
  [51219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    ACTIONS(345), 2,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
  [51230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(883), 1,
      anon_sym_RPAREN,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [51243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_COMMA,
    ACTIONS(2807), 1,
      anon_sym_RBRACE,
    STATE(1616), 1,
      aux_sym_error_set_declaration_repeat1,
  [51256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_RPAREN,
    ACTIONS(2809), 1,
      anon_sym_COMMA,
    STATE(1592), 1,
      aux_sym_parameters_repeat1,
  [51269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_EQ_GT,
    ACTIONS(2811), 1,
      anon_sym_COMMA,
    STATE(1575), 1,
      aux_sym__switch_case_exp_repeat1,
  [51282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1648), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [51293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_COMMA,
    ACTIONS(2815), 1,
      anon_sym_RPAREN,
    STATE(1637), 1,
      aux_sym_asm_clobbers_repeat1,
  [51306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_PIPE,
    ACTIONS(2817), 1,
      anon_sym_COMMA,
    STATE(1604), 1,
      aux_sym_payload_repeat1,
  [51319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2819), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
  [51332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2821), 1,
      anon_sym_COMMA,
    ACTIONS(2824), 1,
      anon_sym_PIPE,
    STATE(1604), 1,
      aux_sym_payload_repeat1,
  [51345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      anon_sym_COMMA,
    ACTIONS(2828), 1,
      anon_sym_RBRACE,
    STATE(1614), 1,
      aux_sym_switch_expression_repeat1,
  [51358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [51367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [51376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [51385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [51394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    ACTIONS(2836), 2,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
  [51405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_RPAREN,
    ACTIONS(2838), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [51418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2840), 1,
      anon_sym_SEMI,
    STATE(672), 1,
      sym_block,
  [51431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_PIPE,
    ACTIONS(2842), 1,
      anon_sym_COMMA,
    STATE(1604), 1,
      aux_sym_payload_repeat1,
  [51444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_RBRACE,
    ACTIONS(2844), 1,
      anon_sym_COMMA,
    STATE(1576), 1,
      aux_sym_switch_expression_repeat1,
  [51457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    ACTIONS(2849), 1,
      anon_sym_EQ,
    STATE(1615), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
  [51470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2571), 1,
      anon_sym_RBRACE,
    ACTIONS(2851), 1,
      anon_sym_COMMA,
    STATE(1626), 1,
      aux_sym_error_set_declaration_repeat1,
  [51483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_EQ_GT,
    ACTIONS(2207), 1,
      anon_sym_COMMA,
    STATE(1575), 1,
      aux_sym__switch_case_exp_repeat1,
  [51496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    ACTIONS(2853), 1,
      anon_sym_EQ,
    STATE(1615), 1,
      aux_sym__variable_declaration_expression_statement_repeat1,
  [51509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_RBRACE,
    ACTIONS(2855), 1,
      anon_sym_COMMA,
    STATE(1576), 1,
      aux_sym_switch_expression_repeat1,
  [51522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_RPAREN,
    ACTIONS(2857), 1,
      anon_sym_COMMA,
    STATE(1641), 1,
      aux_sym__for_prefix_repeat1,
  [51535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 1,
      anon_sym_RPAREN,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(2859), 1,
      anon_sym_LPAREN,
  [51548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_RBRACE,
    ACTIONS(2861), 1,
      anon_sym_COMMA,
    STATE(1633), 1,
      aux_sym_initializer_list_repeat1,
  [51561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1710), 1,
      sym__variable_declaration_header,
    ACTIONS(2529), 2,
      anon_sym_const,
      anon_sym_var,
  [51572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_PIPE,
    ACTIONS(2842), 1,
      anon_sym_COMMA,
    STATE(1602), 1,
      aux_sym_payload_repeat1,
  [51585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2863), 1,
      anon_sym_SEMI,
    STATE(703), 1,
      sym_block,
  [51598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2865), 1,
      anon_sym_COMMA,
    ACTIONS(2868), 1,
      anon_sym_RBRACE,
    STATE(1626), 1,
      aux_sym_error_set_declaration_repeat1,
  [51611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2870), 1,
      anon_sym_SEMI,
    STATE(714), 1,
      sym_block,
  [51624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_RBRACE,
    ACTIONS(2872), 1,
      anon_sym_COMMA,
    STATE(1626), 1,
      aux_sym_error_set_declaration_repeat1,
  [51637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      anon_sym_COMMA,
    ACTIONS(2876), 1,
      anon_sym_PIPE,
    STATE(1613), 1,
      aux_sym_payload_repeat1,
  [51650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 1,
      anon_sym_RBRACE,
    ACTIONS(2878), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [51672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 1,
      anon_sym_RBRACE,
    ACTIONS(2779), 1,
      anon_sym_DOT,
    STATE(1707), 1,
      sym_field_initializer,
  [51685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(889), 1,
      anon_sym_RBRACE,
    ACTIONS(2880), 1,
      anon_sym_COMMA,
    STATE(1588), 1,
      aux_sym_initializer_list_repeat1,
  [51698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
    ACTIONS(2882), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym_call_expression_repeat1,
  [51729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(2884), 1,
      anon_sym_COMMA,
    STATE(1581), 1,
      aux_sym_asm_clobbers_repeat1,
  [51742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_COMMA,
    ACTIONS(2888), 1,
      anon_sym_RPAREN,
    STATE(1641), 1,
      aux_sym__for_prefix_repeat1,
  [51755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [51764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 1,
      anon_sym_RPAREN,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(2890), 1,
      anon_sym_LPAREN,
  [51777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_RPAREN,
    ACTIONS(2892), 1,
      anon_sym_COMMA,
    STATE(1641), 1,
      aux_sym__for_prefix_repeat1,
  [51790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_RPAREN,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(2895), 1,
      anon_sym_LPAREN,
  [51803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    ACTIONS(2897), 1,
      anon_sym_SEMI,
    STATE(717), 1,
      sym_block,
  [51816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      anon_sym_EQ,
    ACTIONS(2905), 1,
      anon_sym_SEMI,
  [51860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    STATE(694), 1,
      sym_block,
  [51870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 1,
      anon_sym_EQ,
    ACTIONS(2909), 1,
      anon_sym_SEMI,
  [51880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(767), 1,
      sym_payload,
  [51890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(768), 1,
      sym_payload,
  [51900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 1,
      anon_sym_EQ,
    ACTIONS(2913), 1,
      anon_sym_SEMI,
  [51910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    STATE(698), 1,
      sym_block,
  [51920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(2915), 1,
      anon_sym_LPAREN,
  [51938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_DOT,
    STATE(1707), 1,
      sym_field_initializer,
  [51948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_LBRACE,
    ACTIONS(2919), 1,
      anon_sym_DOT,
  [51958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_parameters,
  [51968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_parameters,
  [51978] = 2,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2921), 2,
      sym_escape_sequence,
      aux_sym_character_token1,
  [51986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_parameters,
  [51996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(770), 1,
      sym_payload,
  [52006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      anon_sym_SEMI,
  [52016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2795), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_EQ,
    ACTIONS(2929), 1,
      anon_sym_SEMI,
  [52034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    STATE(693), 1,
      sym_block,
  [52052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_LPAREN,
    ACTIONS(2933), 1,
      anon_sym_LBRACE,
  [52062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_LPAREN,
    ACTIONS(2937), 1,
      anon_sym_LBRACE,
  [52072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 1,
      anon_sym_EQ,
    ACTIONS(2941), 1,
      anon_sym_SEMI,
  [52082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_volatile,
  [52092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [52100] = 2,
    ACTIONS(2665), 1,
      sym_comment,
    ACTIONS(2947), 2,
      sym_escape_sequence,
      aux_sym_character_token1,
  [52108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(772), 1,
      sym_payload,
  [52118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_LPAREN,
    ACTIONS(2951), 1,
      anon_sym_LBRACE,
  [52128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(766), 1,
      sym_payload,
  [52138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [52146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LPAREN,
    STATE(827), 1,
      sym_arguments,
  [52156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LPAREN,
    ACTIONS(2957), 1,
      anon_sym_LBRACE,
  [52166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_LBRACK,
    STATE(1607), 1,
      sym_asm_output_item,
  [52176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_EQ,
    ACTIONS(2961), 1,
      anon_sym_SEMI,
  [52186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_LPAREN,
    STATE(1196), 1,
      sym_arguments,
  [52196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    STATE(1639), 1,
      sym_asm_input_item,
  [52206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_DQUOTE,
    STATE(667), 1,
      sym_string,
  [52216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_fn,
    STATE(1579), 1,
      sym__function_prototype,
  [52226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_DQUOTE,
    STATE(333), 1,
      sym_string,
  [52236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
  [52244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
    STATE(89), 1,
      sym_parameters,
  [52254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(343), 1,
      anon_sym_PIPE,
    STATE(765), 1,
      sym_payload,
  [52264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(2969), 1,
      anon_sym_SEMI,
  [52282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2973), 1,
      anon_sym_SEMI,
  [52292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACE,
  [52302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 1,
      anon_sym_LPAREN,
    ACTIONS(2981), 1,
      anon_sym_LBRACE,
  [52312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2985), 1,
      anon_sym_LBRACE,
  [52322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2989), 1,
      anon_sym_volatile,
  [52332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_LPAREN,
    ACTIONS(2993), 1,
      anon_sym_LBRACE,
  [52342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      anon_sym_LPAREN,
    ACTIONS(2997), 1,
      anon_sym_LBRACE,
  [52352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 1,
      anon_sym_LPAREN,
    ACTIONS(3001), 1,
      anon_sym_LBRACE,
  [52362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2345), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_EQ,
    ACTIONS(3005), 1,
      anon_sym_SEMI,
  [52380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_LPAREN,
    ACTIONS(3009), 1,
      anon_sym_LBRACE,
  [52398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 1,
      anon_sym_LBRACE,
    ACTIONS(3013), 1,
      anon_sym_DOT,
  [52408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_RPAREN,
    ACTIONS(3017), 1,
      anon_sym_LBRACE,
  [52418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [52426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACE,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
  [52436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACE,
    ACTIONS(3021), 1,
      anon_sym_RPAREN,
  [52446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_EQ,
    ACTIONS(3025), 1,
      anon_sym_SEMI,
  [52456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_fn,
    STATE(1643), 1,
      sym__function_prototype,
  [52482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3027), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [52490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACE,
    ACTIONS(3029), 1,
      anon_sym_RPAREN,
  [52500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3031), 1,
      anon_sym_RBRACE,
  [52507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_RBRACK,
  [52514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_RPAREN,
  [52521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 1,
      anon_sym_LPAREN,
  [52528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_LBRACE,
  [52535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_LBRACE,
  [52542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2341), 1,
      anon_sym_RPAREN,
  [52549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_RBRACE,
  [52556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3045), 1,
      anon_sym_RBRACE,
  [52563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_RBRACE,
  [52570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
  [52577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_RBRACE,
  [52584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
  [52591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_RBRACK,
  [52598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_RBRACE,
  [52605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3055), 1,
      anon_sym_SQUOTE,
  [52612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_RBRACE,
  [52619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 1,
      anon_sym_RBRACE,
  [52626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 1,
      anon_sym_RPAREN,
  [52633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3061), 1,
      anon_sym_LBRACE,
  [52640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LBRACE,
  [52647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_RBRACE,
  [52654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3067), 1,
      anon_sym_LPAREN,
  [52661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_RBRACE,
  [52668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACE,
  [52675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 1,
      anon_sym_RBRACE,
  [52682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_RBRACE,
  [52689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_RBRACE,
  [52696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
  [52703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_RBRACE,
  [52710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_RBRACE,
  [52717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_RBRACE,
  [52724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_LPAREN,
  [52731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3087), 1,
      anon_sym_EQ_GT,
  [52738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_RPAREN,
  [52745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_RPAREN,
  [52752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_RBRACE,
  [52759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 1,
      anon_sym_RBRACE,
  [52766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3095), 1,
      anon_sym_RBRACE,
  [52773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_RBRACE,
  [52780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3099), 1,
      anon_sym_SQUOTE,
  [52787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 1,
      anon_sym_RPAREN,
  [52794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3101), 1,
      anon_sym_LPAREN,
  [52801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_RBRACE,
  [52808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
  [52815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_RPAREN,
  [52822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      anon_sym_RBRACE,
  [52829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_LPAREN,
  [52836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 1,
      anon_sym_LPAREN,
  [52843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_LPAREN,
  [52850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
  [52857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_RBRACE,
  [52864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 1,
      anon_sym_RBRACE,
  [52871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_EQ_GT,
  [52878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      anon_sym_LBRACE,
  [52885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 1,
      anon_sym_LPAREN,
  [52892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_LPAREN,
  [52899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 1,
      anon_sym_EQ,
  [52906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_RBRACK,
  [52913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 1,
      anon_sym_LBRACE,
  [52920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 1,
      ts_builtin_sym_end,
  [52927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_RBRACE,
  [52934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_LPAREN,
  [52941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
  [52948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3141), 1,
      anon_sym_LBRACE,
  [52955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3143), 1,
      anon_sym_LBRACE,
  [52962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LBRACE,
  [52969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3147), 1,
      anon_sym_LBRACE,
  [52976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3149), 1,
      anon_sym_LBRACE,
  [52983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_LBRACE,
  [52990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 1,
      anon_sym_LBRACE,
  [52997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_LBRACE,
  [53004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_RPAREN,
  [53011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
  [53018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
  [53025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_LBRACE,
  [53032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_RBRACE,
  [53039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_RPAREN,
  [53046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_LPAREN,
  [53053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      ts_builtin_sym_end,
  [53060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_RBRACK,
  [53067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_LPAREN,
  [53074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3173), 1,
      anon_sym_LBRACE,
  [53081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 1,
      anon_sym_RBRACE,
  [53088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_LPAREN,
  [53095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_RBRACK,
  [53102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3181), 1,
      anon_sym_RBRACE,
  [53109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3183), 1,
      anon_sym_LPAREN,
  [53116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_RBRACE,
  [53123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
  [53130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 1,
      anon_sym_LPAREN,
  [53137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_RPAREN,
  [53144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_RPAREN,
  [53151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3195), 1,
      anon_sym_LBRACE,
  [53158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3197), 1,
      anon_sym_LBRACE,
  [53165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_RBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(922)] = 0,
  [SMALL_STATE(923)] = 79,
  [SMALL_STATE(924)] = 168,
  [SMALL_STATE(925)] = 278,
  [SMALL_STATE(926)] = 352,
  [SMALL_STATE(927)] = 450,
  [SMALL_STATE(928)] = 558,
  [SMALL_STATE(929)] = 640,
  [SMALL_STATE(930)] = 748,
  [SMALL_STATE(931)] = 822,
  [SMALL_STATE(932)] = 930,
  [SMALL_STATE(933)] = 1038,
  [SMALL_STATE(934)] = 1140,
  [SMALL_STATE(935)] = 1248,
  [SMALL_STATE(936)] = 1358,
  [SMALL_STATE(937)] = 1466,
  [SMALL_STATE(938)] = 1576,
  [SMALL_STATE(939)] = 1668,
  [SMALL_STATE(940)] = 1744,
  [SMALL_STATE(941)] = 1852,
  [SMALL_STATE(942)] = 1934,
  [SMALL_STATE(943)] = 2032,
  [SMALL_STATE(944)] = 2106,
  [SMALL_STATE(945)] = 2196,
  [SMALL_STATE(946)] = 2304,
  [SMALL_STATE(947)] = 2386,
  [SMALL_STATE(948)] = 2494,
  [SMALL_STATE(949)] = 2576,
  [SMALL_STATE(950)] = 2684,
  [SMALL_STATE(951)] = 2794,
  [SMALL_STATE(952)] = 2880,
  [SMALL_STATE(953)] = 2988,
  [SMALL_STATE(954)] = 3096,
  [SMALL_STATE(955)] = 3172,
  [SMALL_STATE(956)] = 3248,
  [SMALL_STATE(957)] = 3356,
  [SMALL_STATE(958)] = 3432,
  [SMALL_STATE(959)] = 3540,
  [SMALL_STATE(960)] = 3648,
  [SMALL_STATE(961)] = 3756,
  [SMALL_STATE(962)] = 3854,
  [SMALL_STATE(963)] = 3964,
  [SMALL_STATE(964)] = 4072,
  [SMALL_STATE(965)] = 4182,
  [SMALL_STATE(966)] = 4290,
  [SMALL_STATE(967)] = 4398,
  [SMALL_STATE(968)] = 4502,
  [SMALL_STATE(969)] = 4610,
  [SMALL_STATE(970)] = 4718,
  [SMALL_STATE(971)] = 4828,
  [SMALL_STATE(972)] = 4938,
  [SMALL_STATE(973)] = 5020,
  [SMALL_STATE(974)] = 5102,
  [SMALL_STATE(975)] = 5200,
  [SMALL_STATE(976)] = 5308,
  [SMALL_STATE(977)] = 5379,
  [SMALL_STATE(978)] = 5450,
  [SMALL_STATE(979)] = 5519,
  [SMALL_STATE(980)] = 5590,
  [SMALL_STATE(981)] = 5661,
  [SMALL_STATE(982)] = 5732,
  [SMALL_STATE(983)] = 5803,
  [SMALL_STATE(984)] = 5876,
  [SMALL_STATE(985)] = 5947,
  [SMALL_STATE(986)] = 6018,
  [SMALL_STATE(987)] = 6089,
  [SMALL_STATE(988)] = 6160,
  [SMALL_STATE(989)] = 6231,
  [SMALL_STATE(990)] = 6327,
  [SMALL_STATE(991)] = 6395,
  [SMALL_STATE(992)] = 6463,
  [SMALL_STATE(993)] = 6531,
  [SMALL_STATE(994)] = 6599,
  [SMALL_STATE(995)] = 6667,
  [SMALL_STATE(996)] = 6735,
  [SMALL_STATE(997)] = 6803,
  [SMALL_STATE(998)] = 6871,
  [SMALL_STATE(999)] = 6941,
  [SMALL_STATE(1000)] = 7011,
  [SMALL_STATE(1001)] = 7081,
  [SMALL_STATE(1002)] = 7149,
  [SMALL_STATE(1003)] = 7217,
  [SMALL_STATE(1004)] = 7285,
  [SMALL_STATE(1005)] = 7353,
  [SMALL_STATE(1006)] = 7433,
  [SMALL_STATE(1007)] = 7501,
  [SMALL_STATE(1008)] = 7571,
  [SMALL_STATE(1009)] = 7639,
  [SMALL_STATE(1010)] = 7707,
  [SMALL_STATE(1011)] = 7775,
  [SMALL_STATE(1012)] = 7843,
  [SMALL_STATE(1013)] = 7911,
  [SMALL_STATE(1014)] = 7979,
  [SMALL_STATE(1015)] = 8047,
  [SMALL_STATE(1016)] = 8115,
  [SMALL_STATE(1017)] = 8185,
  [SMALL_STATE(1018)] = 8255,
  [SMALL_STATE(1019)] = 8325,
  [SMALL_STATE(1020)] = 8393,
  [SMALL_STATE(1021)] = 8461,
  [SMALL_STATE(1022)] = 8529,
  [SMALL_STATE(1023)] = 8597,
  [SMALL_STATE(1024)] = 8665,
  [SMALL_STATE(1025)] = 8733,
  [SMALL_STATE(1026)] = 8801,
  [SMALL_STATE(1027)] = 8869,
  [SMALL_STATE(1028)] = 8937,
  [SMALL_STATE(1029)] = 9005,
  [SMALL_STATE(1030)] = 9073,
  [SMALL_STATE(1031)] = 9141,
  [SMALL_STATE(1032)] = 9211,
  [SMALL_STATE(1033)] = 9281,
  [SMALL_STATE(1034)] = 9349,
  [SMALL_STATE(1035)] = 9417,
  [SMALL_STATE(1036)] = 9485,
  [SMALL_STATE(1037)] = 9553,
  [SMALL_STATE(1038)] = 9621,
  [SMALL_STATE(1039)] = 9689,
  [SMALL_STATE(1040)] = 9757,
  [SMALL_STATE(1041)] = 9827,
  [SMALL_STATE(1042)] = 9897,
  [SMALL_STATE(1043)] = 9967,
  [SMALL_STATE(1044)] = 10035,
  [SMALL_STATE(1045)] = 10103,
  [SMALL_STATE(1046)] = 10171,
  [SMALL_STATE(1047)] = 10239,
  [SMALL_STATE(1048)] = 10307,
  [SMALL_STATE(1049)] = 10375,
  [SMALL_STATE(1050)] = 10443,
  [SMALL_STATE(1051)] = 10511,
  [SMALL_STATE(1052)] = 10579,
  [SMALL_STATE(1053)] = 10647,
  [SMALL_STATE(1054)] = 10717,
  [SMALL_STATE(1055)] = 10785,
  [SMALL_STATE(1056)] = 10853,
  [SMALL_STATE(1057)] = 10921,
  [SMALL_STATE(1058)] = 10989,
  [SMALL_STATE(1059)] = 11057,
  [SMALL_STATE(1060)] = 11125,
  [SMALL_STATE(1061)] = 11193,
  [SMALL_STATE(1062)] = 11261,
  [SMALL_STATE(1063)] = 11329,
  [SMALL_STATE(1064)] = 11401,
  [SMALL_STATE(1065)] = 11469,
  [SMALL_STATE(1066)] = 11541,
  [SMALL_STATE(1067)] = 11609,
  [SMALL_STATE(1068)] = 11679,
  [SMALL_STATE(1069)] = 11749,
  [SMALL_STATE(1070)] = 11819,
  [SMALL_STATE(1071)] = 11899,
  [SMALL_STATE(1072)] = 11979,
  [SMALL_STATE(1073)] = 12049,
  [SMALL_STATE(1074)] = 12121,
  [SMALL_STATE(1075)] = 12193,
  [SMALL_STATE(1076)] = 12263,
  [SMALL_STATE(1077)] = 12333,
  [SMALL_STATE(1078)] = 12403,
  [SMALL_STATE(1079)] = 12475,
  [SMALL_STATE(1080)] = 12547,
  [SMALL_STATE(1081)] = 12617,
  [SMALL_STATE(1082)] = 12687,
  [SMALL_STATE(1083)] = 12759,
  [SMALL_STATE(1084)] = 12831,
  [SMALL_STATE(1085)] = 12901,
  [SMALL_STATE(1086)] = 12971,
  [SMALL_STATE(1087)] = 13041,
  [SMALL_STATE(1088)] = 13113,
  [SMALL_STATE(1089)] = 13185,
  [SMALL_STATE(1090)] = 13255,
  [SMALL_STATE(1091)] = 13327,
  [SMALL_STATE(1092)] = 13401,
  [SMALL_STATE(1093)] = 13473,
  [SMALL_STATE(1094)] = 13545,
  [SMALL_STATE(1095)] = 13617,
  [SMALL_STATE(1096)] = 13689,
  [SMALL_STATE(1097)] = 13761,
  [SMALL_STATE(1098)] = 13833,
  [SMALL_STATE(1099)] = 13905,
  [SMALL_STATE(1100)] = 13977,
  [SMALL_STATE(1101)] = 14049,
  [SMALL_STATE(1102)] = 14121,
  [SMALL_STATE(1103)] = 14193,
  [SMALL_STATE(1104)] = 14265,
  [SMALL_STATE(1105)] = 14337,
  [SMALL_STATE(1106)] = 14411,
  [SMALL_STATE(1107)] = 14483,
  [SMALL_STATE(1108)] = 14555,
  [SMALL_STATE(1109)] = 14625,
  [SMALL_STATE(1110)] = 14695,
  [SMALL_STATE(1111)] = 14775,
  [SMALL_STATE(1112)] = 14845,
  [SMALL_STATE(1113)] = 14915,
  [SMALL_STATE(1114)] = 15025,
  [SMALL_STATE(1115)] = 15135,
  [SMALL_STATE(1116)] = 15243,
  [SMALL_STATE(1117)] = 15351,
  [SMALL_STATE(1118)] = 15441,
  [SMALL_STATE(1119)] = 15525,
  [SMALL_STATE(1120)] = 15627,
  [SMALL_STATE(1121)] = 15727,
  [SMALL_STATE(1122)] = 15823,
  [SMALL_STATE(1123)] = 15911,
  [SMALL_STATE(1124)] = 16007,
  [SMALL_STATE(1125)] = 16117,
  [SMALL_STATE(1126)] = 16225,
  [SMALL_STATE(1127)] = 16333,
  [SMALL_STATE(1128)] = 16441,
  [SMALL_STATE(1129)] = 16537,
  [SMALL_STATE(1130)] = 16647,
  [SMALL_STATE(1131)] = 16757,
  [SMALL_STATE(1132)] = 16865,
  [SMALL_STATE(1133)] = 16973,
  [SMALL_STATE(1134)] = 17081,
  [SMALL_STATE(1135)] = 17189,
  [SMALL_STATE(1136)] = 17297,
  [SMALL_STATE(1137)] = 17405,
  [SMALL_STATE(1138)] = 17513,
  [SMALL_STATE(1139)] = 17621,
  [SMALL_STATE(1140)] = 17729,
  [SMALL_STATE(1141)] = 17837,
  [SMALL_STATE(1142)] = 17947,
  [SMALL_STATE(1143)] = 18057,
  [SMALL_STATE(1144)] = 18165,
  [SMALL_STATE(1145)] = 18273,
  [SMALL_STATE(1146)] = 18363,
  [SMALL_STATE(1147)] = 18447,
  [SMALL_STATE(1148)] = 18549,
  [SMALL_STATE(1149)] = 18649,
  [SMALL_STATE(1150)] = 18737,
  [SMALL_STATE(1151)] = 18833,
  [SMALL_STATE(1152)] = 18943,
  [SMALL_STATE(1153)] = 19051,
  [SMALL_STATE(1154)] = 19159,
  [SMALL_STATE(1155)] = 19267,
  [SMALL_STATE(1156)] = 19363,
  [SMALL_STATE(1157)] = 19473,
  [SMALL_STATE(1158)] = 19583,
  [SMALL_STATE(1159)] = 19691,
  [SMALL_STATE(1160)] = 19799,
  [SMALL_STATE(1161)] = 19907,
  [SMALL_STATE(1162)] = 20015,
  [SMALL_STATE(1163)] = 20123,
  [SMALL_STATE(1164)] = 20231,
  [SMALL_STATE(1165)] = 20339,
  [SMALL_STATE(1166)] = 20447,
  [SMALL_STATE(1167)] = 20555,
  [SMALL_STATE(1168)] = 20663,
  [SMALL_STATE(1169)] = 20771,
  [SMALL_STATE(1170)] = 20879,
  [SMALL_STATE(1171)] = 20987,
  [SMALL_STATE(1172)] = 21095,
  [SMALL_STATE(1173)] = 21203,
  [SMALL_STATE(1174)] = 21311,
  [SMALL_STATE(1175)] = 21407,
  [SMALL_STATE(1176)] = 21517,
  [SMALL_STATE(1177)] = 21627,
  [SMALL_STATE(1178)] = 21695,
  [SMALL_STATE(1179)] = 21803,
  [SMALL_STATE(1180)] = 21913,
  [SMALL_STATE(1181)] = 21981,
  [SMALL_STATE(1182)] = 22049,
  [SMALL_STATE(1183)] = 22117,
  [SMALL_STATE(1184)] = 22185,
  [SMALL_STATE(1185)] = 22255,
  [SMALL_STATE(1186)] = 22323,
  [SMALL_STATE(1187)] = 22391,
  [SMALL_STATE(1188)] = 22459,
  [SMALL_STATE(1189)] = 22529,
  [SMALL_STATE(1190)] = 22609,
  [SMALL_STATE(1191)] = 22679,
  [SMALL_STATE(1192)] = 22747,
  [SMALL_STATE(1193)] = 22817,
  [SMALL_STATE(1194)] = 22885,
  [SMALL_STATE(1195)] = 22953,
  [SMALL_STATE(1196)] = 23021,
  [SMALL_STATE(1197)] = 23089,
  [SMALL_STATE(1198)] = 23197,
  [SMALL_STATE(1199)] = 23305,
  [SMALL_STATE(1200)] = 23413,
  [SMALL_STATE(1201)] = 23521,
  [SMALL_STATE(1202)] = 23629,
  [SMALL_STATE(1203)] = 23737,
  [SMALL_STATE(1204)] = 23845,
  [SMALL_STATE(1205)] = 23941,
  [SMALL_STATE(1206)] = 24051,
  [SMALL_STATE(1207)] = 24161,
  [SMALL_STATE(1208)] = 24271,
  [SMALL_STATE(1209)] = 24351,
  [SMALL_STATE(1210)] = 24422,
  [SMALL_STATE(1211)] = 24503,
  [SMALL_STATE(1212)] = 24572,
  [SMALL_STATE(1213)] = 24643,
  [SMALL_STATE(1214)] = 24712,
  [SMALL_STATE(1215)] = 24783,
  [SMALL_STATE(1216)] = 24852,
  [SMALL_STATE(1217)] = 24921,
  [SMALL_STATE(1218)] = 25027,
  [SMALL_STATE(1219)] = 25133,
  [SMALL_STATE(1220)] = 25237,
  [SMALL_STATE(1221)] = 25341,
  [SMALL_STATE(1222)] = 25445,
  [SMALL_STATE(1223)] = 25549,
  [SMALL_STATE(1224)] = 25653,
  [SMALL_STATE(1225)] = 25747,
  [SMALL_STATE(1226)] = 25853,
  [SMALL_STATE(1227)] = 25959,
  [SMALL_STATE(1228)] = 26065,
  [SMALL_STATE(1229)] = 26175,
  [SMALL_STATE(1230)] = 26285,
  [SMALL_STATE(1231)] = 26395,
  [SMALL_STATE(1232)] = 26505,
  [SMALL_STATE(1233)] = 26615,
  [SMALL_STATE(1234)] = 26693,
  [SMALL_STATE(1235)] = 26803,
  [SMALL_STATE(1236)] = 26913,
  [SMALL_STATE(1237)] = 27023,
  [SMALL_STATE(1238)] = 27127,
  [SMALL_STATE(1239)] = 27199,
  [SMALL_STATE(1240)] = 27305,
  [SMALL_STATE(1241)] = 27411,
  [SMALL_STATE(1242)] = 27515,
  [SMALL_STATE(1243)] = 27619,
  [SMALL_STATE(1244)] = 27707,
  [SMALL_STATE(1245)] = 27811,
  [SMALL_STATE(1246)] = 27899,
  [SMALL_STATE(1247)] = 28003,
  [SMALL_STATE(1248)] = 28085,
  [SMALL_STATE(1249)] = 28185,
  [SMALL_STATE(1250)] = 28283,
  [SMALL_STATE(1251)] = 28377,
  [SMALL_STATE(1252)] = 28463,
  [SMALL_STATE(1253)] = 28557,
  [SMALL_STATE(1254)] = 28661,
  [SMALL_STATE(1255)] = 28767,
  [SMALL_STATE(1256)] = 28873,
  [SMALL_STATE(1257)] = 28979,
  [SMALL_STATE(1258)] = 29045,
  [SMALL_STATE(1259)] = 29127,
  [SMALL_STATE(1260)] = 29237,
  [SMALL_STATE(1261)] = 29347,
  [SMALL_STATE(1262)] = 29451,
  [SMALL_STATE(1263)] = 29555,
  [SMALL_STATE(1264)] = 29659,
  [SMALL_STATE(1265)] = 29763,
  [SMALL_STATE(1266)] = 29867,
  [SMALL_STATE(1267)] = 29973,
  [SMALL_STATE(1268)] = 30079,
  [SMALL_STATE(1269)] = 30183,
  [SMALL_STATE(1270)] = 30287,
  [SMALL_STATE(1271)] = 30391,
  [SMALL_STATE(1272)] = 30491,
  [SMALL_STATE(1273)] = 30595,
  [SMALL_STATE(1274)] = 30699,
  [SMALL_STATE(1275)] = 30803,
  [SMALL_STATE(1276)] = 30907,
  [SMALL_STATE(1277)] = 31005,
  [SMALL_STATE(1278)] = 31099,
  [SMALL_STATE(1279)] = 31185,
  [SMALL_STATE(1280)] = 31279,
  [SMALL_STATE(1281)] = 31383,
  [SMALL_STATE(1282)] = 31487,
  [SMALL_STATE(1283)] = 31591,
  [SMALL_STATE(1284)] = 31695,
  [SMALL_STATE(1285)] = 31799,
  [SMALL_STATE(1286)] = 31903,
  [SMALL_STATE(1287)] = 32007,
  [SMALL_STATE(1288)] = 32111,
  [SMALL_STATE(1289)] = 32215,
  [SMALL_STATE(1290)] = 32319,
  [SMALL_STATE(1291)] = 32423,
  [SMALL_STATE(1292)] = 32527,
  [SMALL_STATE(1293)] = 32633,
  [SMALL_STATE(1294)] = 32737,
  [SMALL_STATE(1295)] = 32841,
  [SMALL_STATE(1296)] = 32945,
  [SMALL_STATE(1297)] = 33039,
  [SMALL_STATE(1298)] = 33143,
  [SMALL_STATE(1299)] = 33247,
  [SMALL_STATE(1300)] = 33351,
  [SMALL_STATE(1301)] = 33445,
  [SMALL_STATE(1302)] = 33551,
  [SMALL_STATE(1303)] = 33657,
  [SMALL_STATE(1304)] = 33763,
  [SMALL_STATE(1305)] = 33867,
  [SMALL_STATE(1306)] = 33971,
  [SMALL_STATE(1307)] = 34075,
  [SMALL_STATE(1308)] = 34147,
  [SMALL_STATE(1309)] = 34253,
  [SMALL_STATE(1310)] = 34359,
  [SMALL_STATE(1311)] = 34453,
  [SMALL_STATE(1312)] = 34556,
  [SMALL_STATE(1313)] = 34663,
  [SMALL_STATE(1314)] = 34766,
  [SMALL_STATE(1315)] = 34869,
  [SMALL_STATE(1316)] = 34938,
  [SMALL_STATE(1317)] = 35045,
  [SMALL_STATE(1318)] = 35114,
  [SMALL_STATE(1319)] = 35221,
  [SMALL_STATE(1320)] = 35328,
  [SMALL_STATE(1321)] = 35431,
  [SMALL_STATE(1322)] = 35534,
  [SMALL_STATE(1323)] = 35641,
  [SMALL_STATE(1324)] = 35710,
  [SMALL_STATE(1325)] = 35779,
  [SMALL_STATE(1326)] = 35882,
  [SMALL_STATE(1327)] = 35989,
  [SMALL_STATE(1328)] = 36092,
  [SMALL_STATE(1329)] = 36161,
  [SMALL_STATE(1330)] = 36230,
  [SMALL_STATE(1331)] = 36333,
  [SMALL_STATE(1332)] = 36436,
  [SMALL_STATE(1333)] = 36543,
  [SMALL_STATE(1334)] = 36612,
  [SMALL_STATE(1335)] = 36719,
  [SMALL_STATE(1336)] = 36822,
  [SMALL_STATE(1337)] = 36929,
  [SMALL_STATE(1338)] = 37036,
  [SMALL_STATE(1339)] = 37139,
  [SMALL_STATE(1340)] = 37246,
  [SMALL_STATE(1341)] = 37353,
  [SMALL_STATE(1342)] = 37460,
  [SMALL_STATE(1343)] = 37567,
  [SMALL_STATE(1344)] = 37670,
  [SMALL_STATE(1345)] = 37777,
  [SMALL_STATE(1346)] = 37884,
  [SMALL_STATE(1347)] = 37953,
  [SMALL_STATE(1348)] = 38022,
  [SMALL_STATE(1349)] = 38129,
  [SMALL_STATE(1350)] = 38234,
  [SMALL_STATE(1351)] = 38341,
  [SMALL_STATE(1352)] = 38410,
  [SMALL_STATE(1353)] = 38479,
  [SMALL_STATE(1354)] = 38582,
  [SMALL_STATE(1355)] = 38689,
  [SMALL_STATE(1356)] = 38792,
  [SMALL_STATE(1357)] = 38861,
  [SMALL_STATE(1358)] = 38968,
  [SMALL_STATE(1359)] = 39071,
  [SMALL_STATE(1360)] = 39140,
  [SMALL_STATE(1361)] = 39247,
  [SMALL_STATE(1362)] = 39316,
  [SMALL_STATE(1363)] = 39423,
  [SMALL_STATE(1364)] = 39492,
  [SMALL_STATE(1365)] = 39599,
  [SMALL_STATE(1366)] = 39706,
  [SMALL_STATE(1367)] = 39775,
  [SMALL_STATE(1368)] = 39844,
  [SMALL_STATE(1369)] = 39947,
  [SMALL_STATE(1370)] = 40054,
  [SMALL_STATE(1371)] = 40161,
  [SMALL_STATE(1372)] = 40268,
  [SMALL_STATE(1373)] = 40375,
  [SMALL_STATE(1374)] = 40477,
  [SMALL_STATE(1375)] = 40581,
  [SMALL_STATE(1376)] = 40683,
  [SMALL_STATE(1377)] = 40785,
  [SMALL_STATE(1378)] = 40889,
  [SMALL_STATE(1379)] = 40993,
  [SMALL_STATE(1380)] = 41097,
  [SMALL_STATE(1381)] = 41165,
  [SMALL_STATE(1382)] = 41269,
  [SMALL_STATE(1383)] = 41373,
  [SMALL_STATE(1384)] = 41477,
  [SMALL_STATE(1385)] = 41579,
  [SMALL_STATE(1386)] = 41681,
  [SMALL_STATE(1387)] = 41785,
  [SMALL_STATE(1388)] = 41886,
  [SMALL_STATE(1389)] = 41987,
  [SMALL_STATE(1390)] = 42088,
  [SMALL_STATE(1391)] = 42189,
  [SMALL_STATE(1392)] = 42290,
  [SMALL_STATE(1393)] = 42391,
  [SMALL_STATE(1394)] = 42492,
  [SMALL_STATE(1395)] = 42593,
  [SMALL_STATE(1396)] = 42694,
  [SMALL_STATE(1397)] = 42795,
  [SMALL_STATE(1398)] = 42896,
  [SMALL_STATE(1399)] = 42997,
  [SMALL_STATE(1400)] = 43098,
  [SMALL_STATE(1401)] = 43199,
  [SMALL_STATE(1402)] = 43300,
  [SMALL_STATE(1403)] = 43401,
  [SMALL_STATE(1404)] = 43502,
  [SMALL_STATE(1405)] = 43603,
  [SMALL_STATE(1406)] = 43704,
  [SMALL_STATE(1407)] = 43805,
  [SMALL_STATE(1408)] = 43906,
  [SMALL_STATE(1409)] = 44007,
  [SMALL_STATE(1410)] = 44108,
  [SMALL_STATE(1411)] = 44209,
  [SMALL_STATE(1412)] = 44310,
  [SMALL_STATE(1413)] = 44411,
  [SMALL_STATE(1414)] = 44512,
  [SMALL_STATE(1415)] = 44613,
  [SMALL_STATE(1416)] = 44714,
  [SMALL_STATE(1417)] = 44815,
  [SMALL_STATE(1418)] = 44916,
  [SMALL_STATE(1419)] = 45017,
  [SMALL_STATE(1420)] = 45118,
  [SMALL_STATE(1421)] = 45219,
  [SMALL_STATE(1422)] = 45294,
  [SMALL_STATE(1423)] = 45395,
  [SMALL_STATE(1424)] = 45496,
  [SMALL_STATE(1425)] = 45597,
  [SMALL_STATE(1426)] = 45698,
  [SMALL_STATE(1427)] = 45799,
  [SMALL_STATE(1428)] = 45900,
  [SMALL_STATE(1429)] = 46001,
  [SMALL_STATE(1430)] = 46102,
  [SMALL_STATE(1431)] = 46203,
  [SMALL_STATE(1432)] = 46304,
  [SMALL_STATE(1433)] = 46405,
  [SMALL_STATE(1434)] = 46506,
  [SMALL_STATE(1435)] = 46607,
  [SMALL_STATE(1436)] = 46708,
  [SMALL_STATE(1437)] = 46809,
  [SMALL_STATE(1438)] = 46910,
  [SMALL_STATE(1439)] = 47011,
  [SMALL_STATE(1440)] = 47112,
  [SMALL_STATE(1441)] = 47213,
  [SMALL_STATE(1442)] = 47314,
  [SMALL_STATE(1443)] = 47415,
  [SMALL_STATE(1444)] = 47516,
  [SMALL_STATE(1445)] = 47617,
  [SMALL_STATE(1446)] = 47718,
  [SMALL_STATE(1447)] = 47819,
  [SMALL_STATE(1448)] = 47920,
  [SMALL_STATE(1449)] = 48021,
  [SMALL_STATE(1450)] = 48122,
  [SMALL_STATE(1451)] = 48220,
  [SMALL_STATE(1452)] = 48318,
  [SMALL_STATE(1453)] = 48416,
  [SMALL_STATE(1454)] = 48514,
  [SMALL_STATE(1455)] = 48612,
  [SMALL_STATE(1456)] = 48651,
  [SMALL_STATE(1457)] = 48681,
  [SMALL_STATE(1458)] = 48719,
  [SMALL_STATE(1459)] = 48749,
  [SMALL_STATE(1460)] = 48775,
  [SMALL_STATE(1461)] = 48805,
  [SMALL_STATE(1462)] = 48831,
  [SMALL_STATE(1463)] = 48857,
  [SMALL_STATE(1464)] = 48883,
  [SMALL_STATE(1465)] = 48909,
  [SMALL_STATE(1466)] = 48935,
  [SMALL_STATE(1467)] = 48961,
  [SMALL_STATE(1468)] = 48987,
  [SMALL_STATE(1469)] = 49013,
  [SMALL_STATE(1470)] = 49039,
  [SMALL_STATE(1471)] = 49062,
  [SMALL_STATE(1472)] = 49085,
  [SMALL_STATE(1473)] = 49108,
  [SMALL_STATE(1474)] = 49131,
  [SMALL_STATE(1475)] = 49154,
  [SMALL_STATE(1476)] = 49177,
  [SMALL_STATE(1477)] = 49200,
  [SMALL_STATE(1478)] = 49229,
  [SMALL_STATE(1479)] = 49252,
  [SMALL_STATE(1480)] = 49275,
  [SMALL_STATE(1481)] = 49302,
  [SMALL_STATE(1482)] = 49322,
  [SMALL_STATE(1483)] = 49342,
  [SMALL_STATE(1484)] = 49362,
  [SMALL_STATE(1485)] = 49382,
  [SMALL_STATE(1486)] = 49402,
  [SMALL_STATE(1487)] = 49422,
  [SMALL_STATE(1488)] = 49442,
  [SMALL_STATE(1489)] = 49462,
  [SMALL_STATE(1490)] = 49482,
  [SMALL_STATE(1491)] = 49502,
  [SMALL_STATE(1492)] = 49522,
  [SMALL_STATE(1493)] = 49542,
  [SMALL_STATE(1494)] = 49562,
  [SMALL_STATE(1495)] = 49588,
  [SMALL_STATE(1496)] = 49609,
  [SMALL_STATE(1497)] = 49630,
  [SMALL_STATE(1498)] = 49655,
  [SMALL_STATE(1499)] = 49680,
  [SMALL_STATE(1500)] = 49705,
  [SMALL_STATE(1501)] = 49730,
  [SMALL_STATE(1502)] = 49755,
  [SMALL_STATE(1503)] = 49780,
  [SMALL_STATE(1504)] = 49805,
  [SMALL_STATE(1505)] = 49830,
  [SMALL_STATE(1506)] = 49855,
  [SMALL_STATE(1507)] = 49873,
  [SMALL_STATE(1508)] = 49893,
  [SMALL_STATE(1509)] = 49911,
  [SMALL_STATE(1510)] = 49929,
  [SMALL_STATE(1511)] = 49949,
  [SMALL_STATE(1512)] = 49969,
  [SMALL_STATE(1513)] = 49989,
  [SMALL_STATE(1514)] = 50009,
  [SMALL_STATE(1515)] = 50027,
  [SMALL_STATE(1516)] = 50045,
  [SMALL_STATE(1517)] = 50065,
  [SMALL_STATE(1518)] = 50087,
  [SMALL_STATE(1519)] = 50105,
  [SMALL_STATE(1520)] = 50120,
  [SMALL_STATE(1521)] = 50139,
  [SMALL_STATE(1522)] = 50158,
  [SMALL_STATE(1523)] = 50177,
  [SMALL_STATE(1524)] = 50196,
  [SMALL_STATE(1525)] = 50215,
  [SMALL_STATE(1526)] = 50234,
  [SMALL_STATE(1527)] = 50253,
  [SMALL_STATE(1528)] = 50270,
  [SMALL_STATE(1529)] = 50285,
  [SMALL_STATE(1530)] = 50304,
  [SMALL_STATE(1531)] = 50321,
  [SMALL_STATE(1532)] = 50338,
  [SMALL_STATE(1533)] = 50357,
  [SMALL_STATE(1534)] = 50376,
  [SMALL_STATE(1535)] = 50391,
  [SMALL_STATE(1536)] = 50406,
  [SMALL_STATE(1537)] = 50422,
  [SMALL_STATE(1538)] = 50434,
  [SMALL_STATE(1539)] = 50450,
  [SMALL_STATE(1540)] = 50460,
  [SMALL_STATE(1541)] = 50476,
  [SMALL_STATE(1542)] = 50492,
  [SMALL_STATE(1543)] = 50508,
  [SMALL_STATE(1544)] = 50524,
  [SMALL_STATE(1545)] = 50540,
  [SMALL_STATE(1546)] = 50556,
  [SMALL_STATE(1547)] = 50572,
  [SMALL_STATE(1548)] = 50588,
  [SMALL_STATE(1549)] = 50604,
  [SMALL_STATE(1550)] = 50618,
  [SMALL_STATE(1551)] = 50630,
  [SMALL_STATE(1552)] = 50646,
  [SMALL_STATE(1553)] = 50656,
  [SMALL_STATE(1554)] = 50672,
  [SMALL_STATE(1555)] = 50688,
  [SMALL_STATE(1556)] = 50704,
  [SMALL_STATE(1557)] = 50716,
  [SMALL_STATE(1558)] = 50728,
  [SMALL_STATE(1559)] = 50744,
  [SMALL_STATE(1560)] = 50760,
  [SMALL_STATE(1561)] = 50776,
  [SMALL_STATE(1562)] = 50792,
  [SMALL_STATE(1563)] = 50804,
  [SMALL_STATE(1564)] = 50816,
  [SMALL_STATE(1565)] = 50832,
  [SMALL_STATE(1566)] = 50846,
  [SMALL_STATE(1567)] = 50860,
  [SMALL_STATE(1568)] = 50876,
  [SMALL_STATE(1569)] = 50887,
  [SMALL_STATE(1570)] = 50900,
  [SMALL_STATE(1571)] = 50913,
  [SMALL_STATE(1572)] = 50926,
  [SMALL_STATE(1573)] = 50939,
  [SMALL_STATE(1574)] = 50950,
  [SMALL_STATE(1575)] = 50963,
  [SMALL_STATE(1576)] = 50976,
  [SMALL_STATE(1577)] = 50989,
  [SMALL_STATE(1578)] = 51002,
  [SMALL_STATE(1579)] = 51015,
  [SMALL_STATE(1580)] = 51028,
  [SMALL_STATE(1581)] = 51041,
  [SMALL_STATE(1582)] = 51054,
  [SMALL_STATE(1583)] = 51067,
  [SMALL_STATE(1584)] = 51080,
  [SMALL_STATE(1585)] = 51089,
  [SMALL_STATE(1586)] = 51102,
  [SMALL_STATE(1587)] = 51115,
  [SMALL_STATE(1588)] = 51128,
  [SMALL_STATE(1589)] = 51141,
  [SMALL_STATE(1590)] = 51154,
  [SMALL_STATE(1591)] = 51167,
  [SMALL_STATE(1592)] = 51180,
  [SMALL_STATE(1593)] = 51193,
  [SMALL_STATE(1594)] = 51206,
  [SMALL_STATE(1595)] = 51219,
  [SMALL_STATE(1596)] = 51230,
  [SMALL_STATE(1597)] = 51243,
  [SMALL_STATE(1598)] = 51256,
  [SMALL_STATE(1599)] = 51269,
  [SMALL_STATE(1600)] = 51282,
  [SMALL_STATE(1601)] = 51293,
  [SMALL_STATE(1602)] = 51306,
  [SMALL_STATE(1603)] = 51319,
  [SMALL_STATE(1604)] = 51332,
  [SMALL_STATE(1605)] = 51345,
  [SMALL_STATE(1606)] = 51358,
  [SMALL_STATE(1607)] = 51367,
  [SMALL_STATE(1608)] = 51376,
  [SMALL_STATE(1609)] = 51385,
  [SMALL_STATE(1610)] = 51394,
  [SMALL_STATE(1611)] = 51405,
  [SMALL_STATE(1612)] = 51418,
  [SMALL_STATE(1613)] = 51431,
  [SMALL_STATE(1614)] = 51444,
  [SMALL_STATE(1615)] = 51457,
  [SMALL_STATE(1616)] = 51470,
  [SMALL_STATE(1617)] = 51483,
  [SMALL_STATE(1618)] = 51496,
  [SMALL_STATE(1619)] = 51509,
  [SMALL_STATE(1620)] = 51522,
  [SMALL_STATE(1621)] = 51535,
  [SMALL_STATE(1622)] = 51548,
  [SMALL_STATE(1623)] = 51561,
  [SMALL_STATE(1624)] = 51572,
  [SMALL_STATE(1625)] = 51585,
  [SMALL_STATE(1626)] = 51598,
  [SMALL_STATE(1627)] = 51611,
  [SMALL_STATE(1628)] = 51624,
  [SMALL_STATE(1629)] = 51637,
  [SMALL_STATE(1630)] = 51650,
  [SMALL_STATE(1631)] = 51659,
  [SMALL_STATE(1632)] = 51672,
  [SMALL_STATE(1633)] = 51685,
  [SMALL_STATE(1634)] = 51698,
  [SMALL_STATE(1635)] = 51707,
  [SMALL_STATE(1636)] = 51716,
  [SMALL_STATE(1637)] = 51729,
  [SMALL_STATE(1638)] = 51742,
  [SMALL_STATE(1639)] = 51755,
  [SMALL_STATE(1640)] = 51764,
  [SMALL_STATE(1641)] = 51777,
  [SMALL_STATE(1642)] = 51790,
  [SMALL_STATE(1643)] = 51803,
  [SMALL_STATE(1644)] = 51816,
  [SMALL_STATE(1645)] = 51825,
  [SMALL_STATE(1646)] = 51834,
  [SMALL_STATE(1647)] = 51842,
  [SMALL_STATE(1648)] = 51850,
  [SMALL_STATE(1649)] = 51860,
  [SMALL_STATE(1650)] = 51870,
  [SMALL_STATE(1651)] = 51880,
  [SMALL_STATE(1652)] = 51890,
  [SMALL_STATE(1653)] = 51900,
  [SMALL_STATE(1654)] = 51910,
  [SMALL_STATE(1655)] = 51920,
  [SMALL_STATE(1656)] = 51928,
  [SMALL_STATE(1657)] = 51938,
  [SMALL_STATE(1658)] = 51948,
  [SMALL_STATE(1659)] = 51958,
  [SMALL_STATE(1660)] = 51968,
  [SMALL_STATE(1661)] = 51978,
  [SMALL_STATE(1662)] = 51986,
  [SMALL_STATE(1663)] = 51996,
  [SMALL_STATE(1664)] = 52006,
  [SMALL_STATE(1665)] = 52016,
  [SMALL_STATE(1666)] = 52024,
  [SMALL_STATE(1667)] = 52034,
  [SMALL_STATE(1668)] = 52042,
  [SMALL_STATE(1669)] = 52052,
  [SMALL_STATE(1670)] = 52062,
  [SMALL_STATE(1671)] = 52072,
  [SMALL_STATE(1672)] = 52082,
  [SMALL_STATE(1673)] = 52092,
  [SMALL_STATE(1674)] = 52100,
  [SMALL_STATE(1675)] = 52108,
  [SMALL_STATE(1676)] = 52118,
  [SMALL_STATE(1677)] = 52128,
  [SMALL_STATE(1678)] = 52138,
  [SMALL_STATE(1679)] = 52146,
  [SMALL_STATE(1680)] = 52156,
  [SMALL_STATE(1681)] = 52166,
  [SMALL_STATE(1682)] = 52176,
  [SMALL_STATE(1683)] = 52186,
  [SMALL_STATE(1684)] = 52196,
  [SMALL_STATE(1685)] = 52206,
  [SMALL_STATE(1686)] = 52216,
  [SMALL_STATE(1687)] = 52226,
  [SMALL_STATE(1688)] = 52236,
  [SMALL_STATE(1689)] = 52244,
  [SMALL_STATE(1690)] = 52254,
  [SMALL_STATE(1691)] = 52264,
  [SMALL_STATE(1692)] = 52272,
  [SMALL_STATE(1693)] = 52282,
  [SMALL_STATE(1694)] = 52292,
  [SMALL_STATE(1695)] = 52302,
  [SMALL_STATE(1696)] = 52312,
  [SMALL_STATE(1697)] = 52322,
  [SMALL_STATE(1698)] = 52332,
  [SMALL_STATE(1699)] = 52342,
  [SMALL_STATE(1700)] = 52352,
  [SMALL_STATE(1701)] = 52362,
  [SMALL_STATE(1702)] = 52370,
  [SMALL_STATE(1703)] = 52380,
  [SMALL_STATE(1704)] = 52388,
  [SMALL_STATE(1705)] = 52398,
  [SMALL_STATE(1706)] = 52408,
  [SMALL_STATE(1707)] = 52418,
  [SMALL_STATE(1708)] = 52426,
  [SMALL_STATE(1709)] = 52436,
  [SMALL_STATE(1710)] = 52446,
  [SMALL_STATE(1711)] = 52456,
  [SMALL_STATE(1712)] = 52464,
  [SMALL_STATE(1713)] = 52472,
  [SMALL_STATE(1714)] = 52482,
  [SMALL_STATE(1715)] = 52490,
  [SMALL_STATE(1716)] = 52500,
  [SMALL_STATE(1717)] = 52507,
  [SMALL_STATE(1718)] = 52514,
  [SMALL_STATE(1719)] = 52521,
  [SMALL_STATE(1720)] = 52528,
  [SMALL_STATE(1721)] = 52535,
  [SMALL_STATE(1722)] = 52542,
  [SMALL_STATE(1723)] = 52549,
  [SMALL_STATE(1724)] = 52556,
  [SMALL_STATE(1725)] = 52563,
  [SMALL_STATE(1726)] = 52570,
  [SMALL_STATE(1727)] = 52577,
  [SMALL_STATE(1728)] = 52584,
  [SMALL_STATE(1729)] = 52591,
  [SMALL_STATE(1730)] = 52598,
  [SMALL_STATE(1731)] = 52605,
  [SMALL_STATE(1732)] = 52612,
  [SMALL_STATE(1733)] = 52619,
  [SMALL_STATE(1734)] = 52626,
  [SMALL_STATE(1735)] = 52633,
  [SMALL_STATE(1736)] = 52640,
  [SMALL_STATE(1737)] = 52647,
  [SMALL_STATE(1738)] = 52654,
  [SMALL_STATE(1739)] = 52661,
  [SMALL_STATE(1740)] = 52668,
  [SMALL_STATE(1741)] = 52675,
  [SMALL_STATE(1742)] = 52682,
  [SMALL_STATE(1743)] = 52689,
  [SMALL_STATE(1744)] = 52696,
  [SMALL_STATE(1745)] = 52703,
  [SMALL_STATE(1746)] = 52710,
  [SMALL_STATE(1747)] = 52717,
  [SMALL_STATE(1748)] = 52724,
  [SMALL_STATE(1749)] = 52731,
  [SMALL_STATE(1750)] = 52738,
  [SMALL_STATE(1751)] = 52745,
  [SMALL_STATE(1752)] = 52752,
  [SMALL_STATE(1753)] = 52759,
  [SMALL_STATE(1754)] = 52766,
  [SMALL_STATE(1755)] = 52773,
  [SMALL_STATE(1756)] = 52780,
  [SMALL_STATE(1757)] = 52787,
  [SMALL_STATE(1758)] = 52794,
  [SMALL_STATE(1759)] = 52801,
  [SMALL_STATE(1760)] = 52808,
  [SMALL_STATE(1761)] = 52815,
  [SMALL_STATE(1762)] = 52822,
  [SMALL_STATE(1763)] = 52829,
  [SMALL_STATE(1764)] = 52836,
  [SMALL_STATE(1765)] = 52843,
  [SMALL_STATE(1766)] = 52850,
  [SMALL_STATE(1767)] = 52857,
  [SMALL_STATE(1768)] = 52864,
  [SMALL_STATE(1769)] = 52871,
  [SMALL_STATE(1770)] = 52878,
  [SMALL_STATE(1771)] = 52885,
  [SMALL_STATE(1772)] = 52892,
  [SMALL_STATE(1773)] = 52899,
  [SMALL_STATE(1774)] = 52906,
  [SMALL_STATE(1775)] = 52913,
  [SMALL_STATE(1776)] = 52920,
  [SMALL_STATE(1777)] = 52927,
  [SMALL_STATE(1778)] = 52934,
  [SMALL_STATE(1779)] = 52941,
  [SMALL_STATE(1780)] = 52948,
  [SMALL_STATE(1781)] = 52955,
  [SMALL_STATE(1782)] = 52962,
  [SMALL_STATE(1783)] = 52969,
  [SMALL_STATE(1784)] = 52976,
  [SMALL_STATE(1785)] = 52983,
  [SMALL_STATE(1786)] = 52990,
  [SMALL_STATE(1787)] = 52997,
  [SMALL_STATE(1788)] = 53004,
  [SMALL_STATE(1789)] = 53011,
  [SMALL_STATE(1790)] = 53018,
  [SMALL_STATE(1791)] = 53025,
  [SMALL_STATE(1792)] = 53032,
  [SMALL_STATE(1793)] = 53039,
  [SMALL_STATE(1794)] = 53046,
  [SMALL_STATE(1795)] = 53053,
  [SMALL_STATE(1796)] = 53060,
  [SMALL_STATE(1797)] = 53067,
  [SMALL_STATE(1798)] = 53074,
  [SMALL_STATE(1799)] = 53081,
  [SMALL_STATE(1800)] = 53088,
  [SMALL_STATE(1801)] = 53095,
  [SMALL_STATE(1802)] = 53102,
  [SMALL_STATE(1803)] = 53109,
  [SMALL_STATE(1804)] = 53116,
  [SMALL_STATE(1805)] = 53123,
  [SMALL_STATE(1806)] = 53130,
  [SMALL_STATE(1807)] = 53137,
  [SMALL_STATE(1808)] = 53144,
  [SMALL_STATE(1809)] = 53151,
  [SMALL_STATE(1810)] = 53158,
  [SMALL_STATE(1811)] = 53165,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 1, 0, 0),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 1, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 11),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 11),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 2, 0, 0),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 2, 0, 0),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1, 0, 0),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1, 0, 0),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__container_members, 1, 0, 0),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1455),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1456),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1513),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1457),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1600),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1482),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1517),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1686),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1704),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1720),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1669),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(367),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1772),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1765),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1771),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1672),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(209),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(6),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(844),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1464),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1536),
  [483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(775),
  [486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(802),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1679),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0), SHIFT_REPEAT(1687),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1482),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1558),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1704),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1720),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1669),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1658),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(217),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(218),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(219),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(195),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1772),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1765),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1771),
  [568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1672),
  [574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(209),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(349),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(844),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1464),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1536),
  [628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(775),
  [631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(802),
  [640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1679),
  [646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1687),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 9, 0, 0),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 9, 0, 0),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 8, 0, 0),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 8, 0, 0),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 3, 0, 0),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 4, 0, 0),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 5, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 6, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_label, 2, 0, 0),
  [873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_label, 2, 0, 0),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 2, 0, 0),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 2, 0, 0),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 2, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_declaration, 2, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_declaration, 2, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_expression, 1, 0, 0),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_expression, 1, 0, 0),
  [923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_expression, 2, 0, 0),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_type_expression, 2, 0, 0),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_type_expression, 2, 0, 0),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_expression, 2, 0, 0),
  [931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 1, 0, 0),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 1, 0, 0),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_expr_statement, 2, 0, 0),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_expr_statement, 2, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_type_expression, 1, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_type_expression, 1, 0, 0),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 2, 0, 0),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 2, 0, 0),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_expr_statement, 1, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_expr_statement, 1, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_byte_alignment, 4, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_byte_alignment, 4, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 15),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 15),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 47),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 47),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 14),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 14),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 41),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 41),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 42),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 42),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 40),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 40),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 13),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 13),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 13),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 13),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_address_space, 4, 0, 0),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_address_space, 4, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 40),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 40),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_declaration, 3, 0, 0),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_declaration, 3, 0, 0),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_declaration, 3, 0, 0),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_declaration, 3, 0, 0),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 28),
  [1009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 28),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 4),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 4),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_declaration, 4, 0, 0),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_declaration, 4, 0, 0),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 28),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 28),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 29),
  [1025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 29),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__container_members_repeat1, 2, 0, 0),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 30),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 30),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 4),
  [1035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 4),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 2, 0, 8),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 2, 0, 8),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 47),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 47),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 2, 0, 9),
  [1047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 2, 0, 9),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_declaration, 2, 0, 0),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_declaration, 2, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_namespace_declaration, 4, 0, 0),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_namespace_declaration, 4, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_namespace_declaration, 3, 0, 0),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_namespace_declaration, 3, 0, 0),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__conditional_body, 1, 0, 18),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__conditional_body, 1, 0, 18),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_slice_type_repeat1, 2, 0, 0),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_slice_type_repeat1, 2, 0, 0), SHIFT_REPEAT(724),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_type_repeat1, 2, 0, 0),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_slice_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1719),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_slice_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1764),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 2, 0, 0),
  [1082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_type_repeat1, 2, 0, 0),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1758),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1764),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_errdefer_statement, 2, 0, 0),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_errdefer_statement, 2, 0, 0),
  [1097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_declaration_expression_statement, 5, 0, 13),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_expression_statement, 5, 0, 13),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 4),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 4),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 2, 0, 19),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 2, 0, 19),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__conditional_body, 2, 0, 18),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__conditional_body, 2, 0, 18),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_declaration_expression_statement, 4, 0, 0),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_expression_statement, 4, 0, 0),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payload, 3, 0, 0),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payload, 3, 0, 0),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, 0, 20),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, 0, 20),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_declaration_expression_statement, 4, 0, 4),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_expression_statement, 4, 0, 4),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payload, 6, 0, 0),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payload, 6, 0, 0),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 34),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 34),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 35),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 35),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 45),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 45),
  [1149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_statement, 2, 0, 13),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_statement, 2, 0, 13),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_statement, 2, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_statement, 2, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nosuspend_statement, 2, 0, 0),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nosuspend_statement, 2, 0, 0),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_suspend_statement, 2, 0, 0),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_suspend_statement, 2, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payload, 4, 0, 0),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payload, 4, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_errdefer_statement, 3, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_errdefer_statement, 3, 0, 0),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payload, 5, 0, 0),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payload, 5, 0, 0),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 2, 0, 19),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 2, 0, 19),
  [1185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_declaration_expression_statement, 5, 0, 36),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_expression_statement, 5, 0, 36),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 50),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 50),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 4, 0, 0),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_type_repeat1, 4, 0, 0),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_type_repeat1, 8, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_type_repeat1, 8, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_section, 4, 0, 0),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_section, 4, 0, 0),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [1215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, 0, 0),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, 0, 0),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__while_prefix, 4, 0, 37),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__while_prefix, 4, 0, 37),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_prefix, 4, 0, 37),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_prefix, 4, 0, 37),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__while_prefix, 5, 0, 37),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__while_prefix, 5, 0, 37),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__while_prefix, 9, 0, 37),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__while_prefix, 9, 0, 37),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 7, 0, 0),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 7, 0, 0),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 6, 0, 0),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 6, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 8, 0, 0),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 8, 0, 0),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 5, 0, 0),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 5, 0, 0),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__while_prefix, 8, 0, 37),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__while_prefix, 8, 0, 37),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 4, 0, 0),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 4, 0, 0),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__if_prefix, 5, 0, 37),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_prefix, 5, 0, 37),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_prefix, 9, 0, 0),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_prefix, 9, 0, 0),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_convention, 4, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 4, 0, 0),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiline_string_repeat1, 2, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multiline_string_repeat1, 2, 0, 0),
  [1281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_string_repeat1, 2, 0, 0), SHIFT_REPEAT(774),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiline_string, 1, 0, 0),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiline_string, 1, 0, 0),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_expression, 1, 0, 0),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_expression, 1, 0, 0),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 1, 0, 0),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 0),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5, 0, 0),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 0),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 0),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, 0, 0),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, 0, 0),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_set_declaration, 5, 0, 0),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_set_declaration, 5, 0, 0),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 24),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 24),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 11, 0, 0),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 11, 0, 0),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 2, 0, 0),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 0),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 0),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 7, 0, 0),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 7, 0, 0),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opaque_declaration, 4, 0, 0),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_opaque_declaration, 4, 0, 0),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 0),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 0),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 4, 0, 33),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 4, 0, 33),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 4, 0, 0),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 4, 0, 0),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_set_declaration, 4, 0, 0),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_set_declaration, 4, 0, 0),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 6, 0, 22),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 6, 0, 22),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 6, 0, 51),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 6, 0, 51),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character, 3, 0, 0),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character, 3, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_type, 3, 0, 0),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_type, 3, 0, 0),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 5, 0, 44),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 5, 0, 44),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_expression, 5, 0, 0),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_expression, 5, 0, 0),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 22),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 22),
  [1388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_expression, 4, 0, 0),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_expression, 4, 0, 0),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 38),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 38),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 0),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 0),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_type_expression, 1, 0, 1),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_type_expression, 1, 0, 1),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 5, 0, 22),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 5, 0, 22),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opaque_declaration, 5, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_opaque_declaration, 5, 0, 0),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 2, 0, 0),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 2, 0, 0),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 0),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 0),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 0),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 8, 0, 0),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 8, 0, 0),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_struct_initializer, 2, 0, 0),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_struct_initializer, 2, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 2, 0, 7),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 2, 0, 7),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 8, 0, 0),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 8, 0, 0),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 5, 0, 0),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 5, 0, 0),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 8, 0, 54),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 8, 0, 54),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 4, 0, 32),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 4, 0, 32),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_initializer, 2, 0, 0),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_initializer, 2, 0, 0),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_function, 2, 0, 0),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_function, 2, 0, 0),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_type_expression, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_type_expression, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 7, 0, 52),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 7, 0, 52),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 3, 0, 17),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 3, 0, 17),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 7, 0, 53),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 7, 0, 53),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dereference_expression, 2, 0, 0),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dereference_expression, 2, 0, 0),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_coercion_expression, 2, 0, 0),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null_coercion_expression, 2, 0, 0),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 6, 0, 48),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 6, 0, 48),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 22),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 22),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 6, 0, 49),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 6, 0, 49),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 10, 0, 0),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 10, 0, 0),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_set_declaration, 6, 0, 0),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_set_declaration, 6, 0, 0),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_set_declaration, 3, 0, 0),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_set_declaration, 3, 0, 0),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_prototype, 5, 0, 43),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_prototype, 5, 0, 43),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_expression, 6, 0, 0),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_expression, 6, 0, 0),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 16),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 16),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 6, 0, 0),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 6, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_type_expression, 2, 0, 10),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 2, 0, 10),
  [1619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 2, 0, 10),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 4, 0, 10),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 4, 0, 10),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expression, 4, 0, 0),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expression, 4, 0, 0),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 10),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 10),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 4, 0, 0),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 4, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 10),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 10),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 4, 0, 0),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 4, 0, 0),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 4, 0, 39),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 4, 0, 39),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 6, 0, 16),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 6, 0, 16),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 3, 0, 0),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 3, 0, 0),
  [1664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 8, 0, 54),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 8, 0, 54),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 6, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 6, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 6, 0, 0),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 6, 0, 0),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 5, 0, 0),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 5, 0, 0),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 6, 0, 39),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 6, 0, 39),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 7, 0, 39),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 7, 0, 39),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 7, 0, 52),
  [1697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 7, 0, 52),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 5, 0, 44),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 5, 0, 44),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 5),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 5),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 4, 0, 33),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 4, 0, 33),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_type_expression, 4, 0, 10),
  [1718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 4, 0, 10),
  [1721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 4, 0, 10),
  [1724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 3, 0, 17),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 3, 0, 17),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, 0, 0),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, 0, 0),
  [1734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 3, 0, 0),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 3, 0, 0),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 3, 0, 16),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 3, 0, 16),
  [1746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 4, 0, 32),
  [1749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 4, 0, 32),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 5, 0, 0),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 5, 0, 0),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_union_type, 2, 0, 6),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_union_type, 2, 0, 6),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_type_expression, 5, 0, 10),
  [1762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 5, 0, 10),
  [1765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_if_type_expression, 5, 0, 10),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 21),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 21),
  [1772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 7, 0, 53),
  [1775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 7, 0, 53),
  [1778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 5, 0, 43),
  [1781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 5, 0, 43),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 4, 0, 0),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 4, 0, 0),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_type_expression, 2, 0, 0),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_comptime_type_expression, 2, 0, 0),
  [1793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_comptime_type_expression, 2, 0, 0),
  [1796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 10),
  [1798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 10),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 21),
  [1802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 21),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_expression, 2, 0, 0),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_expression, 2, 0, 0),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nosuspend_expression, 2, 0, 0),
  [1810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nosuspend_expression, 2, 0, 0),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 6, 0, 48),
  [1815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 6, 0, 48),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 7, 0, 0),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 7, 0, 0),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_expression, 2, 0, 0),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_expression, 2, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resume_expression, 2, 0, 0),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_resume_expression, 2, 0, 0),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2, 0, 0),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 2, 0, 0),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 2, 0, 0),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 2, 0, 10),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 2, 0, 10),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 2, 0, 0),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 2, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 2, 0, 10),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 2, 0, 10),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 5, 0, 46),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 5, 0, 46),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 6, 0, 49),
  [1867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__function_prototype, 6, 0, 49),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 6, 0, 46),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 6, 0, 46),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_expression, 3, 0, 0),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_expression, 3, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [1880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anyframe_type, 3, 0, 0),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anyframe_type, 3, 0, 0),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_union_type, 3, 0, 25),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_union_type, 3, 0, 25),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 23),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 23),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 3, 0, 0),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 3, 0, 0),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 4, 0, 33),
  [1904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_declaration_header, 4, 0, 33),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 3, 1, 27),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiline_string_repeat1, 2, 0, 0), SHIFT_REPEAT(930),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 32),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 1, 1, 2),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 31),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 3, 1, 26),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 2, 1, 3),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__switch_case_exp, 1, 0, 0),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_expression, 2, 0, 0), REDUCE(sym_for_expression, 3, 0, 0),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_while_expression, 2, 0, 10), REDUCE(sym_while_expression, 3, 0, 16),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 2),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 6, 1, 32),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 6, 1, 26),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_for_expression, 4, 0, 0), REDUCE(sym_for_expression, 5, 0, 0),
  [2274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_while_expression, 4, 0, 10), REDUCE(sym_while_expression, 5, 0, 16),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 31),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 32),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 6, 1, 27),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 3),
  [2289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 3), REDUCE(sym_comptime_type_expression, 2, 0, 0),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 2),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 7, 1, 31),
  [2296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 10), REDUCE(sym_while_expression, 6, 0, 16),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 26),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 7, 1, 32),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 3, 1, 2),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 3),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__switch_case_exp_repeat1, 2, 0, 0),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 5, 1, 26),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 5, 1, 27),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 5, 1, 3),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 27),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 6, 1, 31),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, 0, 0),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, 0, 0),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_prefix_repeat1, 2, 0, 0),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__switch_case_exp_repeat1, 4, 0, 0),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 0),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declaration_expression_statement_repeat1, 2, 0, 0),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_declaration_expression_statement_repeat1, 2, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 2, 0, 0),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 5, 0, 33),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 3, 0, 0),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_clobbers, 3, 0, 0),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_clobbers, 1, 0, 0),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_clobbers, 4, 0, 0),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input, 4, 0, 0),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output, 2, 0, 0),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input, 2, 0, 0),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output, 3, 0, 0),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input, 3, 0, 0),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output, 1, 0, 0),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input, 1, 0, 0),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output, 4, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 4, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 6, 0, 33),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 26),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_label, 2, 0, 12),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [2681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_input_repeat1, 2, 0, 0), SHIFT_REPEAT(1684),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_asm_input_repeat1, 2, 0, 0),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 3, 1, 3),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_label, 2, 0, 0),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 2, 1, 2),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 4, 1, 27),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [2714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 5, 1, 31),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_container_field, 5, 1, 32),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [2724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [2727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_output_repeat1, 2, 0, 0), SHIFT_REPEAT(1681),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_asm_output_repeat1, 2, 0, 0),
  [2735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(375),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__switch_case_exp_repeat1, 2, 0, 0), SHIFT_REPEAT(389),
  [2749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(197),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_clobbers_repeat1, 2, 0, 0), SHIFT_REPEAT(1527),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_asm_clobbers_repeat1, 2, 0, 0),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 5, 0, 0),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1657),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(162),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_clobbers, 2, 0, 0),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_payload_repeat1, 2, 0, 0), SHIFT_REPEAT(1471),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_payload_repeat1, 2, 0, 0),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output_item, 7, 0, 0),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input_item, 7, 0, 0),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output_item, 8, 0, 0),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__container_members, 2, 0, 0),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declaration_expression_statement_repeat1, 2, 0, 36), SHIFT_REPEAT(196),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declaration_expression_statement_repeat1, 2, 0, 36),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_error_set_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1489),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_error_set_declaration_repeat1, 2, 0, 0),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(372),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declaration_header, 7, 0, 33),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declaration_expression_statement_repeat1, 2, 0, 13),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_payload_repeat1, 3, 0, 0),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [3167] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_output, 5, 0, 0),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_input, 5, 0, 0),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_zig(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
